-- Pretend You're Xyzzy cards by Andy Janata is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.
-- Based on a work at www.cardsagainsthumanity.com.
-- For more information, see http://creativecommons.org/licenses/by-nc-sa/3.0/

-- This file contains the Black Cards and White Cards for Cards Against Humanity, as a script for importing into PostgreSQL. There should be a user named cah.
-- Includes the First, Second, Third, and Fourth Expansions, as well as the Canadian version cards, 2012 Holiday Pack, and PAX East 2013 and 13PAX packs.
-- 2013 Holiday Bullshit and House of Cards Against Humanity.
-- Also includes a lot of custom card sets.

--
-- PostgreSQL database dump
--

-- Dumped from database version 9.1.11
-- Dumped by pg_dump version 9.2.2
-- Started on 2014-02-16 23:02:25

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- TOC entry 169 (class 3079 OID 11677)
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: 
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- TOC entry 1943 (class 0 OID 0)
-- Dependencies: 169
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 161 (class 1259 OID 16471)
-- Name: black_cards; Type: TABLE; Schema: public; Owner: cah; Tablespace: 
--

CREATE TABLE black_cards (
    id integer NOT NULL,
    text character varying(255) NOT NULL,
    draw smallint DEFAULT 0,
    pick smallint DEFAULT 1,
    watermark character varying(5)
);


ALTER TABLE public.black_cards OWNER TO cah;

--
-- TOC entry 162 (class 1259 OID 16476)
-- Name: black_cards_id_seq; Type: SEQUENCE; Schema: public; Owner: cah
--

CREATE SEQUENCE black_cards_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.black_cards_id_seq OWNER TO cah;

--
-- TOC entry 1944 (class 0 OID 0)
-- Dependencies: 162
-- Name: black_cards_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: cah
--

ALTER SEQUENCE black_cards_id_seq OWNED BY black_cards.id;


--
-- TOC entry 163 (class 1259 OID 16478)
-- Name: card_set; Type: TABLE; Schema: public; Owner: cah; Tablespace: 
--

CREATE TABLE card_set (
    id integer NOT NULL,
    active boolean NOT NULL,
    name character varying(255),
    base_deck boolean NOT NULL,
    description character varying(255),
    weight integer DEFAULT 0 NOT NULL
);


ALTER TABLE public.card_set OWNER TO cah;

--
-- TOC entry 164 (class 1259 OID 16485)
-- Name: card_set_black_card; Type: TABLE; Schema: public; Owner: cah; Tablespace: 
--

CREATE TABLE card_set_black_card (
    card_set_id integer NOT NULL,
    black_card_id integer NOT NULL
);


ALTER TABLE public.card_set_black_card OWNER TO cah;

--
-- TOC entry 165 (class 1259 OID 16488)
-- Name: card_set_white_card; Type: TABLE; Schema: public; Owner: cah; Tablespace: 
--

CREATE TABLE card_set_white_card (
    card_set_id integer NOT NULL,
    white_card_id integer NOT NULL
);


ALTER TABLE public.card_set_white_card OWNER TO cah;

--
-- TOC entry 166 (class 1259 OID 16491)
-- Name: hibernate_sequence; Type: SEQUENCE; Schema: public; Owner: cah
--

CREATE SEQUENCE hibernate_sequence
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.hibernate_sequence OWNER TO cah;

--
-- TOC entry 167 (class 1259 OID 16493)
-- Name: white_cards; Type: TABLE; Schema: public; Owner: cah; Tablespace: 
--

CREATE TABLE white_cards (
    id integer NOT NULL,
    text character varying(255) NOT NULL,
    watermark character varying(5)
);


ALTER TABLE public.white_cards OWNER TO cah;

--
-- TOC entry 168 (class 1259 OID 16496)
-- Name: white_cards_id_seq; Type: SEQUENCE; Schema: public; Owner: cah
--

CREATE SEQUENCE white_cards_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.white_cards_id_seq OWNER TO cah;

--
-- TOC entry 1945 (class 0 OID 0)
-- Dependencies: 168
-- Name: white_cards_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: cah
--

ALTER SEQUENCE white_cards_id_seq OWNED BY white_cards.id;


--
-- TOC entry 1907 (class 2604 OID 16498)
-- Name: id; Type: DEFAULT; Schema: public; Owner: cah
--

ALTER TABLE ONLY black_cards ALTER COLUMN id SET DEFAULT nextval('black_cards_id_seq'::regclass);


--
-- TOC entry 1909 (class 2604 OID 16499)
-- Name: id; Type: DEFAULT; Schema: public; Owner: cah
--

ALTER TABLE ONLY white_cards ALTER COLUMN id SET DEFAULT nextval('white_cards_id_seq'::regclass);


--
-- TOC entry 1928 (class 0 OID 16471)
-- Dependencies: 161
-- Data for Name: black_cards; Type: TABLE DATA; Schema: public; Owner: cah
--

INSERT INTO black_cards VALUES (16, 'Who stole the cookies from the cookie jar?', 0, 1, NULL);
INSERT INTO black_cards VALUES (504, 'What is the next great Kickstarter project?', 0, 1, 'RS');
INSERT INTO black_cards VALUES (27, 'What''s the next superhero?', 0, 1, NULL);
INSERT INTO black_cards VALUES (505, '____ 2012.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (100230, '____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (5097, 'Personals ad: Seeking a female who doesn''t mind ____, might also be willing to try a male if they''re ____.', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5099, 'I tell everyone I''m not a furry, but I''ve drawn a lot of ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (1, 'Why can''t I sleep at night?', 0, 1, NULL);
INSERT INTO black_cards VALUES (4, 'What''s that smell?', 0, 1, NULL);
INSERT INTO black_cards VALUES (1273, 'And that''s how Equestria was made!', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (15, 'What''s that sound?', 0, 1, NULL);
INSERT INTO black_cards VALUES (9, 'What ended my last relationship?', 0, 1, NULL);
INSERT INTO black_cards VALUES (7, 'What is Batman''s guilty pleasure?', 0, 1, NULL);
INSERT INTO black_cards VALUES (3, 'What''s a girl''s best friend?', 0, 1, NULL);
INSERT INTO black_cards VALUES (22, 'What does Dick Cheney prefer?', 0, 1, NULL);
INSERT INTO black_cards VALUES (25, 'What''s the most emo?', 0, 1, NULL);
INSERT INTO black_cards VALUES (39, 'What are my parents hiding from me?', 0, 1, NULL);
INSERT INTO black_cards VALUES (36, 'What will always get you laid?', 0, 1, NULL);
INSERT INTO black_cards VALUES (38, 'What did I bring back from Mexico?', 0, 1, NULL);
INSERT INTO black_cards VALUES (48, 'What don''t you want to find in your Chinese food?', 0, 1, NULL);
INSERT INTO black_cards VALUES (49, 'What will I bring back in time to convince people that I am a powerful wizard?', 0, 1, NULL);
INSERT INTO black_cards VALUES (50, 'How am I maintaining my relationship status?', 0, 1, NULL);
INSERT INTO black_cards VALUES (58, 'What gives me uncontrollable gas?', 0, 1, NULL);
INSERT INTO black_cards VALUES (62, 'What do old people smell like? ', 0, 1, NULL);
INSERT INTO black_cards VALUES (59, 'What''s my secret power?', 0, 1, NULL);
INSERT INTO black_cards VALUES (41, 'What''s there a ton of in heaven?', 0, 1, NULL);
INSERT INTO black_cards VALUES (42, 'What would grandma find disturbing, yet oddly charming?', 0, 1, NULL);
INSERT INTO black_cards VALUES (43, 'What did the U.S. airdrop to the children of Afghanistan?', 0, 1, NULL);
INSERT INTO black_cards VALUES (40, 'What helps Obama unwind?', 0, 1, NULL);
INSERT INTO black_cards VALUES (73, 'What did Vin Diesel eat for dinner?', 0, 1, NULL);
INSERT INTO black_cards VALUES (76, 'Why am I sticky?', 0, 1, NULL);
INSERT INTO black_cards VALUES (75, 'What gets better with age?', 0, 1, NULL);
INSERT INTO black_cards VALUES (71, 'What''s the crustiest?', 0, 1, NULL);
INSERT INTO black_cards VALUES (70, 'What''s Teach for America using to inspire inner city students to succeed?', 0, 1, NULL);
INSERT INTO black_cards VALUES (86, 'Make a haiku.', 2, 3, NULL);
INSERT INTO black_cards VALUES (66, 'Why do I hurt all over?', 0, 1, NULL);
INSERT INTO black_cards VALUES (63, 'What am I giving up for Lent?', 0, 1, NULL);
INSERT INTO black_cards VALUES (77, 'What''s my anti-drug?', 0, 1, NULL);
INSERT INTO black_cards VALUES (56, 'What never fails to liven up the party?', 0, 1, NULL);
INSERT INTO black_cards VALUES (44, 'What''s the new fad diet?', 0, 1, NULL);
INSERT INTO black_cards VALUES (2, 'I got 99 problems but ____ ain''t one.', 0, 1, NULL);
INSERT INTO black_cards VALUES (8, 'TSA guidelines now prohibit ____ on airplanes.', 0, 1, NULL);
INSERT INTO black_cards VALUES (10, 'MTV''s new reality show features eight washed-up celebrities living with ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (11, 'I drink to forget ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (12, 'I''m sorry, Professor, but I couldn''t complete my homework because of ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (13, 'During Picasso''s often-overlooked Brown Period, he produced hundreds of paintings of ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (14, 'Alternative medicine is now embracing the curative powers of ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (18, 'Anthropologists have recently discovered a primitive tribe that worships ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (19, 'It''s a pity that kids these days are all getting involved with ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (20, '____. That''s how I want to die.', 0, 1, NULL);
INSERT INTO black_cards VALUES (21, 'In the new Disney Channel Original Movie, Hannah Montana struggles with ____ for the first time.', 0, 1, NULL);
INSERT INTO black_cards VALUES (23, 'I wish I hadn''t lost the instruction manual for ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (24, 'Instead of coal, Santa now gives the bad children ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (26, 'In 1,000 years, when paper money is but a distant memory, ____ will be our currency.', 0, 1, NULL);
INSERT INTO black_cards VALUES (28, 'A romantic, candlelit dinner would be incomplete without ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (29, 'Next from J.K. Rowling: Harry Potter and the Chamber of ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (30, '____. Betcha can''t have just one!', 0, 1, NULL);
INSERT INTO black_cards VALUES (31, 'White people like ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (32, '____. High five, bro.', 0, 1, NULL);
INSERT INTO black_cards VALUES (33, 'During sex, I like to think about ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (35, 'BILLY MAYS HERE FOR ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (37, 'When I''m in prison, I''ll have ____ smuggled in.', 0, 1, NULL);
INSERT INTO black_cards VALUES (45, 'When I am the President of the United States, I will create the Department of ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (46, 'Major League Baseball has banned ____ for giving players an unfair advantage.', 0, 1, NULL);
INSERT INTO black_cards VALUES (47, 'When I am a billionare, I shall erect a 50-foot statue to commemorate ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (51, '____. It''s a trap!', 0, 1, NULL);
INSERT INTO black_cards VALUES (52, 'Coming to Broadway this season, ____: The Musical.', 0, 1, NULL);
INSERT INTO black_cards VALUES (54, 'After Hurricane Katrina, Sean Penn brought ____ to all the people of New Orleans.', 0, 1, NULL);
INSERT INTO black_cards VALUES (55, 'Due to a PR fiasco, Walmart no longer offers ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (57, 'But before I kill you, Mr. Bond, I must show you ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (60, 'When Pharaoh remained unmoved, Moses called down a plague of ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (61, 'The class field trip was completely ruined by ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (64, 'In Michael Jackson''s final moments, he thought about ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (65, 'In an attempt to reach a wider audience, the Smithsonian Museum of Natural History has opened an interactive exhibit on ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (67, 'Studies show that lab rats navigate mazes 50% faster after being exposed to ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (68, 'I do not know with which weapons World War III will be fought, but World War IV will be fought with ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (69, 'Life was difficult for cavemen before ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (72, '____: Good to the last drop.', 0, 1, NULL);
INSERT INTO black_cards VALUES (74, '____: kid-tested, mother-approved.', 0, 1, NULL);
INSERT INTO black_cards VALUES (78, 'And the Academy Award for ____ goes to ____.', 0, 2, NULL);
INSERT INTO black_cards VALUES (79, 'For my next trick, I will pull ____ out of ____.', 0, 2, NULL);
INSERT INTO black_cards VALUES (80, '____ is a slippery slope that leads to ____.', 0, 2, NULL);
INSERT INTO black_cards VALUES (81, 'In M. Night Shyamalan''s new movie, Bruce Willis discovers that ____ had really been ____ all along.', 0, 2, NULL);
INSERT INTO black_cards VALUES (82, 'In a world ravaged by ____, our only solace is ____.', 0, 2, NULL);
INSERT INTO black_cards VALUES (83, 'In his new summer comedy, Rob Schneider is ____ trapped in the body of ____.', 0, 2, NULL);
INSERT INTO black_cards VALUES (85, 'I never truly understood ____ until I encountered ____.', 0, 2, NULL);
INSERT INTO black_cards VALUES (88, 'When I was tripping on acid, ____ turned into ____.', 0, 2, NULL);
INSERT INTO black_cards VALUES (89, 'That''s right, I killed ____. How, you ask? ____.', 0, 2, NULL);
INSERT INTO black_cards VALUES (90, '____ + ____ = ____.', 2, 3, NULL);
INSERT INTO black_cards VALUES (506, 'What is Curious George so curious about?', 0, 1, 'RS');
INSERT INTO black_cards VALUES (1001, 'test', 0, 1, NULL);
INSERT INTO black_cards VALUES (1003, 'Starting Canadian Black Cards', 0, 1, NULL);
INSERT INTO black_cards VALUES (1009, 'End Canadian Black Cards', 0, 1, NULL);
INSERT INTO black_cards VALUES (1033, 'end bonus misprint bonus card', 0, 1, NULL);
INSERT INTO black_cards VALUES (1044, 'begin First Expansion', 0, 1, NULL);
INSERT INTO black_cards VALUES (1065, 'end first expansion', 0, 1, NULL);
INSERT INTO black_cards VALUES (1004, 'O Canada, we stand on guard for ____.', 0, 1, 'CAN');
INSERT INTO black_cards VALUES (1005, 'Air Canada guidelines now prohibit ____ on airplanes.', 0, 1, 'CAN');
INSERT INTO black_cards VALUES (1006, 'In an attempt to reach a wider audience, the Royal Ontario Museum has opened an interactive exhibit on ____.', 0, 1, 'CAN');
INSERT INTO black_cards VALUES (1007, 'CTV presents ____, the story of ____.', 0, 2, 'CAN');
INSERT INTO black_cards VALUES (1008, 'What''s the Canadian government using to inspire rural students to succeed?', 0, 1, 'CAN');
INSERT INTO black_cards VALUES (1045, 'He who controls ____ controls the world.', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1046, 'The CIA now interrogates enemy agents by repeatedly subjecting them to ____.', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1047, 'Dear Sir or Madam, We regret to inform you that the Office of ____ has denied your request for ____.', 0, 2, 'X1');
INSERT INTO black_cards VALUES (1048, 'In Rome, there are whisperings that the Vatican has a secret room devoted to ____.', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1049, 'Science will never explain the origin of ____.', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1050, 'When all else fails, I can always masturbate to ____.', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1051, 'I learned the hard way that you can''t cheer up a grieving friend with ____.', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1052, 'In its new tourism campaign, Detroit proudly proclaims that it has finally eliminated ____.', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1053, 'An international tribunal has found ____ guilty of ____.', 0, 2, 'X1');
INSERT INTO black_cards VALUES (1054, 'The socialist governments of Scandinavia have declared that access to ____ is a basic human right.', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1055, 'In his new self-produced album, Kanye West raps over the sounds of ____.', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1056, 'What''s the gift that keeps on giving?', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1057, 'This season on Man vs. Wild, Bear Grylls must survive in the depths of the Amazon with only ____ and his wits.', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1058, 'When I pooped, what came out of my butt?', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1059, 'In the distant future, historians will agree that ____ marked the beginning of America''s decline.', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1060, 'In a pinch, ____ can be a suitable substitute for ____.', 0, 2, 'X1');
INSERT INTO black_cards VALUES (1061, 'What has been making life difficult at the nudist colony?', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1062, 'Michael Bay''s new three-hour action epic pits ____ against ____.', 0, 2, 'X1');
INSERT INTO black_cards VALUES (507, 'What is the next big sideshow attraction?', 0, 1, 'RS');
INSERT INTO black_cards VALUES (508, 'Praise ____!', 0, 1, 'RS');
INSERT INTO black_cards VALUES (93, 'What''s the next superhero/sidekick duo?', 0, 2, '1.2');
INSERT INTO black_cards VALUES (509, 'Keith Richards enjoys ____ on his food.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (1032, 'Daddy, why is Mommy crying?', 0, 1, 'B');
INSERT INTO black_cards VALUES (1063, 'And I would have gotten away with it, too, if it hadn''t been for ____!', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1064, 'What brought the orgy to a grinding halt?', 0, 1, 'X1');
INSERT INTO black_cards VALUES (1156, 'During his midlife crisis, my dad got really into ____.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1157, '____ would be woefully incomplete without ____.', 0, 2, 'X2');
INSERT INTO black_cards VALUES (1158, 'My new favorite porn star is Joey "____" McGee.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1159, 'Before I run for president, I must destroy all evidence of my involvement with ____.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1160, 'This is your captain speaking. Fasten your seatbelts and prepare for ____.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1161, 'In his newest and most difficult stunt, David Blaine must escape from ____.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1162, 'The Five Stages of Grief: denial, anger, bargaining, ____, acceptance.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1163, 'My mom freaked out when she looked at my browser history and found ____.com/____.', 0, 2, 'X2');
INSERT INTO black_cards VALUES (1164, 'I went from ____ to ____, all thanks to ____.', 2, 3, 'X2');
INSERT INTO black_cards VALUES (1165, 'Members of New York''s social elite are paying thousands of dollars just to experience ____.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1166, 'This month''s Cosmo: "Spice up your sex life by bringing ____ into the bedroom."', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1167, 'Little Miss Muffet Sat on a tuffet, Eating her curds and ____.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1168, 'If God didn''t want us to enjoy ____, he wouldn''t have given us ____.', 0, 2, 'X2');
INSERT INTO black_cards VALUES (1169, 'My country, ''tis of thee, sweet land of ____.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1170, 'After months of debate, the Occupy Wall Street General Assembly could only agree on "More ____!"', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1171, 'I spent my whole life working toward ____, only to have it ruined by ____.', 0, 2, 'X2');
INSERT INTO black_cards VALUES (1172, 'Next time on Dr. Phil: How to talk to your child about ____.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1173, 'Only two things in life are certain: death and ____.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1174, 'Everyone down on the ground! We don''t want to hurt anyone. We''re just here for ____.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1175, 'The healing process began when I joined a support group for victims of ____.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1176, 'The votes are in, and the new high school mascot is ____.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1177, 'Charades was ruined for me forever when my mom had to act out ____.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1178, 'Before ____, all we had was ____.', 0, 2, 'X2');
INSERT INTO black_cards VALUES (1179, 'Tonight on 20/20: What you don''t know about ____ could kill you.', 0, 1, 'X2');
INSERT INTO black_cards VALUES (1180, 'You haven''t truly lived until you''ve experienced ____ and ____ at the same time.', 0, 2, 'X2');
INSERT INTO black_cards VALUES (5, '____? There''s an app for that.', 0, 1, NULL);
INSERT INTO black_cards VALUES (91, 'Maybe she''s born with it. Maybe it''s ____.', 0, 1, '1.2');
INSERT INTO black_cards VALUES (94, 'In L.A. County Jail, word is you can trade 200 cigarettes for ____.', 0, 1, '1.2');
INSERT INTO black_cards VALUES (95, 'After the earthquake, Sean Penn brought ____ to the people of Haiti.', 0, 1, '1.2');
INSERT INTO black_cards VALUES (96, 'Next on ESPN2, the World Series of ____.', 0, 1, '1.2');
INSERT INTO black_cards VALUES (97, 'Step 1: ____. Step 2: ____. Step 3: Profit.', 0, 2, '1.2');
INSERT INTO black_cards VALUES (98, 'Life for American Indians was forever changed when the White Man introduced them to ____.', 0, 1, '1.2');
INSERT INTO black_cards VALUES (1458, 'This holiday season, Tim Allen must overcome his fear of ____ to save Christmas.', 0, 1, '❄');
INSERT INTO black_cards VALUES (1459, 'Jesus is ____.', 0, 1, '❄');
INSERT INTO black_cards VALUES (1462, 'On the third day of Christmas, my true love gave to me: three French hens, two turtle doves, and ____.', 0, 1, '❄');
INSERT INTO black_cards VALUES (1463, 'Wake up, America. Christmas is under attack by secular liberals and their ____.', 0, 1, '❄');
INSERT INTO black_cards VALUES (1460, 'Every Christmas, my uncle gets drunk and tells the story about ____.', 0, 1, '❄');
INSERT INTO black_cards VALUES (1461, 'What keeps me warm during the cold, cold winter?', 0, 1, '❄');
INSERT INTO black_cards VALUES (1457, 'After blacking out during New Year''s Eve, I was awoken by ____.', 0, 1, '❄');
INSERT INTO black_cards VALUES (99, '____ Jesus is the Jesus of ____.', 0, 2, 'VS');
INSERT INTO black_cards VALUES (100, '____ ALL THE ____.', 0, 2, 'VS');
INSERT INTO black_cards VALUES (101, 'There were ALOT of ____ doing ____.', 0, 2, 'VS');
INSERT INTO black_cards VALUES (102, 'Dogimo would give up ____ to type a six sentence paragraph in a thread.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (103, 'Simple dog ate and vomited ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (104, 'When I was 25, I won an award for ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (105, 'I''m more awesome than a T-rex because of ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (106, '____ in my pants.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (107, 'We need to talk about your whole gallon of ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (108, 'Clean ALL the ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (109, 'The first rule of Jade Club is ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (110, 'The forum nearly broke when ____ posted ____ in The Dead Thread.', 0, 2, 'VS');
INSERT INTO black_cards VALUES (111, 'A mod war about ____ occurred during ____.', 0, 2, 'VS');
INSERT INTO black_cards VALUES (112, 'No one likes me after I posted ____ in the TMI thread.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (113, '____ was banned from tinychat because of ____.', 0, 2, 'VS');
INSERT INTO black_cards VALUES (114, '____ for president!', 0, 1, 'VS');
INSERT INTO black_cards VALUES (115, 'I did ____, like a fucking adult.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (116, 'Domo travelled across ____ to win the prize of ____.', 0, 2, 'VS');
INSERT INTO black_cards VALUES (117, 'Roses and her hammer collection defeated an entire squadron of ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (118, 'After Blue posted ____ in chat, I never trusted his links again.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (119, 'Fuck you, I''m a ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (120, 'Cunnilungus and psychiatry brought us to ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (121, 'I CAN ____ ACROSS THE ____.', 0, 2, 'VS');
INSERT INTO black_cards VALUES (122, '____ is the only thing that matters.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (123, 'I''m an expert on ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (510, 'What can you always find in between the couch cushions?', 0, 1, 'RS');
INSERT INTO black_cards VALUES (125, 'I want ____ in my mouflon RIGHT MEOW.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (126, 'Don''t get mad, get ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (127, 'Have fun, don''t be ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (128, 'It''s the end of ____ as we know it.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (129, '____ is my worst habit.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (130, 'Everything''s better with ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (131, 'Yaar''s mother is ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (132, 'What would you taste like?', 0, 1, 'VS');
INSERT INTO black_cards VALUES (133, 'What have you accomplished today?', 0, 1, 'VS');
INSERT INTO black_cards VALUES (134, 'What made you happy today?', 0, 1, 'VS');
INSERT INTO black_cards VALUES (135, 'Why are you frothing with rage?', 0, 1, 'VS');
INSERT INTO black_cards VALUES (136, 'What mildy annoyed you today?', 0, 1, 'VS');
INSERT INTO black_cards VALUES (137, 'We''ll always have ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (138, '____ uses ____. It is SUPER EFFECTIVE!', 0, 2, 'VS');
INSERT INTO black_cards VALUES (139, 'Let''s all rock out to the sounds of ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (140, 'Take ____, it will last longer.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (141, 'You have my bow. AND MY ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (142, 'VS: Where the ____ happens!', 0, 1, 'VS');
INSERT INTO black_cards VALUES (143, '____? FRY. EYES.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (144, 'A wild ____ appeared! It used ____!', 0, 2, 'VS');
INSERT INTO black_cards VALUES (145, 'I thought being a ____ was the best thing ever, until I became a ____.', 0, 2, 'VS');
INSERT INTO black_cards VALUES (146, 'Live long and ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (511, 'The victim was found with ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (148, 'I''m under the ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (149, 'If life gives you ____, make ____.', 0, 2, 'VS');
INSERT INTO black_cards VALUES (150, 'Who needs a bidet when you have ____?', 0, 1, 'VS');
INSERT INTO black_cards VALUES (151, 'Kill it with ____!', 0, 1, 'VS');
INSERT INTO black_cards VALUES (152, 'My ____ is too big!', 0, 1, 'VS');
INSERT INTO black_cards VALUES (153, 'Best drink ever: One part ____, three parts ____, and a splash of ____.', 2, 3, 'VS');
INSERT INTO black_cards VALUES (154, '____ makes me uncomfortable.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (155, 'Stop, drop, and ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (156, 'Think before you ____.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (157, 'The hills are alive with ____ of ____.', 0, 2, 'VS');
INSERT INTO black_cards VALUES (512, 'What is love without ____?', 0, 1, 'RS');
INSERT INTO black_cards VALUES (100004, 'test<sup>&reg;</sup><br><i>italic</i>&trade;<br><span class="card_number"><b>&uarr;</b></span>', 0, 1, 'test');
INSERT INTO black_cards VALUES (100006, '____ is the name of my ____ cover band.', 0, 2, 'SG');
INSERT INTO black_cards VALUES (100016, 'Alcoholic games of Clue&reg; lead to ____.', 0, 1, 'SG');
INSERT INTO black_cards VALUES (100027, 'I have an idea even better than Kickstarter, and it''s called ____starter.', 0, 1, 'PAX A');
INSERT INTO black_cards VALUES (100028, 'You have been waylaid by ____ and must defend yourself.', 0, 1, 'PAX A');
INSERT INTO black_cards VALUES (100037, 'Action stations! Action stations! Set condition one throughout the fleet and brace for ____!', 0, 1, 'PAX B');
INSERT INTO black_cards VALUES (100038, 'In the final round of this year''s Omegathon, Omeganauts must face off in a game of ____.', 0, 1, 'PAX B');
INSERT INTO black_cards VALUES (100047, 'Press <span class="card_number">&darr;</span><span class="card_number">&darr;</span><span class="card_number">&larr;</span><span class="card_number">&rarr;</span><span class="card_number">B</span> to unleash ____.', 0, 1, 'PAX C');
INSERT INTO black_cards VALUES (100048, 'I don''t know exactly how I got the PAX plague, but I suspect it had something to do with ____.', 0, 1, 'PAX C');
INSERT INTO black_cards VALUES (100054, '____: Hours of fun. Easy to use. Perfect for ____!', 0, 2, 'X3');
INSERT INTO black_cards VALUES (100058, 'Turns out that ____-Man was neither the hero we needed nor wanted.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100059, 'What left this stain on my couch?', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100065, 'Call the law offices of Goldstein &amp; Goldstein, because no one should have to tolerate ____ in the workplace.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100066, 'A successful job interview begins with a firm handshake and ends with ____.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100070, 'Lovin'' you is easy ''cause you''re ____.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100074, 'Money can''t buy me love, but it can buy me ____.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100078, 'Listen, son. If you want to get involved with ____, I won''t stop you. Just steer clear of ____.', 0, 2, 'X3');
INSERT INTO black_cards VALUES (100085, 'During high school, I never really fit in until I found ____ club.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100089, 'Hey baby, come back to my place and I''ll show you ____.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100093, 'To prepare for his upcoming role, Daniel Day-Lewis immersed himself in the world of ____.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100094, 'Finally! A service that delivers ____ right to your door.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100095, 'My gym teacher got fired for adding ____ to the obstacle course.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100096, 'When you get right down to it, ____ is just ____.', 0, 2, 'X3');
INSERT INTO black_cards VALUES (100097, 'As part of his daily regimen, Anderson Cooper sets aside 15 minutes for ____.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100098, 'In the seventh circle of Hell, sinners must endure ____ for all eternity.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100100, 'After months of practice with ____, I think I''m finally ready for ____.', 0, 2, 'X3');
INSERT INTO black_cards VALUES (100103, 'The blind date was going horribly until we discovered our shared interest in ____.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100104, '____. Awesome in theory, kind of a mess in practice.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100105, 'With enough time and pressure, ____ will turn into ____.', 0, 2, 'X3');
INSERT INTO black_cards VALUES (100106, 'I''m not like the rest of you. I''m too rich and busy for ____.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100108, 'And what did <i>you</i> bring for show and tell?', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100110, 'Having problems with ____? Try ____!', 0, 2, 'X3');
INSERT INTO black_cards VALUES (100113, 'As part of his contract, Prince won''t perform without ____ in his dressing room.', 0, 1, 'X3');
INSERT INTO black_cards VALUES (100155, '____.tumblr.com', 0, 1, 'SG');
INSERT INTO black_cards VALUES (17, 'What''s the next Happy Meal&reg; toy?', 0, 1, NULL);
INSERT INTO black_cards VALUES (100092, 'My life is ruled by a vicious cycle of ____ and ____.', 0, 2, 'X3');
INSERT INTO black_cards VALUES (124, 'After I saw ____, I needed ____.', 0, 2, 'VS');
INSERT INTO black_cards VALUES (147, 'There''s ____ in my soup.', 0, 1, 'VS');
INSERT INTO black_cards VALUES (158, '____ caused Northernlion to take stupid damage.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (159, '____ Is the best item in The Binding of Isaac.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (160, '____ is the worst item in The Binding of Isaac.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (161, '____ is/are Northernlion''s worst nightmare.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (162, '____ sounds like a great alternative rock band.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (163, '____: The Northernlion Story.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (164, '____? Well, I won''t look a gift horse in the mouth on that one.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (165, '____. Everything else is uncivilized.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (166, '"Hey everybody and welcome to Let''s Look At ____!"', 0, 1, 'NL');
INSERT INTO black_cards VALUES (167, 'As always, I will ____ you next time!', 0, 1, 'NL');
INSERT INTO black_cards VALUES (168, 'Best game of 2013? ____, of course.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (169, 'But that ____ has sailed.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (87, 'Lifetime&reg; presents ____, the story of ____.', 0, 2, NULL);
INSERT INTO black_cards VALUES (92, 'Dear Abby,<br><br>I''m having some trouble with ____ and would like your advice.', 0, 1, '1.2');
INSERT INTO black_cards VALUES (170, 'Even ____ is/are better at video games than Northernlion.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (171, 'Everything''s coming up ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (172, 'Finding something like ____ would turn this run around.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (173, 'Fuck the haters, this is ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (174, 'Get in my ____ zone.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (175, 'How do you get your dog to stop humping your leg?', 0, 1, 'NL');
INSERT INTO black_cards VALUES (176, 'I can do ____ and die immediately afterward.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (177, 'I don''t even see ____ anymore; all I see are blondes, brunettes, redheads...', 0, 1, 'NL');
INSERT INTO black_cards VALUES (178, 'I''m in the permanent ____ state.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (179, 'If sloth ____ are wrong I don’t want to be right.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (180, 'Invaded the world of ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (181, 'It''s ____, ya dangus!', 0, 1, 'NL');
INSERT INTO black_cards VALUES (182, 'JSmithOTI: Total ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (183, 'Legend has it, the Thug of Porn was arrested for ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (184, 'Let''s Look At: ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (185, 'Northernlion''s latest novelty Twitter account is @____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (186, 'More like the Duke of ____, right?', 0, 1, 'NL');
INSERT INTO black_cards VALUES (187, 'No one man should have all that ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (188, 'Northernlion has been facing ridicule for calling ____ a rogue-like.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (189, 'Northernlion always forgets the name of ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (190, 'Northernlion''s refusal to Let''s Play ____ was probably a good call.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (191, 'Of all the things that Ryan and Josh have in common, they bond together through their mutual love of ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (192, 'Oh god, I can''t believe we ate ____ at PAX.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (193, 'One thing Northernlion was right about was ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (194, 'Only in Korea can you see ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (195, 'Praise the ____!', 0, 1, 'NL');
INSERT INTO black_cards VALUES (196, 'Recently, Northernlion has felt woefully insecure due to ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (197, 'Roguelike? How about ___-like.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (198, 'Sometimes, a man''s just gotta ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (199, 'The hero of the stream was ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (200, 'The stream was going well until ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (201, 'The Youtube chat proved ineffective, so instead we had to communicate via ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (202, '____? It''s a DLC item.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (203, 'This new game is an interesting ____-like-like.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (204, 'We''re rolling in ____!', 0, 1, 'NL');
INSERT INTO black_cards VALUES (205, 'Whenever I ___, take a drink.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (206, 'Today''s trivia topic is ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (207, 'What do you give to the CEO of Youtube as a gift?', 0, 1, 'NL');
INSERT INTO black_cards VALUES (208, 'The only way NL is ever going to make it to Hell in Spelunky is by using ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (209, 'That ____ has sailed.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (210, 'Welcome back to The Binding of Isaac. Today''s challenge run will be based on  ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (211, 'Well there''s nothing wrong with ____ by any stretch of the imagination.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (212, 'I''d sacrifice ____ at the Altar.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (213, 'Fox would still be here if not for ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (214, 'The Holy Trinity: ____, ____, and ____!', 2, 3, 'NL');
INSERT INTO black_cards VALUES (215, 'I wasn''t even that drunk! I just had some ____, ____, and ____.', 2, 3, 'NL');
INSERT INTO black_cards VALUES (216, '____ was indicted on account of ____.', 0, 2, 'NL');
INSERT INTO black_cards VALUES (217, '____: The ____ Story.', 0, 2, 'NL');
INSERT INTO black_cards VALUES (8710, 'What does Alucard have nightmares about?', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (219, 'Hello everybody, welcome to a new episode of ____ plays ____.', 0, 2, 'NL');
INSERT INTO black_cards VALUES (220, 'I beat Blue Baby with only ____ and ____!', 0, 2, 'NL');
INSERT INTO black_cards VALUES (221, 'Northernlion has alienated fans of ____ by calling them ____.', 0, 2, 'NL');
INSERT INTO black_cards VALUES (222, 'Northernlion was fired from his teaching job and had to flee South Korea after an incident involving  ____ and ____.', 0, 2, 'NL');
INSERT INTO black_cards VALUES (8711, 'I''ve always wanted to become a voice actor, so I could play the role of ____.', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (5100, 'My original species combines ____ and ____. It''s called ____.', 2, 3, 'Furry');
INSERT INTO black_cards VALUES (5101, '____. And now I''m bleeding.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (100159, 'Don''t slow down in East Cleveland or ____.', 0, 1, 'SG');
INSERT INTO black_cards VALUES (53, 'While the United States raced the Soviet Union to the moon, the Mexican government funneled millions of pesos into research on ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (226, 'My life for ____!', 0, 1, 'RS');
INSERT INTO black_cards VALUES (513, 'Who let the dogs out?', 0, 1, 'RS');
INSERT INTO black_cards VALUES (514, 'In his next movie, Will Smith saves the world from ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (515, 'Lady Gaga has revealed her new dress will be made of ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (516, 'Justin Beiber''s new song is all about ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (517, 'The new fad diet is all about making people do ____ and eat ____.', 0, 2, 'RS');
INSERT INTO black_cards VALUES (518, 'Grand Theft Auto&trade;: ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (519, 'I whip my ____ back and forth.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (520, 'When North Korea gets ____, it will be the end of the world.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (521, 'Plan a three course meal.', 2, 3, 'RS');
INSERT INTO black_cards VALUES (522, 'Tastes like ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (523, 'What is literally worse than Hitler?', 0, 1, 'RS');
INSERT INTO black_cards VALUES (524, '____ ruined many people''s childhood.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (525, '____ and ____ are the new hot couple.', 0, 2, 'RS');
INSERT INTO black_cards VALUES (526, 'Who needs college when you have ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (527, 'When short on money, you can always ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (528, 'What will Xyzzy take over the world with?', 0, 1, 'RS');
INSERT INTO black_cards VALUES (529, 'The next pokemon will combine ____ and ____.', 0, 2, 'RS');
INSERT INTO black_cards VALUES (530, 'Who is GLaDOS''s next test subject?', 0, 1, 'RS');
INSERT INTO black_cards VALUES (531, 'Instead of playing Cards Against Humanity, you could be ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (532, 'The next Assassin''s Creed game will take place in ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (533, 'I wouldn''t fuck ____ with ____''s dick.', 0, 2, 'RS');
INSERT INTO black_cards VALUES (534, 'One does not simply walk into ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (535, 'In the next Punch Out!!, ____ will be the secret final boss.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (536, 'Welcome to my secret lair on ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (537, 'Dustin Browder demands more ____ in StarCraft&reg;.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (538, 'What is the answer to life''s question?', 0, 1, 'RS');
INSERT INTO black_cards VALUES (539, 'I''ve got the whole world in my ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (540, 'I never thought ____ would be so enjoyable.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (541, 'In his second term, Obama will rid America of ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (542, 'What is Japan''s national pastime?', 0, 1, 'RS');
INSERT INTO black_cards VALUES (5102, 'Suck my ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (543, 'In the future, ____ will fuel our cars.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (544, 'The lion, the witch, and ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (545, 'In the next episode, SpongeBob gets introduced to ____. ', 0, 1, 'RS');
INSERT INTO black_cards VALUES (546, '____ Game of the Year Edition.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (547, 'What was going through Osama Bin Laden''s head before he died?', 0, 1, 'RS');
INSERT INTO black_cards VALUES (548, 'In a news conference, Obama pulled out ____, to everyone''s surprise.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (549, 'Nights filled with ____.', 0, 1, 'RS');
INSERT INTO black_cards VALUES (738, 'To top One More Day, future comic writers will use ____ to break up a relationship.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (739, 'The real reason MAGFest was ruined was ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (740, 'The reason Linkara doesn''t like milk in his cereal is ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (741, 'The secret of Linkara''s magic gun is ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8712, 'If the anime industry is dying, what will be the final nail in it''s coffin?', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (743, 'For the next Anniversary event, the TGWTG producers must battle ____ to get ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (744, 'If a dog and a dolphin can get along, why not ____ and ____?', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (745, 'If I wanted to see ____, I''ll stick with ____, thank you very much.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (746, 'I asked Linkara to retweet ____, but instead, he retweeted ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (747, 'I write slash fanfiction pairing ____ with ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8713, 'Ladies and gentlemen, I give you ____... COVERED IN BEES!!!', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (749, 'Next time on Obscurus Lupa Presents: " ____ IV: The Return of ____".', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8714, 'Don''t stand behind him, if you value your ____.', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (751, 'Todd in the Shadows broke the Not a Rhyme button when the singer tried to rhyme ____ with ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (752, 'Welshy is to ____ as Sad Panda is to ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (753, 'Linkara''s next story arc will involve him defeating ____ with the power of  ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (754, 'Rock and Roll is nothing but ____ and the rage of ____!', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8715, 'What the hell is "Juvijuvibro"?!', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (756, 'Being fed up with reviewing lamps, what obscure topic did Linkara review next?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (225, 'When I was a kid, all we had in Lunchables were three ____ and ____.', 0, 2, 'NL');
INSERT INTO black_cards VALUES (224, 'On its last dying breath, ____ sent out a cry for help. A bunch of ____ heard the cry.', 0, 2, 'NL');
INSERT INTO black_cards VALUES (5103, 'I also take ____ as payment for commissions.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5015, '____ looks pretty in all the art, but have you seen one in real life?', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (100203, 'At the last PAX, Paul and Storm had ____ thrown at them during "Opening Band".', 0, 1, 'SG');
INSERT INTO black_cards VALUES (100206, 'How did I lose my virginity?', 0, 1, '1.3');
INSERT INTO black_cards VALUES (100207, 'Here is the church<br>Here is the steeple<br>Open the doors<br>And there is ____.', 0, 1, '1.3');
INSERT INTO black_cards VALUES (100208, 'During his childhood, Salvador Dal&iacute; produced hundreds of paintings of ____.', 0, 1, '1.3');
INSERT INTO black_cards VALUES (6, 'This is the way the world ends \ This is the way the world ends \ Not with a bang but with ____.', 0, 1, NULL);
INSERT INTO black_cards VALUES (100209, 'In 1,000 years, when paper money is a distant memory, how will we pay for goods and services?', 0, 1, '1.3');
INSERT INTO black_cards VALUES (34, 'War!<br><br>What is it good for?', 0, 1, NULL);
INSERT INTO black_cards VALUES (100210, 'What don''t you want to find in your Kung Pao chicken?', 0, 1, '1.3');
INSERT INTO black_cards VALUES (84, 'Rumor has it that Vladimir Putin''s favorite delicacy is ____ stuffed with ____.', 0, 2, NULL);
INSERT INTO black_cards VALUES (100217, 'The Smithsonian Museum of Natural History has just opened an exhibit on ____.', 0, 1, '1.3');
INSERT INTO black_cards VALUES (100218, 'What did the commenters bitch about next to Doug?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (5016, 'At first I couldn''t understand ____, but now it''s my biggest kink.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5017, 'Long story short, I ended up with ____ in my ass.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5018, 'Don''t knock ____ until you''ve tried it.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5019, 'Who knew I''d be able to make a living off of ____?', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5020, 'It''s difficult to explain to friends and family why I know so much about ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5021, 'Once I started roleplaying ____, it was all downhill from there.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5022, '____ are so goddamn cool.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5023, '____, by Bad Dragon™.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5024, 'No, look, you don''t understand. I REALLY like ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5025, 'I don''t think my parents will ever accept that the real me is ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5026, 'I can''t believe I spent most of my paycheck on ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5027, 'You can try to justify ____ all you want, but you don''t have to be ____ to realize it''s just plain wrong.', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5028, 'I''ve been waiting all year for ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5029, 'I can''t wait to meet up with my internet friends for ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (771, 'The next crossover will have ____ and ____ review ____.', 2, 3, 'TGWTG');
INSERT INTO black_cards VALUES (772, 'We all made a mistake when we ate ____ at MAGFest.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (773, 'Kyle''s next student film will focus on ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (774, 'The RDA chat knew Nash was trolling them when he played ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (775, 'Why does Linkara have all of those Cybermats?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (776, '____ will be the subject of the next TGWTG panel at MAGFest.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (777, 'At his next con appearance, Linkara will cosplay as ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (778, 'WAIT!  I have an idea!  It involves using ____!', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (779, 'What does Linkara eat with his chicken strips?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (723, 'Why was Radio Dead Air shut down this time?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (780, 'If you value your life, never mention ____ around Oancitizen.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (781, 'Arlo P. Arlo''s newest weapon combines ____ and ____!', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (782, '____ and ____ are in the worst comic Linkara ever read.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (783, '____ is only on the site because of ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (784, 'The newest fanfic trend is turning ____ into ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (785, 'Every weekend, Golby likes to ____ then ____ before finally ____.', 2, 3, 'GFC');
INSERT INTO black_cards VALUES (786, 'Every weekend, Golby enjoys drinking ____ before getting into a fight with ____ and having sex with ____.', 2, 3, 'GFC');
INSERT INTO black_cards VALUES (787, 'Connie the Condor often doesn''t talk on skype because of ____.', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (788, 'Jorgi the Corgi most definitely enjoys ____.', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (789, 'Tom is good, but he''s not ____ good.', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (790, 'It''s DJ Manny in the hizouse, playing ____ all night long!', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (791, 'BENCH ALL THE ____.', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (792, 'Hey guys, check out my ____ montage!', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (793, '____ + ____ = Golby.', 0, 2, 'GFC');
INSERT INTO black_cards VALUES (653, '____ is the reason Linkara doesn''t like to swear.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (654, '____ was completely avoidable!', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (655, '____ will live!', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (656, '____ is something else Diamanda Hagan has to live with every day.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (657, '____ should be on TGWTG.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (658, '____ was the first thing to go when Hagan took over the world.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (659, '____! What are you doing here?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (660, '____! You know, for kids.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (661, 'I love ____. It''s so bad.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8716, 'As part of a recent promotion, Japanese KFCs are now dressing their Colonel Sanders statues up as ____.', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (663, '____. With onions.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (664, '____ is the theme of this year''s anniversary crossover.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (665, 'A ____ Credit Card!?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8717, 'Fighting ____ by moonlight! Winning ____ by daylight! Never running from a real fight! She is the one named ____!', 2, 3, 'ANX1');
INSERT INTO black_cards VALUES (8718, 'It''s no secret.  Deep down, everybody wants to fuck ____.', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (8719, 'Behold! My trap card, ____!', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (669, 'Blip checks are way smaller in January so I''ll spend the month riffing on ____ to gain more views.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (670, 'Brad Tries ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (671, 'Doug still regrets the day he decided to do a Let''s Play video for "Bart Simpson''s ____ Adventure".', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (672, 'Enemies of Diamanda Hagan have been known to receive strange packages filled with  ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (673, 'High and away on a wing and a prayer, who could it be? Believe it or not, it''s just ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (674, 'What broke Nash this week?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (675, 'I ____ so you don''t have to.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (676, 'I AM THE VOICELESS. THE NEVER SHOULD. I AM ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (677, 'I prefer for MY exploitation films to have ____, thank you very much.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (678, 'I watch movies just to see if I can find a Big Lipped ____ Moment.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (679, 'I''m looking forward to Jesuotaku''s playthrough of Fire Emblem: ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8720, 'After eating a Devil Fruit, I now have the power of ____.', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (681, 'In his latest review, Phelous was killed by ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (682, 'It was all going well until they found ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (683, 'JW confirms, you can play ____,', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (684, 'Next January, the Nostalgia Critic is doing ____ Month.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (685, 'No one wants to see your ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (686, 'Of Course! Don''t you know anything about ____?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (687, 'OH MY GOD THIS IS THE GREATEST ____ I''VE EVER SEEN IN MY LIFE!', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (688, 'On the other side of the Plot Hole, the Nostalgia Critic found ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (689, 'Reactions were mixed when ____ joined TGWTG.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (690, 'Sage has presented JO with the new ecchi series ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (691, 'Sean got his head stuck in ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (692, 'STOP OR I WILL ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (693, 'The invasion of Molassia was tragically thwarted by ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (694, 'The newest reviewer addition to the site specializes in ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (695, 'The next person to leave Channel Awesome will announce their departure via ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (696, 'The next Renegade Cut is about ____ in a beloved children''s movie.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (697, 'The Nostalgia Critic will NEVER review ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (698, 'The only thing Linkara would sell his soul for is ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (699, 'What is the real reason Demo Reel failed?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8721, 'By far, the most mind-bogglingly awesome thing I''ve ever seen in anime is ____.', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (8722, 'My Little Sister Can''t Be ____!', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (702, 'This weekend, the nation of Haganistan will once again commence its annual celebration of ____.  ', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (703, 'To troll the RDA chat this time, Todd requested a song by ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (704, 'Todd knew he didn''t have a chance after trying to seduce Lupa with ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (705, 'Turns out, that wasn''t tea in MikeJ''s cup, it was ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (706, 'Viewers were shocked when Paw declared ____ the best song of the movie.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (707, 'WE WERE FIGHTING LIKE ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (708, 'Well, I''ve read enough fanfic about ____ and Lupa to last a lifetime.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (709, 'What does Nash like to sing about?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (710, 'What does Todd look like under his mask?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (711, 'What doesn''t go there?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (712, 'What doesn''t work that way?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (713, 'What else does Diamanda Hagan have to live with every day?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (714, 'What is in Sci Fi Guy''s vest?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (715, 'What the fuck is wrong with you?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (716, 'What will Tara name her next hippo?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (717, 'What''s holding up the site redesign?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (718, 'What''s really inside the Plot Hole?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (719, 'What''s the real reason nobody has ever played the TGWTG Panel Drinking Game?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (720, 'What''s up next on WTFIWWY?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (721, 'When the JesuOtaku stream got to the "awful part of the night," the GreatSG video featured ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (722, 'Why can''t Film Brain stop extending his final vowels?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (724, '90''s Kid''s favorite comic is ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (725, 'Because poor literacy is ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (726, 'He is a glitch. He is missing. He is ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (727, 'In a surprise twist, the villain of Linkara''s next story arc turned out to be ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (728, 'Linkara now prefers to say ____ in lieu of "fuck".', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (729, 'Of course!  Don''t you know anything about ___?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (730, 'Snowflame feels no ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (731, 'Snowflame found a new love besides cocaine. What is it?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (732, 'So let''s dig into ____ #1.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (734, 'Where''d he purchase that?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (735, 'When is the next History of Power Rangers coming out?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (736, 'What is as low as the standards of the 90''s Kid?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (737, 'What delayed the next History of Power Rangers?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (100163, '____ has the "mount" keyword.', 0, 1, 'SG');
INSERT INTO black_cards VALUES (794, 'On a night out, Golby will traditionally get into a fight with a ____ then have sex with a ____ before complaining about a hangover from too much ____.', 2, 3, 'GFC');
INSERT INTO black_cards VALUES (795, 'You''re so _____ I''ll have to delete you.', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (796, 'Cindi suddenly turned into Steven after ____.', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (797, 'When Barta isn''t talking he''s ____.', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (798, 'I got a new tattoo, it looks a bit like ____.', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (799, 'What strange Korean delicacy will Mark enjoy today?', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (800, '____ is camping my lane.', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (801, 'The OGN was fun, but there was far too much ____ cosplay.', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (802, '"What are you thinking?" "You know, ____ and stuff."', 0, 1, 'GFC');
INSERT INTO black_cards VALUES (100223, 'Drunken games of Pretend You''re Xyzzy lead to ____ and ____.', 0, 2, 'SG');
INSERT INTO black_cards VALUES (803, 'Vegeta, what does the scouter say?', 0, 1, 'AN');
INSERT INTO black_cards VALUES (804, '____. BELIEVE IT!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (805, 'Make a contract with me, and become ____!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (806, 'You guys are so wrong. Obviously, ____ is best waifu.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (807, 'In the latest chapter of Toriko, our hero hunts down, kills, and eats a creature made entirely of ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (808, 'THIS ____ HAS BEEN PASSED DOWN THE ARMSTRONG FAMILY LINE FOR GENERATIONS!!!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (809, 'My favorite episode of ____ is the one with ____.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (810, 'Make a yaoi shipping.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (811, 'This doujinshi I just bought has ____ and ____ getting it on, hardcore.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (812, 'On the next episode of Dragon Ball Z, ____ is forced to do the fusion dance with ____.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (813, 'You are already ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (814, 'Who the hell do you think I am?!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (815, 'On the next episode of Dragon Ball Z, Goku has a fierce battle with ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (816, '____. YOU SHOULD BE WATCHING.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (5096, 'Most cats are ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (818, 'Fresh from Japan: The new smash hit single by ____ titled ____.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (819, '____ vs. ____. BEST. FIGHT. EVER.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (820, 'So wait, ____ was actually ____? Wow, I didn''t see that one coming!', 0, 2, 'AN');
INSERT INTO black_cards VALUES (821, 'Real men watch ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (822, 'When it comes to hentai, nothing gets me hotter than ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (823, 'Whenever I''m splashed with cold water, I turn into ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (824, 'No matter how you look at it, ultimately ____ is responsible for ____.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (825, 'S-Shut up!! I-It''s not like I''m ____ or anything.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (826, 'The English dub of ____ sucks worse than ____.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (827, 'What is mo&eacute;?', 0, 1, 'AN');
INSERT INTO black_cards VALUES (828, 'Hayao Miyazaki''s latest family film is about a young boy befriending ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (829, 'Congratulations, ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (830, 'By far the best panel at any anime convention is the one for ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (831, 'One thing you almost never see in anime is ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (832, 'The rarest Pok&eacute;mon in my collection is ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (833, 'What do I hate most about anime?', 0, 1, 'AN');
INSERT INTO black_cards VALUES (834, 'Mamoru Oshii''s latest film is a slow-paced, two hour-long cerebral piece about the horrors of ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (835, 'What do I love most about anime?', 0, 1, 'AN');
INSERT INTO black_cards VALUES (836, 'This morning, hundreds of Japanese otaku lined up outside their favorite store to buy the limited collector''s edition of ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (837, 'Every now and then, I like to participate in the time-honored Japanese tradition of ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (838, 'There are guilty pleasures. And then there''s ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (839, 'Watch it! Or I''ll take your ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (840, 'New from Studio GAINAX: ____ the Animation.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (841, 'Using my power of Geass, I command you to do... THIS!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (842, 'Chicks. Dig. ____. <i>Nice.</i>', 0, 1, 'AN');
INSERT INTO black_cards VALUES (843, 'When it comes to Japanese cuisine, there''s simply nothing better than ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (844, 'The next big Tokusatsu show: "Super Sentai ____ Ranger!"', 0, 1, 'AN');
INSERT INTO black_cards VALUES (845, 'In the name of the moon, I will punish ____!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (846, 'Just announced: The brand new anime adaptation of ____, starring ____ as the voice of ____.', 2, 3, 'AN');
INSERT INTO black_cards VALUES (847, 'Don''t worry, he''s okay! He survived thanks to ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (848, '____. Goddammit, Japan.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (849, 'In the latest chapter of Golgo 13, he kills his target with ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (850, 'Welcome home, Master! Is there anything your servant girl can bring you today?', 0, 1, 'AN');
INSERT INTO black_cards VALUES (851, 'In the latest episode of Case Closed, Conan deduces that it was ____ who killed ____ because of ____.', 2, 3, 'AN');
INSERT INTO black_cards VALUES (852, 'I have never in my life laughed harder than the first time I watched ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (853, 'Take this! My love, my anger, and all of my ____!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (854, 'Karaoke night! I''m totally gonna sing my favorite song, ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (855, 'Digimon! Digivolve to: ____-mon!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (856, 'Now! Face my ultimate attack!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (857, 'Behold the name of my Zanpakuto, ____!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (858, 'From the twisted mind of Nabeshin: An anime about ____, ____, and ____.', 2, 3, 'AN');
INSERT INTO black_cards VALUES (859, '____. Only on Toonami', 0, 1, 'AN');
INSERT INTO black_cards VALUES (860, 'I am in despair! ____ has left me in despair!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (861, 'The new manga from ____ is about a highschool girl discovering ____.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (862, 'To save the world, you must collect all 7 ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (863, 'Sasuke has ____ implants.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (864, 'In truth, the EVA units are actually powered by the souls of ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (865, 'Dreaming! Don''t give it up ____! Dreaming! Don''t give it up ____! Dreaming! Don''t give it up ____!', 2, 3, 'AN');
INSERT INTO black_cards VALUES (817, 'Lupin the III''s latest caper involves him trying to steal ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (666, 'A piece of ____ is missing.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (667, 'What do Brad and Floyd like to do after a long day?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (668, 'At least he didn''t fuck ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (742, 'Hello, and welcome to Atop ____, where ____ burns.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8723, 'No matter how I look at it, it''s your fault I''m not ____!', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (662, 'Hello, I''m the Nostalgia Critic. I remember ____ so you don''t have to!', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (5098, 'Taking pride in one''s collection of ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (755, 'If you are able to deflect ____ with ____, we refer to it as "Frying ____".', 2, 3, 'TGWTG');
INSERT INTO black_cards VALUES (8724, 'They are the prey, and we are the ____.', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (5030, 'Did you hear about the guy that smuggled ____ into the hotel?', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (867, 'The new Gurren Lagann blurays from Aniplex will literally cost you ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (868, 'The most overused anime cliche is ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (869, 'The inspiration behind the latest hit show is ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (870, 'While writing Dragon Ball, Akira Toriyama would occasionally take a break from working to enjoy ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (871, 'The show was great, until ____ showed up.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (872, 'Nothing ruins a good anime faster than ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (873, 'People die when they are ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (874, 'I want to be the very best, like no one ever was! ____ is my real test, ____ is my cause!', 0, 2, 'AN');
INSERT INTO black_cards VALUES (875, 'Okay, I''ll admit it. I would totally go gay for ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (876, 'Who are you callin'' ____ so short he can''t see over his own ____?!?!', 0, 2, 'AN');
INSERT INTO black_cards VALUES (877, 'If you ask me, there need to be more shows about ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (878, '____. That is the kind of man I was.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (879, 'I''m sorry! I''m sorry! I didn''t mean to accidentally walk in on you while you were ____!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (880, 'After a long, arduous battle, ____ finally met their end by ____.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (881, 'This is our final battle. Mark my words, I will defeat you, ____!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (882, 'You used ____. It''s super effective!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (883, 'The best English dub I''ve ever heard is the one for ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (884, 'I know of opinions and all that, but I just don''t understand how anyone could actually enjoy ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (885, '____. HE DEDD.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (886, 'She''ll thaw out if you try ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (887, 'You see, I''m simply ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (888, 'Yoko Kanno''s latest musical score features a song sung entirely by ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (889, 'Truly and without question, ____ is the manliest of all men.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (890, 'WANTED: $50,000,000,000 reward for the apprehension of____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (891, 'This year, I totally lucked out and found ____ in the dealer''s room.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (892, 'How did I avoid your attack? Simple. By ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (893, 'If I was a magical girl, my cute mascot sidekick would be ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (894, 'From the creators of Tiger &amp; Bunny: ____ &amp; ____!!', 0, 2, 'AN');
INSERT INTO black_cards VALUES (895, 'In the future of 199X, the barrier between our world and the demon world is broken, and thousands of monsters invade our realm to feed upon ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (896, 'Animation studio ____ is perhaps best known for ____.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (897, '____. So kawaii!! &lt;3 &lt;3', 0, 1, 'AN');
INSERT INTO black_cards VALUES (898, 'The most annoying kind of anime fans are ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (899, 'Cooking is so fun! Cooking is so fun! Now it''s time to take a break and see what we have done! ____. YAY! IT''S READY!!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (900, 'My favorite hentai is the one where ____ is held down and violated by ____.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (901, 'The government of Japan recently passed a law that effectively forbids all forms of ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (903, 'This year, I''m totally gonna cosplay as ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (904, 'Coming to Neon Alley: ____, completely UNCUT &amp; UNCENSORED.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (905, 'No matter how many times I see it, ____ always brings a tear to my eye.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (906, 'Of my entire collection, my most prized possession is ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (907, 'Who placed first in the most recent Shonen Jump popularity poll?', 0, 1, 'AN');
INSERT INTO black_cards VALUES (908, 'Someday when I have kids, I want to share with them the joys of ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (909, 'So, what have you learned from all of this?', 0, 1, 'AN');
INSERT INTO black_cards VALUES (910, 'In this episode of Master Keaton, Keaton builds ____ out of ____ and ____.', 2, 3, 'AN');
INSERT INTO black_cards VALUES (911, 'The World Line was changed when I sent a D-mail to myself about ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (912, 'My ____ is the ____ that will pierce the heavens!!  <i>*same white card used for both blanks*</i>', 0, 1, 'AN');
INSERT INTO black_cards VALUES (913, 'After years of searching, the crew of the Thousand Sunny finally found out that the One Piece is actually ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (914, 'When I found all 7 Dragon Balls, Shenron granted me my wish for ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (915, 'The best part of my ____ costume is ____.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (916, 'Cards Against Anime: It''s more fun than ____!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (917, 'On the mean streets of Tokyo, everyone knows that ____ is the leader of the ________ Gang.', 0, 2, 'AN');
INSERT INTO black_cards VALUES (918, 'He might just save the universe, if he only had some ____!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (920, 'Make a harem.', 3, 5, 'AN');
INSERT INTO black_cards VALUES (921, 'Make a dub cast. ____ as ____, ____ as ____, &amp; ____ as ____.', 4, 6, 'AN');
INSERT INTO black_cards VALUES (922, 'So just who is this Henry Goto fellow, anyway?', 0, 1, 'AN');
INSERT INTO black_cards VALUES (923, 'When Henry Goto is alone and thinks that no one''s looking, he secretly enjoys ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (924, 'Dr. Black Jack, please hurry! The patient is suffering from a terminal case of ____!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (925, 'I''M-A FIRIN'' MAH ____!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (926, 'Make a love triangle.', 2, 3, 'AN');
INSERT INTO black_cards VALUES (919, 'This ____ of mine glows with an awesome power! Its ____ tells me to defeat you!', 0, 2, 'AN');
INSERT INTO black_cards VALUES (866, 'Yo-Ho-Ho! He took a bite of ____.', 0, 1, 'AN');
INSERT INTO black_cards VALUES (927, 'Scientists have reverse engineered alien technology that unlocks the secrets of ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (928, 'It is often argued that our ancestors would have never evolved without the aid of ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (929, 'The sad truth is, that at the edge of the universe, there is nothing but ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (930, 'The 1930''s is often regarded as the golden age of ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (931, '____ a day keeps ____ away.', 0, 2, 'MrMan');
INSERT INTO black_cards VALUES (932, 'There is a time for peace, a time for war, and a time for ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (933, 'If a pot of gold is at one end of the rainbow, what is at the other?', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (934, 'A fortune teller told me I will live a life filled with ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (935, 'The Himalayas are filled with many perils, such as ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (936, 'The road to success is paved with ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (937, 'I work out so I can look good when I''m ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (939, 'And on his farm he had ____, E-I-E-I-O!', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (940, 'Genius is 10% inspiration and 90% ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (941, 'I will not eat them Sam-I-Am. I will not eat ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (938, 'What''s the time? ____ time!', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (942, '____ is the root of all evil.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (943, 'The primitive villagers were both shocked and amazed when I showed them ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (944, 'And it is said his ghost still wanders these halls, forever searching for his lost ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (945, 'Disney presents ____, on ice!', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (946, 'The best part of waking up is ____ in your cup.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (947, 'Though Thomas Edison invented the lightbulb, he is also known for giving us ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (948, 'Little Miss. Muffet sat on her tuffet, eating her ____ and ____.', 0, 2, 'MrMan');
INSERT INTO black_cards VALUES (949, 'What do I keep hidden in the crawlspace?', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (950, 'Go-Go-Gadget, ____!', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (951, 'I qualify for this job because I have several years experience in the field of ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (952, 'We just adopted ____ from the pound.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (953, 'It was the happiest day of my life when I became the proud parent of ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (954, 'I finally realized I hit rock bottom when I started digging through dumpsters for ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (955, 'With a million times the destructive force of all our nuclear weapons combined, no one was able to survive ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (956, 'You have been found guilty of 5 counts of ____, and 13 counts of ____.', 0, 2, 'MrMan');
INSERT INTO black_cards VALUES (957, 'And the award for the filthiest scene in an adult film goes to "5 women and ____."', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (959, '"Why Grandma", said Little Red Riding Hood, "What big ____ you have!"', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (960, 'Pay no attention to ____ behind the curtain!', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (961, 'Who would have guessed that the alien invasion would be easily thwarted by ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (962, 'With Democrats and Republicans in a dead heat, the election was snatched by ____ party.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (963, 'Mama always said life was like ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (100226, 'Who could have guessed that the alien invasion would be easily thwarted by ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (100227, 'With the Democrats and Republicans in a dead heat, the election was snatched by the ____ party.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (5001, 'The panel I''m looking forward to most at AC this year is...', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5002, 'My Original Character''s name is ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5003, 'My secret tumblr account where I post nothing but ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5004, 'Only my internet friends know that I fantasize about ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5005, 'Everyone really just goes to the cons for ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5006, 'It all started with ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5007, 'I''ll roleplay ____, you can be ____.', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5008, 'I''m no longer allowed near ____ after the incident with ____.', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5009, 'I''ve been into ____ since before I hit puberty, I just didn''t know what it meant.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5010, 'Realizing, too late, the implications of your interest in ____ as a child.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5011, 'Whoa, I might fantasize about ____, but I''d never actually go that far in real life.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5012, 'I realized they were a furry when they mentioned ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5013, 'Everyone on this site has such strong opinions about ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5014, 'My landlord had a lot of uncomfortable questions for me when when he found ____ in my bedroom while I was at work.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5031, 'I''m not even aroused by normal porn anymore, I can only get off to ____ or ____.', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5032, '____? Oh, yeah, I could get my mouth around that.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5033, 'What wouldn''t I fuck?', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5034, 'When I thought I couldn''t go any lower, I realized I would probably fuck ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5035, 'I knew my boyfriend was a keeper when he said he''d try ____, just for me.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5036, 'Fuck ____, get ____.', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5038, 'I would bend over for ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5039, 'I think having horns would make ____ complicated.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5040, 'In my past life, I was ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5041, '____ is my spirit animal.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5042, '____. This is what my life has come to.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5043, 'I''m not even sad that I devote at least six hours of each day to ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5044, 'I never felt more accomplished than when I realized I could fit ____ into my ass.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5045, 'Yeah, I know I have a lot of ____ in my favorites, but I''m just here for the art.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5046, 'I''m not a "furry," I prefer to be called ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5047, 'Okay, ____? Pretty much the cutest thing ever.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5048, '____. Yeah, that''s a pretty interesting way to die.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5049, 'I didn''t believe the rumors about ____, until I saw the videos.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5050, 'I knew I needed to leave the fandom when I realized I was ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5051, 'After being a furry for so long, I can never see ____ without getting a little aroused.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5052, 'It''s really hard not to laugh at ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5053, 'If my parents ever found ____, I''d probably be disowned.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5054, '____ ruined the fandom.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5055, 'The most recent item in my search history.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5056, 'Is it weird that I want to rub my face on ____?', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (680, 'In her newest review, Diamanda Hagan finds herself in the body of ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8725, 'My love for you is like ____.  BERSERKER!', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (748, 'Last time I took bath salts, I ended up ____ in ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (750, 'Tara taught me that if you''re going to engage in ____, then ____ isn''t a good idea.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (700, 'The website was almost called "thatguywith____.com".', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (701, 'They even took ____! Who does that?!', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (733, 'You may be a robot, but I AM ____!', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (223, 'Northernlion''s doctor diagnosed him today with ____, an unfortunate condition that would lead to ____.', 0, 2, 'NL');
INSERT INTO black_cards VALUES (218, 'And now we''re going to be fighting ____ on ____.', 0, 2, 'NL');
INSERT INTO black_cards VALUES (8681, 'The comment section was nothing but ____ arguing about ____.', 0, 2, 'DAH');
INSERT INTO black_cards VALUES (8726, 'IT''S ____ TIME!', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (8727, 'It has been said... That there are entire forests of ____, made from the sweetest ____.', 0, 2, 'ANX1');
INSERT INTO black_cards VALUES (8728, 'Attention, duelists: My hair is ____.', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (8729, 'What do otaku smell like?', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (8730, 'Madoka Kyouno''s nickname for Muginami''s older brother is ____.', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (8731, '"____."<br>"What the hell, man?!"<br>"____."<br>"Oh, okay."', 0, 2, 'ANX1');
INSERT INTO black_cards VALUES (8732, 'And from Kyoto Animation, a show about cute girls doing ____.', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (8733, 'Anime has taught me that classic literature can always be improved by adding ____.', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (8734, 'The mo&eacute; debate was surprisingly civil until someone mentioned ____.', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (8735, 'That''s not a squid!  It''s ____!', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (8736, 'The Chocolate Underground stopped the Good For You Party by capturing their ____ and exposing their leader as ____.', 0, 2, 'ANX1');
INSERT INTO black_cards VALUES (8737, 'Who cares about the printing press, did that medieval peasant girl just invent ____?!', 0, 1, 'ANX1');
INSERT INTO black_cards VALUES (8747, 'Eating ____ gave me ____.', 2, 2, 'AI');
INSERT INTO black_cards VALUES (8748, 'The reason I go to church is to learn about ____.', 0, 1, 'AI');
INSERT INTO black_cards VALUES (8749, 'Show me on ____, where he ____.', 0, 2, 'AI');
INSERT INTO black_cards VALUES (8750, 'I wouldn''t ____ you with ____.', 0, 2, 'AI');
INSERT INTO black_cards VALUES (8751, 'All attempts at ____, have met with failure and crippling economic sanctions.', 0, 1, 'AI');
INSERT INTO black_cards VALUES (8752, 'Despite our Administration''s best efforts, we are still incapable of ____.', 0, 1, 'AI');
INSERT INTO black_cards VALUES (8753, 'Technology improves every day. One day soon, surfing the web will be replaced by ____.', 0, 1, 'AI');
INSERT INTO black_cards VALUES (8754, 'Choosy Moms Choose ____.', 0, 1, 'AI');
INSERT INTO black_cards VALUES (8755, 'At camp, we''d scare each other by telling stories about ____ around the fire.', 0, 1, 'AI');
INSERT INTO black_cards VALUES (1275, 'Big Mac sleeps soundly whenever ____ is with him.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1257, '____ has won the national Equestrian award for ____.', 0, 2, 'CAE');
INSERT INTO black_cards VALUES (1260, '____ is best pony.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1262, '____ should ____ ____.', 2, 3, 'CAE');
INSERT INTO black_cards VALUES (1264, '____? That''s future Spike''s problem.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1265, 'After a wild night of crusading, Applebloom learned that ____ was her super special talent.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1267, 'After a wild night of partying, Fluttershy awakens to find ____ in her bed.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1268, 'After living for thousands of years Celestia can only find pleasure in ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1270, 'Aloe and Lotus have been experimenting with a radical treatment that utilizes the therapeutic properties of ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1277, 'BUY SOME ____!', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1279, 'CUTIE MARK CRUSADERS; ____! YAY!', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1281, 'Daring Do and the quest for ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1283, 'Dear Princess Celestia, Today I learned about ____. ', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1285, 'Despite everypony''s expectations, Sweetie Belle''s cutie mark ended up being ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1287, 'Equestrian researchers have discovered that ____ is The 7th Element of Harmony.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1289, 'Every Morning, Princess Celestia Rises ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1303, 'In a stroke of unparalleled evil, Discord turned ____ into ____.', 0, 2, 'CAE');
INSERT INTO black_cards VALUES (1305, 'In a world without humans, saddles are actually made for ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1306, 'Inexplicably, the only thing the parasprites wouldn''t eat was ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1309, 'It turns out Hitler''s favorite pony was ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1311, 'It''s not a boulder! It''s ____!', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1313, 'Lauren Faust was shocked to find ____ in her mailbox.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1315, 'Luna didn''t help in the fight against Chrysalis because she was too busy with ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1317, 'My cutie mark would be ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1319, 'Not many people know that Tara Strong is also the voice of ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1321, 'Nothing makes Pinkie smile more than ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1291, 'Everypony was shocked to discover that Scootaloo''s cutie mark was ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1292, 'Giggle at ____!', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1295, 'I never knew what ____ could be, until you all shared its ____ with me.', 0, 2, 'CAE');
INSERT INTO black_cards VALUES (1297, 'I''d like to be ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1301, 'In a fit of rage, Princess Celestia sent ____ to the ____ for ____.', 2, 3, 'CAE');
INSERT INTO black_cards VALUES (1323, 'Once upon a time, the land of Equestria was ruled by ____ and ____.', 0, 2, 'CAE');
INSERT INTO black_cards VALUES (1325, 'Ponyville is widely known for ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1327, 'Ponyville was shocked to discover ____ in Fluttershy''s shed.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1329, 'Prince Blueblood''s cutie mark represents ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1330, 'Rainbow Dash has always wanted ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1345, 'Rainbow Dash is the only pony in all of Equestria who can ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1347, 'Rainbow Dash received a concussion after flying into ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1350, 'Rarity has a long forgotten line of clothing inspired by ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1352, 'Rarity was supposed to have a song about ____, but it was cut.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1353, 'Rarity''s latest dress design was inspired by ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1354, 'Should the Elements of Harmony fail, ____ is to be used as a last resort.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1355, 'Super Speedy ____ Squeezy 5000.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1356, 'Surprisingly, Canterlot has a museum of ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1359, '____. That is my fetish.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1361, 'The Elements of Harmony were originally the Elements of ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1363, 'The Everfree forest is full of ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1365, 'The national anthem of Equestria is ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1366, 'The only way to get Opal in the bath is with ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1369, 'The worst mishap caused by Princess Cadance was when she made ____ and ____ fall in love.', 0, 2, 'CAE');
INSERT INTO black_cards VALUES (1370, 'To much controversy, Princess Celestia made ____ illegal.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1371, 'Today, Mayor Mare announced her official campaign position on ____ and ____. No pony was the least bit surprised.', 0, 2, 'CAE');
INSERT INTO black_cards VALUES (1372, 'Twilight got bored with the magic of friendship, and now studies the magic of ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1373, 'Twilight Sparkle owns far more books on ____ than she''d like to admit.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1374, 'When Luna got to the moon, she was greeted with ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (5037, '____? Oh murr.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (100007, 'Who dunnit? ____ with ____ in ____.', 2, 3, 'SG');
INSERT INTO black_cards VALUES (1375, 'When Spike is asleep, Twilight likes to read books about ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (5106, 'Why are you making chocolate pudding at 4 in the morning?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5107, 'The newest feature of the Xbox One is ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5108, 'PS3: It only does  ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5109, 'The new TF2 promo items are based on ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5110, 'If Gordon Freeman spoke, what would he talk about?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5111, '&gt;tfw when ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5112, 'All you had to do was follow the damn ____, CJ!', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5113, 'Liquid! How can you still be alive?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5114, 'What can change the nature of a man?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5115, ' Microsoft revealed that the Xbox One''s demos had actually been running on ____ ', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5116, 'What if ____ was a girl?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5117, 'What did I preorder at gamestop?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5118, '____ confirmed for Super Smash Bros!', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5119, 'Based ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5120, 'The newest IP from Nintendo, Super ____ Bros. ', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5121, '____ only, no items, Final Destination. ', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5122, 'Enjoy ____ while you play your Xbox one!', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5123, 'The future of gaming lies with the ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5124, 'The best way to be comfy when playing video games is with ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5125, '____ has no games.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5126, 'PC gamers have made a petition to get ____ on their platform.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5127, 'The new Nintendo ____ is a big gimmick. ', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5128, '&gt;implying you aren''t ____', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5129, 'WHAT IS A MAN?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5130, 'What is a ___ but a ____?', 0, 2, 'Vidya');
INSERT INTO black_cards VALUES (5131, 'WE WILL DRAG THIS ___ INTO THE 21ST CENTURY.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5132, 'Wake up, Mr. Freeman. Wake up and ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5133, 'All your ____ are belong to us', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5134, 'I''m in ur base, ____', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5135, 'Pop Quiz: Beatles Song- ___ terday.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5136, ' ___ would like to play.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5137, 'A mod of doom was made that was based off of ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5138, 'I really didn''t like what they did with the ____ Movie adaption.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5139, '"HEY, GOLLEN PALACE? HOW U SAY ____ IN CHINESE?"', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5140, 'Pumpkin doesn''t want this.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5141, 'NEXT TIME ON GAME GRUMPS: ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5142, 'I used to be an adventurer like you, until ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5143, 'Yeah, well, my dad works for ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5144, 'Kotaku addresses sexism in ____ in their latest article.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5145, 'Get double XP for Halo 3 with purchase of ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5146, 'Sorry Mario, but ____ is in another castle.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5147, 'LoL stole their new character design off of ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5148, '____ is the cancer killing video games.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5149, 'Suffer, like ____ did.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5151, 'It''s like ____ with guns!', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5152, 'Is a man not entitiled to ____?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5153, '____ has changed.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5154, 'But you can call me ____ the ____. Has a nice ring to it dontcha think?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5155, 'Objective: ____', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5156, 'EA Sports! It''s ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5157, '____ is waiting for your challenge!', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5158, '____ sappin'' my sentry. ', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5159, 'I''m here to ____ and chew bubble gum, and I''m all out of gum.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5160, 'I''ve covered ____, you know.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5161, 'It''s dangerous to go alone! Take this:', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5162, 'You were almost a ____ sandwich!', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5163, 'That''s the second biggest ____ I''ve ever seen!', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5164, '____. ____ never changes.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5165, '____ has changed. ', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5166, 'You have been banned. Reason: ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5167, 'The newest trope against women in video games: ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5168, 'Fans started a kickstarter for a new ____ game. ', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5169, 'Huh? What was that noise?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5170, 'Viral marketers are trying to push the new ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5171, 'I wouldn''t call it a Battlestation, more like a ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5172, '____: Gotta go fast!', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5173, 'The best final fantasy game was ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5174, 'I love the ____, it''s so bad', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5175, 'Valve is going to make ____ 2 before they release HL3.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5176, '____ is a pretty cool guy', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5177, 'Ah! Your rival! What was his name again?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5178, 'What''s in the box, /v/?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5179, 'Why is the ____ fandom the worst?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5180, 'Achievement Unlocked: ____ !', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5181, 'I''m ____ under the table right now!', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5182, 'brb guys, ____ break', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5183, 'OH MY GOD JC, A ____', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5184, 'wooooooow, it took all 3 of you to ____', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5185, 'Rev up those ____, because I am sure hungry for one- HELP! HELP!', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5186, '____ is 2deep and edgy for you.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5187, 'Only casuals like ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5188, 'The princess is in another ____', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5189, 'I have the bigger ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5190, '____ TEAM RULES!!', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5191, 'When you see it... you don''t see ____.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5192, 'HEY, GOLLEN PALACE? HOW U SAY ____ IN CHINESE?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5193, 'WHAT THE FUCK DID YOU SAY ABOUT ME YOU ____?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5194, 'This will be the 6th time we''ve posted ____; we''ve become increasingly efficient at it.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5195, 'appealing to a larger audience', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5196, 'we must embrace ____ and burn it as fuel for out journey.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5197, 'In Kingdom Hearts, Donald Duck will be replaced with ____ .', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5198, '&gt;walk into gamestop<br>&gt;see ____<br>&gt;walk out', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5150, '____ is a lie.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (1376, 'Without any warning, Pinkie Pie burst into a song about ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (5199, 'Because of the lastest school shooting, ____ is being blamed for making kids too violent.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5200, 'Here lies ____: peperony and chease', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5201, 'Throwaway round: Get rid of those shit cards you don''t want. Thanks for all the suggestions, /v/', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5202, 'The president has been kidnapped by ____. Are you a bad enough dude to rescue the president?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5203, 'We ____ now.', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5204, 'What is the new mustard paste?', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (5205, '&gt;____<br>&gt;____<br>&gt;2011<br>&gt;ISHYGDDT', 0, 2, 'Vidya');
INSERT INTO black_cards VALUES (5206, 'All you had to do was ____ the damn ____!', 0, 2, 'Vidya');
INSERT INTO black_cards VALUES (5207, 'The new ititeration in the Call of Duty franchise has players fighting off ____ deep in the jungles of ____ ', 0, 2, 'Vidya');
INSERT INTO black_cards VALUES (5208, 'Check your privilege, you ____ ____.', 0, 2, 'Vidya');
INSERT INTO black_cards VALUES (5209, 'Jill, here''s a ____. It might come in handy if you, the master of ____, take it with you. ', 0, 2, 'Vidya');
INSERT INTO black_cards VALUES (5210, '____ is a pretty cool guy, eh ____ and doesn''t afraid of anything.', 0, 2, 'Vidya');
INSERT INTO black_cards VALUES (5212, 'It''s like ____with ____!', 0, 2, 'Vidya');
INSERT INTO black_cards VALUES (5057, 'I never thought I''d be comfortable with ____, but now it''s pretty much the only thing I masturbate to.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5058, 'My next fursuit will have ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5059, 'I''m writing a porn comic about ____ and ____. ', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5060, 'I tell everyone that I make my money off "illustration," when really, I just draw ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5061, 'Oh, you''re an artist? Could you draw ____ for me?', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5062, 'Everyone thinks they''re so great, but the only thing they''re good at drawing is ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5063, 'They''re just going to spend all that money on ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5064, 'While everyone else seems to have a deep, instinctual fear of ____, it just turns me on.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5065, 'Lying about having ____ to get donations, which you spend on ____.', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5066, 'It''s not bestiality, it''s ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5067, 'Everyone thinks that because I''m a furry, I''m into ____. Unfortunately, they''re right.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5068, 'I''m only gay for ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5069, 'Excuse you, I''m a were-____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5070, 'If you like it, then you should put ____ on it.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5071, 'My girlfriend won''t let me do ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5072, 'The most pleasant surprise I''ve had this year.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5073, 'I knew I had a problem when I had to sell ____ to pay for ____.', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5074, 'I''m about 50% ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5075, '____: Horrible tragedy, or sexual opportunity?', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5076, 'It''s a little worrying that I have to compare the size of ____ to beverage containers.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5077, 'Hey, you guys wanna come back to my place? I''ve got ____ and ____.', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5078, 'Jizzing all over ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5079, 'It''s just that much creepier when 40-year-old men are into ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5080, '____ is no substitute for social skills, but it''s a start.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5081, 'The real reason I got into the fandom? ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5082, '____ are definitely the new huskies.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5083, 'I remember when ____ was just getting started.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5084, 'When no one else is around, sometimes I consider doing things with ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5085, 'Actually coming inside ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5086, 'I don''t know how we got on the subject of dragon cocks, but it probably started with ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5087, '____ is a shining example of what those with autism can really do.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5088, 'It is my dream to be covered with ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5089, '____ fucking ____. Now that''s hot.', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5090, 'Would you rather suck ____, or get dicked by ____?', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5091, 'It never fails to liven up the workplace when you ask your coworkers if they''d rather have sex with ____ or ____.', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5092, 'HELLO FURRIEND, HOWL ARE YOU DOING?', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5093, 'What are the two worst cards in your hand right now?', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5094, 'Nobody believes me when I tell that one story about walking in on ____.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5095, 'You don''t know who ____ is? They''re the one that draws ____.', 0, 2, 'Furry');
INSERT INTO black_cards VALUES (5104, 'You sometimes wish you''d encounter ____ while all alone, in the woods. With a bottle of lube.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (5105, 'I used to avoid talking about ____, but now it''s just a part of normal conversation with my friends.', 0, 1, 'Furry');
INSERT INTO black_cards VALUES (100266, 'The most controversial game at PAX this year is an 8-bit indie platformer about ____. (38/44)', 0, 1, 'PAX');
INSERT INTO black_cards VALUES (1377, 'You''re a human transported to Equestria! The first thing you''d look for is ____.', 0, 1, 'CAE');
INSERT INTO black_cards VALUES (1378, 'Zecora is a well known supplier of ____ and ____.', 0, 2, 'CAE');
INSERT INTO black_cards VALUES (100267, 'There was a riot at the Gearbox panel when they gave the attendees ____. (41/44)', 0, 1, 'PAX');
INSERT INTO black_cards VALUES (100298, 'The most controversial game at PAX this year is an 8-bit indie platformer about ____.<span class="cardnum">38 / 44</span>', 0, 1, '13PAX');
INSERT INTO black_cards VALUES (100299, 'What made Spock cry?<span class="cardnum">39 / 44</span>', 0, 1, '13PAX');
INSERT INTO black_cards VALUES (100300, '____: Achievement unlocked.<span class="cardnum">40 / 44</span>', 0, 1, '13PAX');
INSERT INTO black_cards VALUES (100304, 'What''s the latest bullshit that''s troubling this quaint fantasy town?<span class="cardnum">43 / 44</span>', 0, 1, '13PAX');
INSERT INTO black_cards VALUES (8377, '____ didn''t make it onto the first AT4W DVD.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8378, '____ is part of the WTFIWWY wheelhouse.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8379, '____ is the subject of the Critic''s newest review.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8380, '____ is the subject of the missing short from The Uncanny Valley.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8381, '____ needs more gay.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8382, '____ will be Linkara''s next cosplay.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8383, '____ wound up in this week''s top WTFIWWY story.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8384, 'After getting snowed in at MAGfest, the reviewers were stuck with ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8385, 'ALL OF ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8386, 'An intervention was staged for Linkara after ____ was discovered in his hat.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8387, 'As a way of apologizing for a poorly received episode, E Rod promised to review ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8388, 'Being done with My Little Pony, 8-Bit Mickey has moved onto ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8389, 'Birdemic 3: ____', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8390, 'E Rod has a new dance move called ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8391, 'Even Kyle thinks ____ is pretentious.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8392, 'Florida''s new crazy is about ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8393, 'Hello, I''m a ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8394, 'Here There Be ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8395, 'Hey kids, I''m Nash, and I couldn''t make ____ up if I tried.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8396, 'Hey Nash, whatcha playin''?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8397, 'How is Bennett going to creep out Ask That Guy this time? ', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8398, 'In his most recent Avatar vlog, Doug''s favorite thing about the episode was ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8399, 'In the newest Cheap Damage, CR looks at the trading card game version of ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8400, 'IT''S NOT ____!', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8401, 'It''s not nudity if there''s ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8402, 'Leon Thomas almost named his show Renegade ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8403, 'Linkara was shocked when he found out Insano was secretly ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8404, 'Linkara''s Yu-Gi-Oh deck is built up with nothing but ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8405, 'Luke Mochrie proved he was still part of the site by____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8406, 'MikeJ''s next sexual conquest is ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8407, 'Nash had a long day at work, so tonight he''ll stream ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8408, 'Nash rejected yet another RDA request for ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8409, 'Nash''s recent rant about Microsoft led to ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8410, 'Nash''s Reviewer Spotlight featured ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8411, 'New rule in the RDA Drinking Game:  Every time ____ happens, take a shot!', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8412, 'On the next WTFIWWY, Nash will give us a brief history of ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8413, 'The best Bad Movie Beatdown sketch is where Film Brain ropes Lordhebe into ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8414, 'The controversy over ad-blocking could be easily solved by ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8415, 'The easiest way to counteract a DMCA takedown notice is with ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8416, 'The last time Welshy and Film Brain were in a room together, they ended up ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8417, 'The new site that will overtake TGWTG is ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8418, 'The newest Rap Libs makes extensive use of the phrase "____."', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8419, 'The theme of this week''s WTFIWWY is ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8420, 'This week, Nash''s beer is made with ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8421, 'What did Doug bring to the set of To Boldly Flee?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8422, 'What does Ven have to do now?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8423, 'What hot, trendy new dance will feature in Paw''s next Dance Spectacular?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8424, 'What is hidden in Linkara''s hat?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8425, 'What is literally the only thing tastier than a dragon''s soul?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8426, 'What is Snowflame''s only known weakness?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8427, 'What is the name of the next new Channel Awesome contributor?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8428, 'What killed Harvey Finevoice''s son?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8429, 'What made Dodger ban someone from the RDA chat this week?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8430, 'What new upgrade did Nash give Laura?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8431, 'What was the first sign that Linkara was turning evil?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8432, 'What will Nash try to kill next with his hammer?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8433, 'When Arlo The Orc turns into a werewolf, he likes to snack on ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8434, 'When interviewing Linkara, be sure to ask him about ____!', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8435, 'When not reviewing or ruling Haganistan with an iron fist, Hagan''s hobby is ____.', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8436, 'Who REALLY called Oancitizen to help him snap out of his ennui?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8437, 'Whose ass did Zodann kick this time?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8438, 'Why did Nash go to Chicago?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8439, 'Why doesn''t Doug ever attend MAGFest?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8440, 'Why doesn''t Film Brain have an actual reviewer costume?', 0, 1, 'TGWTG');
INSERT INTO black_cards VALUES (8441, 'The MAGFest Nerf War took a dark turn when ____ was waylaid by ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8442, 'For a late night snack, Nash made a sandwich of ____ and ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8443, 'The next TGWTG porn spoof?  ____ with ____!', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8444, 'Putting ____ in ____? That doesn''t go there!', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8445, 'In trying to ban ____, Florida accidentally banned ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8446, 'If ____ got to direct an Uncanny Valley short, it would have featured ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8447, 'At ConBravo, ____ will be hosting a panel on ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8448, 'At MAGFest, ____ will host a panel focusing on ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8449, '"Greetings, dear listeners.  Won''t you join ____ for ____?"', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8450, 'Sad Panda is actually ____ and  ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8451, 'I''m going to die watching ____ review ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8452, 'In a new latest announcement video, ____ has announced an appearance at ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8453, 'After ____, Phelous regenerated into ____. ', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8454, '____ and ____ would make awesome siblings.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8455, 'Some fangirls lay awake all night thinking of ____ and ____ together.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8456, 'In my new show, I review ____ while dressed like ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8457, 'Luke''s newest character is ____, the Inner ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8458, 'Good evening! I am ____ of  ____.', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8459, '____ is the reason that ____ picked "AIDS."', 0, 2, 'TGWTG');
INSERT INTO black_cards VALUES (8460, 'Nash''s newest made-up curse word is ____-____-____! ', 2, 3, 'TGWTG');
INSERT INTO black_cards VALUES (8461, 'Using alchemy, combine ____ and ____ to make ____! ', 2, 3, 'TGWTG');
INSERT INTO black_cards VALUES (8462, 'Write Linkara''s next storyline as a haiku.', 2, 3, 'TGWTG');
INSERT INTO black_cards VALUES (8463, 'Nash will build his next contraption with just ____, ____, and ____.', 2, 3, 'TGWTG');
INSERT INTO black_cards VALUES (8464, ' ____  did ____ to avoid ____.', 2, 3, 'TGWTG');
INSERT INTO black_cards VALUES (8465, 'Make a WTFIWWY story.', 2, 3, 'TGWTG');
INSERT INTO black_cards VALUES (8466, 'Dang it, ____!', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8467, '____ was full of leeches.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8468, 'Pimp your ___!', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8469, 'My apologies to the ____ estate.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8470, 'What interrupted the #NLSS?', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8471, 'Travel by ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8472, 'The stream broke when Ryuka stepped on the ____ key.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8473, 'Say that to my face one more time and I''ll start ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8474, 'Oh my god, he''s using ____ magic!', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8475, 'Krazy Mike lost to ____!', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8476, 'What would you do if Ohm really did just die?', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8477, '____ has invaded!', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8478, 'We''re having technical difficulties due to ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8479, 'JSmithOTI is referred to as a Scumlord, but his friends call him ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8480, 'Ohmwrecker is known for his MLG online play. What people don''t know is that he''s also MLG at ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8481, 'Follow MichaelALFox on Twitter and you can see pictures of ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8482, 'After Mars, ____ is the next furthest planet from the sun.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8483, 'What would Ohm do?', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8484, 'The next movie reading will be of ____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8485, 'How did Northernlion unite Scotland?', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8486, 'Green loves the new Paranautical Activity item ____, but keeps comparing it to the crossbow.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8487, '____ is really essential to completing the game.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8488, 'My channel is youtube.com/____.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8489, 'Northernlion''s cat Ryuka is known for ____ while he records.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8490, 'What gave Ohmwrecker his gaming powers?', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8491, 'Hello anybody, I am ____Patrol.', 0, 1, 'NL');
INSERT INTO black_cards VALUES (8492, 'I have ____, can you ____ me?', 0, 2, 'NL');
INSERT INTO black_cards VALUES (8493, '____! Get off the ____!', 0, 2, 'NL');
INSERT INTO black_cards VALUES (8494, 'My name is ____ and today we''ll be checking out ____.', 0, 2, 'NL');
INSERT INTO black_cards VALUES (8495, 'It''s true that Green9090 is ____, but we must all admit that Ohm is better at ____', 0, 2, 'NL');
INSERT INTO black_cards VALUES (8496, 'That''s the way ____ did it, that''s the way ____ does it, and it''''s worked out pretty well so far.', 0, 2, 'NL');
INSERT INTO black_cards VALUES (8497, 'Today on Crusader Kings 2, NL plays King ____ the ____.', 0, 2, 'NL');
INSERT INTO black_cards VALUES (8498, 'After winning yet another race, Josh made ____ tweet about ____.', 0, 2, 'NL');
INSERT INTO black_cards VALUES (8499, 'This time on ____ vs. ____, we''re playing ____.', 2, 3, 'NL');
INSERT INTO black_cards VALUES (8500, 'Welcome back to ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8501, 'Welcome to Sonic Team! We make ____, I think!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8502, 'What am I willing to put up with today?', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8503, 'What can be found in Arin''s chins?', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8504, 'What do Mumbo''s magic words mean?', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8505, 'What is the boopinest shit?', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8506, 'WHAT THE FUCK IS A ____?!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8507, 'What''s better than Skyward Sword?', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8508, 'What''s the real reason Jon left?', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8509, 'When I look in the mirror I see ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8510, 'Who replaced Jon when he left GameGrumps?', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8511, 'Who''s an asshole?', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8512, 'Why is Steam Train so controversial?', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8513, 'WOOP WOOP WOOP I''M A ____!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8514, 'You know what fan mail makes me the happiest every time I see it? It''s the ones where people are like, "____." ', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8515, 'You''re ruining my integrity! ____ won''t hire me now!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8516, 'I''ve been ____ again!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8517, 'Rolling around at the speed of ____!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8518, 'This time on Guest Grumps, we have ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8519, 'Top five games, go! 1? Mega Man X. 2-5? ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8520, 'Use your ____!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8521, 'Look at this guy, he''s like ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8522, 'Look, it''s ____!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8523, 'Next time on Game Grumps, ____!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8524, 'Nightshade: The Claws of ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8525, 'Number one! With a bullet! Zoom in on the ____!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8526, 'Oh, it''s ____!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8527, 'One slice of ____ please.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8528, 'Pikachu, use your ____ attack!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8529, 'Put a hole in that ____!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8530, 'Real talk? ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8531, 'Jon''s mom called him to tell him about ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8532, 'Kirby has two iconic abilities: suck and ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8533, 'Listen to the ____ on this shit.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8534, 'Jon believes that the most important part of any video game is ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8535, 'Jon can''t get enough of ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8536, 'Jon can''t survive air travel without ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8537, 'Jon just wants to touch ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8538, 'Is there anything to gain from this?', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8539, 'It''s no use! Take ____!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8540, 'Jon and Arin suck at ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8541, 'Jon and Arin win! They realize ____ is more important.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8542, 'If the ____ wasn''t there, I would do. But it''s there, so it''s not.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8543, 'How many ____ does Mega Man get?', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8544, 'How many nose hairs does ____ have?', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8545, 'I certainly can''t do it without you, and I know you can''t do it without ____!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8546, 'I tell you once, I tell you twice! ____ is good for economy!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8547, 'I wanna put my ____ in her!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8548, 'I''m not even SELLING ____!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8549, 'Do you remember the episode where Ash caught a ____?', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8550, 'Don''t throw ____! It''s expensive to somebody!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8551, 'Dude, real talk? ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8552, 'Eat your ____, son.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8553, 'Egoraptor''s fiancee is actually a ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8554, 'Everybody wants to know about me, but they don''t know about my ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8555, 'Fool me once, I''m mad. Fool me twice? How could you. Fool me three times, you''re officially ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8556, 'For my first attack, I will juggle ____ to impress you.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8557, 'Fuck, I found a ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8558, 'Game Grumps: sponsored by ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8559, 'Give ____ a chance! He''ll grow on you!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8560, '____? Ten-outta-ten!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8561, '____. I AAAAAAIN’T HAVIN’ THAT SHIT!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8562, '____. It''s no use!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8563, '____. MILLIONS ARE DEAD!!!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8564, '____. Put that in, Barry.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8565, '____. This is like one of my Japanese animes!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8566, '...What the bloody hell are you two talking about?!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8567, '"These new ____ t-shirts are gonna change some lives, Arin."', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8568, '"You want cheese pizza?" "No. ____."', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8569, 'And then, as a fuckin'' goof, I''d put a hole in ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8570, 'And there it was...Kirby had finally met the ____ of the lost city.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8672, 'It took hours to edit ____ into the video.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8571, 'Arin believes that the most important part of any video game is ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8572, 'Arin has an adverse reaction to ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8573, 'Barry entertains himself by watching old episodes of ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8574, 'Barry, add ____ into the video!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8575, 'Barry, we need a replay on ____.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8576, 'BARRY! SHOW ____ AGAIN!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8577, 'Barry''s sheer skill at ____ is unmatched.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8578, 'I don''t like the ____ flavor.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8579, '____ don''t even cost this less!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8580, '____ Grumps!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8581, '____ has aged really well.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8582, '____ is GREAT GREAT GREAT!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8583, '____ is Jon''s favorite video game of all time.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8584, '____ is not Jon''s strong suit.', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8585, '____ Train!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8586, '____ WINS!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8587, '____: Better than deer shit!', 0, 1, 'GG');
INSERT INTO black_cards VALUES (8588, 'Welcome back to ____ ____!', 0, 2, 'GG');
INSERT INTO black_cards VALUES (8589, 'Real talk? Is that ____ ____?', 0, 2, 'GG');
INSERT INTO black_cards VALUES (8590, 'Look at that ____-ass ____!', 0, 2, 'GG');
INSERT INTO black_cards VALUES (8591, 'JON''S ____, SHOW US YOUR ____.', 0, 2, 'GG');
INSERT INTO black_cards VALUES (8592, 'The Grumps'' latest silly player names are ____ and ____.', 0, 2, 'GG');
INSERT INTO black_cards VALUES (8593, 'If you don''t know what ____ is, you can''t go to ____.', 0, 2, 'GG');
INSERT INTO black_cards VALUES (8594, 'In this corner, ____; in the other corner, ____; it''s Game Grumps VS!', 0, 2, 'GG');
INSERT INTO black_cards VALUES (8595, 'IF I CAN''T BE ____, I SURE AS HELL CAN BE ____!!', 0, 2, 'GG');
INSERT INTO black_cards VALUES (8596, 'COME ON AND ____, AND WELCOME TO THE ____!', 0, 2, 'GG');
INSERT INTO black_cards VALUES (8597, 'If ____ evolved from ____, why the fuck is there still ____, dude?!', 2, 3, 'GG');
INSERT INTO black_cards VALUES (8598, '____? Pretty smart. ____? Pretty fuckin'' smart. ____? FUCKING GENIUS!!!!', 2, 3, 'GG');
INSERT INTO black_cards VALUES (8599, '____ is probably a Venusaur kind of guy.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8600, '____ is the greatest Canadian.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8601, '____ is the worst on the Podcast.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8602, '____. That''s top.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8603, 'After getting wasted at PAX, Burnie announced that "I am ____!"', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8604, 'Barbara sucks ____.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8605, 'Close up of my ____.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8606, 'Come to Fort ____!', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8607, 'Describe yourself in one word/phrase.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8608, 'Detective ____ is down!', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8609, 'Does our house say "We love ____?"', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8610, 'Dude, I got sixteen ____!', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8611, 'Fight, fight, fight, ____?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8612, 'Fuck it, I mean ____, right?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8613, 'I''ma smother you in my ____!', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8614, 'If Jack was frog and you kissed him, what would he turn into?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8615, 'If you could fuck anyone in the world, who would you choose?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8616, 'If you could have any superpower, what would it be?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8617, 'If you were allowed to do one illegal thing, what would it be? ', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8618, 'It''s a ____ out there.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8619, 'It''s not my fault. Somebody put ____ in my way.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8620, 'Joel plays ____.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8621, 'Let''s do ____ again! This is fun!', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8622, 'Lindsay could fuck up ____.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8623, 'LLLLLLLLLLLLLET''S ____!', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8624, 'My ____ is trying to die.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8625, 'On tonight''s Let''s Play, the AH crew plays ____.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8626, 'People like ____.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8627, 'RT Recap, featuring ____!', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8628, 'Shout out to ____!', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8629, 'Shout out to my mom. Called my Teddy Bear ____.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8630, 'So, I was just walking along, until suddenly ____ came along and attacked me.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8631, 'Thanks to ____ for this week''s theme song.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8632, 'The next RvB cameo will be voiced by ____.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8633, 'They questioned Ryan''s sanity after finding ____ in his house.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8634, 'This week on AHWU, ____.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8635, 'This week on Immersion, we are going to test ____.', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8636, 'What are fire hydrants called in England?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8637, 'What does Ryan''s kid listen to?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8638, 'What is Game Night?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8639, 'What is the meaning of life?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8640, 'What is the saddest thing you''ve ever seen?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8641, 'What is the worst thing anyone could say in front of the police?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8642, 'What is your biggest feature?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8643, 'What is your favorite book?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8644, 'What is your mating call?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8645, 'What makes Caboose angry?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8646, 'What makes Michael the angriest?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8647, 'What mysteries lie beyond Jack''s beard? ', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8648, 'What would be your chosen catchphrase?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8649, 'What''s in Gavin''s desk?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8650, 'Where are we going for lunch?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8651, 'Where does Ray belong?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8652, 'Who has a fake Internet girlfriend?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8654, 'Why are we here?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8655, 'Why is Geoff cool?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8656, 'Why was Michael screaming at Gavin?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8657, 'Would you guys still like me if my name was ____?', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8658, 'You threw it against the wall like a ____!', 0, 1, 'RT');
INSERT INTO black_cards VALUES (8659, '____ is ____ as dicks.', 0, 2, 'RT');
INSERT INTO black_cards VALUES (8660, '____ is the best ____ ever. Of all time.', 0, 2, 'RT');
INSERT INTO black_cards VALUES (8661, '____ wins! ____ is a horse!', 0, 2, 'RT');
INSERT INTO black_cards VALUES (8662, 'If you got $1,000,000 per week, would you ____, but in the next day, you''d have to ____?', 0, 2, 'RT');
INSERT INTO black_cards VALUES (8663, 'My name is ____, and I hate ____!', 0, 2, 'RT');
INSERT INTO black_cards VALUES (8664, 'No one in the office expected the bromance between ____ and ____.', 0, 2, 'RT');
INSERT INTO black_cards VALUES (8665, 'Select two cards to create your team name.', 0, 2, 'RT');
INSERT INTO black_cards VALUES (8666, 'This week on VS, ____ challenges ____ to a game of ____.', 2, 3, 'RT');
INSERT INTO black_cards VALUES (8667, 'The war''s over. We''re holding a parade in ____''s honor. ____ drives the float, and ____ is in charge of confetti.', 2, 3, 'RT');
INSERT INTO black_cards VALUES (8668, 'What''s a paladin?', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8669, 'One of these days i''m just gonna shit my ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8670, 'You need to ____ your asshole, it''s vital to this operation.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8671, 'I''m sorry Timmy, but I must ____ you.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8673, 'In this week''s gauntlet, Tehsmarty challenges ChilledChaos to ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8674, 'In this week''s gauntlet, ChilledChaos challenges Tehsmarty to ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8675, 'I AM THE ____ CZAR!!!', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8676, 'ZeRoyalViking''s up and coming game company, "ZEA" accredits their success to ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8677, 'Tehsmarty loves the smell of ____ in the morning.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8678, 'The Creatures'' next member is ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8679, 'Come on and slam, and welcome to the ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8680, '____, the one you want to get DDoS''d', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8653, 'Why are there six ____ when there are only four ____?', 0, 2, 'RT');
INSERT INTO black_cards VALUES (8682, 'GaLmHD is so pro at almost every game he plays yet he can`t play____!', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8683, 'Smarty''s darkest fear is ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8684, 'Pewdiepie''s going to play ____!?', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8685, 'And here we have ____. Strike it''s weakness for MASSIVE damage!', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8686, 'But Beardman! Why do you think that ____?', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8687, 'In the next episode of Press Heart to Continue: Dodger talks about ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8688, 'What did Criken do this time to break ARMA III? ', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8689, 'What was the big prize this time around at the Thrown Controllers panel?', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8690, 'What did Mitch or Bajan Canadian find in the fridge today?', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8691, 'In ____ We Trust.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8692, 'When Sp00n finally removed his horsemask on the livestream, we saw ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8693, 'I give this game a rating of ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8694, 'What did Pewdiepie overreact to on his channel today?', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8695, 'This time on Brutalmoose''s Top 10, his guest was ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8696, 'Only Totalbiscuit would spend an hour long video discussing ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8697, 'Last Thursday, Riorach was identified in public and she proceeded to ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8698, 'On this episode of PKA Woody and Wings talk about ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8699, 'Bro''s Angels. We ____ hard.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8700, 'TotalBiscuit''s top hat is actually ____. ', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8701, 'GTA shenanigans would not be GTA shenanigans without Seananners dropping ____ on ____.', 0, 2, 'DAH');
INSERT INTO black_cards VALUES (8702, 'Knowing Chilled''s knowledge with Minecraft, he''ll probably use ____ on ____ in his next video.', 0, 2, 'DAH');
INSERT INTO black_cards VALUES (8707, 'Oh great, ____ is doing another ____ game LP.', 0, 2, 'DAH');
INSERT INTO black_cards VALUES (8708, 'In his new Co-op work SSoHPKC will be playing ____ with ____.', 0, 2, 'DAH');
INSERT INTO black_cards VALUES (8709, 'My name is-a ____ and i likea da ____.', 0, 2, 'DAH');
INSERT INTO black_cards VALUES (8704, 'In today''s Driftor in-depth episode we shall look at ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8703, 'The Xbox One''s DRM policy isn''t half as bad as ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8705, 'What will YouTube add in its next unneeded update?', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (8706, 'Two Best Friends Play ____.', 0, 1, 'DAH');
INSERT INTO black_cards VALUES (100301, 'There was a riot at the Gearbox panel when they gave the attendees ____.<span class="cardnum">41 / 44</span>', 0, 1, '13PAX');
INSERT INTO black_cards VALUES (100302, 'In the new DLC for Mass Effect, Shepard must save the galaxy from ____.<span class="cardnum">42 / 44</span>', 0, 1, '13PAX');
INSERT INTO black_cards VALUES (100303, 'No Enforcer wants to manage the panel on ____.<span class="cardnum">44 / 44</span>', 0, 1, '13PAX');
INSERT INTO black_cards VALUES (100384, 'What''s fun until it gets weird?', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100386, 'Wes Anderson''s new film tells the story of a precocious child coming to terms with ____.', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100388, 'I''m sorry, sir, but we don''t allow ____ at the country club.', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100389, 'How am I compensating for my tiny penis?', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100390, 'You''ve seen the bearded lady!<br/>You''ve seen the ring of fire!<br/>Now, ladies and gentlemen, feast your eyes upon ____!', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100392, 'She''s up all night for good fun.<br/>I''m up all night for ____.', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100394, 'Dear Leader Kim Jong-un,<br/>our village praises your infinite wisdom with a humble offering of ____.', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100395, 'Man, this is bullshit. Fuck ____.', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100396, 'You guys, I saw this crazy movie last night. It opens on ____, and then there''s some stuff about ____, and then it ends with ____.', 2, 3, 'X4');
INSERT INTO black_cards VALUES (100397, 'In return for my soul, the Devil promised me ____, but all I got was ____.', 0, 2, 'X4');
INSERT INTO black_cards VALUES (100398, 'The Japanese have developed a smaller, more efficient version of ____.', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100399, 'Alright, bros. Our frat house is condemned, and all the hot slampieces are over at Gamma Phi. The time has come to commence Operation ____.', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100400, 'This is the prime of my life. I''m young, hot, and full of ____.', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100401, 'I''m pretty sure I''m high right now, because I''m absolutely mesmerized by ____.', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100402, 'It lurks in the night. It hungers for flesh. This summer, no one is safe from ____.', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100403, 'If you can''t handle ____, you''d better stay away from ____.', 0, 2, 'X4');
INSERT INTO black_cards VALUES (100404, 'Forget everything you know about ____, because now we''ve supercharged it with ____!', 0, 2, 'X4');
INSERT INTO black_cards VALUES (100405, 'Honey, I have a new role-play I want to try tonight! You can be ____, and I''ll be ____.', 0, 2, 'X4');
INSERT INTO black_cards VALUES (100406, 'This year''s hottest album is "____" by ____.', 0, 2, 'X4');
INSERT INTO black_cards VALUES (100407, 'Every step towards ____ gets me a little closer to ____.', 0, 2, 'X4');
INSERT INTO black_cards VALUES (100409, 'Do <i>not</i> fuck with me! I am literally ____ right now.', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100410, '2 AM in the city that never sleeps. The door swings open and <i>she</i> walks in, legs up to here. Something in her eyes tells me she''s looking for ____.', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100411, 'As king, how will I keep the peasants in line?', 0, 1, 'X4');
INSERT INTO black_cards VALUES (100413, 'I am become ____, destroyer of ____!', 0, 2, 'X4');
INSERT INTO black_cards VALUES (100385, 'In the beginning, there was ____.<br/>And the Lord said, "Let there be ____."', 0, 2, 'X4');
INSERT INTO black_cards VALUES (100387, '____ will never be the same after ____.', 0, 2, 'X4');
INSERT INTO black_cards VALUES (100391, 'We never did find ____, but along the way we sure learned a lot about ____.', 0, 2, 'X4');
INSERT INTO black_cards VALUES (100393, '____ may pass, but ____ will last forever.', 0, 2, 'X4');
INSERT INTO black_cards VALUES (100412, 'Adventure.<br/>Romance.<br/>____.<br/><br/>From Paramount Pictures, "____."', 0, 2, 'X4');
INSERT INTO black_cards VALUES (958, 'The seldomly mentioned 4th little pig built his house out of ____.', 0, 1, 'MrMan');
INSERT INTO black_cards VALUES (902, 'Mom, I swear! Despite its name, ____ is NOT a porno!', 0, 1, 'AN');
INSERT INTO black_cards VALUES (100408, 'Oprah''s book of the month is "____ For ____: A Story of Hope."', 0, 2, 'X4');
INSERT INTO black_cards VALUES (100421, 'But wait, there''s more! If you order ____ in the next 15 minutes, we''ll throw in ____ absolutely free!', 0, 2, 'HBS');
INSERT INTO black_cards VALUES (100426, 'Blessed are you, Lord our God, creator of the universe, who has granted us ____.', 0, 1, 'HBS');
INSERT INTO black_cards VALUES (8843, 'That fucking idiot ____ ragequit the fandom over ____.', 1, 2, 'FiM1');
INSERT INTO black_cards VALUES (100427, 'Because they are forbidden from masturbating, Mormons channel their repressed sexual energy into ____.', 0, 1, 'HBS');
INSERT INTO black_cards VALUES (100432, 'I really hope my grandmother doesn''t ask me to explain ____ again.', 0, 1, 'HBS');
INSERT INTO black_cards VALUES (100437, 'What''s the one thing that makes an elf instantly ejaculate?', 0, 1, 'HBS');
INSERT INTO black_cards VALUES (100441, 'GREETINGS HUMANS<br><br>I AM ____ BOT<br><br>EXECUTING PROGRAM', 0, 1, 'HBS');
INSERT INTO black_cards VALUES (100442, 'Kids these days with their iPods and their Internet. In my day, all we needed to pass the time was ____.', 0, 1, 'HBS');
INSERT INTO black_cards VALUES (8756, 'I always ____ ass - razor1000.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8757, '____ for temperature. ', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8758, 'Not asking for upvotes but ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8759, 'I got ____ to the frontpage ', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8760, 'I know this is going to get downvoted to hell but ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8761, 'I know this is a selfie but ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8762, 'Imgur: where the points don’t matter and the ____ is made up.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8763, 'If you could stop ____, that’d be greeeeattt. ', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8764, 'ERMAGERD! ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8765, 'Not sure if Imgur reference or ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8766, 'Having a bit of fun with the new ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8767, 'Press 0 twice for ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8768, 'No, no, you leave ____. We no like you.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8769, 'FOR ____!!!!', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8770, 'If ____ happens because of ____, I will eat my socks.', 0, 2, 'Imgur');
INSERT INTO black_cards VALUES (8771, 'Put that ____ back where it came from or so help me.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8772, 'Yer a wizard ____', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8773, 'Am I the only one around here who ____?', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8774, 'Confession Bear: When I was 6, I ____ on my ____.', 0, 2, 'Imgur');
INSERT INTO black_cards VALUES (8775, 'Actual Advice Mallard: Always ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8776, 'For every upvote I will ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8777, '____. Awkward boner. ', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8778, '____. Forever Alone.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8779, '____. TOO SAD AND TOO TINY!', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8780, 'I’ve never seen anyone so ____ while ____.', 0, 2, 'Imgur');
INSERT INTO black_cards VALUES (8781, 'OH MY GOD ____. ARE YOU FUCKING KIDDING ME!?', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8782, 'You know nothing ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8783, 'Most of the time you can only fit one____ in there.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8784, 'That ____ tasted so bad, I needed a Jolly Rancher. ', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8785, 'I don’t always ____. But when I do____..', 0, 2, 'Imgur');
INSERT INTO black_cards VALUES (8786, '+1 for ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8787, 'SAY GOODBYE TO____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8788, 'When I found ____ in usersubmitted, I was flabbergasted. ', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8789, 'France is ____', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8790, 'The ____ for this ____ is TOO DAMN HIGH. ', 0, 2, 'Imgur');
INSERT INTO black_cards VALUES (8791, 'Any love for ____?', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8792, 'In Japan, ____ is the new sexual trend.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8793, 'I love bacon as much as ____ loves ____.', 0, 2, 'Imgur');
INSERT INTO black_cards VALUES (8794, 'A hipster needs a ____ as much as a fish needs a ____.', 0, 2, 'Imgur');
INSERT INTO black_cards VALUES (8795, 'Justin Bieber is a ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8796, 'Are you my ____?', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8797, 'Weasley is our ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8798, 'I have a bad feeling about ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8799, 'I am a leaf on the ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8800, 'That was more awkward than ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8801, 'Boardgame Online is more fun than ____.', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8802, 'I hate My Little Pony more than ____ hates ____.', 0, 2, 'Imgur');
INSERT INTO black_cards VALUES (8803, 'I love My Little Pony more than ____ loves ____.', 0, 2, 'Imgur');
INSERT INTO black_cards VALUES (8804, 'Cat gifs are cuter than ____. ', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8805, 'If it fits, I ____. ', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8806, '____. My moon and my stars. ', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8807, 'A ____ always pays his debts. ', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8808, 'My ovaries just exploded because of ____. ', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8809, 'Chewie, ____ it!', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8810, 'Steven Moffat has no ____. ', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8811, 'Dobby is ____!!', 0, 1, 'Imgur');
INSERT INTO black_cards VALUES (8812, 'The court finds the defendant, ____, guilty of ____, and sentences them to a lifetime of ____.', 2, 3, 'ANX1');
INSERT INTO black_cards VALUES (5211, 'Ironic ____ is still ____.<br><br>(same in both blanks)', 0, 1, 'Vidya');
INSERT INTO black_cards VALUES (8813, '____ ____ Divided By ____.', 2, 3, 'FiM1');
INSERT INTO black_cards VALUES (8814, '____ <br>~Skeeter The Lurker', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8815, '____ adds a thread in the Anti-____ group, and everybody loses their fucking minds.', 1, 2, 'FiM1');
INSERT INTO black_cards VALUES (8816, '____ is Best Pony.', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8817, '____ is the least autistic ____ on Fimfiction.', 1, 2, 'FiM1');
INSERT INTO black_cards VALUES (8818, '____ posted that they''re not working on fics for a while, because ____.', 1, 2, 'FiM1');
INSERT INTO black_cards VALUES (8819, '____ signalled the end of the ____ Age of FiMfiction.net.', 1, 2, 'FiM1');
INSERT INTO black_cards VALUES (8820, '____ signalled the end of the Golden Age of FiMfiction.net.', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8821, '____ was a strong stallion.', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8822, '____, ____, and ____ in a sexy circlejerk.', 2, 3, 'FiM1');
INSERT INTO black_cards VALUES (8823, 'A clopfic about ____ with ____, and ____ is a sexy orphan.', 2, 3, 'FiM1');
INSERT INTO black_cards VALUES (8824, 'An alternate universe where ____ is instead ____.', 1, 2, 'FiM1');
INSERT INTO black_cards VALUES (8825, 'Fallout Equestria is ____ and tends to overdramaticize its ____.', 0, 2, 'FiM1');
INSERT INTO black_cards VALUES (8826, 'Hey, let''s cross over ____ and MLP! Why the fuck not?', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8827, 'I commissioned a picture of ____ violating ____ with ____''s dick.', 2, 3, 'FiM1');
INSERT INTO black_cards VALUES (8828, 'I hope someone writes a fic about ____ because I am too fucking lazy to do it myself.', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8829, 'I just read a fic where ____ was fucking ____.', 1, 2, 'FiM1');
INSERT INTO black_cards VALUES (8830, 'I just started the ____verse.', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8831, 'I swear I''m going to quit the fandom if ____ happens.', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8832, 'If only people bothered to read Ezn''s ____ Guide!', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8833, 'knighty''s new blogpost is about ____', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8834, 'My ____ Pony', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8835, 'My Little Dashie? How about My Little ____?', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8836, 'My OTP is ____ and ____.', 1, 2, 'FiM1');
INSERT INTO black_cards VALUES (8837, 'Oh, fuck, someone made a group about ____.', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8838, 'Oh, look, ____ made a fan group for themselves.', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8839, 'RainbowBob''s newest clopfic: ____ X ____', 0, 2, 'FiM1');
INSERT INTO black_cards VALUES (8840, 'Remember when ____ was on every page?', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8841, 'Short Skirts and ____.', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8842, 'Someone should write a clopfic of ____ fucking ____, using ____ as lubricant.', 2, 3, 'FiM1');
INSERT INTO black_cards VALUES (8844, 'The ____ Bureau.', 0, 1, 'FiM1');
INSERT INTO black_cards VALUES (8845, 'The ____ Group of ____ Excellence.', 1, 2, 'FiM1');
INSERT INTO black_cards VALUES (8846, 'The cardinal sin of FiMFic noobs: _____ without ______', 0, 2, 'FiM1');
INSERT INTO black_cards VALUES (8847, 'The Incredible ____ Of A Winning ____.', 1, 2, 'FiM1');
INSERT INTO black_cards VALUES (8848, 'There''s a crossover fic about ____ and ____ in the FB.', 0, 2, 'FiM1');
INSERT INTO black_cards VALUES (8939, '____: ____ in fiction, ____ on the tabletop.', 1, 3, '/tg/');
INSERT INTO black_cards VALUES (8940, 'I proxy ____ using a second-hand ____.', 0, 2, '/tg/');
INSERT INTO black_cards VALUES (8941, 'Next up: Lord Lysander''s paints ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8942, 'The citizens of Innsmouth are really ____!', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8943, 'I am Angry, Angry about ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8944, 'In respect to your chapter, the Blood Ravens have dedicated one of their____to ____.', 0, 2, '/tg/');
INSERT INTO black_cards VALUES (8945, 'Roll for ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8946, 'I prepared ____ this morning.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8947, 'The bard nearly got us killed when he rolled to seduce ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8948, '____ causes the Paladin to fall', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8949, 'The door to the FLGS opens and a ____ walks in!', 0, 2, '/tg/');
INSERT INTO black_cards VALUES (8950, 'GW stores no longer stock____', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8951, 'The price on ____ Has doubled!', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8952, '____ falls, everyone dies.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8953, 'My GM just made his girlfriend a ____ character. How fucked are we?', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8954, 'If you buy a camel, Crazy Hassan is adding in free ____ this week only!', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8955, 'Around elves, watch ____', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8956, 'The only good ____ is a dead ____', 1, 2, '/tg/');
INSERT INTO black_cards VALUES (8957, '...And then he killed the Tarasque with a ____', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8958, 'There is a ____ on the roof.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8959, 'What are we going to argue about today?', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8960, 'I got a box today. What''s inside? ____', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8961, 'Roll ____ circumference', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8962, 'What I made: ____.<br>What the DM saw: ____.<br>What I played: ____', 2, 3, '/tg/');
INSERT INTO black_cards VALUES (8963, '____ vs. ____: Critical Hit!', 1, 2, '/tg/');
INSERT INTO black_cards VALUES (8964, 'Then the barbarian drank from the ____-filled fountain', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8965, '____: That was a thing.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8966, '&gt;preferring 3D women over ____', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8967, 'Where we''re going, we won''t need ____ to see', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8968, 'You encounter a Gazebo. You respond with ____', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8969, 'D&amp;D: 6th edition will feature ____ as a main race!', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8970, 'Your Natural 1 summons ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8971, 'It would have taken ____ to..... CREEEEEEEEEED!', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8972, 'Can ____ bloom on the battlefield?', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8973, '&gt;mfw ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8974, '____? That''s ULTRA heretical', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8975, 'So I made my chapter insignia ____', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8976, 'In the grim darkness of the far future there is only ____', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8977, '2e or ____', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8978, 'Blood for the blood god! ____ for the ____!', 1, 2, '/tg/');
INSERT INTO black_cards VALUES (8979, '____. we don''t need other boards anymore!', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8980, '____ just fucked us', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8981, 'The guard looks a troubled, uncomfortable glare, like a man who must explain to his ____, that''s its dreams of becoming ____ will never happen.', 1, 2, '/tg/');
INSERT INTO black_cards VALUES (8982, 'Dwarf Fortress needs more ____', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8983, 'My ____ are moving on their own', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8984, 'Welcome to the ____ Quest Thread.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8985, 'You should never let your bard ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8986, 'That one guy in my group always rolls a chaotic neutral ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8987, 'The lich''s phylactery is a  ____!', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8988, 'Macha was dismayed to find out that ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8989, 'Never fire ____ at the bulkhead!', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8990, '____ is the only way I can forget about 4e.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8991, 'I sure hope no one notices that I inserted my ____ fetish into the game.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8992, 'Behold! White Wolf''s newest game: ____: the ____.', 1, 2, '/tg/');
INSERT INTO black_cards VALUES (8993, 'For our upcoming FATAL game, I''ve assigned ____ as your new character.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8994, 'The GM has invited his new ____ to join the game. They''ll be playing ____.', 1, 2, '/tg/');
INSERT INTO black_cards VALUES (8995, '0/10 would not ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8996, 'The ____ guides my blade.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8997, 'Don''t touch me ____!', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8998, 'Mountain, Black lotus, sac, to cast ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (8999, '____ followed by gratuitous ____ is how I got kicked out off my last group.', 0, 2, '/tg/');
INSERT INTO black_cards VALUES (9000, 'Everybody was surprised when the king''s trusted adviser turned out to be ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9001, 'You and ____ must stop ____ with the ancient artifact ____.', 1, 3, '/tg/');
INSERT INTO black_cards VALUES (9002, 'Elf ____ Wat do?', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9003, 'Magic the Gathering''s next set is themed around ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9004, 'We knew the game was off to a good start when the GM didn''t veto a player''s decision to play as ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9005, 'My Kriegers came in a box of ____!', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9006, 'I had to kill a party member when wasted 2 hours by ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9007, 'We found ____in the Dragon''s hoard.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9008, 'What''s on today''s agenda for the mage guild meeting?', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9009, '____ is the only way to fix 3.5.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9010, 'What is the BBEG''s secret weapon?', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9011, 'Ach! Hans run! It''s the ____!', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9012, 'The enemy''s ____ is down.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9013, 'Only fags play mono____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9014, 'What is better than 3D women?', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9015, 'I kept getting weird looks at FNM when I brought my new ____ card sleeves.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9016, 'I like to dress up like ____ and hit people with foam swords.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9017, 'You''ve been cursed by the witch! Your ____ has turned into a ____!', 0, 2, '/tg/');
INSERT INTO black_cards VALUES (9018, 'The adventure was going fine until the BBEG put ____ in our path.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9019, 'Your BBEG is actually ____!', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9020, 'The last straw was the Chaotic Neutral buying a case of ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9021, 'What won''t the Bard fuck?.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9022, '____! what was that?', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9023, 'You roll 00 for your magical mishap and turn into ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9024, 'You fool! you fell victim to one of the classic blunders: ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9025, '...and then the bastard pulled out ____ and placed it on the table.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9183, 'What is your OT3?', 2, 3, 'MSPA');
INSERT INTO black_cards VALUES (9026, 'I cast magic missile at ____.', 0, 1, '/tg/');
INSERT INTO black_cards VALUES (9027, 'Wait! I''m a ____! Let me tell you about my ____!', 0, 2, '/tg/');
INSERT INTO black_cards VALUES (9028, 'Whenever we run ____, it''s customary that ____ pays for the group''s pizza.', 0, 2, '/tg/');
INSERT INTO black_cards VALUES (9112, 'My most shameful orgasm was the time I masturbated to ____.', 0, 1, 'RPF');
INSERT INTO black_cards VALUES (9113, 'I got an STD from ____.', 0, 1, 'RPF');
INSERT INTO black_cards VALUES (9114, '____ is serious business.', 0, 1, 'RPF');
INSERT INTO black_cards VALUES (9115, 'If you don''t pay your Comcast cable bill, they will send ____ after you.', 0, 1, 'RPF');
INSERT INTO black_cards VALUES (9116, 'Mewtwo achieved a utopian society when he eliminated ____ once and for all.', 0, 1, 'RPF');
INSERT INTO black_cards VALUES (9117, 'The only thing that caused more of a shitfit than Mewtwo''s new form is ____.', 0, 1, 'RPF');
INSERT INTO black_cards VALUES (9118, 'The idiots in that one room at the Westin finally got kicked out of Anthrocon for ____.', 0, 1, 'RPF');
INSERT INTO black_cards VALUES (9119, 'Furaffinity went down for 48 hours because of ____.', 0, 1, 'RPF');
INSERT INTO black_cards VALUES (9120, 'Anthrocon was ruined by ____.', 0, 1, 'RPF');
INSERT INTO black_cards VALUES (9121, 'I unwatched his FurAffinity page because he kept posting ____.', 0, 1, 'RPF');
INSERT INTO black_cards VALUES (9122, 'You don''t want to find ____ in your Furnando''s Lasagna Wrap.', 0, 1, 'RPF');
INSERT INTO black_cards VALUES (9123, '____ ruined the ____ fandom for all eternity.', 0, 2, 'RPF');
INSERT INTO black_cards VALUES (9124, 'I was fapping to ____, but ____ walked in on me.', 0, 2, 'RPF');
INSERT INTO black_cards VALUES (9125, 'In recent tech news, computers are now being ruined by ____.', 0, 1, 'RPF');
INSERT INTO black_cards VALUES (9126, 'Yu-Gi-Oh players were shocked when the win condition of holding 5 Exodia pieces was replaced by ____, ____, and ____. ', 2, 3, 'RPF');
INSERT INTO black_cards VALUES (9127, 'What are the worst 3 cards in your hand right now?', 2, 3, 'RPF');
INSERT INTO black_cards VALUES (9128, '____ makes the Homestuck fandom uncomfortable.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9129, '____ stays awake at night, crying over ____.', 0, 2, 'MSPA');
INSERT INTO black_cards VALUES (9130, '____. It keeps happening!', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9131, '"Sacred leggings" was a mistranslation. The Sufferer actually died in Sacred ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9132, 'After throwing ____ at Karkat''s head, Dave made the intriguing discover that troll horns are very sensitive.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9133, 'AG: Who needs luck when you have ____?', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9134, 'All ____. All of it!', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9135, 'Alternia''s political system was based upon ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9136, 'Believe it or not, Kankri''s biggest trigger is ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9137, 'Dave Strider likes ____, but only ironically.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9138, 'Equius beats up Eridan for ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9140, 'Feferi secretly hates ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9141, 'For Betty Crocker''s latest ad campaign/brainwashing scheme, she is using ____ as inspiration.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9142, 'For his birthday, Dave gave John ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9143, 'Fuckin'' ____. How do they work?', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9144, 'Gamzee not only likes using his clubs for juggling and strifing, he also uses them for____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9145, 'Getting a friend to read Homestuck is like ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9146, 'How do I live without ____?', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9147, 'Hussie died on his quest bed and rose as the fully realized ____ of ____.', 0, 2, 'MSPA');
INSERT INTO black_cards VALUES (9148, 'Hussie unintentionally revealed that Homestuck will end with ____ and ____ consummating their relationship at last.', 0, 2, 'MSPA');
INSERT INTO black_cards VALUES (9149, 'I am ____. It''s me.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9150, 'I finally became Tumblr famous when I released a gifset of ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9151, 'I just found ____ in my closet it is like fucking christmas up in here.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9152, 'I warned you about ____, bro! I told you, dog!', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9153, 'In the final battle, John distracts Lord English by showing him ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9154, 'It''s hard, being ____. It''s hard and no one understands.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9155, 'John is a good boy. And he loves ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9156, 'John may not be a homosexual, but he has a serious thing for ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9157, 'Kanaya reached into her dead lusus''s stomach and retrieved ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9158, 'Kanaya tells Karkat about ____ to cheer him up.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9159, 'Karkat gave our universe ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9160, 'Latula and Porrin have decided to teach Kankri about the wonders of ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9161, 'Little did they know, the key to defeating Lord English was actually ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9162, 'Little known fact: Kurloz''s stitching is actually made out of ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9163, 'Nanna baked a cake for John to commemorate ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9164, 'Nepeta only likes Karkat for his ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9165, 'Nepeta''s secret OTP is ____ with ____.', 0, 2, 'MSPA');
INSERT INTO black_cards VALUES (9166, 'The next thing Hussie will turn into a sex joke will be ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9167, 'Nobody was surprised to find ____ under Jade''s skirt. The surprise was she used it for/on ____.', 0, 2, 'MSPA');
INSERT INTO black_cards VALUES (9168, 'The only way to beat Vriska in an eating contest is to put ____ on the table.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9169, 'Porrim made Kankri a sweater to cover his ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9170, 'Problem Sleuth had a hard time investigating ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9171, 'The real reason Terezi stabbed Vriska was to punish her for ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9172, 'Rose was rather disgusted when she started reading about ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9173, 'The secret way to achieve God Tier is to die on top of ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9174, 'Terezi can top anyone except ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9175, 'The thing that made Kankri break his vow of celibacy was ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9176, 'Turns out, pre-entry prototyping with ____ was not the best idea.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9177, 'Vriska killed Spidermom with ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9178, 'Vriska roleplays ____ with Terezi as ____.', 0, 2, 'MSPA');
INSERT INTO black_cards VALUES (9179, 'Vriska''s greatest regret is ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9180, 'Wear  ____. Be ____.', 0, 2, 'MSPA');
INSERT INTO black_cards VALUES (9181, 'What did Jake get Dirk for his birthday?', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9182, 'What is the worst thing that Terezi ever licked?', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9184, 'What makes your kokoro go "doki doki"?', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9185, 'What''s in the box, Jack?', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9186, 'When a bucket is unavailable, trolls with use ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9187, 'When Dave received ____ from his Bro for his 9th birthday, be felt a little warm inside.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9188, 'The hole in Kanaya''s stomach is so large, she can fit ____ in it.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9189, 'where doing it man. where MAKING ____ HAPEN!', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9190, 'Your name is JOHN EGBERT and boy do you love ____!', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9191, '____. On the roof. Now.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9192, '____ totally makes me question my sexuality.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9193, 'Whenever I see ____ on MSPARP, I disconnect immediately.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9194, 'Calliborn wants you to draw pornography of ____.', 0, 1, 'MSPA');
INSERT INTO black_cards VALUES (9195, 'They found some more last episodes! They were found in ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9196, 'The Doctor did it! He saved the world again! This time using a ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9198, 'I''d give up ____ to travel with The Doctor.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9199, 'The next Doctor Who spin-off is going to be called ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9200, 'Who should be the 13th Doctor?', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9201, 'The Chameleon circuit is working again...somewhat. Instead of a phone booth, the TARDIS is now a ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9202, 'Originally, the 50th special was going to have ____ appear, but the BBC decided against it in the end.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9203, 'After we watch an episode, I''ve got some ____-flavored Jelly Babies to hand out.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9204, 'Wibbly-wobbly, timey-wimey ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9205, 'What''s going to be The Doctor''s new catchphrase?', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9206, 'Bowties are ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9207, 'Old and busted: EXTERMINATE! New hotness: ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9208, 'There''s a new dance on Gallifrey. It''s called the ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9209, 'They announced a new LEGO Doctor Who game! Rumor has it that ____ is an unlockable character.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9210, 'FUN FACT: The Daleks were originally shaped to look like ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9211, 'At this new Doctor Who themed restaurant, you can get a free ____ if you can eat a plate of bangers and mash in under 3 minutes.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9213, 'Who is going to be The Doctor''s next companion?', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9214, 'I think the BBC is losing it. They just released a Doctor Who themed ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9215, 'It''s a little known fact that if you send a ____ to the BBC, they will send you a picture of The Doctor.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9216, 'I was ok with all the BAD WOLF graffiti, until someone wrote it on ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9217, 'Jack Harkness, I can''t leave you alone for a minute! I turn around and you''re trying to seduce ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9218, 'In all of space and time you decide that ____ is a good choice?!', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9219, 'Adipose were thought to be made of fat, but are really made of ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9220, 'I hear the next thing that will cause The Doctor to regenerate is ____.', 0, 1, 'DW');
INSERT INTO black_cards VALUES (9221, 'Honey badger don''t give a ____!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9222, 'My next video turorial covers ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9223, 'We found a map Charlie! A map to ____ Mountain!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9224, 'For the love of GOD, and all that is HOLY, ____!!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9225, 'The new Operating System will be called ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9226, 'I used to be an adventurer like you, then I took a/an ____ in the ____.', 0, 2, 'KHAOS');
INSERT INTO black_cards VALUES (9227, 'You''ve got to check out ____ Fluxx!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9228, 'Call of Duty Modern Warfare 37: War of ____!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9229, 'In brightest day, in blackest night, no ____ shall escape my sight.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9230, 'Yes, Mr. Death... I''ll play you a game! But not chess! My game is ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9231, 'I cannot preach hate and warfare when I am a disciple of ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9232, 'With great power comes great ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9233, 'Don''t make me ____. You wouldn''t like me when I''m ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9234, 'Fighting a never-ending battle for truth, justice, and the American ____!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9235, 'Faster than a speeding ____! More powerful than a ____!', 0, 2, 'KHAOS');
INSERT INTO black_cards VALUES (9236, 'Able to leap ____ in a single bound! ', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9237, 'Disguised as ____, mild-mannered ____. ', 0, 2, 'KHAOS');
INSERT INTO black_cards VALUES (9238, 'Patriotism doesn''t automatically equal ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9239, 'I''m loyal to nothing, General - except the ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9240, 'Alright you Primitive Screwheads, listen up! You see this? This... is my ____!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9241, 'Shop smart. Shop ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9242, 'Hail to the ____, baby.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9243, 'Good. Bad. I''m the guy with the ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9244, 'How will we stop an army of the dead at our castle walls?', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9245, 'I seek The Holy ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9246, 'I see you have the machine that goes ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9247, 'Every sperm is ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9248, 'An African or European ____?', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9249, 'Well you can''t expect to wield supreme executive power just ''cause some watery tart threw a ____ at you!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9250, '"____!" "It''s only a model."', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9251, 'Good night. Sleep well. I''ll most likely ____ you in the morning.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9252, 'I am The Dread Pirate ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9253, 'Do you want me to send you back to where you were, ____ in ____?', 0, 2, 'KHAOS');
INSERT INTO black_cards VALUES (9254, 'I see ____ people', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9255, '____? We don''t need no stinking ____!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9256, 'These aren''t the ____ you''re looking for.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9257, 'We''re gonna need a bigger ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9258, 'Beavis and Butthead Do ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9259, 'I, for one, welcome our new ____ overlords.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9260, 'You know, there''s a million fine looking women in the world, dude. But they don''t all bring you ____ at work. Most of ''em just ____.', 0, 2, 'KHAOS');
INSERT INTO black_cards VALUES (9261, 'Teenage Mutant Ninja ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9262, 'Achy Breaky ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9263, 'I''m not a ____, but I play one on TV', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9264, '____''s latest music video features a dozen ____ on ____.', 0, 3, 'KHAOS');
INSERT INTO black_cards VALUES (9265, '____. Like a boss!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9266, 'In Soviet ____, ____ ____s you.', 2, 3, 'KHAOS');
INSERT INTO black_cards VALUES (9267, '____. It''s not just for breakfast anymore.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9268, '____. It''s what''s for dinner!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9269, '____. Part of this nutritious breakfast.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9270, '____. Breakfast of champions!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9271, 'Where''s the beef?', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9272, 'Oh my god! They killed ____!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9273, 'I am not fat! I''m just ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9274, 'Two by two, hands of ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9197, '____ was sent to save ____.', 0, 2, 'DW');
INSERT INTO black_cards VALUES (9275, 'The anxiously awaited new season of Firefly is rumoured to kick off with an action packed scene, featuring River Tam''s amazing feats of ____!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9276, 'I swear by my pretty floral  ____, I will ____ you.', 0, 2, 'KHAOS');
INSERT INTO black_cards VALUES (9277, 'Wendy''s ____ & Juicy.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9278, 'I HATE it when ____(s) crawl(s) up my ____!', 0, 2, 'KHAOS');
INSERT INTO black_cards VALUES (9279, 'At ____, where every day is ____ day!', 0, 2, 'KHAOS');
INSERT INTO black_cards VALUES (9280, '____ at last! ____ at last! Thank God almighty, I''m ____ at last! ', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9281, 'I have a dream that one day this nation will rise up and live out the true meaning of its creed:', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9282, 'This year''s ____ guest of honour is ____.', 0, 2, 'KHAOS');
INSERT INTO black_cards VALUES (9283, 'This will be the greatest ____con ever!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9284, '____ is the new ____.', 0, 2, 'KHAOS');
INSERT INTO black_cards VALUES (9285, 'Bitches LOVE ____!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9286, 'The only good ____ is a dead ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9287, 'A vote for ____ is a vote for ____.', 0, 2, 'KHAOS');
INSERT INTO black_cards VALUES (9288, 'Thou shalt not____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9289, 'I am the King of ____!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9290, 'Team ____!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9291, 'We went to a workshop on tantric ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9292, 'My safeword is ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9293, 'I like ____, but ____ is a hard limit!', 0, 2, 'KHAOS');
INSERT INTO black_cards VALUES (9294, 'I ____, therefore I ____.', 0, 2, 'KHAOS');
INSERT INTO black_cards VALUES (9295, 'Welcome to my secret lair. I call it The Fortress of ____.', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9296, 'These are my minions of ____!', 0, 1, 'KHAOS');
INSERT INTO black_cards VALUES (9366, '____ doesn''t need to be judged right now.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9367, '____ is a terrible thing to do to the ____!', 0, 2, 'RP');
INSERT INTO black_cards VALUES (9368, '____ &amp; ____: Worst mods ever.', 0, 2, 'RP');
INSERT INTO black_cards VALUES (9369, '/____ all over this post.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9370, '/____ delicately from the butt.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9371, '/slides hand up your ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9372, '____ is not an island.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9373, '____ runs into the forest, screaming.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9374, '____ was better before the anon meme.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9375, 'We''d love to have you at ____ Island!', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9376, 'Bad news guys, my parents found that thread involving ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9377, 'But what are your thoughts on ____?', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9378, 'Chaos ensued when Wankgate banned ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9379, 'Cute, fun and ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9380, 'Does anyone ____? I feel like the only one.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9381, 'Excuse me, but I identify as ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9382, 'Great, another ____ event.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9383, 'How can there be a group of people more ____ than us?', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9384, 'How''s my driving?', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9385, 'I can only ____ if I feel a deep emotional connection.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9386, 'I can''t believe we just spent a whole page wanking about ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9387, 'I have a PHD in ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9388, 'I just benchpressed, like, 14 ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9389, 'I need deets on ____, stat.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9390, 'I predict ____ will close by the end of the year.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9391, 'I randomly began to ____ and ____ came galloping up the stairs.', 0, 2, 'RP');
INSERT INTO black_cards VALUES (9392, 'I see Wankgate''s bitching about ____ again.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9393, 'I''m literally shaking and ____ right now.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9394, 'I''m married to ____ on the astral plane.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9395, 'I''m really into ____, so please don''t kinkshame.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9396, 'I''m sad we lost ____ in the exodus from LJ to DW.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9397, 'I''m starting a game where the characters are stuck in ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9398, 'I''m taking commissions for ____!', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9399, 'How dare you not warn for ____! Don''t you know how triggering that is?', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9400, 'In this world, sexual roles are divided into three categories: the ____, the ____, and the ____', 2, 3, 'RP');
INSERT INTO black_cards VALUES (9401, 'It''s ____ o''clock.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9402, 'ITT: ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9403, 'Join my new game about ____!', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9404, 'Keep fucking that ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9405, 'Let me tell you about ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9406, 'Log in and ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9407, 'My favorite thread is the one where ____ has kinky sex with ____.', 0, 2, 'RP');
INSERT INTO black_cards VALUES (9408, 'My headcanon is that ____ is ____.', 0, 2, 'RP');
INSERT INTO black_cards VALUES (9409, 'My OTP: ____ x ____.', 0, 2, 'RP');
INSERT INTO black_cards VALUES (9410, 'New game idea! You''re kidnapped by ____ and forced into ____.', 0, 2, 'RP');
INSERT INTO black_cards VALUES (9411, 'no actually i don''t care at all, i don''t even ____. :))))', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9412, 'OMG you guys I have so many feels about ____!', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9413, 'Only ____ would play from ____.', 0, 2, 'RP');
INSERT INTO black_cards VALUES (9414, 'Raising money for ____! Please replurk!', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9415, 'RPAnons made me ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9416, 'SHUT UP ABOUT YOUR ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9417, 'Signal boosting for ____!', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9418, 'Since ____ is on hiatus, fans have migrated to ____.', 0, 2, 'RP');
INSERT INTO black_cards VALUES (9419, 'Someone just stuck their head out of the window and screamed "____''s UP!"', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9420, 'Someone left a ____ out in the rain.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9421, 'That ____. You know, *that* one.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9422, 'The ____ is happy.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9423, 'The perfect username for my next character: ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9424, 'The thing I hate most about RP is ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9425, 'Their ____ are of age.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9426, 'There are too many memes about ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9427, 'There is no ____ in Holly Heights.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9428, 'We need a new post. This one smells like ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9429, 'Why was I asked for app revisions?', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9430, 'Why was I banned?', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9431, 'Who apps ____ to a sex game?', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9432, 'Who should I play next?', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9433, 'You can''t fist ____.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9434, 'You sound ____, tbh.', 0, 1, 'RP');
INSERT INTO black_cards VALUES (9435, 'Azerbaijan, Land of ____.', 0, 1, 'ESC');
INSERT INTO black_cards VALUES (9436, 'There''s rumours of a country buying votes with ____.', 0, 1, 'ESC');
INSERT INTO black_cards VALUES (9437, 'Your ideal interval act.', 0, 3, 'ESC');
INSERT INTO black_cards VALUES (9438, 'This performance contains flashing images, ____ and ____.', 0, 2, 'ESC');
INSERT INTO black_cards VALUES (9439, 'Serbia entered magical girls. How horribly will their contract end?', 0, 2, 'ESC');
INSERT INTO black_cards VALUES (9440, 'HELLO EUROPE, ____ CALLING! 12 POINTS GO TO ____!', 0, 2, 'ESC');
INSERT INTO black_cards VALUES (9441, '____. As guaranteed as Cyprus giving Greece 12 points.', 0, 1, 'ESC');
INSERT INTO black_cards VALUES (9442, 'Women kissing each other on stage, men kissing each other on stage, what next?', 0, 1, 'ESC');
INSERT INTO black_cards VALUES (9443, 'Lena goes from Eurovision winner, to participant, to score reader. Her next job is ____.', 0, 1, 'ESC');
INSERT INTO black_cards VALUES (9444, 'The correct procedure for listening to Fairytale is:', 0, 2, 'ESC');
INSERT INTO black_cards VALUES (9445, 'Nothing can bring down Ruslana''s chippy mood,, not even ____.', 0, 1, 'ESC');
INSERT INTO black_cards VALUES (9446, 'Krista Siegfrids'' chronic marrying spree added ____ to her victims list.', 0, 1, 'ESC');
INSERT INTO black_cards VALUES (9447, 'The BBC have decided to dig up another old relic and send ____ to represent the UK.', 0, 1, 'ESC');
INSERT INTO black_cards VALUES (9448, 'A (few) word(s) synonymous with Eurovision fans: ____', 0, 1, 'ESC');
INSERT INTO black_cards VALUES (9449, 'Johnny Logan is a man of many talents; he wins Eurovisions and ____.', 0, 1, 'ESC');
INSERT INTO black_cards VALUES (9450, 'Misheard lyrics of Verjamem resulted in people thinking Eva Boto screeched ____.', 0, 1, 'ESC');
INSERT INTO black_cards VALUES (9451, 'This country has declined to participate due to ____.', 0, 1, 'ESC');
INSERT INTO black_cards VALUES (9452, 'I''m in loooooooove with a fairytaaaale, even thouuugh it ____.', 0, 1, 'ESC');
INSERT INTO black_cards VALUES (9453, 'In an attempt to foster friendly attitudes between ESC entrants, the host country made them ____ and ____.', 0, 2, 'ESC');
INSERT INTO black_cards VALUES (9454, 'The winning act had ____ and ____ as the singer belted out lyrics about ____.', 2, 3, 'ESC');
INSERT INTO black_cards VALUES (9455, 'Podczas lotu samolotem zabrania się ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9456, 'To straszna szkoda, że wszystkie dzieci w dzisijszych czasach majš do czynienia z ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9457, 'Za 1000lat zamiast papierowych pieniędzy będziemy używać ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9458, 'Czego wstydzi się Batman? .', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9459, 'PZPN zakazał ____ bowiem dawało to graczš niesprawiedliwš przewagę.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9460, 'Następna ksišżka JK Rowling będzie nosiła tytuł: Harry Potter i Komnata ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9461, 'Co przywiozłem z Turcji?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9462, '____? Istnieje aplikacja, która to robi.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9463, 'Co jest moim narkotykiem?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9464, 'Gdy USA cigało się ze Zwišzkiem Radzieckim na księżyc, rzšd Meksyku wydał milion pesos na ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9465, 'W nowym filmnie Disnaya Hannah Montana po raz pierwszy zmaga się z ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9466, 'Co jest mojš super mocš?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9467, 'Co jest kolejnš modnš dietš?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9468, 'Co Bogusław Linda jadł na obiad?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9469, 'Gdy Faraon nie dawał się przekonać Mojżesz zesłał plagę ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9470, 'W jaki sposób udaje mi się utrzymać mój zwišzek?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9471, 'Co jest najbardziej chrupišce?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9472, 'W wiezieniu za 200 fajek dostaniesz ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9473, 'Po wielkiej powodzi w 2010 roku, jako pomoc, polski rzšd zorganizował powodzianom ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9474, 'W dzisiejszych czasach niegrzeczne dzieci zamiast rózgi dostajš pod choinkę ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9475, 'Życie indian zostało na zawsze zmienione gdy biały człowiek pokazał im ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9476, 'Przy pomocy czego polski rzšd wspiera studentów z regionów wiejskich?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9477, 'Może to jej urok, a może to ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9478, 'W ostatnich chwilach swego życia Michael Jackson mylał o ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9479, 'Biali ludzie lubiš ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9480, 'Przez co wszystko mnie boli?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9481, 'Romantyczna kolacja ze wiecami nie może obejć się bez ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9482, 'Co sprowadzę z przyszłoci by przekonać ludzi, że jestem potężnym czarodziejem ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9483, 'TV Mango prezentuje ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9484, 'Wycieczka szkolna została zrujnowana przez ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9485, 'Co jest najlepszym przyjacielem kobiety?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9486, 'Drogie Bravo, mam problem z ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9487, 'Jak będę premierem, to stworze Ministerstwo ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9488, 'Co ukrywajš przede mnš rodzice?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9489, 'Co zawsze rozkręca imprezy?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9490, 'Co staje się lepsze z wiekiem?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9491, '____ dobry do ostaniej kropli.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9492, '____ To pułapka!.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9493, 'W nowym reality show MTV omiu celebrytom wprowadza się do domu z ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9494, 'Co jest najbardziej emo?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9495, 'W czasie seksu lubię myleć o ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9496, 'Co zakończyło mój ostatni zwišzek?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9497, 'Co to za dżwięk?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9498, '____ Tak chce umrzeć.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9499, 'Przez co cały się kleje?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9500, 'Co będzie następnš zabawkš w zestawie Happy Meal?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9501, 'Czego jest pełno w niebie?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9502, 'Nie wiem czym będzie sie walczyć podczas trzeciej wojny wiatowej, ale podczas czwartej wojny wiatowej będzie się walczyć ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9503, 'Na co zawsze można poderwać laskę?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9504, '____ Dla Ciebie, dla Rodziny.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9505, 'Przez co nie mogę spać w nocy?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9506, 'Co tak pachnie?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9507, 'Co pomaga Obamie się wyluzować?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9508, 'Do teatrów wchodzi musical o ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9509, 'Antropologowie odkryli ostatnio starożyne plemię czczšce ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9510, 'Zanim Pana zabije, Panie Bond, muszę pokazać Panu ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9511, 'Badania wykazujš, że myszy laboratotyjne pokonujš labirynt 50% wybciej po kontakcie z ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9512, 'Na żywo, tylko w Polsat Sport: Cykl turniejów ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9513, 'Jak będę miliarderem, to wzniosę 50 metrowy pomnik na czeć ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9514, 'By przycišgnšć więcej goci, Muzeum Narodowe otworzyło interaktywny eksponat z ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9515, 'Wojna! jaki z niej pożytek?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9516, 'Co powoduje u mnie gazy?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9517, 'Czym mierdzš starzy ludzie?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9518, 'Z czego rezygnuje w czasie postu?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9519, 'Medycyna alternatywna zaczęła doceniać właciwoci lecznicze ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9520, 'Co USA wysyłało dzieciom w Afganistanie?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9521, 'CO preferuje Janusz Korwin-Mikke?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9522, 'Czego nie chcielibyce znależć w chińskim żarciu?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9523, 'Pije by zapomnieć o ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9524, '____ Pištka stary!.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9525, 'Picasso w czasie swoich twórczych eksperymentów z uproszczeniem formy stworzył setki obrazów przedstawiajšcych ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9526, 'Przepraszam profesorze, ale nie mogłem obronić pracy domowej przez ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9527, 'Co będzie następnym duetem superbohaterów?.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9528, '____ to pierwszy krok do ____.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9529, 'Tak, to ja zabiłem ____ Pytacie jak? ____.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9530, 'Nagrodę za ____ otrzymuje ____.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9531, 'Jako moja nastepnš sztuczkę, wycišgne ____ z ____.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9532, 'Krok 1: ____ Krok 2: ____ Krok 3: Profity.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9533, 'Jak byłem na kwasie, to ____ zmienił się w ____.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9534, 'W wiecie zniszczonym przez ____ naszš jedynš nadziejš będzie ____.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9535, 'W nowym filmie akcji Bruca willis odkrywa, że ____ był tak naprawdę ____.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9536, 'Nigdy nie rozumiałem ____ dopóki nie ____.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9537, 'Plotka głosi, że ulubionym daniem Władimira Putina jest ____ nadziewane ____.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9538, 'TVP Kultura przedstawia film dokumentalny pt. ____ nieznana historia ____.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9539, 'Stwórz Haiku.', 2, 3, 'Pol');
INSERT INTO black_cards VALUES (9540, 'Kiedy byłem/am na dragach, _____ zamieniło się w _____..', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9541, 'Po trzęsieniu ziemi, Miley Cyrus podarowała ludziom z Haiti ______.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9542, 'Wymiliłe włanie nowš postać do lola nazwałe jš ____ jej głównš umiejętnociš będzie ____.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9543, 'Tato, dlaczego mama płacze?.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9544, '____ władca mojego ____.', 0, 2, 'Pol');
INSERT INTO black_cards VALUES (9545, 'Co to za plama na mojej kanapie? ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9546, 'Wielka miłoć do ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9547, 'Dlaczego moja siostra ma gumowego penisa? ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9548, 'Czym dla Ciebie jest bóg ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9549, 'Murzyn w stroju banana ____.', 0, 1, 'Pol');
INSERT INTO black_cards VALUES (9139, 'Everybody out of the god damn way. You''ve got a heart full of ____, a soul full of ____, and a body full of ____.', 2, 3, 'MSPA');
INSERT INTO black_cards VALUES (9030, '____ would be a good name for a band.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9031, '____ wouldn''t be funny if not for the irony.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9032, 'Help, I''m trapped in a ____ factory!', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9033, 'None of the places I floated to had ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9034, '____. My normal method is useless here.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9035, 'We had a ____ party, but it turned out not to be very much fun.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9036, 'My hobby: ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9037, '____ makes terrible pillow talk.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9038, 'What is the best way to protect yourself from Velociraptors?', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9039, 'I''m pretty sure you can''t send ____ through the mail.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9040, 'I''m like ____, except with love.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9041, 'Spoiler Alert! ____ kills ____ with ____!', 2, 3, 'xkcd');
INSERT INTO black_cards VALUES (9042, 'I didn''t actually want you to be ____; I just wanted you to be ____.', 0, 2, 'xkcd');
INSERT INTO black_cards VALUES (9043, 'Do you really expect ____? No, Mister Bond. I expect you to die!', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9044, 'What do we miss most from the internet in 1998?', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9046, 'All of my algorithms were really just disguised ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9047, 'Waking up would be a lot easier if ____ didn''t look so much like you.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9048, '____? No, I''m not really into Pokémon.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9049, 'I got a lot more interested in ____ when I made the connection to ____.', 0, 2, 'xkcd');
INSERT INTO black_cards VALUES (9050, 'Dreaming about ____ in Cirque du Soleil.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9051, 'When I eat ____, I like to pretend I''m a Turing machine.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9052, 'Freestyle rapping is really just ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9053, 'It turns out God created the universe using ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9054, 'Human intelligence decreases with increasing proximity to ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9055, 'If I could rearrange the alphabet, I''d put ____ and ____ together.', 0, 2, 'xkcd');
INSERT INTO black_cards VALUES (9056, 'The #1 Programmer''s excuse for legitimately slacking off: ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9057, 'I like alter songs by replacing ____ with ____.', 0, 2, 'xkcd');
INSERT INTO black_cards VALUES (9058, 'Ebay review: Instead of ____, package contained ____. Would not buy again.', 0, 2, 'xkcd');
INSERT INTO black_cards VALUES (9059, 'Social rule 99.1: If friends spend more than 60 minutes deciding what to do, they must default to ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9060, '____ linked to Acne! 95% confidence.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9061, 'How many Google results are there for "Died in a ____ accident?"', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9062, 'Real Programmers use ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9063, 'After finding Higgs-Boson, I can always use the LHC for ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9064, 'My health declined when I realized I could eat ____ whenever I wanted.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9065, '____ is just applied ____.', 0, 2, 'xkcd');
INSERT INTO black_cards VALUES (9066, 'What''s my favorite unit of measurement?', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9067, 'In the extended base metaphor, shortstop is ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9068, 'I don''t actually care about ____, I just like ____.', 0, 2, 'xkcd');
INSERT INTO black_cards VALUES (9069, 'Why do you have a crossbow in your desk?', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9070, 'I set up script to buy things on ebay for $1, but then it bought ____, ____, and ____.', 2, 3, 'xkcd');
INSERT INTO black_cards VALUES (9071, 'I can extrude ____, but I can''t retract it.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9072, '____''s fetish: ____.', 0, 2, 'xkcd');
INSERT INTO black_cards VALUES (9073, 'Now I have to live my whole life pretending ____ never happened. It''s going to be a fun 70 years.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9074, 'My new favorite game is Strip ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9075, 'Did you know you can just buy ____?', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9076, 'Take me down to the ____, where the ____ is green and the ____ are pretty.', 2, 3, 'xkcd');
INSERT INTO black_cards VALUES (9077, '____. That''s right. Shit just got REAL.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9078, 'Just because I have ____ doesn''t mean you could milk me now. I''d have to be lactating.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9079, '2009 called? Did you warn them about ____?', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9080, 'I''m going to name my child ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9081, '3D printers sound great until you receive spam containing actual ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9082, 'Until I see more data, I''m going to assume ____ causes ____.', 0, 2, 'xkcd');
INSERT INTO black_cards VALUES (9083, 'Did you know November is ____ Awareness Month?', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9084, 'University Researchers create life in lab! ____ blamed!', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9085, 'It''s fun to mentally replace the word ____ with ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9086, 'If you really hate someone, teach them to recognize ____.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9087, '____. So it has come to this.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9088, 'Hey baby, wanna come back to my sex ____?', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9089, 'The past is a foreign country... with ____ and ____!', 0, 2, 'xkcd');
INSERT INTO black_cards VALUES (9090, 'What role has social media played in ____? Well, it''s certainly made ____ stupider.', 0, 2, 'xkcd');
INSERT INTO black_cards VALUES (9091, '____. It works in Kerbal Space Program.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9092, '____ is too big for small talk.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9093, 'What did I suggest to the IAU for a new planet name?', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (9094, 'By 2019, ____ will be outnumbered by ____.', 0, 2, 'xkcd');
INSERT INTO black_cards VALUES (9095, 'New movie this summer: ____ beats up everyone.', 0, 1, 'xkcd');
INSERT INTO black_cards VALUES (100458, 'Revealed:<br>Why He Really Resigned!<br>Pope Benedict''s Secret Struggle with ____!', 0, 1, 'HBS');
INSERT INTO black_cards VALUES (100459, 'Here''s what you can expect for the new year.<br>Out: ____.<br>In: ____.', 0, 2, 'HBS');
INSERT INTO black_cards VALUES (9212, 'According to the Daleks, ____ is better at ____.', 0, 2, 'DW');
INSERT INTO black_cards VALUES (100476, 'I can''t believe Netflix is using ____ to promote House of Cards.', 0, 1, 'HOCAH');
INSERT INTO black_cards VALUES (100477, 'I''m not going to lie. I despise ____. There, I said it.', 0, 1, 'HOCAH');
INSERT INTO black_cards VALUES (100478, 'A wise man said, "Everything is about sex. Except sex. Sex is about ____."', 0, 1, 'HOCAH');
INSERT INTO black_cards VALUES (100480, 'Our relationship is strictly professional. Let''s not complicate things with ____.', 0, 1, 'HOCAH');
INSERT INTO black_cards VALUES (100481, 'Because you enjoyed ____, we thought you''d like ____.', 0, 2, 'HOCAH');
INSERT INTO black_cards VALUES (100482, 'We''re not like other news organizations. Here at Slugline, we welcome ____ in the office. ', 0, 1, 'HOCAH');
INSERT INTO black_cards VALUES (100483, 'Cancel all my meetings. We''ve got a situation with ____ that requires my immediate attention.', 0, 1, 'HOCAH');
INSERT INTO black_cards VALUES (100484, 'If you need him to, Remy Danton can pull some strings and get you ____, but it''ll cost you.', 0, 1, 'HOCAH');
INSERT INTO black_cards VALUES (100479, 'Corruption. Betrayal. ____. Coming soon to Netflix, "House of ____."', 0, 2, 'HOCAH');
INSERT INTO black_cards VALUES (9045, 'I filled my apartment with ____.', 0, 1, 'xkcd');


--
-- TOC entry 1946 (class 0 OID 0)
-- Dependencies: 162
-- Name: black_cards_id_seq; Type: SEQUENCE SET; Schema: public; Owner: cah
--

SELECT pg_catalog.setval('black_cards_id_seq', 9549, true);


--
-- TOC entry 1930 (class 0 OID 16478)
-- Dependencies: 163
-- Data for Name: card_set; Type: TABLE DATA; Schema: public; Owner: cah
--

INSERT INTO card_set VALUES (100017, true, '[C] SocialGamer', false, 'Custom cards from the SocialGamer.net community.', 101);
INSERT INTO card_set VALUES (100157, true, '[C] Northernlion', false, 'http://www.youtube.com/user/Northernlion', 502);
INSERT INTO card_set VALUES (100160, true, '[C] Ridiculously Stupid', false, '', 504);
INSERT INTO card_set VALUES (100161, true, '[C] That Guy With The Glasses', true, 'http://thatguywiththeglasses.com/', 503);
INSERT INTO card_set VALUES (100219, true, '[C] Golby Fan Club', false, '', 505);
INSERT INTO card_set VALUES (1151, true, 'First Version', true, 'The original version of the Cards Against Humanity base game.', 1);
INSERT INTO card_set VALUES (1152, true, 'Second Version', true, 'The updated version of the Cards Against Humanity base game.', 2);
INSERT INTO card_set VALUES (100211, true, 'Third Version', true, 'Another updated version of the Cards Against Humanity base game.', 3);
INSERT INTO card_set VALUES (1155, true, 'The First Expansion', false, 'The official First Expansion.', 10);
INSERT INTO card_set VALUES (1256, true, 'The Second Expansion', false, 'The official Second Expansion.', 11);
INSERT INTO card_set VALUES (100224, true, '[C] Anime', true, 'http://www.desudesbrigade.com/', 506);
INSERT INTO card_set VALUES (1153, true, 'Canadian', false, 'Cards included in Canadian orders.', 20);
INSERT INTO card_set VALUES (1154, true, 'Misprint Replacement Bonus Cards', false, 'Bonus cards included with replacements for misprinted cards.', 21);
INSERT INTO card_set VALUES (100225, true, '[C] Mr. Man Collection', false, '', 515);
INSERT INTO card_set VALUES (1488, true, '2012 Holiday Pack', false, 'The 2012 Holiday Pack.', 22);
INSERT INTO card_set VALUES (100154, true, 'The Third Expansion', false, 'The official Third Expansion.', 12);
INSERT INTO card_set VALUES (100228, true, '[C] Sodomy Dog''s Furry Pack', false, '', 516);
INSERT INTO card_set VALUES (100051, true, 'PAX East 2013 Pack &quot;C&quot;', false, 'PAX East 2013 Pack &quot;C&quot;.', 32);
INSERT INTO card_set VALUES (100049, true, 'PAX East 2013 Pack &quot;A&quot;', false, 'PAX East 2013 Pack &quot;A&quot;.', 30);
INSERT INTO card_set VALUES (100050, true, 'PAX East 2013 Pack &quot;B&quot;', false, 'PAX East 2013 Pack &quot;B&quot;.', 31);
INSERT INTO card_set VALUES (100229, true, '[C] Vidya', false, 'by Sl0nderman', 517);
INSERT INTO card_set VALUES (100231, true, '[C] Game Grumps', false, '', 518);
INSERT INTO card_set VALUES (100257, true, 'Box Expansion', false, 'The Expansion Box Box Expansion.', 18);
INSERT INTO card_set VALUES (100002, true, '[C] Very Serious', false, 'http://forum.verysrs.com/', 501);
INSERT INTO card_set VALUES (100003, true, '[C] Admin''s Picks', false, 'Custom cards that I think are particularly fitting.', 100);
INSERT INTO card_set VALUES (100232, true, '[C] Rooster Teeth', false, '', 519);
INSERT INTO card_set VALUES (100233, true, '[C] Derps Against Humanity', false, '', 520);
INSERT INTO card_set VALUES (100312, true, 'PAX Prime 2013', false, 'PAX Prime 2013', 33);
INSERT INTO card_set VALUES (100415, true, 'The Fourth Expansion', false, 'The official Fourth Expansion.', 13);
INSERT INTO card_set VALUES (100236, true, '[C] Antisocial Injustice', false, '', 521);
INSERT INTO card_set VALUES (100422, true, '2013 Holiday Bullshit', false, 'http://www.holidaybullshit.com/', 23);
INSERT INTO card_set VALUES (100453, true, 'Polish Translation [Needs Review]', true, 'I need somebody to examine this set on /viewcards.jsp and ensure that I didn''t screw up the character encoding.', 50);
INSERT INTO card_set VALUES (100444, true, '[C] FiMFiction.net', false, 'For FiMFiction.net users, by Cola_Bubble_Gum.', 500);
INSERT INTO card_set VALUES (100234, true, '[C] Anime Expansion #1', false, 'http://www.desudesbrigade.com/', 507);
INSERT INTO card_set VALUES (100443, true, '[C] Imgur', false, '', 522);
INSERT INTO card_set VALUES (100445, true, '[C] /tg/', false, '/tg/', 523);
INSERT INTO card_set VALUES (100447, true, '[C] RagingPsyfag''s Pack of Shenanigans', false, '', 525);
INSERT INTO card_set VALUES (100448, true, '[C] Cards Against Homestuck', false, '', 526);
INSERT INTO card_set VALUES (100449, true, '[C] Doctor Who', false, '', 527);
INSERT INTO card_set VALUES (100450, true, '[C] Khaos WolfKat', false, '', 528);
INSERT INTO card_set VALUES (100451, true, '[C] RPAnons', false, '', 529);
INSERT INTO card_set VALUES (100452, true, '[C] Eurovision Song Contest', false, '', 530);
INSERT INTO card_set VALUES (100001, true, '[C] Cards Against Equinity', false, 'My Little Pony themed expansion from the reddit MLP communities.', 499);
INSERT INTO card_set VALUES (100446, true, '[C] xkcd', false, '', 524);
INSERT INTO card_set VALUES (100485, false, 'House of Cards Against Humanity', false, 'House of Cards pack. http://www.houseofcardsagainsthumanity.com/', 40);


--
-- TOC entry 1931 (class 0 OID 16485)
-- Dependencies: 164
-- Data for Name: card_set_black_card; Type: TABLE DATA; Schema: public; Owner: cah
--

INSERT INTO card_set_black_card VALUES (1151, 1);
INSERT INTO card_set_black_card VALUES (1151, 2);
INSERT INTO card_set_black_card VALUES (1151, 3);
INSERT INTO card_set_black_card VALUES (1151, 4);
INSERT INTO card_set_black_card VALUES (1151, 5);
INSERT INTO card_set_black_card VALUES (1151, 6);
INSERT INTO card_set_black_card VALUES (1151, 7);
INSERT INTO card_set_black_card VALUES (1151, 8);
INSERT INTO card_set_black_card VALUES (1151, 9);
INSERT INTO card_set_black_card VALUES (1151, 10);
INSERT INTO card_set_black_card VALUES (1151, 11);
INSERT INTO card_set_black_card VALUES (1151, 12);
INSERT INTO card_set_black_card VALUES (1151, 13);
INSERT INTO card_set_black_card VALUES (1151, 14);
INSERT INTO card_set_black_card VALUES (1151, 15);
INSERT INTO card_set_black_card VALUES (1151, 17);
INSERT INTO card_set_black_card VALUES (1151, 16);
INSERT INTO card_set_black_card VALUES (1151, 19);
INSERT INTO card_set_black_card VALUES (1151, 18);
INSERT INTO card_set_black_card VALUES (1151, 21);
INSERT INTO card_set_black_card VALUES (1151, 20);
INSERT INTO card_set_black_card VALUES (1151, 23);
INSERT INTO card_set_black_card VALUES (1151, 22);
INSERT INTO card_set_black_card VALUES (1151, 25);
INSERT INTO card_set_black_card VALUES (1151, 24);
INSERT INTO card_set_black_card VALUES (1151, 27);
INSERT INTO card_set_black_card VALUES (1151, 26);
INSERT INTO card_set_black_card VALUES (1151, 29);
INSERT INTO card_set_black_card VALUES (1151, 28);
INSERT INTO card_set_black_card VALUES (1151, 31);
INSERT INTO card_set_black_card VALUES (1151, 30);
INSERT INTO card_set_black_card VALUES (1151, 34);
INSERT INTO card_set_black_card VALUES (1151, 35);
INSERT INTO card_set_black_card VALUES (1151, 32);
INSERT INTO card_set_black_card VALUES (1151, 33);
INSERT INTO card_set_black_card VALUES (1151, 38);
INSERT INTO card_set_black_card VALUES (1151, 39);
INSERT INTO card_set_black_card VALUES (1151, 36);
INSERT INTO card_set_black_card VALUES (1151, 37);
INSERT INTO card_set_black_card VALUES (1151, 42);
INSERT INTO card_set_black_card VALUES (1151, 43);
INSERT INTO card_set_black_card VALUES (1151, 40);
INSERT INTO card_set_black_card VALUES (1151, 41);
INSERT INTO card_set_black_card VALUES (1151, 46);
INSERT INTO card_set_black_card VALUES (1151, 47);
INSERT INTO card_set_black_card VALUES (1151, 44);
INSERT INTO card_set_black_card VALUES (1151, 45);
INSERT INTO card_set_black_card VALUES (1151, 51);
INSERT INTO card_set_black_card VALUES (1151, 50);
INSERT INTO card_set_black_card VALUES (1151, 49);
INSERT INTO card_set_black_card VALUES (1151, 48);
INSERT INTO card_set_black_card VALUES (1151, 55);
INSERT INTO card_set_black_card VALUES (1151, 54);
INSERT INTO card_set_black_card VALUES (1151, 53);
INSERT INTO card_set_black_card VALUES (1151, 52);
INSERT INTO card_set_black_card VALUES (1151, 59);
INSERT INTO card_set_black_card VALUES (1151, 58);
INSERT INTO card_set_black_card VALUES (1151, 57);
INSERT INTO card_set_black_card VALUES (1151, 56);
INSERT INTO card_set_black_card VALUES (1151, 63);
INSERT INTO card_set_black_card VALUES (1151, 62);
INSERT INTO card_set_black_card VALUES (1151, 61);
INSERT INTO card_set_black_card VALUES (1151, 60);
INSERT INTO card_set_black_card VALUES (1151, 68);
INSERT INTO card_set_black_card VALUES (1151, 69);
INSERT INTO card_set_black_card VALUES (1151, 70);
INSERT INTO card_set_black_card VALUES (1151, 71);
INSERT INTO card_set_black_card VALUES (1151, 64);
INSERT INTO card_set_black_card VALUES (1151, 65);
INSERT INTO card_set_black_card VALUES (1151, 66);
INSERT INTO card_set_black_card VALUES (1151, 67);
INSERT INTO card_set_black_card VALUES (1151, 76);
INSERT INTO card_set_black_card VALUES (1151, 77);
INSERT INTO card_set_black_card VALUES (1151, 78);
INSERT INTO card_set_black_card VALUES (1151, 79);
INSERT INTO card_set_black_card VALUES (1151, 72);
INSERT INTO card_set_black_card VALUES (1151, 73);
INSERT INTO card_set_black_card VALUES (1151, 74);
INSERT INTO card_set_black_card VALUES (1151, 75);
INSERT INTO card_set_black_card VALUES (1151, 85);
INSERT INTO card_set_black_card VALUES (1151, 84);
INSERT INTO card_set_black_card VALUES (1151, 87);
INSERT INTO card_set_black_card VALUES (1151, 86);
INSERT INTO card_set_black_card VALUES (1151, 81);
INSERT INTO card_set_black_card VALUES (1151, 80);
INSERT INTO card_set_black_card VALUES (1151, 83);
INSERT INTO card_set_black_card VALUES (1151, 82);
INSERT INTO card_set_black_card VALUES (1151, 89);
INSERT INTO card_set_black_card VALUES (1151, 88);
INSERT INTO card_set_black_card VALUES (1151, 90);
INSERT INTO card_set_black_card VALUES (1152, 1);
INSERT INTO card_set_black_card VALUES (1152, 2);
INSERT INTO card_set_black_card VALUES (1152, 3);
INSERT INTO card_set_black_card VALUES (1152, 4);
INSERT INTO card_set_black_card VALUES (1152, 5);
INSERT INTO card_set_black_card VALUES (1152, 6);
INSERT INTO card_set_black_card VALUES (1152, 7);
INSERT INTO card_set_black_card VALUES (1152, 8);
INSERT INTO card_set_black_card VALUES (1152, 9);
INSERT INTO card_set_black_card VALUES (1152, 10);
INSERT INTO card_set_black_card VALUES (1152, 11);
INSERT INTO card_set_black_card VALUES (1152, 12);
INSERT INTO card_set_black_card VALUES (1152, 13);
INSERT INTO card_set_black_card VALUES (1152, 14);
INSERT INTO card_set_black_card VALUES (1152, 15);
INSERT INTO card_set_black_card VALUES (1152, 17);
INSERT INTO card_set_black_card VALUES (1152, 19);
INSERT INTO card_set_black_card VALUES (1152, 18);
INSERT INTO card_set_black_card VALUES (1152, 21);
INSERT INTO card_set_black_card VALUES (1152, 20);
INSERT INTO card_set_black_card VALUES (1152, 22);
INSERT INTO card_set_black_card VALUES (1152, 25);
INSERT INTO card_set_black_card VALUES (1152, 24);
INSERT INTO card_set_black_card VALUES (1152, 26);
INSERT INTO card_set_black_card VALUES (1152, 29);
INSERT INTO card_set_black_card VALUES (1152, 28);
INSERT INTO card_set_black_card VALUES (1152, 31);
INSERT INTO card_set_black_card VALUES (1152, 30);
INSERT INTO card_set_black_card VALUES (1152, 34);
INSERT INTO card_set_black_card VALUES (1152, 35);
INSERT INTO card_set_black_card VALUES (1152, 32);
INSERT INTO card_set_black_card VALUES (1152, 33);
INSERT INTO card_set_black_card VALUES (1152, 38);
INSERT INTO card_set_black_card VALUES (1152, 39);
INSERT INTO card_set_black_card VALUES (1152, 36);
INSERT INTO card_set_black_card VALUES (1152, 42);
INSERT INTO card_set_black_card VALUES (1152, 43);
INSERT INTO card_set_black_card VALUES (1152, 40);
INSERT INTO card_set_black_card VALUES (1152, 41);
INSERT INTO card_set_black_card VALUES (1152, 46);
INSERT INTO card_set_black_card VALUES (1152, 47);
INSERT INTO card_set_black_card VALUES (1152, 44);
INSERT INTO card_set_black_card VALUES (1152, 45);
INSERT INTO card_set_black_card VALUES (1152, 51);
INSERT INTO card_set_black_card VALUES (1152, 50);
INSERT INTO card_set_black_card VALUES (1152, 49);
INSERT INTO card_set_black_card VALUES (1152, 48);
INSERT INTO card_set_black_card VALUES (1152, 53);
INSERT INTO card_set_black_card VALUES (1152, 52);
INSERT INTO card_set_black_card VALUES (1152, 59);
INSERT INTO card_set_black_card VALUES (1152, 58);
INSERT INTO card_set_black_card VALUES (1152, 57);
INSERT INTO card_set_black_card VALUES (1152, 56);
INSERT INTO card_set_black_card VALUES (1152, 63);
INSERT INTO card_set_black_card VALUES (1152, 62);
INSERT INTO card_set_black_card VALUES (1152, 61);
INSERT INTO card_set_black_card VALUES (1152, 60);
INSERT INTO card_set_black_card VALUES (1152, 68);
INSERT INTO card_set_black_card VALUES (1152, 70);
INSERT INTO card_set_black_card VALUES (1152, 71);
INSERT INTO card_set_black_card VALUES (1152, 64);
INSERT INTO card_set_black_card VALUES (1152, 65);
INSERT INTO card_set_black_card VALUES (1152, 66);
INSERT INTO card_set_black_card VALUES (1152, 67);
INSERT INTO card_set_black_card VALUES (1152, 76);
INSERT INTO card_set_black_card VALUES (1152, 77);
INSERT INTO card_set_black_card VALUES (1152, 78);
INSERT INTO card_set_black_card VALUES (1152, 79);
INSERT INTO card_set_black_card VALUES (1152, 72);
INSERT INTO card_set_black_card VALUES (1152, 73);
INSERT INTO card_set_black_card VALUES (1152, 74);
INSERT INTO card_set_black_card VALUES (1152, 75);
INSERT INTO card_set_black_card VALUES (1152, 85);
INSERT INTO card_set_black_card VALUES (1152, 84);
INSERT INTO card_set_black_card VALUES (1152, 87);
INSERT INTO card_set_black_card VALUES (1152, 86);
INSERT INTO card_set_black_card VALUES (1152, 81);
INSERT INTO card_set_black_card VALUES (1152, 80);
INSERT INTO card_set_black_card VALUES (1152, 82);
INSERT INTO card_set_black_card VALUES (1152, 93);
INSERT INTO card_set_black_card VALUES (1152, 92);
INSERT INTO card_set_black_card VALUES (1152, 95);
INSERT INTO card_set_black_card VALUES (1152, 94);
INSERT INTO card_set_black_card VALUES (1152, 89);
INSERT INTO card_set_black_card VALUES (1152, 88);
INSERT INTO card_set_black_card VALUES (1152, 91);
INSERT INTO card_set_black_card VALUES (1152, 90);
INSERT INTO card_set_black_card VALUES (1152, 98);
INSERT INTO card_set_black_card VALUES (1152, 96);
INSERT INTO card_set_black_card VALUES (1152, 97);
INSERT INTO card_set_black_card VALUES (1153, 1005);
INSERT INTO card_set_black_card VALUES (1153, 1004);
INSERT INTO card_set_black_card VALUES (1153, 1007);
INSERT INTO card_set_black_card VALUES (1153, 1006);
INSERT INTO card_set_black_card VALUES (1153, 1008);
INSERT INTO card_set_black_card VALUES (1154, 1032);
INSERT INTO card_set_black_card VALUES (1155, 1064);
INSERT INTO card_set_black_card VALUES (1155, 1058);
INSERT INTO card_set_black_card VALUES (1155, 1059);
INSERT INTO card_set_black_card VALUES (1155, 1056);
INSERT INTO card_set_black_card VALUES (1155, 1057);
INSERT INTO card_set_black_card VALUES (1155, 1062);
INSERT INTO card_set_black_card VALUES (1155, 1063);
INSERT INTO card_set_black_card VALUES (1155, 1060);
INSERT INTO card_set_black_card VALUES (1155, 1061);
INSERT INTO card_set_black_card VALUES (1155, 1049);
INSERT INTO card_set_black_card VALUES (1155, 1048);
INSERT INTO card_set_black_card VALUES (1155, 1051);
INSERT INTO card_set_black_card VALUES (1155, 1050);
INSERT INTO card_set_black_card VALUES (1155, 1053);
INSERT INTO card_set_black_card VALUES (1155, 1052);
INSERT INTO card_set_black_card VALUES (1155, 1055);
INSERT INTO card_set_black_card VALUES (1155, 1054);
INSERT INTO card_set_black_card VALUES (1155, 1045);
INSERT INTO card_set_black_card VALUES (1155, 1047);
INSERT INTO card_set_black_card VALUES (1155, 1046);
INSERT INTO card_set_black_card VALUES (1256, 1157);
INSERT INTO card_set_black_card VALUES (1256, 1156);
INSERT INTO card_set_black_card VALUES (1256, 1159);
INSERT INTO card_set_black_card VALUES (1256, 1158);
INSERT INTO card_set_black_card VALUES (1256, 1161);
INSERT INTO card_set_black_card VALUES (1256, 1160);
INSERT INTO card_set_black_card VALUES (1256, 1163);
INSERT INTO card_set_black_card VALUES (1256, 1162);
INSERT INTO card_set_black_card VALUES (1256, 1165);
INSERT INTO card_set_black_card VALUES (1256, 1164);
INSERT INTO card_set_black_card VALUES (1256, 1167);
INSERT INTO card_set_black_card VALUES (1256, 1166);
INSERT INTO card_set_black_card VALUES (1256, 1168);
INSERT INTO card_set_black_card VALUES (1256, 1169);
INSERT INTO card_set_black_card VALUES (1256, 1170);
INSERT INTO card_set_black_card VALUES (1256, 1171);
INSERT INTO card_set_black_card VALUES (1256, 1172);
INSERT INTO card_set_black_card VALUES (1256, 1173);
INSERT INTO card_set_black_card VALUES (1256, 1174);
INSERT INTO card_set_black_card VALUES (1256, 1175);
INSERT INTO card_set_black_card VALUES (1256, 1176);
INSERT INTO card_set_black_card VALUES (1256, 1177);
INSERT INTO card_set_black_card VALUES (1256, 1178);
INSERT INTO card_set_black_card VALUES (1256, 1179);
INSERT INTO card_set_black_card VALUES (1256, 1180);
INSERT INTO card_set_black_card VALUES (1488, 1457);
INSERT INTO card_set_black_card VALUES (1488, 1458);
INSERT INTO card_set_black_card VALUES (1488, 1459);
INSERT INTO card_set_black_card VALUES (1488, 1460);
INSERT INTO card_set_black_card VALUES (1488, 1461);
INSERT INTO card_set_black_card VALUES (1488, 1462);
INSERT INTO card_set_black_card VALUES (1488, 1463);
INSERT INTO card_set_black_card VALUES (100001, 1375);
INSERT INTO card_set_black_card VALUES (100001, 1374);
INSERT INTO card_set_black_card VALUES (100001, 1373);
INSERT INTO card_set_black_card VALUES (100001, 1372);
INSERT INTO card_set_black_card VALUES (100001, 1371);
INSERT INTO card_set_black_card VALUES (100001, 1370);
INSERT INTO card_set_black_card VALUES (100001, 1369);
INSERT INTO card_set_black_card VALUES (100001, 1366);
INSERT INTO card_set_black_card VALUES (100001, 1365);
INSERT INTO card_set_black_card VALUES (100001, 1363);
INSERT INTO card_set_black_card VALUES (100001, 1361);
INSERT INTO card_set_black_card VALUES (100001, 1359);
INSERT INTO card_set_black_card VALUES (100001, 1356);
INSERT INTO card_set_black_card VALUES (100001, 1354);
INSERT INTO card_set_black_card VALUES (100001, 1355);
INSERT INTO card_set_black_card VALUES (100001, 1352);
INSERT INTO card_set_black_card VALUES (100001, 1353);
INSERT INTO card_set_black_card VALUES (100001, 1350);
INSERT INTO card_set_black_card VALUES (100001, 1347);
INSERT INTO card_set_black_card VALUES (100001, 1345);
INSERT INTO card_set_black_card VALUES (100001, 1262);
INSERT INTO card_set_black_card VALUES (100001, 1260);
INSERT INTO card_set_black_card VALUES (100001, 1257);
INSERT INTO card_set_black_card VALUES (100001, 1270);
INSERT INTO card_set_black_card VALUES (100001, 1268);
INSERT INTO card_set_black_card VALUES (100001, 1267);
INSERT INTO card_set_black_card VALUES (100001, 1264);
INSERT INTO card_set_black_card VALUES (100001, 1265);
INSERT INTO card_set_black_card VALUES (100001, 1279);
INSERT INTO card_set_black_card VALUES (100001, 1277);
INSERT INTO card_set_black_card VALUES (100001, 1376);
INSERT INTO card_set_black_card VALUES (100001, 1377);
INSERT INTO card_set_black_card VALUES (100001, 1275);
INSERT INTO card_set_black_card VALUES (100001, 1378);
INSERT INTO card_set_black_card VALUES (100001, 1273);
INSERT INTO card_set_black_card VALUES (100001, 1306);
INSERT INTO card_set_black_card VALUES (100001, 1305);
INSERT INTO card_set_black_card VALUES (100001, 1311);
INSERT INTO card_set_black_card VALUES (100001, 1309);
INSERT INTO card_set_black_card VALUES (100001, 1297);
INSERT INTO card_set_black_card VALUES (100001, 1303);
INSERT INTO card_set_black_card VALUES (100001, 1301);
INSERT INTO card_set_black_card VALUES (100001, 1291);
INSERT INTO card_set_black_card VALUES (100001, 1289);
INSERT INTO card_set_black_card VALUES (100001, 1295);
INSERT INTO card_set_black_card VALUES (100001, 1292);
INSERT INTO card_set_black_card VALUES (100001, 1283);
INSERT INTO card_set_black_card VALUES (100001, 1281);
INSERT INTO card_set_black_card VALUES (100001, 1287);
INSERT INTO card_set_black_card VALUES (100001, 1285);
INSERT INTO card_set_black_card VALUES (100001, 1329);
INSERT INTO card_set_black_card VALUES (100001, 1330);
INSERT INTO card_set_black_card VALUES (100001, 1321);
INSERT INTO card_set_black_card VALUES (100001, 1323);
INSERT INTO card_set_black_card VALUES (100001, 1325);
INSERT INTO card_set_black_card VALUES (100001, 1327);
INSERT INTO card_set_black_card VALUES (100001, 1313);
INSERT INTO card_set_black_card VALUES (100001, 1315);
INSERT INTO card_set_black_card VALUES (100001, 1317);
INSERT INTO card_set_black_card VALUES (100001, 1319);
INSERT INTO card_set_black_card VALUES (100002, 137);
INSERT INTO card_set_black_card VALUES (100002, 136);
INSERT INTO card_set_black_card VALUES (100002, 139);
INSERT INTO card_set_black_card VALUES (100002, 138);
INSERT INTO card_set_black_card VALUES (100002, 141);
INSERT INTO card_set_black_card VALUES (100002, 140);
INSERT INTO card_set_black_card VALUES (100002, 143);
INSERT INTO card_set_black_card VALUES (100002, 142);
INSERT INTO card_set_black_card VALUES (100002, 129);
INSERT INTO card_set_black_card VALUES (100002, 128);
INSERT INTO card_set_black_card VALUES (100002, 131);
INSERT INTO card_set_black_card VALUES (100002, 130);
INSERT INTO card_set_black_card VALUES (100002, 133);
INSERT INTO card_set_black_card VALUES (100002, 132);
INSERT INTO card_set_black_card VALUES (100002, 135);
INSERT INTO card_set_black_card VALUES (100002, 134);
INSERT INTO card_set_black_card VALUES (100002, 152);
INSERT INTO card_set_black_card VALUES (100002, 153);
INSERT INTO card_set_black_card VALUES (100002, 154);
INSERT INTO card_set_black_card VALUES (100002, 155);
INSERT INTO card_set_black_card VALUES (100002, 156);
INSERT INTO card_set_black_card VALUES (100002, 157);
INSERT INTO card_set_black_card VALUES (100002, 144);
INSERT INTO card_set_black_card VALUES (100002, 145);
INSERT INTO card_set_black_card VALUES (100002, 146);
INSERT INTO card_set_black_card VALUES (100002, 147);
INSERT INTO card_set_black_card VALUES (100002, 148);
INSERT INTO card_set_black_card VALUES (100002, 149);
INSERT INTO card_set_black_card VALUES (100002, 150);
INSERT INTO card_set_black_card VALUES (100002, 151);
INSERT INTO card_set_black_card VALUES (100002, 102);
INSERT INTO card_set_black_card VALUES (100002, 103);
INSERT INTO card_set_black_card VALUES (100002, 100);
INSERT INTO card_set_black_card VALUES (100002, 101);
INSERT INTO card_set_black_card VALUES (100002, 99);
INSERT INTO card_set_black_card VALUES (100002, 110);
INSERT INTO card_set_black_card VALUES (100002, 111);
INSERT INTO card_set_black_card VALUES (100002, 108);
INSERT INTO card_set_black_card VALUES (100002, 109);
INSERT INTO card_set_black_card VALUES (100002, 106);
INSERT INTO card_set_black_card VALUES (100002, 107);
INSERT INTO card_set_black_card VALUES (100002, 104);
INSERT INTO card_set_black_card VALUES (100002, 105);
INSERT INTO card_set_black_card VALUES (100002, 119);
INSERT INTO card_set_black_card VALUES (100002, 118);
INSERT INTO card_set_black_card VALUES (100002, 117);
INSERT INTO card_set_black_card VALUES (100002, 116);
INSERT INTO card_set_black_card VALUES (100002, 115);
INSERT INTO card_set_black_card VALUES (100002, 114);
INSERT INTO card_set_black_card VALUES (100002, 113);
INSERT INTO card_set_black_card VALUES (100002, 112);
INSERT INTO card_set_black_card VALUES (100002, 127);
INSERT INTO card_set_black_card VALUES (100002, 126);
INSERT INTO card_set_black_card VALUES (100002, 125);
INSERT INTO card_set_black_card VALUES (100002, 124);
INSERT INTO card_set_black_card VALUES (100002, 123);
INSERT INTO card_set_black_card VALUES (100002, 122);
INSERT INTO card_set_black_card VALUES (100002, 121);
INSERT INTO card_set_black_card VALUES (100002, 120);
INSERT INTO card_set_black_card VALUES (100003, 137);
INSERT INTO card_set_black_card VALUES (100003, 136);
INSERT INTO card_set_black_card VALUES (100003, 139);
INSERT INTO card_set_black_card VALUES (100003, 138);
INSERT INTO card_set_black_card VALUES (100003, 140);
INSERT INTO card_set_black_card VALUES (100003, 129);
INSERT INTO card_set_black_card VALUES (100003, 128);
INSERT INTO card_set_black_card VALUES (100003, 130);
INSERT INTO card_set_black_card VALUES (100003, 133);
INSERT INTO card_set_black_card VALUES (100003, 132);
INSERT INTO card_set_black_card VALUES (100003, 135);
INSERT INTO card_set_black_card VALUES (100003, 134);
INSERT INTO card_set_black_card VALUES (100003, 152);
INSERT INTO card_set_black_card VALUES (100003, 153);
INSERT INTO card_set_black_card VALUES (100003, 1359);
INSERT INTO card_set_black_card VALUES (100003, 154);
INSERT INTO card_set_black_card VALUES (100003, 155);
INSERT INTO card_set_black_card VALUES (100003, 156);
INSERT INTO card_set_black_card VALUES (100003, 144);
INSERT INTO card_set_black_card VALUES (100003, 147);
INSERT INTO card_set_black_card VALUES (100003, 149);
INSERT INTO card_set_black_card VALUES (100003, 150);
INSERT INTO card_set_black_card VALUES (100003, 151);
INSERT INTO card_set_black_card VALUES (100003, 114);
INSERT INTO card_set_black_card VALUES (100003, 127);
INSERT INTO card_set_black_card VALUES (100003, 126);
INSERT INTO card_set_black_card VALUES (100003, 124);
INSERT INTO card_set_black_card VALUES (100003, 123);
INSERT INTO card_set_black_card VALUES (100003, 122);
INSERT INTO card_set_black_card VALUES (100003, 120);
INSERT INTO card_set_black_card VALUES (100017, 100006);
INSERT INTO card_set_black_card VALUES (100017, 100007);
INSERT INTO card_set_black_card VALUES (100017, 100016);
INSERT INTO card_set_black_card VALUES (100049, 100028);
INSERT INTO card_set_black_card VALUES (100049, 100027);
INSERT INTO card_set_black_card VALUES (100050, 100037);
INSERT INTO card_set_black_card VALUES (100050, 100038);
INSERT INTO card_set_black_card VALUES (100051, 100047);
INSERT INTO card_set_black_card VALUES (100051, 100048);
INSERT INTO card_set_black_card VALUES (100154, 100089);
INSERT INTO card_set_black_card VALUES (100154, 100095);
INSERT INTO card_set_black_card VALUES (100154, 100094);
INSERT INTO card_set_black_card VALUES (100154, 100093);
INSERT INTO card_set_black_card VALUES (100154, 100092);
INSERT INTO card_set_black_card VALUES (100154, 100085);
INSERT INTO card_set_black_card VALUES (100154, 100074);
INSERT INTO card_set_black_card VALUES (100154, 100078);
INSERT INTO card_set_black_card VALUES (100154, 100066);
INSERT INTO card_set_black_card VALUES (100154, 100065);
INSERT INTO card_set_black_card VALUES (100154, 100070);
INSERT INTO card_set_black_card VALUES (100154, 100103);
INSERT INTO card_set_black_card VALUES (100154, 100059);
INSERT INTO card_set_black_card VALUES (100154, 100058);
INSERT INTO card_set_black_card VALUES (100154, 100100);
INSERT INTO card_set_black_card VALUES (100154, 100098);
INSERT INTO card_set_black_card VALUES (100154, 100097);
INSERT INTO card_set_black_card VALUES (100154, 100096);
INSERT INTO card_set_black_card VALUES (100154, 100110);
INSERT INTO card_set_black_card VALUES (100154, 100108);
INSERT INTO card_set_black_card VALUES (100154, 100106);
INSERT INTO card_set_black_card VALUES (100154, 100105);
INSERT INTO card_set_black_card VALUES (100154, 100054);
INSERT INTO card_set_black_card VALUES (100154, 100104);
INSERT INTO card_set_black_card VALUES (100154, 100113);
INSERT INTO card_set_black_card VALUES (100017, 100155);
INSERT INTO card_set_black_card VALUES (100003, 100016);
INSERT INTO card_set_black_card VALUES (100003, 100155);
INSERT INTO card_set_black_card VALUES (100003, 100006);
INSERT INTO card_set_black_card VALUES (100157, 158);
INSERT INTO card_set_black_card VALUES (100157, 159);
INSERT INTO card_set_black_card VALUES (100157, 171);
INSERT INTO card_set_black_card VALUES (100157, 170);
INSERT INTO card_set_black_card VALUES (100157, 169);
INSERT INTO card_set_black_card VALUES (100157, 168);
INSERT INTO card_set_black_card VALUES (100157, 175);
INSERT INTO card_set_black_card VALUES (100157, 174);
INSERT INTO card_set_black_card VALUES (100157, 173);
INSERT INTO card_set_black_card VALUES (100157, 172);
INSERT INTO card_set_black_card VALUES (100157, 163);
INSERT INTO card_set_black_card VALUES (100157, 162);
INSERT INTO card_set_black_card VALUES (100157, 161);
INSERT INTO card_set_black_card VALUES (100157, 160);
INSERT INTO card_set_black_card VALUES (100157, 167);
INSERT INTO card_set_black_card VALUES (100157, 166);
INSERT INTO card_set_black_card VALUES (100157, 165);
INSERT INTO card_set_black_card VALUES (100157, 164);
INSERT INTO card_set_black_card VALUES (100157, 186);
INSERT INTO card_set_black_card VALUES (100157, 187);
INSERT INTO card_set_black_card VALUES (100157, 184);
INSERT INTO card_set_black_card VALUES (100157, 185);
INSERT INTO card_set_black_card VALUES (100157, 190);
INSERT INTO card_set_black_card VALUES (100157, 191);
INSERT INTO card_set_black_card VALUES (100157, 188);
INSERT INTO card_set_black_card VALUES (100157, 189);
INSERT INTO card_set_black_card VALUES (100157, 178);
INSERT INTO card_set_black_card VALUES (100157, 179);
INSERT INTO card_set_black_card VALUES (100157, 176);
INSERT INTO card_set_black_card VALUES (100157, 177);
INSERT INTO card_set_black_card VALUES (100157, 182);
INSERT INTO card_set_black_card VALUES (100157, 183);
INSERT INTO card_set_black_card VALUES (100157, 180);
INSERT INTO card_set_black_card VALUES (100157, 181);
INSERT INTO card_set_black_card VALUES (100157, 205);
INSERT INTO card_set_black_card VALUES (100157, 204);
INSERT INTO card_set_black_card VALUES (100157, 207);
INSERT INTO card_set_black_card VALUES (100157, 206);
INSERT INTO card_set_black_card VALUES (100157, 201);
INSERT INTO card_set_black_card VALUES (100157, 200);
INSERT INTO card_set_black_card VALUES (100157, 203);
INSERT INTO card_set_black_card VALUES (100157, 202);
INSERT INTO card_set_black_card VALUES (100157, 197);
INSERT INTO card_set_black_card VALUES (100157, 196);
INSERT INTO card_set_black_card VALUES (100157, 199);
INSERT INTO card_set_black_card VALUES (100157, 198);
INSERT INTO card_set_black_card VALUES (100157, 193);
INSERT INTO card_set_black_card VALUES (100157, 192);
INSERT INTO card_set_black_card VALUES (100157, 195);
INSERT INTO card_set_black_card VALUES (100157, 194);
INSERT INTO card_set_black_card VALUES (100157, 220);
INSERT INTO card_set_black_card VALUES (100157, 221);
INSERT INTO card_set_black_card VALUES (100157, 222);
INSERT INTO card_set_black_card VALUES (100157, 223);
INSERT INTO card_set_black_card VALUES (100157, 216);
INSERT INTO card_set_black_card VALUES (100157, 217);
INSERT INTO card_set_black_card VALUES (100157, 218);
INSERT INTO card_set_black_card VALUES (100157, 219);
INSERT INTO card_set_black_card VALUES (100157, 212);
INSERT INTO card_set_black_card VALUES (100157, 213);
INSERT INTO card_set_black_card VALUES (100157, 214);
INSERT INTO card_set_black_card VALUES (100157, 215);
INSERT INTO card_set_black_card VALUES (100157, 208);
INSERT INTO card_set_black_card VALUES (100157, 210);
INSERT INTO card_set_black_card VALUES (100157, 211);
INSERT INTO card_set_black_card VALUES (100157, 225);
INSERT INTO card_set_black_card VALUES (100157, 224);
INSERT INTO card_set_black_card VALUES (100003, 202);
INSERT INTO card_set_black_card VALUES (100003, 192);
INSERT INTO card_set_black_card VALUES (100003, 162);
INSERT INTO card_set_black_card VALUES (100003, 165);
INSERT INTO card_set_black_card VALUES (100017, 100159);
INSERT INTO card_set_black_card VALUES (100160, 548);
INSERT INTO card_set_black_card VALUES (100160, 549);
INSERT INTO card_set_black_card VALUES (100160, 546);
INSERT INTO card_set_black_card VALUES (100160, 547);
INSERT INTO card_set_black_card VALUES (100160, 544);
INSERT INTO card_set_black_card VALUES (100160, 545);
INSERT INTO card_set_black_card VALUES (100160, 508);
INSERT INTO card_set_black_card VALUES (100160, 516);
INSERT INTO card_set_black_card VALUES (100160, 509);
INSERT INTO card_set_black_card VALUES (100160, 517);
INSERT INTO card_set_black_card VALUES (100160, 510);
INSERT INTO card_set_black_card VALUES (100160, 518);
INSERT INTO card_set_black_card VALUES (100160, 511);
INSERT INTO card_set_black_card VALUES (100160, 519);
INSERT INTO card_set_black_card VALUES (100160, 512);
INSERT INTO card_set_black_card VALUES (100160, 504);
INSERT INTO card_set_black_card VALUES (100160, 513);
INSERT INTO card_set_black_card VALUES (100160, 505);
INSERT INTO card_set_black_card VALUES (100160, 514);
INSERT INTO card_set_black_card VALUES (100160, 506);
INSERT INTO card_set_black_card VALUES (100160, 515);
INSERT INTO card_set_black_card VALUES (100160, 507);
INSERT INTO card_set_black_card VALUES (100160, 524);
INSERT INTO card_set_black_card VALUES (100160, 525);
INSERT INTO card_set_black_card VALUES (100160, 526);
INSERT INTO card_set_black_card VALUES (100160, 527);
INSERT INTO card_set_black_card VALUES (100160, 520);
INSERT INTO card_set_black_card VALUES (100160, 226);
INSERT INTO card_set_black_card VALUES (100160, 521);
INSERT INTO card_set_black_card VALUES (100160, 522);
INSERT INTO card_set_black_card VALUES (100160, 523);
INSERT INTO card_set_black_card VALUES (100160, 533);
INSERT INTO card_set_black_card VALUES (100160, 532);
INSERT INTO card_set_black_card VALUES (100160, 535);
INSERT INTO card_set_black_card VALUES (100160, 534);
INSERT INTO card_set_black_card VALUES (100160, 529);
INSERT INTO card_set_black_card VALUES (100160, 528);
INSERT INTO card_set_black_card VALUES (100160, 531);
INSERT INTO card_set_black_card VALUES (100160, 530);
INSERT INTO card_set_black_card VALUES (100160, 541);
INSERT INTO card_set_black_card VALUES (100160, 540);
INSERT INTO card_set_black_card VALUES (100160, 543);
INSERT INTO card_set_black_card VALUES (100160, 542);
INSERT INTO card_set_black_card VALUES (100160, 537);
INSERT INTO card_set_black_card VALUES (100160, 536);
INSERT INTO card_set_black_card VALUES (100160, 539);
INSERT INTO card_set_black_card VALUES (100160, 538);
INSERT INTO card_set_black_card VALUES (100003, 168);
INSERT INTO card_set_black_card VALUES (100003, 175);
INSERT INTO card_set_black_card VALUES (100003, 513);
INSERT INTO card_set_black_card VALUES (100003, 514);
INSERT INTO card_set_black_card VALUES (100003, 525);
INSERT INTO card_set_black_card VALUES (100003, 520);
INSERT INTO card_set_black_card VALUES (100003, 521);
INSERT INTO card_set_black_card VALUES (100003, 522);
INSERT INTO card_set_black_card VALUES (100003, 528);
INSERT INTO card_set_black_card VALUES (100003, 537);
INSERT INTO card_set_black_card VALUES (100003, 536);
INSERT INTO card_set_black_card VALUES (100003, 194);
INSERT INTO card_set_black_card VALUES (100003, 214);
INSERT INTO card_set_black_card VALUES (100003, 510);
INSERT INTO card_set_black_card VALUES (100003, 504);
INSERT INTO card_set_black_card VALUES (100003, 226);
INSERT INTO card_set_black_card VALUES (100003, 225);
INSERT INTO card_set_black_card VALUES (100003, 224);
INSERT INTO card_set_black_card VALUES (100161, 687);
INSERT INTO card_set_black_card VALUES (100161, 686);
INSERT INTO card_set_black_card VALUES (100161, 685);
INSERT INTO card_set_black_card VALUES (100161, 684);
INSERT INTO card_set_black_card VALUES (100161, 683);
INSERT INTO card_set_black_card VALUES (100161, 682);
INSERT INTO card_set_black_card VALUES (100161, 681);
INSERT INTO card_set_black_card VALUES (100161, 680);
INSERT INTO card_set_black_card VALUES (100161, 679);
INSERT INTO card_set_black_card VALUES (100161, 678);
INSERT INTO card_set_black_card VALUES (100161, 677);
INSERT INTO card_set_black_card VALUES (100161, 676);
INSERT INTO card_set_black_card VALUES (100161, 675);
INSERT INTO card_set_black_card VALUES (100161, 674);
INSERT INTO card_set_black_card VALUES (100161, 673);
INSERT INTO card_set_black_card VALUES (100161, 672);
INSERT INTO card_set_black_card VALUES (100161, 702);
INSERT INTO card_set_black_card VALUES (100161, 703);
INSERT INTO card_set_black_card VALUES (100161, 700);
INSERT INTO card_set_black_card VALUES (100161, 701);
INSERT INTO card_set_black_card VALUES (100161, 698);
INSERT INTO card_set_black_card VALUES (100161, 699);
INSERT INTO card_set_black_card VALUES (100161, 696);
INSERT INTO card_set_black_card VALUES (100161, 697);
INSERT INTO card_set_black_card VALUES (100161, 694);
INSERT INTO card_set_black_card VALUES (100161, 695);
INSERT INTO card_set_black_card VALUES (100161, 692);
INSERT INTO card_set_black_card VALUES (100161, 693);
INSERT INTO card_set_black_card VALUES (100161, 690);
INSERT INTO card_set_black_card VALUES (100161, 691);
INSERT INTO card_set_black_card VALUES (100161, 688);
INSERT INTO card_set_black_card VALUES (100161, 689);
INSERT INTO card_set_black_card VALUES (100161, 653);
INSERT INTO card_set_black_card VALUES (100161, 655);
INSERT INTO card_set_black_card VALUES (100161, 654);
INSERT INTO card_set_black_card VALUES (100161, 668);
INSERT INTO card_set_black_card VALUES (100161, 669);
INSERT INTO card_set_black_card VALUES (100161, 670);
INSERT INTO card_set_black_card VALUES (100161, 671);
INSERT INTO card_set_black_card VALUES (100161, 664);
INSERT INTO card_set_black_card VALUES (100161, 665);
INSERT INTO card_set_black_card VALUES (100161, 666);
INSERT INTO card_set_black_card VALUES (100161, 667);
INSERT INTO card_set_black_card VALUES (100161, 660);
INSERT INTO card_set_black_card VALUES (100161, 661);
INSERT INTO card_set_black_card VALUES (100161, 662);
INSERT INTO card_set_black_card VALUES (100161, 663);
INSERT INTO card_set_black_card VALUES (100161, 656);
INSERT INTO card_set_black_card VALUES (100161, 657);
INSERT INTO card_set_black_card VALUES (100161, 658);
INSERT INTO card_set_black_card VALUES (100161, 659);
INSERT INTO card_set_black_card VALUES (100161, 747);
INSERT INTO card_set_black_card VALUES (100161, 746);
INSERT INTO card_set_black_card VALUES (100161, 745);
INSERT INTO card_set_black_card VALUES (100161, 744);
INSERT INTO card_set_black_card VALUES (100161, 751);
INSERT INTO card_set_black_card VALUES (100161, 750);
INSERT INTO card_set_black_card VALUES (100161, 749);
INSERT INTO card_set_black_card VALUES (100161, 748);
INSERT INTO card_set_black_card VALUES (100161, 739);
INSERT INTO card_set_black_card VALUES (100161, 738);
INSERT INTO card_set_black_card VALUES (100161, 737);
INSERT INTO card_set_black_card VALUES (100161, 736);
INSERT INTO card_set_black_card VALUES (100161, 743);
INSERT INTO card_set_black_card VALUES (100161, 742);
INSERT INTO card_set_black_card VALUES (100161, 741);
INSERT INTO card_set_black_card VALUES (100161, 740);
INSERT INTO card_set_black_card VALUES (100161, 754);
INSERT INTO card_set_black_card VALUES (100161, 755);
INSERT INTO card_set_black_card VALUES (100161, 752);
INSERT INTO card_set_black_card VALUES (100161, 753);
INSERT INTO card_set_black_card VALUES (100161, 713);
INSERT INTO card_set_black_card VALUES (100161, 712);
INSERT INTO card_set_black_card VALUES (100161, 715);
INSERT INTO card_set_black_card VALUES (100161, 714);
INSERT INTO card_set_black_card VALUES (100161, 717);
INSERT INTO card_set_black_card VALUES (100161, 716);
INSERT INTO card_set_black_card VALUES (100161, 719);
INSERT INTO card_set_black_card VALUES (100161, 718);
INSERT INTO card_set_black_card VALUES (100161, 705);
INSERT INTO card_set_black_card VALUES (100161, 704);
INSERT INTO card_set_black_card VALUES (100161, 707);
INSERT INTO card_set_black_card VALUES (100161, 706);
INSERT INTO card_set_black_card VALUES (100161, 709);
INSERT INTO card_set_black_card VALUES (100161, 708);
INSERT INTO card_set_black_card VALUES (100161, 711);
INSERT INTO card_set_black_card VALUES (100161, 710);
INSERT INTO card_set_black_card VALUES (100161, 728);
INSERT INTO card_set_black_card VALUES (100161, 729);
INSERT INTO card_set_black_card VALUES (100161, 730);
INSERT INTO card_set_black_card VALUES (100161, 731);
INSERT INTO card_set_black_card VALUES (100161, 732);
INSERT INTO card_set_black_card VALUES (100161, 733);
INSERT INTO card_set_black_card VALUES (100161, 734);
INSERT INTO card_set_black_card VALUES (100161, 735);
INSERT INTO card_set_black_card VALUES (100161, 720);
INSERT INTO card_set_black_card VALUES (100161, 721);
INSERT INTO card_set_black_card VALUES (100161, 722);
INSERT INTO card_set_black_card VALUES (100161, 723);
INSERT INTO card_set_black_card VALUES (100161, 724);
INSERT INTO card_set_black_card VALUES (100161, 725);
INSERT INTO card_set_black_card VALUES (100161, 726);
INSERT INTO card_set_black_card VALUES (100161, 727);
INSERT INTO card_set_black_card VALUES (100003, 687);
INSERT INTO card_set_black_card VALUES (100003, 685);
INSERT INTO card_set_black_card VALUES (100003, 678);
INSERT INTO card_set_black_card VALUES (100003, 692);
INSERT INTO card_set_black_card VALUES (100003, 660);
INSERT INTO card_set_black_card VALUES (100003, 747);
INSERT INTO card_set_black_card VALUES (100003, 712);
INSERT INTO card_set_black_card VALUES (100003, 715);
INSERT INTO card_set_black_card VALUES (100161, 756);
INSERT INTO card_set_black_card VALUES (100017, 100163);
INSERT INTO card_set_black_card VALUES (100003, 508);
INSERT INTO card_set_black_card VALUES (100017, 100203);
INSERT INTO card_set_black_card VALUES (100211, 100208);
INSERT INTO card_set_black_card VALUES (100211, 100209);
INSERT INTO card_set_black_card VALUES (100211, 100210);
INSERT INTO card_set_black_card VALUES (100211, 100207);
INSERT INTO card_set_black_card VALUES (100211, 100206);
INSERT INTO card_set_black_card VALUES (100211, 1);
INSERT INTO card_set_black_card VALUES (100211, 2);
INSERT INTO card_set_black_card VALUES (100211, 3);
INSERT INTO card_set_black_card VALUES (100211, 4);
INSERT INTO card_set_black_card VALUES (100211, 6);
INSERT INTO card_set_black_card VALUES (100211, 7);
INSERT INTO card_set_black_card VALUES (100211, 8);
INSERT INTO card_set_black_card VALUES (100211, 9);
INSERT INTO card_set_black_card VALUES (100211, 78);
INSERT INTO card_set_black_card VALUES (100211, 10);
INSERT INTO card_set_black_card VALUES (100211, 79);
INSERT INTO card_set_black_card VALUES (100211, 11);
INSERT INTO card_set_black_card VALUES (100211, 12);
INSERT INTO card_set_black_card VALUES (100211, 14);
INSERT INTO card_set_black_card VALUES (100211, 15);
INSERT INTO card_set_black_card VALUES (100211, 17);
INSERT INTO card_set_black_card VALUES (100211, 19);
INSERT INTO card_set_black_card VALUES (100211, 81);
INSERT INTO card_set_black_card VALUES (100211, 21);
INSERT INTO card_set_black_card VALUES (100211, 80);
INSERT INTO card_set_black_card VALUES (100211, 20);
INSERT INTO card_set_black_card VALUES (100211, 82);
INSERT INTO card_set_black_card VALUES (100211, 22);
INSERT INTO card_set_black_card VALUES (100211, 93);
INSERT INTO card_set_black_card VALUES (100211, 25);
INSERT INTO card_set_black_card VALUES (100211, 92);
INSERT INTO card_set_black_card VALUES (100211, 24);
INSERT INTO card_set_black_card VALUES (100211, 29);
INSERT INTO card_set_black_card VALUES (100211, 28);
INSERT INTO card_set_black_card VALUES (100211, 91);
INSERT INTO card_set_black_card VALUES (100211, 31);
INSERT INTO card_set_black_card VALUES (100211, 30);
INSERT INTO card_set_black_card VALUES (100211, 34);
INSERT INTO card_set_black_card VALUES (100211, 35);
INSERT INTO card_set_black_card VALUES (100211, 32);
INSERT INTO card_set_black_card VALUES (100211, 33);
INSERT INTO card_set_black_card VALUES (100211, 38);
INSERT INTO card_set_black_card VALUES (100211, 39);
INSERT INTO card_set_black_card VALUES (100211, 36);
INSERT INTO card_set_black_card VALUES (100211, 42);
INSERT INTO card_set_black_card VALUES (100211, 43);
INSERT INTO card_set_black_card VALUES (100211, 40);
INSERT INTO card_set_black_card VALUES (100211, 41);
INSERT INTO card_set_black_card VALUES (100211, 46);
INSERT INTO card_set_black_card VALUES (100211, 47);
INSERT INTO card_set_black_card VALUES (100211, 44);
INSERT INTO card_set_black_card VALUES (100211, 45);
INSERT INTO card_set_black_card VALUES (100211, 51);
INSERT INTO card_set_black_card VALUES (100211, 50);
INSERT INTO card_set_black_card VALUES (100211, 49);
INSERT INTO card_set_black_card VALUES (100211, 53);
INSERT INTO card_set_black_card VALUES (100211, 52);
INSERT INTO card_set_black_card VALUES (100211, 59);
INSERT INTO card_set_black_card VALUES (100211, 58);
INSERT INTO card_set_black_card VALUES (100211, 57);
INSERT INTO card_set_black_card VALUES (100211, 56);
INSERT INTO card_set_black_card VALUES (100211, 63);
INSERT INTO card_set_black_card VALUES (100211, 62);
INSERT INTO card_set_black_card VALUES (100211, 61);
INSERT INTO card_set_black_card VALUES (100211, 60);
INSERT INTO card_set_black_card VALUES (100211, 1032);
INSERT INTO card_set_black_card VALUES (100211, 68);
INSERT INTO card_set_black_card VALUES (100211, 70);
INSERT INTO card_set_black_card VALUES (100211, 64);
INSERT INTO card_set_black_card VALUES (100211, 66);
INSERT INTO card_set_black_card VALUES (100211, 67);
INSERT INTO card_set_black_card VALUES (100211, 76);
INSERT INTO card_set_black_card VALUES (100211, 77);
INSERT INTO card_set_black_card VALUES (100211, 72);
INSERT INTO card_set_black_card VALUES (100211, 73);
INSERT INTO card_set_black_card VALUES (100211, 74);
INSERT INTO card_set_black_card VALUES (100211, 75);
INSERT INTO card_set_black_card VALUES (100211, 85);
INSERT INTO card_set_black_card VALUES (100211, 84);
INSERT INTO card_set_black_card VALUES (100211, 87);
INSERT INTO card_set_black_card VALUES (100211, 86);
INSERT INTO card_set_black_card VALUES (100211, 95);
INSERT INTO card_set_black_card VALUES (100211, 94);
INSERT INTO card_set_black_card VALUES (100211, 89);
INSERT INTO card_set_black_card VALUES (100211, 88);
INSERT INTO card_set_black_card VALUES (100211, 90);
INSERT INTO card_set_black_card VALUES (100211, 98);
INSERT INTO card_set_black_card VALUES (100211, 96);
INSERT INTO card_set_black_card VALUES (100211, 97);
INSERT INTO card_set_black_card VALUES (100211, 100217);
INSERT INTO card_set_black_card VALUES (100161, 100218);
INSERT INTO card_set_black_card VALUES (100161, 784);
INSERT INTO card_set_black_card VALUES (100161, 774);
INSERT INTO card_set_black_card VALUES (100161, 775);
INSERT INTO card_set_black_card VALUES (100161, 772);
INSERT INTO card_set_black_card VALUES (100161, 773);
INSERT INTO card_set_black_card VALUES (100161, 771);
INSERT INTO card_set_black_card VALUES (100161, 782);
INSERT INTO card_set_black_card VALUES (100161, 783);
INSERT INTO card_set_black_card VALUES (100161, 780);
INSERT INTO card_set_black_card VALUES (100161, 781);
INSERT INTO card_set_black_card VALUES (100161, 778);
INSERT INTO card_set_black_card VALUES (100161, 779);
INSERT INTO card_set_black_card VALUES (100161, 776);
INSERT INTO card_set_black_card VALUES (100161, 777);
INSERT INTO card_set_black_card VALUES (100219, 791);
INSERT INTO card_set_black_card VALUES (100219, 790);
INSERT INTO card_set_black_card VALUES (100219, 789);
INSERT INTO card_set_black_card VALUES (100219, 788);
INSERT INTO card_set_black_card VALUES (100219, 787);
INSERT INTO card_set_black_card VALUES (100219, 786);
INSERT INTO card_set_black_card VALUES (100219, 785);
INSERT INTO card_set_black_card VALUES (100219, 799);
INSERT INTO card_set_black_card VALUES (100219, 798);
INSERT INTO card_set_black_card VALUES (100219, 797);
INSERT INTO card_set_black_card VALUES (100219, 796);
INSERT INTO card_set_black_card VALUES (100219, 795);
INSERT INTO card_set_black_card VALUES (100219, 794);
INSERT INTO card_set_black_card VALUES (100219, 793);
INSERT INTO card_set_black_card VALUES (100219, 792);
INSERT INTO card_set_black_card VALUES (100219, 800);
INSERT INTO card_set_black_card VALUES (100219, 801);
INSERT INTO card_set_black_card VALUES (100219, 802);
INSERT INTO card_set_black_card VALUES (100003, 800);
INSERT INTO card_set_black_card VALUES (100003, 792);
INSERT INTO card_set_black_card VALUES (100017, 100223);
INSERT INTO card_set_black_card VALUES (100224, 821);
INSERT INTO card_set_black_card VALUES (100224, 820);
INSERT INTO card_set_black_card VALUES (100224, 823);
INSERT INTO card_set_black_card VALUES (100224, 822);
INSERT INTO card_set_black_card VALUES (100224, 817);
INSERT INTO card_set_black_card VALUES (100224, 816);
INSERT INTO card_set_black_card VALUES (100224, 819);
INSERT INTO card_set_black_card VALUES (100224, 818);
INSERT INTO card_set_black_card VALUES (100224, 829);
INSERT INTO card_set_black_card VALUES (100224, 828);
INSERT INTO card_set_black_card VALUES (100224, 831);
INSERT INTO card_set_black_card VALUES (100224, 830);
INSERT INTO card_set_black_card VALUES (100224, 825);
INSERT INTO card_set_black_card VALUES (100224, 824);
INSERT INTO card_set_black_card VALUES (100224, 827);
INSERT INTO card_set_black_card VALUES (100224, 826);
INSERT INTO card_set_black_card VALUES (100224, 804);
INSERT INTO card_set_black_card VALUES (100224, 805);
INSERT INTO card_set_black_card VALUES (100224, 806);
INSERT INTO card_set_black_card VALUES (100224, 807);
INSERT INTO card_set_black_card VALUES (100224, 803);
INSERT INTO card_set_black_card VALUES (100224, 812);
INSERT INTO card_set_black_card VALUES (100224, 813);
INSERT INTO card_set_black_card VALUES (100224, 814);
INSERT INTO card_set_black_card VALUES (100224, 815);
INSERT INTO card_set_black_card VALUES (100224, 808);
INSERT INTO card_set_black_card VALUES (100224, 809);
INSERT INTO card_set_black_card VALUES (100224, 810);
INSERT INTO card_set_black_card VALUES (100224, 811);
INSERT INTO card_set_black_card VALUES (100224, 881);
INSERT INTO card_set_black_card VALUES (100224, 880);
INSERT INTO card_set_black_card VALUES (100224, 883);
INSERT INTO card_set_black_card VALUES (100224, 882);
INSERT INTO card_set_black_card VALUES (100224, 885);
INSERT INTO card_set_black_card VALUES (100224, 884);
INSERT INTO card_set_black_card VALUES (100224, 887);
INSERT INTO card_set_black_card VALUES (100224, 886);
INSERT INTO card_set_black_card VALUES (100224, 889);
INSERT INTO card_set_black_card VALUES (100224, 888);
INSERT INTO card_set_black_card VALUES (100224, 891);
INSERT INTO card_set_black_card VALUES (100224, 890);
INSERT INTO card_set_black_card VALUES (100224, 893);
INSERT INTO card_set_black_card VALUES (100224, 892);
INSERT INTO card_set_black_card VALUES (100224, 895);
INSERT INTO card_set_black_card VALUES (100224, 894);
INSERT INTO card_set_black_card VALUES (100224, 864);
INSERT INTO card_set_black_card VALUES (100224, 865);
INSERT INTO card_set_black_card VALUES (100224, 866);
INSERT INTO card_set_black_card VALUES (100224, 867);
INSERT INTO card_set_black_card VALUES (100224, 868);
INSERT INTO card_set_black_card VALUES (100224, 869);
INSERT INTO card_set_black_card VALUES (100224, 870);
INSERT INTO card_set_black_card VALUES (100224, 871);
INSERT INTO card_set_black_card VALUES (100224, 872);
INSERT INTO card_set_black_card VALUES (100224, 873);
INSERT INTO card_set_black_card VALUES (100224, 874);
INSERT INTO card_set_black_card VALUES (100224, 875);
INSERT INTO card_set_black_card VALUES (100224, 876);
INSERT INTO card_set_black_card VALUES (100224, 877);
INSERT INTO card_set_black_card VALUES (100224, 878);
INSERT INTO card_set_black_card VALUES (100224, 879);
INSERT INTO card_set_black_card VALUES (100224, 851);
INSERT INTO card_set_black_card VALUES (100224, 850);
INSERT INTO card_set_black_card VALUES (100224, 849);
INSERT INTO card_set_black_card VALUES (100224, 848);
INSERT INTO card_set_black_card VALUES (100224, 855);
INSERT INTO card_set_black_card VALUES (100224, 854);
INSERT INTO card_set_black_card VALUES (100224, 853);
INSERT INTO card_set_black_card VALUES (100224, 852);
INSERT INTO card_set_black_card VALUES (100224, 859);
INSERT INTO card_set_black_card VALUES (100224, 858);
INSERT INTO card_set_black_card VALUES (100224, 857);
INSERT INTO card_set_black_card VALUES (100224, 856);
INSERT INTO card_set_black_card VALUES (100224, 863);
INSERT INTO card_set_black_card VALUES (100224, 862);
INSERT INTO card_set_black_card VALUES (100224, 861);
INSERT INTO card_set_black_card VALUES (100224, 860);
INSERT INTO card_set_black_card VALUES (100224, 834);
INSERT INTO card_set_black_card VALUES (100224, 835);
INSERT INTO card_set_black_card VALUES (100224, 832);
INSERT INTO card_set_black_card VALUES (100224, 833);
INSERT INTO card_set_black_card VALUES (100224, 838);
INSERT INTO card_set_black_card VALUES (100224, 839);
INSERT INTO card_set_black_card VALUES (100224, 836);
INSERT INTO card_set_black_card VALUES (100224, 837);
INSERT INTO card_set_black_card VALUES (100224, 842);
INSERT INTO card_set_black_card VALUES (100224, 843);
INSERT INTO card_set_black_card VALUES (100224, 840);
INSERT INTO card_set_black_card VALUES (100224, 841);
INSERT INTO card_set_black_card VALUES (100224, 846);
INSERT INTO card_set_black_card VALUES (100224, 847);
INSERT INTO card_set_black_card VALUES (100224, 844);
INSERT INTO card_set_black_card VALUES (100224, 845);
INSERT INTO card_set_black_card VALUES (100224, 926);
INSERT INTO card_set_black_card VALUES (100224, 924);
INSERT INTO card_set_black_card VALUES (100224, 925);
INSERT INTO card_set_black_card VALUES (100224, 922);
INSERT INTO card_set_black_card VALUES (100224, 923);
INSERT INTO card_set_black_card VALUES (100224, 918);
INSERT INTO card_set_black_card VALUES (100224, 919);
INSERT INTO card_set_black_card VALUES (100224, 916);
INSERT INTO card_set_black_card VALUES (100224, 917);
INSERT INTO card_set_black_card VALUES (100224, 914);
INSERT INTO card_set_black_card VALUES (100224, 915);
INSERT INTO card_set_black_card VALUES (100224, 912);
INSERT INTO card_set_black_card VALUES (100224, 913);
INSERT INTO card_set_black_card VALUES (100224, 911);
INSERT INTO card_set_black_card VALUES (100224, 910);
INSERT INTO card_set_black_card VALUES (100224, 909);
INSERT INTO card_set_black_card VALUES (100224, 908);
INSERT INTO card_set_black_card VALUES (100224, 907);
INSERT INTO card_set_black_card VALUES (100224, 906);
INSERT INTO card_set_black_card VALUES (100224, 905);
INSERT INTO card_set_black_card VALUES (100224, 904);
INSERT INTO card_set_black_card VALUES (100224, 903);
INSERT INTO card_set_black_card VALUES (100224, 902);
INSERT INTO card_set_black_card VALUES (100224, 901);
INSERT INTO card_set_black_card VALUES (100224, 900);
INSERT INTO card_set_black_card VALUES (100224, 899);
INSERT INTO card_set_black_card VALUES (100224, 898);
INSERT INTO card_set_black_card VALUES (100224, 897);
INSERT INTO card_set_black_card VALUES (100224, 896);
INSERT INTO card_set_black_card VALUES (100225, 956);
INSERT INTO card_set_black_card VALUES (100225, 957);
INSERT INTO card_set_black_card VALUES (100225, 958);
INSERT INTO card_set_black_card VALUES (100225, 959);
INSERT INTO card_set_black_card VALUES (100225, 952);
INSERT INTO card_set_black_card VALUES (100225, 953);
INSERT INTO card_set_black_card VALUES (100225, 954);
INSERT INTO card_set_black_card VALUES (100225, 955);
INSERT INTO card_set_black_card VALUES (100225, 948);
INSERT INTO card_set_black_card VALUES (100225, 949);
INSERT INTO card_set_black_card VALUES (100225, 950);
INSERT INTO card_set_black_card VALUES (100225, 951);
INSERT INTO card_set_black_card VALUES (100225, 944);
INSERT INTO card_set_black_card VALUES (100225, 945);
INSERT INTO card_set_black_card VALUES (100225, 946);
INSERT INTO card_set_black_card VALUES (100225, 947);
INSERT INTO card_set_black_card VALUES (100225, 941);
INSERT INTO card_set_black_card VALUES (100225, 940);
INSERT INTO card_set_black_card VALUES (100225, 943);
INSERT INTO card_set_black_card VALUES (100225, 942);
INSERT INTO card_set_black_card VALUES (100225, 937);
INSERT INTO card_set_black_card VALUES (100225, 936);
INSERT INTO card_set_black_card VALUES (100225, 939);
INSERT INTO card_set_black_card VALUES (100225, 938);
INSERT INTO card_set_black_card VALUES (100225, 933);
INSERT INTO card_set_black_card VALUES (100225, 932);
INSERT INTO card_set_black_card VALUES (100225, 935);
INSERT INTO card_set_black_card VALUES (100225, 934);
INSERT INTO card_set_black_card VALUES (100225, 929);
INSERT INTO card_set_black_card VALUES (100225, 928);
INSERT INTO card_set_black_card VALUES (100225, 931);
INSERT INTO card_set_black_card VALUES (100225, 930);
INSERT INTO card_set_black_card VALUES (100225, 927);
INSERT INTO card_set_black_card VALUES (100225, 963);
INSERT INTO card_set_black_card VALUES (100225, 960);
INSERT INTO card_set_black_card VALUES (100225, 100226);
INSERT INTO card_set_black_card VALUES (100225, 100227);
INSERT INTO card_set_black_card VALUES (100003, 821);
INSERT INTO card_set_black_card VALUES (100003, 820);
INSERT INTO card_set_black_card VALUES (100003, 823);
INSERT INTO card_set_black_card VALUES (100003, 824);
INSERT INTO card_set_black_card VALUES (100003, 803);
INSERT INTO card_set_black_card VALUES (100003, 814);
INSERT INTO card_set_black_card VALUES (100003, 815);
INSERT INTO card_set_black_card VALUES (100003, 889);
INSERT INTO card_set_black_card VALUES (100003, 890);
INSERT INTO card_set_black_card VALUES (100003, 873);
INSERT INTO card_set_black_card VALUES (100003, 875);
INSERT INTO card_set_black_card VALUES (100003, 848);
INSERT INTO card_set_black_card VALUES (100003, 855);
INSERT INTO card_set_black_card VALUES (100003, 852);
INSERT INTO card_set_black_card VALUES (100003, 838);
INSERT INTO card_set_black_card VALUES (100003, 843);
INSERT INTO card_set_black_card VALUES (100003, 846);
INSERT INTO card_set_black_card VALUES (100003, 957);
INSERT INTO card_set_black_card VALUES (100003, 958);
INSERT INTO card_set_black_card VALUES (100003, 959);
INSERT INTO card_set_black_card VALUES (100003, 954);
INSERT INTO card_set_black_card VALUES (100003, 949);
INSERT INTO card_set_black_card VALUES (100003, 950);
INSERT INTO card_set_black_card VALUES (100003, 944);
INSERT INTO card_set_black_card VALUES (100003, 946);
INSERT INTO card_set_black_card VALUES (100003, 943);
INSERT INTO card_set_black_card VALUES (100003, 942);
INSERT INTO card_set_black_card VALUES (100003, 936);
INSERT INTO card_set_black_card VALUES (100003, 939);
INSERT INTO card_set_black_card VALUES (100003, 935);
INSERT INTO card_set_black_card VALUES (100003, 929);
INSERT INTO card_set_black_card VALUES (100003, 925);
INSERT INTO card_set_black_card VALUES (100003, 906);
INSERT INTO card_set_black_card VALUES (100003, 902);
INSERT INTO card_set_black_card VALUES (100003, 901);
INSERT INTO card_set_black_card VALUES (100003, 962);
INSERT INTO card_set_black_card VALUES (100003, 961);
INSERT INTO card_set_black_card VALUES (100228, 5023);
INSERT INTO card_set_black_card VALUES (100228, 5022);
INSERT INTO card_set_black_card VALUES (100228, 5021);
INSERT INTO card_set_black_card VALUES (100228, 5020);
INSERT INTO card_set_black_card VALUES (100228, 5019);
INSERT INTO card_set_black_card VALUES (100228, 5018);
INSERT INTO card_set_black_card VALUES (100228, 5017);
INSERT INTO card_set_black_card VALUES (100228, 5016);
INSERT INTO card_set_black_card VALUES (100228, 5015);
INSERT INTO card_set_black_card VALUES (100228, 5014);
INSERT INTO card_set_black_card VALUES (100228, 5013);
INSERT INTO card_set_black_card VALUES (100228, 5012);
INSERT INTO card_set_black_card VALUES (100228, 5011);
INSERT INTO card_set_black_card VALUES (100228, 5010);
INSERT INTO card_set_black_card VALUES (100228, 5009);
INSERT INTO card_set_black_card VALUES (100228, 5008);
INSERT INTO card_set_black_card VALUES (100228, 5006);
INSERT INTO card_set_black_card VALUES (100228, 5007);
INSERT INTO card_set_black_card VALUES (100228, 5004);
INSERT INTO card_set_black_card VALUES (100228, 5005);
INSERT INTO card_set_black_card VALUES (100228, 5002);
INSERT INTO card_set_black_card VALUES (100228, 5003);
INSERT INTO card_set_black_card VALUES (100228, 5001);
INSERT INTO card_set_black_card VALUES (100228, 5053);
INSERT INTO card_set_black_card VALUES (100228, 5052);
INSERT INTO card_set_black_card VALUES (100228, 5055);
INSERT INTO card_set_black_card VALUES (100228, 5054);
INSERT INTO card_set_black_card VALUES (100228, 5049);
INSERT INTO card_set_black_card VALUES (100228, 5048);
INSERT INTO card_set_black_card VALUES (100228, 5051);
INSERT INTO card_set_black_card VALUES (100228, 5050);
INSERT INTO card_set_black_card VALUES (100228, 5045);
INSERT INTO card_set_black_card VALUES (100228, 5044);
INSERT INTO card_set_black_card VALUES (100228, 5047);
INSERT INTO card_set_black_card VALUES (100228, 5046);
INSERT INTO card_set_black_card VALUES (100228, 5041);
INSERT INTO card_set_black_card VALUES (100228, 5040);
INSERT INTO card_set_black_card VALUES (100228, 5043);
INSERT INTO card_set_black_card VALUES (100228, 5042);
INSERT INTO card_set_black_card VALUES (100228, 5036);
INSERT INTO card_set_black_card VALUES (100228, 5037);
INSERT INTO card_set_black_card VALUES (100228, 5038);
INSERT INTO card_set_black_card VALUES (100228, 5039);
INSERT INTO card_set_black_card VALUES (100228, 5032);
INSERT INTO card_set_black_card VALUES (100228, 5033);
INSERT INTO card_set_black_card VALUES (100228, 5034);
INSERT INTO card_set_black_card VALUES (100228, 5035);
INSERT INTO card_set_black_card VALUES (100228, 5028);
INSERT INTO card_set_black_card VALUES (100228, 5029);
INSERT INTO card_set_black_card VALUES (100228, 5030);
INSERT INTO card_set_black_card VALUES (100228, 5031);
INSERT INTO card_set_black_card VALUES (100228, 5024);
INSERT INTO card_set_black_card VALUES (100228, 5025);
INSERT INTO card_set_black_card VALUES (100228, 5026);
INSERT INTO card_set_black_card VALUES (100228, 5027);
INSERT INTO card_set_black_card VALUES (100228, 5083);
INSERT INTO card_set_black_card VALUES (100228, 5082);
INSERT INTO card_set_black_card VALUES (100228, 5081);
INSERT INTO card_set_black_card VALUES (100228, 5080);
INSERT INTO card_set_black_card VALUES (100228, 5087);
INSERT INTO card_set_black_card VALUES (100228, 5086);
INSERT INTO card_set_black_card VALUES (100228, 5085);
INSERT INTO card_set_black_card VALUES (100228, 5084);
INSERT INTO card_set_black_card VALUES (100228, 5075);
INSERT INTO card_set_black_card VALUES (100228, 5074);
INSERT INTO card_set_black_card VALUES (100228, 5073);
INSERT INTO card_set_black_card VALUES (100228, 5072);
INSERT INTO card_set_black_card VALUES (100228, 5079);
INSERT INTO card_set_black_card VALUES (100228, 5078);
INSERT INTO card_set_black_card VALUES (100228, 5077);
INSERT INTO card_set_black_card VALUES (100228, 5076);
INSERT INTO card_set_black_card VALUES (100228, 5066);
INSERT INTO card_set_black_card VALUES (100228, 5067);
INSERT INTO card_set_black_card VALUES (100228, 5064);
INSERT INTO card_set_black_card VALUES (100228, 5065);
INSERT INTO card_set_black_card VALUES (100228, 5070);
INSERT INTO card_set_black_card VALUES (100228, 5071);
INSERT INTO card_set_black_card VALUES (100228, 5068);
INSERT INTO card_set_black_card VALUES (100228, 5069);
INSERT INTO card_set_black_card VALUES (100228, 5058);
INSERT INTO card_set_black_card VALUES (100228, 5059);
INSERT INTO card_set_black_card VALUES (100228, 5056);
INSERT INTO card_set_black_card VALUES (100228, 5057);
INSERT INTO card_set_black_card VALUES (100228, 5062);
INSERT INTO card_set_black_card VALUES (100228, 5063);
INSERT INTO card_set_black_card VALUES (100228, 5060);
INSERT INTO card_set_black_card VALUES (100228, 5061);
INSERT INTO card_set_black_card VALUES (100228, 5105);
INSERT INTO card_set_black_card VALUES (100228, 5104);
INSERT INTO card_set_black_card VALUES (100228, 5096);
INSERT INTO card_set_black_card VALUES (100228, 5097);
INSERT INTO card_set_black_card VALUES (100228, 5098);
INSERT INTO card_set_black_card VALUES (100228, 5099);
INSERT INTO card_set_black_card VALUES (100228, 5100);
INSERT INTO card_set_black_card VALUES (100228, 5101);
INSERT INTO card_set_black_card VALUES (100228, 5102);
INSERT INTO card_set_black_card VALUES (100228, 5103);
INSERT INTO card_set_black_card VALUES (100228, 5088);
INSERT INTO card_set_black_card VALUES (100228, 5089);
INSERT INTO card_set_black_card VALUES (100228, 5090);
INSERT INTO card_set_black_card VALUES (100228, 5091);
INSERT INTO card_set_black_card VALUES (100228, 5092);
INSERT INTO card_set_black_card VALUES (100228, 5093);
INSERT INTO card_set_black_card VALUES (100228, 5094);
INSERT INTO card_set_black_card VALUES (100228, 5095);
INSERT INTO card_set_black_card VALUES (100229, 5197);
INSERT INTO card_set_black_card VALUES (100229, 5196);
INSERT INTO card_set_black_card VALUES (100229, 5199);
INSERT INTO card_set_black_card VALUES (100229, 5198);
INSERT INTO card_set_black_card VALUES (100229, 5193);
INSERT INTO card_set_black_card VALUES (100229, 5192);
INSERT INTO card_set_black_card VALUES (100229, 5195);
INSERT INTO card_set_black_card VALUES (100229, 5194);
INSERT INTO card_set_black_card VALUES (100229, 5189);
INSERT INTO card_set_black_card VALUES (100229, 5188);
INSERT INTO card_set_black_card VALUES (100229, 5191);
INSERT INTO card_set_black_card VALUES (100229, 5190);
INSERT INTO card_set_black_card VALUES (100229, 5185);
INSERT INTO card_set_black_card VALUES (100229, 5184);
INSERT INTO card_set_black_card VALUES (100229, 5187);
INSERT INTO card_set_black_card VALUES (100229, 5186);
INSERT INTO card_set_black_card VALUES (100229, 5212);
INSERT INTO card_set_black_card VALUES (100229, 5208);
INSERT INTO card_set_black_card VALUES (100229, 5209);
INSERT INTO card_set_black_card VALUES (100229, 5210);
INSERT INTO card_set_black_card VALUES (100229, 5211);
INSERT INTO card_set_black_card VALUES (100229, 5204);
INSERT INTO card_set_black_card VALUES (100229, 5205);
INSERT INTO card_set_black_card VALUES (100229, 5206);
INSERT INTO card_set_black_card VALUES (100229, 5207);
INSERT INTO card_set_black_card VALUES (100229, 5200);
INSERT INTO card_set_black_card VALUES (100229, 5201);
INSERT INTO card_set_black_card VALUES (100229, 5202);
INSERT INTO card_set_black_card VALUES (100229, 5203);
INSERT INTO card_set_black_card VALUES (100229, 5163);
INSERT INTO card_set_black_card VALUES (100229, 5162);
INSERT INTO card_set_black_card VALUES (100229, 5161);
INSERT INTO card_set_black_card VALUES (100229, 5160);
INSERT INTO card_set_black_card VALUES (100229, 5167);
INSERT INTO card_set_black_card VALUES (100229, 5166);
INSERT INTO card_set_black_card VALUES (100229, 5165);
INSERT INTO card_set_black_card VALUES (100229, 5164);
INSERT INTO card_set_black_card VALUES (100229, 5155);
INSERT INTO card_set_black_card VALUES (100229, 5154);
INSERT INTO card_set_black_card VALUES (100229, 5153);
INSERT INTO card_set_black_card VALUES (100229, 5152);
INSERT INTO card_set_black_card VALUES (100229, 5159);
INSERT INTO card_set_black_card VALUES (100229, 5158);
INSERT INTO card_set_black_card VALUES (100229, 5157);
INSERT INTO card_set_black_card VALUES (100229, 5156);
INSERT INTO card_set_black_card VALUES (100229, 5178);
INSERT INTO card_set_black_card VALUES (100229, 5179);
INSERT INTO card_set_black_card VALUES (100229, 5176);
INSERT INTO card_set_black_card VALUES (100229, 5177);
INSERT INTO card_set_black_card VALUES (100229, 5182);
INSERT INTO card_set_black_card VALUES (100229, 5183);
INSERT INTO card_set_black_card VALUES (100229, 5180);
INSERT INTO card_set_black_card VALUES (100229, 5181);
INSERT INTO card_set_black_card VALUES (100229, 5170);
INSERT INTO card_set_black_card VALUES (100229, 5171);
INSERT INTO card_set_black_card VALUES (100229, 5168);
INSERT INTO card_set_black_card VALUES (100229, 5169);
INSERT INTO card_set_black_card VALUES (100229, 5174);
INSERT INTO card_set_black_card VALUES (100229, 5175);
INSERT INTO card_set_black_card VALUES (100229, 5172);
INSERT INTO card_set_black_card VALUES (100229, 5173);
INSERT INTO card_set_black_card VALUES (100229, 5129);
INSERT INTO card_set_black_card VALUES (100229, 5128);
INSERT INTO card_set_black_card VALUES (100229, 5131);
INSERT INTO card_set_black_card VALUES (100229, 5130);
INSERT INTO card_set_black_card VALUES (100229, 5133);
INSERT INTO card_set_black_card VALUES (100229, 5132);
INSERT INTO card_set_black_card VALUES (100229, 5135);
INSERT INTO card_set_black_card VALUES (100229, 5134);
INSERT INTO card_set_black_card VALUES (100229, 5121);
INSERT INTO card_set_black_card VALUES (100229, 5120);
INSERT INTO card_set_black_card VALUES (100229, 5123);
INSERT INTO card_set_black_card VALUES (100229, 5122);
INSERT INTO card_set_black_card VALUES (100229, 5125);
INSERT INTO card_set_black_card VALUES (100229, 5124);
INSERT INTO card_set_black_card VALUES (100229, 5127);
INSERT INTO card_set_black_card VALUES (100229, 5126);
INSERT INTO card_set_black_card VALUES (100229, 5144);
INSERT INTO card_set_black_card VALUES (100229, 5145);
INSERT INTO card_set_black_card VALUES (100229, 5146);
INSERT INTO card_set_black_card VALUES (100229, 5147);
INSERT INTO card_set_black_card VALUES (100229, 5148);
INSERT INTO card_set_black_card VALUES (100229, 5149);
INSERT INTO card_set_black_card VALUES (100229, 5150);
INSERT INTO card_set_black_card VALUES (100229, 5151);
INSERT INTO card_set_black_card VALUES (100229, 5136);
INSERT INTO card_set_black_card VALUES (100229, 5137);
INSERT INTO card_set_black_card VALUES (100229, 5138);
INSERT INTO card_set_black_card VALUES (100229, 5139);
INSERT INTO card_set_black_card VALUES (100229, 5140);
INSERT INTO card_set_black_card VALUES (100229, 5141);
INSERT INTO card_set_black_card VALUES (100229, 5142);
INSERT INTO card_set_black_card VALUES (100229, 5143);
INSERT INTO card_set_black_card VALUES (100229, 5113);
INSERT INTO card_set_black_card VALUES (100229, 5112);
INSERT INTO card_set_black_card VALUES (100229, 5115);
INSERT INTO card_set_black_card VALUES (100229, 5114);
INSERT INTO card_set_black_card VALUES (100229, 5117);
INSERT INTO card_set_black_card VALUES (100229, 5116);
INSERT INTO card_set_black_card VALUES (100229, 5119);
INSERT INTO card_set_black_card VALUES (100229, 5118);
INSERT INTO card_set_black_card VALUES (100229, 5107);
INSERT INTO card_set_black_card VALUES (100229, 5106);
INSERT INTO card_set_black_card VALUES (100229, 5109);
INSERT INTO card_set_black_card VALUES (100229, 5108);
INSERT INTO card_set_black_card VALUES (100229, 5111);
INSERT INTO card_set_black_card VALUES (100229, 5110);
INSERT INTO card_set_black_card VALUES (100161, 8399);
INSERT INTO card_set_black_card VALUES (100161, 8398);
INSERT INTO card_set_black_card VALUES (100161, 8397);
INSERT INTO card_set_black_card VALUES (100161, 8396);
INSERT INTO card_set_black_card VALUES (100161, 8395);
INSERT INTO card_set_black_card VALUES (100161, 8394);
INSERT INTO card_set_black_card VALUES (100161, 8393);
INSERT INTO card_set_black_card VALUES (100161, 8392);
INSERT INTO card_set_black_card VALUES (100161, 8391);
INSERT INTO card_set_black_card VALUES (100161, 8390);
INSERT INTO card_set_black_card VALUES (100161, 8389);
INSERT INTO card_set_black_card VALUES (100161, 8388);
INSERT INTO card_set_black_card VALUES (100161, 8387);
INSERT INTO card_set_black_card VALUES (100161, 8386);
INSERT INTO card_set_black_card VALUES (100161, 8385);
INSERT INTO card_set_black_card VALUES (100161, 8384);
INSERT INTO card_set_black_card VALUES (100161, 8414);
INSERT INTO card_set_black_card VALUES (100161, 8415);
INSERT INTO card_set_black_card VALUES (100161, 8412);
INSERT INTO card_set_black_card VALUES (100161, 8413);
INSERT INTO card_set_black_card VALUES (100161, 8410);
INSERT INTO card_set_black_card VALUES (100161, 8411);
INSERT INTO card_set_black_card VALUES (100161, 8408);
INSERT INTO card_set_black_card VALUES (100161, 8409);
INSERT INTO card_set_black_card VALUES (100161, 8406);
INSERT INTO card_set_black_card VALUES (100161, 8407);
INSERT INTO card_set_black_card VALUES (100161, 8404);
INSERT INTO card_set_black_card VALUES (100161, 8405);
INSERT INTO card_set_black_card VALUES (100161, 8402);
INSERT INTO card_set_black_card VALUES (100161, 8403);
INSERT INTO card_set_black_card VALUES (100161, 8400);
INSERT INTO card_set_black_card VALUES (100161, 8401);
INSERT INTO card_set_black_card VALUES (100161, 8429);
INSERT INTO card_set_black_card VALUES (100161, 8428);
INSERT INTO card_set_black_card VALUES (100161, 8431);
INSERT INTO card_set_black_card VALUES (100161, 8430);
INSERT INTO card_set_black_card VALUES (100161, 8425);
INSERT INTO card_set_black_card VALUES (100161, 8424);
INSERT INTO card_set_black_card VALUES (100161, 8427);
INSERT INTO card_set_black_card VALUES (100161, 8426);
INSERT INTO card_set_black_card VALUES (100161, 8421);
INSERT INTO card_set_black_card VALUES (100161, 8420);
INSERT INTO card_set_black_card VALUES (100161, 8423);
INSERT INTO card_set_black_card VALUES (100161, 8422);
INSERT INTO card_set_black_card VALUES (100161, 8417);
INSERT INTO card_set_black_card VALUES (100161, 8416);
INSERT INTO card_set_black_card VALUES (100161, 8419);
INSERT INTO card_set_black_card VALUES (100161, 8418);
INSERT INTO card_set_black_card VALUES (100161, 8444);
INSERT INTO card_set_black_card VALUES (100161, 8445);
INSERT INTO card_set_black_card VALUES (100161, 8446);
INSERT INTO card_set_black_card VALUES (100161, 8447);
INSERT INTO card_set_black_card VALUES (100161, 8440);
INSERT INTO card_set_black_card VALUES (100161, 8441);
INSERT INTO card_set_black_card VALUES (100161, 8442);
INSERT INTO card_set_black_card VALUES (100161, 8443);
INSERT INTO card_set_black_card VALUES (100161, 8436);
INSERT INTO card_set_black_card VALUES (100161, 8437);
INSERT INTO card_set_black_card VALUES (100161, 8438);
INSERT INTO card_set_black_card VALUES (100161, 8439);
INSERT INTO card_set_black_card VALUES (100161, 8432);
INSERT INTO card_set_black_card VALUES (100161, 8433);
INSERT INTO card_set_black_card VALUES (100161, 8434);
INSERT INTO card_set_black_card VALUES (100161, 8435);
INSERT INTO card_set_black_card VALUES (100161, 8377);
INSERT INTO card_set_black_card VALUES (100161, 8378);
INSERT INTO card_set_black_card VALUES (100161, 8379);
INSERT INTO card_set_black_card VALUES (100161, 8380);
INSERT INTO card_set_black_card VALUES (100161, 8381);
INSERT INTO card_set_black_card VALUES (100161, 8382);
INSERT INTO card_set_black_card VALUES (100161, 8383);
INSERT INTO card_set_black_card VALUES (100161, 8465);
INSERT INTO card_set_black_card VALUES (100161, 8464);
INSERT INTO card_set_black_card VALUES (100161, 8448);
INSERT INTO card_set_black_card VALUES (100161, 8449);
INSERT INTO card_set_black_card VALUES (100161, 8450);
INSERT INTO card_set_black_card VALUES (100161, 8451);
INSERT INTO card_set_black_card VALUES (100161, 8452);
INSERT INTO card_set_black_card VALUES (100161, 8453);
INSERT INTO card_set_black_card VALUES (100161, 8454);
INSERT INTO card_set_black_card VALUES (100161, 8455);
INSERT INTO card_set_black_card VALUES (100161, 8456);
INSERT INTO card_set_black_card VALUES (100161, 8457);
INSERT INTO card_set_black_card VALUES (100161, 8458);
INSERT INTO card_set_black_card VALUES (100161, 8459);
INSERT INTO card_set_black_card VALUES (100161, 8460);
INSERT INTO card_set_black_card VALUES (100161, 8461);
INSERT INTO card_set_black_card VALUES (100161, 8462);
INSERT INTO card_set_black_card VALUES (100161, 8463);
INSERT INTO card_set_black_card VALUES (100157, 8467);
INSERT INTO card_set_black_card VALUES (100157, 8466);
INSERT INTO card_set_black_card VALUES (100157, 8469);
INSERT INTO card_set_black_card VALUES (100157, 8468);
INSERT INTO card_set_black_card VALUES (100157, 8471);
INSERT INTO card_set_black_card VALUES (100157, 8470);
INSERT INTO card_set_black_card VALUES (100157, 8473);
INSERT INTO card_set_black_card VALUES (100157, 8472);
INSERT INTO card_set_black_card VALUES (100157, 8475);
INSERT INTO card_set_black_card VALUES (100157, 8474);
INSERT INTO card_set_black_card VALUES (100157, 8477);
INSERT INTO card_set_black_card VALUES (100157, 8476);
INSERT INTO card_set_black_card VALUES (100157, 8479);
INSERT INTO card_set_black_card VALUES (100157, 8478);
INSERT INTO card_set_black_card VALUES (100157, 8499);
INSERT INTO card_set_black_card VALUES (100157, 8498);
INSERT INTO card_set_black_card VALUES (100157, 8497);
INSERT INTO card_set_black_card VALUES (100157, 8496);
INSERT INTO card_set_black_card VALUES (100157, 8482);
INSERT INTO card_set_black_card VALUES (100157, 8483);
INSERT INTO card_set_black_card VALUES (100157, 8480);
INSERT INTO card_set_black_card VALUES (100157, 8481);
INSERT INTO card_set_black_card VALUES (100157, 8486);
INSERT INTO card_set_black_card VALUES (100157, 8487);
INSERT INTO card_set_black_card VALUES (100157, 8484);
INSERT INTO card_set_black_card VALUES (100157, 8485);
INSERT INTO card_set_black_card VALUES (100157, 8490);
INSERT INTO card_set_black_card VALUES (100157, 8491);
INSERT INTO card_set_black_card VALUES (100157, 8488);
INSERT INTO card_set_black_card VALUES (100157, 8489);
INSERT INTO card_set_black_card VALUES (100157, 8494);
INSERT INTO card_set_black_card VALUES (100157, 8495);
INSERT INTO card_set_black_card VALUES (100157, 8492);
INSERT INTO card_set_black_card VALUES (100157, 8493);
INSERT INTO card_set_black_card VALUES (100231, 8533);
INSERT INTO card_set_black_card VALUES (100231, 8532);
INSERT INTO card_set_black_card VALUES (100231, 8535);
INSERT INTO card_set_black_card VALUES (100231, 8534);
INSERT INTO card_set_black_card VALUES (100231, 8529);
INSERT INTO card_set_black_card VALUES (100231, 8528);
INSERT INTO card_set_black_card VALUES (100231, 8531);
INSERT INTO card_set_black_card VALUES (100231, 8530);
INSERT INTO card_set_black_card VALUES (100231, 8541);
INSERT INTO card_set_black_card VALUES (100231, 8540);
INSERT INTO card_set_black_card VALUES (100231, 8543);
INSERT INTO card_set_black_card VALUES (100231, 8542);
INSERT INTO card_set_black_card VALUES (100231, 8537);
INSERT INTO card_set_black_card VALUES (100231, 8536);
INSERT INTO card_set_black_card VALUES (100231, 8539);
INSERT INTO card_set_black_card VALUES (100231, 8538);
INSERT INTO card_set_black_card VALUES (100231, 8516);
INSERT INTO card_set_black_card VALUES (100231, 8517);
INSERT INTO card_set_black_card VALUES (100231, 8518);
INSERT INTO card_set_black_card VALUES (100231, 8519);
INSERT INTO card_set_black_card VALUES (100231, 8512);
INSERT INTO card_set_black_card VALUES (100231, 8513);
INSERT INTO card_set_black_card VALUES (100231, 8514);
INSERT INTO card_set_black_card VALUES (100231, 8515);
INSERT INTO card_set_black_card VALUES (100231, 8524);
INSERT INTO card_set_black_card VALUES (100231, 8525);
INSERT INTO card_set_black_card VALUES (100231, 8526);
INSERT INTO card_set_black_card VALUES (100231, 8527);
INSERT INTO card_set_black_card VALUES (100231, 8520);
INSERT INTO card_set_black_card VALUES (100231, 8521);
INSERT INTO card_set_black_card VALUES (100231, 8522);
INSERT INTO card_set_black_card VALUES (100231, 8523);
INSERT INTO card_set_black_card VALUES (100231, 8567);
INSERT INTO card_set_black_card VALUES (100231, 8566);
INSERT INTO card_set_black_card VALUES (100231, 8565);
INSERT INTO card_set_black_card VALUES (100231, 8564);
INSERT INTO card_set_black_card VALUES (100231, 8563);
INSERT INTO card_set_black_card VALUES (100231, 8562);
INSERT INTO card_set_black_card VALUES (100231, 8561);
INSERT INTO card_set_black_card VALUES (100231, 8560);
INSERT INTO card_set_black_card VALUES (100231, 8575);
INSERT INTO card_set_black_card VALUES (100231, 8574);
INSERT INTO card_set_black_card VALUES (100231, 8573);
INSERT INTO card_set_black_card VALUES (100231, 8572);
INSERT INTO card_set_black_card VALUES (100231, 8571);
INSERT INTO card_set_black_card VALUES (100231, 8570);
INSERT INTO card_set_black_card VALUES (100231, 8569);
INSERT INTO card_set_black_card VALUES (100231, 8568);
INSERT INTO card_set_black_card VALUES (100231, 8550);
INSERT INTO card_set_black_card VALUES (100231, 8551);
INSERT INTO card_set_black_card VALUES (100231, 8548);
INSERT INTO card_set_black_card VALUES (100231, 8549);
INSERT INTO card_set_black_card VALUES (100231, 8546);
INSERT INTO card_set_black_card VALUES (100231, 8547);
INSERT INTO card_set_black_card VALUES (100231, 8544);
INSERT INTO card_set_black_card VALUES (100231, 8545);
INSERT INTO card_set_black_card VALUES (100231, 8558);
INSERT INTO card_set_black_card VALUES (100231, 8559);
INSERT INTO card_set_black_card VALUES (100231, 8556);
INSERT INTO card_set_black_card VALUES (100231, 8557);
INSERT INTO card_set_black_card VALUES (100231, 8554);
INSERT INTO card_set_black_card VALUES (100231, 8555);
INSERT INTO card_set_black_card VALUES (100231, 8552);
INSERT INTO card_set_black_card VALUES (100231, 8553);
INSERT INTO card_set_black_card VALUES (100231, 8503);
INSERT INTO card_set_black_card VALUES (100231, 8502);
INSERT INTO card_set_black_card VALUES (100231, 8501);
INSERT INTO card_set_black_card VALUES (100231, 8500);
INSERT INTO card_set_black_card VALUES (100231, 8507);
INSERT INTO card_set_black_card VALUES (100231, 8506);
INSERT INTO card_set_black_card VALUES (100231, 8505);
INSERT INTO card_set_black_card VALUES (100231, 8504);
INSERT INTO card_set_black_card VALUES (100231, 8511);
INSERT INTO card_set_black_card VALUES (100231, 8510);
INSERT INTO card_set_black_card VALUES (100231, 8509);
INSERT INTO card_set_black_card VALUES (100231, 8508);
INSERT INTO card_set_black_card VALUES (100231, 8592);
INSERT INTO card_set_black_card VALUES (100231, 8593);
INSERT INTO card_set_black_card VALUES (100231, 8594);
INSERT INTO card_set_black_card VALUES (100231, 8595);
INSERT INTO card_set_black_card VALUES (100231, 8596);
INSERT INTO card_set_black_card VALUES (100231, 8597);
INSERT INTO card_set_black_card VALUES (100231, 8598);
INSERT INTO card_set_black_card VALUES (100231, 8585);
INSERT INTO card_set_black_card VALUES (100231, 8584);
INSERT INTO card_set_black_card VALUES (100231, 8587);
INSERT INTO card_set_black_card VALUES (100231, 8586);
INSERT INTO card_set_black_card VALUES (100231, 8589);
INSERT INTO card_set_black_card VALUES (100231, 8588);
INSERT INTO card_set_black_card VALUES (100231, 8591);
INSERT INTO card_set_black_card VALUES (100231, 8590);
INSERT INTO card_set_black_card VALUES (100231, 8577);
INSERT INTO card_set_black_card VALUES (100231, 8576);
INSERT INTO card_set_black_card VALUES (100231, 8579);
INSERT INTO card_set_black_card VALUES (100231, 8578);
INSERT INTO card_set_black_card VALUES (100231, 8581);
INSERT INTO card_set_black_card VALUES (100231, 8580);
INSERT INTO card_set_black_card VALUES (100231, 8583);
INSERT INTO card_set_black_card VALUES (100231, 8582);
INSERT INTO card_set_black_card VALUES (100232, 8664);
INSERT INTO card_set_black_card VALUES (100232, 8665);
INSERT INTO card_set_black_card VALUES (100232, 8666);
INSERT INTO card_set_black_card VALUES (100232, 8667);
INSERT INTO card_set_black_card VALUES (100232, 8660);
INSERT INTO card_set_black_card VALUES (100232, 8661);
INSERT INTO card_set_black_card VALUES (100232, 8662);
INSERT INTO card_set_black_card VALUES (100232, 8663);
INSERT INTO card_set_black_card VALUES (100232, 8656);
INSERT INTO card_set_black_card VALUES (100232, 8657);
INSERT INTO card_set_black_card VALUES (100232, 8658);
INSERT INTO card_set_black_card VALUES (100232, 8659);
INSERT INTO card_set_black_card VALUES (100232, 8653);
INSERT INTO card_set_black_card VALUES (100232, 8652);
INSERT INTO card_set_black_card VALUES (100232, 8655);
INSERT INTO card_set_black_card VALUES (100232, 8654);
INSERT INTO card_set_black_card VALUES (100232, 8649);
INSERT INTO card_set_black_card VALUES (100232, 8648);
INSERT INTO card_set_black_card VALUES (100232, 8651);
INSERT INTO card_set_black_card VALUES (100232, 8650);
INSERT INTO card_set_black_card VALUES (100232, 8645);
INSERT INTO card_set_black_card VALUES (100232, 8644);
INSERT INTO card_set_black_card VALUES (100232, 8647);
INSERT INTO card_set_black_card VALUES (100232, 8646);
INSERT INTO card_set_black_card VALUES (100232, 8641);
INSERT INTO card_set_black_card VALUES (100232, 8640);
INSERT INTO card_set_black_card VALUES (100232, 8643);
INSERT INTO card_set_black_card VALUES (100232, 8642);
INSERT INTO card_set_black_card VALUES (100232, 8600);
INSERT INTO card_set_black_card VALUES (100232, 8601);
INSERT INTO card_set_black_card VALUES (100232, 8602);
INSERT INTO card_set_black_card VALUES (100232, 8603);
INSERT INTO card_set_black_card VALUES (100232, 8604);
INSERT INTO card_set_black_card VALUES (100232, 8605);
INSERT INTO card_set_black_card VALUES (100232, 8606);
INSERT INTO card_set_black_card VALUES (100232, 8607);
INSERT INTO card_set_black_card VALUES (100232, 8599);
INSERT INTO card_set_black_card VALUES (100232, 8634);
INSERT INTO card_set_black_card VALUES (100232, 8635);
INSERT INTO card_set_black_card VALUES (100232, 8632);
INSERT INTO card_set_black_card VALUES (100232, 8633);
INSERT INTO card_set_black_card VALUES (100232, 8638);
INSERT INTO card_set_black_card VALUES (100232, 8639);
INSERT INTO card_set_black_card VALUES (100232, 8636);
INSERT INTO card_set_black_card VALUES (100232, 8637);
INSERT INTO card_set_black_card VALUES (100232, 8626);
INSERT INTO card_set_black_card VALUES (100232, 8627);
INSERT INTO card_set_black_card VALUES (100232, 8624);
INSERT INTO card_set_black_card VALUES (100232, 8625);
INSERT INTO card_set_black_card VALUES (100232, 8630);
INSERT INTO card_set_black_card VALUES (100232, 8631);
INSERT INTO card_set_black_card VALUES (100232, 8628);
INSERT INTO card_set_black_card VALUES (100232, 8629);
INSERT INTO card_set_black_card VALUES (100232, 8619);
INSERT INTO card_set_black_card VALUES (100232, 8618);
INSERT INTO card_set_black_card VALUES (100232, 8617);
INSERT INTO card_set_black_card VALUES (100232, 8616);
INSERT INTO card_set_black_card VALUES (100232, 8623);
INSERT INTO card_set_black_card VALUES (100232, 8622);
INSERT INTO card_set_black_card VALUES (100232, 8621);
INSERT INTO card_set_black_card VALUES (100232, 8620);
INSERT INTO card_set_black_card VALUES (100232, 8611);
INSERT INTO card_set_black_card VALUES (100232, 8610);
INSERT INTO card_set_black_card VALUES (100232, 8609);
INSERT INTO card_set_black_card VALUES (100232, 8608);
INSERT INTO card_set_black_card VALUES (100232, 8615);
INSERT INTO card_set_black_card VALUES (100232, 8614);
INSERT INTO card_set_black_card VALUES (100232, 8613);
INSERT INTO card_set_black_card VALUES (100232, 8612);
INSERT INTO card_set_black_card VALUES (100233, 8668);
INSERT INTO card_set_black_card VALUES (100233, 8669);
INSERT INTO card_set_black_card VALUES (100233, 8670);
INSERT INTO card_set_black_card VALUES (100233, 8671);
INSERT INTO card_set_black_card VALUES (100233, 8702);
INSERT INTO card_set_black_card VALUES (100233, 8703);
INSERT INTO card_set_black_card VALUES (100233, 8708);
INSERT INTO card_set_black_card VALUES (100233, 8700);
INSERT INTO card_set_black_card VALUES (100233, 8709);
INSERT INTO card_set_black_card VALUES (100233, 8701);
INSERT INTO card_set_black_card VALUES (100233, 8706);
INSERT INTO card_set_black_card VALUES (100233, 8698);
INSERT INTO card_set_black_card VALUES (100233, 8707);
INSERT INTO card_set_black_card VALUES (100233, 8699);
INSERT INTO card_set_black_card VALUES (100233, 8704);
INSERT INTO card_set_black_card VALUES (100233, 8696);
INSERT INTO card_set_black_card VALUES (100233, 8705);
INSERT INTO card_set_black_card VALUES (100233, 8697);
INSERT INTO card_set_black_card VALUES (100233, 8694);
INSERT INTO card_set_black_card VALUES (100233, 8695);
INSERT INTO card_set_black_card VALUES (100233, 8692);
INSERT INTO card_set_black_card VALUES (100233, 8693);
INSERT INTO card_set_black_card VALUES (100233, 8690);
INSERT INTO card_set_black_card VALUES (100233, 8691);
INSERT INTO card_set_black_card VALUES (100233, 8688);
INSERT INTO card_set_black_card VALUES (100233, 8689);
INSERT INTO card_set_black_card VALUES (100233, 8687);
INSERT INTO card_set_black_card VALUES (100233, 8686);
INSERT INTO card_set_black_card VALUES (100233, 8685);
INSERT INTO card_set_black_card VALUES (100233, 8684);
INSERT INTO card_set_black_card VALUES (100233, 8683);
INSERT INTO card_set_black_card VALUES (100233, 8682);
INSERT INTO card_set_black_card VALUES (100233, 8681);
INSERT INTO card_set_black_card VALUES (100233, 8680);
INSERT INTO card_set_black_card VALUES (100233, 8679);
INSERT INTO card_set_black_card VALUES (100233, 8678);
INSERT INTO card_set_black_card VALUES (100233, 8677);
INSERT INTO card_set_black_card VALUES (100233, 8676);
INSERT INTO card_set_black_card VALUES (100233, 8675);
INSERT INTO card_set_black_card VALUES (100233, 8674);
INSERT INTO card_set_black_card VALUES (100233, 8673);
INSERT INTO card_set_black_card VALUES (100233, 8672);
INSERT INTO card_set_black_card VALUES (100003, 5133);
INSERT INTO card_set_black_card VALUES (100003, 5146);
INSERT INTO card_set_black_card VALUES (100003, 5150);
INSERT INTO card_set_black_card VALUES (100003, 5020);
INSERT INTO card_set_black_card VALUES (100003, 5019);
INSERT INTO card_set_black_card VALUES (100003, 5017);
INSERT INTO card_set_black_card VALUES (100003, 5016);
INSERT INTO card_set_black_card VALUES (100003, 8644);
INSERT INTO card_set_black_card VALUES (100003, 8641);
INSERT INTO card_set_black_card VALUES (100003, 8640);
INSERT INTO card_set_black_card VALUES (100003, 8643);
INSERT INTO card_set_black_card VALUES (100003, 8703);
INSERT INTO card_set_black_card VALUES (100003, 5026);
INSERT INTO card_set_black_card VALUES (100003, 8600);
INSERT INTO card_set_black_card VALUES (100003, 8639);
INSERT INTO card_set_black_card VALUES (100234, 8736);
INSERT INTO card_set_black_card VALUES (100234, 8737);
INSERT INTO card_set_black_card VALUES (100234, 8710);
INSERT INTO card_set_black_card VALUES (100234, 8711);
INSERT INTO card_set_black_card VALUES (100234, 8718);
INSERT INTO card_set_black_card VALUES (100234, 8719);
INSERT INTO card_set_black_card VALUES (100234, 8716);
INSERT INTO card_set_black_card VALUES (100234, 8717);
INSERT INTO card_set_black_card VALUES (100234, 8714);
INSERT INTO card_set_black_card VALUES (100234, 8715);
INSERT INTO card_set_black_card VALUES (100234, 8712);
INSERT INTO card_set_black_card VALUES (100234, 8713);
INSERT INTO card_set_black_card VALUES (100234, 8727);
INSERT INTO card_set_black_card VALUES (100234, 8726);
INSERT INTO card_set_black_card VALUES (100234, 8725);
INSERT INTO card_set_black_card VALUES (100234, 8724);
INSERT INTO card_set_black_card VALUES (100234, 8723);
INSERT INTO card_set_black_card VALUES (100234, 8722);
INSERT INTO card_set_black_card VALUES (100234, 8721);
INSERT INTO card_set_black_card VALUES (100234, 8720);
INSERT INTO card_set_black_card VALUES (100234, 8735);
INSERT INTO card_set_black_card VALUES (100234, 8734);
INSERT INTO card_set_black_card VALUES (100234, 8733);
INSERT INTO card_set_black_card VALUES (100234, 8732);
INSERT INTO card_set_black_card VALUES (100234, 8731);
INSERT INTO card_set_black_card VALUES (100234, 8730);
INSERT INTO card_set_black_card VALUES (100234, 8729);
INSERT INTO card_set_black_card VALUES (100234, 8728);
INSERT INTO card_set_black_card VALUES (100236, 8753);
INSERT INTO card_set_black_card VALUES (100236, 8752);
INSERT INTO card_set_black_card VALUES (100236, 8755);
INSERT INTO card_set_black_card VALUES (100236, 8754);
INSERT INTO card_set_black_card VALUES (100236, 8748);
INSERT INTO card_set_black_card VALUES (100236, 8749);
INSERT INTO card_set_black_card VALUES (100236, 8750);
INSERT INTO card_set_black_card VALUES (100236, 8751);
INSERT INTO card_set_black_card VALUES (100236, 8747);
INSERT INTO card_set_black_card VALUES (100257, 1);
INSERT INTO card_set_black_card VALUES (100312, 100298);
INSERT INTO card_set_black_card VALUES (100312, 100299);
INSERT INTO card_set_black_card VALUES (100312, 100302);
INSERT INTO card_set_black_card VALUES (100312, 100303);
INSERT INTO card_set_black_card VALUES (100312, 100300);
INSERT INTO card_set_black_card VALUES (100312, 100301);
INSERT INTO card_set_black_card VALUES (100312, 100304);
INSERT INTO card_set_black_card VALUES (100415, 100395);
INSERT INTO card_set_black_card VALUES (100415, 100394);
INSERT INTO card_set_black_card VALUES (100415, 100393);
INSERT INTO card_set_black_card VALUES (100415, 100392);
INSERT INTO card_set_black_card VALUES (100415, 100399);
INSERT INTO card_set_black_card VALUES (100415, 100398);
INSERT INTO card_set_black_card VALUES (100415, 100397);
INSERT INTO card_set_black_card VALUES (100415, 100396);
INSERT INTO card_set_black_card VALUES (100415, 100387);
INSERT INTO card_set_black_card VALUES (100415, 100386);
INSERT INTO card_set_black_card VALUES (100415, 100385);
INSERT INTO card_set_black_card VALUES (100415, 100384);
INSERT INTO card_set_black_card VALUES (100415, 100391);
INSERT INTO card_set_black_card VALUES (100415, 100390);
INSERT INTO card_set_black_card VALUES (100415, 100389);
INSERT INTO card_set_black_card VALUES (100415, 100388);
INSERT INTO card_set_black_card VALUES (100415, 100410);
INSERT INTO card_set_black_card VALUES (100415, 100411);
INSERT INTO card_set_black_card VALUES (100415, 100408);
INSERT INTO card_set_black_card VALUES (100415, 100409);
INSERT INTO card_set_black_card VALUES (100415, 100412);
INSERT INTO card_set_black_card VALUES (100415, 100413);
INSERT INTO card_set_black_card VALUES (100415, 100402);
INSERT INTO card_set_black_card VALUES (100415, 100403);
INSERT INTO card_set_black_card VALUES (100415, 100400);
INSERT INTO card_set_black_card VALUES (100415, 100401);
INSERT INTO card_set_black_card VALUES (100415, 100406);
INSERT INTO card_set_black_card VALUES (100415, 100407);
INSERT INTO card_set_black_card VALUES (100415, 100404);
INSERT INTO card_set_black_card VALUES (100415, 100405);
INSERT INTO card_set_black_card VALUES (100003, 8705);
INSERT INTO card_set_black_card VALUES (100003, 8511);
INSERT INTO card_set_black_card VALUES (100003, 8713);
INSERT INTO card_set_black_card VALUES (100003, 8653);
INSERT INTO card_set_black_card VALUES (100003, 8700);
INSERT INTO card_set_black_card VALUES (100003, 8615);
INSERT INTO card_set_black_card VALUES (100422, 100421);
INSERT INTO card_set_black_card VALUES (100422, 100427);
INSERT INTO card_set_black_card VALUES (100422, 100426);
INSERT INTO card_set_black_card VALUES (100422, 100432);
INSERT INTO card_set_black_card VALUES (100422, 100437);
INSERT INTO card_set_black_card VALUES (100422, 100441);
INSERT INTO card_set_black_card VALUES (100422, 100442);
INSERT INTO card_set_black_card VALUES (100234, 8812);
INSERT INTO card_set_black_card VALUES (100443, 8800);
INSERT INTO card_set_black_card VALUES (100443, 8801);
INSERT INTO card_set_black_card VALUES (100443, 8802);
INSERT INTO card_set_black_card VALUES (100443, 8803);
INSERT INTO card_set_black_card VALUES (100443, 8804);
INSERT INTO card_set_black_card VALUES (100443, 8805);
INSERT INTO card_set_black_card VALUES (100443, 8806);
INSERT INTO card_set_black_card VALUES (100443, 8807);
INSERT INTO card_set_black_card VALUES (100443, 8808);
INSERT INTO card_set_black_card VALUES (100443, 8809);
INSERT INTO card_set_black_card VALUES (100443, 8810);
INSERT INTO card_set_black_card VALUES (100443, 8811);
INSERT INTO card_set_black_card VALUES (100443, 8770);
INSERT INTO card_set_black_card VALUES (100443, 8771);
INSERT INTO card_set_black_card VALUES (100443, 8768);
INSERT INTO card_set_black_card VALUES (100443, 8769);
INSERT INTO card_set_black_card VALUES (100443, 8774);
INSERT INTO card_set_black_card VALUES (100443, 8775);
INSERT INTO card_set_black_card VALUES (100443, 8772);
INSERT INTO card_set_black_card VALUES (100443, 8773);
INSERT INTO card_set_black_card VALUES (100443, 8778);
INSERT INTO card_set_black_card VALUES (100443, 8779);
INSERT INTO card_set_black_card VALUES (100443, 8776);
INSERT INTO card_set_black_card VALUES (100443, 8777);
INSERT INTO card_set_black_card VALUES (100443, 8782);
INSERT INTO card_set_black_card VALUES (100443, 8783);
INSERT INTO card_set_black_card VALUES (100443, 8780);
INSERT INTO card_set_black_card VALUES (100443, 8781);
INSERT INTO card_set_black_card VALUES (100443, 8787);
INSERT INTO card_set_black_card VALUES (100443, 8786);
INSERT INTO card_set_black_card VALUES (100443, 8785);
INSERT INTO card_set_black_card VALUES (100443, 8784);
INSERT INTO card_set_black_card VALUES (100443, 8791);
INSERT INTO card_set_black_card VALUES (100443, 8790);
INSERT INTO card_set_black_card VALUES (100443, 8789);
INSERT INTO card_set_black_card VALUES (100443, 8788);
INSERT INTO card_set_black_card VALUES (100443, 8795);
INSERT INTO card_set_black_card VALUES (100443, 8794);
INSERT INTO card_set_black_card VALUES (100443, 8793);
INSERT INTO card_set_black_card VALUES (100443, 8792);
INSERT INTO card_set_black_card VALUES (100443, 8799);
INSERT INTO card_set_black_card VALUES (100443, 8798);
INSERT INTO card_set_black_card VALUES (100443, 8797);
INSERT INTO card_set_black_card VALUES (100443, 8796);
INSERT INTO card_set_black_card VALUES (100443, 8757);
INSERT INTO card_set_black_card VALUES (100443, 8756);
INSERT INTO card_set_black_card VALUES (100443, 8759);
INSERT INTO card_set_black_card VALUES (100443, 8758);
INSERT INTO card_set_black_card VALUES (100443, 8765);
INSERT INTO card_set_black_card VALUES (100443, 8764);
INSERT INTO card_set_black_card VALUES (100443, 8767);
INSERT INTO card_set_black_card VALUES (100443, 8766);
INSERT INTO card_set_black_card VALUES (100443, 8761);
INSERT INTO card_set_black_card VALUES (100443, 8760);
INSERT INTO card_set_black_card VALUES (100443, 8763);
INSERT INTO card_set_black_card VALUES (100443, 8762);
INSERT INTO card_set_black_card VALUES (100444, 8813);
INSERT INTO card_set_black_card VALUES (100444, 8814);
INSERT INTO card_set_black_card VALUES (100444, 8815);
INSERT INTO card_set_black_card VALUES (100444, 8817);
INSERT INTO card_set_black_card VALUES (100444, 8816);
INSERT INTO card_set_black_card VALUES (100444, 8819);
INSERT INTO card_set_black_card VALUES (100444, 8818);
INSERT INTO card_set_black_card VALUES (100444, 8821);
INSERT INTO card_set_black_card VALUES (100444, 8820);
INSERT INTO card_set_black_card VALUES (100444, 8823);
INSERT INTO card_set_black_card VALUES (100444, 8822);
INSERT INTO card_set_black_card VALUES (100444, 8825);
INSERT INTO card_set_black_card VALUES (100444, 8824);
INSERT INTO card_set_black_card VALUES (100444, 8827);
INSERT INTO card_set_black_card VALUES (100444, 8826);
INSERT INTO card_set_black_card VALUES (100444, 8829);
INSERT INTO card_set_black_card VALUES (100444, 8828);
INSERT INTO card_set_black_card VALUES (100444, 8831);
INSERT INTO card_set_black_card VALUES (100444, 8830);
INSERT INTO card_set_black_card VALUES (100444, 8847);
INSERT INTO card_set_black_card VALUES (100444, 8846);
INSERT INTO card_set_black_card VALUES (100444, 8845);
INSERT INTO card_set_black_card VALUES (100444, 8844);
INSERT INTO card_set_black_card VALUES (100444, 8843);
INSERT INTO card_set_black_card VALUES (100444, 8842);
INSERT INTO card_set_black_card VALUES (100444, 8841);
INSERT INTO card_set_black_card VALUES (100444, 8840);
INSERT INTO card_set_black_card VALUES (100444, 8839);
INSERT INTO card_set_black_card VALUES (100444, 8838);
INSERT INTO card_set_black_card VALUES (100444, 8837);
INSERT INTO card_set_black_card VALUES (100444, 8836);
INSERT INTO card_set_black_card VALUES (100444, 8835);
INSERT INTO card_set_black_card VALUES (100444, 8834);
INSERT INTO card_set_black_card VALUES (100444, 8833);
INSERT INTO card_set_black_card VALUES (100444, 8832);
INSERT INTO card_set_black_card VALUES (100444, 8848);
INSERT INTO card_set_black_card VALUES (100445, 8939);
INSERT INTO card_set_black_card VALUES (100445, 8941);
INSERT INTO card_set_black_card VALUES (100445, 8940);
INSERT INTO card_set_black_card VALUES (100445, 8943);
INSERT INTO card_set_black_card VALUES (100445, 8942);
INSERT INTO card_set_black_card VALUES (100445, 8952);
INSERT INTO card_set_black_card VALUES (100445, 8953);
INSERT INTO card_set_black_card VALUES (100445, 8954);
INSERT INTO card_set_black_card VALUES (100445, 8955);
INSERT INTO card_set_black_card VALUES (100445, 8956);
INSERT INTO card_set_black_card VALUES (100445, 8957);
INSERT INTO card_set_black_card VALUES (100445, 8958);
INSERT INTO card_set_black_card VALUES (100445, 8959);
INSERT INTO card_set_black_card VALUES (100445, 8944);
INSERT INTO card_set_black_card VALUES (100445, 8945);
INSERT INTO card_set_black_card VALUES (100445, 8946);
INSERT INTO card_set_black_card VALUES (100445, 8947);
INSERT INTO card_set_black_card VALUES (100445, 8948);
INSERT INTO card_set_black_card VALUES (100445, 8949);
INSERT INTO card_set_black_card VALUES (100445, 8950);
INSERT INTO card_set_black_card VALUES (100445, 8951);
INSERT INTO card_set_black_card VALUES (100445, 9024);
INSERT INTO card_set_black_card VALUES (100445, 9025);
INSERT INTO card_set_black_card VALUES (100445, 9026);
INSERT INTO card_set_black_card VALUES (100445, 9027);
INSERT INTO card_set_black_card VALUES (100445, 9028);
INSERT INTO card_set_black_card VALUES (100445, 9015);
INSERT INTO card_set_black_card VALUES (100445, 9014);
INSERT INTO card_set_black_card VALUES (100445, 9013);
INSERT INTO card_set_black_card VALUES (100445, 9012);
INSERT INTO card_set_black_card VALUES (100445, 9011);
INSERT INTO card_set_black_card VALUES (100445, 9010);
INSERT INTO card_set_black_card VALUES (100445, 9009);
INSERT INTO card_set_black_card VALUES (100445, 9008);
INSERT INTO card_set_black_card VALUES (100445, 9023);
INSERT INTO card_set_black_card VALUES (100445, 9022);
INSERT INTO card_set_black_card VALUES (100445, 9021);
INSERT INTO card_set_black_card VALUES (100445, 9020);
INSERT INTO card_set_black_card VALUES (100445, 9019);
INSERT INTO card_set_black_card VALUES (100445, 9018);
INSERT INTO card_set_black_card VALUES (100445, 9017);
INSERT INTO card_set_black_card VALUES (100445, 9016);
INSERT INTO card_set_black_card VALUES (100445, 8998);
INSERT INTO card_set_black_card VALUES (100445, 8999);
INSERT INTO card_set_black_card VALUES (100445, 8996);
INSERT INTO card_set_black_card VALUES (100445, 8997);
INSERT INTO card_set_black_card VALUES (100445, 8994);
INSERT INTO card_set_black_card VALUES (100445, 8995);
INSERT INTO card_set_black_card VALUES (100445, 8992);
INSERT INTO card_set_black_card VALUES (100445, 8993);
INSERT INTO card_set_black_card VALUES (100445, 9006);
INSERT INTO card_set_black_card VALUES (100445, 9007);
INSERT INTO card_set_black_card VALUES (100445, 9004);
INSERT INTO card_set_black_card VALUES (100445, 9005);
INSERT INTO card_set_black_card VALUES (100445, 9002);
INSERT INTO card_set_black_card VALUES (100445, 9003);
INSERT INTO card_set_black_card VALUES (100445, 9000);
INSERT INTO card_set_black_card VALUES (100445, 9001);
INSERT INTO card_set_black_card VALUES (100445, 8981);
INSERT INTO card_set_black_card VALUES (100445, 8980);
INSERT INTO card_set_black_card VALUES (100445, 8983);
INSERT INTO card_set_black_card VALUES (100445, 8982);
INSERT INTO card_set_black_card VALUES (100445, 8977);
INSERT INTO card_set_black_card VALUES (100445, 8976);
INSERT INTO card_set_black_card VALUES (100445, 8979);
INSERT INTO card_set_black_card VALUES (100445, 8978);
INSERT INTO card_set_black_card VALUES (100445, 8989);
INSERT INTO card_set_black_card VALUES (100445, 8988);
INSERT INTO card_set_black_card VALUES (100445, 8991);
INSERT INTO card_set_black_card VALUES (100445, 8990);
INSERT INTO card_set_black_card VALUES (100445, 8985);
INSERT INTO card_set_black_card VALUES (100445, 8984);
INSERT INTO card_set_black_card VALUES (100445, 8987);
INSERT INTO card_set_black_card VALUES (100445, 8986);
INSERT INTO card_set_black_card VALUES (100445, 8964);
INSERT INTO card_set_black_card VALUES (100445, 8965);
INSERT INTO card_set_black_card VALUES (100445, 8966);
INSERT INTO card_set_black_card VALUES (100445, 8967);
INSERT INTO card_set_black_card VALUES (100445, 8960);
INSERT INTO card_set_black_card VALUES (100445, 8961);
INSERT INTO card_set_black_card VALUES (100445, 8962);
INSERT INTO card_set_black_card VALUES (100445, 8963);
INSERT INTO card_set_black_card VALUES (100445, 8972);
INSERT INTO card_set_black_card VALUES (100445, 8973);
INSERT INTO card_set_black_card VALUES (100445, 8974);
INSERT INTO card_set_black_card VALUES (100445, 8975);
INSERT INTO card_set_black_card VALUES (100445, 8968);
INSERT INTO card_set_black_card VALUES (100445, 8969);
INSERT INTO card_set_black_card VALUES (100445, 8970);
INSERT INTO card_set_black_card VALUES (100445, 8971);
INSERT INTO card_set_black_card VALUES (100446, 9075);
INSERT INTO card_set_black_card VALUES (100446, 9074);
INSERT INTO card_set_black_card VALUES (100446, 9073);
INSERT INTO card_set_black_card VALUES (100446, 9072);
INSERT INTO card_set_black_card VALUES (100446, 9079);
INSERT INTO card_set_black_card VALUES (100446, 9078);
INSERT INTO card_set_black_card VALUES (100446, 9077);
INSERT INTO card_set_black_card VALUES (100446, 9076);
INSERT INTO card_set_black_card VALUES (100446, 9083);
INSERT INTO card_set_black_card VALUES (100446, 9082);
INSERT INTO card_set_black_card VALUES (100446, 9081);
INSERT INTO card_set_black_card VALUES (100446, 9080);
INSERT INTO card_set_black_card VALUES (100446, 9087);
INSERT INTO card_set_black_card VALUES (100446, 9086);
INSERT INTO card_set_black_card VALUES (100446, 9085);
INSERT INTO card_set_black_card VALUES (100446, 9084);
INSERT INTO card_set_black_card VALUES (100446, 9058);
INSERT INTO card_set_black_card VALUES (100446, 9059);
INSERT INTO card_set_black_card VALUES (100446, 9056);
INSERT INTO card_set_black_card VALUES (100446, 9057);
INSERT INTO card_set_black_card VALUES (100446, 9062);
INSERT INTO card_set_black_card VALUES (100446, 9063);
INSERT INTO card_set_black_card VALUES (100446, 9060);
INSERT INTO card_set_black_card VALUES (100446, 9061);
INSERT INTO card_set_black_card VALUES (100446, 9066);
INSERT INTO card_set_black_card VALUES (100446, 9067);
INSERT INTO card_set_black_card VALUES (100446, 9064);
INSERT INTO card_set_black_card VALUES (100446, 9065);
INSERT INTO card_set_black_card VALUES (100446, 9070);
INSERT INTO card_set_black_card VALUES (100446, 9071);
INSERT INTO card_set_black_card VALUES (100446, 9068);
INSERT INTO card_set_black_card VALUES (100446, 9069);
INSERT INTO card_set_black_card VALUES (100446, 9041);
INSERT INTO card_set_black_card VALUES (100446, 9040);
INSERT INTO card_set_black_card VALUES (100446, 9043);
INSERT INTO card_set_black_card VALUES (100446, 9042);
INSERT INTO card_set_black_card VALUES (100446, 9045);
INSERT INTO card_set_black_card VALUES (100446, 9044);
INSERT INTO card_set_black_card VALUES (100446, 9047);
INSERT INTO card_set_black_card VALUES (100446, 9046);
INSERT INTO card_set_black_card VALUES (100446, 9049);
INSERT INTO card_set_black_card VALUES (100446, 9048);
INSERT INTO card_set_black_card VALUES (100446, 9051);
INSERT INTO card_set_black_card VALUES (100446, 9050);
INSERT INTO card_set_black_card VALUES (100446, 9053);
INSERT INTO card_set_black_card VALUES (100446, 9052);
INSERT INTO card_set_black_card VALUES (100446, 9055);
INSERT INTO card_set_black_card VALUES (100446, 9054);
INSERT INTO card_set_black_card VALUES (100446, 9030);
INSERT INTO card_set_black_card VALUES (100446, 9031);
INSERT INTO card_set_black_card VALUES (100446, 9032);
INSERT INTO card_set_black_card VALUES (100446, 9033);
INSERT INTO card_set_black_card VALUES (100446, 9034);
INSERT INTO card_set_black_card VALUES (100446, 9035);
INSERT INTO card_set_black_card VALUES (100446, 9036);
INSERT INTO card_set_black_card VALUES (100446, 9037);
INSERT INTO card_set_black_card VALUES (100446, 9038);
INSERT INTO card_set_black_card VALUES (100446, 9039);
INSERT INTO card_set_black_card VALUES (100446, 100155);
INSERT INTO card_set_black_card VALUES (100446, 9093);
INSERT INTO card_set_black_card VALUES (100446, 9092);
INSERT INTO card_set_black_card VALUES (100446, 9095);
INSERT INTO card_set_black_card VALUES (100446, 9094);
INSERT INTO card_set_black_card VALUES (100446, 9089);
INSERT INTO card_set_black_card VALUES (100446, 9088);
INSERT INTO card_set_black_card VALUES (100446, 9091);
INSERT INTO card_set_black_card VALUES (100446, 9090);
INSERT INTO card_set_black_card VALUES (100447, 9116);
INSERT INTO card_set_black_card VALUES (100447, 9117);
INSERT INTO card_set_black_card VALUES (100447, 9118);
INSERT INTO card_set_black_card VALUES (100447, 9119);
INSERT INTO card_set_black_card VALUES (100447, 9112);
INSERT INTO card_set_black_card VALUES (100447, 9113);
INSERT INTO card_set_black_card VALUES (100447, 9114);
INSERT INTO card_set_black_card VALUES (100447, 9115);
INSERT INTO card_set_black_card VALUES (100447, 9127);
INSERT INTO card_set_black_card VALUES (100447, 9126);
INSERT INTO card_set_black_card VALUES (100447, 9125);
INSERT INTO card_set_black_card VALUES (100447, 9124);
INSERT INTO card_set_black_card VALUES (100447, 9123);
INSERT INTO card_set_black_card VALUES (100447, 9122);
INSERT INTO card_set_black_card VALUES (100447, 9121);
INSERT INTO card_set_black_card VALUES (100447, 9120);
INSERT INTO card_set_black_card VALUES (100448, 9194);
INSERT INTO card_set_black_card VALUES (100448, 9193);
INSERT INTO card_set_black_card VALUES (100448, 9192);
INSERT INTO card_set_black_card VALUES (100448, 9187);
INSERT INTO card_set_black_card VALUES (100448, 9186);
INSERT INTO card_set_black_card VALUES (100448, 9185);
INSERT INTO card_set_black_card VALUES (100448, 9184);
INSERT INTO card_set_black_card VALUES (100448, 9191);
INSERT INTO card_set_black_card VALUES (100448, 9190);
INSERT INTO card_set_black_card VALUES (100448, 9189);
INSERT INTO card_set_black_card VALUES (100448, 9188);
INSERT INTO card_set_black_card VALUES (100448, 9176);
INSERT INTO card_set_black_card VALUES (100448, 9177);
INSERT INTO card_set_black_card VALUES (100448, 9178);
INSERT INTO card_set_black_card VALUES (100448, 9179);
INSERT INTO card_set_black_card VALUES (100448, 9180);
INSERT INTO card_set_black_card VALUES (100448, 9181);
INSERT INTO card_set_black_card VALUES (100448, 9182);
INSERT INTO card_set_black_card VALUES (100448, 9183);
INSERT INTO card_set_black_card VALUES (100448, 9168);
INSERT INTO card_set_black_card VALUES (100448, 9169);
INSERT INTO card_set_black_card VALUES (100448, 9170);
INSERT INTO card_set_black_card VALUES (100448, 9171);
INSERT INTO card_set_black_card VALUES (100448, 9172);
INSERT INTO card_set_black_card VALUES (100448, 9173);
INSERT INTO card_set_black_card VALUES (100448, 9174);
INSERT INTO card_set_black_card VALUES (100448, 9175);
INSERT INTO card_set_black_card VALUES (100448, 9161);
INSERT INTO card_set_black_card VALUES (100448, 9160);
INSERT INTO card_set_black_card VALUES (100448, 9163);
INSERT INTO card_set_black_card VALUES (100448, 9162);
INSERT INTO card_set_black_card VALUES (100448, 9165);
INSERT INTO card_set_black_card VALUES (100448, 9164);
INSERT INTO card_set_black_card VALUES (100448, 9167);
INSERT INTO card_set_black_card VALUES (100448, 9166);
INSERT INTO card_set_black_card VALUES (100448, 9153);
INSERT INTO card_set_black_card VALUES (100448, 9152);
INSERT INTO card_set_black_card VALUES (100448, 9155);
INSERT INTO card_set_black_card VALUES (100448, 9154);
INSERT INTO card_set_black_card VALUES (100448, 9157);
INSERT INTO card_set_black_card VALUES (100448, 9156);
INSERT INTO card_set_black_card VALUES (100448, 9159);
INSERT INTO card_set_black_card VALUES (100448, 9158);
INSERT INTO card_set_black_card VALUES (100448, 9150);
INSERT INTO card_set_black_card VALUES (100448, 9151);
INSERT INTO card_set_black_card VALUES (100448, 9148);
INSERT INTO card_set_black_card VALUES (100448, 9149);
INSERT INTO card_set_black_card VALUES (100448, 9146);
INSERT INTO card_set_black_card VALUES (100448, 9147);
INSERT INTO card_set_black_card VALUES (100448, 9144);
INSERT INTO card_set_black_card VALUES (100448, 9145);
INSERT INTO card_set_black_card VALUES (100448, 9142);
INSERT INTO card_set_black_card VALUES (100448, 9143);
INSERT INTO card_set_black_card VALUES (100448, 9140);
INSERT INTO card_set_black_card VALUES (100448, 9141);
INSERT INTO card_set_black_card VALUES (100448, 9138);
INSERT INTO card_set_black_card VALUES (100448, 9139);
INSERT INTO card_set_black_card VALUES (100448, 9136);
INSERT INTO card_set_black_card VALUES (100448, 9137);
INSERT INTO card_set_black_card VALUES (100448, 9135);
INSERT INTO card_set_black_card VALUES (100448, 9134);
INSERT INTO card_set_black_card VALUES (100448, 9133);
INSERT INTO card_set_black_card VALUES (100448, 9132);
INSERT INTO card_set_black_card VALUES (100448, 9131);
INSERT INTO card_set_black_card VALUES (100448, 9130);
INSERT INTO card_set_black_card VALUES (100448, 9129);
INSERT INTO card_set_black_card VALUES (100448, 9128);
INSERT INTO card_set_black_card VALUES (100449, 9210);
INSERT INTO card_set_black_card VALUES (100449, 9211);
INSERT INTO card_set_black_card VALUES (100449, 9208);
INSERT INTO card_set_black_card VALUES (100449, 9209);
INSERT INTO card_set_black_card VALUES (100449, 9214);
INSERT INTO card_set_black_card VALUES (100449, 9215);
INSERT INTO card_set_black_card VALUES (100449, 9212);
INSERT INTO card_set_black_card VALUES (100449, 9213);
INSERT INTO card_set_black_card VALUES (100449, 9202);
INSERT INTO card_set_black_card VALUES (100449, 9218);
INSERT INTO card_set_black_card VALUES (100449, 9203);
INSERT INTO card_set_black_card VALUES (100449, 9219);
INSERT INTO card_set_black_card VALUES (100449, 9200);
INSERT INTO card_set_black_card VALUES (100449, 9216);
INSERT INTO card_set_black_card VALUES (100449, 9201);
INSERT INTO card_set_black_card VALUES (100449, 9217);
INSERT INTO card_set_black_card VALUES (100449, 9206);
INSERT INTO card_set_black_card VALUES (100449, 9207);
INSERT INTO card_set_black_card VALUES (100449, 9220);
INSERT INTO card_set_black_card VALUES (100449, 9204);
INSERT INTO card_set_black_card VALUES (100449, 9205);
INSERT INTO card_set_black_card VALUES (100449, 9195);
INSERT INTO card_set_black_card VALUES (100449, 9199);
INSERT INTO card_set_black_card VALUES (100449, 9198);
INSERT INTO card_set_black_card VALUES (100449, 9197);
INSERT INTO card_set_black_card VALUES (100449, 9196);
INSERT INTO card_set_black_card VALUES (100450, 9226);
INSERT INTO card_set_black_card VALUES (100450, 9227);
INSERT INTO card_set_black_card VALUES (100450, 9224);
INSERT INTO card_set_black_card VALUES (100450, 9225);
INSERT INTO card_set_black_card VALUES (100450, 9230);
INSERT INTO card_set_black_card VALUES (100450, 9231);
INSERT INTO card_set_black_card VALUES (100450, 9228);
INSERT INTO card_set_black_card VALUES (100450, 9229);
INSERT INTO card_set_black_card VALUES (100450, 9222);
INSERT INTO card_set_black_card VALUES (100450, 9223);
INSERT INTO card_set_black_card VALUES (100450, 9221);
INSERT INTO card_set_black_card VALUES (100450, 9243);
INSERT INTO card_set_black_card VALUES (100450, 9242);
INSERT INTO card_set_black_card VALUES (100450, 9241);
INSERT INTO card_set_black_card VALUES (100450, 9240);
INSERT INTO card_set_black_card VALUES (100450, 9247);
INSERT INTO card_set_black_card VALUES (100450, 9246);
INSERT INTO card_set_black_card VALUES (100450, 9245);
INSERT INTO card_set_black_card VALUES (100450, 9244);
INSERT INTO card_set_black_card VALUES (100450, 9235);
INSERT INTO card_set_black_card VALUES (100450, 9234);
INSERT INTO card_set_black_card VALUES (100450, 9233);
INSERT INTO card_set_black_card VALUES (100450, 9232);
INSERT INTO card_set_black_card VALUES (100450, 9239);
INSERT INTO card_set_black_card VALUES (100450, 9238);
INSERT INTO card_set_black_card VALUES (100450, 9237);
INSERT INTO card_set_black_card VALUES (100450, 9236);
INSERT INTO card_set_black_card VALUES (100450, 9256);
INSERT INTO card_set_black_card VALUES (100450, 9257);
INSERT INTO card_set_black_card VALUES (100450, 9258);
INSERT INTO card_set_black_card VALUES (100450, 9259);
INSERT INTO card_set_black_card VALUES (100450, 9260);
INSERT INTO card_set_black_card VALUES (100450, 9261);
INSERT INTO card_set_black_card VALUES (100450, 9262);
INSERT INTO card_set_black_card VALUES (100450, 9263);
INSERT INTO card_set_black_card VALUES (100450, 9248);
INSERT INTO card_set_black_card VALUES (100450, 9249);
INSERT INTO card_set_black_card VALUES (100450, 9250);
INSERT INTO card_set_black_card VALUES (100450, 9251);
INSERT INTO card_set_black_card VALUES (100450, 9252);
INSERT INTO card_set_black_card VALUES (100450, 9253);
INSERT INTO card_set_black_card VALUES (100450, 9254);
INSERT INTO card_set_black_card VALUES (100450, 9255);
INSERT INTO card_set_black_card VALUES (100450, 9273);
INSERT INTO card_set_black_card VALUES (100450, 9272);
INSERT INTO card_set_black_card VALUES (100450, 9275);
INSERT INTO card_set_black_card VALUES (100450, 9274);
INSERT INTO card_set_black_card VALUES (100450, 9277);
INSERT INTO card_set_black_card VALUES (100450, 9276);
INSERT INTO card_set_black_card VALUES (100450, 9279);
INSERT INTO card_set_black_card VALUES (100450, 9278);
INSERT INTO card_set_black_card VALUES (100450, 9265);
INSERT INTO card_set_black_card VALUES (100450, 9264);
INSERT INTO card_set_black_card VALUES (100450, 9267);
INSERT INTO card_set_black_card VALUES (100450, 9266);
INSERT INTO card_set_black_card VALUES (100450, 9269);
INSERT INTO card_set_black_card VALUES (100450, 9268);
INSERT INTO card_set_black_card VALUES (100450, 9271);
INSERT INTO card_set_black_card VALUES (100450, 9270);
INSERT INTO card_set_black_card VALUES (100450, 9294);
INSERT INTO card_set_black_card VALUES (100450, 9295);
INSERT INTO card_set_black_card VALUES (100450, 9292);
INSERT INTO card_set_black_card VALUES (100450, 9293);
INSERT INTO card_set_black_card VALUES (100450, 9290);
INSERT INTO card_set_black_card VALUES (100450, 9291);
INSERT INTO card_set_black_card VALUES (100450, 9288);
INSERT INTO card_set_black_card VALUES (100450, 9289);
INSERT INTO card_set_black_card VALUES (100450, 9286);
INSERT INTO card_set_black_card VALUES (100450, 9287);
INSERT INTO card_set_black_card VALUES (100450, 9284);
INSERT INTO card_set_black_card VALUES (100450, 9285);
INSERT INTO card_set_black_card VALUES (100450, 9282);
INSERT INTO card_set_black_card VALUES (100450, 9283);
INSERT INTO card_set_black_card VALUES (100450, 9280);
INSERT INTO card_set_black_card VALUES (100450, 9281);
INSERT INTO card_set_black_card VALUES (100450, 9296);
INSERT INTO card_set_black_card VALUES (100451, 9366);
INSERT INTO card_set_black_card VALUES (100451, 9367);
INSERT INTO card_set_black_card VALUES (100451, 9370);
INSERT INTO card_set_black_card VALUES (100451, 9371);
INSERT INTO card_set_black_card VALUES (100451, 9368);
INSERT INTO card_set_black_card VALUES (100451, 9369);
INSERT INTO card_set_black_card VALUES (100451, 9374);
INSERT INTO card_set_black_card VALUES (100451, 9375);
INSERT INTO card_set_black_card VALUES (100451, 9372);
INSERT INTO card_set_black_card VALUES (100451, 9373);
INSERT INTO card_set_black_card VALUES (100451, 9377);
INSERT INTO card_set_black_card VALUES (100451, 9376);
INSERT INTO card_set_black_card VALUES (100451, 9379);
INSERT INTO card_set_black_card VALUES (100451, 9378);
INSERT INTO card_set_black_card VALUES (100451, 9381);
INSERT INTO card_set_black_card VALUES (100451, 9380);
INSERT INTO card_set_black_card VALUES (100451, 9383);
INSERT INTO card_set_black_card VALUES (100451, 9382);
INSERT INTO card_set_black_card VALUES (100451, 9385);
INSERT INTO card_set_black_card VALUES (100451, 9384);
INSERT INTO card_set_black_card VALUES (100451, 9387);
INSERT INTO card_set_black_card VALUES (100451, 9386);
INSERT INTO card_set_black_card VALUES (100451, 9389);
INSERT INTO card_set_black_card VALUES (100451, 9388);
INSERT INTO card_set_black_card VALUES (100451, 9391);
INSERT INTO card_set_black_card VALUES (100451, 9390);
INSERT INTO card_set_black_card VALUES (100451, 9392);
INSERT INTO card_set_black_card VALUES (100451, 9393);
INSERT INTO card_set_black_card VALUES (100451, 9394);
INSERT INTO card_set_black_card VALUES (100451, 9395);
INSERT INTO card_set_black_card VALUES (100451, 9396);
INSERT INTO card_set_black_card VALUES (100451, 9397);
INSERT INTO card_set_black_card VALUES (100451, 9398);
INSERT INTO card_set_black_card VALUES (100451, 9399);
INSERT INTO card_set_black_card VALUES (100451, 9400);
INSERT INTO card_set_black_card VALUES (100451, 9401);
INSERT INTO card_set_black_card VALUES (100451, 9402);
INSERT INTO card_set_black_card VALUES (100451, 9403);
INSERT INTO card_set_black_card VALUES (100451, 9404);
INSERT INTO card_set_black_card VALUES (100451, 9405);
INSERT INTO card_set_black_card VALUES (100451, 9406);
INSERT INTO card_set_black_card VALUES (100451, 9407);
INSERT INTO card_set_black_card VALUES (100451, 9415);
INSERT INTO card_set_black_card VALUES (100451, 9414);
INSERT INTO card_set_black_card VALUES (100451, 9413);
INSERT INTO card_set_black_card VALUES (100451, 9412);
INSERT INTO card_set_black_card VALUES (100451, 9411);
INSERT INTO card_set_black_card VALUES (100451, 9410);
INSERT INTO card_set_black_card VALUES (100451, 9409);
INSERT INTO card_set_black_card VALUES (100451, 9408);
INSERT INTO card_set_black_card VALUES (100451, 9423);
INSERT INTO card_set_black_card VALUES (100451, 9422);
INSERT INTO card_set_black_card VALUES (100451, 9421);
INSERT INTO card_set_black_card VALUES (100451, 9420);
INSERT INTO card_set_black_card VALUES (100451, 9419);
INSERT INTO card_set_black_card VALUES (100451, 9418);
INSERT INTO card_set_black_card VALUES (100451, 9417);
INSERT INTO card_set_black_card VALUES (100451, 9416);
INSERT INTO card_set_black_card VALUES (100451, 9430);
INSERT INTO card_set_black_card VALUES (100451, 9431);
INSERT INTO card_set_black_card VALUES (100451, 9428);
INSERT INTO card_set_black_card VALUES (100451, 9429);
INSERT INTO card_set_black_card VALUES (100451, 9426);
INSERT INTO card_set_black_card VALUES (100451, 9427);
INSERT INTO card_set_black_card VALUES (100451, 9424);
INSERT INTO card_set_black_card VALUES (100451, 9425);
INSERT INTO card_set_black_card VALUES (100451, 9434);
INSERT INTO card_set_black_card VALUES (100451, 9432);
INSERT INTO card_set_black_card VALUES (100451, 9433);
INSERT INTO card_set_black_card VALUES (100452, 9445);
INSERT INTO card_set_black_card VALUES (100452, 9444);
INSERT INTO card_set_black_card VALUES (100452, 9447);
INSERT INTO card_set_black_card VALUES (100452, 9446);
INSERT INTO card_set_black_card VALUES (100452, 9441);
INSERT INTO card_set_black_card VALUES (100452, 9440);
INSERT INTO card_set_black_card VALUES (100452, 9443);
INSERT INTO card_set_black_card VALUES (100452, 9442);
INSERT INTO card_set_black_card VALUES (100452, 9453);
INSERT INTO card_set_black_card VALUES (100452, 9452);
INSERT INTO card_set_black_card VALUES (100452, 9454);
INSERT INTO card_set_black_card VALUES (100452, 9449);
INSERT INTO card_set_black_card VALUES (100452, 9448);
INSERT INTO card_set_black_card VALUES (100452, 9451);
INSERT INTO card_set_black_card VALUES (100452, 9450);
INSERT INTO card_set_black_card VALUES (100452, 9438);
INSERT INTO card_set_black_card VALUES (100452, 9439);
INSERT INTO card_set_black_card VALUES (100452, 9436);
INSERT INTO card_set_black_card VALUES (100452, 9437);
INSERT INTO card_set_black_card VALUES (100452, 9435);
INSERT INTO card_set_black_card VALUES (100453, 9497);
INSERT INTO card_set_black_card VALUES (100453, 9496);
INSERT INTO card_set_black_card VALUES (100453, 9499);
INSERT INTO card_set_black_card VALUES (100453, 9498);
INSERT INTO card_set_black_card VALUES (100453, 9501);
INSERT INTO card_set_black_card VALUES (100453, 9500);
INSERT INTO card_set_black_card VALUES (100453, 9503);
INSERT INTO card_set_black_card VALUES (100453, 9502);
INSERT INTO card_set_black_card VALUES (100453, 9489);
INSERT INTO card_set_black_card VALUES (100453, 9488);
INSERT INTO card_set_black_card VALUES (100453, 9491);
INSERT INTO card_set_black_card VALUES (100453, 9490);
INSERT INTO card_set_black_card VALUES (100453, 9493);
INSERT INTO card_set_black_card VALUES (100453, 9492);
INSERT INTO card_set_black_card VALUES (100453, 9495);
INSERT INTO card_set_black_card VALUES (100453, 9494);
INSERT INTO card_set_black_card VALUES (100453, 9480);
INSERT INTO card_set_black_card VALUES (100453, 9481);
INSERT INTO card_set_black_card VALUES (100453, 9482);
INSERT INTO card_set_black_card VALUES (100453, 9483);
INSERT INTO card_set_black_card VALUES (100453, 9484);
INSERT INTO card_set_black_card VALUES (100453, 9485);
INSERT INTO card_set_black_card VALUES (100453, 9486);
INSERT INTO card_set_black_card VALUES (100453, 9487);
INSERT INTO card_set_black_card VALUES (100453, 9472);
INSERT INTO card_set_black_card VALUES (100453, 9473);
INSERT INTO card_set_black_card VALUES (100453, 9474);
INSERT INTO card_set_black_card VALUES (100453, 9475);
INSERT INTO card_set_black_card VALUES (100453, 9476);
INSERT INTO card_set_black_card VALUES (100453, 9477);
INSERT INTO card_set_black_card VALUES (100453, 9478);
INSERT INTO card_set_black_card VALUES (100453, 9479);
INSERT INTO card_set_black_card VALUES (100453, 9531);
INSERT INTO card_set_black_card VALUES (100453, 9530);
INSERT INTO card_set_black_card VALUES (100453, 9529);
INSERT INTO card_set_black_card VALUES (100453, 9528);
INSERT INTO card_set_black_card VALUES (100453, 9535);
INSERT INTO card_set_black_card VALUES (100453, 9534);
INSERT INTO card_set_black_card VALUES (100453, 9533);
INSERT INTO card_set_black_card VALUES (100453, 9532);
INSERT INTO card_set_black_card VALUES (100453, 9523);
INSERT INTO card_set_black_card VALUES (100453, 9522);
INSERT INTO card_set_black_card VALUES (100453, 9521);
INSERT INTO card_set_black_card VALUES (100453, 9520);
INSERT INTO card_set_black_card VALUES (100453, 9527);
INSERT INTO card_set_black_card VALUES (100453, 9526);
INSERT INTO card_set_black_card VALUES (100453, 9525);
INSERT INTO card_set_black_card VALUES (100453, 9524);
INSERT INTO card_set_black_card VALUES (100453, 9514);
INSERT INTO card_set_black_card VALUES (100453, 9515);
INSERT INTO card_set_black_card VALUES (100453, 9512);
INSERT INTO card_set_black_card VALUES (100453, 9513);
INSERT INTO card_set_black_card VALUES (100453, 9518);
INSERT INTO card_set_black_card VALUES (100453, 9519);
INSERT INTO card_set_black_card VALUES (100453, 9516);
INSERT INTO card_set_black_card VALUES (100453, 9517);
INSERT INTO card_set_black_card VALUES (100453, 9506);
INSERT INTO card_set_black_card VALUES (100453, 9507);
INSERT INTO card_set_black_card VALUES (100453, 9504);
INSERT INTO card_set_black_card VALUES (100453, 9505);
INSERT INTO card_set_black_card VALUES (100453, 9510);
INSERT INTO card_set_black_card VALUES (100453, 9511);
INSERT INTO card_set_black_card VALUES (100453, 9508);
INSERT INTO card_set_black_card VALUES (100453, 9509);
INSERT INTO card_set_black_card VALUES (100453, 9548);
INSERT INTO card_set_black_card VALUES (100453, 9549);
INSERT INTO card_set_black_card VALUES (100453, 9544);
INSERT INTO card_set_black_card VALUES (100453, 9545);
INSERT INTO card_set_black_card VALUES (100453, 9546);
INSERT INTO card_set_black_card VALUES (100453, 9547);
INSERT INTO card_set_black_card VALUES (100453, 9540);
INSERT INTO card_set_black_card VALUES (100453, 9541);
INSERT INTO card_set_black_card VALUES (100453, 9542);
INSERT INTO card_set_black_card VALUES (100453, 9543);
INSERT INTO card_set_black_card VALUES (100453, 9536);
INSERT INTO card_set_black_card VALUES (100453, 9537);
INSERT INTO card_set_black_card VALUES (100453, 9538);
INSERT INTO card_set_black_card VALUES (100453, 9539);
INSERT INTO card_set_black_card VALUES (100453, 90);
INSERT INTO card_set_black_card VALUES (100453, 9455);
INSERT INTO card_set_black_card VALUES (100453, 9460);
INSERT INTO card_set_black_card VALUES (100453, 9461);
INSERT INTO card_set_black_card VALUES (100453, 9462);
INSERT INTO card_set_black_card VALUES (100453, 9463);
INSERT INTO card_set_black_card VALUES (100453, 9456);
INSERT INTO card_set_black_card VALUES (100453, 9457);
INSERT INTO card_set_black_card VALUES (100453, 9458);
INSERT INTO card_set_black_card VALUES (100453, 9459);
INSERT INTO card_set_black_card VALUES (100453, 9468);
INSERT INTO card_set_black_card VALUES (100453, 9469);
INSERT INTO card_set_black_card VALUES (100453, 9470);
INSERT INTO card_set_black_card VALUES (100453, 9471);
INSERT INTO card_set_black_card VALUES (100453, 9464);
INSERT INTO card_set_black_card VALUES (100453, 9465);
INSERT INTO card_set_black_card VALUES (100453, 9466);
INSERT INTO card_set_black_card VALUES (100453, 9467);
INSERT INTO card_set_black_card VALUES (100422, 100459);
INSERT INTO card_set_black_card VALUES (100422, 100458);
INSERT INTO card_set_black_card VALUES (100485, 100480);
INSERT INTO card_set_black_card VALUES (100485, 100478);
INSERT INTO card_set_black_card VALUES (100485, 100481);
INSERT INTO card_set_black_card VALUES (100485, 100479);
INSERT INTO card_set_black_card VALUES (100485, 100482);
INSERT INTO card_set_black_card VALUES (100485, 100476);
INSERT INTO card_set_black_card VALUES (100485, 100483);
INSERT INTO card_set_black_card VALUES (100485, 100477);
INSERT INTO card_set_black_card VALUES (100485, 100484);


--
-- TOC entry 1932 (class 0 OID 16488)
-- Dependencies: 165
-- Data for Name: card_set_white_card; Type: TABLE DATA; Schema: public; Owner: cah
--

INSERT INTO card_set_white_card VALUES (1151, 1);
INSERT INTO card_set_white_card VALUES (1151, 2);
INSERT INTO card_set_white_card VALUES (1151, 3);
INSERT INTO card_set_white_card VALUES (1151, 4);
INSERT INTO card_set_white_card VALUES (1151, 5);
INSERT INTO card_set_white_card VALUES (1151, 6);
INSERT INTO card_set_white_card VALUES (1151, 7);
INSERT INTO card_set_white_card VALUES (1151, 8);
INSERT INTO card_set_white_card VALUES (1151, 9);
INSERT INTO card_set_white_card VALUES (1151, 10);
INSERT INTO card_set_white_card VALUES (1151, 11);
INSERT INTO card_set_white_card VALUES (1151, 12);
INSERT INTO card_set_white_card VALUES (1151, 13);
INSERT INTO card_set_white_card VALUES (1151, 14);
INSERT INTO card_set_white_card VALUES (1151, 15);
INSERT INTO card_set_white_card VALUES (1151, 17);
INSERT INTO card_set_white_card VALUES (1151, 16);
INSERT INTO card_set_white_card VALUES (1151, 19);
INSERT INTO card_set_white_card VALUES (1151, 18);
INSERT INTO card_set_white_card VALUES (1151, 21);
INSERT INTO card_set_white_card VALUES (1151, 20);
INSERT INTO card_set_white_card VALUES (1151, 23);
INSERT INTO card_set_white_card VALUES (1151, 22);
INSERT INTO card_set_white_card VALUES (1151, 25);
INSERT INTO card_set_white_card VALUES (1151, 24);
INSERT INTO card_set_white_card VALUES (1151, 27);
INSERT INTO card_set_white_card VALUES (1151, 26);
INSERT INTO card_set_white_card VALUES (1151, 29);
INSERT INTO card_set_white_card VALUES (1151, 28);
INSERT INTO card_set_white_card VALUES (1151, 31);
INSERT INTO card_set_white_card VALUES (1151, 30);
INSERT INTO card_set_white_card VALUES (1151, 34);
INSERT INTO card_set_white_card VALUES (1151, 35);
INSERT INTO card_set_white_card VALUES (1151, 32);
INSERT INTO card_set_white_card VALUES (1151, 33);
INSERT INTO card_set_white_card VALUES (1151, 38);
INSERT INTO card_set_white_card VALUES (1151, 39);
INSERT INTO card_set_white_card VALUES (1151, 36);
INSERT INTO card_set_white_card VALUES (1151, 37);
INSERT INTO card_set_white_card VALUES (1151, 42);
INSERT INTO card_set_white_card VALUES (1151, 43);
INSERT INTO card_set_white_card VALUES (1151, 40);
INSERT INTO card_set_white_card VALUES (1151, 41);
INSERT INTO card_set_white_card VALUES (1151, 46);
INSERT INTO card_set_white_card VALUES (1151, 47);
INSERT INTO card_set_white_card VALUES (1151, 44);
INSERT INTO card_set_white_card VALUES (1151, 45);
INSERT INTO card_set_white_card VALUES (1151, 51);
INSERT INTO card_set_white_card VALUES (1151, 50);
INSERT INTO card_set_white_card VALUES (1151, 49);
INSERT INTO card_set_white_card VALUES (1151, 48);
INSERT INTO card_set_white_card VALUES (1151, 55);
INSERT INTO card_set_white_card VALUES (1151, 54);
INSERT INTO card_set_white_card VALUES (1151, 53);
INSERT INTO card_set_white_card VALUES (1151, 52);
INSERT INTO card_set_white_card VALUES (1151, 59);
INSERT INTO card_set_white_card VALUES (1151, 58);
INSERT INTO card_set_white_card VALUES (1151, 57);
INSERT INTO card_set_white_card VALUES (1151, 56);
INSERT INTO card_set_white_card VALUES (1151, 63);
INSERT INTO card_set_white_card VALUES (1151, 62);
INSERT INTO card_set_white_card VALUES (1151, 61);
INSERT INTO card_set_white_card VALUES (1151, 60);
INSERT INTO card_set_white_card VALUES (1151, 68);
INSERT INTO card_set_white_card VALUES (1151, 69);
INSERT INTO card_set_white_card VALUES (1151, 70);
INSERT INTO card_set_white_card VALUES (1151, 71);
INSERT INTO card_set_white_card VALUES (1151, 64);
INSERT INTO card_set_white_card VALUES (1151, 65);
INSERT INTO card_set_white_card VALUES (1151, 66);
INSERT INTO card_set_white_card VALUES (1151, 67);
INSERT INTO card_set_white_card VALUES (1151, 76);
INSERT INTO card_set_white_card VALUES (1151, 77);
INSERT INTO card_set_white_card VALUES (1151, 78);
INSERT INTO card_set_white_card VALUES (1151, 79);
INSERT INTO card_set_white_card VALUES (1151, 72);
INSERT INTO card_set_white_card VALUES (1151, 73);
INSERT INTO card_set_white_card VALUES (1151, 74);
INSERT INTO card_set_white_card VALUES (1151, 75);
INSERT INTO card_set_white_card VALUES (1151, 85);
INSERT INTO card_set_white_card VALUES (1151, 84);
INSERT INTO card_set_white_card VALUES (1151, 87);
INSERT INTO card_set_white_card VALUES (1151, 86);
INSERT INTO card_set_white_card VALUES (1151, 81);
INSERT INTO card_set_white_card VALUES (1151, 80);
INSERT INTO card_set_white_card VALUES (1151, 83);
INSERT INTO card_set_white_card VALUES (1151, 82);
INSERT INTO card_set_white_card VALUES (1151, 93);
INSERT INTO card_set_white_card VALUES (1151, 92);
INSERT INTO card_set_white_card VALUES (1151, 95);
INSERT INTO card_set_white_card VALUES (1151, 94);
INSERT INTO card_set_white_card VALUES (1151, 89);
INSERT INTO card_set_white_card VALUES (1151, 88);
INSERT INTO card_set_white_card VALUES (1151, 91);
INSERT INTO card_set_white_card VALUES (1151, 90);
INSERT INTO card_set_white_card VALUES (1151, 102);
INSERT INTO card_set_white_card VALUES (1151, 103);
INSERT INTO card_set_white_card VALUES (1151, 100);
INSERT INTO card_set_white_card VALUES (1151, 101);
INSERT INTO card_set_white_card VALUES (1151, 98);
INSERT INTO card_set_white_card VALUES (1151, 99);
INSERT INTO card_set_white_card VALUES (1151, 96);
INSERT INTO card_set_white_card VALUES (1151, 97);
INSERT INTO card_set_white_card VALUES (1151, 110);
INSERT INTO card_set_white_card VALUES (1151, 111);
INSERT INTO card_set_white_card VALUES (1151, 108);
INSERT INTO card_set_white_card VALUES (1151, 109);
INSERT INTO card_set_white_card VALUES (1151, 106);
INSERT INTO card_set_white_card VALUES (1151, 107);
INSERT INTO card_set_white_card VALUES (1151, 104);
INSERT INTO card_set_white_card VALUES (1151, 105);
INSERT INTO card_set_white_card VALUES (1151, 119);
INSERT INTO card_set_white_card VALUES (1151, 118);
INSERT INTO card_set_white_card VALUES (1151, 117);
INSERT INTO card_set_white_card VALUES (1151, 116);
INSERT INTO card_set_white_card VALUES (1151, 115);
INSERT INTO card_set_white_card VALUES (1151, 114);
INSERT INTO card_set_white_card VALUES (1151, 113);
INSERT INTO card_set_white_card VALUES (1151, 112);
INSERT INTO card_set_white_card VALUES (1151, 127);
INSERT INTO card_set_white_card VALUES (1151, 126);
INSERT INTO card_set_white_card VALUES (1151, 125);
INSERT INTO card_set_white_card VALUES (1151, 124);
INSERT INTO card_set_white_card VALUES (1151, 123);
INSERT INTO card_set_white_card VALUES (1151, 122);
INSERT INTO card_set_white_card VALUES (1151, 121);
INSERT INTO card_set_white_card VALUES (1151, 120);
INSERT INTO card_set_white_card VALUES (1151, 137);
INSERT INTO card_set_white_card VALUES (1151, 136);
INSERT INTO card_set_white_card VALUES (1151, 139);
INSERT INTO card_set_white_card VALUES (1151, 138);
INSERT INTO card_set_white_card VALUES (1151, 141);
INSERT INTO card_set_white_card VALUES (1151, 140);
INSERT INTO card_set_white_card VALUES (1151, 143);
INSERT INTO card_set_white_card VALUES (1151, 142);
INSERT INTO card_set_white_card VALUES (1151, 129);
INSERT INTO card_set_white_card VALUES (1151, 128);
INSERT INTO card_set_white_card VALUES (1151, 131);
INSERT INTO card_set_white_card VALUES (1151, 130);
INSERT INTO card_set_white_card VALUES (1151, 133);
INSERT INTO card_set_white_card VALUES (1151, 132);
INSERT INTO card_set_white_card VALUES (1151, 135);
INSERT INTO card_set_white_card VALUES (1151, 134);
INSERT INTO card_set_white_card VALUES (1151, 152);
INSERT INTO card_set_white_card VALUES (1151, 153);
INSERT INTO card_set_white_card VALUES (1151, 154);
INSERT INTO card_set_white_card VALUES (1151, 155);
INSERT INTO card_set_white_card VALUES (1151, 156);
INSERT INTO card_set_white_card VALUES (1151, 157);
INSERT INTO card_set_white_card VALUES (1151, 158);
INSERT INTO card_set_white_card VALUES (1151, 159);
INSERT INTO card_set_white_card VALUES (1151, 144);
INSERT INTO card_set_white_card VALUES (1151, 145);
INSERT INTO card_set_white_card VALUES (1151, 146);
INSERT INTO card_set_white_card VALUES (1151, 147);
INSERT INTO card_set_white_card VALUES (1151, 148);
INSERT INTO card_set_white_card VALUES (1151, 149);
INSERT INTO card_set_white_card VALUES (1151, 150);
INSERT INTO card_set_white_card VALUES (1151, 151);
INSERT INTO card_set_white_card VALUES (1151, 171);
INSERT INTO card_set_white_card VALUES (1151, 170);
INSERT INTO card_set_white_card VALUES (1151, 169);
INSERT INTO card_set_white_card VALUES (1151, 168);
INSERT INTO card_set_white_card VALUES (1151, 175);
INSERT INTO card_set_white_card VALUES (1151, 174);
INSERT INTO card_set_white_card VALUES (1151, 173);
INSERT INTO card_set_white_card VALUES (1151, 172);
INSERT INTO card_set_white_card VALUES (1151, 163);
INSERT INTO card_set_white_card VALUES (1151, 162);
INSERT INTO card_set_white_card VALUES (1151, 161);
INSERT INTO card_set_white_card VALUES (1151, 160);
INSERT INTO card_set_white_card VALUES (1151, 167);
INSERT INTO card_set_white_card VALUES (1151, 166);
INSERT INTO card_set_white_card VALUES (1151, 165);
INSERT INTO card_set_white_card VALUES (1151, 164);
INSERT INTO card_set_white_card VALUES (1151, 186);
INSERT INTO card_set_white_card VALUES (1151, 187);
INSERT INTO card_set_white_card VALUES (1151, 184);
INSERT INTO card_set_white_card VALUES (1151, 185);
INSERT INTO card_set_white_card VALUES (1151, 190);
INSERT INTO card_set_white_card VALUES (1151, 191);
INSERT INTO card_set_white_card VALUES (1151, 188);
INSERT INTO card_set_white_card VALUES (1151, 189);
INSERT INTO card_set_white_card VALUES (1151, 178);
INSERT INTO card_set_white_card VALUES (1151, 179);
INSERT INTO card_set_white_card VALUES (1151, 176);
INSERT INTO card_set_white_card VALUES (1151, 177);
INSERT INTO card_set_white_card VALUES (1151, 182);
INSERT INTO card_set_white_card VALUES (1151, 183);
INSERT INTO card_set_white_card VALUES (1151, 180);
INSERT INTO card_set_white_card VALUES (1151, 181);
INSERT INTO card_set_white_card VALUES (1151, 205);
INSERT INTO card_set_white_card VALUES (1151, 204);
INSERT INTO card_set_white_card VALUES (1151, 207);
INSERT INTO card_set_white_card VALUES (1151, 206);
INSERT INTO card_set_white_card VALUES (1151, 201);
INSERT INTO card_set_white_card VALUES (1151, 200);
INSERT INTO card_set_white_card VALUES (1151, 203);
INSERT INTO card_set_white_card VALUES (1151, 202);
INSERT INTO card_set_white_card VALUES (1151, 197);
INSERT INTO card_set_white_card VALUES (1151, 196);
INSERT INTO card_set_white_card VALUES (1151, 199);
INSERT INTO card_set_white_card VALUES (1151, 198);
INSERT INTO card_set_white_card VALUES (1151, 193);
INSERT INTO card_set_white_card VALUES (1151, 192);
INSERT INTO card_set_white_card VALUES (1151, 195);
INSERT INTO card_set_white_card VALUES (1151, 194);
INSERT INTO card_set_white_card VALUES (1151, 220);
INSERT INTO card_set_white_card VALUES (1151, 221);
INSERT INTO card_set_white_card VALUES (1151, 222);
INSERT INTO card_set_white_card VALUES (1151, 223);
INSERT INTO card_set_white_card VALUES (1151, 216);
INSERT INTO card_set_white_card VALUES (1151, 217);
INSERT INTO card_set_white_card VALUES (1151, 218);
INSERT INTO card_set_white_card VALUES (1151, 219);
INSERT INTO card_set_white_card VALUES (1151, 212);
INSERT INTO card_set_white_card VALUES (1151, 213);
INSERT INTO card_set_white_card VALUES (1151, 214);
INSERT INTO card_set_white_card VALUES (1151, 215);
INSERT INTO card_set_white_card VALUES (1151, 208);
INSERT INTO card_set_white_card VALUES (1151, 209);
INSERT INTO card_set_white_card VALUES (1151, 210);
INSERT INTO card_set_white_card VALUES (1151, 211);
INSERT INTO card_set_white_card VALUES (1151, 239);
INSERT INTO card_set_white_card VALUES (1151, 238);
INSERT INTO card_set_white_card VALUES (1151, 237);
INSERT INTO card_set_white_card VALUES (1151, 236);
INSERT INTO card_set_white_card VALUES (1151, 235);
INSERT INTO card_set_white_card VALUES (1151, 234);
INSERT INTO card_set_white_card VALUES (1151, 233);
INSERT INTO card_set_white_card VALUES (1151, 232);
INSERT INTO card_set_white_card VALUES (1151, 231);
INSERT INTO card_set_white_card VALUES (1151, 230);
INSERT INTO card_set_white_card VALUES (1151, 229);
INSERT INTO card_set_white_card VALUES (1151, 228);
INSERT INTO card_set_white_card VALUES (1151, 227);
INSERT INTO card_set_white_card VALUES (1151, 226);
INSERT INTO card_set_white_card VALUES (1151, 225);
INSERT INTO card_set_white_card VALUES (1151, 224);
INSERT INTO card_set_white_card VALUES (1151, 254);
INSERT INTO card_set_white_card VALUES (1151, 255);
INSERT INTO card_set_white_card VALUES (1151, 252);
INSERT INTO card_set_white_card VALUES (1151, 253);
INSERT INTO card_set_white_card VALUES (1151, 250);
INSERT INTO card_set_white_card VALUES (1151, 251);
INSERT INTO card_set_white_card VALUES (1151, 248);
INSERT INTO card_set_white_card VALUES (1151, 249);
INSERT INTO card_set_white_card VALUES (1151, 246);
INSERT INTO card_set_white_card VALUES (1151, 247);
INSERT INTO card_set_white_card VALUES (1151, 244);
INSERT INTO card_set_white_card VALUES (1151, 245);
INSERT INTO card_set_white_card VALUES (1151, 242);
INSERT INTO card_set_white_card VALUES (1151, 243);
INSERT INTO card_set_white_card VALUES (1151, 240);
INSERT INTO card_set_white_card VALUES (1151, 241);
INSERT INTO card_set_white_card VALUES (1151, 275);
INSERT INTO card_set_white_card VALUES (1151, 274);
INSERT INTO card_set_white_card VALUES (1151, 273);
INSERT INTO card_set_white_card VALUES (1151, 272);
INSERT INTO card_set_white_card VALUES (1151, 279);
INSERT INTO card_set_white_card VALUES (1151, 278);
INSERT INTO card_set_white_card VALUES (1151, 277);
INSERT INTO card_set_white_card VALUES (1151, 276);
INSERT INTO card_set_white_card VALUES (1151, 283);
INSERT INTO card_set_white_card VALUES (1151, 282);
INSERT INTO card_set_white_card VALUES (1151, 281);
INSERT INTO card_set_white_card VALUES (1151, 280);
INSERT INTO card_set_white_card VALUES (1151, 287);
INSERT INTO card_set_white_card VALUES (1151, 286);
INSERT INTO card_set_white_card VALUES (1151, 285);
INSERT INTO card_set_white_card VALUES (1151, 284);
INSERT INTO card_set_white_card VALUES (1151, 258);
INSERT INTO card_set_white_card VALUES (1151, 259);
INSERT INTO card_set_white_card VALUES (1151, 256);
INSERT INTO card_set_white_card VALUES (1151, 257);
INSERT INTO card_set_white_card VALUES (1151, 262);
INSERT INTO card_set_white_card VALUES (1151, 263);
INSERT INTO card_set_white_card VALUES (1151, 260);
INSERT INTO card_set_white_card VALUES (1151, 261);
INSERT INTO card_set_white_card VALUES (1151, 266);
INSERT INTO card_set_white_card VALUES (1151, 267);
INSERT INTO card_set_white_card VALUES (1151, 264);
INSERT INTO card_set_white_card VALUES (1151, 265);
INSERT INTO card_set_white_card VALUES (1151, 270);
INSERT INTO card_set_white_card VALUES (1151, 271);
INSERT INTO card_set_white_card VALUES (1151, 268);
INSERT INTO card_set_white_card VALUES (1151, 269);
INSERT INTO card_set_white_card VALUES (1151, 305);
INSERT INTO card_set_white_card VALUES (1151, 304);
INSERT INTO card_set_white_card VALUES (1151, 307);
INSERT INTO card_set_white_card VALUES (1151, 306);
INSERT INTO card_set_white_card VALUES (1151, 309);
INSERT INTO card_set_white_card VALUES (1151, 308);
INSERT INTO card_set_white_card VALUES (1151, 311);
INSERT INTO card_set_white_card VALUES (1151, 310);
INSERT INTO card_set_white_card VALUES (1151, 313);
INSERT INTO card_set_white_card VALUES (1151, 312);
INSERT INTO card_set_white_card VALUES (1151, 315);
INSERT INTO card_set_white_card VALUES (1151, 314);
INSERT INTO card_set_white_card VALUES (1151, 317);
INSERT INTO card_set_white_card VALUES (1151, 316);
INSERT INTO card_set_white_card VALUES (1151, 319);
INSERT INTO card_set_white_card VALUES (1151, 318);
INSERT INTO card_set_white_card VALUES (1151, 288);
INSERT INTO card_set_white_card VALUES (1151, 289);
INSERT INTO card_set_white_card VALUES (1151, 290);
INSERT INTO card_set_white_card VALUES (1151, 291);
INSERT INTO card_set_white_card VALUES (1151, 292);
INSERT INTO card_set_white_card VALUES (1151, 293);
INSERT INTO card_set_white_card VALUES (1151, 294);
INSERT INTO card_set_white_card VALUES (1151, 295);
INSERT INTO card_set_white_card VALUES (1151, 296);
INSERT INTO card_set_white_card VALUES (1151, 297);
INSERT INTO card_set_white_card VALUES (1151, 298);
INSERT INTO card_set_white_card VALUES (1151, 299);
INSERT INTO card_set_white_card VALUES (1151, 300);
INSERT INTO card_set_white_card VALUES (1151, 301);
INSERT INTO card_set_white_card VALUES (1151, 302);
INSERT INTO card_set_white_card VALUES (1151, 303);
INSERT INTO card_set_white_card VALUES (1151, 343);
INSERT INTO card_set_white_card VALUES (1151, 342);
INSERT INTO card_set_white_card VALUES (1151, 341);
INSERT INTO card_set_white_card VALUES (1151, 340);
INSERT INTO card_set_white_card VALUES (1151, 339);
INSERT INTO card_set_white_card VALUES (1151, 338);
INSERT INTO card_set_white_card VALUES (1151, 337);
INSERT INTO card_set_white_card VALUES (1151, 336);
INSERT INTO card_set_white_card VALUES (1151, 351);
INSERT INTO card_set_white_card VALUES (1151, 350);
INSERT INTO card_set_white_card VALUES (1151, 349);
INSERT INTO card_set_white_card VALUES (1151, 348);
INSERT INTO card_set_white_card VALUES (1151, 347);
INSERT INTO card_set_white_card VALUES (1151, 346);
INSERT INTO card_set_white_card VALUES (1151, 345);
INSERT INTO card_set_white_card VALUES (1151, 344);
INSERT INTO card_set_white_card VALUES (1151, 326);
INSERT INTO card_set_white_card VALUES (1151, 327);
INSERT INTO card_set_white_card VALUES (1151, 324);
INSERT INTO card_set_white_card VALUES (1151, 325);
INSERT INTO card_set_white_card VALUES (1151, 322);
INSERT INTO card_set_white_card VALUES (1151, 323);
INSERT INTO card_set_white_card VALUES (1151, 320);
INSERT INTO card_set_white_card VALUES (1151, 321);
INSERT INTO card_set_white_card VALUES (1151, 334);
INSERT INTO card_set_white_card VALUES (1151, 335);
INSERT INTO card_set_white_card VALUES (1151, 332);
INSERT INTO card_set_white_card VALUES (1151, 333);
INSERT INTO card_set_white_card VALUES (1151, 330);
INSERT INTO card_set_white_card VALUES (1151, 331);
INSERT INTO card_set_white_card VALUES (1151, 328);
INSERT INTO card_set_white_card VALUES (1151, 329);
INSERT INTO card_set_white_card VALUES (1151, 373);
INSERT INTO card_set_white_card VALUES (1151, 372);
INSERT INTO card_set_white_card VALUES (1151, 375);
INSERT INTO card_set_white_card VALUES (1151, 374);
INSERT INTO card_set_white_card VALUES (1151, 369);
INSERT INTO card_set_white_card VALUES (1151, 368);
INSERT INTO card_set_white_card VALUES (1151, 371);
INSERT INTO card_set_white_card VALUES (1151, 370);
INSERT INTO card_set_white_card VALUES (1151, 381);
INSERT INTO card_set_white_card VALUES (1151, 380);
INSERT INTO card_set_white_card VALUES (1151, 383);
INSERT INTO card_set_white_card VALUES (1151, 382);
INSERT INTO card_set_white_card VALUES (1151, 377);
INSERT INTO card_set_white_card VALUES (1151, 376);
INSERT INTO card_set_white_card VALUES (1151, 379);
INSERT INTO card_set_white_card VALUES (1151, 378);
INSERT INTO card_set_white_card VALUES (1151, 356);
INSERT INTO card_set_white_card VALUES (1151, 357);
INSERT INTO card_set_white_card VALUES (1151, 358);
INSERT INTO card_set_white_card VALUES (1151, 359);
INSERT INTO card_set_white_card VALUES (1151, 352);
INSERT INTO card_set_white_card VALUES (1151, 353);
INSERT INTO card_set_white_card VALUES (1151, 354);
INSERT INTO card_set_white_card VALUES (1151, 355);
INSERT INTO card_set_white_card VALUES (1151, 364);
INSERT INTO card_set_white_card VALUES (1151, 365);
INSERT INTO card_set_white_card VALUES (1151, 366);
INSERT INTO card_set_white_card VALUES (1151, 367);
INSERT INTO card_set_white_card VALUES (1151, 360);
INSERT INTO card_set_white_card VALUES (1151, 361);
INSERT INTO card_set_white_card VALUES (1151, 362);
INSERT INTO card_set_white_card VALUES (1151, 363);
INSERT INTO card_set_white_card VALUES (1151, 410);
INSERT INTO card_set_white_card VALUES (1151, 411);
INSERT INTO card_set_white_card VALUES (1151, 408);
INSERT INTO card_set_white_card VALUES (1151, 409);
INSERT INTO card_set_white_card VALUES (1151, 414);
INSERT INTO card_set_white_card VALUES (1151, 415);
INSERT INTO card_set_white_card VALUES (1151, 412);
INSERT INTO card_set_white_card VALUES (1151, 413);
INSERT INTO card_set_white_card VALUES (1151, 402);
INSERT INTO card_set_white_card VALUES (1151, 403);
INSERT INTO card_set_white_card VALUES (1151, 400);
INSERT INTO card_set_white_card VALUES (1151, 401);
INSERT INTO card_set_white_card VALUES (1151, 406);
INSERT INTO card_set_white_card VALUES (1151, 407);
INSERT INTO card_set_white_card VALUES (1151, 404);
INSERT INTO card_set_white_card VALUES (1151, 405);
INSERT INTO card_set_white_card VALUES (1151, 395);
INSERT INTO card_set_white_card VALUES (1151, 394);
INSERT INTO card_set_white_card VALUES (1151, 393);
INSERT INTO card_set_white_card VALUES (1151, 392);
INSERT INTO card_set_white_card VALUES (1151, 399);
INSERT INTO card_set_white_card VALUES (1151, 398);
INSERT INTO card_set_white_card VALUES (1151, 397);
INSERT INTO card_set_white_card VALUES (1151, 396);
INSERT INTO card_set_white_card VALUES (1151, 387);
INSERT INTO card_set_white_card VALUES (1151, 386);
INSERT INTO card_set_white_card VALUES (1151, 385);
INSERT INTO card_set_white_card VALUES (1151, 384);
INSERT INTO card_set_white_card VALUES (1151, 391);
INSERT INTO card_set_white_card VALUES (1151, 390);
INSERT INTO card_set_white_card VALUES (1151, 389);
INSERT INTO card_set_white_card VALUES (1151, 388);
INSERT INTO card_set_white_card VALUES (1151, 440);
INSERT INTO card_set_white_card VALUES (1151, 441);
INSERT INTO card_set_white_card VALUES (1151, 442);
INSERT INTO card_set_white_card VALUES (1151, 443);
INSERT INTO card_set_white_card VALUES (1151, 444);
INSERT INTO card_set_white_card VALUES (1151, 445);
INSERT INTO card_set_white_card VALUES (1151, 446);
INSERT INTO card_set_white_card VALUES (1151, 447);
INSERT INTO card_set_white_card VALUES (1151, 432);
INSERT INTO card_set_white_card VALUES (1151, 433);
INSERT INTO card_set_white_card VALUES (1151, 434);
INSERT INTO card_set_white_card VALUES (1151, 435);
INSERT INTO card_set_white_card VALUES (1151, 436);
INSERT INTO card_set_white_card VALUES (1151, 437);
INSERT INTO card_set_white_card VALUES (1151, 438);
INSERT INTO card_set_white_card VALUES (1151, 439);
INSERT INTO card_set_white_card VALUES (1151, 425);
INSERT INTO card_set_white_card VALUES (1151, 424);
INSERT INTO card_set_white_card VALUES (1151, 427);
INSERT INTO card_set_white_card VALUES (1151, 426);
INSERT INTO card_set_white_card VALUES (1151, 429);
INSERT INTO card_set_white_card VALUES (1151, 428);
INSERT INTO card_set_white_card VALUES (1151, 431);
INSERT INTO card_set_white_card VALUES (1151, 430);
INSERT INTO card_set_white_card VALUES (1151, 417);
INSERT INTO card_set_white_card VALUES (1151, 416);
INSERT INTO card_set_white_card VALUES (1151, 419);
INSERT INTO card_set_white_card VALUES (1151, 418);
INSERT INTO card_set_white_card VALUES (1151, 421);
INSERT INTO card_set_white_card VALUES (1151, 420);
INSERT INTO card_set_white_card VALUES (1151, 423);
INSERT INTO card_set_white_card VALUES (1151, 422);
INSERT INTO card_set_white_card VALUES (1151, 460);
INSERT INTO card_set_white_card VALUES (1151, 459);
INSERT INTO card_set_white_card VALUES (1151, 458);
INSERT INTO card_set_white_card VALUES (1151, 457);
INSERT INTO card_set_white_card VALUES (1151, 456);
INSERT INTO card_set_white_card VALUES (1151, 455);
INSERT INTO card_set_white_card VALUES (1151, 454);
INSERT INTO card_set_white_card VALUES (1151, 453);
INSERT INTO card_set_white_card VALUES (1151, 452);
INSERT INTO card_set_white_card VALUES (1151, 451);
INSERT INTO card_set_white_card VALUES (1151, 450);
INSERT INTO card_set_white_card VALUES (1151, 449);
INSERT INTO card_set_white_card VALUES (1151, 448);
INSERT INTO card_set_white_card VALUES (1152, 1);
INSERT INTO card_set_white_card VALUES (1152, 2);
INSERT INTO card_set_white_card VALUES (1152, 3);
INSERT INTO card_set_white_card VALUES (1152, 4);
INSERT INTO card_set_white_card VALUES (1152, 5);
INSERT INTO card_set_white_card VALUES (1152, 6);
INSERT INTO card_set_white_card VALUES (1152, 7);
INSERT INTO card_set_white_card VALUES (1152, 10);
INSERT INTO card_set_white_card VALUES (1152, 11);
INSERT INTO card_set_white_card VALUES (1152, 12);
INSERT INTO card_set_white_card VALUES (1152, 13);
INSERT INTO card_set_white_card VALUES (1152, 14);
INSERT INTO card_set_white_card VALUES (1152, 16);
INSERT INTO card_set_white_card VALUES (1152, 19);
INSERT INTO card_set_white_card VALUES (1152, 18);
INSERT INTO card_set_white_card VALUES (1152, 20);
INSERT INTO card_set_white_card VALUES (1152, 23);
INSERT INTO card_set_white_card VALUES (1152, 22);
INSERT INTO card_set_white_card VALUES (1152, 25);
INSERT INTO card_set_white_card VALUES (1152, 24);
INSERT INTO card_set_white_card VALUES (1152, 27);
INSERT INTO card_set_white_card VALUES (1152, 26);
INSERT INTO card_set_white_card VALUES (1152, 29);
INSERT INTO card_set_white_card VALUES (1152, 28);
INSERT INTO card_set_white_card VALUES (1152, 31);
INSERT INTO card_set_white_card VALUES (1152, 30);
INSERT INTO card_set_white_card VALUES (1152, 34);
INSERT INTO card_set_white_card VALUES (1152, 35);
INSERT INTO card_set_white_card VALUES (1152, 32);
INSERT INTO card_set_white_card VALUES (1152, 33);
INSERT INTO card_set_white_card VALUES (1152, 38);
INSERT INTO card_set_white_card VALUES (1152, 39);
INSERT INTO card_set_white_card VALUES (1152, 36);
INSERT INTO card_set_white_card VALUES (1152, 37);
INSERT INTO card_set_white_card VALUES (1152, 42);
INSERT INTO card_set_white_card VALUES (1152, 40);
INSERT INTO card_set_white_card VALUES (1152, 41);
INSERT INTO card_set_white_card VALUES (1152, 46);
INSERT INTO card_set_white_card VALUES (1152, 47);
INSERT INTO card_set_white_card VALUES (1152, 44);
INSERT INTO card_set_white_card VALUES (1152, 45);
INSERT INTO card_set_white_card VALUES (1152, 51);
INSERT INTO card_set_white_card VALUES (1152, 50);
INSERT INTO card_set_white_card VALUES (1152, 49);
INSERT INTO card_set_white_card VALUES (1152, 48);
INSERT INTO card_set_white_card VALUES (1152, 55);
INSERT INTO card_set_white_card VALUES (1152, 54);
INSERT INTO card_set_white_card VALUES (1152, 53);
INSERT INTO card_set_white_card VALUES (1152, 52);
INSERT INTO card_set_white_card VALUES (1152, 59);
INSERT INTO card_set_white_card VALUES (1152, 58);
INSERT INTO card_set_white_card VALUES (1152, 57);
INSERT INTO card_set_white_card VALUES (1152, 56);
INSERT INTO card_set_white_card VALUES (1152, 63);
INSERT INTO card_set_white_card VALUES (1152, 62);
INSERT INTO card_set_white_card VALUES (1152, 61);
INSERT INTO card_set_white_card VALUES (1152, 60);
INSERT INTO card_set_white_card VALUES (1152, 68);
INSERT INTO card_set_white_card VALUES (1152, 70);
INSERT INTO card_set_white_card VALUES (1152, 71);
INSERT INTO card_set_white_card VALUES (1152, 65);
INSERT INTO card_set_white_card VALUES (1152, 66);
INSERT INTO card_set_white_card VALUES (1152, 67);
INSERT INTO card_set_white_card VALUES (1152, 76);
INSERT INTO card_set_white_card VALUES (1152, 77);
INSERT INTO card_set_white_card VALUES (1152, 78);
INSERT INTO card_set_white_card VALUES (1152, 79);
INSERT INTO card_set_white_card VALUES (1152, 72);
INSERT INTO card_set_white_card VALUES (1152, 73);
INSERT INTO card_set_white_card VALUES (1152, 74);
INSERT INTO card_set_white_card VALUES (1152, 75);
INSERT INTO card_set_white_card VALUES (1152, 85);
INSERT INTO card_set_white_card VALUES (1152, 84);
INSERT INTO card_set_white_card VALUES (1152, 87);
INSERT INTO card_set_white_card VALUES (1152, 86);
INSERT INTO card_set_white_card VALUES (1152, 81);
INSERT INTO card_set_white_card VALUES (1152, 80);
INSERT INTO card_set_white_card VALUES (1152, 83);
INSERT INTO card_set_white_card VALUES (1152, 82);
INSERT INTO card_set_white_card VALUES (1152, 93);
INSERT INTO card_set_white_card VALUES (1152, 92);
INSERT INTO card_set_white_card VALUES (1152, 95);
INSERT INTO card_set_white_card VALUES (1152, 94);
INSERT INTO card_set_white_card VALUES (1152, 89);
INSERT INTO card_set_white_card VALUES (1152, 88);
INSERT INTO card_set_white_card VALUES (1152, 91);
INSERT INTO card_set_white_card VALUES (1152, 90);
INSERT INTO card_set_white_card VALUES (1152, 102);
INSERT INTO card_set_white_card VALUES (1152, 103);
INSERT INTO card_set_white_card VALUES (1152, 101);
INSERT INTO card_set_white_card VALUES (1152, 98);
INSERT INTO card_set_white_card VALUES (1152, 99);
INSERT INTO card_set_white_card VALUES (1152, 96);
INSERT INTO card_set_white_card VALUES (1152, 97);
INSERT INTO card_set_white_card VALUES (1152, 111);
INSERT INTO card_set_white_card VALUES (1152, 108);
INSERT INTO card_set_white_card VALUES (1152, 109);
INSERT INTO card_set_white_card VALUES (1152, 106);
INSERT INTO card_set_white_card VALUES (1152, 107);
INSERT INTO card_set_white_card VALUES (1152, 104);
INSERT INTO card_set_white_card VALUES (1152, 105);
INSERT INTO card_set_white_card VALUES (1152, 119);
INSERT INTO card_set_white_card VALUES (1152, 118);
INSERT INTO card_set_white_card VALUES (1152, 117);
INSERT INTO card_set_white_card VALUES (1152, 116);
INSERT INTO card_set_white_card VALUES (1152, 115);
INSERT INTO card_set_white_card VALUES (1152, 114);
INSERT INTO card_set_white_card VALUES (1152, 113);
INSERT INTO card_set_white_card VALUES (1152, 112);
INSERT INTO card_set_white_card VALUES (1152, 127);
INSERT INTO card_set_white_card VALUES (1152, 126);
INSERT INTO card_set_white_card VALUES (1152, 125);
INSERT INTO card_set_white_card VALUES (1152, 124);
INSERT INTO card_set_white_card VALUES (1152, 122);
INSERT INTO card_set_white_card VALUES (1152, 121);
INSERT INTO card_set_white_card VALUES (1152, 137);
INSERT INTO card_set_white_card VALUES (1152, 136);
INSERT INTO card_set_white_card VALUES (1152, 139);
INSERT INTO card_set_white_card VALUES (1152, 138);
INSERT INTO card_set_white_card VALUES (1152, 141);
INSERT INTO card_set_white_card VALUES (1152, 140);
INSERT INTO card_set_white_card VALUES (1152, 142);
INSERT INTO card_set_white_card VALUES (1152, 129);
INSERT INTO card_set_white_card VALUES (1152, 128);
INSERT INTO card_set_white_card VALUES (1152, 132);
INSERT INTO card_set_white_card VALUES (1152, 135);
INSERT INTO card_set_white_card VALUES (1152, 134);
INSERT INTO card_set_white_card VALUES (1152, 152);
INSERT INTO card_set_white_card VALUES (1152, 153);
INSERT INTO card_set_white_card VALUES (1152, 154);
INSERT INTO card_set_white_card VALUES (1152, 155);
INSERT INTO card_set_white_card VALUES (1152, 157);
INSERT INTO card_set_white_card VALUES (1152, 159);
INSERT INTO card_set_white_card VALUES (1152, 144);
INSERT INTO card_set_white_card VALUES (1152, 145);
INSERT INTO card_set_white_card VALUES (1152, 146);
INSERT INTO card_set_white_card VALUES (1152, 147);
INSERT INTO card_set_white_card VALUES (1152, 148);
INSERT INTO card_set_white_card VALUES (1152, 149);
INSERT INTO card_set_white_card VALUES (1152, 150);
INSERT INTO card_set_white_card VALUES (1152, 151);
INSERT INTO card_set_white_card VALUES (1152, 171);
INSERT INTO card_set_white_card VALUES (1152, 170);
INSERT INTO card_set_white_card VALUES (1152, 169);
INSERT INTO card_set_white_card VALUES (1152, 168);
INSERT INTO card_set_white_card VALUES (1152, 175);
INSERT INTO card_set_white_card VALUES (1152, 174);
INSERT INTO card_set_white_card VALUES (1152, 173);
INSERT INTO card_set_white_card VALUES (1152, 172);
INSERT INTO card_set_white_card VALUES (1152, 163);
INSERT INTO card_set_white_card VALUES (1152, 162);
INSERT INTO card_set_white_card VALUES (1152, 161);
INSERT INTO card_set_white_card VALUES (1152, 160);
INSERT INTO card_set_white_card VALUES (1152, 167);
INSERT INTO card_set_white_card VALUES (1152, 166);
INSERT INTO card_set_white_card VALUES (1152, 165);
INSERT INTO card_set_white_card VALUES (1152, 186);
INSERT INTO card_set_white_card VALUES (1152, 187);
INSERT INTO card_set_white_card VALUES (1152, 184);
INSERT INTO card_set_white_card VALUES (1152, 185);
INSERT INTO card_set_white_card VALUES (1152, 191);
INSERT INTO card_set_white_card VALUES (1152, 189);
INSERT INTO card_set_white_card VALUES (1152, 178);
INSERT INTO card_set_white_card VALUES (1152, 179);
INSERT INTO card_set_white_card VALUES (1152, 176);
INSERT INTO card_set_white_card VALUES (1152, 182);
INSERT INTO card_set_white_card VALUES (1152, 183);
INSERT INTO card_set_white_card VALUES (1152, 180);
INSERT INTO card_set_white_card VALUES (1152, 181);
INSERT INTO card_set_white_card VALUES (1152, 205);
INSERT INTO card_set_white_card VALUES (1152, 204);
INSERT INTO card_set_white_card VALUES (1152, 207);
INSERT INTO card_set_white_card VALUES (1152, 206);
INSERT INTO card_set_white_card VALUES (1152, 201);
INSERT INTO card_set_white_card VALUES (1152, 200);
INSERT INTO card_set_white_card VALUES (1152, 203);
INSERT INTO card_set_white_card VALUES (1152, 202);
INSERT INTO card_set_white_card VALUES (1152, 197);
INSERT INTO card_set_white_card VALUES (1152, 196);
INSERT INTO card_set_white_card VALUES (1152, 199);
INSERT INTO card_set_white_card VALUES (1152, 198);
INSERT INTO card_set_white_card VALUES (1152, 193);
INSERT INTO card_set_white_card VALUES (1152, 192);
INSERT INTO card_set_white_card VALUES (1152, 195);
INSERT INTO card_set_white_card VALUES (1152, 194);
INSERT INTO card_set_white_card VALUES (1152, 220);
INSERT INTO card_set_white_card VALUES (1152, 221);
INSERT INTO card_set_white_card VALUES (1152, 222);
INSERT INTO card_set_white_card VALUES (1152, 223);
INSERT INTO card_set_white_card VALUES (1152, 217);
INSERT INTO card_set_white_card VALUES (1152, 218);
INSERT INTO card_set_white_card VALUES (1152, 219);
INSERT INTO card_set_white_card VALUES (1152, 212);
INSERT INTO card_set_white_card VALUES (1152, 213);
INSERT INTO card_set_white_card VALUES (1152, 214);
INSERT INTO card_set_white_card VALUES (1152, 215);
INSERT INTO card_set_white_card VALUES (1152, 208);
INSERT INTO card_set_white_card VALUES (1152, 209);
INSERT INTO card_set_white_card VALUES (1152, 210);
INSERT INTO card_set_white_card VALUES (1152, 211);
INSERT INTO card_set_white_card VALUES (1152, 239);
INSERT INTO card_set_white_card VALUES (1152, 238);
INSERT INTO card_set_white_card VALUES (1152, 237);
INSERT INTO card_set_white_card VALUES (1152, 236);
INSERT INTO card_set_white_card VALUES (1152, 235);
INSERT INTO card_set_white_card VALUES (1152, 234);
INSERT INTO card_set_white_card VALUES (1152, 233);
INSERT INTO card_set_white_card VALUES (1152, 232);
INSERT INTO card_set_white_card VALUES (1152, 231);
INSERT INTO card_set_white_card VALUES (1152, 230);
INSERT INTO card_set_white_card VALUES (1152, 229);
INSERT INTO card_set_white_card VALUES (1152, 228);
INSERT INTO card_set_white_card VALUES (1152, 227);
INSERT INTO card_set_white_card VALUES (1152, 226);
INSERT INTO card_set_white_card VALUES (1152, 225);
INSERT INTO card_set_white_card VALUES (1152, 224);
INSERT INTO card_set_white_card VALUES (1152, 254);
INSERT INTO card_set_white_card VALUES (1152, 255);
INSERT INTO card_set_white_card VALUES (1152, 252);
INSERT INTO card_set_white_card VALUES (1152, 253);
INSERT INTO card_set_white_card VALUES (1152, 250);
INSERT INTO card_set_white_card VALUES (1152, 251);
INSERT INTO card_set_white_card VALUES (1152, 249);
INSERT INTO card_set_white_card VALUES (1152, 246);
INSERT INTO card_set_white_card VALUES (1152, 244);
INSERT INTO card_set_white_card VALUES (1152, 245);
INSERT INTO card_set_white_card VALUES (1152, 242);
INSERT INTO card_set_white_card VALUES (1152, 243);
INSERT INTO card_set_white_card VALUES (1152, 240);
INSERT INTO card_set_white_card VALUES (1152, 241);
INSERT INTO card_set_white_card VALUES (1152, 275);
INSERT INTO card_set_white_card VALUES (1152, 274);
INSERT INTO card_set_white_card VALUES (1152, 272);
INSERT INTO card_set_white_card VALUES (1152, 279);
INSERT INTO card_set_white_card VALUES (1152, 278);
INSERT INTO card_set_white_card VALUES (1152, 277);
INSERT INTO card_set_white_card VALUES (1152, 276);
INSERT INTO card_set_white_card VALUES (1152, 283);
INSERT INTO card_set_white_card VALUES (1152, 282);
INSERT INTO card_set_white_card VALUES (1152, 280);
INSERT INTO card_set_white_card VALUES (1152, 287);
INSERT INTO card_set_white_card VALUES (1152, 286);
INSERT INTO card_set_white_card VALUES (1152, 284);
INSERT INTO card_set_white_card VALUES (1152, 258);
INSERT INTO card_set_white_card VALUES (1152, 259);
INSERT INTO card_set_white_card VALUES (1152, 256);
INSERT INTO card_set_white_card VALUES (1152, 257);
INSERT INTO card_set_white_card VALUES (1152, 262);
INSERT INTO card_set_white_card VALUES (1152, 263);
INSERT INTO card_set_white_card VALUES (1152, 260);
INSERT INTO card_set_white_card VALUES (1152, 261);
INSERT INTO card_set_white_card VALUES (1152, 266);
INSERT INTO card_set_white_card VALUES (1152, 267);
INSERT INTO card_set_white_card VALUES (1152, 265);
INSERT INTO card_set_white_card VALUES (1152, 270);
INSERT INTO card_set_white_card VALUES (1152, 271);
INSERT INTO card_set_white_card VALUES (1152, 268);
INSERT INTO card_set_white_card VALUES (1152, 269);
INSERT INTO card_set_white_card VALUES (1152, 305);
INSERT INTO card_set_white_card VALUES (1152, 304);
INSERT INTO card_set_white_card VALUES (1152, 306);
INSERT INTO card_set_white_card VALUES (1152, 309);
INSERT INTO card_set_white_card VALUES (1152, 308);
INSERT INTO card_set_white_card VALUES (1152, 311);
INSERT INTO card_set_white_card VALUES (1152, 312);
INSERT INTO card_set_white_card VALUES (1152, 315);
INSERT INTO card_set_white_card VALUES (1152, 314);
INSERT INTO card_set_white_card VALUES (1152, 317);
INSERT INTO card_set_white_card VALUES (1152, 316);
INSERT INTO card_set_white_card VALUES (1152, 319);
INSERT INTO card_set_white_card VALUES (1152, 318);
INSERT INTO card_set_white_card VALUES (1152, 289);
INSERT INTO card_set_white_card VALUES (1152, 290);
INSERT INTO card_set_white_card VALUES (1152, 291);
INSERT INTO card_set_white_card VALUES (1152, 292);
INSERT INTO card_set_white_card VALUES (1152, 293);
INSERT INTO card_set_white_card VALUES (1152, 294);
INSERT INTO card_set_white_card VALUES (1152, 295);
INSERT INTO card_set_white_card VALUES (1152, 296);
INSERT INTO card_set_white_card VALUES (1152, 297);
INSERT INTO card_set_white_card VALUES (1152, 298);
INSERT INTO card_set_white_card VALUES (1152, 299);
INSERT INTO card_set_white_card VALUES (1152, 300);
INSERT INTO card_set_white_card VALUES (1152, 302);
INSERT INTO card_set_white_card VALUES (1152, 303);
INSERT INTO card_set_white_card VALUES (1152, 343);
INSERT INTO card_set_white_card VALUES (1152, 340);
INSERT INTO card_set_white_card VALUES (1152, 339);
INSERT INTO card_set_white_card VALUES (1152, 337);
INSERT INTO card_set_white_card VALUES (1152, 336);
INSERT INTO card_set_white_card VALUES (1152, 351);
INSERT INTO card_set_white_card VALUES (1152, 349);
INSERT INTO card_set_white_card VALUES (1152, 348);
INSERT INTO card_set_white_card VALUES (1152, 347);
INSERT INTO card_set_white_card VALUES (1152, 346);
INSERT INTO card_set_white_card VALUES (1152, 345);
INSERT INTO card_set_white_card VALUES (1152, 344);
INSERT INTO card_set_white_card VALUES (1152, 326);
INSERT INTO card_set_white_card VALUES (1152, 327);
INSERT INTO card_set_white_card VALUES (1152, 324);
INSERT INTO card_set_white_card VALUES (1152, 325);
INSERT INTO card_set_white_card VALUES (1152, 322);
INSERT INTO card_set_white_card VALUES (1152, 323);
INSERT INTO card_set_white_card VALUES (1152, 320);
INSERT INTO card_set_white_card VALUES (1152, 321);
INSERT INTO card_set_white_card VALUES (1152, 334);
INSERT INTO card_set_white_card VALUES (1152, 335);
INSERT INTO card_set_white_card VALUES (1152, 332);
INSERT INTO card_set_white_card VALUES (1152, 330);
INSERT INTO card_set_white_card VALUES (1152, 329);
INSERT INTO card_set_white_card VALUES (1152, 373);
INSERT INTO card_set_white_card VALUES (1152, 372);
INSERT INTO card_set_white_card VALUES (1152, 375);
INSERT INTO card_set_white_card VALUES (1152, 374);
INSERT INTO card_set_white_card VALUES (1152, 369);
INSERT INTO card_set_white_card VALUES (1152, 368);
INSERT INTO card_set_white_card VALUES (1152, 370);
INSERT INTO card_set_white_card VALUES (1152, 381);
INSERT INTO card_set_white_card VALUES (1152, 380);
INSERT INTO card_set_white_card VALUES (1152, 382);
INSERT INTO card_set_white_card VALUES (1152, 377);
INSERT INTO card_set_white_card VALUES (1152, 376);
INSERT INTO card_set_white_card VALUES (1152, 379);
INSERT INTO card_set_white_card VALUES (1152, 378);
INSERT INTO card_set_white_card VALUES (1152, 356);
INSERT INTO card_set_white_card VALUES (1152, 357);
INSERT INTO card_set_white_card VALUES (1152, 358);
INSERT INTO card_set_white_card VALUES (1152, 359);
INSERT INTO card_set_white_card VALUES (1152, 352);
INSERT INTO card_set_white_card VALUES (1152, 354);
INSERT INTO card_set_white_card VALUES (1152, 355);
INSERT INTO card_set_white_card VALUES (1152, 364);
INSERT INTO card_set_white_card VALUES (1152, 365);
INSERT INTO card_set_white_card VALUES (1152, 366);
INSERT INTO card_set_white_card VALUES (1152, 367);
INSERT INTO card_set_white_card VALUES (1152, 360);
INSERT INTO card_set_white_card VALUES (1152, 361);
INSERT INTO card_set_white_card VALUES (1152, 362);
INSERT INTO card_set_white_card VALUES (1152, 410);
INSERT INTO card_set_white_card VALUES (1152, 411);
INSERT INTO card_set_white_card VALUES (1152, 408);
INSERT INTO card_set_white_card VALUES (1152, 409);
INSERT INTO card_set_white_card VALUES (1152, 414);
INSERT INTO card_set_white_card VALUES (1152, 415);
INSERT INTO card_set_white_card VALUES (1152, 412);
INSERT INTO card_set_white_card VALUES (1152, 413);
INSERT INTO card_set_white_card VALUES (1152, 402);
INSERT INTO card_set_white_card VALUES (1152, 400);
INSERT INTO card_set_white_card VALUES (1152, 401);
INSERT INTO card_set_white_card VALUES (1152, 406);
INSERT INTO card_set_white_card VALUES (1152, 407);
INSERT INTO card_set_white_card VALUES (1152, 404);
INSERT INTO card_set_white_card VALUES (1152, 405);
INSERT INTO card_set_white_card VALUES (1152, 395);
INSERT INTO card_set_white_card VALUES (1152, 394);
INSERT INTO card_set_white_card VALUES (1152, 393);
INSERT INTO card_set_white_card VALUES (1152, 392);
INSERT INTO card_set_white_card VALUES (1152, 399);
INSERT INTO card_set_white_card VALUES (1152, 398);
INSERT INTO card_set_white_card VALUES (1152, 397);
INSERT INTO card_set_white_card VALUES (1152, 396);
INSERT INTO card_set_white_card VALUES (1152, 387);
INSERT INTO card_set_white_card VALUES (1152, 386);
INSERT INTO card_set_white_card VALUES (1152, 385);
INSERT INTO card_set_white_card VALUES (1152, 384);
INSERT INTO card_set_white_card VALUES (1152, 391);
INSERT INTO card_set_white_card VALUES (1152, 390);
INSERT INTO card_set_white_card VALUES (1152, 389);
INSERT INTO card_set_white_card VALUES (1152, 388);
INSERT INTO card_set_white_card VALUES (1152, 440);
INSERT INTO card_set_white_card VALUES (1152, 441);
INSERT INTO card_set_white_card VALUES (1152, 442);
INSERT INTO card_set_white_card VALUES (1152, 443);
INSERT INTO card_set_white_card VALUES (1152, 444);
INSERT INTO card_set_white_card VALUES (1152, 445);
INSERT INTO card_set_white_card VALUES (1152, 446);
INSERT INTO card_set_white_card VALUES (1152, 447);
INSERT INTO card_set_white_card VALUES (1152, 432);
INSERT INTO card_set_white_card VALUES (1152, 433);
INSERT INTO card_set_white_card VALUES (1152, 434);
INSERT INTO card_set_white_card VALUES (1152, 435);
INSERT INTO card_set_white_card VALUES (1152, 436);
INSERT INTO card_set_white_card VALUES (1152, 437);
INSERT INTO card_set_white_card VALUES (1152, 438);
INSERT INTO card_set_white_card VALUES (1152, 439);
INSERT INTO card_set_white_card VALUES (1152, 425);
INSERT INTO card_set_white_card VALUES (1152, 427);
INSERT INTO card_set_white_card VALUES (1152, 426);
INSERT INTO card_set_white_card VALUES (1152, 429);
INSERT INTO card_set_white_card VALUES (1152, 431);
INSERT INTO card_set_white_card VALUES (1152, 430);
INSERT INTO card_set_white_card VALUES (1152, 417);
INSERT INTO card_set_white_card VALUES (1152, 416);
INSERT INTO card_set_white_card VALUES (1152, 419);
INSERT INTO card_set_white_card VALUES (1152, 418);
INSERT INTO card_set_white_card VALUES (1152, 421);
INSERT INTO card_set_white_card VALUES (1152, 420);
INSERT INTO card_set_white_card VALUES (1152, 423);
INSERT INTO card_set_white_card VALUES (1152, 422);
INSERT INTO card_set_white_card VALUES (1152, 478);
INSERT INTO card_set_white_card VALUES (1152, 479);
INSERT INTO card_set_white_card VALUES (1152, 476);
INSERT INTO card_set_white_card VALUES (1152, 477);
INSERT INTO card_set_white_card VALUES (1152, 474);
INSERT INTO card_set_white_card VALUES (1152, 475);
INSERT INTO card_set_white_card VALUES (1152, 472);
INSERT INTO card_set_white_card VALUES (1152, 473);
INSERT INTO card_set_white_card VALUES (1152, 470);
INSERT INTO card_set_white_card VALUES (1152, 471);
INSERT INTO card_set_white_card VALUES (1152, 468);
INSERT INTO card_set_white_card VALUES (1152, 469);
INSERT INTO card_set_white_card VALUES (1152, 466);
INSERT INTO card_set_white_card VALUES (1152, 467);
INSERT INTO card_set_white_card VALUES (1152, 464);
INSERT INTO card_set_white_card VALUES (1152, 465);
INSERT INTO card_set_white_card VALUES (1152, 463);
INSERT INTO card_set_white_card VALUES (1152, 462);
INSERT INTO card_set_white_card VALUES (1152, 461);
INSERT INTO card_set_white_card VALUES (1152, 460);
INSERT INTO card_set_white_card VALUES (1152, 459);
INSERT INTO card_set_white_card VALUES (1152, 458);
INSERT INTO card_set_white_card VALUES (1152, 457);
INSERT INTO card_set_white_card VALUES (1152, 456);
INSERT INTO card_set_white_card VALUES (1152, 455);
INSERT INTO card_set_white_card VALUES (1152, 453);
INSERT INTO card_set_white_card VALUES (1152, 452);
INSERT INTO card_set_white_card VALUES (1152, 451);
INSERT INTO card_set_white_card VALUES (1152, 450);
INSERT INTO card_set_white_card VALUES (1152, 449);
INSERT INTO card_set_white_card VALUES (1152, 448);
INSERT INTO card_set_white_card VALUES (1152, 508);
INSERT INTO card_set_white_card VALUES (1152, 504);
INSERT INTO card_set_white_card VALUES (1152, 505);
INSERT INTO card_set_white_card VALUES (1152, 506);
INSERT INTO card_set_white_card VALUES (1152, 507);
INSERT INTO card_set_white_card VALUES (1152, 500);
INSERT INTO card_set_white_card VALUES (1152, 501);
INSERT INTO card_set_white_card VALUES (1152, 502);
INSERT INTO card_set_white_card VALUES (1152, 503);
INSERT INTO card_set_white_card VALUES (1152, 496);
INSERT INTO card_set_white_card VALUES (1152, 497);
INSERT INTO card_set_white_card VALUES (1152, 498);
INSERT INTO card_set_white_card VALUES (1152, 499);
INSERT INTO card_set_white_card VALUES (1152, 493);
INSERT INTO card_set_white_card VALUES (1152, 492);
INSERT INTO card_set_white_card VALUES (1152, 495);
INSERT INTO card_set_white_card VALUES (1152, 494);
INSERT INTO card_set_white_card VALUES (1152, 489);
INSERT INTO card_set_white_card VALUES (1152, 488);
INSERT INTO card_set_white_card VALUES (1152, 491);
INSERT INTO card_set_white_card VALUES (1152, 490);
INSERT INTO card_set_white_card VALUES (1152, 485);
INSERT INTO card_set_white_card VALUES (1152, 484);
INSERT INTO card_set_white_card VALUES (1152, 487);
INSERT INTO card_set_white_card VALUES (1152, 486);
INSERT INTO card_set_white_card VALUES (1152, 481);
INSERT INTO card_set_white_card VALUES (1152, 480);
INSERT INTO card_set_white_card VALUES (1152, 483);
INSERT INTO card_set_white_card VALUES (1152, 482);
INSERT INTO card_set_white_card VALUES (1153, 1016);
INSERT INTO card_set_white_card VALUES (1153, 1017);
INSERT INTO card_set_white_card VALUES (1153, 1018);
INSERT INTO card_set_white_card VALUES (1153, 1019);
INSERT INTO card_set_white_card VALUES (1153, 1020);
INSERT INTO card_set_white_card VALUES (1153, 1021);
INSERT INTO card_set_white_card VALUES (1153, 1022);
INSERT INTO card_set_white_card VALUES (1153, 1023);
INSERT INTO card_set_white_card VALUES (1153, 1024);
INSERT INTO card_set_white_card VALUES (1153, 1025);
INSERT INTO card_set_white_card VALUES (1153, 1026);
INSERT INTO card_set_white_card VALUES (1153, 1010);
INSERT INTO card_set_white_card VALUES (1153, 1027);
INSERT INTO card_set_white_card VALUES (1153, 1011);
INSERT INTO card_set_white_card VALUES (1153, 1028);
INSERT INTO card_set_white_card VALUES (1153, 1012);
INSERT INTO card_set_white_card VALUES (1153, 1029);
INSERT INTO card_set_white_card VALUES (1153, 1013);
INSERT INTO card_set_white_card VALUES (1153, 1030);
INSERT INTO card_set_white_card VALUES (1153, 1014);
INSERT INTO card_set_white_card VALUES (1153, 1015);
INSERT INTO card_set_white_card VALUES (1154, 1034);
INSERT INTO card_set_white_card VALUES (1154, 1035);
INSERT INTO card_set_white_card VALUES (1154, 1036);
INSERT INTO card_set_white_card VALUES (1154, 1037);
INSERT INTO card_set_white_card VALUES (1154, 1038);
INSERT INTO card_set_white_card VALUES (1154, 1039);
INSERT INTO card_set_white_card VALUES (1154, 1041);
INSERT INTO card_set_white_card VALUES (1154, 1040);
INSERT INTO card_set_white_card VALUES (1154, 1042);
INSERT INTO card_set_white_card VALUES (1155, 1100);
INSERT INTO card_set_white_card VALUES (1155, 1101);
INSERT INTO card_set_white_card VALUES (1155, 1102);
INSERT INTO card_set_white_card VALUES (1155, 1103);
INSERT INTO card_set_white_card VALUES (1155, 1096);
INSERT INTO card_set_white_card VALUES (1155, 1097);
INSERT INTO card_set_white_card VALUES (1155, 1098);
INSERT INTO card_set_white_card VALUES (1155, 1099);
INSERT INTO card_set_white_card VALUES (1155, 1092);
INSERT INTO card_set_white_card VALUES (1155, 1093);
INSERT INTO card_set_white_card VALUES (1155, 1094);
INSERT INTO card_set_white_card VALUES (1155, 1095);
INSERT INTO card_set_white_card VALUES (1155, 1088);
INSERT INTO card_set_white_card VALUES (1155, 1089);
INSERT INTO card_set_white_card VALUES (1155, 1090);
INSERT INTO card_set_white_card VALUES (1155, 1091);
INSERT INTO card_set_white_card VALUES (1155, 1117);
INSERT INTO card_set_white_card VALUES (1155, 1116);
INSERT INTO card_set_white_card VALUES (1155, 1119);
INSERT INTO card_set_white_card VALUES (1155, 1118);
INSERT INTO card_set_white_card VALUES (1155, 1113);
INSERT INTO card_set_white_card VALUES (1155, 1112);
INSERT INTO card_set_white_card VALUES (1155, 1115);
INSERT INTO card_set_white_card VALUES (1155, 1114);
INSERT INTO card_set_white_card VALUES (1155, 1109);
INSERT INTO card_set_white_card VALUES (1155, 1108);
INSERT INTO card_set_white_card VALUES (1155, 1111);
INSERT INTO card_set_white_card VALUES (1155, 1110);
INSERT INTO card_set_white_card VALUES (1155, 1105);
INSERT INTO card_set_white_card VALUES (1155, 1104);
INSERT INTO card_set_white_card VALUES (1155, 1107);
INSERT INTO card_set_white_card VALUES (1155, 1106);
INSERT INTO card_set_white_card VALUES (1155, 1134);
INSERT INTO card_set_white_card VALUES (1155, 1135);
INSERT INTO card_set_white_card VALUES (1155, 1132);
INSERT INTO card_set_white_card VALUES (1155, 1133);
INSERT INTO card_set_white_card VALUES (1155, 1130);
INSERT INTO card_set_white_card VALUES (1155, 1131);
INSERT INTO card_set_white_card VALUES (1155, 1128);
INSERT INTO card_set_white_card VALUES (1155, 1129);
INSERT INTO card_set_white_card VALUES (1155, 1126);
INSERT INTO card_set_white_card VALUES (1155, 1127);
INSERT INTO card_set_white_card VALUES (1155, 1124);
INSERT INTO card_set_white_card VALUES (1155, 1125);
INSERT INTO card_set_white_card VALUES (1155, 1122);
INSERT INTO card_set_white_card VALUES (1155, 1123);
INSERT INTO card_set_white_card VALUES (1155, 1120);
INSERT INTO card_set_white_card VALUES (1155, 1121);
INSERT INTO card_set_white_card VALUES (1155, 1145);
INSERT INTO card_set_white_card VALUES (1155, 1144);
INSERT INTO card_set_white_card VALUES (1155, 1143);
INSERT INTO card_set_white_card VALUES (1155, 1142);
INSERT INTO card_set_white_card VALUES (1155, 1141);
INSERT INTO card_set_white_card VALUES (1155, 1140);
INSERT INTO card_set_white_card VALUES (1155, 1139);
INSERT INTO card_set_white_card VALUES (1155, 1138);
INSERT INTO card_set_white_card VALUES (1155, 1137);
INSERT INTO card_set_white_card VALUES (1155, 1136);
INSERT INTO card_set_white_card VALUES (1155, 1066);
INSERT INTO card_set_white_card VALUES (1155, 1067);
INSERT INTO card_set_white_card VALUES (1155, 1070);
INSERT INTO card_set_white_card VALUES (1155, 1071);
INSERT INTO card_set_white_card VALUES (1155, 1068);
INSERT INTO card_set_white_card VALUES (1155, 1069);
INSERT INTO card_set_white_card VALUES (1155, 1083);
INSERT INTO card_set_white_card VALUES (1155, 1082);
INSERT INTO card_set_white_card VALUES (1155, 1081);
INSERT INTO card_set_white_card VALUES (1155, 1080);
INSERT INTO card_set_white_card VALUES (1155, 1087);
INSERT INTO card_set_white_card VALUES (1155, 1086);
INSERT INTO card_set_white_card VALUES (1155, 1085);
INSERT INTO card_set_white_card VALUES (1155, 1084);
INSERT INTO card_set_white_card VALUES (1155, 1075);
INSERT INTO card_set_white_card VALUES (1155, 1074);
INSERT INTO card_set_white_card VALUES (1155, 1073);
INSERT INTO card_set_white_card VALUES (1155, 1072);
INSERT INTO card_set_white_card VALUES (1155, 1079);
INSERT INTO card_set_white_card VALUES (1155, 1078);
INSERT INTO card_set_white_card VALUES (1155, 1077);
INSERT INTO card_set_white_card VALUES (1155, 1076);
INSERT INTO card_set_white_card VALUES (1256, 1221);
INSERT INTO card_set_white_card VALUES (1256, 1220);
INSERT INTO card_set_white_card VALUES (1256, 1223);
INSERT INTO card_set_white_card VALUES (1256, 1222);
INSERT INTO card_set_white_card VALUES (1256, 1217);
INSERT INTO card_set_white_card VALUES (1256, 1216);
INSERT INTO card_set_white_card VALUES (1256, 1219);
INSERT INTO card_set_white_card VALUES (1256, 1218);
INSERT INTO card_set_white_card VALUES (1256, 1229);
INSERT INTO card_set_white_card VALUES (1256, 1228);
INSERT INTO card_set_white_card VALUES (1256, 1231);
INSERT INTO card_set_white_card VALUES (1256, 1230);
INSERT INTO card_set_white_card VALUES (1256, 1225);
INSERT INTO card_set_white_card VALUES (1256, 1224);
INSERT INTO card_set_white_card VALUES (1256, 1227);
INSERT INTO card_set_white_card VALUES (1256, 1226);
INSERT INTO card_set_white_card VALUES (1256, 1236);
INSERT INTO card_set_white_card VALUES (1256, 1237);
INSERT INTO card_set_white_card VALUES (1256, 1238);
INSERT INTO card_set_white_card VALUES (1256, 1239);
INSERT INTO card_set_white_card VALUES (1256, 1232);
INSERT INTO card_set_white_card VALUES (1256, 1233);
INSERT INTO card_set_white_card VALUES (1256, 1234);
INSERT INTO card_set_white_card VALUES (1256, 1235);
INSERT INTO card_set_white_card VALUES (1256, 1244);
INSERT INTO card_set_white_card VALUES (1256, 1245);
INSERT INTO card_set_white_card VALUES (1256, 1246);
INSERT INTO card_set_white_card VALUES (1256, 1247);
INSERT INTO card_set_white_card VALUES (1256, 1240);
INSERT INTO card_set_white_card VALUES (1256, 1241);
INSERT INTO card_set_white_card VALUES (1256, 1242);
INSERT INTO card_set_white_card VALUES (1256, 1243);
INSERT INTO card_set_white_card VALUES (1256, 1255);
INSERT INTO card_set_white_card VALUES (1256, 1254);
INSERT INTO card_set_white_card VALUES (1256, 1253);
INSERT INTO card_set_white_card VALUES (1256, 1252);
INSERT INTO card_set_white_card VALUES (1256, 1251);
INSERT INTO card_set_white_card VALUES (1256, 1250);
INSERT INTO card_set_white_card VALUES (1256, 1249);
INSERT INTO card_set_white_card VALUES (1256, 1248);
INSERT INTO card_set_white_card VALUES (1256, 1181);
INSERT INTO card_set_white_card VALUES (1256, 1182);
INSERT INTO card_set_white_card VALUES (1256, 1183);
INSERT INTO card_set_white_card VALUES (1256, 1187);
INSERT INTO card_set_white_card VALUES (1256, 1186);
INSERT INTO card_set_white_card VALUES (1256, 1185);
INSERT INTO card_set_white_card VALUES (1256, 1184);
INSERT INTO card_set_white_card VALUES (1256, 1191);
INSERT INTO card_set_white_card VALUES (1256, 1190);
INSERT INTO card_set_white_card VALUES (1256, 1189);
INSERT INTO card_set_white_card VALUES (1256, 1188);
INSERT INTO card_set_white_card VALUES (1256, 1195);
INSERT INTO card_set_white_card VALUES (1256, 1194);
INSERT INTO card_set_white_card VALUES (1256, 1193);
INSERT INTO card_set_white_card VALUES (1256, 1192);
INSERT INTO card_set_white_card VALUES (1256, 1199);
INSERT INTO card_set_white_card VALUES (1256, 1198);
INSERT INTO card_set_white_card VALUES (1256, 1197);
INSERT INTO card_set_white_card VALUES (1256, 1196);
INSERT INTO card_set_white_card VALUES (1256, 1202);
INSERT INTO card_set_white_card VALUES (1256, 1203);
INSERT INTO card_set_white_card VALUES (1256, 1200);
INSERT INTO card_set_white_card VALUES (1256, 1201);
INSERT INTO card_set_white_card VALUES (1256, 1206);
INSERT INTO card_set_white_card VALUES (1256, 1207);
INSERT INTO card_set_white_card VALUES (1256, 1204);
INSERT INTO card_set_white_card VALUES (1256, 1205);
INSERT INTO card_set_white_card VALUES (1256, 1210);
INSERT INTO card_set_white_card VALUES (1256, 1211);
INSERT INTO card_set_white_card VALUES (1256, 1208);
INSERT INTO card_set_white_card VALUES (1256, 1209);
INSERT INTO card_set_white_card VALUES (1256, 1214);
INSERT INTO card_set_white_card VALUES (1256, 1215);
INSERT INTO card_set_white_card VALUES (1256, 1212);
INSERT INTO card_set_white_card VALUES (1256, 1213);
INSERT INTO card_set_white_card VALUES (1488, 1464);
INSERT INTO card_set_white_card VALUES (1488, 1465);
INSERT INTO card_set_white_card VALUES (1488, 1466);
INSERT INTO card_set_white_card VALUES (1488, 1467);
INSERT INTO card_set_white_card VALUES (1488, 1468);
INSERT INTO card_set_white_card VALUES (1488, 1469);
INSERT INTO card_set_white_card VALUES (1488, 1470);
INSERT INTO card_set_white_card VALUES (1488, 1471);
INSERT INTO card_set_white_card VALUES (1488, 1479);
INSERT INTO card_set_white_card VALUES (1488, 1478);
INSERT INTO card_set_white_card VALUES (1488, 1477);
INSERT INTO card_set_white_card VALUES (1488, 1476);
INSERT INTO card_set_white_card VALUES (1488, 1475);
INSERT INTO card_set_white_card VALUES (1488, 1474);
INSERT INTO card_set_white_card VALUES (1488, 1473);
INSERT INTO card_set_white_card VALUES (1488, 1487);
INSERT INTO card_set_white_card VALUES (1488, 1486);
INSERT INTO card_set_white_card VALUES (1488, 1485);
INSERT INTO card_set_white_card VALUES (1488, 1484);
INSERT INTO card_set_white_card VALUES (1488, 1483);
INSERT INTO card_set_white_card VALUES (1488, 1482);
INSERT INTO card_set_white_card VALUES (1488, 1481);
INSERT INTO card_set_white_card VALUES (1488, 1480);
INSERT INTO card_set_white_card VALUES (100001, 1368);
INSERT INTO card_set_white_card VALUES (100001, 1367);
INSERT INTO card_set_white_card VALUES (100001, 1364);
INSERT INTO card_set_white_card VALUES (100001, 1362);
INSERT INTO card_set_white_card VALUES (100001, 1360);
INSERT INTO card_set_white_card VALUES (100001, 1358);
INSERT INTO card_set_white_card VALUES (100001, 1357);
INSERT INTO card_set_white_card VALUES (100001, 1351);
INSERT INTO card_set_white_card VALUES (100001, 1348);
INSERT INTO card_set_white_card VALUES (100001, 1349);
INSERT INTO card_set_white_card VALUES (100001, 1346);
INSERT INTO card_set_white_card VALUES (100001, 1344);
INSERT INTO card_set_white_card VALUES (100001, 1405);
INSERT INTO card_set_white_card VALUES (100001, 1404);
INSERT INTO card_set_white_card VALUES (100001, 1407);
INSERT INTO card_set_white_card VALUES (100001, 1406);
INSERT INTO card_set_white_card VALUES (100001, 1401);
INSERT INTO card_set_white_card VALUES (100001, 1400);
INSERT INTO card_set_white_card VALUES (100001, 1403);
INSERT INTO card_set_white_card VALUES (100001, 1402);
INSERT INTO card_set_white_card VALUES (100001, 1397);
INSERT INTO card_set_white_card VALUES (100001, 1396);
INSERT INTO card_set_white_card VALUES (100001, 1399);
INSERT INTO card_set_white_card VALUES (100001, 1398);
INSERT INTO card_set_white_card VALUES (100001, 1393);
INSERT INTO card_set_white_card VALUES (100001, 1392);
INSERT INTO card_set_white_card VALUES (100001, 1395);
INSERT INTO card_set_white_card VALUES (100001, 1394);
INSERT INTO card_set_white_card VALUES (100001, 1388);
INSERT INTO card_set_white_card VALUES (100001, 1389);
INSERT INTO card_set_white_card VALUES (100001, 1390);
INSERT INTO card_set_white_card VALUES (100001, 1391);
INSERT INTO card_set_white_card VALUES (100001, 1384);
INSERT INTO card_set_white_card VALUES (100001, 1385);
INSERT INTO card_set_white_card VALUES (100001, 1386);
INSERT INTO card_set_white_card VALUES (100001, 1387);
INSERT INTO card_set_white_card VALUES (100001, 1380);
INSERT INTO card_set_white_card VALUES (100001, 1381);
INSERT INTO card_set_white_card VALUES (100001, 1382);
INSERT INTO card_set_white_card VALUES (100001, 1383);
INSERT INTO card_set_white_card VALUES (100001, 1379);
INSERT INTO card_set_white_card VALUES (100001, 1307);
INSERT INTO card_set_white_card VALUES (100001, 1304);
INSERT INTO card_set_white_card VALUES (100001, 1310);
INSERT INTO card_set_white_card VALUES (100001, 1308);
INSERT INTO card_set_white_card VALUES (100001, 1299);
INSERT INTO card_set_white_card VALUES (100001, 1298);
INSERT INTO card_set_white_card VALUES (100001, 1296);
INSERT INTO card_set_white_card VALUES (100001, 1302);
INSERT INTO card_set_white_card VALUES (100001, 1300);
INSERT INTO card_set_white_card VALUES (100001, 1290);
INSERT INTO card_set_white_card VALUES (100001, 1288);
INSERT INTO card_set_white_card VALUES (100001, 1294);
INSERT INTO card_set_white_card VALUES (100001, 1293);
INSERT INTO card_set_white_card VALUES (100001, 1282);
INSERT INTO card_set_white_card VALUES (100001, 1280);
INSERT INTO card_set_white_card VALUES (100001, 1286);
INSERT INTO card_set_white_card VALUES (100001, 1284);
INSERT INTO card_set_white_card VALUES (100001, 1337);
INSERT INTO card_set_white_card VALUES (100001, 1336);
INSERT INTO card_set_white_card VALUES (100001, 1339);
INSERT INTO card_set_white_card VALUES (100001, 1338);
INSERT INTO card_set_white_card VALUES (100001, 1341);
INSERT INTO card_set_white_card VALUES (100001, 1340);
INSERT INTO card_set_white_card VALUES (100001, 1343);
INSERT INTO card_set_white_card VALUES (100001, 1342);
INSERT INTO card_set_white_card VALUES (100001, 1328);
INSERT INTO card_set_white_card VALUES (100001, 1331);
INSERT INTO card_set_white_card VALUES (100001, 1333);
INSERT INTO card_set_white_card VALUES (100001, 1332);
INSERT INTO card_set_white_card VALUES (100001, 1335);
INSERT INTO card_set_white_card VALUES (100001, 1334);
INSERT INTO card_set_white_card VALUES (100001, 1320);
INSERT INTO card_set_white_card VALUES (100001, 1322);
INSERT INTO card_set_white_card VALUES (100001, 1324);
INSERT INTO card_set_white_card VALUES (100001, 1326);
INSERT INTO card_set_white_card VALUES (100001, 1312);
INSERT INTO card_set_white_card VALUES (100001, 1314);
INSERT INTO card_set_white_card VALUES (100001, 1316);
INSERT INTO card_set_white_card VALUES (100001, 1318);
INSERT INTO card_set_white_card VALUES (100001, 1263);
INSERT INTO card_set_white_card VALUES (100001, 1261);
INSERT INTO card_set_white_card VALUES (100001, 1259);
INSERT INTO card_set_white_card VALUES (100001, 1258);
INSERT INTO card_set_white_card VALUES (100001, 1271);
INSERT INTO card_set_white_card VALUES (100001, 1269);
INSERT INTO card_set_white_card VALUES (100001, 1266);
INSERT INTO card_set_white_card VALUES (100001, 1278);
INSERT INTO card_set_white_card VALUES (100001, 1276);
INSERT INTO card_set_white_card VALUES (100001, 1274);
INSERT INTO card_set_white_card VALUES (100001, 1272);
INSERT INTO card_set_white_card VALUES (100001, 1426);
INSERT INTO card_set_white_card VALUES (100001, 1427);
INSERT INTO card_set_white_card VALUES (100001, 1424);
INSERT INTO card_set_white_card VALUES (100001, 1425);
INSERT INTO card_set_white_card VALUES (100001, 1430);
INSERT INTO card_set_white_card VALUES (100001, 1431);
INSERT INTO card_set_white_card VALUES (100001, 1428);
INSERT INTO card_set_white_card VALUES (100001, 1429);
INSERT INTO card_set_white_card VALUES (100001, 1435);
INSERT INTO card_set_white_card VALUES (100001, 1432);
INSERT INTO card_set_white_card VALUES (100001, 1433);
INSERT INTO card_set_white_card VALUES (100001, 1438);
INSERT INTO card_set_white_card VALUES (100001, 1439);
INSERT INTO card_set_white_card VALUES (100001, 1436);
INSERT INTO card_set_white_card VALUES (100001, 1437);
INSERT INTO card_set_white_card VALUES (100001, 1411);
INSERT INTO card_set_white_card VALUES (100001, 1410);
INSERT INTO card_set_white_card VALUES (100001, 1409);
INSERT INTO card_set_white_card VALUES (100001, 1408);
INSERT INTO card_set_white_card VALUES (100001, 1415);
INSERT INTO card_set_white_card VALUES (100001, 1414);
INSERT INTO card_set_white_card VALUES (100001, 1413);
INSERT INTO card_set_white_card VALUES (100001, 1412);
INSERT INTO card_set_white_card VALUES (100001, 1419);
INSERT INTO card_set_white_card VALUES (100001, 1418);
INSERT INTO card_set_white_card VALUES (100001, 1417);
INSERT INTO card_set_white_card VALUES (100001, 1416);
INSERT INTO card_set_white_card VALUES (100001, 1423);
INSERT INTO card_set_white_card VALUES (100001, 1422);
INSERT INTO card_set_white_card VALUES (100001, 1421);
INSERT INTO card_set_white_card VALUES (100001, 1420);
INSERT INTO card_set_white_card VALUES (100001, 1441);
INSERT INTO card_set_white_card VALUES (100001, 1440);
INSERT INTO card_set_white_card VALUES (100001, 1443);
INSERT INTO card_set_white_card VALUES (100001, 1442);
INSERT INTO card_set_white_card VALUES (100001, 1445);
INSERT INTO card_set_white_card VALUES (100001, 1444);
INSERT INTO card_set_white_card VALUES (100001, 1447);
INSERT INTO card_set_white_card VALUES (100001, 1446);
INSERT INTO card_set_white_card VALUES (100001, 1449);
INSERT INTO card_set_white_card VALUES (100001, 1448);
INSERT INTO card_set_white_card VALUES (100001, 1451);
INSERT INTO card_set_white_card VALUES (100001, 1450);
INSERT INTO card_set_white_card VALUES (100001, 1453);
INSERT INTO card_set_white_card VALUES (100001, 1452);
INSERT INTO card_set_white_card VALUES (100001, 1455);
INSERT INTO card_set_white_card VALUES (100001, 1454);
INSERT INTO card_set_white_card VALUES (100002, 550);
INSERT INTO card_set_white_card VALUES (100002, 551);
INSERT INTO card_set_white_card VALUES (100002, 548);
INSERT INTO card_set_white_card VALUES (100002, 549);
INSERT INTO card_set_white_card VALUES (100002, 546);
INSERT INTO card_set_white_card VALUES (100002, 547);
INSERT INTO card_set_white_card VALUES (100002, 544);
INSERT INTO card_set_white_card VALUES (100002, 545);
INSERT INTO card_set_white_card VALUES (100002, 558);
INSERT INTO card_set_white_card VALUES (100002, 559);
INSERT INTO card_set_white_card VALUES (100002, 556);
INSERT INTO card_set_white_card VALUES (100002, 557);
INSERT INTO card_set_white_card VALUES (100002, 554);
INSERT INTO card_set_white_card VALUES (100002, 555);
INSERT INTO card_set_white_card VALUES (100002, 552);
INSERT INTO card_set_white_card VALUES (100002, 553);
INSERT INTO card_set_white_card VALUES (100002, 567);
INSERT INTO card_set_white_card VALUES (100002, 566);
INSERT INTO card_set_white_card VALUES (100002, 565);
INSERT INTO card_set_white_card VALUES (100002, 564);
INSERT INTO card_set_white_card VALUES (100002, 563);
INSERT INTO card_set_white_card VALUES (100002, 562);
INSERT INTO card_set_white_card VALUES (100002, 561);
INSERT INTO card_set_white_card VALUES (100002, 560);
INSERT INTO card_set_white_card VALUES (100002, 575);
INSERT INTO card_set_white_card VALUES (100002, 574);
INSERT INTO card_set_white_card VALUES (100002, 573);
INSERT INTO card_set_white_card VALUES (100002, 572);
INSERT INTO card_set_white_card VALUES (100002, 571);
INSERT INTO card_set_white_card VALUES (100002, 570);
INSERT INTO card_set_white_card VALUES (100002, 569);
INSERT INTO card_set_white_card VALUES (100002, 568);
INSERT INTO card_set_white_card VALUES (100002, 516);
INSERT INTO card_set_white_card VALUES (100002, 517);
INSERT INTO card_set_white_card VALUES (100002, 518);
INSERT INTO card_set_white_card VALUES (100002, 519);
INSERT INTO card_set_white_card VALUES (100002, 512);
INSERT INTO card_set_white_card VALUES (100002, 513);
INSERT INTO card_set_white_card VALUES (100002, 514);
INSERT INTO card_set_white_card VALUES (100002, 515);
INSERT INTO card_set_white_card VALUES (100002, 524);
INSERT INTO card_set_white_card VALUES (100002, 525);
INSERT INTO card_set_white_card VALUES (100002, 526);
INSERT INTO card_set_white_card VALUES (100002, 527);
INSERT INTO card_set_white_card VALUES (100002, 520);
INSERT INTO card_set_white_card VALUES (100002, 521);
INSERT INTO card_set_white_card VALUES (100002, 522);
INSERT INTO card_set_white_card VALUES (100002, 523);
INSERT INTO card_set_white_card VALUES (100002, 533);
INSERT INTO card_set_white_card VALUES (100002, 532);
INSERT INTO card_set_white_card VALUES (100002, 535);
INSERT INTO card_set_white_card VALUES (100002, 534);
INSERT INTO card_set_white_card VALUES (100002, 529);
INSERT INTO card_set_white_card VALUES (100002, 528);
INSERT INTO card_set_white_card VALUES (100002, 531);
INSERT INTO card_set_white_card VALUES (100002, 530);
INSERT INTO card_set_white_card VALUES (100002, 541);
INSERT INTO card_set_white_card VALUES (100002, 540);
INSERT INTO card_set_white_card VALUES (100002, 543);
INSERT INTO card_set_white_card VALUES (100002, 542);
INSERT INTO card_set_white_card VALUES (100002, 537);
INSERT INTO card_set_white_card VALUES (100002, 536);
INSERT INTO card_set_white_card VALUES (100002, 539);
INSERT INTO card_set_white_card VALUES (100002, 538);
INSERT INTO card_set_white_card VALUES (100002, 610);
INSERT INTO card_set_white_card VALUES (100002, 611);
INSERT INTO card_set_white_card VALUES (100002, 608);
INSERT INTO card_set_white_card VALUES (100002, 609);
INSERT INTO card_set_white_card VALUES (100002, 614);
INSERT INTO card_set_white_card VALUES (100002, 615);
INSERT INTO card_set_white_card VALUES (100002, 612);
INSERT INTO card_set_white_card VALUES (100002, 613);
INSERT INTO card_set_white_card VALUES (100002, 618);
INSERT INTO card_set_white_card VALUES (100002, 619);
INSERT INTO card_set_white_card VALUES (100002, 616);
INSERT INTO card_set_white_card VALUES (100002, 617);
INSERT INTO card_set_white_card VALUES (100002, 620);
INSERT INTO card_set_white_card VALUES (100002, 621);
INSERT INTO card_set_white_card VALUES (100002, 576);
INSERT INTO card_set_white_card VALUES (100002, 577);
INSERT INTO card_set_white_card VALUES (100002, 578);
INSERT INTO card_set_white_card VALUES (100002, 579);
INSERT INTO card_set_white_card VALUES (100002, 580);
INSERT INTO card_set_white_card VALUES (100002, 581);
INSERT INTO card_set_white_card VALUES (100002, 582);
INSERT INTO card_set_white_card VALUES (100002, 583);
INSERT INTO card_set_white_card VALUES (100002, 584);
INSERT INTO card_set_white_card VALUES (100002, 585);
INSERT INTO card_set_white_card VALUES (100002, 586);
INSERT INTO card_set_white_card VALUES (100002, 587);
INSERT INTO card_set_white_card VALUES (100002, 588);
INSERT INTO card_set_white_card VALUES (100002, 589);
INSERT INTO card_set_white_card VALUES (100002, 590);
INSERT INTO card_set_white_card VALUES (100002, 591);
INSERT INTO card_set_white_card VALUES (100002, 593);
INSERT INTO card_set_white_card VALUES (100002, 592);
INSERT INTO card_set_white_card VALUES (100002, 595);
INSERT INTO card_set_white_card VALUES (100002, 594);
INSERT INTO card_set_white_card VALUES (100002, 597);
INSERT INTO card_set_white_card VALUES (100002, 596);
INSERT INTO card_set_white_card VALUES (100002, 599);
INSERT INTO card_set_white_card VALUES (100002, 598);
INSERT INTO card_set_white_card VALUES (100002, 601);
INSERT INTO card_set_white_card VALUES (100002, 600);
INSERT INTO card_set_white_card VALUES (100002, 603);
INSERT INTO card_set_white_card VALUES (100002, 602);
INSERT INTO card_set_white_card VALUES (100002, 605);
INSERT INTO card_set_white_card VALUES (100002, 604);
INSERT INTO card_set_white_card VALUES (100002, 607);
INSERT INTO card_set_white_card VALUES (100002, 606);
INSERT INTO card_set_white_card VALUES (100002, 509);
INSERT INTO card_set_white_card VALUES (100002, 510);
INSERT INTO card_set_white_card VALUES (100002, 511);
INSERT INTO card_set_white_card VALUES (100003, 610);
INSERT INTO card_set_white_card VALUES (100003, 550);
INSERT INTO card_set_white_card VALUES (100003, 551);
INSERT INTO card_set_white_card VALUES (100003, 608);
INSERT INTO card_set_white_card VALUES (100003, 549);
INSERT INTO card_set_white_card VALUES (100003, 544);
INSERT INTO card_set_white_card VALUES (100003, 545);
INSERT INTO card_set_white_card VALUES (100003, 556);
INSERT INTO card_set_white_card VALUES (100003, 554);
INSERT INTO card_set_white_card VALUES (100003, 553);
INSERT INTO card_set_white_card VALUES (100003, 1288);
INSERT INTO card_set_white_card VALUES (100003, 564);
INSERT INTO card_set_white_card VALUES (100003, 572);
INSERT INTO card_set_white_card VALUES (100003, 568);
INSERT INTO card_set_white_card VALUES (100003, 576);
INSERT INTO card_set_white_card VALUES (100003, 516);
INSERT INTO card_set_white_card VALUES (100003, 509);
INSERT INTO card_set_white_card VALUES (100003, 578);
INSERT INTO card_set_white_card VALUES (100003, 518);
INSERT INTO card_set_white_card VALUES (100003, 510);
INSERT INTO card_set_white_card VALUES (100003, 579);
INSERT INTO card_set_white_card VALUES (100003, 512);
INSERT INTO card_set_white_card VALUES (100003, 581);
INSERT INTO card_set_white_card VALUES (100003, 513);
INSERT INTO card_set_white_card VALUES (100003, 582);
INSERT INTO card_set_white_card VALUES (100003, 514);
INSERT INTO card_set_white_card VALUES (100003, 1263);
INSERT INTO card_set_white_card VALUES (100003, 588);
INSERT INTO card_set_white_card VALUES (100003, 520);
INSERT INTO card_set_white_card VALUES (100003, 589);
INSERT INTO card_set_white_card VALUES (100003, 541);
INSERT INTO card_set_white_card VALUES (100003, 540);
INSERT INTO card_set_white_card VALUES (100003, 1383);
INSERT INTO card_set_white_card VALUES (100003, 605);
INSERT INTO card_set_white_card VALUES (100003, 1274);
INSERT INTO card_set_white_card VALUES (100003, 604);
INSERT INTO card_set_white_card VALUES (100003, 539);
INSERT INTO card_set_white_card VALUES (100003, 606);
INSERT INTO card_set_white_card VALUES (100017, 100014);
INSERT INTO card_set_white_card VALUES (100017, 100015);
INSERT INTO card_set_white_card VALUES (100017, 100012);
INSERT INTO card_set_white_card VALUES (100017, 100013);
INSERT INTO card_set_white_card VALUES (100017, 100011);
INSERT INTO card_set_white_card VALUES (100017, 100008);
INSERT INTO card_set_white_card VALUES (100017, 100009);
INSERT INTO card_set_white_card VALUES (100017, 100018);
INSERT INTO card_set_white_card VALUES (100049, 100026);
INSERT INTO card_set_white_card VALUES (100049, 100025);
INSERT INTO card_set_white_card VALUES (100049, 100024);
INSERT INTO card_set_white_card VALUES (100049, 100023);
INSERT INTO card_set_white_card VALUES (100049, 100022);
INSERT INTO card_set_white_card VALUES (100049, 100021);
INSERT INTO card_set_white_card VALUES (100049, 100020);
INSERT INTO card_set_white_card VALUES (100049, 100019);
INSERT INTO card_set_white_card VALUES (100050, 100031);
INSERT INTO card_set_white_card VALUES (100050, 100030);
INSERT INTO card_set_white_card VALUES (100050, 100029);
INSERT INTO card_set_white_card VALUES (100050, 100032);
INSERT INTO card_set_white_card VALUES (100050, 100033);
INSERT INTO card_set_white_card VALUES (100050, 100034);
INSERT INTO card_set_white_card VALUES (100050, 100035);
INSERT INTO card_set_white_card VALUES (100050, 100036);
INSERT INTO card_set_white_card VALUES (100051, 100040);
INSERT INTO card_set_white_card VALUES (100051, 100041);
INSERT INTO card_set_white_card VALUES (100051, 100042);
INSERT INTO card_set_white_card VALUES (100051, 100043);
INSERT INTO card_set_white_card VALUES (100051, 100044);
INSERT INTO card_set_white_card VALUES (100051, 100045);
INSERT INTO card_set_white_card VALUES (100051, 100046);
INSERT INTO card_set_white_card VALUES (100051, 100039);
INSERT INTO card_set_white_card VALUES (100017, 100052);
INSERT INTO card_set_white_card VALUES (100017, 100057);
INSERT INTO card_set_white_card VALUES (100154, 100091);
INSERT INTO card_set_white_card VALUES (100154, 100090);
INSERT INTO card_set_white_card VALUES (100154, 100088);
INSERT INTO card_set_white_card VALUES (100154, 100083);
INSERT INTO card_set_white_card VALUES (100154, 100082);
INSERT INTO card_set_white_card VALUES (100154, 100081);
INSERT INTO card_set_white_card VALUES (100154, 100080);
INSERT INTO card_set_white_card VALUES (100154, 100087);
INSERT INTO card_set_white_card VALUES (100154, 100086);
INSERT INTO card_set_white_card VALUES (100154, 100084);
INSERT INTO card_set_white_card VALUES (100154, 100075);
INSERT INTO card_set_white_card VALUES (100154, 100072);
INSERT INTO card_set_white_card VALUES (100154, 100073);
INSERT INTO card_set_white_card VALUES (100154, 100079);
INSERT INTO card_set_white_card VALUES (100154, 100076);
INSERT INTO card_set_white_card VALUES (100154, 100077);
INSERT INTO card_set_white_card VALUES (100154, 100067);
INSERT INTO card_set_white_card VALUES (100154, 100064);
INSERT INTO card_set_white_card VALUES (100154, 100071);
INSERT INTO card_set_white_card VALUES (100154, 100068);
INSERT INTO card_set_white_card VALUES (100154, 100069);
INSERT INTO card_set_white_card VALUES (100154, 100056);
INSERT INTO card_set_white_card VALUES (100154, 100061);
INSERT INTO card_set_white_card VALUES (100154, 100060);
INSERT INTO card_set_white_card VALUES (100154, 100063);
INSERT INTO card_set_white_card VALUES (100154, 100062);
INSERT INTO card_set_white_card VALUES (100154, 100053);
INSERT INTO card_set_white_card VALUES (100154, 100055);
INSERT INTO card_set_white_card VALUES (100154, 100133);
INSERT INTO card_set_white_card VALUES (100154, 100132);
INSERT INTO card_set_white_card VALUES (100154, 100135);
INSERT INTO card_set_white_card VALUES (100154, 100134);
INSERT INTO card_set_white_card VALUES (100154, 100129);
INSERT INTO card_set_white_card VALUES (100154, 100128);
INSERT INTO card_set_white_card VALUES (100154, 100131);
INSERT INTO card_set_white_card VALUES (100154, 100130);
INSERT INTO card_set_white_card VALUES (100154, 100141);
INSERT INTO card_set_white_card VALUES (100154, 100140);
INSERT INTO card_set_white_card VALUES (100154, 100143);
INSERT INTO card_set_white_card VALUES (100154, 100142);
INSERT INTO card_set_white_card VALUES (100154, 100137);
INSERT INTO card_set_white_card VALUES (100154, 100136);
INSERT INTO card_set_white_card VALUES (100154, 100139);
INSERT INTO card_set_white_card VALUES (100154, 100138);
INSERT INTO card_set_white_card VALUES (100154, 100148);
INSERT INTO card_set_white_card VALUES (100154, 100149);
INSERT INTO card_set_white_card VALUES (100154, 100150);
INSERT INTO card_set_white_card VALUES (100154, 100151);
INSERT INTO card_set_white_card VALUES (100154, 100144);
INSERT INTO card_set_white_card VALUES (100154, 100145);
INSERT INTO card_set_white_card VALUES (100154, 100146);
INSERT INTO card_set_white_card VALUES (100154, 100147);
INSERT INTO card_set_white_card VALUES (100154, 100152);
INSERT INTO card_set_white_card VALUES (100154, 100153);
INSERT INTO card_set_white_card VALUES (100154, 100102);
INSERT INTO card_set_white_card VALUES (100154, 100101);
INSERT INTO card_set_white_card VALUES (100154, 100099);
INSERT INTO card_set_white_card VALUES (100154, 100111);
INSERT INTO card_set_white_card VALUES (100154, 100109);
INSERT INTO card_set_white_card VALUES (100154, 100107);
INSERT INTO card_set_white_card VALUES (100154, 100118);
INSERT INTO card_set_white_card VALUES (100154, 100119);
INSERT INTO card_set_white_card VALUES (100154, 100116);
INSERT INTO card_set_white_card VALUES (100154, 100117);
INSERT INTO card_set_white_card VALUES (100154, 100114);
INSERT INTO card_set_white_card VALUES (100154, 100115);
INSERT INTO card_set_white_card VALUES (100154, 100112);
INSERT INTO card_set_white_card VALUES (100154, 100126);
INSERT INTO card_set_white_card VALUES (100154, 100127);
INSERT INTO card_set_white_card VALUES (100154, 100124);
INSERT INTO card_set_white_card VALUES (100154, 100125);
INSERT INTO card_set_white_card VALUES (100154, 100122);
INSERT INTO card_set_white_card VALUES (100154, 100123);
INSERT INTO card_set_white_card VALUES (100154, 100120);
INSERT INTO card_set_white_card VALUES (100154, 100121);
INSERT INTO card_set_white_card VALUES (100003, 100011);
INSERT INTO card_set_white_card VALUES (100003, 100008);
INSERT INTO card_set_white_card VALUES (100003, 100057);
INSERT INTO card_set_white_card VALUES (100017, 100156);
INSERT INTO card_set_white_card VALUES (100157, 3004);
INSERT INTO card_set_white_card VALUES (100157, 3005);
INSERT INTO card_set_white_card VALUES (100157, 3006);
INSERT INTO card_set_white_card VALUES (100157, 3007);
INSERT INTO card_set_white_card VALUES (100157, 3001);
INSERT INTO card_set_white_card VALUES (100157, 3002);
INSERT INTO card_set_white_card VALUES (100157, 3003);
INSERT INTO card_set_white_card VALUES (100157, 3049);
INSERT INTO card_set_white_card VALUES (100157, 3048);
INSERT INTO card_set_white_card VALUES (100157, 3051);
INSERT INTO card_set_white_card VALUES (100157, 3050);
INSERT INTO card_set_white_card VALUES (100157, 3053);
INSERT INTO card_set_white_card VALUES (100157, 3052);
INSERT INTO card_set_white_card VALUES (100157, 3055);
INSERT INTO card_set_white_card VALUES (100157, 3054);
INSERT INTO card_set_white_card VALUES (100157, 3041);
INSERT INTO card_set_white_card VALUES (100157, 3040);
INSERT INTO card_set_white_card VALUES (100157, 3043);
INSERT INTO card_set_white_card VALUES (100157, 3042);
INSERT INTO card_set_white_card VALUES (100157, 3045);
INSERT INTO card_set_white_card VALUES (100157, 3044);
INSERT INTO card_set_white_card VALUES (100157, 3047);
INSERT INTO card_set_white_card VALUES (100157, 3046);
INSERT INTO card_set_white_card VALUES (100157, 3064);
INSERT INTO card_set_white_card VALUES (100157, 3065);
INSERT INTO card_set_white_card VALUES (100157, 3066);
INSERT INTO card_set_white_card VALUES (100157, 3067);
INSERT INTO card_set_white_card VALUES (100157, 3068);
INSERT INTO card_set_white_card VALUES (100157, 3069);
INSERT INTO card_set_white_card VALUES (100157, 3070);
INSERT INTO card_set_white_card VALUES (100157, 3071);
INSERT INTO card_set_white_card VALUES (100157, 3056);
INSERT INTO card_set_white_card VALUES (100157, 3057);
INSERT INTO card_set_white_card VALUES (100157, 3058);
INSERT INTO card_set_white_card VALUES (100157, 3059);
INSERT INTO card_set_white_card VALUES (100157, 3060);
INSERT INTO card_set_white_card VALUES (100157, 3061);
INSERT INTO card_set_white_card VALUES (100157, 3062);
INSERT INTO card_set_white_card VALUES (100157, 3063);
INSERT INTO card_set_white_card VALUES (100157, 3019);
INSERT INTO card_set_white_card VALUES (100157, 3018);
INSERT INTO card_set_white_card VALUES (100157, 3017);
INSERT INTO card_set_white_card VALUES (100157, 3016);
INSERT INTO card_set_white_card VALUES (100157, 3023);
INSERT INTO card_set_white_card VALUES (100157, 3022);
INSERT INTO card_set_white_card VALUES (100157, 3021);
INSERT INTO card_set_white_card VALUES (100157, 3020);
INSERT INTO card_set_white_card VALUES (100157, 3011);
INSERT INTO card_set_white_card VALUES (100157, 3010);
INSERT INTO card_set_white_card VALUES (100157, 3009);
INSERT INTO card_set_white_card VALUES (100157, 3008);
INSERT INTO card_set_white_card VALUES (100157, 3015);
INSERT INTO card_set_white_card VALUES (100157, 3014);
INSERT INTO card_set_white_card VALUES (100157, 3013);
INSERT INTO card_set_white_card VALUES (100157, 3012);
INSERT INTO card_set_white_card VALUES (100157, 3034);
INSERT INTO card_set_white_card VALUES (100157, 3035);
INSERT INTO card_set_white_card VALUES (100157, 3032);
INSERT INTO card_set_white_card VALUES (100157, 3033);
INSERT INTO card_set_white_card VALUES (100157, 3038);
INSERT INTO card_set_white_card VALUES (100157, 3039);
INSERT INTO card_set_white_card VALUES (100157, 3036);
INSERT INTO card_set_white_card VALUES (100157, 3037);
INSERT INTO card_set_white_card VALUES (100157, 3026);
INSERT INTO card_set_white_card VALUES (100157, 3027);
INSERT INTO card_set_white_card VALUES (100157, 3024);
INSERT INTO card_set_white_card VALUES (100157, 3025);
INSERT INTO card_set_white_card VALUES (100157, 3030);
INSERT INTO card_set_white_card VALUES (100157, 3031);
INSERT INTO card_set_white_card VALUES (100157, 3028);
INSERT INTO card_set_white_card VALUES (100157, 3029);
INSERT INTO card_set_white_card VALUES (100157, 3097);
INSERT INTO card_set_white_card VALUES (100157, 3096);
INSERT INTO card_set_white_card VALUES (100157, 3099);
INSERT INTO card_set_white_card VALUES (100157, 3098);
INSERT INTO card_set_white_card VALUES (100157, 3101);
INSERT INTO card_set_white_card VALUES (100157, 3100);
INSERT INTO card_set_white_card VALUES (100157, 3103);
INSERT INTO card_set_white_card VALUES (100157, 3102);
INSERT INTO card_set_white_card VALUES (100157, 3089);
INSERT INTO card_set_white_card VALUES (100157, 3088);
INSERT INTO card_set_white_card VALUES (100157, 3091);
INSERT INTO card_set_white_card VALUES (100157, 3090);
INSERT INTO card_set_white_card VALUES (100157, 3093);
INSERT INTO card_set_white_card VALUES (100157, 3092);
INSERT INTO card_set_white_card VALUES (100157, 3095);
INSERT INTO card_set_white_card VALUES (100157, 3094);
INSERT INTO card_set_white_card VALUES (100157, 3080);
INSERT INTO card_set_white_card VALUES (100157, 3081);
INSERT INTO card_set_white_card VALUES (100157, 3082);
INSERT INTO card_set_white_card VALUES (100157, 3083);
INSERT INTO card_set_white_card VALUES (100157, 3084);
INSERT INTO card_set_white_card VALUES (100157, 3085);
INSERT INTO card_set_white_card VALUES (100157, 3086);
INSERT INTO card_set_white_card VALUES (100157, 3087);
INSERT INTO card_set_white_card VALUES (100157, 3072);
INSERT INTO card_set_white_card VALUES (100157, 3073);
INSERT INTO card_set_white_card VALUES (100157, 3074);
INSERT INTO card_set_white_card VALUES (100157, 3075);
INSERT INTO card_set_white_card VALUES (100157, 3076);
INSERT INTO card_set_white_card VALUES (100157, 3077);
INSERT INTO card_set_white_card VALUES (100157, 3078);
INSERT INTO card_set_white_card VALUES (100157, 3079);
INSERT INTO card_set_white_card VALUES (100157, 3131);
INSERT INTO card_set_white_card VALUES (100157, 3130);
INSERT INTO card_set_white_card VALUES (100157, 3129);
INSERT INTO card_set_white_card VALUES (100157, 3128);
INSERT INTO card_set_white_card VALUES (100157, 3123);
INSERT INTO card_set_white_card VALUES (100157, 3122);
INSERT INTO card_set_white_card VALUES (100157, 3121);
INSERT INTO card_set_white_card VALUES (100157, 3120);
INSERT INTO card_set_white_card VALUES (100157, 3127);
INSERT INTO card_set_white_card VALUES (100157, 3126);
INSERT INTO card_set_white_card VALUES (100157, 3125);
INSERT INTO card_set_white_card VALUES (100157, 3124);
INSERT INTO card_set_white_card VALUES (100157, 3114);
INSERT INTO card_set_white_card VALUES (100157, 3115);
INSERT INTO card_set_white_card VALUES (100157, 3112);
INSERT INTO card_set_white_card VALUES (100157, 3113);
INSERT INTO card_set_white_card VALUES (100157, 3118);
INSERT INTO card_set_white_card VALUES (100157, 3119);
INSERT INTO card_set_white_card VALUES (100157, 3116);
INSERT INTO card_set_white_card VALUES (100157, 3117);
INSERT INTO card_set_white_card VALUES (100157, 3106);
INSERT INTO card_set_white_card VALUES (100157, 3107);
INSERT INTO card_set_white_card VALUES (100157, 3104);
INSERT INTO card_set_white_card VALUES (100157, 3105);
INSERT INTO card_set_white_card VALUES (100157, 3110);
INSERT INTO card_set_white_card VALUES (100157, 3111);
INSERT INTO card_set_white_card VALUES (100157, 3108);
INSERT INTO card_set_white_card VALUES (100157, 3109);
INSERT INTO card_set_white_card VALUES (100157, 100158);
INSERT INTO card_set_white_card VALUES (100003, 3006);
INSERT INTO card_set_white_card VALUES (100003, 3007);
INSERT INTO card_set_white_card VALUES (100003, 3054);
INSERT INTO card_set_white_card VALUES (100003, 3094);
INSERT INTO card_set_white_card VALUES (100003, 3065);
INSERT INTO card_set_white_card VALUES (100003, 3085);
INSERT INTO card_set_white_card VALUES (100003, 3070);
INSERT INTO card_set_white_card VALUES (100003, 3117);
INSERT INTO card_set_white_card VALUES (100160, 3776);
INSERT INTO card_set_white_card VALUES (100160, 3766);
INSERT INTO card_set_white_card VALUES (100160, 3767);
INSERT INTO card_set_white_card VALUES (100160, 3764);
INSERT INTO card_set_white_card VALUES (100160, 3765);
INSERT INTO card_set_white_card VALUES (100160, 3762);
INSERT INTO card_set_white_card VALUES (100160, 3763);
INSERT INTO card_set_white_card VALUES (100160, 3760);
INSERT INTO card_set_white_card VALUES (100160, 3761);
INSERT INTO card_set_white_card VALUES (100160, 3774);
INSERT INTO card_set_white_card VALUES (100160, 3775);
INSERT INTO card_set_white_card VALUES (100160, 3772);
INSERT INTO card_set_white_card VALUES (100160, 3773);
INSERT INTO card_set_white_card VALUES (100160, 3770);
INSERT INTO card_set_white_card VALUES (100160, 3771);
INSERT INTO card_set_white_card VALUES (100160, 3768);
INSERT INTO card_set_white_card VALUES (100160, 3769);
INSERT INTO card_set_white_card VALUES (100160, 3751);
INSERT INTO card_set_white_card VALUES (100160, 3750);
INSERT INTO card_set_white_card VALUES (100160, 3749);
INSERT INTO card_set_white_card VALUES (100160, 3748);
INSERT INTO card_set_white_card VALUES (100160, 3747);
INSERT INTO card_set_white_card VALUES (100160, 3746);
INSERT INTO card_set_white_card VALUES (100160, 3745);
INSERT INTO card_set_white_card VALUES (100160, 3744);
INSERT INTO card_set_white_card VALUES (100160, 3759);
INSERT INTO card_set_white_card VALUES (100160, 3758);
INSERT INTO card_set_white_card VALUES (100160, 3757);
INSERT INTO card_set_white_card VALUES (100160, 3756);
INSERT INTO card_set_white_card VALUES (100160, 3755);
INSERT INTO card_set_white_card VALUES (100160, 3754);
INSERT INTO card_set_white_card VALUES (100160, 3753);
INSERT INTO card_set_white_card VALUES (100160, 3752);
INSERT INTO card_set_white_card VALUES (100160, 3732);
INSERT INTO card_set_white_card VALUES (100160, 3733);
INSERT INTO card_set_white_card VALUES (100160, 3734);
INSERT INTO card_set_white_card VALUES (100160, 3735);
INSERT INTO card_set_white_card VALUES (100160, 3728);
INSERT INTO card_set_white_card VALUES (100160, 3729);
INSERT INTO card_set_white_card VALUES (100160, 3730);
INSERT INTO card_set_white_card VALUES (100160, 3731);
INSERT INTO card_set_white_card VALUES (100160, 3740);
INSERT INTO card_set_white_card VALUES (100160, 3741);
INSERT INTO card_set_white_card VALUES (100160, 3742);
INSERT INTO card_set_white_card VALUES (100160, 3743);
INSERT INTO card_set_white_card VALUES (100160, 3736);
INSERT INTO card_set_white_card VALUES (100160, 3737);
INSERT INTO card_set_white_card VALUES (100160, 3738);
INSERT INTO card_set_white_card VALUES (100160, 3739);
INSERT INTO card_set_white_card VALUES (100160, 3717);
INSERT INTO card_set_white_card VALUES (100160, 3716);
INSERT INTO card_set_white_card VALUES (100160, 3719);
INSERT INTO card_set_white_card VALUES (100160, 3718);
INSERT INTO card_set_white_card VALUES (100160, 3713);
INSERT INTO card_set_white_card VALUES (100160, 3712);
INSERT INTO card_set_white_card VALUES (100160, 3715);
INSERT INTO card_set_white_card VALUES (100160, 3714);
INSERT INTO card_set_white_card VALUES (100160, 3725);
INSERT INTO card_set_white_card VALUES (100160, 3724);
INSERT INTO card_set_white_card VALUES (100160, 3727);
INSERT INTO card_set_white_card VALUES (100160, 3726);
INSERT INTO card_set_white_card VALUES (100160, 3721);
INSERT INTO card_set_white_card VALUES (100160, 3720);
INSERT INTO card_set_white_card VALUES (100160, 3723);
INSERT INTO card_set_white_card VALUES (100160, 3722);
INSERT INTO card_set_white_card VALUES (100160, 3707);
INSERT INTO card_set_white_card VALUES (100160, 3706);
INSERT INTO card_set_white_card VALUES (100160, 3705);
INSERT INTO card_set_white_card VALUES (100160, 3704);
INSERT INTO card_set_white_card VALUES (100160, 3711);
INSERT INTO card_set_white_card VALUES (100160, 3710);
INSERT INTO card_set_white_card VALUES (100160, 3709);
INSERT INTO card_set_white_card VALUES (100160, 3708);
INSERT INTO card_set_white_card VALUES (100160, 3699);
INSERT INTO card_set_white_card VALUES (100160, 3698);
INSERT INTO card_set_white_card VALUES (100160, 3697);
INSERT INTO card_set_white_card VALUES (100160, 3696);
INSERT INTO card_set_white_card VALUES (100160, 3703);
INSERT INTO card_set_white_card VALUES (100160, 3702);
INSERT INTO card_set_white_card VALUES (100160, 3701);
INSERT INTO card_set_white_card VALUES (100160, 3700);
INSERT INTO card_set_white_card VALUES (100160, 3690);
INSERT INTO card_set_white_card VALUES (100160, 3691);
INSERT INTO card_set_white_card VALUES (100160, 3688);
INSERT INTO card_set_white_card VALUES (100160, 3689);
INSERT INTO card_set_white_card VALUES (100160, 3694);
INSERT INTO card_set_white_card VALUES (100160, 3695);
INSERT INTO card_set_white_card VALUES (100160, 3692);
INSERT INTO card_set_white_card VALUES (100160, 3693);
INSERT INTO card_set_white_card VALUES (100160, 3682);
INSERT INTO card_set_white_card VALUES (100160, 3683);
INSERT INTO card_set_white_card VALUES (100160, 3680);
INSERT INTO card_set_white_card VALUES (100160, 3681);
INSERT INTO card_set_white_card VALUES (100160, 3686);
INSERT INTO card_set_white_card VALUES (100160, 3687);
INSERT INTO card_set_white_card VALUES (100160, 3684);
INSERT INTO card_set_white_card VALUES (100160, 3685);
INSERT INTO card_set_white_card VALUES (100160, 3673);
INSERT INTO card_set_white_card VALUES (100160, 3672);
INSERT INTO card_set_white_card VALUES (100160, 3675);
INSERT INTO card_set_white_card VALUES (100160, 3674);
INSERT INTO card_set_white_card VALUES (100160, 3677);
INSERT INTO card_set_white_card VALUES (100160, 3676);
INSERT INTO card_set_white_card VALUES (100160, 3679);
INSERT INTO card_set_white_card VALUES (100160, 3678);
INSERT INTO card_set_white_card VALUES (100160, 3665);
INSERT INTO card_set_white_card VALUES (100160, 3664);
INSERT INTO card_set_white_card VALUES (100160, 3667);
INSERT INTO card_set_white_card VALUES (100160, 3666);
INSERT INTO card_set_white_card VALUES (100160, 3669);
INSERT INTO card_set_white_card VALUES (100160, 3668);
INSERT INTO card_set_white_card VALUES (100160, 3671);
INSERT INTO card_set_white_card VALUES (100160, 3670);
INSERT INTO card_set_white_card VALUES (100160, 3662);
INSERT INTO card_set_white_card VALUES (100160, 3663);
INSERT INTO card_set_white_card VALUES (100003, 3709);
INSERT INTO card_set_white_card VALUES (100003, 3708);
INSERT INTO card_set_white_card VALUES (100003, 3688);
INSERT INTO card_set_white_card VALUES (100003, 3687);
INSERT INTO card_set_white_card VALUES (100003, 3684);
INSERT INTO card_set_white_card VALUES (100003, 3676);
INSERT INTO card_set_white_card VALUES (100003, 3667);
INSERT INTO card_set_white_card VALUES (100003, 3666);
INSERT INTO card_set_white_card VALUES (100003, 3671);
INSERT INTO card_set_white_card VALUES (100003, 3670);
INSERT INTO card_set_white_card VALUES (100003, 3663);
INSERT INTO card_set_white_card VALUES (100003, 3762);
INSERT INTO card_set_white_card VALUES (100003, 3763);
INSERT INTO card_set_white_card VALUES (100003, 3100);
INSERT INTO card_set_white_card VALUES (100003, 3761);
INSERT INTO card_set_white_card VALUES (100003, 3773);
INSERT INTO card_set_white_card VALUES (100003, 3770);
INSERT INTO card_set_white_card VALUES (100003, 3084);
INSERT INTO card_set_white_card VALUES (100003, 3744);
INSERT INTO card_set_white_card VALUES (100003, 3059);
INSERT INTO card_set_white_card VALUES (100003, 3754);
INSERT INTO card_set_white_card VALUES (100003, 3740);
INSERT INTO card_set_white_card VALUES (100003, 3011);
INSERT INTO card_set_white_card VALUES (100003, 3742);
INSERT INTO card_set_white_card VALUES (100003, 3121);
INSERT INTO card_set_white_card VALUES (100003, 3009);
INSERT INTO card_set_white_card VALUES (100003, 3736);
INSERT INTO card_set_white_card VALUES (100003, 3014);
INSERT INTO card_set_white_card VALUES (100003, 3719);
INSERT INTO card_set_white_card VALUES (100003, 3104);
INSERT INTO card_set_white_card VALUES (100003, 3723);
INSERT INTO card_set_white_card VALUES (100161, 4131);
INSERT INTO card_set_white_card VALUES (100161, 4065);
INSERT INTO card_set_white_card VALUES (100161, 4130);
INSERT INTO card_set_white_card VALUES (100161, 4064);
INSERT INTO card_set_white_card VALUES (100161, 4129);
INSERT INTO card_set_white_card VALUES (100161, 4067);
INSERT INTO card_set_white_card VALUES (100161, 4128);
INSERT INTO card_set_white_card VALUES (100161, 4066);
INSERT INTO card_set_white_card VALUES (100161, 4135);
INSERT INTO card_set_white_card VALUES (100161, 4069);
INSERT INTO card_set_white_card VALUES (100161, 4134);
INSERT INTO card_set_white_card VALUES (100161, 4068);
INSERT INTO card_set_white_card VALUES (100161, 4133);
INSERT INTO card_set_white_card VALUES (100161, 4071);
INSERT INTO card_set_white_card VALUES (100161, 4132);
INSERT INTO card_set_white_card VALUES (100161, 4070);
INSERT INTO card_set_white_card VALUES (100161, 4073);
INSERT INTO card_set_white_card VALUES (100161, 4139);
INSERT INTO card_set_white_card VALUES (100161, 4138);
INSERT INTO card_set_white_card VALUES (100161, 4072);
INSERT INTO card_set_white_card VALUES (100161, 4075);
INSERT INTO card_set_white_card VALUES (100161, 4137);
INSERT INTO card_set_white_card VALUES (100161, 4074);
INSERT INTO card_set_white_card VALUES (100161, 4136);
INSERT INTO card_set_white_card VALUES (100161, 4077);
INSERT INTO card_set_white_card VALUES (100161, 4143);
INSERT INTO card_set_white_card VALUES (100161, 4076);
INSERT INTO card_set_white_card VALUES (100161, 4142);
INSERT INTO card_set_white_card VALUES (100161, 4079);
INSERT INTO card_set_white_card VALUES (100161, 4141);
INSERT INTO card_set_white_card VALUES (100161, 4078);
INSERT INTO card_set_white_card VALUES (100161, 4140);
INSERT INTO card_set_white_card VALUES (100161, 4080);
INSERT INTO card_set_white_card VALUES (100161, 4146);
INSERT INTO card_set_white_card VALUES (100161, 4081);
INSERT INTO card_set_white_card VALUES (100161, 4147);
INSERT INTO card_set_white_card VALUES (100161, 4082);
INSERT INTO card_set_white_card VALUES (100161, 4144);
INSERT INTO card_set_white_card VALUES (100161, 4083);
INSERT INTO card_set_white_card VALUES (100161, 4145);
INSERT INTO card_set_white_card VALUES (100161, 4084);
INSERT INTO card_set_white_card VALUES (100161, 4150);
INSERT INTO card_set_white_card VALUES (100161, 4085);
INSERT INTO card_set_white_card VALUES (100161, 4151);
INSERT INTO card_set_white_card VALUES (100161, 4086);
INSERT INTO card_set_white_card VALUES (100161, 4148);
INSERT INTO card_set_white_card VALUES (100161, 4087);
INSERT INTO card_set_white_card VALUES (100161, 4149);
INSERT INTO card_set_white_card VALUES (100161, 4088);
INSERT INTO card_set_white_card VALUES (100161, 4154);
INSERT INTO card_set_white_card VALUES (100161, 4089);
INSERT INTO card_set_white_card VALUES (100161, 4155);
INSERT INTO card_set_white_card VALUES (100161, 4090);
INSERT INTO card_set_white_card VALUES (100161, 4152);
INSERT INTO card_set_white_card VALUES (100161, 4091);
INSERT INTO card_set_white_card VALUES (100161, 4153);
INSERT INTO card_set_white_card VALUES (100161, 4092);
INSERT INTO card_set_white_card VALUES (100161, 4158);
INSERT INTO card_set_white_card VALUES (100161, 4093);
INSERT INTO card_set_white_card VALUES (100161, 4159);
INSERT INTO card_set_white_card VALUES (100161, 4094);
INSERT INTO card_set_white_card VALUES (100161, 4156);
INSERT INTO card_set_white_card VALUES (100161, 4095);
INSERT INTO card_set_white_card VALUES (100161, 4157);
INSERT INTO card_set_white_card VALUES (100161, 4097);
INSERT INTO card_set_white_card VALUES (100161, 4035);
INSERT INTO card_set_white_card VALUES (100161, 4096);
INSERT INTO card_set_white_card VALUES (100161, 4034);
INSERT INTO card_set_white_card VALUES (100161, 4099);
INSERT INTO card_set_white_card VALUES (100161, 4033);
INSERT INTO card_set_white_card VALUES (100161, 4098);
INSERT INTO card_set_white_card VALUES (100161, 4032);
INSERT INTO card_set_white_card VALUES (100161, 4101);
INSERT INTO card_set_white_card VALUES (100161, 4039);
INSERT INTO card_set_white_card VALUES (100161, 4100);
INSERT INTO card_set_white_card VALUES (100161, 4038);
INSERT INTO card_set_white_card VALUES (100161, 4103);
INSERT INTO card_set_white_card VALUES (100161, 4037);
INSERT INTO card_set_white_card VALUES (100161, 4102);
INSERT INTO card_set_white_card VALUES (100161, 4036);
INSERT INTO card_set_white_card VALUES (100161, 4105);
INSERT INTO card_set_white_card VALUES (100161, 4043);
INSERT INTO card_set_white_card VALUES (100161, 4104);
INSERT INTO card_set_white_card VALUES (100161, 4042);
INSERT INTO card_set_white_card VALUES (100161, 4107);
INSERT INTO card_set_white_card VALUES (100161, 4041);
INSERT INTO card_set_white_card VALUES (100161, 4106);
INSERT INTO card_set_white_card VALUES (100161, 4040);
INSERT INTO card_set_white_card VALUES (100161, 4109);
INSERT INTO card_set_white_card VALUES (100161, 4047);
INSERT INTO card_set_white_card VALUES (100161, 4108);
INSERT INTO card_set_white_card VALUES (100161, 4046);
INSERT INTO card_set_white_card VALUES (100161, 4111);
INSERT INTO card_set_white_card VALUES (100161, 4045);
INSERT INTO card_set_white_card VALUES (100161, 4110);
INSERT INTO card_set_white_card VALUES (100161, 4044);
INSERT INTO card_set_white_card VALUES (100161, 4112);
INSERT INTO card_set_white_card VALUES (100161, 4050);
INSERT INTO card_set_white_card VALUES (100161, 4113);
INSERT INTO card_set_white_card VALUES (100161, 4051);
INSERT INTO card_set_white_card VALUES (100161, 4114);
INSERT INTO card_set_white_card VALUES (100161, 4048);
INSERT INTO card_set_white_card VALUES (100161, 4115);
INSERT INTO card_set_white_card VALUES (100161, 4049);
INSERT INTO card_set_white_card VALUES (100161, 4116);
INSERT INTO card_set_white_card VALUES (100161, 4054);
INSERT INTO card_set_white_card VALUES (100161, 4117);
INSERT INTO card_set_white_card VALUES (100161, 4055);
INSERT INTO card_set_white_card VALUES (100161, 4118);
INSERT INTO card_set_white_card VALUES (100161, 4052);
INSERT INTO card_set_white_card VALUES (100161, 4119);
INSERT INTO card_set_white_card VALUES (100161, 4053);
INSERT INTO card_set_white_card VALUES (100161, 4120);
INSERT INTO card_set_white_card VALUES (100161, 4058);
INSERT INTO card_set_white_card VALUES (100161, 4121);
INSERT INTO card_set_white_card VALUES (100161, 4059);
INSERT INTO card_set_white_card VALUES (100161, 4122);
INSERT INTO card_set_white_card VALUES (100161, 4056);
INSERT INTO card_set_white_card VALUES (100161, 4123);
INSERT INTO card_set_white_card VALUES (100161, 4057);
INSERT INTO card_set_white_card VALUES (100161, 4124);
INSERT INTO card_set_white_card VALUES (100161, 4062);
INSERT INTO card_set_white_card VALUES (100161, 4125);
INSERT INTO card_set_white_card VALUES (100161, 4063);
INSERT INTO card_set_white_card VALUES (100161, 4126);
INSERT INTO card_set_white_card VALUES (100161, 4060);
INSERT INTO card_set_white_card VALUES (100161, 4127);
INSERT INTO card_set_white_card VALUES (100161, 4061);
INSERT INTO card_set_white_card VALUES (100161, 4199);
INSERT INTO card_set_white_card VALUES (100161, 4005);
INSERT INTO card_set_white_card VALUES (100161, 4004);
INSERT INTO card_set_white_card VALUES (100161, 4197);
INSERT INTO card_set_white_card VALUES (100161, 4007);
INSERT INTO card_set_white_card VALUES (100161, 4196);
INSERT INTO card_set_white_card VALUES (100161, 4006);
INSERT INTO card_set_white_card VALUES (100161, 4195);
INSERT INTO card_set_white_card VALUES (100161, 4001);
INSERT INTO card_set_white_card VALUES (100161, 4194);
INSERT INTO card_set_white_card VALUES (100161, 4000);
INSERT INTO card_set_white_card VALUES (100161, 4193);
INSERT INTO card_set_white_card VALUES (100161, 4003);
INSERT INTO card_set_white_card VALUES (100161, 4192);
INSERT INTO card_set_white_card VALUES (100161, 4002);
INSERT INTO card_set_white_card VALUES (100161, 4207);
INSERT INTO card_set_white_card VALUES (100161, 4013);
INSERT INTO card_set_white_card VALUES (100161, 4206);
INSERT INTO card_set_white_card VALUES (100161, 4012);
INSERT INTO card_set_white_card VALUES (100161, 4205);
INSERT INTO card_set_white_card VALUES (100161, 4015);
INSERT INTO card_set_white_card VALUES (100161, 4204);
INSERT INTO card_set_white_card VALUES (100161, 4014);
INSERT INTO card_set_white_card VALUES (100161, 4203);
INSERT INTO card_set_white_card VALUES (100161, 4009);
INSERT INTO card_set_white_card VALUES (100161, 4202);
INSERT INTO card_set_white_card VALUES (100161, 4008);
INSERT INTO card_set_white_card VALUES (100161, 4201);
INSERT INTO card_set_white_card VALUES (100161, 4011);
INSERT INTO card_set_white_card VALUES (100161, 4200);
INSERT INTO card_set_white_card VALUES (100161, 4010);
INSERT INTO card_set_white_card VALUES (100161, 4214);
INSERT INTO card_set_white_card VALUES (100161, 4020);
INSERT INTO card_set_white_card VALUES (100161, 4215);
INSERT INTO card_set_white_card VALUES (100161, 4021);
INSERT INTO card_set_white_card VALUES (100161, 4212);
INSERT INTO card_set_white_card VALUES (100161, 4022);
INSERT INTO card_set_white_card VALUES (100161, 4213);
INSERT INTO card_set_white_card VALUES (100161, 4023);
INSERT INTO card_set_white_card VALUES (100161, 4210);
INSERT INTO card_set_white_card VALUES (100161, 4016);
INSERT INTO card_set_white_card VALUES (100161, 4211);
INSERT INTO card_set_white_card VALUES (100161, 4017);
INSERT INTO card_set_white_card VALUES (100161, 4018);
INSERT INTO card_set_white_card VALUES (100161, 4209);
INSERT INTO card_set_white_card VALUES (100161, 4019);
INSERT INTO card_set_white_card VALUES (100161, 4222);
INSERT INTO card_set_white_card VALUES (100161, 4028);
INSERT INTO card_set_white_card VALUES (100161, 4223);
INSERT INTO card_set_white_card VALUES (100161, 4029);
INSERT INTO card_set_white_card VALUES (100161, 4220);
INSERT INTO card_set_white_card VALUES (100161, 4030);
INSERT INTO card_set_white_card VALUES (100161, 4221);
INSERT INTO card_set_white_card VALUES (100161, 4031);
INSERT INTO card_set_white_card VALUES (100161, 4218);
INSERT INTO card_set_white_card VALUES (100161, 4024);
INSERT INTO card_set_white_card VALUES (100161, 4219);
INSERT INTO card_set_white_card VALUES (100161, 4025);
INSERT INTO card_set_white_card VALUES (100161, 4216);
INSERT INTO card_set_white_card VALUES (100161, 4026);
INSERT INTO card_set_white_card VALUES (100161, 4217);
INSERT INTO card_set_white_card VALUES (100161, 4027);
INSERT INTO card_set_white_card VALUES (100161, 4165);
INSERT INTO card_set_white_card VALUES (100161, 4164);
INSERT INTO card_set_white_card VALUES (100161, 4167);
INSERT INTO card_set_white_card VALUES (100161, 4166);
INSERT INTO card_set_white_card VALUES (100161, 4161);
INSERT INTO card_set_white_card VALUES (100161, 4163);
INSERT INTO card_set_white_card VALUES (100161, 4162);
INSERT INTO card_set_white_card VALUES (100161, 4173);
INSERT INTO card_set_white_card VALUES (100161, 4172);
INSERT INTO card_set_white_card VALUES (100161, 4175);
INSERT INTO card_set_white_card VALUES (100161, 4174);
INSERT INTO card_set_white_card VALUES (100161, 4169);
INSERT INTO card_set_white_card VALUES (100161, 4168);
INSERT INTO card_set_white_card VALUES (100161, 4171);
INSERT INTO card_set_white_card VALUES (100161, 4170);
INSERT INTO card_set_white_card VALUES (100161, 4180);
INSERT INTO card_set_white_card VALUES (100161, 4181);
INSERT INTO card_set_white_card VALUES (100161, 4182);
INSERT INTO card_set_white_card VALUES (100161, 4183);
INSERT INTO card_set_white_card VALUES (100161, 4176);
INSERT INTO card_set_white_card VALUES (100161, 4177);
INSERT INTO card_set_white_card VALUES (100161, 4178);
INSERT INTO card_set_white_card VALUES (100161, 4179);
INSERT INTO card_set_white_card VALUES (100161, 4188);
INSERT INTO card_set_white_card VALUES (100161, 3998);
INSERT INTO card_set_white_card VALUES (100161, 4189);
INSERT INTO card_set_white_card VALUES (100161, 3999);
INSERT INTO card_set_white_card VALUES (100161, 4190);
INSERT INTO card_set_white_card VALUES (100161, 3996);
INSERT INTO card_set_white_card VALUES (100161, 4191);
INSERT INTO card_set_white_card VALUES (100161, 3997);
INSERT INTO card_set_white_card VALUES (100161, 4184);
INSERT INTO card_set_white_card VALUES (100161, 3994);
INSERT INTO card_set_white_card VALUES (100161, 4185);
INSERT INTO card_set_white_card VALUES (100161, 3995);
INSERT INTO card_set_white_card VALUES (100161, 4186);
INSERT INTO card_set_white_card VALUES (100161, 4187);
INSERT INTO card_set_white_card VALUES (100161, 3993);
INSERT INTO card_set_white_card VALUES (100161, 4224);
INSERT INTO card_set_white_card VALUES (100161, 4225);
INSERT INTO card_set_white_card VALUES (100161, 4226);
INSERT INTO card_set_white_card VALUES (100161, 4227);
INSERT INTO card_set_white_card VALUES (100161, 4228);
INSERT INTO card_set_white_card VALUES (100003, 4084);
INSERT INTO card_set_white_card VALUES (100003, 4085);
INSERT INTO card_set_white_card VALUES (100003, 4148);
INSERT INTO card_set_white_card VALUES (100003, 4088);
INSERT INTO card_set_white_card VALUES (100003, 4089);
INSERT INTO card_set_white_card VALUES (100003, 4090);
INSERT INTO card_set_white_card VALUES (100003, 4096);
INSERT INTO card_set_white_card VALUES (100003, 4044);
INSERT INTO card_set_white_card VALUES (100003, 4053);
INSERT INTO card_set_white_card VALUES (100003, 4120);
INSERT INTO card_set_white_card VALUES (100003, 4121);
INSERT INTO card_set_white_card VALUES (100003, 4207);
INSERT INTO card_set_white_card VALUES (100003, 4201);
INSERT INTO card_set_white_card VALUES (100003, 4011);
INSERT INTO card_set_white_card VALUES (100003, 4021);
INSERT INTO card_set_white_card VALUES (100003, 4023);
INSERT INTO card_set_white_card VALUES (100003, 4029);
INSERT INTO card_set_white_card VALUES (100003, 4030);
INSERT INTO card_set_white_card VALUES (100003, 4031);
INSERT INTO card_set_white_card VALUES (100003, 4161);
INSERT INTO card_set_white_card VALUES (100003, 4175);
INSERT INTO card_set_white_card VALUES (100003, 4170);
INSERT INTO card_set_white_card VALUES (100003, 4180);
INSERT INTO card_set_white_card VALUES (100003, 4183);
INSERT INTO card_set_white_card VALUES (100003, 3998);
INSERT INTO card_set_white_card VALUES (100003, 3996);
INSERT INTO card_set_white_card VALUES (100003, 4191);
INSERT INTO card_set_white_card VALUES (100003, 3994);
INSERT INTO card_set_white_card VALUES (100003, 4045);
INSERT INTO card_set_white_card VALUES (100157, 4229);
INSERT INTO card_set_white_card VALUES (100017, 100162);
INSERT INTO card_set_white_card VALUES (100003, 100162);
INSERT INTO card_set_white_card VALUES (100211, 100193);
INSERT INTO card_set_white_card VALUES (100211, 100192);
INSERT INTO card_set_white_card VALUES (100211, 100195);
INSERT INTO card_set_white_card VALUES (100211, 100194);
INSERT INTO card_set_white_card VALUES (100211, 100197);
INSERT INTO card_set_white_card VALUES (100211, 100196);
INSERT INTO card_set_white_card VALUES (100211, 100199);
INSERT INTO card_set_white_card VALUES (100211, 100198);
INSERT INTO card_set_white_card VALUES (100211, 100201);
INSERT INTO card_set_white_card VALUES (100211, 100200);
INSERT INTO card_set_white_card VALUES (100211, 100202);
INSERT INTO card_set_white_card VALUES (100211, 100205);
INSERT INTO card_set_white_card VALUES (100211, 100204);
INSERT INTO card_set_white_card VALUES (100211, 100167);
INSERT INTO card_set_white_card VALUES (100211, 100166);
INSERT INTO card_set_white_card VALUES (100211, 100165);
INSERT INTO card_set_white_card VALUES (100211, 100164);
INSERT INTO card_set_white_card VALUES (100211, 100170);
INSERT INTO card_set_white_card VALUES (100211, 100168);
INSERT INTO card_set_white_card VALUES (100211, 100175);
INSERT INTO card_set_white_card VALUES (100211, 100174);
INSERT INTO card_set_white_card VALUES (100211, 100173);
INSERT INTO card_set_white_card VALUES (100211, 100172);
INSERT INTO card_set_white_card VALUES (100211, 100178);
INSERT INTO card_set_white_card VALUES (100211, 100179);
INSERT INTO card_set_white_card VALUES (100211, 100176);
INSERT INTO card_set_white_card VALUES (100211, 100177);
INSERT INTO card_set_white_card VALUES (100211, 100182);
INSERT INTO card_set_white_card VALUES (100211, 100183);
INSERT INTO card_set_white_card VALUES (100211, 100180);
INSERT INTO card_set_white_card VALUES (100211, 100181);
INSERT INTO card_set_white_card VALUES (100211, 100186);
INSERT INTO card_set_white_card VALUES (100211, 100187);
INSERT INTO card_set_white_card VALUES (100211, 100184);
INSERT INTO card_set_white_card VALUES (100211, 100185);
INSERT INTO card_set_white_card VALUES (100211, 100190);
INSERT INTO card_set_white_card VALUES (100211, 100191);
INSERT INTO card_set_white_card VALUES (100211, 100188);
INSERT INTO card_set_white_card VALUES (100211, 100189);
INSERT INTO card_set_white_card VALUES (100211, 19);
INSERT INTO card_set_white_card VALUES (100211, 441);
INSERT INTO card_set_white_card VALUES (100211, 308);
INSERT INTO card_set_white_card VALUES (100211, 173);
INSERT INTO card_set_white_card VALUES (100211, 340);
INSERT INTO card_set_white_card VALUES (100211, 85);
INSERT INTO card_set_white_card VALUES (100211, 101);
INSERT INTO card_set_white_card VALUES (100211, 368);
INSERT INTO card_set_white_card VALUES (100211, 380);
INSERT INTO card_set_white_card VALUES (100211, 357);
INSERT INTO card_set_white_card VALUES (100211, 365);
INSERT INTO card_set_white_card VALUES (100211, 272);
INSERT INTO card_set_white_card VALUES (100211, 400);
INSERT INTO card_set_white_card VALUES (100211, 154);
INSERT INTO card_set_white_card VALUES (100211, 100212);
INSERT INTO card_set_white_card VALUES (100211, 145);
INSERT INTO card_set_white_card VALUES (100211, 384);
INSERT INTO card_set_white_card VALUES (100211, 34);
INSERT INTO card_set_white_card VALUES (100211, 169);
INSERT INTO card_set_white_card VALUES (100211, 36);
INSERT INTO card_set_white_card VALUES (100211, 312);
INSERT INTO card_set_white_card VALUES (100211, 167);
INSERT INTO card_set_white_card VALUES (100211, 45);
INSERT INTO card_set_white_card VALUES (100211, 294);
INSERT INTO card_set_white_card VALUES (100211, 295);
INSERT INTO card_set_white_card VALUES (100211, 419);
INSERT INTO card_set_white_card VALUES (100211, 301);
INSERT INTO card_set_white_card VALUES (100211, 77);
INSERT INTO card_set_white_card VALUES (100211, 471);
INSERT INTO card_set_white_card VALUES (100211, 74);
INSERT INTO card_set_white_card VALUES (100211, 456);
INSERT INTO card_set_white_card VALUES (100211, 93);
INSERT INTO card_set_white_card VALUES (100211, 209);
INSERT INTO card_set_white_card VALUES (100211, 102);
INSERT INTO card_set_white_card VALUES (100211, 232);
INSERT INTO card_set_white_card VALUES (100211, 106);
INSERT INTO card_set_white_card VALUES (100211, 358);
INSERT INTO card_set_white_card VALUES (100211, 359);
INSERT INTO card_set_white_card VALUES (100211, 122);
INSERT INTO card_set_white_card VALUES (100211, 6);
INSERT INTO card_set_white_card VALUES (100211, 263);
INSERT INTO card_set_white_card VALUES (100211, 266);
INSERT INTO card_set_white_card VALUES (100211, 31);
INSERT INTO card_set_white_card VALUES (100211, 315);
INSERT INTO card_set_white_card VALUES (100211, 292);
INSERT INTO card_set_white_card VALUES (100211, 303);
INSERT INTO card_set_white_card VALUES (100211, 347);
INSERT INTO card_set_white_card VALUES (100211, 345);
INSERT INTO card_set_white_card VALUES (100211, 103);
INSERT INTO card_set_white_card VALUES (100211, 125);
INSERT INTO card_set_white_card VALUES (100211, 437);
INSERT INTO card_set_white_card VALUES (100211, 427);
INSERT INTO card_set_white_card VALUES (100211, 193);
INSERT INTO card_set_white_card VALUES (100211, 462);
INSERT INTO card_set_white_card VALUES (100211, 451);
INSERT INTO card_set_white_card VALUES (100211, 235);
INSERT INTO card_set_white_card VALUES (100211, 226);
INSERT INTO card_set_white_card VALUES (100211, 488);
INSERT INTO card_set_white_card VALUES (100211, 283);
INSERT INTO card_set_white_card VALUES (100211, 286);
INSERT INTO card_set_white_card VALUES (100211, 23);
INSERT INTO card_set_white_card VALUES (100211, 26);
INSERT INTO card_set_white_card VALUES (100211, 270);
INSERT INTO card_set_white_card VALUES (100211, 305);
INSERT INTO card_set_white_card VALUES (100211, 306);
INSERT INTO card_set_white_card VALUES (100211, 296);
INSERT INTO card_set_white_card VALUES (100211, 70);
INSERT INTO card_set_white_card VALUES (100211, 71);
INSERT INTO card_set_white_card VALUES (100211, 337);
INSERT INTO card_set_white_card VALUES (100211, 1038);
INSERT INTO card_set_white_card VALUES (100211, 336);
INSERT INTO card_set_white_card VALUES (100211, 87);
INSERT INTO card_set_white_card VALUES (100211, 1041);
INSERT INTO card_set_white_card VALUES (100211, 1042);
INSERT INTO card_set_white_card VALUES (100211, 330);
INSERT INTO card_set_white_card VALUES (100211, 355);
INSERT INTO card_set_white_card VALUES (100211, 367);
INSERT INTO card_set_white_card VALUES (100211, 362);
INSERT INTO card_set_white_card VALUES (100211, 138);
INSERT INTO card_set_white_card VALUES (100211, 389);
INSERT INTO card_set_white_card VALUES (100211, 444);
INSERT INTO card_set_white_card VALUES (100211, 446);
INSERT INTO card_set_white_card VALUES (100211, 172);
INSERT INTO card_set_white_card VALUES (100211, 418);
INSERT INTO card_set_white_card VALUES (100211, 420);
INSERT INTO card_set_white_card VALUES (100211, 479);
INSERT INTO card_set_white_card VALUES (100211, 195);
INSERT INTO card_set_white_card VALUES (100211, 222);
INSERT INTO card_set_white_card VALUES (100211, 461);
INSERT INTO card_set_white_card VALUES (100211, 210);
INSERT INTO card_set_white_card VALUES (100211, 448);
INSERT INTO card_set_white_card VALUES (100211, 229);
INSERT INTO card_set_white_card VALUES (100211, 249);
INSERT INTO card_set_white_card VALUES (100211, 245);
INSERT INTO card_set_white_card VALUES (100211, 256);
INSERT INTO card_set_white_card VALUES (100211, 35);
INSERT INTO card_set_white_card VALUES (100211, 33);
INSERT INTO card_set_white_card VALUES (100211, 310);
INSERT INTO card_set_white_card VALUES (100211, 40);
INSERT INTO card_set_white_card VALUES (100211, 44);
INSERT INTO card_set_white_card VALUES (100211, 49);
INSERT INTO card_set_white_card VALUES (100211, 63);
INSERT INTO card_set_white_card VALUES (100211, 1035);
INSERT INTO card_set_white_card VALUES (100211, 65);
INSERT INTO card_set_white_card VALUES (100211, 67);
INSERT INTO card_set_white_card VALUES (100211, 329);
INSERT INTO card_set_white_card VALUES (100211, 98);
INSERT INTO card_set_white_card VALUES (100211, 104);
INSERT INTO card_set_white_card VALUES (100211, 105);
INSERT INTO card_set_white_card VALUES (100211, 360);
INSERT INTO card_set_white_card VALUES (100211, 137);
INSERT INTO card_set_white_card VALUES (100211, 142);
INSERT INTO card_set_white_card VALUES (100211, 394);
INSERT INTO card_set_white_card VALUES (100211, 151);
INSERT INTO card_set_white_card VALUES (100211, 171);
INSERT INTO card_set_white_card VALUES (100211, 443);
INSERT INTO card_set_white_card VALUES (100211, 447);
INSERT INTO card_set_white_card VALUES (100211, 434);
INSERT INTO card_set_white_card VALUES (100211, 161);
INSERT INTO card_set_white_card VALUES (100211, 189);
INSERT INTO card_set_white_card VALUES (100211, 417);
INSERT INTO card_set_white_card VALUES (100211, 478);
INSERT INTO card_set_white_card VALUES (100211, 475);
INSERT INTO card_set_white_card VALUES (100211, 198);
INSERT INTO card_set_white_card VALUES (100211, 463);
INSERT INTO card_set_white_card VALUES (100211, 223);
INSERT INTO card_set_white_card VALUES (100211, 457);
INSERT INTO card_set_white_card VALUES (100211, 504);
INSERT INTO card_set_white_card VALUES (100211, 503);
INSERT INTO card_set_white_card VALUES (100211, 244);
INSERT INTO card_set_white_card VALUES (100211, 481);
INSERT INTO card_set_white_card VALUES (100211, 2);
INSERT INTO card_set_white_card VALUES (100211, 10);
INSERT INTO card_set_white_card VALUES (100211, 27);
INSERT INTO card_set_white_card VALUES (100211, 32);
INSERT INTO card_set_white_card VALUES (100211, 37);
INSERT INTO card_set_white_card VALUES (100211, 42);
INSERT INTO card_set_white_card VALUES (100211, 41);
INSERT INTO card_set_white_card VALUES (100211, 51);
INSERT INTO card_set_white_card VALUES (100211, 56);
INSERT INTO card_set_white_card VALUES (100211, 72);
INSERT INTO card_set_white_card VALUES (100211, 97);
INSERT INTO card_set_white_card VALUES (100211, 118);
INSERT INTO card_set_white_card VALUES (100211, 114);
INSERT INTO card_set_white_card VALUES (100211, 141);
INSERT INTO card_set_white_card VALUES (100211, 140);
INSERT INTO card_set_white_card VALUES (100211, 160);
INSERT INTO card_set_white_card VALUES (100211, 200);
INSERT INTO card_set_white_card VALUES (100211, 202);
INSERT INTO card_set_white_card VALUES (100211, 221);
INSERT INTO card_set_white_card VALUES (100211, 218);
INSERT INTO card_set_white_card VALUES (100211, 246);
INSERT INTO card_set_white_card VALUES (100211, 287);
INSERT INTO card_set_white_card VALUES (100211, 265);
INSERT INTO card_set_white_card VALUES (100211, 297);
INSERT INTO card_set_white_card VALUES (100211, 300);
INSERT INTO card_set_white_card VALUES (100211, 339);
INSERT INTO card_set_white_card VALUES (100211, 325);
INSERT INTO card_set_white_card VALUES (100211, 354);
INSERT INTO card_set_white_card VALUES (100211, 361);
INSERT INTO card_set_white_card VALUES (100211, 405);
INSERT INTO card_set_white_card VALUES (100211, 399);
INSERT INTO card_set_white_card VALUES (100211, 445);
INSERT INTO card_set_white_card VALUES (100211, 436);
INSERT INTO card_set_white_card VALUES (100211, 423);
INSERT INTO card_set_white_card VALUES (100211, 469);
INSERT INTO card_set_white_card VALUES (100211, 484);
INSERT INTO card_set_white_card VALUES (100211, 12);
INSERT INTO card_set_white_card VALUES (100211, 94);
INSERT INTO card_set_white_card VALUES (100211, 166);
INSERT INTO card_set_white_card VALUES (100211, 180);
INSERT INTO card_set_white_card VALUES (100211, 239);
INSERT INTO card_set_white_card VALUES (100211, 274);
INSERT INTO card_set_white_card VALUES (100211, 317);
INSERT INTO card_set_white_card VALUES (100211, 348);
INSERT INTO card_set_white_card VALUES (100211, 334);
INSERT INTO card_set_white_card VALUES (100211, 370);
INSERT INTO card_set_white_card VALUES (100211, 356);
INSERT INTO card_set_white_card VALUES (100211, 395);
INSERT INTO card_set_white_card VALUES (100211, 432);
INSERT INTO card_set_white_card VALUES (100211, 435);
INSERT INTO card_set_white_card VALUES (100211, 426);
INSERT INTO card_set_white_card VALUES (100211, 508);
INSERT INTO card_set_white_card VALUES (100211, 48);
INSERT INTO card_set_white_card VALUES (100211, 90);
INSERT INTO card_set_white_card VALUES (100211, 132);
INSERT INTO card_set_white_card VALUES (100211, 159);
INSERT INTO card_set_white_card VALUES (100211, 146);
INSERT INTO card_set_white_card VALUES (100211, 175);
INSERT INTO card_set_white_card VALUES (100211, 191);
INSERT INTO card_set_white_card VALUES (100211, 205);
INSERT INTO card_set_white_card VALUES (100211, 237);
INSERT INTO card_set_white_card VALUES (100211, 230);
INSERT INTO card_set_white_card VALUES (100211, 241);
INSERT INTO card_set_white_card VALUES (100211, 332);
INSERT INTO card_set_white_card VALUES (100211, 411);
INSERT INTO card_set_white_card VALUES (100211, 425);
INSERT INTO card_set_white_card VALUES (100211, 453);
INSERT INTO card_set_white_card VALUES (100211, 492);
INSERT INTO card_set_white_card VALUES (100211, 495);
INSERT INTO card_set_white_card VALUES (100211, 480);
INSERT INTO card_set_white_card VALUES (100211, 38);
INSERT INTO card_set_white_card VALUES (100211, 50);
INSERT INTO card_set_white_card VALUES (100211, 61);
INSERT INTO card_set_white_card VALUES (100211, 1036);
INSERT INTO card_set_white_card VALUES (100211, 80);
INSERT INTO card_set_white_card VALUES (100211, 117);
INSERT INTO card_set_white_card VALUES (100211, 115);
INSERT INTO card_set_white_card VALUES (100211, 127);
INSERT INTO card_set_white_card VALUES (100211, 126);
INSERT INTO card_set_white_card VALUES (100211, 124);
INSERT INTO card_set_white_card VALUES (100211, 136);
INSERT INTO card_set_white_card VALUES (100211, 135);
INSERT INTO card_set_white_card VALUES (100211, 150);
INSERT INTO card_set_white_card VALUES (100211, 170);
INSERT INTO card_set_white_card VALUES (100211, 204);
INSERT INTO card_set_white_card VALUES (100211, 206);
INSERT INTO card_set_white_card VALUES (100211, 194);
INSERT INTO card_set_white_card VALUES (100211, 208);
INSERT INTO card_set_white_card VALUES (100211, 236);
INSERT INTO card_set_white_card VALUES (100211, 228);
INSERT INTO card_set_white_card VALUES (100211, 255);
INSERT INTO card_set_white_card VALUES (100211, 253);
INSERT INTO card_set_white_card VALUES (100211, 276);
INSERT INTO card_set_white_card VALUES (100211, 298);
INSERT INTO card_set_white_card VALUES (100211, 299);
INSERT INTO card_set_white_card VALUES (100211, 326);
INSERT INTO card_set_white_card VALUES (100211, 327);
INSERT INTO card_set_white_card VALUES (100211, 382);
INSERT INTO card_set_white_card VALUES (100211, 376);
INSERT INTO card_set_white_card VALUES (100211, 440);
INSERT INTO card_set_white_card VALUES (100211, 431);
INSERT INTO card_set_white_card VALUES (100211, 476);
INSERT INTO card_set_white_card VALUES (100211, 477);
INSERT INTO card_set_white_card VALUES (100211, 474);
INSERT INTO card_set_white_card VALUES (100211, 501);
INSERT INTO card_set_white_card VALUES (100211, 496);
INSERT INTO card_set_white_card VALUES (100211, 499);
INSERT INTO card_set_white_card VALUES (100211, 493);
INSERT INTO card_set_white_card VALUES (100211, 485);
INSERT INTO card_set_white_card VALUES (100211, 22);
INSERT INTO card_set_white_card VALUES (100211, 30);
INSERT INTO card_set_white_card VALUES (100211, 47);
INSERT INTO card_set_white_card VALUES (100211, 62);
INSERT INTO card_set_white_card VALUES (100211, 60);
INSERT INTO card_set_white_card VALUES (100211, 73);
INSERT INTO card_set_white_card VALUES (100211, 88);
INSERT INTO card_set_white_card VALUES (100211, 111);
INSERT INTO card_set_white_card VALUES (100211, 147);
INSERT INTO card_set_white_card VALUES (100211, 149);
INSERT INTO card_set_white_card VALUES (100211, 168);
INSERT INTO card_set_white_card VALUES (100211, 185);
INSERT INTO card_set_white_card VALUES (100211, 182);
INSERT INTO card_set_white_card VALUES (100211, 220);
INSERT INTO card_set_white_card VALUES (100211, 213);
INSERT INTO card_set_white_card VALUES (100211, 225);
INSERT INTO card_set_white_card VALUES (100211, 275);
INSERT INTO card_set_white_card VALUES (100211, 277);
INSERT INTO card_set_white_card VALUES (100211, 311);
INSERT INTO card_set_white_card VALUES (100211, 319);
INSERT INTO card_set_white_card VALUES (100211, 349);
INSERT INTO card_set_white_card VALUES (100211, 373);
INSERT INTO card_set_white_card VALUES (100211, 372);
INSERT INTO card_set_white_card VALUES (100211, 375);
INSERT INTO card_set_white_card VALUES (100211, 409);
INSERT INTO card_set_white_card VALUES (100211, 414);
INSERT INTO card_set_white_card VALUES (100211, 415);
INSERT INTO card_set_white_card VALUES (100211, 407);
INSERT INTO card_set_white_card VALUES (100211, 396);
INSERT INTO card_set_white_card VALUES (100211, 391);
INSERT INTO card_set_white_card VALUES (100211, 388);
INSERT INTO card_set_white_card VALUES (100211, 442);
INSERT INTO card_set_white_card VALUES (100211, 421);
INSERT INTO card_set_white_card VALUES (100211, 467);
INSERT INTO card_set_white_card VALUES (100211, 452);
INSERT INTO card_set_white_card VALUES (100211, 500);
INSERT INTO card_set_white_card VALUES (100211, 497);
INSERT INTO card_set_white_card VALUES (100211, 487);
INSERT INTO card_set_white_card VALUES (100211, 24);
INSERT INTO card_set_white_card VALUES (100211, 46);
INSERT INTO card_set_white_card VALUES (100211, 1039);
INSERT INTO card_set_white_card VALUES (100211, 82);
INSERT INTO card_set_white_card VALUES (100211, 128);
INSERT INTO card_set_white_card VALUES (100211, 181);
INSERT INTO card_set_white_card VALUES (100211, 211);
INSERT INTO card_set_white_card VALUES (100211, 252);
INSERT INTO card_set_white_card VALUES (100211, 280);
INSERT INTO card_set_white_card VALUES (100211, 257);
INSERT INTO card_set_white_card VALUES (100211, 322);
INSERT INTO card_set_white_card VALUES (100211, 402);
INSERT INTO card_set_white_card VALUES (100211, 401);
INSERT INTO card_set_white_card VALUES (100211, 404);
INSERT INTO card_set_white_card VALUES (100211, 392);
INSERT INTO card_set_white_card VALUES (100211, 387);
INSERT INTO card_set_white_card VALUES (100211, 385);
INSERT INTO card_set_white_card VALUES (100211, 466);
INSERT INTO card_set_white_card VALUES (100211, 482);
INSERT INTO card_set_white_card VALUES (100211, 3);
INSERT INTO card_set_white_card VALUES (100211, 100213);
INSERT INTO card_set_white_card VALUES (100211, 28);
INSERT INTO card_set_white_card VALUES (100211, 52);
INSERT INTO card_set_white_card VALUES (100211, 59);
INSERT INTO card_set_white_card VALUES (100211, 58);
INSERT INTO card_set_white_card VALUES (100211, 57);
INSERT INTO card_set_white_card VALUES (100211, 83);
INSERT INTO card_set_white_card VALUES (100211, 1040);
INSERT INTO card_set_white_card VALUES (100211, 109);
INSERT INTO card_set_white_card VALUES (100211, 155);
INSERT INTO card_set_white_card VALUES (100211, 144);
INSERT INTO card_set_white_card VALUES (100211, 163);
INSERT INTO card_set_white_card VALUES (100211, 201);
INSERT INTO card_set_white_card VALUES (100211, 199);
INSERT INTO card_set_white_card VALUES (100211, 217);
INSERT INTO card_set_white_card VALUES (100211, 234);
INSERT INTO card_set_white_card VALUES (100211, 231);
INSERT INTO card_set_white_card VALUES (100211, 224);
INSERT INTO card_set_white_card VALUES (100211, 254);
INSERT INTO card_set_white_card VALUES (100211, 261);
INSERT INTO card_set_white_card VALUES (100211, 314);
INSERT INTO card_set_white_card VALUES (100211, 316);
INSERT INTO card_set_white_card VALUES (100211, 343);
INSERT INTO card_set_white_card VALUES (100211, 351);
INSERT INTO card_set_white_card VALUES (100211, 346);
INSERT INTO card_set_white_card VALUES (100211, 364);
INSERT INTO card_set_white_card VALUES (100211, 408);
INSERT INTO card_set_white_card VALUES (100211, 412);
INSERT INTO card_set_white_card VALUES (100211, 406);
INSERT INTO card_set_white_card VALUES (100211, 430);
INSERT INTO card_set_white_card VALUES (100211, 416);
INSERT INTO card_set_white_card VALUES (100211, 472);
INSERT INTO card_set_white_card VALUES (100211, 470);
INSERT INTO card_set_white_card VALUES (100211, 460);
INSERT INTO card_set_white_card VALUES (100211, 494);
INSERT INTO card_set_white_card VALUES (100211, 490);
INSERT INTO card_set_white_card VALUES (100211, 54);
INSERT INTO card_set_white_card VALUES (100211, 53);
INSERT INTO card_set_white_card VALUES (100211, 79);
INSERT INTO card_set_white_card VALUES (100211, 91);
INSERT INTO card_set_white_card VALUES (100211, 112);
INSERT INTO card_set_white_card VALUES (100211, 153);
INSERT INTO card_set_white_card VALUES (100211, 183);
INSERT INTO card_set_white_card VALUES (100211, 197);
INSERT INTO card_set_white_card VALUES (100211, 284);
INSERT INTO card_set_white_card VALUES (100211, 259);
INSERT INTO card_set_white_card VALUES (100211, 413);
INSERT INTO card_set_white_card VALUES (100211, 455);
INSERT INTO card_set_white_card VALUES (100211, 505);
INSERT INTO card_set_white_card VALUES (100211, 506);
INSERT INTO card_set_white_card VALUES (100211, 489);
INSERT INTO card_set_white_card VALUES (100211, 1);
INSERT INTO card_set_white_card VALUES (100211, 11);
INSERT INTO card_set_white_card VALUES (100211, 13);
INSERT INTO card_set_white_card VALUES (100211, 16);
INSERT INTO card_set_white_card VALUES (100211, 100214);
INSERT INTO card_set_white_card VALUES (100211, 100215);
INSERT INTO card_set_white_card VALUES (100211, 25);
INSERT INTO card_set_white_card VALUES (100211, 29);
INSERT INTO card_set_white_card VALUES (100211, 39);
INSERT INTO card_set_white_card VALUES (100211, 55);
INSERT INTO card_set_white_card VALUES (100211, 1037);
INSERT INTO card_set_white_card VALUES (100211, 76);
INSERT INTO card_set_white_card VALUES (100211, 75);
INSERT INTO card_set_white_card VALUES (100211, 108);
INSERT INTO card_set_white_card VALUES (100211, 129);
INSERT INTO card_set_white_card VALUES (100211, 152);
INSERT INTO card_set_white_card VALUES (100211, 157);
INSERT INTO card_set_white_card VALUES (100211, 148);
INSERT INTO card_set_white_card VALUES (100211, 174);
INSERT INTO card_set_white_card VALUES (100211, 165);
INSERT INTO card_set_white_card VALUES (100211, 178);
INSERT INTO card_set_white_card VALUES (100211, 179);
INSERT INTO card_set_white_card VALUES (100211, 203);
INSERT INTO card_set_white_card VALUES (100211, 196);
INSERT INTO card_set_white_card VALUES (100211, 192);
INSERT INTO card_set_white_card VALUES (100211, 216);
INSERT INTO card_set_white_card VALUES (100211, 215);
INSERT INTO card_set_white_card VALUES (100211, 238);
INSERT INTO card_set_white_card VALUES (100211, 233);
INSERT INTO card_set_white_card VALUES (100211, 227);
INSERT INTO card_set_white_card VALUES (100211, 250);
INSERT INTO card_set_white_card VALUES (100211, 242);
INSERT INTO card_set_white_card VALUES (100211, 279);
INSERT INTO card_set_white_card VALUES (100211, 267);
INSERT INTO card_set_white_card VALUES (100211, 271);
INSERT INTO card_set_white_card VALUES (100211, 268);
INSERT INTO card_set_white_card VALUES (100211, 269);
INSERT INTO card_set_white_card VALUES (100211, 304);
INSERT INTO card_set_white_card VALUES (100211, 318);
INSERT INTO card_set_white_card VALUES (100211, 323);
INSERT INTO card_set_white_card VALUES (100211, 377);
INSERT INTO card_set_white_card VALUES (100211, 393);
INSERT INTO card_set_white_card VALUES (100211, 397);
INSERT INTO card_set_white_card VALUES (100211, 386);
INSERT INTO card_set_white_card VALUES (100211, 433);
INSERT INTO card_set_white_card VALUES (100211, 429);
INSERT INTO card_set_white_card VALUES (100211, 473);
INSERT INTO card_set_white_card VALUES (100211, 465);
INSERT INTO card_set_white_card VALUES (100211, 459);
INSERT INTO card_set_white_card VALUES (100211, 458);
INSERT INTO card_set_white_card VALUES (100211, 100216);
INSERT INTO card_set_white_card VALUES (100211, 4);
INSERT INTO card_set_white_card VALUES (100211, 5);
INSERT INTO card_set_white_card VALUES (100211, 7);
INSERT INTO card_set_white_card VALUES (100211, 18);
INSERT INTO card_set_white_card VALUES (100211, 1034);
INSERT INTO card_set_white_card VALUES (100211, 84);
INSERT INTO card_set_white_card VALUES (100211, 95);
INSERT INTO card_set_white_card VALUES (100211, 99);
INSERT INTO card_set_white_card VALUES (100211, 212);
INSERT INTO card_set_white_card VALUES (100211, 214);
INSERT INTO card_set_white_card VALUES (100211, 278);
INSERT INTO card_set_white_card VALUES (100211, 282);
INSERT INTO card_set_white_card VALUES (100211, 290);
INSERT INTO card_set_white_card VALUES (100211, 302);
INSERT INTO card_set_white_card VALUES (100211, 324);
INSERT INTO card_set_white_card VALUES (100211, 374);
INSERT INTO card_set_white_card VALUES (100211, 410);
INSERT INTO card_set_white_card VALUES (100211, 390);
INSERT INTO card_set_white_card VALUES (100211, 187);
INSERT INTO card_set_white_card VALUES (100211, 293);
INSERT INTO card_set_white_card VALUES (100211, 498);
INSERT INTO card_set_white_card VALUES (100161, 4266);
INSERT INTO card_set_white_card VALUES (100161, 4267);
INSERT INTO card_set_white_card VALUES (100161, 4264);
INSERT INTO card_set_white_card VALUES (100161, 4265);
INSERT INTO card_set_white_card VALUES (100161, 4270);
INSERT INTO card_set_white_card VALUES (100161, 4271);
INSERT INTO card_set_white_card VALUES (100161, 4268);
INSERT INTO card_set_white_card VALUES (100161, 4269);
INSERT INTO card_set_white_card VALUES (100161, 4258);
INSERT INTO card_set_white_card VALUES (100161, 4259);
INSERT INTO card_set_white_card VALUES (100161, 4256);
INSERT INTO card_set_white_card VALUES (100161, 4257);
INSERT INTO card_set_white_card VALUES (100161, 4262);
INSERT INTO card_set_white_card VALUES (100161, 4263);
INSERT INTO card_set_white_card VALUES (100161, 4260);
INSERT INTO card_set_white_card VALUES (100161, 4261);
INSERT INTO card_set_white_card VALUES (100161, 4273);
INSERT INTO card_set_white_card VALUES (100161, 4272);
INSERT INTO card_set_white_card VALUES (100161, 4232);
INSERT INTO card_set_white_card VALUES (100161, 4233);
INSERT INTO card_set_white_card VALUES (100161, 4234);
INSERT INTO card_set_white_card VALUES (100161, 4235);
INSERT INTO card_set_white_card VALUES (100161, 4236);
INSERT INTO card_set_white_card VALUES (100161, 4237);
INSERT INTO card_set_white_card VALUES (100161, 4238);
INSERT INTO card_set_white_card VALUES (100161, 4239);
INSERT INTO card_set_white_card VALUES (100161, 4230);
INSERT INTO card_set_white_card VALUES (100161, 4231);
INSERT INTO card_set_white_card VALUES (100161, 4249);
INSERT INTO card_set_white_card VALUES (100161, 4248);
INSERT INTO card_set_white_card VALUES (100161, 4251);
INSERT INTO card_set_white_card VALUES (100161, 4250);
INSERT INTO card_set_white_card VALUES (100161, 4253);
INSERT INTO card_set_white_card VALUES (100161, 4252);
INSERT INTO card_set_white_card VALUES (100161, 4255);
INSERT INTO card_set_white_card VALUES (100161, 4254);
INSERT INTO card_set_white_card VALUES (100161, 4241);
INSERT INTO card_set_white_card VALUES (100161, 4240);
INSERT INTO card_set_white_card VALUES (100161, 4243);
INSERT INTO card_set_white_card VALUES (100161, 4242);
INSERT INTO card_set_white_card VALUES (100161, 4245);
INSERT INTO card_set_white_card VALUES (100161, 4244);
INSERT INTO card_set_white_card VALUES (100161, 4247);
INSERT INTO card_set_white_card VALUES (100161, 4246);
INSERT INTO card_set_white_card VALUES (100157, 4275);
INSERT INTO card_set_white_card VALUES (100157, 4274);
INSERT INTO card_set_white_card VALUES (100157, 4277);
INSERT INTO card_set_white_card VALUES (100157, 4276);
INSERT INTO card_set_white_card VALUES (100219, 4400);
INSERT INTO card_set_white_card VALUES (100219, 4401);
INSERT INTO card_set_white_card VALUES (100219, 4402);
INSERT INTO card_set_white_card VALUES (100219, 4403);
INSERT INTO card_set_white_card VALUES (100219, 4404);
INSERT INTO card_set_white_card VALUES (100219, 4405);
INSERT INTO card_set_white_card VALUES (100219, 4406);
INSERT INTO card_set_white_card VALUES (100219, 4407);
INSERT INTO card_set_white_card VALUES (100219, 4408);
INSERT INTO card_set_white_card VALUES (100219, 4409);
INSERT INTO card_set_white_card VALUES (100219, 4410);
INSERT INTO card_set_white_card VALUES (100219, 4411);
INSERT INTO card_set_white_card VALUES (100219, 4412);
INSERT INTO card_set_white_card VALUES (100219, 4413);
INSERT INTO card_set_white_card VALUES (100219, 4414);
INSERT INTO card_set_white_card VALUES (100219, 4415);
INSERT INTO card_set_white_card VALUES (100219, 4385);
INSERT INTO card_set_white_card VALUES (100219, 4384);
INSERT INTO card_set_white_card VALUES (100219, 4387);
INSERT INTO card_set_white_card VALUES (100219, 4386);
INSERT INTO card_set_white_card VALUES (100219, 4389);
INSERT INTO card_set_white_card VALUES (100219, 4388);
INSERT INTO card_set_white_card VALUES (100219, 4391);
INSERT INTO card_set_white_card VALUES (100219, 4390);
INSERT INTO card_set_white_card VALUES (100219, 4393);
INSERT INTO card_set_white_card VALUES (100219, 4392);
INSERT INTO card_set_white_card VALUES (100219, 4395);
INSERT INTO card_set_white_card VALUES (100219, 4394);
INSERT INTO card_set_white_card VALUES (100219, 4397);
INSERT INTO card_set_white_card VALUES (100219, 4396);
INSERT INTO card_set_white_card VALUES (100219, 4399);
INSERT INTO card_set_white_card VALUES (100219, 4398);
INSERT INTO card_set_white_card VALUES (100219, 4370);
INSERT INTO card_set_white_card VALUES (100219, 4371);
INSERT INTO card_set_white_card VALUES (100219, 4368);
INSERT INTO card_set_white_card VALUES (100219, 4369);
INSERT INTO card_set_white_card VALUES (100219, 4374);
INSERT INTO card_set_white_card VALUES (100219, 4375);
INSERT INTO card_set_white_card VALUES (100219, 4372);
INSERT INTO card_set_white_card VALUES (100219, 4373);
INSERT INTO card_set_white_card VALUES (100219, 4378);
INSERT INTO card_set_white_card VALUES (100219, 4379);
INSERT INTO card_set_white_card VALUES (100219, 4376);
INSERT INTO card_set_white_card VALUES (100219, 4377);
INSERT INTO card_set_white_card VALUES (100219, 4382);
INSERT INTO card_set_white_card VALUES (100219, 4383);
INSERT INTO card_set_white_card VALUES (100219, 4380);
INSERT INTO card_set_white_card VALUES (100219, 4381);
INSERT INTO card_set_white_card VALUES (100219, 4359);
INSERT INTO card_set_white_card VALUES (100219, 4358);
INSERT INTO card_set_white_card VALUES (100219, 4363);
INSERT INTO card_set_white_card VALUES (100219, 4362);
INSERT INTO card_set_white_card VALUES (100219, 4361);
INSERT INTO card_set_white_card VALUES (100219, 4360);
INSERT INTO card_set_white_card VALUES (100219, 4367);
INSERT INTO card_set_white_card VALUES (100219, 4366);
INSERT INTO card_set_white_card VALUES (100219, 4365);
INSERT INTO card_set_white_card VALUES (100219, 4364);
INSERT INTO card_set_white_card VALUES (100219, 4453);
INSERT INTO card_set_white_card VALUES (100219, 4452);
INSERT INTO card_set_white_card VALUES (100219, 4455);
INSERT INTO card_set_white_card VALUES (100219, 4454);
INSERT INTO card_set_white_card VALUES (100219, 4449);
INSERT INTO card_set_white_card VALUES (100219, 4448);
INSERT INTO card_set_white_card VALUES (100219, 4451);
INSERT INTO card_set_white_card VALUES (100219, 4450);
INSERT INTO card_set_white_card VALUES (100219, 4457);
INSERT INTO card_set_white_card VALUES (100219, 4456);
INSERT INTO card_set_white_card VALUES (100219, 4458);
INSERT INTO card_set_white_card VALUES (100219, 4438);
INSERT INTO card_set_white_card VALUES (100219, 4439);
INSERT INTO card_set_white_card VALUES (100219, 4436);
INSERT INTO card_set_white_card VALUES (100219, 4437);
INSERT INTO card_set_white_card VALUES (100219, 4434);
INSERT INTO card_set_white_card VALUES (100219, 4435);
INSERT INTO card_set_white_card VALUES (100219, 4432);
INSERT INTO card_set_white_card VALUES (100219, 4433);
INSERT INTO card_set_white_card VALUES (100219, 4446);
INSERT INTO card_set_white_card VALUES (100219, 4447);
INSERT INTO card_set_white_card VALUES (100219, 4444);
INSERT INTO card_set_white_card VALUES (100219, 4445);
INSERT INTO card_set_white_card VALUES (100219, 4442);
INSERT INTO card_set_white_card VALUES (100219, 4443);
INSERT INTO card_set_white_card VALUES (100219, 4440);
INSERT INTO card_set_white_card VALUES (100219, 4441);
INSERT INTO card_set_white_card VALUES (100219, 4423);
INSERT INTO card_set_white_card VALUES (100219, 4422);
INSERT INTO card_set_white_card VALUES (100219, 4421);
INSERT INTO card_set_white_card VALUES (100219, 4420);
INSERT INTO card_set_white_card VALUES (100219, 4419);
INSERT INTO card_set_white_card VALUES (100219, 4418);
INSERT INTO card_set_white_card VALUES (100219, 4417);
INSERT INTO card_set_white_card VALUES (100219, 4416);
INSERT INTO card_set_white_card VALUES (100219, 4431);
INSERT INTO card_set_white_card VALUES (100219, 4430);
INSERT INTO card_set_white_card VALUES (100219, 4429);
INSERT INTO card_set_white_card VALUES (100219, 4428);
INSERT INTO card_set_white_card VALUES (100219, 4427);
INSERT INTO card_set_white_card VALUES (100219, 4426);
INSERT INTO card_set_white_card VALUES (100219, 4425);
INSERT INTO card_set_white_card VALUES (100219, 4424);
INSERT INTO card_set_white_card VALUES (100003, 4400);
INSERT INTO card_set_white_card VALUES (100003, 4401);
INSERT INTO card_set_white_card VALUES (100003, 4404);
INSERT INTO card_set_white_card VALUES (100003, 4405);
INSERT INTO card_set_white_card VALUES (100003, 4407);
INSERT INTO card_set_white_card VALUES (100003, 4396);
INSERT INTO card_set_white_card VALUES (100003, 4364);
INSERT INTO card_set_white_card VALUES (100003, 4454);
INSERT INTO card_set_white_card VALUES (100003, 4458);
INSERT INTO card_set_white_card VALUES (100017, 100220);
INSERT INTO card_set_white_card VALUES (100017, 100221);
INSERT INTO card_set_white_card VALUES (100017, 100222);
INSERT INTO card_set_white_card VALUES (100224, 4468);
INSERT INTO card_set_white_card VALUES (100224, 4469);
INSERT INTO card_set_white_card VALUES (100224, 4470);
INSERT INTO card_set_white_card VALUES (100224, 4471);
INSERT INTO card_set_white_card VALUES (100224, 4464);
INSERT INTO card_set_white_card VALUES (100224, 4465);
INSERT INTO card_set_white_card VALUES (100224, 4466);
INSERT INTO card_set_white_card VALUES (100224, 4467);
INSERT INTO card_set_white_card VALUES (100224, 4476);
INSERT INTO card_set_white_card VALUES (100224, 4477);
INSERT INTO card_set_white_card VALUES (100224, 4478);
INSERT INTO card_set_white_card VALUES (100224, 4479);
INSERT INTO card_set_white_card VALUES (100224, 4472);
INSERT INTO card_set_white_card VALUES (100224, 4473);
INSERT INTO card_set_white_card VALUES (100224, 4474);
INSERT INTO card_set_white_card VALUES (100224, 4475);
INSERT INTO card_set_white_card VALUES (100224, 4461);
INSERT INTO card_set_white_card VALUES (100224, 4460);
INSERT INTO card_set_white_card VALUES (100224, 4463);
INSERT INTO card_set_white_card VALUES (100224, 4462);
INSERT INTO card_set_white_card VALUES (100224, 4459);
INSERT INTO card_set_white_card VALUES (100224, 4537);
INSERT INTO card_set_white_card VALUES (100224, 4536);
INSERT INTO card_set_white_card VALUES (100224, 4539);
INSERT INTO card_set_white_card VALUES (100224, 4538);
INSERT INTO card_set_white_card VALUES (100224, 4541);
INSERT INTO card_set_white_card VALUES (100224, 4540);
INSERT INTO card_set_white_card VALUES (100224, 4543);
INSERT INTO card_set_white_card VALUES (100224, 4542);
INSERT INTO card_set_white_card VALUES (100224, 4529);
INSERT INTO card_set_white_card VALUES (100224, 4528);
INSERT INTO card_set_white_card VALUES (100224, 4531);
INSERT INTO card_set_white_card VALUES (100224, 4530);
INSERT INTO card_set_white_card VALUES (100224, 4533);
INSERT INTO card_set_white_card VALUES (100224, 4532);
INSERT INTO card_set_white_card VALUES (100224, 4535);
INSERT INTO card_set_white_card VALUES (100224, 4534);
INSERT INTO card_set_white_card VALUES (100224, 4520);
INSERT INTO card_set_white_card VALUES (100224, 4521);
INSERT INTO card_set_white_card VALUES (100224, 4522);
INSERT INTO card_set_white_card VALUES (100224, 4523);
INSERT INTO card_set_white_card VALUES (100224, 4524);
INSERT INTO card_set_white_card VALUES (100224, 4525);
INSERT INTO card_set_white_card VALUES (100224, 4526);
INSERT INTO card_set_white_card VALUES (100224, 4527);
INSERT INTO card_set_white_card VALUES (100224, 4512);
INSERT INTO card_set_white_card VALUES (100224, 4513);
INSERT INTO card_set_white_card VALUES (100224, 4514);
INSERT INTO card_set_white_card VALUES (100224, 4515);
INSERT INTO card_set_white_card VALUES (100224, 4516);
INSERT INTO card_set_white_card VALUES (100224, 4517);
INSERT INTO card_set_white_card VALUES (100224, 4518);
INSERT INTO card_set_white_card VALUES (100224, 4519);
INSERT INTO card_set_white_card VALUES (100224, 4507);
INSERT INTO card_set_white_card VALUES (100224, 4506);
INSERT INTO card_set_white_card VALUES (100224, 4505);
INSERT INTO card_set_white_card VALUES (100224, 4504);
INSERT INTO card_set_white_card VALUES (100224, 4511);
INSERT INTO card_set_white_card VALUES (100224, 4510);
INSERT INTO card_set_white_card VALUES (100224, 4509);
INSERT INTO card_set_white_card VALUES (100224, 4508);
INSERT INTO card_set_white_card VALUES (100224, 4499);
INSERT INTO card_set_white_card VALUES (100224, 4498);
INSERT INTO card_set_white_card VALUES (100224, 4497);
INSERT INTO card_set_white_card VALUES (100224, 4496);
INSERT INTO card_set_white_card VALUES (100224, 4503);
INSERT INTO card_set_white_card VALUES (100224, 4502);
INSERT INTO card_set_white_card VALUES (100224, 4501);
INSERT INTO card_set_white_card VALUES (100224, 4500);
INSERT INTO card_set_white_card VALUES (100224, 4490);
INSERT INTO card_set_white_card VALUES (100224, 4491);
INSERT INTO card_set_white_card VALUES (100224, 4488);
INSERT INTO card_set_white_card VALUES (100224, 4489);
INSERT INTO card_set_white_card VALUES (100224, 4494);
INSERT INTO card_set_white_card VALUES (100224, 4495);
INSERT INTO card_set_white_card VALUES (100224, 4492);
INSERT INTO card_set_white_card VALUES (100224, 4493);
INSERT INTO card_set_white_card VALUES (100224, 4482);
INSERT INTO card_set_white_card VALUES (100224, 4483);
INSERT INTO card_set_white_card VALUES (100224, 4480);
INSERT INTO card_set_white_card VALUES (100224, 4481);
INSERT INTO card_set_white_card VALUES (100224, 4486);
INSERT INTO card_set_white_card VALUES (100224, 4487);
INSERT INTO card_set_white_card VALUES (100224, 4484);
INSERT INTO card_set_white_card VALUES (100224, 4485);
INSERT INTO card_set_white_card VALUES (100224, 4605);
INSERT INTO card_set_white_card VALUES (100224, 4604);
INSERT INTO card_set_white_card VALUES (100224, 4607);
INSERT INTO card_set_white_card VALUES (100224, 4606);
INSERT INTO card_set_white_card VALUES (100224, 4601);
INSERT INTO card_set_white_card VALUES (100224, 4600);
INSERT INTO card_set_white_card VALUES (100224, 4603);
INSERT INTO card_set_white_card VALUES (100224, 4602);
INSERT INTO card_set_white_card VALUES (100224, 4597);
INSERT INTO card_set_white_card VALUES (100224, 4596);
INSERT INTO card_set_white_card VALUES (100224, 4599);
INSERT INTO card_set_white_card VALUES (100224, 4598);
INSERT INTO card_set_white_card VALUES (100224, 4593);
INSERT INTO card_set_white_card VALUES (100224, 4592);
INSERT INTO card_set_white_card VALUES (100224, 4595);
INSERT INTO card_set_white_card VALUES (100224, 4594);
INSERT INTO card_set_white_card VALUES (100224, 4588);
INSERT INTO card_set_white_card VALUES (100224, 4589);
INSERT INTO card_set_white_card VALUES (100224, 4590);
INSERT INTO card_set_white_card VALUES (100224, 4591);
INSERT INTO card_set_white_card VALUES (100224, 4584);
INSERT INTO card_set_white_card VALUES (100224, 4585);
INSERT INTO card_set_white_card VALUES (100224, 4586);
INSERT INTO card_set_white_card VALUES (100224, 4587);
INSERT INTO card_set_white_card VALUES (100224, 4580);
INSERT INTO card_set_white_card VALUES (100224, 4581);
INSERT INTO card_set_white_card VALUES (100224, 4582);
INSERT INTO card_set_white_card VALUES (100224, 4583);
INSERT INTO card_set_white_card VALUES (100224, 4576);
INSERT INTO card_set_white_card VALUES (100224, 4577);
INSERT INTO card_set_white_card VALUES (100224, 4578);
INSERT INTO card_set_white_card VALUES (100224, 4579);
INSERT INTO card_set_white_card VALUES (100224, 4575);
INSERT INTO card_set_white_card VALUES (100224, 4574);
INSERT INTO card_set_white_card VALUES (100224, 4573);
INSERT INTO card_set_white_card VALUES (100224, 4572);
INSERT INTO card_set_white_card VALUES (100224, 4571);
INSERT INTO card_set_white_card VALUES (100224, 4570);
INSERT INTO card_set_white_card VALUES (100224, 4569);
INSERT INTO card_set_white_card VALUES (100224, 4568);
INSERT INTO card_set_white_card VALUES (100224, 4567);
INSERT INTO card_set_white_card VALUES (100224, 4566);
INSERT INTO card_set_white_card VALUES (100224, 4565);
INSERT INTO card_set_white_card VALUES (100224, 4564);
INSERT INTO card_set_white_card VALUES (100224, 4563);
INSERT INTO card_set_white_card VALUES (100224, 4562);
INSERT INTO card_set_white_card VALUES (100224, 4561);
INSERT INTO card_set_white_card VALUES (100224, 4560);
INSERT INTO card_set_white_card VALUES (100224, 4558);
INSERT INTO card_set_white_card VALUES (100224, 4559);
INSERT INTO card_set_white_card VALUES (100224, 4556);
INSERT INTO card_set_white_card VALUES (100224, 4557);
INSERT INTO card_set_white_card VALUES (100224, 4554);
INSERT INTO card_set_white_card VALUES (100224, 4555);
INSERT INTO card_set_white_card VALUES (100224, 4552);
INSERT INTO card_set_white_card VALUES (100224, 4553);
INSERT INTO card_set_white_card VALUES (100224, 4550);
INSERT INTO card_set_white_card VALUES (100224, 4551);
INSERT INTO card_set_white_card VALUES (100224, 4548);
INSERT INTO card_set_white_card VALUES (100224, 4549);
INSERT INTO card_set_white_card VALUES (100224, 4546);
INSERT INTO card_set_white_card VALUES (100224, 4547);
INSERT INTO card_set_white_card VALUES (100224, 4544);
INSERT INTO card_set_white_card VALUES (100224, 4545);
INSERT INTO card_set_white_card VALUES (100224, 4613);
INSERT INTO card_set_white_card VALUES (100224, 4612);
INSERT INTO card_set_white_card VALUES (100224, 4615);
INSERT INTO card_set_white_card VALUES (100224, 4614);
INSERT INTO card_set_white_card VALUES (100224, 4609);
INSERT INTO card_set_white_card VALUES (100224, 4608);
INSERT INTO card_set_white_card VALUES (100224, 4611);
INSERT INTO card_set_white_card VALUES (100224, 4610);
INSERT INTO card_set_white_card VALUES (100224, 4621);
INSERT INTO card_set_white_card VALUES (100224, 4620);
INSERT INTO card_set_white_card VALUES (100224, 4623);
INSERT INTO card_set_white_card VALUES (100224, 4622);
INSERT INTO card_set_white_card VALUES (100224, 4617);
INSERT INTO card_set_white_card VALUES (100224, 4616);
INSERT INTO card_set_white_card VALUES (100224, 4619);
INSERT INTO card_set_white_card VALUES (100224, 4618);
INSERT INTO card_set_white_card VALUES (100224, 4628);
INSERT INTO card_set_white_card VALUES (100224, 4629);
INSERT INTO card_set_white_card VALUES (100224, 4630);
INSERT INTO card_set_white_card VALUES (100224, 4631);
INSERT INTO card_set_white_card VALUES (100224, 4624);
INSERT INTO card_set_white_card VALUES (100224, 4625);
INSERT INTO card_set_white_card VALUES (100224, 4626);
INSERT INTO card_set_white_card VALUES (100224, 4627);
INSERT INTO card_set_white_card VALUES (100224, 4636);
INSERT INTO card_set_white_card VALUES (100224, 4637);
INSERT INTO card_set_white_card VALUES (100224, 4638);
INSERT INTO card_set_white_card VALUES (100224, 4639);
INSERT INTO card_set_white_card VALUES (100224, 4632);
INSERT INTO card_set_white_card VALUES (100224, 4633);
INSERT INTO card_set_white_card VALUES (100224, 4634);
INSERT INTO card_set_white_card VALUES (100224, 4635);
INSERT INTO card_set_white_card VALUES (100224, 4647);
INSERT INTO card_set_white_card VALUES (100224, 4646);
INSERT INTO card_set_white_card VALUES (100224, 4645);
INSERT INTO card_set_white_card VALUES (100224, 4644);
INSERT INTO card_set_white_card VALUES (100224, 4643);
INSERT INTO card_set_white_card VALUES (100224, 4642);
INSERT INTO card_set_white_card VALUES (100224, 4641);
INSERT INTO card_set_white_card VALUES (100224, 4640);
INSERT INTO card_set_white_card VALUES (100224, 4655);
INSERT INTO card_set_white_card VALUES (100224, 4654);
INSERT INTO card_set_white_card VALUES (100224, 4653);
INSERT INTO card_set_white_card VALUES (100224, 4652);
INSERT INTO card_set_white_card VALUES (100224, 4651);
INSERT INTO card_set_white_card VALUES (100224, 4650);
INSERT INTO card_set_white_card VALUES (100224, 4649);
INSERT INTO card_set_white_card VALUES (100224, 4648);
INSERT INTO card_set_white_card VALUES (100224, 4662);
INSERT INTO card_set_white_card VALUES (100224, 4663);
INSERT INTO card_set_white_card VALUES (100224, 4660);
INSERT INTO card_set_white_card VALUES (100224, 4661);
INSERT INTO card_set_white_card VALUES (100224, 4658);
INSERT INTO card_set_white_card VALUES (100224, 4659);
INSERT INTO card_set_white_card VALUES (100224, 4656);
INSERT INTO card_set_white_card VALUES (100224, 4657);
INSERT INTO card_set_white_card VALUES (100224, 4670);
INSERT INTO card_set_white_card VALUES (100224, 4671);
INSERT INTO card_set_white_card VALUES (100224, 4668);
INSERT INTO card_set_white_card VALUES (100224, 4669);
INSERT INTO card_set_white_card VALUES (100224, 4666);
INSERT INTO card_set_white_card VALUES (100224, 4667);
INSERT INTO card_set_white_card VALUES (100224, 4664);
INSERT INTO card_set_white_card VALUES (100224, 4665);
INSERT INTO card_set_white_card VALUES (100224, 4673);
INSERT INTO card_set_white_card VALUES (100224, 4672);
INSERT INTO card_set_white_card VALUES (100224, 4675);
INSERT INTO card_set_white_card VALUES (100224, 4674);
INSERT INTO card_set_white_card VALUES (100224, 4677);
INSERT INTO card_set_white_card VALUES (100224, 4676);
INSERT INTO card_set_white_card VALUES (100224, 4679);
INSERT INTO card_set_white_card VALUES (100224, 4678);
INSERT INTO card_set_white_card VALUES (100224, 4681);
INSERT INTO card_set_white_card VALUES (100224, 4680);
INSERT INTO card_set_white_card VALUES (100224, 4683);
INSERT INTO card_set_white_card VALUES (100224, 4682);
INSERT INTO card_set_white_card VALUES (100224, 4685);
INSERT INTO card_set_white_card VALUES (100224, 4684);
INSERT INTO card_set_white_card VALUES (100224, 4687);
INSERT INTO card_set_white_card VALUES (100224, 4686);
INSERT INTO card_set_white_card VALUES (100224, 4688);
INSERT INTO card_set_white_card VALUES (100224, 4689);
INSERT INTO card_set_white_card VALUES (100224, 4690);
INSERT INTO card_set_white_card VALUES (100224, 4691);
INSERT INTO card_set_white_card VALUES (100224, 4692);
INSERT INTO card_set_white_card VALUES (100224, 4693);
INSERT INTO card_set_white_card VALUES (100224, 4694);
INSERT INTO card_set_white_card VALUES (100224, 4695);
INSERT INTO card_set_white_card VALUES (100224, 4696);
INSERT INTO card_set_white_card VALUES (100224, 4697);
INSERT INTO card_set_white_card VALUES (100224, 4698);
INSERT INTO card_set_white_card VALUES (100224, 4699);
INSERT INTO card_set_white_card VALUES (100224, 4700);
INSERT INTO card_set_white_card VALUES (100224, 4701);
INSERT INTO card_set_white_card VALUES (100224, 4702);
INSERT INTO card_set_white_card VALUES (100224, 4703);
INSERT INTO card_set_white_card VALUES (100224, 4707);
INSERT INTO card_set_white_card VALUES (100224, 4706);
INSERT INTO card_set_white_card VALUES (100224, 4705);
INSERT INTO card_set_white_card VALUES (100224, 4704);
INSERT INTO card_set_white_card VALUES (100224, 4711);
INSERT INTO card_set_white_card VALUES (100224, 4710);
INSERT INTO card_set_white_card VALUES (100224, 4709);
INSERT INTO card_set_white_card VALUES (100224, 4708);
INSERT INTO card_set_white_card VALUES (100224, 4715);
INSERT INTO card_set_white_card VALUES (100224, 4714);
INSERT INTO card_set_white_card VALUES (100224, 4713);
INSERT INTO card_set_white_card VALUES (100224, 4712);
INSERT INTO card_set_white_card VALUES (100224, 4719);
INSERT INTO card_set_white_card VALUES (100224, 4718);
INSERT INTO card_set_white_card VALUES (100224, 4717);
INSERT INTO card_set_white_card VALUES (100224, 4716);
INSERT INTO card_set_white_card VALUES (100224, 4722);
INSERT INTO card_set_white_card VALUES (100224, 4723);
INSERT INTO card_set_white_card VALUES (100224, 4720);
INSERT INTO card_set_white_card VALUES (100224, 4721);
INSERT INTO card_set_white_card VALUES (100224, 4726);
INSERT INTO card_set_white_card VALUES (100224, 4727);
INSERT INTO card_set_white_card VALUES (100224, 4724);
INSERT INTO card_set_white_card VALUES (100224, 4725);
INSERT INTO card_set_white_card VALUES (100224, 4730);
INSERT INTO card_set_white_card VALUES (100224, 4731);
INSERT INTO card_set_white_card VALUES (100224, 4728);
INSERT INTO card_set_white_card VALUES (100224, 4729);
INSERT INTO card_set_white_card VALUES (100224, 4734);
INSERT INTO card_set_white_card VALUES (100224, 4735);
INSERT INTO card_set_white_card VALUES (100224, 4732);
INSERT INTO card_set_white_card VALUES (100224, 4733);
INSERT INTO card_set_white_card VALUES (100224, 4748);
INSERT INTO card_set_white_card VALUES (100224, 4749);
INSERT INTO card_set_white_card VALUES (100224, 4750);
INSERT INTO card_set_white_card VALUES (100224, 4751);
INSERT INTO card_set_white_card VALUES (100224, 4744);
INSERT INTO card_set_white_card VALUES (100224, 4745);
INSERT INTO card_set_white_card VALUES (100224, 4746);
INSERT INTO card_set_white_card VALUES (100224, 4747);
INSERT INTO card_set_white_card VALUES (100224, 4740);
INSERT INTO card_set_white_card VALUES (100224, 4741);
INSERT INTO card_set_white_card VALUES (100224, 4742);
INSERT INTO card_set_white_card VALUES (100224, 4743);
INSERT INTO card_set_white_card VALUES (100224, 4736);
INSERT INTO card_set_white_card VALUES (100224, 4737);
INSERT INTO card_set_white_card VALUES (100224, 4738);
INSERT INTO card_set_white_card VALUES (100224, 4739);
INSERT INTO card_set_white_card VALUES (100224, 4765);
INSERT INTO card_set_white_card VALUES (100224, 4764);
INSERT INTO card_set_white_card VALUES (100224, 4767);
INSERT INTO card_set_white_card VALUES (100224, 4766);
INSERT INTO card_set_white_card VALUES (100224, 4761);
INSERT INTO card_set_white_card VALUES (100224, 4760);
INSERT INTO card_set_white_card VALUES (100224, 4763);
INSERT INTO card_set_white_card VALUES (100224, 4762);
INSERT INTO card_set_white_card VALUES (100224, 4757);
INSERT INTO card_set_white_card VALUES (100224, 4756);
INSERT INTO card_set_white_card VALUES (100224, 4759);
INSERT INTO card_set_white_card VALUES (100224, 4758);
INSERT INTO card_set_white_card VALUES (100224, 4753);
INSERT INTO card_set_white_card VALUES (100224, 4752);
INSERT INTO card_set_white_card VALUES (100224, 4755);
INSERT INTO card_set_white_card VALUES (100224, 4754);
INSERT INTO card_set_white_card VALUES (100224, 4782);
INSERT INTO card_set_white_card VALUES (100224, 4783);
INSERT INTO card_set_white_card VALUES (100224, 4780);
INSERT INTO card_set_white_card VALUES (100224, 4781);
INSERT INTO card_set_white_card VALUES (100224, 4778);
INSERT INTO card_set_white_card VALUES (100224, 4779);
INSERT INTO card_set_white_card VALUES (100224, 4776);
INSERT INTO card_set_white_card VALUES (100224, 4777);
INSERT INTO card_set_white_card VALUES (100224, 4774);
INSERT INTO card_set_white_card VALUES (100224, 4775);
INSERT INTO card_set_white_card VALUES (100224, 4772);
INSERT INTO card_set_white_card VALUES (100224, 4773);
INSERT INTO card_set_white_card VALUES (100224, 4770);
INSERT INTO card_set_white_card VALUES (100224, 4771);
INSERT INTO card_set_white_card VALUES (100224, 4768);
INSERT INTO card_set_white_card VALUES (100224, 4769);
INSERT INTO card_set_white_card VALUES (100224, 4799);
INSERT INTO card_set_white_card VALUES (100224, 4798);
INSERT INTO card_set_white_card VALUES (100224, 4797);
INSERT INTO card_set_white_card VALUES (100224, 4796);
INSERT INTO card_set_white_card VALUES (100224, 4795);
INSERT INTO card_set_white_card VALUES (100224, 4794);
INSERT INTO card_set_white_card VALUES (100224, 4793);
INSERT INTO card_set_white_card VALUES (100224, 4792);
INSERT INTO card_set_white_card VALUES (100224, 4791);
INSERT INTO card_set_white_card VALUES (100224, 4790);
INSERT INTO card_set_white_card VALUES (100224, 4789);
INSERT INTO card_set_white_card VALUES (100224, 4788);
INSERT INTO card_set_white_card VALUES (100224, 4787);
INSERT INTO card_set_white_card VALUES (100224, 4786);
INSERT INTO card_set_white_card VALUES (100224, 4785);
INSERT INTO card_set_white_card VALUES (100224, 4784);
INSERT INTO card_set_white_card VALUES (100224, 4808);
INSERT INTO card_set_white_card VALUES (100224, 4809);
INSERT INTO card_set_white_card VALUES (100224, 4810);
INSERT INTO card_set_white_card VALUES (100224, 4811);
INSERT INTO card_set_white_card VALUES (100224, 4812);
INSERT INTO card_set_white_card VALUES (100224, 4813);
INSERT INTO card_set_white_card VALUES (100224, 4814);
INSERT INTO card_set_white_card VALUES (100224, 4815);
INSERT INTO card_set_white_card VALUES (100224, 4800);
INSERT INTO card_set_white_card VALUES (100224, 4801);
INSERT INTO card_set_white_card VALUES (100224, 4802);
INSERT INTO card_set_white_card VALUES (100224, 4803);
INSERT INTO card_set_white_card VALUES (100224, 4804);
INSERT INTO card_set_white_card VALUES (100224, 4805);
INSERT INTO card_set_white_card VALUES (100224, 4806);
INSERT INTO card_set_white_card VALUES (100224, 4807);
INSERT INTO card_set_white_card VALUES (100224, 4825);
INSERT INTO card_set_white_card VALUES (100224, 4824);
INSERT INTO card_set_white_card VALUES (100224, 4827);
INSERT INTO card_set_white_card VALUES (100224, 4826);
INSERT INTO card_set_white_card VALUES (100224, 4829);
INSERT INTO card_set_white_card VALUES (100224, 4828);
INSERT INTO card_set_white_card VALUES (100224, 4831);
INSERT INTO card_set_white_card VALUES (100224, 4830);
INSERT INTO card_set_white_card VALUES (100224, 4817);
INSERT INTO card_set_white_card VALUES (100224, 4816);
INSERT INTO card_set_white_card VALUES (100224, 4819);
INSERT INTO card_set_white_card VALUES (100224, 4818);
INSERT INTO card_set_white_card VALUES (100224, 4821);
INSERT INTO card_set_white_card VALUES (100224, 4820);
INSERT INTO card_set_white_card VALUES (100224, 4823);
INSERT INTO card_set_white_card VALUES (100224, 4822);
INSERT INTO card_set_white_card VALUES (100224, 4842);
INSERT INTO card_set_white_card VALUES (100224, 4843);
INSERT INTO card_set_white_card VALUES (100224, 4840);
INSERT INTO card_set_white_card VALUES (100224, 4841);
INSERT INTO card_set_white_card VALUES (100224, 4846);
INSERT INTO card_set_white_card VALUES (100224, 4847);
INSERT INTO card_set_white_card VALUES (100224, 4844);
INSERT INTO card_set_white_card VALUES (100224, 4845);
INSERT INTO card_set_white_card VALUES (100224, 4834);
INSERT INTO card_set_white_card VALUES (100224, 4835);
INSERT INTO card_set_white_card VALUES (100224, 4832);
INSERT INTO card_set_white_card VALUES (100224, 4833);
INSERT INTO card_set_white_card VALUES (100224, 4838);
INSERT INTO card_set_white_card VALUES (100224, 4839);
INSERT INTO card_set_white_card VALUES (100224, 4836);
INSERT INTO card_set_white_card VALUES (100224, 4837);
INSERT INTO card_set_white_card VALUES (100224, 4850);
INSERT INTO card_set_white_card VALUES (100224, 4849);
INSERT INTO card_set_white_card VALUES (100224, 4848);
INSERT INTO card_set_white_card VALUES (100225, 4886);
INSERT INTO card_set_white_card VALUES (100225, 4887);
INSERT INTO card_set_white_card VALUES (100225, 4884);
INSERT INTO card_set_white_card VALUES (100225, 4885);
INSERT INTO card_set_white_card VALUES (100225, 4882);
INSERT INTO card_set_white_card VALUES (100225, 4883);
INSERT INTO card_set_white_card VALUES (100225, 4880);
INSERT INTO card_set_white_card VALUES (100225, 4881);
INSERT INTO card_set_white_card VALUES (100225, 4894);
INSERT INTO card_set_white_card VALUES (100225, 4895);
INSERT INTO card_set_white_card VALUES (100225, 4892);
INSERT INTO card_set_white_card VALUES (100225, 4893);
INSERT INTO card_set_white_card VALUES (100225, 4890);
INSERT INTO card_set_white_card VALUES (100225, 4891);
INSERT INTO card_set_white_card VALUES (100225, 4888);
INSERT INTO card_set_white_card VALUES (100225, 4889);
INSERT INTO card_set_white_card VALUES (100225, 4871);
INSERT INTO card_set_white_card VALUES (100225, 4870);
INSERT INTO card_set_white_card VALUES (100225, 4869);
INSERT INTO card_set_white_card VALUES (100225, 4868);
INSERT INTO card_set_white_card VALUES (100225, 4867);
INSERT INTO card_set_white_card VALUES (100225, 4866);
INSERT INTO card_set_white_card VALUES (100225, 4865);
INSERT INTO card_set_white_card VALUES (100225, 4864);
INSERT INTO card_set_white_card VALUES (100225, 4879);
INSERT INTO card_set_white_card VALUES (100225, 4878);
INSERT INTO card_set_white_card VALUES (100225, 4877);
INSERT INTO card_set_white_card VALUES (100225, 4876);
INSERT INTO card_set_white_card VALUES (100225, 4875);
INSERT INTO card_set_white_card VALUES (100225, 4874);
INSERT INTO card_set_white_card VALUES (100225, 4873);
INSERT INTO card_set_white_card VALUES (100225, 4872);
INSERT INTO card_set_white_card VALUES (100225, 4916);
INSERT INTO card_set_white_card VALUES (100225, 4917);
INSERT INTO card_set_white_card VALUES (100225, 4918);
INSERT INTO card_set_white_card VALUES (100225, 4919);
INSERT INTO card_set_white_card VALUES (100225, 4912);
INSERT INTO card_set_white_card VALUES (100225, 4913);
INSERT INTO card_set_white_card VALUES (100225, 4914);
INSERT INTO card_set_white_card VALUES (100225, 4915);
INSERT INTO card_set_white_card VALUES (100225, 4924);
INSERT INTO card_set_white_card VALUES (100225, 4925);
INSERT INTO card_set_white_card VALUES (100225, 4926);
INSERT INTO card_set_white_card VALUES (100225, 4927);
INSERT INTO card_set_white_card VALUES (100225, 4920);
INSERT INTO card_set_white_card VALUES (100225, 4921);
INSERT INTO card_set_white_card VALUES (100225, 4922);
INSERT INTO card_set_white_card VALUES (100225, 4923);
INSERT INTO card_set_white_card VALUES (100225, 4901);
INSERT INTO card_set_white_card VALUES (100225, 4900);
INSERT INTO card_set_white_card VALUES (100225, 4903);
INSERT INTO card_set_white_card VALUES (100225, 4902);
INSERT INTO card_set_white_card VALUES (100225, 4897);
INSERT INTO card_set_white_card VALUES (100225, 4896);
INSERT INTO card_set_white_card VALUES (100225, 4899);
INSERT INTO card_set_white_card VALUES (100225, 4898);
INSERT INTO card_set_white_card VALUES (100225, 4909);
INSERT INTO card_set_white_card VALUES (100225, 4908);
INSERT INTO card_set_white_card VALUES (100225, 4911);
INSERT INTO card_set_white_card VALUES (100225, 4910);
INSERT INTO card_set_white_card VALUES (100225, 4905);
INSERT INTO card_set_white_card VALUES (100225, 4904);
INSERT INTO card_set_white_card VALUES (100225, 4907);
INSERT INTO card_set_white_card VALUES (100225, 4906);
INSERT INTO card_set_white_card VALUES (100225, 4946);
INSERT INTO card_set_white_card VALUES (100225, 4947);
INSERT INTO card_set_white_card VALUES (100225, 4944);
INSERT INTO card_set_white_card VALUES (100225, 4945);
INSERT INTO card_set_white_card VALUES (100225, 4948);
INSERT INTO card_set_white_card VALUES (100225, 4949);
INSERT INTO card_set_white_card VALUES (100225, 4931);
INSERT INTO card_set_white_card VALUES (100225, 4930);
INSERT INTO card_set_white_card VALUES (100225, 4929);
INSERT INTO card_set_white_card VALUES (100225, 4928);
INSERT INTO card_set_white_card VALUES (100225, 4935);
INSERT INTO card_set_white_card VALUES (100225, 4934);
INSERT INTO card_set_white_card VALUES (100225, 4933);
INSERT INTO card_set_white_card VALUES (100225, 4932);
INSERT INTO card_set_white_card VALUES (100225, 4939);
INSERT INTO card_set_white_card VALUES (100225, 4938);
INSERT INTO card_set_white_card VALUES (100225, 4937);
INSERT INTO card_set_white_card VALUES (100225, 4936);
INSERT INTO card_set_white_card VALUES (100225, 4943);
INSERT INTO card_set_white_card VALUES (100225, 4942);
INSERT INTO card_set_white_card VALUES (100225, 4941);
INSERT INTO card_set_white_card VALUES (100225, 4940);
INSERT INTO card_set_white_card VALUES (100225, 4859);
INSERT INTO card_set_white_card VALUES (100225, 4858);
INSERT INTO card_set_white_card VALUES (100225, 4857);
INSERT INTO card_set_white_card VALUES (100225, 4856);
INSERT INTO card_set_white_card VALUES (100225, 4863);
INSERT INTO card_set_white_card VALUES (100225, 4862);
INSERT INTO card_set_white_card VALUES (100225, 4861);
INSERT INTO card_set_white_card VALUES (100225, 4860);
INSERT INTO card_set_white_card VALUES (100225, 4851);
INSERT INTO card_set_white_card VALUES (100225, 4855);
INSERT INTO card_set_white_card VALUES (100225, 4854);
INSERT INTO card_set_white_card VALUES (100225, 4853);
INSERT INTO card_set_white_card VALUES (100225, 4852);
INSERT INTO card_set_white_card VALUES (100003, 4886);
INSERT INTO card_set_white_card VALUES (100003, 4880);
INSERT INTO card_set_white_card VALUES (100003, 4894);
INSERT INTO card_set_white_card VALUES (100003, 4893);
INSERT INTO card_set_white_card VALUES (100003, 4888);
INSERT INTO card_set_white_card VALUES (100003, 4618);
INSERT INTO card_set_white_card VALUES (100003, 4869);
INSERT INTO card_set_white_card VALUES (100003, 4877);
INSERT INTO card_set_white_card VALUES (100003, 4876);
INSERT INTO card_set_white_card VALUES (100003, 4644);
INSERT INTO card_set_white_card VALUES (100003, 4914);
INSERT INTO card_set_white_card VALUES (100003, 4926);
INSERT INTO card_set_white_card VALUES (100003, 4923);
INSERT INTO card_set_white_card VALUES (100003, 4901);
INSERT INTO card_set_white_card VALUES (100003, 4900);
INSERT INTO card_set_white_card VALUES (100003, 4903);
INSERT INTO card_set_white_card VALUES (100003, 4897);
INSERT INTO card_set_white_card VALUES (100003, 4658);
INSERT INTO card_set_white_card VALUES (100003, 4659);
INSERT INTO card_set_white_card VALUES (100003, 4905);
INSERT INTO card_set_white_card VALUES (100003, 4947);
INSERT INTO card_set_white_card VALUES (100003, 4944);
INSERT INTO card_set_white_card VALUES (100003, 4471);
INSERT INTO card_set_white_card VALUES (100003, 4948);
INSERT INTO card_set_white_card VALUES (100003, 4466);
INSERT INTO card_set_white_card VALUES (100003, 4477);
INSERT INTO card_set_white_card VALUES (100003, 4682);
INSERT INTO card_set_white_card VALUES (100003, 4687);
INSERT INTO card_set_white_card VALUES (100003, 4930);
INSERT INTO card_set_white_card VALUES (100003, 4929);
INSERT INTO card_set_white_card VALUES (100003, 4690);
INSERT INTO card_set_white_card VALUES (100003, 4461);
INSERT INTO card_set_white_card VALUES (100003, 4462);
INSERT INTO card_set_white_card VALUES (100003, 4942);
INSERT INTO card_set_white_card VALUES (100003, 4941);
INSERT INTO card_set_white_card VALUES (100003, 4707);
INSERT INTO card_set_white_card VALUES (100003, 4727);
INSERT INTO card_set_white_card VALUES (100003, 4738);
INSERT INTO card_set_white_card VALUES (100003, 4535);
INSERT INTO card_set_white_card VALUES (100003, 4739);
INSERT INTO card_set_white_card VALUES (100003, 4534);
INSERT INTO card_set_white_card VALUES (100003, 4764);
INSERT INTO card_set_white_card VALUES (100003, 4522);
INSERT INTO card_set_white_card VALUES (100003, 4523);
INSERT INTO card_set_white_card VALUES (100003, 4524);
INSERT INTO card_set_white_card VALUES (100003, 4517);
INSERT INTO card_set_white_card VALUES (100003, 4506);
INSERT INTO card_set_white_card VALUES (100003, 4510);
INSERT INTO card_set_white_card VALUES (100003, 4489);
INSERT INTO card_set_white_card VALUES (100003, 4494);
INSERT INTO card_set_white_card VALUES (100003, 4493);
INSERT INTO card_set_white_card VALUES (100003, 4482);
INSERT INTO card_set_white_card VALUES (100003, 4480);
INSERT INTO card_set_white_card VALUES (100003, 4808);
INSERT INTO card_set_white_card VALUES (100003, 4602);
INSERT INTO card_set_white_card VALUES (100003, 4803);
INSERT INTO card_set_white_card VALUES (100003, 4805);
INSERT INTO card_set_white_card VALUES (100003, 4584);
INSERT INTO card_set_white_card VALUES (100003, 4577);
INSERT INTO card_set_white_card VALUES (100003, 4859);
INSERT INTO card_set_white_card VALUES (100003, 4858);
INSERT INTO card_set_white_card VALUES (100003, 4863);
INSERT INTO card_set_white_card VALUES (100003, 4862);
INSERT INTO card_set_white_card VALUES (100003, 4861);
INSERT INTO card_set_white_card VALUES (100003, 4552);
INSERT INTO card_set_white_card VALUES (100003, 4851);
INSERT INTO card_set_white_card VALUES (100003, 4548);
INSERT INTO card_set_white_card VALUES (100003, 4854);
INSERT INTO card_set_white_card VALUES (100003, 4853);
INSERT INTO card_set_white_card VALUES (100003, 4852);
INSERT INTO card_set_white_card VALUES (100228, 10047);
INSERT INTO card_set_white_card VALUES (100228, 10046);
INSERT INTO card_set_white_card VALUES (100228, 10045);
INSERT INTO card_set_white_card VALUES (100228, 10044);
INSERT INTO card_set_white_card VALUES (100228, 10043);
INSERT INTO card_set_white_card VALUES (100228, 10042);
INSERT INTO card_set_white_card VALUES (100228, 10041);
INSERT INTO card_set_white_card VALUES (100228, 10040);
INSERT INTO card_set_white_card VALUES (100228, 10039);
INSERT INTO card_set_white_card VALUES (100228, 10038);
INSERT INTO card_set_white_card VALUES (100228, 10037);
INSERT INTO card_set_white_card VALUES (100228, 10036);
INSERT INTO card_set_white_card VALUES (100228, 10035);
INSERT INTO card_set_white_card VALUES (100228, 10034);
INSERT INTO card_set_white_card VALUES (100228, 10033);
INSERT INTO card_set_white_card VALUES (100228, 10032);
INSERT INTO card_set_white_card VALUES (100228, 10030);
INSERT INTO card_set_white_card VALUES (100228, 10031);
INSERT INTO card_set_white_card VALUES (100228, 10028);
INSERT INTO card_set_white_card VALUES (100228, 10029);
INSERT INTO card_set_white_card VALUES (100228, 10026);
INSERT INTO card_set_white_card VALUES (100228, 10027);
INSERT INTO card_set_white_card VALUES (100228, 10024);
INSERT INTO card_set_white_card VALUES (100228, 10025);
INSERT INTO card_set_white_card VALUES (100228, 10022);
INSERT INTO card_set_white_card VALUES (100228, 10023);
INSERT INTO card_set_white_card VALUES (100228, 10020);
INSERT INTO card_set_white_card VALUES (100228, 10021);
INSERT INTO card_set_white_card VALUES (100228, 10018);
INSERT INTO card_set_white_card VALUES (100228, 10019);
INSERT INTO card_set_white_card VALUES (100228, 10016);
INSERT INTO card_set_white_card VALUES (100228, 10017);
INSERT INTO card_set_white_card VALUES (100228, 10013);
INSERT INTO card_set_white_card VALUES (100228, 10012);
INSERT INTO card_set_white_card VALUES (100228, 10015);
INSERT INTO card_set_white_card VALUES (100228, 10014);
INSERT INTO card_set_white_card VALUES (100228, 10009);
INSERT INTO card_set_white_card VALUES (100228, 10008);
INSERT INTO card_set_white_card VALUES (100228, 10011);
INSERT INTO card_set_white_card VALUES (100228, 10010);
INSERT INTO card_set_white_card VALUES (100228, 10005);
INSERT INTO card_set_white_card VALUES (100228, 10004);
INSERT INTO card_set_white_card VALUES (100228, 10007);
INSERT INTO card_set_white_card VALUES (100228, 10006);
INSERT INTO card_set_white_card VALUES (100228, 10001);
INSERT INTO card_set_white_card VALUES (100228, 10003);
INSERT INTO card_set_white_card VALUES (100228, 10002);
INSERT INTO card_set_white_card VALUES (100228, 10107);
INSERT INTO card_set_white_card VALUES (100228, 10106);
INSERT INTO card_set_white_card VALUES (100228, 10105);
INSERT INTO card_set_white_card VALUES (100228, 10104);
INSERT INTO card_set_white_card VALUES (100228, 10111);
INSERT INTO card_set_white_card VALUES (100228, 10110);
INSERT INTO card_set_white_card VALUES (100228, 10109);
INSERT INTO card_set_white_card VALUES (100228, 10108);
INSERT INTO card_set_white_card VALUES (100228, 10099);
INSERT INTO card_set_white_card VALUES (100228, 10098);
INSERT INTO card_set_white_card VALUES (100228, 10097);
INSERT INTO card_set_white_card VALUES (100228, 10096);
INSERT INTO card_set_white_card VALUES (100228, 10103);
INSERT INTO card_set_white_card VALUES (100228, 10102);
INSERT INTO card_set_white_card VALUES (100228, 10101);
INSERT INTO card_set_white_card VALUES (100228, 10100);
INSERT INTO card_set_white_card VALUES (100228, 10090);
INSERT INTO card_set_white_card VALUES (100228, 10091);
INSERT INTO card_set_white_card VALUES (100228, 10088);
INSERT INTO card_set_white_card VALUES (100228, 10089);
INSERT INTO card_set_white_card VALUES (100228, 10094);
INSERT INTO card_set_white_card VALUES (100228, 10095);
INSERT INTO card_set_white_card VALUES (100228, 10092);
INSERT INTO card_set_white_card VALUES (100228, 10093);
INSERT INTO card_set_white_card VALUES (100228, 10082);
INSERT INTO card_set_white_card VALUES (100228, 10083);
INSERT INTO card_set_white_card VALUES (100228, 10080);
INSERT INTO card_set_white_card VALUES (100228, 10081);
INSERT INTO card_set_white_card VALUES (100228, 10086);
INSERT INTO card_set_white_card VALUES (100228, 10087);
INSERT INTO card_set_white_card VALUES (100228, 10084);
INSERT INTO card_set_white_card VALUES (100228, 10085);
INSERT INTO card_set_white_card VALUES (100228, 10073);
INSERT INTO card_set_white_card VALUES (100228, 10072);
INSERT INTO card_set_white_card VALUES (100228, 10075);
INSERT INTO card_set_white_card VALUES (100228, 10074);
INSERT INTO card_set_white_card VALUES (100228, 10077);
INSERT INTO card_set_white_card VALUES (100228, 10076);
INSERT INTO card_set_white_card VALUES (100228, 10079);
INSERT INTO card_set_white_card VALUES (100228, 10078);
INSERT INTO card_set_white_card VALUES (100228, 10065);
INSERT INTO card_set_white_card VALUES (100228, 10064);
INSERT INTO card_set_white_card VALUES (100228, 10067);
INSERT INTO card_set_white_card VALUES (100228, 10066);
INSERT INTO card_set_white_card VALUES (100228, 10069);
INSERT INTO card_set_white_card VALUES (100228, 10068);
INSERT INTO card_set_white_card VALUES (100228, 10071);
INSERT INTO card_set_white_card VALUES (100228, 10070);
INSERT INTO card_set_white_card VALUES (100228, 10056);
INSERT INTO card_set_white_card VALUES (100228, 10057);
INSERT INTO card_set_white_card VALUES (100228, 10058);
INSERT INTO card_set_white_card VALUES (100228, 10059);
INSERT INTO card_set_white_card VALUES (100228, 10060);
INSERT INTO card_set_white_card VALUES (100228, 10061);
INSERT INTO card_set_white_card VALUES (100228, 10062);
INSERT INTO card_set_white_card VALUES (100228, 10063);
INSERT INTO card_set_white_card VALUES (100228, 10048);
INSERT INTO card_set_white_card VALUES (100228, 10049);
INSERT INTO card_set_white_card VALUES (100228, 10050);
INSERT INTO card_set_white_card VALUES (100228, 10051);
INSERT INTO card_set_white_card VALUES (100228, 10052);
INSERT INTO card_set_white_card VALUES (100228, 10053);
INSERT INTO card_set_white_card VALUES (100228, 10054);
INSERT INTO card_set_white_card VALUES (100228, 10055);
INSERT INTO card_set_white_card VALUES (100228, 10166);
INSERT INTO card_set_white_card VALUES (100228, 10167);
INSERT INTO card_set_white_card VALUES (100228, 10164);
INSERT INTO card_set_white_card VALUES (100228, 10165);
INSERT INTO card_set_white_card VALUES (100228, 10162);
INSERT INTO card_set_white_card VALUES (100228, 10163);
INSERT INTO card_set_white_card VALUES (100228, 10160);
INSERT INTO card_set_white_card VALUES (100228, 10161);
INSERT INTO card_set_white_card VALUES (100228, 10174);
INSERT INTO card_set_white_card VALUES (100228, 10175);
INSERT INTO card_set_white_card VALUES (100228, 10172);
INSERT INTO card_set_white_card VALUES (100228, 10173);
INSERT INTO card_set_white_card VALUES (100228, 10170);
INSERT INTO card_set_white_card VALUES (100228, 10171);
INSERT INTO card_set_white_card VALUES (100228, 10168);
INSERT INTO card_set_white_card VALUES (100228, 10169);
INSERT INTO card_set_white_card VALUES (100228, 10151);
INSERT INTO card_set_white_card VALUES (100228, 10150);
INSERT INTO card_set_white_card VALUES (100228, 10149);
INSERT INTO card_set_white_card VALUES (100228, 10148);
INSERT INTO card_set_white_card VALUES (100228, 10147);
INSERT INTO card_set_white_card VALUES (100228, 10146);
INSERT INTO card_set_white_card VALUES (100228, 10145);
INSERT INTO card_set_white_card VALUES (100228, 10144);
INSERT INTO card_set_white_card VALUES (100228, 10159);
INSERT INTO card_set_white_card VALUES (100228, 10158);
INSERT INTO card_set_white_card VALUES (100228, 10157);
INSERT INTO card_set_white_card VALUES (100228, 10156);
INSERT INTO card_set_white_card VALUES (100228, 10155);
INSERT INTO card_set_white_card VALUES (100228, 10154);
INSERT INTO card_set_white_card VALUES (100228, 10153);
INSERT INTO card_set_white_card VALUES (100228, 10152);
INSERT INTO card_set_white_card VALUES (100228, 10132);
INSERT INTO card_set_white_card VALUES (100228, 10133);
INSERT INTO card_set_white_card VALUES (100228, 10134);
INSERT INTO card_set_white_card VALUES (100228, 10135);
INSERT INTO card_set_white_card VALUES (100228, 10128);
INSERT INTO card_set_white_card VALUES (100228, 10129);
INSERT INTO card_set_white_card VALUES (100228, 10130);
INSERT INTO card_set_white_card VALUES (100228, 10131);
INSERT INTO card_set_white_card VALUES (100228, 10140);
INSERT INTO card_set_white_card VALUES (100228, 10141);
INSERT INTO card_set_white_card VALUES (100228, 10142);
INSERT INTO card_set_white_card VALUES (100228, 10143);
INSERT INTO card_set_white_card VALUES (100228, 10136);
INSERT INTO card_set_white_card VALUES (100228, 10137);
INSERT INTO card_set_white_card VALUES (100228, 10138);
INSERT INTO card_set_white_card VALUES (100228, 10139);
INSERT INTO card_set_white_card VALUES (100228, 10117);
INSERT INTO card_set_white_card VALUES (100228, 10116);
INSERT INTO card_set_white_card VALUES (100228, 10119);
INSERT INTO card_set_white_card VALUES (100228, 10118);
INSERT INTO card_set_white_card VALUES (100228, 10113);
INSERT INTO card_set_white_card VALUES (100228, 10112);
INSERT INTO card_set_white_card VALUES (100228, 10115);
INSERT INTO card_set_white_card VALUES (100228, 10114);
INSERT INTO card_set_white_card VALUES (100228, 10125);
INSERT INTO card_set_white_card VALUES (100228, 10124);
INSERT INTO card_set_white_card VALUES (100228, 10127);
INSERT INTO card_set_white_card VALUES (100228, 10126);
INSERT INTO card_set_white_card VALUES (100228, 10121);
INSERT INTO card_set_white_card VALUES (100228, 10120);
INSERT INTO card_set_white_card VALUES (100228, 10123);
INSERT INTO card_set_white_card VALUES (100228, 10122);
INSERT INTO card_set_white_card VALUES (100228, 10177);
INSERT INTO card_set_white_card VALUES (100228, 10176);
INSERT INTO card_set_white_card VALUES (100228, 10178);
INSERT INTO card_set_white_card VALUES (100229, 10701);
INSERT INTO card_set_white_card VALUES (100229, 10700);
INSERT INTO card_set_white_card VALUES (100229, 10703);
INSERT INTO card_set_white_card VALUES (100229, 10702);
INSERT INTO card_set_white_card VALUES (100229, 10697);
INSERT INTO card_set_white_card VALUES (100229, 10696);
INSERT INTO card_set_white_card VALUES (100229, 10699);
INSERT INTO card_set_white_card VALUES (100229, 10698);
INSERT INTO card_set_white_card VALUES (100229, 10693);
INSERT INTO card_set_white_card VALUES (100229, 10692);
INSERT INTO card_set_white_card VALUES (100229, 10695);
INSERT INTO card_set_white_card VALUES (100229, 10694);
INSERT INTO card_set_white_card VALUES (100229, 10689);
INSERT INTO card_set_white_card VALUES (100229, 10688);
INSERT INTO card_set_white_card VALUES (100229, 10691);
INSERT INTO card_set_white_card VALUES (100229, 10690);
INSERT INTO card_set_white_card VALUES (100229, 10716);
INSERT INTO card_set_white_card VALUES (100229, 10717);
INSERT INTO card_set_white_card VALUES (100229, 10718);
INSERT INTO card_set_white_card VALUES (100229, 10719);
INSERT INTO card_set_white_card VALUES (100229, 10712);
INSERT INTO card_set_white_card VALUES (100229, 10713);
INSERT INTO card_set_white_card VALUES (100229, 10714);
INSERT INTO card_set_white_card VALUES (100229, 10715);
INSERT INTO card_set_white_card VALUES (100229, 10708);
INSERT INTO card_set_white_card VALUES (100229, 10709);
INSERT INTO card_set_white_card VALUES (100229, 10710);
INSERT INTO card_set_white_card VALUES (100229, 10711);
INSERT INTO card_set_white_card VALUES (100229, 10704);
INSERT INTO card_set_white_card VALUES (100229, 10705);
INSERT INTO card_set_white_card VALUES (100229, 10706);
INSERT INTO card_set_white_card VALUES (100229, 10707);
INSERT INTO card_set_white_card VALUES (100229, 10723);
INSERT INTO card_set_white_card VALUES (100229, 10722);
INSERT INTO card_set_white_card VALUES (100229, 10721);
INSERT INTO card_set_white_card VALUES (100229, 10720);
INSERT INTO card_set_white_card VALUES (100229, 10633);
INSERT INTO card_set_white_card VALUES (100229, 10632);
INSERT INTO card_set_white_card VALUES (100229, 10635);
INSERT INTO card_set_white_card VALUES (100229, 10634);
INSERT INTO card_set_white_card VALUES (100229, 10637);
INSERT INTO card_set_white_card VALUES (100229, 10636);
INSERT INTO card_set_white_card VALUES (100229, 10639);
INSERT INTO card_set_white_card VALUES (100229, 10638);
INSERT INTO card_set_white_card VALUES (100229, 10625);
INSERT INTO card_set_white_card VALUES (100229, 10624);
INSERT INTO card_set_white_card VALUES (100229, 10627);
INSERT INTO card_set_white_card VALUES (100229, 10626);
INSERT INTO card_set_white_card VALUES (100229, 10629);
INSERT INTO card_set_white_card VALUES (100229, 10628);
INSERT INTO card_set_white_card VALUES (100229, 10631);
INSERT INTO card_set_white_card VALUES (100229, 10630);
INSERT INTO card_set_white_card VALUES (100229, 10648);
INSERT INTO card_set_white_card VALUES (100229, 10649);
INSERT INTO card_set_white_card VALUES (100229, 10650);
INSERT INTO card_set_white_card VALUES (100229, 10651);
INSERT INTO card_set_white_card VALUES (100229, 10652);
INSERT INTO card_set_white_card VALUES (100229, 10653);
INSERT INTO card_set_white_card VALUES (100229, 10654);
INSERT INTO card_set_white_card VALUES (100229, 10655);
INSERT INTO card_set_white_card VALUES (100229, 10640);
INSERT INTO card_set_white_card VALUES (100229, 10641);
INSERT INTO card_set_white_card VALUES (100229, 10642);
INSERT INTO card_set_white_card VALUES (100229, 10643);
INSERT INTO card_set_white_card VALUES (100229, 10644);
INSERT INTO card_set_white_card VALUES (100229, 10645);
INSERT INTO card_set_white_card VALUES (100229, 10646);
INSERT INTO card_set_white_card VALUES (100229, 10647);
INSERT INTO card_set_white_card VALUES (100229, 10667);
INSERT INTO card_set_white_card VALUES (100229, 10666);
INSERT INTO card_set_white_card VALUES (100229, 10665);
INSERT INTO card_set_white_card VALUES (100229, 10664);
INSERT INTO card_set_white_card VALUES (100229, 10671);
INSERT INTO card_set_white_card VALUES (100229, 10670);
INSERT INTO card_set_white_card VALUES (100229, 10669);
INSERT INTO card_set_white_card VALUES (100229, 10668);
INSERT INTO card_set_white_card VALUES (100229, 10659);
INSERT INTO card_set_white_card VALUES (100229, 10658);
INSERT INTO card_set_white_card VALUES (100229, 10657);
INSERT INTO card_set_white_card VALUES (100229, 10656);
INSERT INTO card_set_white_card VALUES (100229, 10663);
INSERT INTO card_set_white_card VALUES (100229, 10662);
INSERT INTO card_set_white_card VALUES (100229, 10661);
INSERT INTO card_set_white_card VALUES (100229, 10660);
INSERT INTO card_set_white_card VALUES (100229, 10682);
INSERT INTO card_set_white_card VALUES (100229, 10683);
INSERT INTO card_set_white_card VALUES (100229, 10680);
INSERT INTO card_set_white_card VALUES (100229, 10681);
INSERT INTO card_set_white_card VALUES (100229, 10686);
INSERT INTO card_set_white_card VALUES (100229, 10687);
INSERT INTO card_set_white_card VALUES (100229, 10684);
INSERT INTO card_set_white_card VALUES (100229, 10685);
INSERT INTO card_set_white_card VALUES (100229, 10674);
INSERT INTO card_set_white_card VALUES (100229, 10675);
INSERT INTO card_set_white_card VALUES (100229, 10672);
INSERT INTO card_set_white_card VALUES (100229, 10673);
INSERT INTO card_set_white_card VALUES (100229, 10678);
INSERT INTO card_set_white_card VALUES (100229, 10679);
INSERT INTO card_set_white_card VALUES (100229, 10676);
INSERT INTO card_set_white_card VALUES (100229, 10677);
INSERT INTO card_set_white_card VALUES (100229, 10564);
INSERT INTO card_set_white_card VALUES (100229, 10565);
INSERT INTO card_set_white_card VALUES (100229, 10566);
INSERT INTO card_set_white_card VALUES (100229, 10567);
INSERT INTO card_set_white_card VALUES (100229, 10560);
INSERT INTO card_set_white_card VALUES (100229, 10561);
INSERT INTO card_set_white_card VALUES (100229, 10562);
INSERT INTO card_set_white_card VALUES (100229, 10563);
INSERT INTO card_set_white_card VALUES (100229, 10572);
INSERT INTO card_set_white_card VALUES (100229, 10573);
INSERT INTO card_set_white_card VALUES (100229, 10574);
INSERT INTO card_set_white_card VALUES (100229, 10575);
INSERT INTO card_set_white_card VALUES (100229, 10568);
INSERT INTO card_set_white_card VALUES (100229, 10569);
INSERT INTO card_set_white_card VALUES (100229, 10570);
INSERT INTO card_set_white_card VALUES (100229, 10571);
INSERT INTO card_set_white_card VALUES (100229, 10581);
INSERT INTO card_set_white_card VALUES (100229, 10580);
INSERT INTO card_set_white_card VALUES (100229, 10583);
INSERT INTO card_set_white_card VALUES (100229, 10582);
INSERT INTO card_set_white_card VALUES (100229, 10577);
INSERT INTO card_set_white_card VALUES (100229, 10576);
INSERT INTO card_set_white_card VALUES (100229, 10579);
INSERT INTO card_set_white_card VALUES (100229, 10578);
INSERT INTO card_set_white_card VALUES (100229, 10589);
INSERT INTO card_set_white_card VALUES (100229, 10588);
INSERT INTO card_set_white_card VALUES (100229, 10591);
INSERT INTO card_set_white_card VALUES (100229, 10590);
INSERT INTO card_set_white_card VALUES (100229, 10585);
INSERT INTO card_set_white_card VALUES (100229, 10584);
INSERT INTO card_set_white_card VALUES (100229, 10587);
INSERT INTO card_set_white_card VALUES (100229, 10586);
INSERT INTO card_set_white_card VALUES (100229, 10598);
INSERT INTO card_set_white_card VALUES (100229, 10599);
INSERT INTO card_set_white_card VALUES (100229, 10596);
INSERT INTO card_set_white_card VALUES (100229, 10597);
INSERT INTO card_set_white_card VALUES (100229, 10594);
INSERT INTO card_set_white_card VALUES (100229, 10595);
INSERT INTO card_set_white_card VALUES (100229, 10592);
INSERT INTO card_set_white_card VALUES (100229, 10593);
INSERT INTO card_set_white_card VALUES (100229, 10606);
INSERT INTO card_set_white_card VALUES (100229, 10607);
INSERT INTO card_set_white_card VALUES (100229, 10604);
INSERT INTO card_set_white_card VALUES (100229, 10605);
INSERT INTO card_set_white_card VALUES (100229, 10602);
INSERT INTO card_set_white_card VALUES (100229, 10603);
INSERT INTO card_set_white_card VALUES (100229, 10600);
INSERT INTO card_set_white_card VALUES (100229, 10601);
INSERT INTO card_set_white_card VALUES (100229, 10615);
INSERT INTO card_set_white_card VALUES (100229, 10614);
INSERT INTO card_set_white_card VALUES (100229, 10613);
INSERT INTO card_set_white_card VALUES (100229, 10612);
INSERT INTO card_set_white_card VALUES (100229, 10611);
INSERT INTO card_set_white_card VALUES (100229, 10610);
INSERT INTO card_set_white_card VALUES (100229, 10609);
INSERT INTO card_set_white_card VALUES (100229, 10608);
INSERT INTO card_set_white_card VALUES (100229, 10623);
INSERT INTO card_set_white_card VALUES (100229, 10622);
INSERT INTO card_set_white_card VALUES (100229, 10621);
INSERT INTO card_set_white_card VALUES (100229, 10620);
INSERT INTO card_set_white_card VALUES (100229, 10619);
INSERT INTO card_set_white_card VALUES (100229, 10618);
INSERT INTO card_set_white_card VALUES (100229, 10617);
INSERT INTO card_set_white_card VALUES (100229, 10616);
INSERT INTO card_set_white_card VALUES (100229, 10509);
INSERT INTO card_set_white_card VALUES (100229, 10510);
INSERT INTO card_set_white_card VALUES (100229, 10511);
INSERT INTO card_set_white_card VALUES (100229, 10513);
INSERT INTO card_set_white_card VALUES (100229, 10512);
INSERT INTO card_set_white_card VALUES (100229, 10515);
INSERT INTO card_set_white_card VALUES (100229, 10514);
INSERT INTO card_set_white_card VALUES (100229, 10517);
INSERT INTO card_set_white_card VALUES (100229, 10516);
INSERT INTO card_set_white_card VALUES (100229, 10519);
INSERT INTO card_set_white_card VALUES (100229, 10518);
INSERT INTO card_set_white_card VALUES (100229, 10521);
INSERT INTO card_set_white_card VALUES (100229, 10520);
INSERT INTO card_set_white_card VALUES (100229, 10523);
INSERT INTO card_set_white_card VALUES (100229, 10522);
INSERT INTO card_set_white_card VALUES (100229, 10525);
INSERT INTO card_set_white_card VALUES (100229, 10524);
INSERT INTO card_set_white_card VALUES (100229, 10527);
INSERT INTO card_set_white_card VALUES (100229, 10526);
INSERT INTO card_set_white_card VALUES (100229, 10530);
INSERT INTO card_set_white_card VALUES (100229, 10531);
INSERT INTO card_set_white_card VALUES (100229, 10528);
INSERT INTO card_set_white_card VALUES (100229, 10529);
INSERT INTO card_set_white_card VALUES (100229, 10534);
INSERT INTO card_set_white_card VALUES (100229, 10535);
INSERT INTO card_set_white_card VALUES (100229, 10532);
INSERT INTO card_set_white_card VALUES (100229, 10533);
INSERT INTO card_set_white_card VALUES (100229, 10538);
INSERT INTO card_set_white_card VALUES (100229, 10539);
INSERT INTO card_set_white_card VALUES (100229, 10536);
INSERT INTO card_set_white_card VALUES (100229, 10537);
INSERT INTO card_set_white_card VALUES (100229, 10542);
INSERT INTO card_set_white_card VALUES (100229, 10543);
INSERT INTO card_set_white_card VALUES (100229, 10540);
INSERT INTO card_set_white_card VALUES (100229, 10541);
INSERT INTO card_set_white_card VALUES (100229, 10547);
INSERT INTO card_set_white_card VALUES (100229, 10546);
INSERT INTO card_set_white_card VALUES (100229, 10545);
INSERT INTO card_set_white_card VALUES (100229, 10544);
INSERT INTO card_set_white_card VALUES (100229, 10551);
INSERT INTO card_set_white_card VALUES (100229, 10550);
INSERT INTO card_set_white_card VALUES (100229, 10549);
INSERT INTO card_set_white_card VALUES (100229, 10548);
INSERT INTO card_set_white_card VALUES (100229, 10555);
INSERT INTO card_set_white_card VALUES (100229, 10554);
INSERT INTO card_set_white_card VALUES (100229, 10553);
INSERT INTO card_set_white_card VALUES (100229, 10552);
INSERT INTO card_set_white_card VALUES (100229, 10559);
INSERT INTO card_set_white_card VALUES (100229, 10558);
INSERT INTO card_set_white_card VALUES (100229, 10557);
INSERT INTO card_set_white_card VALUES (100229, 10556);
INSERT INTO card_set_white_card VALUES (100161, 14930);
INSERT INTO card_set_white_card VALUES (100161, 14931);
INSERT INTO card_set_white_card VALUES (100161, 14928);
INSERT INTO card_set_white_card VALUES (100161, 14929);
INSERT INTO card_set_white_card VALUES (100161, 14934);
INSERT INTO card_set_white_card VALUES (100161, 14935);
INSERT INTO card_set_white_card VALUES (100161, 14932);
INSERT INTO card_set_white_card VALUES (100161, 14933);
INSERT INTO card_set_white_card VALUES (100161, 14938);
INSERT INTO card_set_white_card VALUES (100161, 14939);
INSERT INTO card_set_white_card VALUES (100161, 14936);
INSERT INTO card_set_white_card VALUES (100161, 14937);
INSERT INTO card_set_white_card VALUES (100161, 14942);
INSERT INTO card_set_white_card VALUES (100161, 14943);
INSERT INTO card_set_white_card VALUES (100161, 14940);
INSERT INTO card_set_white_card VALUES (100161, 14941);
INSERT INTO card_set_white_card VALUES (100161, 14915);
INSERT INTO card_set_white_card VALUES (100161, 14914);
INSERT INTO card_set_white_card VALUES (100161, 14913);
INSERT INTO card_set_white_card VALUES (100161, 14912);
INSERT INTO card_set_white_card VALUES (100161, 14919);
INSERT INTO card_set_white_card VALUES (100161, 14918);
INSERT INTO card_set_white_card VALUES (100161, 14917);
INSERT INTO card_set_white_card VALUES (100161, 14916);
INSERT INTO card_set_white_card VALUES (100161, 14923);
INSERT INTO card_set_white_card VALUES (100161, 14922);
INSERT INTO card_set_white_card VALUES (100161, 14921);
INSERT INTO card_set_white_card VALUES (100161, 14920);
INSERT INTO card_set_white_card VALUES (100161, 14927);
INSERT INTO card_set_white_card VALUES (100161, 14926);
INSERT INTO card_set_white_card VALUES (100161, 14925);
INSERT INTO card_set_white_card VALUES (100161, 14924);
INSERT INTO card_set_white_card VALUES (100161, 14960);
INSERT INTO card_set_white_card VALUES (100161, 14961);
INSERT INTO card_set_white_card VALUES (100161, 14962);
INSERT INTO card_set_white_card VALUES (100161, 14963);
INSERT INTO card_set_white_card VALUES (100161, 14964);
INSERT INTO card_set_white_card VALUES (100161, 14945);
INSERT INTO card_set_white_card VALUES (100161, 14944);
INSERT INTO card_set_white_card VALUES (100161, 14947);
INSERT INTO card_set_white_card VALUES (100161, 14946);
INSERT INTO card_set_white_card VALUES (100161, 14949);
INSERT INTO card_set_white_card VALUES (100161, 14948);
INSERT INTO card_set_white_card VALUES (100161, 14951);
INSERT INTO card_set_white_card VALUES (100161, 14950);
INSERT INTO card_set_white_card VALUES (100161, 14953);
INSERT INTO card_set_white_card VALUES (100161, 14952);
INSERT INTO card_set_white_card VALUES (100161, 14955);
INSERT INTO card_set_white_card VALUES (100161, 14954);
INSERT INTO card_set_white_card VALUES (100161, 14957);
INSERT INTO card_set_white_card VALUES (100161, 14956);
INSERT INTO card_set_white_card VALUES (100161, 14959);
INSERT INTO card_set_white_card VALUES (100161, 14958);
INSERT INTO card_set_white_card VALUES (100161, 14870);
INSERT INTO card_set_white_card VALUES (100161, 14871);
INSERT INTO card_set_white_card VALUES (100161, 14868);
INSERT INTO card_set_white_card VALUES (100161, 14869);
INSERT INTO card_set_white_card VALUES (100161, 14866);
INSERT INTO card_set_white_card VALUES (100161, 14867);
INSERT INTO card_set_white_card VALUES (100161, 14864);
INSERT INTO card_set_white_card VALUES (100161, 14865);
INSERT INTO card_set_white_card VALUES (100161, 14878);
INSERT INTO card_set_white_card VALUES (100161, 14879);
INSERT INTO card_set_white_card VALUES (100161, 14876);
INSERT INTO card_set_white_card VALUES (100161, 14877);
INSERT INTO card_set_white_card VALUES (100161, 14874);
INSERT INTO card_set_white_card VALUES (100161, 14875);
INSERT INTO card_set_white_card VALUES (100161, 14872);
INSERT INTO card_set_white_card VALUES (100161, 14873);
INSERT INTO card_set_white_card VALUES (100161, 14855);
INSERT INTO card_set_white_card VALUES (100161, 14854);
INSERT INTO card_set_white_card VALUES (100161, 14853);
INSERT INTO card_set_white_card VALUES (100161, 14852);
INSERT INTO card_set_white_card VALUES (100161, 14851);
INSERT INTO card_set_white_card VALUES (100161, 14850);
INSERT INTO card_set_white_card VALUES (100161, 14849);
INSERT INTO card_set_white_card VALUES (100161, 14848);
INSERT INTO card_set_white_card VALUES (100161, 14863);
INSERT INTO card_set_white_card VALUES (100161, 14862);
INSERT INTO card_set_white_card VALUES (100161, 14861);
INSERT INTO card_set_white_card VALUES (100161, 14860);
INSERT INTO card_set_white_card VALUES (100161, 14859);
INSERT INTO card_set_white_card VALUES (100161, 14858);
INSERT INTO card_set_white_card VALUES (100161, 14857);
INSERT INTO card_set_white_card VALUES (100161, 14856);
INSERT INTO card_set_white_card VALUES (100161, 14900);
INSERT INTO card_set_white_card VALUES (100161, 14901);
INSERT INTO card_set_white_card VALUES (100161, 14902);
INSERT INTO card_set_white_card VALUES (100161, 14903);
INSERT INTO card_set_white_card VALUES (100161, 14896);
INSERT INTO card_set_white_card VALUES (100161, 14897);
INSERT INTO card_set_white_card VALUES (100161, 14898);
INSERT INTO card_set_white_card VALUES (100161, 14899);
INSERT INTO card_set_white_card VALUES (100161, 14908);
INSERT INTO card_set_white_card VALUES (100161, 14909);
INSERT INTO card_set_white_card VALUES (100161, 14910);
INSERT INTO card_set_white_card VALUES (100161, 14911);
INSERT INTO card_set_white_card VALUES (100161, 14904);
INSERT INTO card_set_white_card VALUES (100161, 14905);
INSERT INTO card_set_white_card VALUES (100161, 14906);
INSERT INTO card_set_white_card VALUES (100161, 14907);
INSERT INTO card_set_white_card VALUES (100161, 14885);
INSERT INTO card_set_white_card VALUES (100161, 14884);
INSERT INTO card_set_white_card VALUES (100161, 14887);
INSERT INTO card_set_white_card VALUES (100161, 14886);
INSERT INTO card_set_white_card VALUES (100161, 14881);
INSERT INTO card_set_white_card VALUES (100161, 14880);
INSERT INTO card_set_white_card VALUES (100161, 14883);
INSERT INTO card_set_white_card VALUES (100161, 14882);
INSERT INTO card_set_white_card VALUES (100161, 14893);
INSERT INTO card_set_white_card VALUES (100161, 14892);
INSERT INTO card_set_white_card VALUES (100161, 14895);
INSERT INTO card_set_white_card VALUES (100161, 14894);
INSERT INTO card_set_white_card VALUES (100161, 14889);
INSERT INTO card_set_white_card VALUES (100161, 14888);
INSERT INTO card_set_white_card VALUES (100161, 14891);
INSERT INTO card_set_white_card VALUES (100161, 14890);
INSERT INTO card_set_white_card VALUES (100161, 14830);
INSERT INTO card_set_white_card VALUES (100161, 14831);
INSERT INTO card_set_white_card VALUES (100161, 14828);
INSERT INTO card_set_white_card VALUES (100161, 14829);
INSERT INTO card_set_white_card VALUES (100161, 14826);
INSERT INTO card_set_white_card VALUES (100161, 14827);
INSERT INTO card_set_white_card VALUES (100161, 14824);
INSERT INTO card_set_white_card VALUES (100161, 14825);
INSERT INTO card_set_white_card VALUES (100161, 14822);
INSERT INTO card_set_white_card VALUES (100161, 14823);
INSERT INTO card_set_white_card VALUES (100161, 14820);
INSERT INTO card_set_white_card VALUES (100161, 14821);
INSERT INTO card_set_white_card VALUES (100161, 14818);
INSERT INTO card_set_white_card VALUES (100161, 14819);
INSERT INTO card_set_white_card VALUES (100161, 14847);
INSERT INTO card_set_white_card VALUES (100161, 14846);
INSERT INTO card_set_white_card VALUES (100161, 14845);
INSERT INTO card_set_white_card VALUES (100161, 14844);
INSERT INTO card_set_white_card VALUES (100161, 14843);
INSERT INTO card_set_white_card VALUES (100161, 14842);
INSERT INTO card_set_white_card VALUES (100161, 14841);
INSERT INTO card_set_white_card VALUES (100161, 14840);
INSERT INTO card_set_white_card VALUES (100161, 14839);
INSERT INTO card_set_white_card VALUES (100161, 14838);
INSERT INTO card_set_white_card VALUES (100161, 14837);
INSERT INTO card_set_white_card VALUES (100161, 14836);
INSERT INTO card_set_white_card VALUES (100161, 14835);
INSERT INTO card_set_white_card VALUES (100161, 14834);
INSERT INTO card_set_white_card VALUES (100161, 14833);
INSERT INTO card_set_white_card VALUES (100161, 14832);
INSERT INTO card_set_white_card VALUES (100157, 14998);
INSERT INTO card_set_white_card VALUES (100157, 14997);
INSERT INTO card_set_white_card VALUES (100157, 14996);
INSERT INTO card_set_white_card VALUES (100157, 14995);
INSERT INTO card_set_white_card VALUES (100157, 14994);
INSERT INTO card_set_white_card VALUES (100157, 14993);
INSERT INTO card_set_white_card VALUES (100157, 14992);
INSERT INTO card_set_white_card VALUES (100157, 14990);
INSERT INTO card_set_white_card VALUES (100157, 14991);
INSERT INTO card_set_white_card VALUES (100157, 14988);
INSERT INTO card_set_white_card VALUES (100157, 14989);
INSERT INTO card_set_white_card VALUES (100157, 14986);
INSERT INTO card_set_white_card VALUES (100157, 14987);
INSERT INTO card_set_white_card VALUES (100157, 14984);
INSERT INTO card_set_white_card VALUES (100157, 14985);
INSERT INTO card_set_white_card VALUES (100157, 14982);
INSERT INTO card_set_white_card VALUES (100157, 14983);
INSERT INTO card_set_white_card VALUES (100157, 14980);
INSERT INTO card_set_white_card VALUES (100157, 14981);
INSERT INTO card_set_white_card VALUES (100157, 14978);
INSERT INTO card_set_white_card VALUES (100157, 14979);
INSERT INTO card_set_white_card VALUES (100157, 14976);
INSERT INTO card_set_white_card VALUES (100157, 14977);
INSERT INTO card_set_white_card VALUES (100157, 14965);
INSERT INTO card_set_white_card VALUES (100157, 14966);
INSERT INTO card_set_white_card VALUES (100157, 14967);
INSERT INTO card_set_white_card VALUES (100157, 14968);
INSERT INTO card_set_white_card VALUES (100157, 14969);
INSERT INTO card_set_white_card VALUES (100157, 14970);
INSERT INTO card_set_white_card VALUES (100157, 14971);
INSERT INTO card_set_white_card VALUES (100157, 14972);
INSERT INTO card_set_white_card VALUES (100157, 14973);
INSERT INTO card_set_white_card VALUES (100157, 14974);
INSERT INTO card_set_white_card VALUES (100157, 14975);
INSERT INTO card_set_white_card VALUES (100231, 15067);
INSERT INTO card_set_white_card VALUES (100231, 15066);
INSERT INTO card_set_white_card VALUES (100231, 15065);
INSERT INTO card_set_white_card VALUES (100231, 15064);
INSERT INTO card_set_white_card VALUES (100231, 15071);
INSERT INTO card_set_white_card VALUES (100231, 15070);
INSERT INTO card_set_white_card VALUES (100231, 15069);
INSERT INTO card_set_white_card VALUES (100231, 15068);
INSERT INTO card_set_white_card VALUES (100231, 15059);
INSERT INTO card_set_white_card VALUES (100231, 15058);
INSERT INTO card_set_white_card VALUES (100231, 15057);
INSERT INTO card_set_white_card VALUES (100231, 15056);
INSERT INTO card_set_white_card VALUES (100231, 15063);
INSERT INTO card_set_white_card VALUES (100231, 15062);
INSERT INTO card_set_white_card VALUES (100231, 15061);
INSERT INTO card_set_white_card VALUES (100231, 15060);
INSERT INTO card_set_white_card VALUES (100231, 15050);
INSERT INTO card_set_white_card VALUES (100231, 15051);
INSERT INTO card_set_white_card VALUES (100231, 10028);
INSERT INTO card_set_white_card VALUES (100231, 15048);
INSERT INTO card_set_white_card VALUES (100231, 15049);
INSERT INTO card_set_white_card VALUES (100231, 15054);
INSERT INTO card_set_white_card VALUES (100231, 15055);
INSERT INTO card_set_white_card VALUES (100231, 15052);
INSERT INTO card_set_white_card VALUES (100231, 15053);
INSERT INTO card_set_white_card VALUES (100231, 15042);
INSERT INTO card_set_white_card VALUES (100231, 15043);
INSERT INTO card_set_white_card VALUES (100231, 15040);
INSERT INTO card_set_white_card VALUES (100231, 15041);
INSERT INTO card_set_white_card VALUES (100231, 15046);
INSERT INTO card_set_white_card VALUES (100231, 15047);
INSERT INTO card_set_white_card VALUES (100231, 15044);
INSERT INTO card_set_white_card VALUES (100231, 15045);
INSERT INTO card_set_white_card VALUES (100231, 15097);
INSERT INTO card_set_white_card VALUES (100231, 15096);
INSERT INTO card_set_white_card VALUES (100231, 15099);
INSERT INTO card_set_white_card VALUES (100231, 15098);
INSERT INTO card_set_white_card VALUES (100231, 15101);
INSERT INTO card_set_white_card VALUES (100231, 15100);
INSERT INTO card_set_white_card VALUES (100231, 15103);
INSERT INTO card_set_white_card VALUES (100231, 15102);
INSERT INTO card_set_white_card VALUES (100231, 15089);
INSERT INTO card_set_white_card VALUES (100231, 15088);
INSERT INTO card_set_white_card VALUES (100231, 15091);
INSERT INTO card_set_white_card VALUES (100231, 15090);
INSERT INTO card_set_white_card VALUES (100231, 15093);
INSERT INTO card_set_white_card VALUES (100231, 15092);
INSERT INTO card_set_white_card VALUES (100231, 15095);
INSERT INTO card_set_white_card VALUES (100231, 15094);
INSERT INTO card_set_white_card VALUES (100231, 15080);
INSERT INTO card_set_white_card VALUES (100231, 15081);
INSERT INTO card_set_white_card VALUES (100231, 15082);
INSERT INTO card_set_white_card VALUES (100231, 15083);
INSERT INTO card_set_white_card VALUES (100231, 15084);
INSERT INTO card_set_white_card VALUES (100231, 15085);
INSERT INTO card_set_white_card VALUES (100231, 15086);
INSERT INTO card_set_white_card VALUES (100231, 15087);
INSERT INTO card_set_white_card VALUES (100231, 15072);
INSERT INTO card_set_white_card VALUES (100231, 15073);
INSERT INTO card_set_white_card VALUES (100231, 15074);
INSERT INTO card_set_white_card VALUES (100231, 15075);
INSERT INTO card_set_white_card VALUES (100231, 15076);
INSERT INTO card_set_white_card VALUES (100231, 15077);
INSERT INTO card_set_white_card VALUES (100231, 15078);
INSERT INTO card_set_white_card VALUES (100231, 15079);
INSERT INTO card_set_white_card VALUES (100231, 15007);
INSERT INTO card_set_white_card VALUES (100231, 15006);
INSERT INTO card_set_white_card VALUES (100231, 15005);
INSERT INTO card_set_white_card VALUES (100231, 15004);
INSERT INTO card_set_white_card VALUES (100231, 15003);
INSERT INTO card_set_white_card VALUES (100231, 15002);
INSERT INTO card_set_white_card VALUES (100231, 15001);
INSERT INTO card_set_white_card VALUES (100231, 15000);
INSERT INTO card_set_white_card VALUES (100231, 14999);
INSERT INTO card_set_white_card VALUES (100231, 15037);
INSERT INTO card_set_white_card VALUES (100231, 15036);
INSERT INTO card_set_white_card VALUES (100231, 15039);
INSERT INTO card_set_white_card VALUES (100231, 15038);
INSERT INTO card_set_white_card VALUES (100231, 15033);
INSERT INTO card_set_white_card VALUES (100231, 15032);
INSERT INTO card_set_white_card VALUES (100231, 15035);
INSERT INTO card_set_white_card VALUES (100231, 15034);
INSERT INTO card_set_white_card VALUES (100231, 15029);
INSERT INTO card_set_white_card VALUES (100231, 15028);
INSERT INTO card_set_white_card VALUES (100231, 15031);
INSERT INTO card_set_white_card VALUES (100231, 15030);
INSERT INTO card_set_white_card VALUES (100231, 15025);
INSERT INTO card_set_white_card VALUES (100231, 15024);
INSERT INTO card_set_white_card VALUES (100231, 15027);
INSERT INTO card_set_white_card VALUES (100231, 15026);
INSERT INTO card_set_white_card VALUES (100231, 15020);
INSERT INTO card_set_white_card VALUES (100231, 15021);
INSERT INTO card_set_white_card VALUES (100231, 15022);
INSERT INTO card_set_white_card VALUES (100231, 15023);
INSERT INTO card_set_white_card VALUES (100231, 15016);
INSERT INTO card_set_white_card VALUES (100231, 15017);
INSERT INTO card_set_white_card VALUES (100231, 15018);
INSERT INTO card_set_white_card VALUES (100231, 15019);
INSERT INTO card_set_white_card VALUES (100231, 15012);
INSERT INTO card_set_white_card VALUES (100231, 15013);
INSERT INTO card_set_white_card VALUES (100231, 15014);
INSERT INTO card_set_white_card VALUES (100231, 15015);
INSERT INTO card_set_white_card VALUES (100231, 15008);
INSERT INTO card_set_white_card VALUES (100231, 15009);
INSERT INTO card_set_white_card VALUES (100231, 15010);
INSERT INTO card_set_white_card VALUES (100231, 15011);
INSERT INTO card_set_white_card VALUES (100231, 15169);
INSERT INTO card_set_white_card VALUES (100231, 15168);
INSERT INTO card_set_white_card VALUES (100231, 15171);
INSERT INTO card_set_white_card VALUES (100231, 15170);
INSERT INTO card_set_white_card VALUES (100231, 15173);
INSERT INTO card_set_white_card VALUES (100231, 15172);
INSERT INTO card_set_white_card VALUES (100231, 15175);
INSERT INTO card_set_white_card VALUES (100231, 15174);
INSERT INTO card_set_white_card VALUES (100231, 15109);
INSERT INTO card_set_white_card VALUES (100231, 15108);
INSERT INTO card_set_white_card VALUES (100231, 15111);
INSERT INTO card_set_white_card VALUES (100231, 15110);
INSERT INTO card_set_white_card VALUES (100231, 15105);
INSERT INTO card_set_white_card VALUES (100231, 15104);
INSERT INTO card_set_white_card VALUES (100231, 15107);
INSERT INTO card_set_white_card VALUES (100231, 15106);
INSERT INTO card_set_white_card VALUES (100231, 15117);
INSERT INTO card_set_white_card VALUES (100231, 15116);
INSERT INTO card_set_white_card VALUES (100231, 15119);
INSERT INTO card_set_white_card VALUES (100231, 15118);
INSERT INTO card_set_white_card VALUES (100231, 15113);
INSERT INTO card_set_white_card VALUES (100231, 15112);
INSERT INTO card_set_white_card VALUES (100231, 15115);
INSERT INTO card_set_white_card VALUES (100231, 15114);
INSERT INTO card_set_white_card VALUES (100231, 15124);
INSERT INTO card_set_white_card VALUES (100231, 15125);
INSERT INTO card_set_white_card VALUES (100231, 15126);
INSERT INTO card_set_white_card VALUES (100231, 15127);
INSERT INTO card_set_white_card VALUES (100231, 15120);
INSERT INTO card_set_white_card VALUES (100231, 15121);
INSERT INTO card_set_white_card VALUES (100231, 15122);
INSERT INTO card_set_white_card VALUES (100231, 15123);
INSERT INTO card_set_white_card VALUES (100231, 15132);
INSERT INTO card_set_white_card VALUES (100231, 15133);
INSERT INTO card_set_white_card VALUES (100231, 15134);
INSERT INTO card_set_white_card VALUES (100231, 15135);
INSERT INTO card_set_white_card VALUES (100231, 15128);
INSERT INTO card_set_white_card VALUES (100231, 15129);
INSERT INTO card_set_white_card VALUES (100231, 15130);
INSERT INTO card_set_white_card VALUES (100231, 15131);
INSERT INTO card_set_white_card VALUES (100231, 15143);
INSERT INTO card_set_white_card VALUES (100231, 15142);
INSERT INTO card_set_white_card VALUES (100231, 15141);
INSERT INTO card_set_white_card VALUES (100231, 15140);
INSERT INTO card_set_white_card VALUES (100231, 15139);
INSERT INTO card_set_white_card VALUES (100231, 15138);
INSERT INTO card_set_white_card VALUES (100231, 15137);
INSERT INTO card_set_white_card VALUES (100231, 15136);
INSERT INTO card_set_white_card VALUES (100231, 15151);
INSERT INTO card_set_white_card VALUES (100231, 15150);
INSERT INTO card_set_white_card VALUES (100231, 15149);
INSERT INTO card_set_white_card VALUES (100231, 15148);
INSERT INTO card_set_white_card VALUES (100231, 15147);
INSERT INTO card_set_white_card VALUES (100231, 15146);
INSERT INTO card_set_white_card VALUES (100231, 15145);
INSERT INTO card_set_white_card VALUES (100231, 15144);
INSERT INTO card_set_white_card VALUES (100231, 15158);
INSERT INTO card_set_white_card VALUES (100231, 15159);
INSERT INTO card_set_white_card VALUES (100231, 15156);
INSERT INTO card_set_white_card VALUES (100231, 15157);
INSERT INTO card_set_white_card VALUES (100231, 15154);
INSERT INTO card_set_white_card VALUES (100231, 15155);
INSERT INTO card_set_white_card VALUES (100231, 15152);
INSERT INTO card_set_white_card VALUES (100231, 15153);
INSERT INTO card_set_white_card VALUES (100231, 15166);
INSERT INTO card_set_white_card VALUES (100231, 15167);
INSERT INTO card_set_white_card VALUES (100231, 15164);
INSERT INTO card_set_white_card VALUES (100231, 15165);
INSERT INTO card_set_white_card VALUES (100231, 15162);
INSERT INTO card_set_white_card VALUES (100231, 15163);
INSERT INTO card_set_white_card VALUES (100231, 15160);
INSERT INTO card_set_white_card VALUES (100231, 15161);
INSERT INTO card_set_white_card VALUES (100232, 15304);
INSERT INTO card_set_white_card VALUES (100232, 15305);
INSERT INTO card_set_white_card VALUES (100232, 15306);
INSERT INTO card_set_white_card VALUES (100232, 15307);
INSERT INTO card_set_white_card VALUES (100232, 15308);
INSERT INTO card_set_white_card VALUES (100232, 15309);
INSERT INTO card_set_white_card VALUES (100232, 15310);
INSERT INTO card_set_white_card VALUES (100232, 15311);
INSERT INTO card_set_white_card VALUES (100232, 15296);
INSERT INTO card_set_white_card VALUES (100232, 15297);
INSERT INTO card_set_white_card VALUES (100232, 15298);
INSERT INTO card_set_white_card VALUES (100232, 15299);
INSERT INTO card_set_white_card VALUES (100232, 15300);
INSERT INTO card_set_white_card VALUES (100232, 15301);
INSERT INTO card_set_white_card VALUES (100232, 15302);
INSERT INTO card_set_white_card VALUES (100232, 15303);
INSERT INTO card_set_white_card VALUES (100232, 15321);
INSERT INTO card_set_white_card VALUES (100232, 15320);
INSERT INTO card_set_white_card VALUES (100232, 15323);
INSERT INTO card_set_white_card VALUES (100232, 15322);
INSERT INTO card_set_white_card VALUES (100232, 15325);
INSERT INTO card_set_white_card VALUES (100232, 15324);
INSERT INTO card_set_white_card VALUES (100232, 15327);
INSERT INTO card_set_white_card VALUES (100232, 15326);
INSERT INTO card_set_white_card VALUES (100232, 15313);
INSERT INTO card_set_white_card VALUES (100232, 15312);
INSERT INTO card_set_white_card VALUES (100232, 15315);
INSERT INTO card_set_white_card VALUES (100232, 15314);
INSERT INTO card_set_white_card VALUES (100232, 15317);
INSERT INTO card_set_white_card VALUES (100232, 15316);
INSERT INTO card_set_white_card VALUES (100232, 15319);
INSERT INTO card_set_white_card VALUES (100232, 15318);
INSERT INTO card_set_white_card VALUES (100232, 15330);
INSERT INTO card_set_white_card VALUES (100232, 15328);
INSERT INTO card_set_white_card VALUES (100232, 15329);
INSERT INTO card_set_white_card VALUES (100232, 15244);
INSERT INTO card_set_white_card VALUES (100232, 15245);
INSERT INTO card_set_white_card VALUES (100232, 15246);
INSERT INTO card_set_white_card VALUES (100232, 15247);
INSERT INTO card_set_white_card VALUES (100232, 15240);
INSERT INTO card_set_white_card VALUES (100232, 15241);
INSERT INTO card_set_white_card VALUES (100232, 15242);
INSERT INTO card_set_white_card VALUES (100232, 15243);
INSERT INTO card_set_white_card VALUES (100232, 15236);
INSERT INTO card_set_white_card VALUES (100232, 15237);
INSERT INTO card_set_white_card VALUES (100232, 15238);
INSERT INTO card_set_white_card VALUES (100232, 15239);
INSERT INTO card_set_white_card VALUES (100232, 15232);
INSERT INTO card_set_white_card VALUES (100232, 15233);
INSERT INTO card_set_white_card VALUES (100232, 15234);
INSERT INTO card_set_white_card VALUES (100232, 15235);
INSERT INTO card_set_white_card VALUES (100232, 15261);
INSERT INTO card_set_white_card VALUES (100232, 15260);
INSERT INTO card_set_white_card VALUES (100232, 15263);
INSERT INTO card_set_white_card VALUES (100232, 15262);
INSERT INTO card_set_white_card VALUES (100232, 15257);
INSERT INTO card_set_white_card VALUES (100232, 15256);
INSERT INTO card_set_white_card VALUES (100232, 15259);
INSERT INTO card_set_white_card VALUES (100232, 15258);
INSERT INTO card_set_white_card VALUES (100232, 15253);
INSERT INTO card_set_white_card VALUES (100232, 15252);
INSERT INTO card_set_white_card VALUES (100232, 15255);
INSERT INTO card_set_white_card VALUES (100232, 15254);
INSERT INTO card_set_white_card VALUES (100232, 15249);
INSERT INTO card_set_white_card VALUES (100232, 15248);
INSERT INTO card_set_white_card VALUES (100232, 15251);
INSERT INTO card_set_white_card VALUES (100232, 15250);
INSERT INTO card_set_white_card VALUES (100232, 15278);
INSERT INTO card_set_white_card VALUES (100232, 15279);
INSERT INTO card_set_white_card VALUES (100232, 15276);
INSERT INTO card_set_white_card VALUES (100232, 15277);
INSERT INTO card_set_white_card VALUES (100232, 15274);
INSERT INTO card_set_white_card VALUES (100232, 15275);
INSERT INTO card_set_white_card VALUES (100232, 15272);
INSERT INTO card_set_white_card VALUES (100232, 15273);
INSERT INTO card_set_white_card VALUES (100232, 15270);
INSERT INTO card_set_white_card VALUES (100232, 15271);
INSERT INTO card_set_white_card VALUES (100232, 15268);
INSERT INTO card_set_white_card VALUES (100232, 15269);
INSERT INTO card_set_white_card VALUES (100232, 15266);
INSERT INTO card_set_white_card VALUES (100232, 15267);
INSERT INTO card_set_white_card VALUES (100232, 15264);
INSERT INTO card_set_white_card VALUES (100232, 15265);
INSERT INTO card_set_white_card VALUES (100232, 15295);
INSERT INTO card_set_white_card VALUES (100232, 15294);
INSERT INTO card_set_white_card VALUES (100232, 15293);
INSERT INTO card_set_white_card VALUES (100232, 15292);
INSERT INTO card_set_white_card VALUES (100232, 15291);
INSERT INTO card_set_white_card VALUES (100232, 15290);
INSERT INTO card_set_white_card VALUES (100232, 15289);
INSERT INTO card_set_white_card VALUES (100232, 15288);
INSERT INTO card_set_white_card VALUES (100232, 15287);
INSERT INTO card_set_white_card VALUES (100232, 15286);
INSERT INTO card_set_white_card VALUES (100232, 15285);
INSERT INTO card_set_white_card VALUES (100232, 15284);
INSERT INTO card_set_white_card VALUES (100232, 15283);
INSERT INTO card_set_white_card VALUES (100232, 15282);
INSERT INTO card_set_white_card VALUES (100232, 15281);
INSERT INTO card_set_white_card VALUES (100232, 15280);
INSERT INTO card_set_white_card VALUES (100232, 15177);
INSERT INTO card_set_white_card VALUES (100232, 15176);
INSERT INTO card_set_white_card VALUES (100232, 15179);
INSERT INTO card_set_white_card VALUES (100232, 15178);
INSERT INTO card_set_white_card VALUES (100232, 15181);
INSERT INTO card_set_white_card VALUES (100232, 15180);
INSERT INTO card_set_white_card VALUES (100232, 15183);
INSERT INTO card_set_white_card VALUES (100232, 15182);
INSERT INTO card_set_white_card VALUES (100232, 15184);
INSERT INTO card_set_white_card VALUES (100232, 15185);
INSERT INTO card_set_white_card VALUES (100232, 15186);
INSERT INTO card_set_white_card VALUES (100232, 15187);
INSERT INTO card_set_white_card VALUES (100232, 15188);
INSERT INTO card_set_white_card VALUES (100232, 15189);
INSERT INTO card_set_white_card VALUES (100232, 15190);
INSERT INTO card_set_white_card VALUES (100232, 15191);
INSERT INTO card_set_white_card VALUES (100232, 15192);
INSERT INTO card_set_white_card VALUES (100232, 15193);
INSERT INTO card_set_white_card VALUES (100232, 15194);
INSERT INTO card_set_white_card VALUES (100232, 15195);
INSERT INTO card_set_white_card VALUES (100232, 15196);
INSERT INTO card_set_white_card VALUES (100232, 15197);
INSERT INTO card_set_white_card VALUES (100232, 15198);
INSERT INTO card_set_white_card VALUES (100232, 15199);
INSERT INTO card_set_white_card VALUES (100232, 15203);
INSERT INTO card_set_white_card VALUES (100232, 15202);
INSERT INTO card_set_white_card VALUES (100232, 15201);
INSERT INTO card_set_white_card VALUES (100232, 15200);
INSERT INTO card_set_white_card VALUES (100232, 15207);
INSERT INTO card_set_white_card VALUES (100232, 15206);
INSERT INTO card_set_white_card VALUES (100232, 15205);
INSERT INTO card_set_white_card VALUES (100232, 15204);
INSERT INTO card_set_white_card VALUES (100232, 15211);
INSERT INTO card_set_white_card VALUES (100232, 15210);
INSERT INTO card_set_white_card VALUES (100232, 15209);
INSERT INTO card_set_white_card VALUES (100232, 15208);
INSERT INTO card_set_white_card VALUES (100232, 15215);
INSERT INTO card_set_white_card VALUES (100232, 15214);
INSERT INTO card_set_white_card VALUES (100232, 15213);
INSERT INTO card_set_white_card VALUES (100232, 15212);
INSERT INTO card_set_white_card VALUES (100232, 15218);
INSERT INTO card_set_white_card VALUES (100232, 15219);
INSERT INTO card_set_white_card VALUES (100232, 15216);
INSERT INTO card_set_white_card VALUES (100232, 15217);
INSERT INTO card_set_white_card VALUES (100232, 15222);
INSERT INTO card_set_white_card VALUES (100232, 15223);
INSERT INTO card_set_white_card VALUES (100232, 15220);
INSERT INTO card_set_white_card VALUES (100232, 15221);
INSERT INTO card_set_white_card VALUES (100232, 15226);
INSERT INTO card_set_white_card VALUES (100232, 15227);
INSERT INTO card_set_white_card VALUES (100232, 15224);
INSERT INTO card_set_white_card VALUES (100232, 15225);
INSERT INTO card_set_white_card VALUES (100232, 15230);
INSERT INTO card_set_white_card VALUES (100232, 15231);
INSERT INTO card_set_white_card VALUES (100232, 15228);
INSERT INTO card_set_white_card VALUES (100232, 15229);
INSERT INTO card_set_white_card VALUES (100233, 15338);
INSERT INTO card_set_white_card VALUES (100233, 15339);
INSERT INTO card_set_white_card VALUES (100233, 15336);
INSERT INTO card_set_white_card VALUES (100233, 15337);
INSERT INTO card_set_white_card VALUES (100233, 15342);
INSERT INTO card_set_white_card VALUES (100233, 15343);
INSERT INTO card_set_white_card VALUES (100233, 15340);
INSERT INTO card_set_white_card VALUES (100233, 15341);
INSERT INTO card_set_white_card VALUES (100233, 15331);
INSERT INTO card_set_white_card VALUES (100233, 15334);
INSERT INTO card_set_white_card VALUES (100233, 15335);
INSERT INTO card_set_white_card VALUES (100233, 15332);
INSERT INTO card_set_white_card VALUES (100233, 15333);
INSERT INTO card_set_white_card VALUES (100233, 15355);
INSERT INTO card_set_white_card VALUES (100233, 15354);
INSERT INTO card_set_white_card VALUES (100233, 15353);
INSERT INTO card_set_white_card VALUES (100233, 15352);
INSERT INTO card_set_white_card VALUES (100233, 15359);
INSERT INTO card_set_white_card VALUES (100233, 15358);
INSERT INTO card_set_white_card VALUES (100233, 15357);
INSERT INTO card_set_white_card VALUES (100233, 15356);
INSERT INTO card_set_white_card VALUES (100233, 15363);
INSERT INTO card_set_white_card VALUES (100233, 15347);
INSERT INTO card_set_white_card VALUES (100233, 15362);
INSERT INTO card_set_white_card VALUES (100233, 15346);
INSERT INTO card_set_white_card VALUES (100233, 15361);
INSERT INTO card_set_white_card VALUES (100233, 15345);
INSERT INTO card_set_white_card VALUES (100233, 15360);
INSERT INTO card_set_white_card VALUES (100233, 15344);
INSERT INTO card_set_white_card VALUES (100233, 15367);
INSERT INTO card_set_white_card VALUES (100233, 15351);
INSERT INTO card_set_white_card VALUES (100233, 15366);
INSERT INTO card_set_white_card VALUES (100233, 15350);
INSERT INTO card_set_white_card VALUES (100233, 15365);
INSERT INTO card_set_white_card VALUES (100233, 15349);
INSERT INTO card_set_white_card VALUES (100233, 15364);
INSERT INTO card_set_white_card VALUES (100233, 15348);
INSERT INTO card_set_white_card VALUES (100161, 14817);
INSERT INTO card_set_white_card VALUES (100003, 15303);
INSERT INTO card_set_white_card VALUES (100003, 15333);
INSERT INTO card_set_white_card VALUES (100003, 15210);
INSERT INTO card_set_white_card VALUES (100003, 15131);
INSERT INTO card_set_white_card VALUES (100003, 10036);
INSERT INTO card_set_white_card VALUES (100003, 10028);
INSERT INTO card_set_white_card VALUES (100003, 10027);
INSERT INTO card_set_white_card VALUES (100003, 10025);
INSERT INTO card_set_white_card VALUES (100003, 10013);
INSERT INTO card_set_white_card VALUES (100003, 10014);
INSERT INTO card_set_white_card VALUES (100003, 15102);
INSERT INTO card_set_white_card VALUES (100003, 10560);
INSERT INTO card_set_white_card VALUES (100003, 14942);
INSERT INTO card_set_white_card VALUES (100003, 14940);
INSERT INTO card_set_white_card VALUES (100003, 10581);
INSERT INTO card_set_white_card VALUES (100003, 14971);
INSERT INTO card_set_white_card VALUES (100003, 10120);
INSERT INTO card_set_white_card VALUES (100003, 10510);
INSERT INTO card_set_white_card VALUES (100003, 10525);
INSERT INTO card_set_white_card VALUES (100003, 10524);
INSERT INTO card_set_white_card VALUES (100003, 10527);
INSERT INTO card_set_white_card VALUES (100003, 10526);
INSERT INTO card_set_white_card VALUES (100003, 10528);
INSERT INTO card_set_white_card VALUES (100003, 10529);
INSERT INTO card_set_white_card VALUES (100003, 10543);
INSERT INTO card_set_white_card VALUES (100234, 15490);
INSERT INTO card_set_white_card VALUES (100234, 15491);
INSERT INTO card_set_white_card VALUES (100234, 15488);
INSERT INTO card_set_white_card VALUES (100234, 15489);
INSERT INTO card_set_white_card VALUES (100234, 15494);
INSERT INTO card_set_white_card VALUES (100234, 15495);
INSERT INTO card_set_white_card VALUES (100234, 15492);
INSERT INTO card_set_white_card VALUES (100234, 15493);
INSERT INTO card_set_white_card VALUES (100234, 15416);
INSERT INTO card_set_white_card VALUES (100234, 15417);
INSERT INTO card_set_white_card VALUES (100234, 15418);
INSERT INTO card_set_white_card VALUES (100234, 15419);
INSERT INTO card_set_white_card VALUES (100234, 15420);
INSERT INTO card_set_white_card VALUES (100234, 15421);
INSERT INTO card_set_white_card VALUES (100234, 15422);
INSERT INTO card_set_white_card VALUES (100234, 15423);
INSERT INTO card_set_white_card VALUES (100234, 15408);
INSERT INTO card_set_white_card VALUES (100234, 15409);
INSERT INTO card_set_white_card VALUES (100234, 15410);
INSERT INTO card_set_white_card VALUES (100234, 15411);
INSERT INTO card_set_white_card VALUES (100234, 15412);
INSERT INTO card_set_white_card VALUES (100234, 15413);
INSERT INTO card_set_white_card VALUES (100234, 15414);
INSERT INTO card_set_white_card VALUES (100234, 15415);
INSERT INTO card_set_white_card VALUES (100234, 15401);
INSERT INTO card_set_white_card VALUES (100234, 15400);
INSERT INTO card_set_white_card VALUES (100234, 15403);
INSERT INTO card_set_white_card VALUES (100234, 15402);
INSERT INTO card_set_white_card VALUES (100234, 15405);
INSERT INTO card_set_white_card VALUES (100234, 15404);
INSERT INTO card_set_white_card VALUES (100234, 15407);
INSERT INTO card_set_white_card VALUES (100234, 15406);
INSERT INTO card_set_white_card VALUES (100234, 15393);
INSERT INTO card_set_white_card VALUES (100234, 15392);
INSERT INTO card_set_white_card VALUES (100234, 15395);
INSERT INTO card_set_white_card VALUES (100234, 15394);
INSERT INTO card_set_white_card VALUES (100234, 15397);
INSERT INTO card_set_white_card VALUES (100234, 15396);
INSERT INTO card_set_white_card VALUES (100234, 15399);
INSERT INTO card_set_white_card VALUES (100234, 15398);
INSERT INTO card_set_white_card VALUES (100234, 15386);
INSERT INTO card_set_white_card VALUES (100234, 15387);
INSERT INTO card_set_white_card VALUES (100234, 15384);
INSERT INTO card_set_white_card VALUES (100234, 15385);
INSERT INTO card_set_white_card VALUES (100234, 15390);
INSERT INTO card_set_white_card VALUES (100234, 15391);
INSERT INTO card_set_white_card VALUES (100234, 15388);
INSERT INTO card_set_white_card VALUES (100234, 15389);
INSERT INTO card_set_white_card VALUES (100234, 15378);
INSERT INTO card_set_white_card VALUES (100234, 15379);
INSERT INTO card_set_white_card VALUES (100234, 15376);
INSERT INTO card_set_white_card VALUES (100234, 15377);
INSERT INTO card_set_white_card VALUES (100234, 15382);
INSERT INTO card_set_white_card VALUES (100234, 15383);
INSERT INTO card_set_white_card VALUES (100234, 15380);
INSERT INTO card_set_white_card VALUES (100234, 15381);
INSERT INTO card_set_white_card VALUES (100234, 15371);
INSERT INTO card_set_white_card VALUES (100234, 15370);
INSERT INTO card_set_white_card VALUES (100234, 15369);
INSERT INTO card_set_white_card VALUES (100234, 15368);
INSERT INTO card_set_white_card VALUES (100234, 15375);
INSERT INTO card_set_white_card VALUES (100234, 15374);
INSERT INTO card_set_white_card VALUES (100234, 15373);
INSERT INTO card_set_white_card VALUES (100234, 15372);
INSERT INTO card_set_white_card VALUES (100234, 15484);
INSERT INTO card_set_white_card VALUES (100234, 15485);
INSERT INTO card_set_white_card VALUES (100234, 15486);
INSERT INTO card_set_white_card VALUES (100234, 15487);
INSERT INTO card_set_white_card VALUES (100234, 15480);
INSERT INTO card_set_white_card VALUES (100234, 15481);
INSERT INTO card_set_white_card VALUES (100234, 15482);
INSERT INTO card_set_white_card VALUES (100234, 15483);
INSERT INTO card_set_white_card VALUES (100234, 15476);
INSERT INTO card_set_white_card VALUES (100234, 15477);
INSERT INTO card_set_white_card VALUES (100234, 15478);
INSERT INTO card_set_white_card VALUES (100234, 15479);
INSERT INTO card_set_white_card VALUES (100234, 15472);
INSERT INTO card_set_white_card VALUES (100234, 15473);
INSERT INTO card_set_white_card VALUES (100234, 15474);
INSERT INTO card_set_white_card VALUES (100234, 15475);
INSERT INTO card_set_white_card VALUES (100234, 15469);
INSERT INTO card_set_white_card VALUES (100234, 15468);
INSERT INTO card_set_white_card VALUES (100234, 15471);
INSERT INTO card_set_white_card VALUES (100234, 15470);
INSERT INTO card_set_white_card VALUES (100234, 15465);
INSERT INTO card_set_white_card VALUES (100234, 15464);
INSERT INTO card_set_white_card VALUES (100234, 15467);
INSERT INTO card_set_white_card VALUES (100234, 15466);
INSERT INTO card_set_white_card VALUES (100234, 15461);
INSERT INTO card_set_white_card VALUES (100234, 15460);
INSERT INTO card_set_white_card VALUES (100234, 15463);
INSERT INTO card_set_white_card VALUES (100234, 15462);
INSERT INTO card_set_white_card VALUES (100234, 15457);
INSERT INTO card_set_white_card VALUES (100234, 15456);
INSERT INTO card_set_white_card VALUES (100234, 15459);
INSERT INTO card_set_white_card VALUES (100234, 15458);
INSERT INTO card_set_white_card VALUES (100234, 15454);
INSERT INTO card_set_white_card VALUES (100234, 15455);
INSERT INTO card_set_white_card VALUES (100234, 15452);
INSERT INTO card_set_white_card VALUES (100234, 15453);
INSERT INTO card_set_white_card VALUES (100234, 15450);
INSERT INTO card_set_white_card VALUES (100234, 15451);
INSERT INTO card_set_white_card VALUES (100234, 15448);
INSERT INTO card_set_white_card VALUES (100234, 15449);
INSERT INTO card_set_white_card VALUES (100234, 15446);
INSERT INTO card_set_white_card VALUES (100234, 15447);
INSERT INTO card_set_white_card VALUES (100234, 15444);
INSERT INTO card_set_white_card VALUES (100234, 15445);
INSERT INTO card_set_white_card VALUES (100234, 15442);
INSERT INTO card_set_white_card VALUES (100234, 15443);
INSERT INTO card_set_white_card VALUES (100234, 15440);
INSERT INTO card_set_white_card VALUES (100234, 15441);
INSERT INTO card_set_white_card VALUES (100234, 15439);
INSERT INTO card_set_white_card VALUES (100234, 15438);
INSERT INTO card_set_white_card VALUES (100234, 15437);
INSERT INTO card_set_white_card VALUES (100234, 15436);
INSERT INTO card_set_white_card VALUES (100234, 15435);
INSERT INTO card_set_white_card VALUES (100234, 15434);
INSERT INTO card_set_white_card VALUES (100234, 15433);
INSERT INTO card_set_white_card VALUES (100234, 15432);
INSERT INTO card_set_white_card VALUES (100234, 15431);
INSERT INTO card_set_white_card VALUES (100234, 15430);
INSERT INTO card_set_white_card VALUES (100234, 15429);
INSERT INTO card_set_white_card VALUES (100234, 15428);
INSERT INTO card_set_white_card VALUES (100234, 15427);
INSERT INTO card_set_white_card VALUES (100234, 15426);
INSERT INTO card_set_white_card VALUES (100234, 15425);
INSERT INTO card_set_white_card VALUES (100234, 15424);
INSERT INTO card_set_white_card VALUES (100236, 15537);
INSERT INTO card_set_white_card VALUES (100236, 15536);
INSERT INTO card_set_white_card VALUES (100236, 15539);
INSERT INTO card_set_white_card VALUES (100236, 15538);
INSERT INTO card_set_white_card VALUES (100236, 15541);
INSERT INTO card_set_white_card VALUES (100236, 15540);
INSERT INTO card_set_white_card VALUES (100236, 15543);
INSERT INTO card_set_white_card VALUES (100236, 15542);
INSERT INTO card_set_white_card VALUES (100236, 15545);
INSERT INTO card_set_white_card VALUES (100236, 15544);
INSERT INTO card_set_white_card VALUES (100236, 15547);
INSERT INTO card_set_white_card VALUES (100236, 15546);
INSERT INTO card_set_white_card VALUES (100236, 15548);
INSERT INTO card_set_white_card VALUES (100236, 15522);
INSERT INTO card_set_white_card VALUES (100236, 15523);
INSERT INTO card_set_white_card VALUES (100236, 15524);
INSERT INTO card_set_white_card VALUES (100236, 15525);
INSERT INTO card_set_white_card VALUES (100236, 15526);
INSERT INTO card_set_white_card VALUES (100236, 15527);
INSERT INTO card_set_white_card VALUES (100236, 15528);
INSERT INTO card_set_white_card VALUES (100236, 15529);
INSERT INTO card_set_white_card VALUES (100236, 15530);
INSERT INTO card_set_white_card VALUES (100236, 15531);
INSERT INTO card_set_white_card VALUES (100236, 15532);
INSERT INTO card_set_white_card VALUES (100236, 15533);
INSERT INTO card_set_white_card VALUES (100236, 15534);
INSERT INTO card_set_white_card VALUES (100236, 15535);
INSERT INTO card_set_white_card VALUES (100257, 100238);
INSERT INTO card_set_white_card VALUES (100257, 100239);
INSERT INTO card_set_white_card VALUES (100257, 100237);
INSERT INTO card_set_white_card VALUES (100257, 100256);
INSERT INTO card_set_white_card VALUES (100257, 100255);
INSERT INTO card_set_white_card VALUES (100257, 100254);
INSERT INTO card_set_white_card VALUES (100257, 100253);
INSERT INTO card_set_white_card VALUES (100257, 100252);
INSERT INTO card_set_white_card VALUES (100257, 100251);
INSERT INTO card_set_white_card VALUES (100257, 100250);
INSERT INTO card_set_white_card VALUES (100257, 100249);
INSERT INTO card_set_white_card VALUES (100257, 100248);
INSERT INTO card_set_white_card VALUES (100257, 100247);
INSERT INTO card_set_white_card VALUES (100257, 100246);
INSERT INTO card_set_white_card VALUES (100257, 100245);
INSERT INTO card_set_white_card VALUES (100257, 100244);
INSERT INTO card_set_white_card VALUES (100257, 100243);
INSERT INTO card_set_white_card VALUES (100257, 100242);
INSERT INTO card_set_white_card VALUES (100257, 100241);
INSERT INTO card_set_white_card VALUES (100257, 100240);
INSERT INTO card_set_white_card VALUES (100312, 100268);
INSERT INTO card_set_white_card VALUES (100312, 100269);
INSERT INTO card_set_white_card VALUES (100312, 100270);
INSERT INTO card_set_white_card VALUES (100312, 100271);
INSERT INTO card_set_white_card VALUES (100312, 100285);
INSERT INTO card_set_white_card VALUES (100312, 100284);
INSERT INTO card_set_white_card VALUES (100312, 100287);
INSERT INTO card_set_white_card VALUES (100312, 100286);
INSERT INTO card_set_white_card VALUES (100312, 100281);
INSERT INTO card_set_white_card VALUES (100312, 100280);
INSERT INTO card_set_white_card VALUES (100312, 100283);
INSERT INTO card_set_white_card VALUES (100312, 100282);
INSERT INTO card_set_white_card VALUES (100312, 100277);
INSERT INTO card_set_white_card VALUES (100312, 100276);
INSERT INTO card_set_white_card VALUES (100312, 100279);
INSERT INTO card_set_white_card VALUES (100312, 100278);
INSERT INTO card_set_white_card VALUES (100312, 100273);
INSERT INTO card_set_white_card VALUES (100312, 100272);
INSERT INTO card_set_white_card VALUES (100312, 100275);
INSERT INTO card_set_white_card VALUES (100312, 100274);
INSERT INTO card_set_white_card VALUES (100312, 100296);
INSERT INTO card_set_white_card VALUES (100312, 100297);
INSERT INTO card_set_white_card VALUES (100312, 100290);
INSERT INTO card_set_white_card VALUES (100312, 100291);
INSERT INTO card_set_white_card VALUES (100312, 100288);
INSERT INTO card_set_white_card VALUES (100312, 100289);
INSERT INTO card_set_white_card VALUES (100312, 100294);
INSERT INTO card_set_white_card VALUES (100312, 100295);
INSERT INTO card_set_white_card VALUES (100312, 100292);
INSERT INTO card_set_white_card VALUES (100312, 100293);
INSERT INTO card_set_white_card VALUES (100312, 100307);
INSERT INTO card_set_white_card VALUES (100312, 100306);
INSERT INTO card_set_white_card VALUES (100312, 100305);
INSERT INTO card_set_white_card VALUES (100312, 100311);
INSERT INTO card_set_white_card VALUES (100312, 100310);
INSERT INTO card_set_white_card VALUES (100312, 100309);
INSERT INTO card_set_white_card VALUES (100312, 100308);
INSERT INTO card_set_white_card VALUES (100017, 100414);
INSERT INTO card_set_white_card VALUES (100003, 100414);
INSERT INTO card_set_white_card VALUES (100415, 100328);
INSERT INTO card_set_white_card VALUES (100415, 100361);
INSERT INTO card_set_white_card VALUES (100415, 100360);
INSERT INTO card_set_white_card VALUES (100415, 100329);
INSERT INTO card_set_white_card VALUES (100415, 100330);
INSERT INTO card_set_white_card VALUES (100415, 100363);
INSERT INTO card_set_white_card VALUES (100415, 100331);
INSERT INTO card_set_white_card VALUES (100415, 100362);
INSERT INTO card_set_white_card VALUES (100415, 100332);
INSERT INTO card_set_white_card VALUES (100415, 100365);
INSERT INTO card_set_white_card VALUES (100415, 100333);
INSERT INTO card_set_white_card VALUES (100415, 100364);
INSERT INTO card_set_white_card VALUES (100415, 100367);
INSERT INTO card_set_white_card VALUES (100415, 100334);
INSERT INTO card_set_white_card VALUES (100415, 100366);
INSERT INTO card_set_white_card VALUES (100415, 100335);
INSERT INTO card_set_white_card VALUES (100415, 100320);
INSERT INTO card_set_white_card VALUES (100415, 100353);
INSERT INTO card_set_white_card VALUES (100415, 100321);
INSERT INTO card_set_white_card VALUES (100415, 100352);
INSERT INTO card_set_white_card VALUES (100415, 100322);
INSERT INTO card_set_white_card VALUES (100415, 100355);
INSERT INTO card_set_white_card VALUES (100415, 100354);
INSERT INTO card_set_white_card VALUES (100415, 100323);
INSERT INTO card_set_white_card VALUES (100415, 100357);
INSERT INTO card_set_white_card VALUES (100415, 100324);
INSERT INTO card_set_white_card VALUES (100415, 100356);
INSERT INTO card_set_white_card VALUES (100415, 100325);
INSERT INTO card_set_white_card VALUES (100415, 100326);
INSERT INTO card_set_white_card VALUES (100415, 100359);
INSERT INTO card_set_white_card VALUES (100415, 100358);
INSERT INTO card_set_white_card VALUES (100415, 100327);
INSERT INTO card_set_white_card VALUES (100415, 100376);
INSERT INTO card_set_white_card VALUES (100415, 100345);
INSERT INTO card_set_white_card VALUES (100415, 100377);
INSERT INTO card_set_white_card VALUES (100415, 100344);
INSERT INTO card_set_white_card VALUES (100415, 100378);
INSERT INTO card_set_white_card VALUES (100415, 100347);
INSERT INTO card_set_white_card VALUES (100415, 100379);
INSERT INTO card_set_white_card VALUES (100415, 100346);
INSERT INTO card_set_white_card VALUES (100415, 100380);
INSERT INTO card_set_white_card VALUES (100415, 100349);
INSERT INTO card_set_white_card VALUES (100415, 100381);
INSERT INTO card_set_white_card VALUES (100415, 100348);
INSERT INTO card_set_white_card VALUES (100415, 100382);
INSERT INTO card_set_white_card VALUES (100415, 100351);
INSERT INTO card_set_white_card VALUES (100415, 100383);
INSERT INTO card_set_white_card VALUES (100415, 100350);
INSERT INTO card_set_white_card VALUES (100415, 100368);
INSERT INTO card_set_white_card VALUES (100415, 100337);
INSERT INTO card_set_white_card VALUES (100415, 100336);
INSERT INTO card_set_white_card VALUES (100415, 100369);
INSERT INTO card_set_white_card VALUES (100415, 100370);
INSERT INTO card_set_white_card VALUES (100415, 100339);
INSERT INTO card_set_white_card VALUES (100415, 100371);
INSERT INTO card_set_white_card VALUES (100415, 100338);
INSERT INTO card_set_white_card VALUES (100415, 100372);
INSERT INTO card_set_white_card VALUES (100415, 100341);
INSERT INTO card_set_white_card VALUES (100415, 100373);
INSERT INTO card_set_white_card VALUES (100415, 100340);
INSERT INTO card_set_white_card VALUES (100415, 100374);
INSERT INTO card_set_white_card VALUES (100415, 100343);
INSERT INTO card_set_white_card VALUES (100415, 100375);
INSERT INTO card_set_white_card VALUES (100415, 100342);
INSERT INTO card_set_white_card VALUES (100415, 100315);
INSERT INTO card_set_white_card VALUES (100415, 100314);
INSERT INTO card_set_white_card VALUES (100415, 100319);
INSERT INTO card_set_white_card VALUES (100415, 100318);
INSERT INTO card_set_white_card VALUES (100415, 100317);
INSERT INTO card_set_white_card VALUES (100415, 100316);
INSERT INTO card_set_white_card VALUES (100017, 100416);
INSERT INTO card_set_white_card VALUES (100003, 100416);
INSERT INTO card_set_white_card VALUES (100003, 15180);
INSERT INTO card_set_white_card VALUES (100003, 15209);
INSERT INTO card_set_white_card VALUES (100003, 15119);
INSERT INTO card_set_white_card VALUES (100003, 15051);
INSERT INTO card_set_white_card VALUES (100003, 15007);
INSERT INTO card_set_white_card VALUES (100003, 15004);
INSERT INTO card_set_white_card VALUES (100003, 15001);
INSERT INTO card_set_white_card VALUES (100003, 15000);
INSERT INTO card_set_white_card VALUES (100003, 15012);
INSERT INTO card_set_white_card VALUES (100003, 15009);
INSERT INTO card_set_white_card VALUES (100422, 100420);
INSERT INTO card_set_white_card VALUES (100422, 100417);
INSERT INTO card_set_white_card VALUES (100422, 100419);
INSERT INTO card_set_white_card VALUES (100422, 100418);
INSERT INTO card_set_white_card VALUES (100422, 100429);
INSERT INTO card_set_white_card VALUES (100422, 100428);
INSERT INTO card_set_white_card VALUES (100422, 100431);
INSERT INTO card_set_white_card VALUES (100422, 100430);
INSERT INTO card_set_white_card VALUES (100422, 100425);
INSERT INTO card_set_white_card VALUES (100422, 100424);
INSERT INTO card_set_white_card VALUES (100422, 100423);
INSERT INTO card_set_white_card VALUES (100422, 100436);
INSERT INTO card_set_white_card VALUES (100422, 100433);
INSERT INTO card_set_white_card VALUES (100422, 100434);
INSERT INTO card_set_white_card VALUES (100422, 100435);
INSERT INTO card_set_white_card VALUES (100422, 100440);
INSERT INTO card_set_white_card VALUES (100422, 100438);
INSERT INTO card_set_white_card VALUES (100422, 100439);
INSERT INTO card_set_white_card VALUES (100234, 15601);
INSERT INTO card_set_white_card VALUES (100234, 15600);
INSERT INTO card_set_white_card VALUES (100234, 15603);
INSERT INTO card_set_white_card VALUES (100234, 15602);
INSERT INTO card_set_white_card VALUES (100234, 15598);
INSERT INTO card_set_white_card VALUES (100234, 15599);
INSERT INTO card_set_white_card VALUES (100443, 15549);
INSERT INTO card_set_white_card VALUES (100443, 15551);
INSERT INTO card_set_white_card VALUES (100443, 15550);
INSERT INTO card_set_white_card VALUES (100443, 15588);
INSERT INTO card_set_white_card VALUES (100443, 15589);
INSERT INTO card_set_white_card VALUES (100443, 15590);
INSERT INTO card_set_white_card VALUES (100443, 15591);
INSERT INTO card_set_white_card VALUES (100443, 15584);
INSERT INTO card_set_white_card VALUES (100443, 15585);
INSERT INTO card_set_white_card VALUES (100443, 15586);
INSERT INTO card_set_white_card VALUES (100443, 15587);
INSERT INTO card_set_white_card VALUES (100443, 15596);
INSERT INTO card_set_white_card VALUES (100443, 15597);
INSERT INTO card_set_white_card VALUES (100443, 15592);
INSERT INTO card_set_white_card VALUES (100443, 15593);
INSERT INTO card_set_white_card VALUES (100443, 15594);
INSERT INTO card_set_white_card VALUES (100443, 15595);
INSERT INTO card_set_white_card VALUES (100443, 15575);
INSERT INTO card_set_white_card VALUES (100443, 15574);
INSERT INTO card_set_white_card VALUES (100443, 15573);
INSERT INTO card_set_white_card VALUES (100443, 15572);
INSERT INTO card_set_white_card VALUES (100443, 15571);
INSERT INTO card_set_white_card VALUES (100443, 15570);
INSERT INTO card_set_white_card VALUES (100443, 15569);
INSERT INTO card_set_white_card VALUES (100443, 15568);
INSERT INTO card_set_white_card VALUES (100443, 15583);
INSERT INTO card_set_white_card VALUES (100443, 15582);
INSERT INTO card_set_white_card VALUES (100443, 15581);
INSERT INTO card_set_white_card VALUES (100443, 15580);
INSERT INTO card_set_white_card VALUES (100443, 15579);
INSERT INTO card_set_white_card VALUES (100443, 15578);
INSERT INTO card_set_white_card VALUES (100443, 15577);
INSERT INTO card_set_white_card VALUES (100443, 15576);
INSERT INTO card_set_white_card VALUES (100443, 15558);
INSERT INTO card_set_white_card VALUES (100443, 15559);
INSERT INTO card_set_white_card VALUES (100443, 15556);
INSERT INTO card_set_white_card VALUES (100443, 15557);
INSERT INTO card_set_white_card VALUES (100443, 15554);
INSERT INTO card_set_white_card VALUES (100443, 15555);
INSERT INTO card_set_white_card VALUES (100443, 15552);
INSERT INTO card_set_white_card VALUES (100443, 15553);
INSERT INTO card_set_white_card VALUES (100443, 15566);
INSERT INTO card_set_white_card VALUES (100443, 15567);
INSERT INTO card_set_white_card VALUES (100443, 15564);
INSERT INTO card_set_white_card VALUES (100443, 15565);
INSERT INTO card_set_white_card VALUES (100443, 15562);
INSERT INTO card_set_white_card VALUES (100443, 15563);
INSERT INTO card_set_white_card VALUES (100443, 15560);
INSERT INTO card_set_white_card VALUES (100443, 15561);
INSERT INTO card_set_white_card VALUES (100444, 15659);
INSERT INTO card_set_white_card VALUES (100444, 15658);
INSERT INTO card_set_white_card VALUES (100444, 15657);
INSERT INTO card_set_white_card VALUES (100444, 15656);
INSERT INTO card_set_white_card VALUES (100444, 15663);
INSERT INTO card_set_white_card VALUES (100444, 15662);
INSERT INTO card_set_white_card VALUES (100444, 15661);
INSERT INTO card_set_white_card VALUES (100444, 15660);
INSERT INTO card_set_white_card VALUES (100444, 15651);
INSERT INTO card_set_white_card VALUES (100444, 15650);
INSERT INTO card_set_white_card VALUES (100444, 15649);
INSERT INTO card_set_white_card VALUES (100444, 15648);
INSERT INTO card_set_white_card VALUES (100444, 15655);
INSERT INTO card_set_white_card VALUES (100444, 15654);
INSERT INTO card_set_white_card VALUES (100444, 15653);
INSERT INTO card_set_white_card VALUES (100444, 15652);
INSERT INTO card_set_white_card VALUES (100444, 15674);
INSERT INTO card_set_white_card VALUES (100444, 15675);
INSERT INTO card_set_white_card VALUES (100444, 15672);
INSERT INTO card_set_white_card VALUES (100444, 15673);
INSERT INTO card_set_white_card VALUES (100444, 15678);
INSERT INTO card_set_white_card VALUES (100444, 15679);
INSERT INTO card_set_white_card VALUES (100444, 15676);
INSERT INTO card_set_white_card VALUES (100444, 15677);
INSERT INTO card_set_white_card VALUES (100444, 15666);
INSERT INTO card_set_white_card VALUES (100444, 15667);
INSERT INTO card_set_white_card VALUES (100444, 15664);
INSERT INTO card_set_white_card VALUES (100444, 15665);
INSERT INTO card_set_white_card VALUES (100444, 15670);
INSERT INTO card_set_white_card VALUES (100444, 15671);
INSERT INTO card_set_white_card VALUES (100444, 15668);
INSERT INTO card_set_white_card VALUES (100444, 15669);
INSERT INTO card_set_white_card VALUES (100444, 15625);
INSERT INTO card_set_white_card VALUES (100444, 15624);
INSERT INTO card_set_white_card VALUES (100444, 15627);
INSERT INTO card_set_white_card VALUES (100444, 15626);
INSERT INTO card_set_white_card VALUES (100444, 15629);
INSERT INTO card_set_white_card VALUES (100444, 15628);
INSERT INTO card_set_white_card VALUES (100444, 15631);
INSERT INTO card_set_white_card VALUES (100444, 15630);
INSERT INTO card_set_white_card VALUES (100444, 15617);
INSERT INTO card_set_white_card VALUES (100444, 15616);
INSERT INTO card_set_white_card VALUES (100444, 15619);
INSERT INTO card_set_white_card VALUES (100444, 15618);
INSERT INTO card_set_white_card VALUES (100444, 15621);
INSERT INTO card_set_white_card VALUES (100444, 15620);
INSERT INTO card_set_white_card VALUES (100444, 15623);
INSERT INTO card_set_white_card VALUES (100444, 15622);
INSERT INTO card_set_white_card VALUES (100444, 15640);
INSERT INTO card_set_white_card VALUES (100444, 15641);
INSERT INTO card_set_white_card VALUES (100444, 15642);
INSERT INTO card_set_white_card VALUES (100444, 15643);
INSERT INTO card_set_white_card VALUES (100444, 15644);
INSERT INTO card_set_white_card VALUES (100444, 15645);
INSERT INTO card_set_white_card VALUES (100444, 15646);
INSERT INTO card_set_white_card VALUES (100444, 15647);
INSERT INTO card_set_white_card VALUES (100444, 15632);
INSERT INTO card_set_white_card VALUES (100444, 15633);
INSERT INTO card_set_white_card VALUES (100444, 15634);
INSERT INTO card_set_white_card VALUES (100444, 15635);
INSERT INTO card_set_white_card VALUES (100444, 15636);
INSERT INTO card_set_white_card VALUES (100444, 15637);
INSERT INTO card_set_white_card VALUES (100444, 15638);
INSERT INTO card_set_white_card VALUES (100444, 15639);
INSERT INTO card_set_white_card VALUES (100444, 15605);
INSERT INTO card_set_white_card VALUES (100444, 15604);
INSERT INTO card_set_white_card VALUES (100444, 15607);
INSERT INTO card_set_white_card VALUES (100444, 15606);
INSERT INTO card_set_white_card VALUES (100444, 15613);
INSERT INTO card_set_white_card VALUES (100444, 15612);
INSERT INTO card_set_white_card VALUES (100444, 15615);
INSERT INTO card_set_white_card VALUES (100444, 15614);
INSERT INTO card_set_white_card VALUES (100444, 15609);
INSERT INTO card_set_white_card VALUES (100444, 15608);
INSERT INTO card_set_white_card VALUES (100444, 15611);
INSERT INTO card_set_white_card VALUES (100444, 15610);
INSERT INTO card_set_white_card VALUES (100444, 15680);
INSERT INTO card_set_white_card VALUES (100445, 16930);
INSERT INTO card_set_white_card VALUES (100445, 16931);
INSERT INTO card_set_white_card VALUES (100445, 16928);
INSERT INTO card_set_white_card VALUES (100445, 16929);
INSERT INTO card_set_white_card VALUES (100445, 16934);
INSERT INTO card_set_white_card VALUES (100445, 16935);
INSERT INTO card_set_white_card VALUES (100445, 16932);
INSERT INTO card_set_white_card VALUES (100445, 16933);
INSERT INTO card_set_white_card VALUES (100445, 16938);
INSERT INTO card_set_white_card VALUES (100445, 16939);
INSERT INTO card_set_white_card VALUES (100445, 16936);
INSERT INTO card_set_white_card VALUES (100445, 16937);
INSERT INTO card_set_white_card VALUES (100445, 16942);
INSERT INTO card_set_white_card VALUES (100445, 16943);
INSERT INTO card_set_white_card VALUES (100445, 16940);
INSERT INTO card_set_white_card VALUES (100445, 16941);
INSERT INTO card_set_white_card VALUES (100445, 16947);
INSERT INTO card_set_white_card VALUES (100445, 16946);
INSERT INTO card_set_white_card VALUES (100445, 16945);
INSERT INTO card_set_white_card VALUES (100445, 16944);
INSERT INTO card_set_white_card VALUES (100445, 16951);
INSERT INTO card_set_white_card VALUES (100445, 16950);
INSERT INTO card_set_white_card VALUES (100445, 16949);
INSERT INTO card_set_white_card VALUES (100445, 16948);
INSERT INTO card_set_white_card VALUES (100445, 16955);
INSERT INTO card_set_white_card VALUES (100445, 16954);
INSERT INTO card_set_white_card VALUES (100445, 16953);
INSERT INTO card_set_white_card VALUES (100445, 16952);
INSERT INTO card_set_white_card VALUES (100445, 16959);
INSERT INTO card_set_white_card VALUES (100445, 16958);
INSERT INTO card_set_white_card VALUES (100445, 16957);
INSERT INTO card_set_white_card VALUES (100445, 16956);
INSERT INTO card_set_white_card VALUES (100445, 16896);
INSERT INTO card_set_white_card VALUES (100445, 16897);
INSERT INTO card_set_white_card VALUES (100445, 16898);
INSERT INTO card_set_white_card VALUES (100445, 16899);
INSERT INTO card_set_white_card VALUES (100445, 16900);
INSERT INTO card_set_white_card VALUES (100445, 16901);
INSERT INTO card_set_white_card VALUES (100445, 16902);
INSERT INTO card_set_white_card VALUES (100445, 16903);
INSERT INTO card_set_white_card VALUES (100445, 16904);
INSERT INTO card_set_white_card VALUES (100445, 16905);
INSERT INTO card_set_white_card VALUES (100445, 16906);
INSERT INTO card_set_white_card VALUES (100445, 16907);
INSERT INTO card_set_white_card VALUES (100445, 16908);
INSERT INTO card_set_white_card VALUES (100445, 16909);
INSERT INTO card_set_white_card VALUES (100445, 16910);
INSERT INTO card_set_white_card VALUES (100445, 16911);
INSERT INTO card_set_white_card VALUES (100445, 16913);
INSERT INTO card_set_white_card VALUES (100445, 16912);
INSERT INTO card_set_white_card VALUES (100445, 16915);
INSERT INTO card_set_white_card VALUES (100445, 16914);
INSERT INTO card_set_white_card VALUES (100445, 16917);
INSERT INTO card_set_white_card VALUES (100445, 16916);
INSERT INTO card_set_white_card VALUES (100445, 16919);
INSERT INTO card_set_white_card VALUES (100445, 16918);
INSERT INTO card_set_white_card VALUES (100445, 16921);
INSERT INTO card_set_white_card VALUES (100445, 16920);
INSERT INTO card_set_white_card VALUES (100445, 16923);
INSERT INTO card_set_white_card VALUES (100445, 16922);
INSERT INTO card_set_white_card VALUES (100445, 16925);
INSERT INTO card_set_white_card VALUES (100445, 16924);
INSERT INTO card_set_white_card VALUES (100445, 16927);
INSERT INTO card_set_white_card VALUES (100445, 16926);
INSERT INTO card_set_white_card VALUES (100445, 16964);
INSERT INTO card_set_white_card VALUES (100445, 16965);
INSERT INTO card_set_white_card VALUES (100445, 16966);
INSERT INTO card_set_white_card VALUES (100445, 16967);
INSERT INTO card_set_white_card VALUES (100445, 16960);
INSERT INTO card_set_white_card VALUES (100445, 16961);
INSERT INTO card_set_white_card VALUES (100445, 16962);
INSERT INTO card_set_white_card VALUES (100445, 16963);
INSERT INTO card_set_white_card VALUES (100445, 16972);
INSERT INTO card_set_white_card VALUES (100445, 16973);
INSERT INTO card_set_white_card VALUES (100445, 16974);
INSERT INTO card_set_white_card VALUES (100445, 16975);
INSERT INTO card_set_white_card VALUES (100445, 16968);
INSERT INTO card_set_white_card VALUES (100445, 16969);
INSERT INTO card_set_white_card VALUES (100445, 16970);
INSERT INTO card_set_white_card VALUES (100445, 16971);
INSERT INTO card_set_white_card VALUES (100445, 16980);
INSERT INTO card_set_white_card VALUES (100445, 16977);
INSERT INTO card_set_white_card VALUES (100445, 16976);
INSERT INTO card_set_white_card VALUES (100445, 16979);
INSERT INTO card_set_white_card VALUES (100445, 16978);
INSERT INTO card_set_white_card VALUES (100445, 16798);
INSERT INTO card_set_white_card VALUES (100445, 16799);
INSERT INTO card_set_white_card VALUES (100445, 16796);
INSERT INTO card_set_white_card VALUES (100445, 16797);
INSERT INTO card_set_white_card VALUES (100445, 16794);
INSERT INTO card_set_white_card VALUES (100445, 16795);
INSERT INTO card_set_white_card VALUES (100445, 16792);
INSERT INTO card_set_white_card VALUES (100445, 16793);
INSERT INTO card_set_white_card VALUES (100445, 16790);
INSERT INTO card_set_white_card VALUES (100445, 16791);
INSERT INTO card_set_white_card VALUES (100445, 16788);
INSERT INTO card_set_white_card VALUES (100445, 16789);
INSERT INTO card_set_white_card VALUES (100445, 16786);
INSERT INTO card_set_white_card VALUES (100445, 16787);
INSERT INTO card_set_white_card VALUES (100445, 16784);
INSERT INTO card_set_white_card VALUES (100445, 16785);
INSERT INTO card_set_white_card VALUES (100445, 16783);
INSERT INTO card_set_white_card VALUES (100445, 16782);
INSERT INTO card_set_white_card VALUES (100445, 16781);
INSERT INTO card_set_white_card VALUES (100445, 16780);
INSERT INTO card_set_white_card VALUES (100445, 16779);
INSERT INTO card_set_white_card VALUES (100445, 16778);
INSERT INTO card_set_white_card VALUES (100445, 16777);
INSERT INTO card_set_white_card VALUES (100445, 16776);
INSERT INTO card_set_white_card VALUES (100445, 16775);
INSERT INTO card_set_white_card VALUES (100445, 16774);
INSERT INTO card_set_white_card VALUES (100445, 16773);
INSERT INTO card_set_white_card VALUES (100445, 16772);
INSERT INTO card_set_white_card VALUES (100445, 16771);
INSERT INTO card_set_white_card VALUES (100445, 16770);
INSERT INTO card_set_white_card VALUES (100445, 16769);
INSERT INTO card_set_white_card VALUES (100445, 16768);
INSERT INTO card_set_white_card VALUES (100445, 16828);
INSERT INTO card_set_white_card VALUES (100445, 16829);
INSERT INTO card_set_white_card VALUES (100445, 16830);
INSERT INTO card_set_white_card VALUES (100445, 16831);
INSERT INTO card_set_white_card VALUES (100445, 16824);
INSERT INTO card_set_white_card VALUES (100445, 16825);
INSERT INTO card_set_white_card VALUES (100445, 16826);
INSERT INTO card_set_white_card VALUES (100445, 16827);
INSERT INTO card_set_white_card VALUES (100445, 16820);
INSERT INTO card_set_white_card VALUES (100445, 16821);
INSERT INTO card_set_white_card VALUES (100445, 16822);
INSERT INTO card_set_white_card VALUES (100445, 16823);
INSERT INTO card_set_white_card VALUES (100445, 16816);
INSERT INTO card_set_white_card VALUES (100445, 16817);
INSERT INTO card_set_white_card VALUES (100445, 16818);
INSERT INTO card_set_white_card VALUES (100445, 16819);
INSERT INTO card_set_white_card VALUES (100445, 16813);
INSERT INTO card_set_white_card VALUES (100445, 16812);
INSERT INTO card_set_white_card VALUES (100445, 16815);
INSERT INTO card_set_white_card VALUES (100445, 16814);
INSERT INTO card_set_white_card VALUES (100445, 16809);
INSERT INTO card_set_white_card VALUES (100445, 16808);
INSERT INTO card_set_white_card VALUES (100445, 16811);
INSERT INTO card_set_white_card VALUES (100445, 16810);
INSERT INTO card_set_white_card VALUES (100445, 16805);
INSERT INTO card_set_white_card VALUES (100445, 16804);
INSERT INTO card_set_white_card VALUES (100445, 16807);
INSERT INTO card_set_white_card VALUES (100445, 16806);
INSERT INTO card_set_white_card VALUES (100445, 16801);
INSERT INTO card_set_white_card VALUES (100445, 16800);
INSERT INTO card_set_white_card VALUES (100445, 16803);
INSERT INTO card_set_white_card VALUES (100445, 16802);
INSERT INTO card_set_white_card VALUES (100445, 16858);
INSERT INTO card_set_white_card VALUES (100445, 16859);
INSERT INTO card_set_white_card VALUES (100445, 16856);
INSERT INTO card_set_white_card VALUES (100445, 16857);
INSERT INTO card_set_white_card VALUES (100445, 16862);
INSERT INTO card_set_white_card VALUES (100445, 16863);
INSERT INTO card_set_white_card VALUES (100445, 16860);
INSERT INTO card_set_white_card VALUES (100445, 16861);
INSERT INTO card_set_white_card VALUES (100445, 16850);
INSERT INTO card_set_white_card VALUES (100445, 16851);
INSERT INTO card_set_white_card VALUES (100445, 16848);
INSERT INTO card_set_white_card VALUES (100445, 16849);
INSERT INTO card_set_white_card VALUES (100445, 10629);
INSERT INTO card_set_white_card VALUES (100445, 16854);
INSERT INTO card_set_white_card VALUES (100445, 16855);
INSERT INTO card_set_white_card VALUES (100445, 16852);
INSERT INTO card_set_white_card VALUES (100445, 10630);
INSERT INTO card_set_white_card VALUES (100445, 16853);
INSERT INTO card_set_white_card VALUES (100445, 16843);
INSERT INTO card_set_white_card VALUES (100445, 16842);
INSERT INTO card_set_white_card VALUES (100445, 16841);
INSERT INTO card_set_white_card VALUES (100445, 16840);
INSERT INTO card_set_white_card VALUES (100445, 16847);
INSERT INTO card_set_white_card VALUES (100445, 16846);
INSERT INTO card_set_white_card VALUES (100445, 16845);
INSERT INTO card_set_white_card VALUES (100445, 16844);
INSERT INTO card_set_white_card VALUES (100445, 16835);
INSERT INTO card_set_white_card VALUES (100445, 16834);
INSERT INTO card_set_white_card VALUES (100445, 16833);
INSERT INTO card_set_white_card VALUES (100445, 16832);
INSERT INTO card_set_white_card VALUES (100445, 16839);
INSERT INTO card_set_white_card VALUES (100445, 16838);
INSERT INTO card_set_white_card VALUES (100445, 16837);
INSERT INTO card_set_white_card VALUES (100445, 16836);
INSERT INTO card_set_white_card VALUES (100445, 16888);
INSERT INTO card_set_white_card VALUES (100445, 16889);
INSERT INTO card_set_white_card VALUES (100445, 16890);
INSERT INTO card_set_white_card VALUES (100445, 16891);
INSERT INTO card_set_white_card VALUES (100445, 16892);
INSERT INTO card_set_white_card VALUES (100445, 16893);
INSERT INTO card_set_white_card VALUES (100445, 16894);
INSERT INTO card_set_white_card VALUES (100445, 16895);
INSERT INTO card_set_white_card VALUES (100445, 16880);
INSERT INTO card_set_white_card VALUES (100445, 16881);
INSERT INTO card_set_white_card VALUES (100445, 16882);
INSERT INTO card_set_white_card VALUES (100445, 16883);
INSERT INTO card_set_white_card VALUES (100445, 16884);
INSERT INTO card_set_white_card VALUES (100445, 16885);
INSERT INTO card_set_white_card VALUES (100445, 16886);
INSERT INTO card_set_white_card VALUES (100445, 16887);
INSERT INTO card_set_white_card VALUES (100445, 16873);
INSERT INTO card_set_white_card VALUES (100445, 16872);
INSERT INTO card_set_white_card VALUES (100445, 16875);
INSERT INTO card_set_white_card VALUES (100445, 16874);
INSERT INTO card_set_white_card VALUES (100445, 16877);
INSERT INTO card_set_white_card VALUES (100445, 16876);
INSERT INTO card_set_white_card VALUES (100445, 16879);
INSERT INTO card_set_white_card VALUES (100445, 16878);
INSERT INTO card_set_white_card VALUES (100445, 16865);
INSERT INTO card_set_white_card VALUES (100445, 16864);
INSERT INTO card_set_white_card VALUES (100445, 16867);
INSERT INTO card_set_white_card VALUES (100445, 16866);
INSERT INTO card_set_white_card VALUES (100445, 16869);
INSERT INTO card_set_white_card VALUES (100445, 16868);
INSERT INTO card_set_white_card VALUES (100445, 16871);
INSERT INTO card_set_white_card VALUES (100445, 16870);
INSERT INTO card_set_white_card VALUES (100445, 10586);
INSERT INTO card_set_white_card VALUES (100445, 16723);
INSERT INTO card_set_white_card VALUES (100445, 16722);
INSERT INTO card_set_white_card VALUES (100445, 16721);
INSERT INTO card_set_white_card VALUES (100445, 16720);
INSERT INTO card_set_white_card VALUES (100445, 16727);
INSERT INTO card_set_white_card VALUES (100445, 16726);
INSERT INTO card_set_white_card VALUES (100445, 16725);
INSERT INTO card_set_white_card VALUES (100445, 16724);
INSERT INTO card_set_white_card VALUES (100445, 16731);
INSERT INTO card_set_white_card VALUES (100445, 16730);
INSERT INTO card_set_white_card VALUES (100445, 16729);
INSERT INTO card_set_white_card VALUES (100445, 16728);
INSERT INTO card_set_white_card VALUES (100445, 16735);
INSERT INTO card_set_white_card VALUES (100445, 16734);
INSERT INTO card_set_white_card VALUES (100445, 16733);
INSERT INTO card_set_white_card VALUES (100445, 16732);
INSERT INTO card_set_white_card VALUES (100445, 16718);
INSERT INTO card_set_white_card VALUES (100445, 16719);
INSERT INTO card_set_white_card VALUES (100445, 16753);
INSERT INTO card_set_white_card VALUES (100445, 16752);
INSERT INTO card_set_white_card VALUES (100445, 16755);
INSERT INTO card_set_white_card VALUES (100445, 16754);
INSERT INTO card_set_white_card VALUES (100445, 16757);
INSERT INTO card_set_white_card VALUES (100445, 16756);
INSERT INTO card_set_white_card VALUES (100445, 16759);
INSERT INTO card_set_white_card VALUES (100445, 16758);
INSERT INTO card_set_white_card VALUES (100445, 16761);
INSERT INTO card_set_white_card VALUES (100445, 16760);
INSERT INTO card_set_white_card VALUES (100445, 16763);
INSERT INTO card_set_white_card VALUES (100445, 16762);
INSERT INTO card_set_white_card VALUES (100445, 16765);
INSERT INTO card_set_white_card VALUES (100445, 16764);
INSERT INTO card_set_white_card VALUES (100445, 16767);
INSERT INTO card_set_white_card VALUES (100445, 10540);
INSERT INTO card_set_white_card VALUES (100445, 16766);
INSERT INTO card_set_white_card VALUES (100445, 16736);
INSERT INTO card_set_white_card VALUES (100445, 16737);
INSERT INTO card_set_white_card VALUES (100445, 16738);
INSERT INTO card_set_white_card VALUES (100445, 16739);
INSERT INTO card_set_white_card VALUES (100445, 16740);
INSERT INTO card_set_white_card VALUES (100445, 16741);
INSERT INTO card_set_white_card VALUES (100445, 16742);
INSERT INTO card_set_white_card VALUES (100445, 16743);
INSERT INTO card_set_white_card VALUES (100445, 16744);
INSERT INTO card_set_white_card VALUES (100445, 16745);
INSERT INTO card_set_white_card VALUES (100445, 16746);
INSERT INTO card_set_white_card VALUES (100445, 16747);
INSERT INTO card_set_white_card VALUES (100445, 16748);
INSERT INTO card_set_white_card VALUES (100445, 16749);
INSERT INTO card_set_white_card VALUES (100445, 16750);
INSERT INTO card_set_white_card VALUES (100445, 16751);
INSERT INTO card_set_white_card VALUES (100446, 16998);
INSERT INTO card_set_white_card VALUES (100446, 16999);
INSERT INTO card_set_white_card VALUES (100446, 16996);
INSERT INTO card_set_white_card VALUES (100446, 16997);
INSERT INTO card_set_white_card VALUES (100446, 16994);
INSERT INTO card_set_white_card VALUES (100446, 16995);
INSERT INTO card_set_white_card VALUES (100446, 16992);
INSERT INTO card_set_white_card VALUES (100446, 16993);
INSERT INTO card_set_white_card VALUES (100446, 17006);
INSERT INTO card_set_white_card VALUES (100446, 17007);
INSERT INTO card_set_white_card VALUES (100446, 17004);
INSERT INTO card_set_white_card VALUES (100446, 17005);
INSERT INTO card_set_white_card VALUES (100446, 17002);
INSERT INTO card_set_white_card VALUES (100446, 17003);
INSERT INTO card_set_white_card VALUES (100446, 17000);
INSERT INTO card_set_white_card VALUES (100446, 17001);
INSERT INTO card_set_white_card VALUES (100446, 17015);
INSERT INTO card_set_white_card VALUES (100446, 17014);
INSERT INTO card_set_white_card VALUES (100446, 17013);
INSERT INTO card_set_white_card VALUES (100446, 17012);
INSERT INTO card_set_white_card VALUES (100446, 17011);
INSERT INTO card_set_white_card VALUES (100446, 17010);
INSERT INTO card_set_white_card VALUES (100446, 17009);
INSERT INTO card_set_white_card VALUES (100446, 17008);
INSERT INTO card_set_white_card VALUES (100446, 17021);
INSERT INTO card_set_white_card VALUES (100446, 17020);
INSERT INTO card_set_white_card VALUES (100446, 17019);
INSERT INTO card_set_white_card VALUES (100446, 17018);
INSERT INTO card_set_white_card VALUES (100446, 17017);
INSERT INTO card_set_white_card VALUES (100446, 17016);
INSERT INTO card_set_white_card VALUES (100446, 16981);
INSERT INTO card_set_white_card VALUES (100446, 16983);
INSERT INTO card_set_white_card VALUES (100446, 16982);
INSERT INTO card_set_white_card VALUES (100446, 16989);
INSERT INTO card_set_white_card VALUES (100446, 16988);
INSERT INTO card_set_white_card VALUES (100446, 16991);
INSERT INTO card_set_white_card VALUES (100446, 16990);
INSERT INTO card_set_white_card VALUES (100446, 16985);
INSERT INTO card_set_white_card VALUES (100446, 16984);
INSERT INTO card_set_white_card VALUES (100446, 16987);
INSERT INTO card_set_white_card VALUES (100446, 16986);
INSERT INTO card_set_white_card VALUES (100447, 4534);
INSERT INTO card_set_white_card VALUES (100447, 17082);
INSERT INTO card_set_white_card VALUES (100447, 17083);
INSERT INTO card_set_white_card VALUES (100447, 17080);
INSERT INTO card_set_white_card VALUES (100447, 17081);
INSERT INTO card_set_white_card VALUES (100447, 17086);
INSERT INTO card_set_white_card VALUES (100447, 17087);
INSERT INTO card_set_white_card VALUES (100447, 17084);
INSERT INTO card_set_white_card VALUES (100447, 17085);
INSERT INTO card_set_white_card VALUES (100447, 17075);
INSERT INTO card_set_white_card VALUES (100447, 17078);
INSERT INTO card_set_white_card VALUES (100447, 17079);
INSERT INTO card_set_white_card VALUES (100447, 17076);
INSERT INTO card_set_white_card VALUES (100447, 17077);
INSERT INTO card_set_white_card VALUES (100447, 17135);
INSERT INTO card_set_white_card VALUES (100447, 17134);
INSERT INTO card_set_white_card VALUES (100447, 17133);
INSERT INTO card_set_white_card VALUES (100447, 17132);
INSERT INTO card_set_white_card VALUES (100447, 17131);
INSERT INTO card_set_white_card VALUES (100447, 17130);
INSERT INTO card_set_white_card VALUES (100447, 17129);
INSERT INTO card_set_white_card VALUES (100447, 17128);
INSERT INTO card_set_white_card VALUES (100447, 17127);
INSERT INTO card_set_white_card VALUES (100447, 17126);
INSERT INTO card_set_white_card VALUES (100447, 17125);
INSERT INTO card_set_white_card VALUES (100447, 17124);
INSERT INTO card_set_white_card VALUES (100447, 17123);
INSERT INTO card_set_white_card VALUES (100447, 17122);
INSERT INTO card_set_white_card VALUES (100447, 17121);
INSERT INTO card_set_white_card VALUES (100447, 17120);
INSERT INTO card_set_white_card VALUES (100447, 17101);
INSERT INTO card_set_white_card VALUES (100447, 17100);
INSERT INTO card_set_white_card VALUES (100447, 17103);
INSERT INTO card_set_white_card VALUES (100447, 17102);
INSERT INTO card_set_white_card VALUES (100447, 17097);
INSERT INTO card_set_white_card VALUES (100447, 17096);
INSERT INTO card_set_white_card VALUES (100447, 17099);
INSERT INTO card_set_white_card VALUES (100447, 17098);
INSERT INTO card_set_white_card VALUES (100447, 17093);
INSERT INTO card_set_white_card VALUES (100447, 17092);
INSERT INTO card_set_white_card VALUES (100447, 17095);
INSERT INTO card_set_white_card VALUES (100447, 17094);
INSERT INTO card_set_white_card VALUES (100447, 17089);
INSERT INTO card_set_white_card VALUES (100447, 17088);
INSERT INTO card_set_white_card VALUES (100447, 17091);
INSERT INTO card_set_white_card VALUES (100447, 17090);
INSERT INTO card_set_white_card VALUES (100447, 17116);
INSERT INTO card_set_white_card VALUES (100447, 17117);
INSERT INTO card_set_white_card VALUES (100447, 17118);
INSERT INTO card_set_white_card VALUES (100447, 17119);
INSERT INTO card_set_white_card VALUES (100447, 17112);
INSERT INTO card_set_white_card VALUES (100447, 17113);
INSERT INTO card_set_white_card VALUES (100447, 17114);
INSERT INTO card_set_white_card VALUES (100447, 17115);
INSERT INTO card_set_white_card VALUES (100447, 17108);
INSERT INTO card_set_white_card VALUES (100447, 17109);
INSERT INTO card_set_white_card VALUES (100447, 17110);
INSERT INTO card_set_white_card VALUES (100447, 17111);
INSERT INTO card_set_white_card VALUES (100447, 17104);
INSERT INTO card_set_white_card VALUES (100447, 17105);
INSERT INTO card_set_white_card VALUES (100447, 17106);
INSERT INTO card_set_white_card VALUES (100447, 17107);
INSERT INTO card_set_white_card VALUES (100448, 18453);
INSERT INTO card_set_white_card VALUES (100448, 18452);
INSERT INTO card_set_white_card VALUES (100448, 18455);
INSERT INTO card_set_white_card VALUES (100448, 18454);
INSERT INTO card_set_white_card VALUES (100448, 18449);
INSERT INTO card_set_white_card VALUES (100448, 18448);
INSERT INTO card_set_white_card VALUES (100448, 18451);
INSERT INTO card_set_white_card VALUES (100448, 18450);
INSERT INTO card_set_white_card VALUES (100448, 18461);
INSERT INTO card_set_white_card VALUES (100448, 18460);
INSERT INTO card_set_white_card VALUES (100448, 18463);
INSERT INTO card_set_white_card VALUES (100448, 18462);
INSERT INTO card_set_white_card VALUES (100448, 18457);
INSERT INTO card_set_white_card VALUES (100448, 18456);
INSERT INTO card_set_white_card VALUES (100448, 18459);
INSERT INTO card_set_white_card VALUES (100448, 18458);
INSERT INTO card_set_white_card VALUES (100448, 18436);
INSERT INTO card_set_white_card VALUES (100448, 18437);
INSERT INTO card_set_white_card VALUES (100448, 18438);
INSERT INTO card_set_white_card VALUES (100448, 18439);
INSERT INTO card_set_white_card VALUES (100448, 18432);
INSERT INTO card_set_white_card VALUES (100448, 18433);
INSERT INTO card_set_white_card VALUES (100448, 18434);
INSERT INTO card_set_white_card VALUES (100448, 18435);
INSERT INTO card_set_white_card VALUES (100448, 18444);
INSERT INTO card_set_white_card VALUES (100448, 18174);
INSERT INTO card_set_white_card VALUES (100448, 18445);
INSERT INTO card_set_white_card VALUES (100448, 18175);
INSERT INTO card_set_white_card VALUES (100448, 18446);
INSERT INTO card_set_white_card VALUES (100448, 18172);
INSERT INTO card_set_white_card VALUES (100448, 18447);
INSERT INTO card_set_white_card VALUES (100448, 18173);
INSERT INTO card_set_white_card VALUES (100448, 18440);
INSERT INTO card_set_white_card VALUES (100448, 18170);
INSERT INTO card_set_white_card VALUES (100448, 18441);
INSERT INTO card_set_white_card VALUES (100448, 18171);
INSERT INTO card_set_white_card VALUES (100448, 18442);
INSERT INTO card_set_white_card VALUES (100448, 18168);
INSERT INTO card_set_white_card VALUES (100448, 18443);
INSERT INTO card_set_white_card VALUES (100448, 18169);
INSERT INTO card_set_white_card VALUES (100448, 18487);
INSERT INTO card_set_white_card VALUES (100448, 18486);
INSERT INTO card_set_white_card VALUES (100448, 18485);
INSERT INTO card_set_white_card VALUES (100448, 18484);
INSERT INTO card_set_white_card VALUES (100448, 18483);
INSERT INTO card_set_white_card VALUES (100448, 18482);
INSERT INTO card_set_white_card VALUES (100448, 18481);
INSERT INTO card_set_white_card VALUES (100448, 18480);
INSERT INTO card_set_white_card VALUES (100448, 18495);
INSERT INTO card_set_white_card VALUES (100448, 18494);
INSERT INTO card_set_white_card VALUES (100448, 18493);
INSERT INTO card_set_white_card VALUES (100448, 18492);
INSERT INTO card_set_white_card VALUES (100448, 18491);
INSERT INTO card_set_white_card VALUES (100448, 18490);
INSERT INTO card_set_white_card VALUES (100448, 18489);
INSERT INTO card_set_white_card VALUES (100448, 18488);
INSERT INTO card_set_white_card VALUES (100448, 18470);
INSERT INTO card_set_white_card VALUES (100448, 18471);
INSERT INTO card_set_white_card VALUES (100448, 18468);
INSERT INTO card_set_white_card VALUES (100448, 18469);
INSERT INTO card_set_white_card VALUES (100448, 18466);
INSERT INTO card_set_white_card VALUES (100448, 18467);
INSERT INTO card_set_white_card VALUES (100448, 18464);
INSERT INTO card_set_white_card VALUES (100448, 18465);
INSERT INTO card_set_white_card VALUES (100448, 18478);
INSERT INTO card_set_white_card VALUES (100448, 18479);
INSERT INTO card_set_white_card VALUES (100448, 18476);
INSERT INTO card_set_white_card VALUES (100448, 18477);
INSERT INTO card_set_white_card VALUES (100448, 18474);
INSERT INTO card_set_white_card VALUES (100448, 18475);
INSERT INTO card_set_white_card VALUES (100448, 18472);
INSERT INTO card_set_white_card VALUES (100448, 18473);
INSERT INTO card_set_white_card VALUES (100448, 18496);
INSERT INTO card_set_white_card VALUES (100448, 18497);
INSERT INTO card_set_white_card VALUES (100448, 18498);
INSERT INTO card_set_white_card VALUES (100448, 18499);
INSERT INTO card_set_white_card VALUES (100448, 18500);
INSERT INTO card_set_white_card VALUES (100448, 18501);
INSERT INTO card_set_white_card VALUES (100448, 18502);
INSERT INTO card_set_white_card VALUES (100448, 18503);
INSERT INTO card_set_white_card VALUES (100448, 18504);
INSERT INTO card_set_white_card VALUES (100448, 18505);
INSERT INTO card_set_white_card VALUES (100448, 18506);
INSERT INTO card_set_white_card VALUES (100448, 18507);
INSERT INTO card_set_white_card VALUES (100448, 18420);
INSERT INTO card_set_white_card VALUES (100448, 18421);
INSERT INTO card_set_white_card VALUES (100448, 18422);
INSERT INTO card_set_white_card VALUES (100448, 18423);
INSERT INTO card_set_white_card VALUES (100448, 18416);
INSERT INTO card_set_white_card VALUES (100448, 18417);
INSERT INTO card_set_white_card VALUES (100448, 18418);
INSERT INTO card_set_white_card VALUES (100448, 18419);
INSERT INTO card_set_white_card VALUES (100448, 18428);
INSERT INTO card_set_white_card VALUES (100448, 18429);
INSERT INTO card_set_white_card VALUES (100448, 18430);
INSERT INTO card_set_white_card VALUES (100448, 18431);
INSERT INTO card_set_white_card VALUES (100448, 18424);
INSERT INTO card_set_white_card VALUES (100448, 18425);
INSERT INTO card_set_white_card VALUES (100448, 18426);
INSERT INTO card_set_white_card VALUES (100448, 18427);
INSERT INTO card_set_white_card VALUES (100448, 18405);
INSERT INTO card_set_white_card VALUES (100448, 18404);
INSERT INTO card_set_white_card VALUES (100448, 18407);
INSERT INTO card_set_white_card VALUES (100448, 18406);
INSERT INTO card_set_white_card VALUES (100448, 18401);
INSERT INTO card_set_white_card VALUES (100448, 18400);
INSERT INTO card_set_white_card VALUES (100448, 18403);
INSERT INTO card_set_white_card VALUES (100448, 18402);
INSERT INTO card_set_white_card VALUES (100448, 18413);
INSERT INTO card_set_white_card VALUES (100448, 18412);
INSERT INTO card_set_white_card VALUES (100448, 18415);
INSERT INTO card_set_white_card VALUES (100448, 18414);
INSERT INTO card_set_white_card VALUES (100448, 18409);
INSERT INTO card_set_white_card VALUES (100448, 18408);
INSERT INTO card_set_white_card VALUES (100448, 18411);
INSERT INTO card_set_white_card VALUES (100448, 18410);
INSERT INTO card_set_white_card VALUES (100448, 18390);
INSERT INTO card_set_white_card VALUES (100448, 18391);
INSERT INTO card_set_white_card VALUES (100448, 18388);
INSERT INTO card_set_white_card VALUES (100448, 18389);
INSERT INTO card_set_white_card VALUES (100448, 18386);
INSERT INTO card_set_white_card VALUES (100448, 18387);
INSERT INTO card_set_white_card VALUES (100448, 18384);
INSERT INTO card_set_white_card VALUES (100448, 18385);
INSERT INTO card_set_white_card VALUES (100448, 18398);
INSERT INTO card_set_white_card VALUES (100448, 18399);
INSERT INTO card_set_white_card VALUES (100448, 18396);
INSERT INTO card_set_white_card VALUES (100448, 18397);
INSERT INTO card_set_white_card VALUES (100448, 18394);
INSERT INTO card_set_white_card VALUES (100448, 18395);
INSERT INTO card_set_white_card VALUES (100448, 18392);
INSERT INTO card_set_white_card VALUES (100448, 18393);
INSERT INTO card_set_white_card VALUES (100448, 18375);
INSERT INTO card_set_white_card VALUES (100448, 18374);
INSERT INTO card_set_white_card VALUES (100448, 18373);
INSERT INTO card_set_white_card VALUES (100448, 18372);
INSERT INTO card_set_white_card VALUES (100448, 18371);
INSERT INTO card_set_white_card VALUES (100448, 18370);
INSERT INTO card_set_white_card VALUES (100448, 18369);
INSERT INTO card_set_white_card VALUES (100448, 18368);
INSERT INTO card_set_white_card VALUES (100448, 18383);
INSERT INTO card_set_white_card VALUES (100448, 18382);
INSERT INTO card_set_white_card VALUES (100448, 18381);
INSERT INTO card_set_white_card VALUES (100448, 18380);
INSERT INTO card_set_white_card VALUES (100448, 18379);
INSERT INTO card_set_white_card VALUES (100448, 18378);
INSERT INTO card_set_white_card VALUES (100448, 18377);
INSERT INTO card_set_white_card VALUES (100448, 18376);
INSERT INTO card_set_white_card VALUES (100448, 18352);
INSERT INTO card_set_white_card VALUES (100448, 18353);
INSERT INTO card_set_white_card VALUES (100448, 18354);
INSERT INTO card_set_white_card VALUES (100448, 18355);
INSERT INTO card_set_white_card VALUES (100448, 18356);
INSERT INTO card_set_white_card VALUES (100448, 18357);
INSERT INTO card_set_white_card VALUES (100448, 18358);
INSERT INTO card_set_white_card VALUES (100448, 18359);
INSERT INTO card_set_white_card VALUES (100448, 18360);
INSERT INTO card_set_white_card VALUES (100448, 18361);
INSERT INTO card_set_white_card VALUES (100448, 18362);
INSERT INTO card_set_white_card VALUES (100448, 18363);
INSERT INTO card_set_white_card VALUES (100448, 18364);
INSERT INTO card_set_white_card VALUES (100448, 18365);
INSERT INTO card_set_white_card VALUES (100448, 18366);
INSERT INTO card_set_white_card VALUES (100448, 18367);
INSERT INTO card_set_white_card VALUES (100448, 18337);
INSERT INTO card_set_white_card VALUES (100448, 18336);
INSERT INTO card_set_white_card VALUES (100448, 18339);
INSERT INTO card_set_white_card VALUES (100448, 18338);
INSERT INTO card_set_white_card VALUES (100448, 18341);
INSERT INTO card_set_white_card VALUES (100448, 18340);
INSERT INTO card_set_white_card VALUES (100448, 18343);
INSERT INTO card_set_white_card VALUES (100448, 18342);
INSERT INTO card_set_white_card VALUES (100448, 18345);
INSERT INTO card_set_white_card VALUES (100448, 18344);
INSERT INTO card_set_white_card VALUES (100448, 18347);
INSERT INTO card_set_white_card VALUES (100448, 18346);
INSERT INTO card_set_white_card VALUES (100448, 18349);
INSERT INTO card_set_white_card VALUES (100448, 18348);
INSERT INTO card_set_white_card VALUES (100448, 18351);
INSERT INTO card_set_white_card VALUES (100448, 18350);
INSERT INTO card_set_white_card VALUES (100448, 18322);
INSERT INTO card_set_white_card VALUES (100448, 18323);
INSERT INTO card_set_white_card VALUES (100448, 18320);
INSERT INTO card_set_white_card VALUES (100448, 18321);
INSERT INTO card_set_white_card VALUES (100448, 18326);
INSERT INTO card_set_white_card VALUES (100448, 18327);
INSERT INTO card_set_white_card VALUES (100448, 18324);
INSERT INTO card_set_white_card VALUES (100448, 18325);
INSERT INTO card_set_white_card VALUES (100448, 18330);
INSERT INTO card_set_white_card VALUES (100448, 18331);
INSERT INTO card_set_white_card VALUES (100448, 18328);
INSERT INTO card_set_white_card VALUES (100448, 18329);
INSERT INTO card_set_white_card VALUES (100448, 18334);
INSERT INTO card_set_white_card VALUES (100448, 18335);
INSERT INTO card_set_white_card VALUES (100448, 18332);
INSERT INTO card_set_white_card VALUES (100448, 18333);
INSERT INTO card_set_white_card VALUES (100448, 18307);
INSERT INTO card_set_white_card VALUES (100448, 18306);
INSERT INTO card_set_white_card VALUES (100448, 18305);
INSERT INTO card_set_white_card VALUES (100448, 18304);
INSERT INTO card_set_white_card VALUES (100448, 18311);
INSERT INTO card_set_white_card VALUES (100448, 18310);
INSERT INTO card_set_white_card VALUES (100448, 18309);
INSERT INTO card_set_white_card VALUES (100448, 18308);
INSERT INTO card_set_white_card VALUES (100448, 18315);
INSERT INTO card_set_white_card VALUES (100448, 18314);
INSERT INTO card_set_white_card VALUES (100448, 18313);
INSERT INTO card_set_white_card VALUES (100448, 18312);
INSERT INTO card_set_white_card VALUES (100448, 18319);
INSERT INTO card_set_white_card VALUES (100448, 18318);
INSERT INTO card_set_white_card VALUES (100448, 18317);
INSERT INTO card_set_white_card VALUES (100448, 18316);
INSERT INTO card_set_white_card VALUES (100448, 18301);
INSERT INTO card_set_white_card VALUES (100448, 18300);
INSERT INTO card_set_white_card VALUES (100448, 18303);
INSERT INTO card_set_white_card VALUES (100448, 18302);
INSERT INTO card_set_white_card VALUES (100448, 18297);
INSERT INTO card_set_white_card VALUES (100448, 18296);
INSERT INTO card_set_white_card VALUES (100448, 18299);
INSERT INTO card_set_white_card VALUES (100448, 18298);
INSERT INTO card_set_white_card VALUES (100448, 18293);
INSERT INTO card_set_white_card VALUES (100448, 18292);
INSERT INTO card_set_white_card VALUES (100448, 18295);
INSERT INTO card_set_white_card VALUES (100448, 18294);
INSERT INTO card_set_white_card VALUES (100448, 18289);
INSERT INTO card_set_white_card VALUES (100448, 18288);
INSERT INTO card_set_white_card VALUES (100448, 18291);
INSERT INTO card_set_white_card VALUES (100448, 18290);
INSERT INTO card_set_white_card VALUES (100448, 18284);
INSERT INTO card_set_white_card VALUES (100448, 18285);
INSERT INTO card_set_white_card VALUES (100448, 18286);
INSERT INTO card_set_white_card VALUES (100448, 18287);
INSERT INTO card_set_white_card VALUES (100448, 18280);
INSERT INTO card_set_white_card VALUES (100448, 18281);
INSERT INTO card_set_white_card VALUES (100448, 18282);
INSERT INTO card_set_white_card VALUES (100448, 18283);
INSERT INTO card_set_white_card VALUES (100448, 18276);
INSERT INTO card_set_white_card VALUES (100448, 18277);
INSERT INTO card_set_white_card VALUES (100448, 18278);
INSERT INTO card_set_white_card VALUES (100448, 18279);
INSERT INTO card_set_white_card VALUES (100448, 18272);
INSERT INTO card_set_white_card VALUES (100448, 18273);
INSERT INTO card_set_white_card VALUES (100448, 18274);
INSERT INTO card_set_white_card VALUES (100448, 18275);
INSERT INTO card_set_white_card VALUES (100448, 18271);
INSERT INTO card_set_white_card VALUES (100448, 18270);
INSERT INTO card_set_white_card VALUES (100448, 18269);
INSERT INTO card_set_white_card VALUES (100448, 18268);
INSERT INTO card_set_white_card VALUES (100448, 18267);
INSERT INTO card_set_white_card VALUES (100448, 18266);
INSERT INTO card_set_white_card VALUES (100448, 18265);
INSERT INTO card_set_white_card VALUES (100448, 18264);
INSERT INTO card_set_white_card VALUES (100448, 18263);
INSERT INTO card_set_white_card VALUES (100448, 18262);
INSERT INTO card_set_white_card VALUES (100448, 18261);
INSERT INTO card_set_white_card VALUES (100448, 18260);
INSERT INTO card_set_white_card VALUES (100448, 18259);
INSERT INTO card_set_white_card VALUES (100448, 18258);
INSERT INTO card_set_white_card VALUES (100448, 18257);
INSERT INTO card_set_white_card VALUES (100448, 18256);
INSERT INTO card_set_white_card VALUES (100448, 18254);
INSERT INTO card_set_white_card VALUES (100448, 18255);
INSERT INTO card_set_white_card VALUES (100448, 18252);
INSERT INTO card_set_white_card VALUES (100448, 18253);
INSERT INTO card_set_white_card VALUES (100448, 18250);
INSERT INTO card_set_white_card VALUES (100448, 18251);
INSERT INTO card_set_white_card VALUES (100448, 18248);
INSERT INTO card_set_white_card VALUES (100448, 18249);
INSERT INTO card_set_white_card VALUES (100448, 18246);
INSERT INTO card_set_white_card VALUES (100448, 18247);
INSERT INTO card_set_white_card VALUES (100448, 18244);
INSERT INTO card_set_white_card VALUES (100448, 18245);
INSERT INTO card_set_white_card VALUES (100448, 18242);
INSERT INTO card_set_white_card VALUES (100448, 18243);
INSERT INTO card_set_white_card VALUES (100448, 18240);
INSERT INTO card_set_white_card VALUES (100448, 18241);
INSERT INTO card_set_white_card VALUES (100448, 18233);
INSERT INTO card_set_white_card VALUES (100448, 18232);
INSERT INTO card_set_white_card VALUES (100448, 18235);
INSERT INTO card_set_white_card VALUES (100448, 18234);
INSERT INTO card_set_white_card VALUES (100448, 18237);
INSERT INTO card_set_white_card VALUES (100448, 18236);
INSERT INTO card_set_white_card VALUES (100448, 18239);
INSERT INTO card_set_white_card VALUES (100448, 18238);
INSERT INTO card_set_white_card VALUES (100448, 18225);
INSERT INTO card_set_white_card VALUES (100448, 18224);
INSERT INTO card_set_white_card VALUES (100448, 18227);
INSERT INTO card_set_white_card VALUES (100448, 18226);
INSERT INTO card_set_white_card VALUES (100448, 18229);
INSERT INTO card_set_white_card VALUES (100448, 18228);
INSERT INTO card_set_white_card VALUES (100448, 18231);
INSERT INTO card_set_white_card VALUES (100448, 18230);
INSERT INTO card_set_white_card VALUES (100448, 18216);
INSERT INTO card_set_white_card VALUES (100448, 18217);
INSERT INTO card_set_white_card VALUES (100448, 18218);
INSERT INTO card_set_white_card VALUES (100448, 18219);
INSERT INTO card_set_white_card VALUES (100448, 18220);
INSERT INTO card_set_white_card VALUES (100448, 18221);
INSERT INTO card_set_white_card VALUES (100448, 18222);
INSERT INTO card_set_white_card VALUES (100448, 18223);
INSERT INTO card_set_white_card VALUES (100448, 18208);
INSERT INTO card_set_white_card VALUES (100448, 18209);
INSERT INTO card_set_white_card VALUES (100448, 18210);
INSERT INTO card_set_white_card VALUES (100448, 18211);
INSERT INTO card_set_white_card VALUES (100448, 18212);
INSERT INTO card_set_white_card VALUES (100448, 18213);
INSERT INTO card_set_white_card VALUES (100448, 18214);
INSERT INTO card_set_white_card VALUES (100448, 18215);
INSERT INTO card_set_white_card VALUES (100448, 18203);
INSERT INTO card_set_white_card VALUES (100448, 18202);
INSERT INTO card_set_white_card VALUES (100448, 18201);
INSERT INTO card_set_white_card VALUES (100448, 18200);
INSERT INTO card_set_white_card VALUES (100448, 18207);
INSERT INTO card_set_white_card VALUES (100448, 18206);
INSERT INTO card_set_white_card VALUES (100448, 18205);
INSERT INTO card_set_white_card VALUES (100448, 18204);
INSERT INTO card_set_white_card VALUES (100448, 18195);
INSERT INTO card_set_white_card VALUES (100448, 18194);
INSERT INTO card_set_white_card VALUES (100448, 18193);
INSERT INTO card_set_white_card VALUES (100448, 18192);
INSERT INTO card_set_white_card VALUES (100448, 18199);
INSERT INTO card_set_white_card VALUES (100448, 18198);
INSERT INTO card_set_white_card VALUES (100448, 18197);
INSERT INTO card_set_white_card VALUES (100448, 18196);
INSERT INTO card_set_white_card VALUES (100448, 18186);
INSERT INTO card_set_white_card VALUES (100448, 18187);
INSERT INTO card_set_white_card VALUES (100448, 18184);
INSERT INTO card_set_white_card VALUES (100448, 18185);
INSERT INTO card_set_white_card VALUES (100448, 18190);
INSERT INTO card_set_white_card VALUES (100448, 18191);
INSERT INTO card_set_white_card VALUES (100448, 18188);
INSERT INTO card_set_white_card VALUES (100448, 18189);
INSERT INTO card_set_white_card VALUES (100448, 18178);
INSERT INTO card_set_white_card VALUES (100448, 18179);
INSERT INTO card_set_white_card VALUES (100448, 18176);
INSERT INTO card_set_white_card VALUES (100448, 18177);
INSERT INTO card_set_white_card VALUES (100448, 18182);
INSERT INTO card_set_white_card VALUES (100448, 18183);
INSERT INTO card_set_white_card VALUES (100448, 18180);
INSERT INTO card_set_white_card VALUES (100448, 18181);
INSERT INTO card_set_white_card VALUES (100449, 18576);
INSERT INTO card_set_white_card VALUES (100449, 18577);
INSERT INTO card_set_white_card VALUES (100449, 18578);
INSERT INTO card_set_white_card VALUES (100449, 18573);
INSERT INTO card_set_white_card VALUES (100449, 18572);
INSERT INTO card_set_white_card VALUES (100449, 18575);
INSERT INTO card_set_white_card VALUES (100449, 18574);
INSERT INTO card_set_white_card VALUES (100449, 18569);
INSERT INTO card_set_white_card VALUES (100449, 18568);
INSERT INTO card_set_white_card VALUES (100449, 18571);
INSERT INTO card_set_white_card VALUES (100449, 18570);
INSERT INTO card_set_white_card VALUES (100449, 18565);
INSERT INTO card_set_white_card VALUES (100449, 18564);
INSERT INTO card_set_white_card VALUES (100449, 18567);
INSERT INTO card_set_white_card VALUES (100449, 18566);
INSERT INTO card_set_white_card VALUES (100449, 18561);
INSERT INTO card_set_white_card VALUES (100449, 18560);
INSERT INTO card_set_white_card VALUES (100449, 18563);
INSERT INTO card_set_white_card VALUES (100449, 18562);
INSERT INTO card_set_white_card VALUES (100449, 18513);
INSERT INTO card_set_white_card VALUES (100449, 18512);
INSERT INTO card_set_white_card VALUES (100449, 18515);
INSERT INTO card_set_white_card VALUES (100449, 18514);
INSERT INTO card_set_white_card VALUES (100449, 18517);
INSERT INTO card_set_white_card VALUES (100449, 18516);
INSERT INTO card_set_white_card VALUES (100449, 18519);
INSERT INTO card_set_white_card VALUES (100449, 18518);
INSERT INTO card_set_white_card VALUES (100449, 18521);
INSERT INTO card_set_white_card VALUES (100449, 18520);
INSERT INTO card_set_white_card VALUES (100449, 18523);
INSERT INTO card_set_white_card VALUES (100449, 18522);
INSERT INTO card_set_white_card VALUES (100449, 18525);
INSERT INTO card_set_white_card VALUES (100449, 18524);
INSERT INTO card_set_white_card VALUES (100449, 18527);
INSERT INTO card_set_white_card VALUES (100449, 18526);
INSERT INTO card_set_white_card VALUES (100449, 18508);
INSERT INTO card_set_white_card VALUES (100449, 18509);
INSERT INTO card_set_white_card VALUES (100449, 18510);
INSERT INTO card_set_white_card VALUES (100449, 18511);
INSERT INTO card_set_white_card VALUES (100449, 18547);
INSERT INTO card_set_white_card VALUES (100449, 18546);
INSERT INTO card_set_white_card VALUES (100449, 18545);
INSERT INTO card_set_white_card VALUES (100449, 18544);
INSERT INTO card_set_white_card VALUES (100449, 18551);
INSERT INTO card_set_white_card VALUES (100449, 18550);
INSERT INTO card_set_white_card VALUES (100449, 18549);
INSERT INTO card_set_white_card VALUES (100449, 18548);
INSERT INTO card_set_white_card VALUES (100449, 18555);
INSERT INTO card_set_white_card VALUES (100449, 18554);
INSERT INTO card_set_white_card VALUES (100449, 18553);
INSERT INTO card_set_white_card VALUES (100449, 18552);
INSERT INTO card_set_white_card VALUES (100449, 18559);
INSERT INTO card_set_white_card VALUES (100449, 18558);
INSERT INTO card_set_white_card VALUES (100449, 18557);
INSERT INTO card_set_white_card VALUES (100449, 18556);
INSERT INTO card_set_white_card VALUES (100449, 18530);
INSERT INTO card_set_white_card VALUES (100449, 18531);
INSERT INTO card_set_white_card VALUES (100449, 18528);
INSERT INTO card_set_white_card VALUES (100449, 18529);
INSERT INTO card_set_white_card VALUES (100449, 18534);
INSERT INTO card_set_white_card VALUES (100449, 18535);
INSERT INTO card_set_white_card VALUES (100449, 18532);
INSERT INTO card_set_white_card VALUES (100449, 18533);
INSERT INTO card_set_white_card VALUES (100449, 18538);
INSERT INTO card_set_white_card VALUES (100449, 18539);
INSERT INTO card_set_white_card VALUES (100449, 18536);
INSERT INTO card_set_white_card VALUES (100449, 18537);
INSERT INTO card_set_white_card VALUES (100449, 18542);
INSERT INTO card_set_white_card VALUES (100449, 18543);
INSERT INTO card_set_white_card VALUES (100449, 18540);
INSERT INTO card_set_white_card VALUES (100449, 18541);
INSERT INTO card_set_white_card VALUES (100450, 18588);
INSERT INTO card_set_white_card VALUES (100450, 18589);
INSERT INTO card_set_white_card VALUES (100450, 18590);
INSERT INTO card_set_white_card VALUES (100450, 18591);
INSERT INTO card_set_white_card VALUES (100450, 18584);
INSERT INTO card_set_white_card VALUES (100450, 18585);
INSERT INTO card_set_white_card VALUES (100450, 18586);
INSERT INTO card_set_white_card VALUES (100450, 18587);
INSERT INTO card_set_white_card VALUES (100450, 18580);
INSERT INTO card_set_white_card VALUES (100450, 18581);
INSERT INTO card_set_white_card VALUES (100450, 18582);
INSERT INTO card_set_white_card VALUES (100450, 18583);
INSERT INTO card_set_white_card VALUES (100450, 18622);
INSERT INTO card_set_white_card VALUES (100450, 18623);
INSERT INTO card_set_white_card VALUES (100450, 18620);
INSERT INTO card_set_white_card VALUES (100450, 18621);
INSERT INTO card_set_white_card VALUES (100450, 18618);
INSERT INTO card_set_white_card VALUES (100450, 18619);
INSERT INTO card_set_white_card VALUES (100450, 18616);
INSERT INTO card_set_white_card VALUES (100450, 18617);
INSERT INTO card_set_white_card VALUES (100450, 18614);
INSERT INTO card_set_white_card VALUES (100450, 18615);
INSERT INTO card_set_white_card VALUES (100450, 18612);
INSERT INTO card_set_white_card VALUES (100450, 18613);
INSERT INTO card_set_white_card VALUES (100450, 18610);
INSERT INTO card_set_white_card VALUES (100450, 18611);
INSERT INTO card_set_white_card VALUES (100450, 18608);
INSERT INTO card_set_white_card VALUES (100450, 18609);
INSERT INTO card_set_white_card VALUES (100450, 18607);
INSERT INTO card_set_white_card VALUES (100450, 18606);
INSERT INTO card_set_white_card VALUES (100450, 18605);
INSERT INTO card_set_white_card VALUES (100450, 18604);
INSERT INTO card_set_white_card VALUES (100450, 18603);
INSERT INTO card_set_white_card VALUES (100450, 18602);
INSERT INTO card_set_white_card VALUES (100450, 18601);
INSERT INTO card_set_white_card VALUES (100450, 18600);
INSERT INTO card_set_white_card VALUES (100450, 18599);
INSERT INTO card_set_white_card VALUES (100450, 18598);
INSERT INTO card_set_white_card VALUES (100450, 18597);
INSERT INTO card_set_white_card VALUES (100450, 18596);
INSERT INTO card_set_white_card VALUES (100450, 18595);
INSERT INTO card_set_white_card VALUES (100450, 18594);
INSERT INTO card_set_white_card VALUES (100450, 18593);
INSERT INTO card_set_white_card VALUES (100450, 18592);
INSERT INTO card_set_white_card VALUES (100450, 18648);
INSERT INTO card_set_white_card VALUES (100450, 18649);
INSERT INTO card_set_white_card VALUES (100450, 18650);
INSERT INTO card_set_white_card VALUES (100450, 18651);
INSERT INTO card_set_white_card VALUES (100450, 18652);
INSERT INTO card_set_white_card VALUES (100450, 18653);
INSERT INTO card_set_white_card VALUES (100450, 18654);
INSERT INTO card_set_white_card VALUES (100450, 18655);
INSERT INTO card_set_white_card VALUES (100450, 18640);
INSERT INTO card_set_white_card VALUES (100450, 18641);
INSERT INTO card_set_white_card VALUES (100450, 18642);
INSERT INTO card_set_white_card VALUES (100450, 18643);
INSERT INTO card_set_white_card VALUES (100450, 18644);
INSERT INTO card_set_white_card VALUES (100450, 18645);
INSERT INTO card_set_white_card VALUES (100450, 18646);
INSERT INTO card_set_white_card VALUES (100450, 18647);
INSERT INTO card_set_white_card VALUES (100450, 18633);
INSERT INTO card_set_white_card VALUES (100450, 18632);
INSERT INTO card_set_white_card VALUES (100450, 18635);
INSERT INTO card_set_white_card VALUES (100450, 18634);
INSERT INTO card_set_white_card VALUES (100450, 18637);
INSERT INTO card_set_white_card VALUES (100450, 18636);
INSERT INTO card_set_white_card VALUES (100450, 18639);
INSERT INTO card_set_white_card VALUES (100450, 18638);
INSERT INTO card_set_white_card VALUES (100450, 18625);
INSERT INTO card_set_white_card VALUES (100450, 18624);
INSERT INTO card_set_white_card VALUES (100450, 18627);
INSERT INTO card_set_white_card VALUES (100450, 18626);
INSERT INTO card_set_white_card VALUES (100450, 18629);
INSERT INTO card_set_white_card VALUES (100450, 18628);
INSERT INTO card_set_white_card VALUES (100450, 18631);
INSERT INTO card_set_white_card VALUES (100450, 18630);
INSERT INTO card_set_white_card VALUES (100450, 18667);
INSERT INTO card_set_white_card VALUES (100450, 18666);
INSERT INTO card_set_white_card VALUES (100450, 18665);
INSERT INTO card_set_white_card VALUES (100450, 18664);
INSERT INTO card_set_white_card VALUES (100450, 18669);
INSERT INTO card_set_white_card VALUES (100450, 18668);
INSERT INTO card_set_white_card VALUES (100450, 18659);
INSERT INTO card_set_white_card VALUES (100450, 18658);
INSERT INTO card_set_white_card VALUES (100450, 18657);
INSERT INTO card_set_white_card VALUES (100450, 18656);
INSERT INTO card_set_white_card VALUES (100450, 18663);
INSERT INTO card_set_white_card VALUES (100450, 18662);
INSERT INTO card_set_white_card VALUES (100450, 18661);
INSERT INTO card_set_white_card VALUES (100450, 18660);
INSERT INTO card_set_white_card VALUES (100451, 18779);
INSERT INTO card_set_white_card VALUES (100451, 18778);
INSERT INTO card_set_white_card VALUES (100451, 18777);
INSERT INTO card_set_white_card VALUES (100451, 18783);
INSERT INTO card_set_white_card VALUES (100451, 18782);
INSERT INTO card_set_white_card VALUES (100451, 18781);
INSERT INTO card_set_white_card VALUES (100451, 18780);
INSERT INTO card_set_white_card VALUES (100451, 18784);
INSERT INTO card_set_white_card VALUES (100451, 18785);
INSERT INTO card_set_white_card VALUES (100451, 18786);
INSERT INTO card_set_white_card VALUES (100451, 18787);
INSERT INTO card_set_white_card VALUES (100451, 18788);
INSERT INTO card_set_white_card VALUES (100451, 18789);
INSERT INTO card_set_white_card VALUES (100451, 18790);
INSERT INTO card_set_white_card VALUES (100451, 18791);
INSERT INTO card_set_white_card VALUES (100451, 18792);
INSERT INTO card_set_white_card VALUES (100451, 18793);
INSERT INTO card_set_white_card VALUES (100451, 18794);
INSERT INTO card_set_white_card VALUES (100451, 18795);
INSERT INTO card_set_white_card VALUES (100451, 18796);
INSERT INTO card_set_white_card VALUES (100451, 18797);
INSERT INTO card_set_white_card VALUES (100451, 18798);
INSERT INTO card_set_white_card VALUES (100451, 18799);
INSERT INTO card_set_white_card VALUES (100451, 18801);
INSERT INTO card_set_white_card VALUES (100451, 18800);
INSERT INTO card_set_white_card VALUES (100451, 18803);
INSERT INTO card_set_white_card VALUES (100451, 18802);
INSERT INTO card_set_white_card VALUES (100451, 18805);
INSERT INTO card_set_white_card VALUES (100451, 18804);
INSERT INTO card_set_white_card VALUES (100451, 18807);
INSERT INTO card_set_white_card VALUES (100451, 18806);
INSERT INTO card_set_white_card VALUES (100451, 18809);
INSERT INTO card_set_white_card VALUES (100451, 18808);
INSERT INTO card_set_white_card VALUES (100451, 18811);
INSERT INTO card_set_white_card VALUES (100451, 18810);
INSERT INTO card_set_white_card VALUES (100451, 18813);
INSERT INTO card_set_white_card VALUES (100451, 18812);
INSERT INTO card_set_white_card VALUES (100451, 18815);
INSERT INTO card_set_white_card VALUES (100451, 18814);
INSERT INTO card_set_white_card VALUES (100451, 18831);
INSERT INTO card_set_white_card VALUES (100451, 18830);
INSERT INTO card_set_white_card VALUES (100451, 18829);
INSERT INTO card_set_white_card VALUES (100451, 18828);
INSERT INTO card_set_white_card VALUES (100451, 18827);
INSERT INTO card_set_white_card VALUES (100451, 18826);
INSERT INTO card_set_white_card VALUES (100451, 18825);
INSERT INTO card_set_white_card VALUES (100451, 18824);
INSERT INTO card_set_white_card VALUES (100451, 18823);
INSERT INTO card_set_white_card VALUES (100451, 18822);
INSERT INTO card_set_white_card VALUES (100451, 18821);
INSERT INTO card_set_white_card VALUES (100451, 18820);
INSERT INTO card_set_white_card VALUES (100451, 18819);
INSERT INTO card_set_white_card VALUES (100451, 15655);
INSERT INTO card_set_white_card VALUES (100451, 18818);
INSERT INTO card_set_white_card VALUES (100451, 18817);
INSERT INTO card_set_white_card VALUES (100451, 18816);
INSERT INTO card_set_white_card VALUES (100451, 18846);
INSERT INTO card_set_white_card VALUES (100451, 18847);
INSERT INTO card_set_white_card VALUES (100451, 18844);
INSERT INTO card_set_white_card VALUES (100451, 18845);
INSERT INTO card_set_white_card VALUES (100451, 18842);
INSERT INTO card_set_white_card VALUES (100451, 18843);
INSERT INTO card_set_white_card VALUES (100451, 18840);
INSERT INTO card_set_white_card VALUES (100451, 18841);
INSERT INTO card_set_white_card VALUES (100451, 18838);
INSERT INTO card_set_white_card VALUES (100451, 18839);
INSERT INTO card_set_white_card VALUES (100451, 18836);
INSERT INTO card_set_white_card VALUES (100451, 18837);
INSERT INTO card_set_white_card VALUES (100451, 18834);
INSERT INTO card_set_white_card VALUES (100451, 18835);
INSERT INTO card_set_white_card VALUES (100451, 18832);
INSERT INTO card_set_white_card VALUES (100451, 18833);
INSERT INTO card_set_white_card VALUES (100451, 18861);
INSERT INTO card_set_white_card VALUES (100451, 18860);
INSERT INTO card_set_white_card VALUES (100451, 18863);
INSERT INTO card_set_white_card VALUES (100451, 18862);
INSERT INTO card_set_white_card VALUES (100451, 18857);
INSERT INTO card_set_white_card VALUES (100451, 18856);
INSERT INTO card_set_white_card VALUES (100451, 18859);
INSERT INTO card_set_white_card VALUES (100451, 18858);
INSERT INTO card_set_white_card VALUES (100451, 18853);
INSERT INTO card_set_white_card VALUES (100451, 18852);
INSERT INTO card_set_white_card VALUES (100451, 18855);
INSERT INTO card_set_white_card VALUES (100451, 18854);
INSERT INTO card_set_white_card VALUES (100451, 18849);
INSERT INTO card_set_white_card VALUES (100451, 18848);
INSERT INTO card_set_white_card VALUES (100451, 18851);
INSERT INTO card_set_white_card VALUES (100451, 18850);
INSERT INTO card_set_white_card VALUES (100451, 18876);
INSERT INTO card_set_white_card VALUES (100451, 18877);
INSERT INTO card_set_white_card VALUES (100451, 18878);
INSERT INTO card_set_white_card VALUES (100451, 18879);
INSERT INTO card_set_white_card VALUES (100451, 18872);
INSERT INTO card_set_white_card VALUES (100451, 18873);
INSERT INTO card_set_white_card VALUES (100451, 18874);
INSERT INTO card_set_white_card VALUES (100451, 18875);
INSERT INTO card_set_white_card VALUES (100451, 18868);
INSERT INTO card_set_white_card VALUES (100451, 18869);
INSERT INTO card_set_white_card VALUES (100451, 18870);
INSERT INTO card_set_white_card VALUES (100451, 18871);
INSERT INTO card_set_white_card VALUES (100451, 18864);
INSERT INTO card_set_white_card VALUES (100451, 18865);
INSERT INTO card_set_white_card VALUES (100451, 18866);
INSERT INTO card_set_white_card VALUES (100451, 18867);
INSERT INTO card_set_white_card VALUES (100451, 18891);
INSERT INTO card_set_white_card VALUES (100451, 18890);
INSERT INTO card_set_white_card VALUES (100451, 18889);
INSERT INTO card_set_white_card VALUES (100451, 18888);
INSERT INTO card_set_white_card VALUES (100451, 18895);
INSERT INTO card_set_white_card VALUES (100451, 18894);
INSERT INTO card_set_white_card VALUES (100451, 18893);
INSERT INTO card_set_white_card VALUES (100451, 18892);
INSERT INTO card_set_white_card VALUES (100451, 18883);
INSERT INTO card_set_white_card VALUES (100451, 18882);
INSERT INTO card_set_white_card VALUES (100451, 18881);
INSERT INTO card_set_white_card VALUES (100451, 18880);
INSERT INTO card_set_white_card VALUES (100451, 18887);
INSERT INTO card_set_white_card VALUES (100451, 18886);
INSERT INTO card_set_white_card VALUES (100451, 18885);
INSERT INTO card_set_white_card VALUES (100451, 18884);
INSERT INTO card_set_white_card VALUES (100451, 18906);
INSERT INTO card_set_white_card VALUES (100451, 18907);
INSERT INTO card_set_white_card VALUES (100451, 18904);
INSERT INTO card_set_white_card VALUES (100451, 18905);
INSERT INTO card_set_white_card VALUES (100451, 18910);
INSERT INTO card_set_white_card VALUES (100451, 18911);
INSERT INTO card_set_white_card VALUES (100451, 18908);
INSERT INTO card_set_white_card VALUES (100451, 18909);
INSERT INTO card_set_white_card VALUES (100451, 18898);
INSERT INTO card_set_white_card VALUES (100451, 18899);
INSERT INTO card_set_white_card VALUES (100451, 18896);
INSERT INTO card_set_white_card VALUES (100451, 18897);
INSERT INTO card_set_white_card VALUES (100451, 18902);
INSERT INTO card_set_white_card VALUES (100451, 18903);
INSERT INTO card_set_white_card VALUES (100451, 18900);
INSERT INTO card_set_white_card VALUES (100451, 18901);
INSERT INTO card_set_white_card VALUES (100451, 18921);
INSERT INTO card_set_white_card VALUES (100451, 18920);
INSERT INTO card_set_white_card VALUES (100451, 18923);
INSERT INTO card_set_white_card VALUES (100451, 18922);
INSERT INTO card_set_white_card VALUES (100451, 18925);
INSERT INTO card_set_white_card VALUES (100451, 18924);
INSERT INTO card_set_white_card VALUES (100451, 18927);
INSERT INTO card_set_white_card VALUES (100451, 18926);
INSERT INTO card_set_white_card VALUES (100451, 18913);
INSERT INTO card_set_white_card VALUES (100451, 18912);
INSERT INTO card_set_white_card VALUES (100451, 18915);
INSERT INTO card_set_white_card VALUES (100451, 18914);
INSERT INTO card_set_white_card VALUES (100451, 18917);
INSERT INTO card_set_white_card VALUES (100451, 18916);
INSERT INTO card_set_white_card VALUES (100451, 18919);
INSERT INTO card_set_white_card VALUES (100451, 18918);
INSERT INTO card_set_white_card VALUES (100451, 18936);
INSERT INTO card_set_white_card VALUES (100451, 18937);
INSERT INTO card_set_white_card VALUES (100451, 18938);
INSERT INTO card_set_white_card VALUES (100451, 18928);
INSERT INTO card_set_white_card VALUES (100451, 18929);
INSERT INTO card_set_white_card VALUES (100451, 18930);
INSERT INTO card_set_white_card VALUES (100451, 18931);
INSERT INTO card_set_white_card VALUES (100451, 18932);
INSERT INTO card_set_white_card VALUES (100451, 18933);
INSERT INTO card_set_white_card VALUES (100451, 18934);
INSERT INTO card_set_white_card VALUES (100451, 18935);
INSERT INTO card_set_white_card VALUES (100452, 18944);
INSERT INTO card_set_white_card VALUES (100452, 18945);
INSERT INTO card_set_white_card VALUES (100452, 18946);
INSERT INTO card_set_white_card VALUES (100452, 18939);
INSERT INTO card_set_white_card VALUES (100452, 18947);
INSERT INTO card_set_white_card VALUES (100452, 18940);
INSERT INTO card_set_white_card VALUES (100452, 18948);
INSERT INTO card_set_white_card VALUES (100452, 18941);
INSERT INTO card_set_white_card VALUES (100452, 18949);
INSERT INTO card_set_white_card VALUES (100452, 18942);
INSERT INTO card_set_white_card VALUES (100452, 18950);
INSERT INTO card_set_white_card VALUES (100452, 18943);
INSERT INTO card_set_white_card VALUES (100452, 18951);
INSERT INTO card_set_white_card VALUES (100452, 18952);
INSERT INTO card_set_white_card VALUES (100452, 18953);
INSERT INTO card_set_white_card VALUES (100452, 18954);
INSERT INTO card_set_white_card VALUES (100452, 18955);
INSERT INTO card_set_white_card VALUES (100452, 18956);
INSERT INTO card_set_white_card VALUES (100452, 18957);
INSERT INTO card_set_white_card VALUES (100452, 18958);
INSERT INTO card_set_white_card VALUES (100453, 22001);
INSERT INTO card_set_white_card VALUES (100453, 22000);
INSERT INTO card_set_white_card VALUES (100453, 22003);
INSERT INTO card_set_white_card VALUES (100453, 22002);
INSERT INTO card_set_white_card VALUES (100453, 22005);
INSERT INTO card_set_white_card VALUES (100453, 22004);
INSERT INTO card_set_white_card VALUES (100453, 22007);
INSERT INTO card_set_white_card VALUES (100453, 22006);
INSERT INTO card_set_white_card VALUES (100453, 22009);
INSERT INTO card_set_white_card VALUES (100453, 22008);
INSERT INTO card_set_white_card VALUES (100453, 22011);
INSERT INTO card_set_white_card VALUES (100453, 22010);
INSERT INTO card_set_white_card VALUES (100453, 22013);
INSERT INTO card_set_white_card VALUES (100453, 22012);
INSERT INTO card_set_white_card VALUES (100453, 22015);
INSERT INTO card_set_white_card VALUES (100453, 22014);
INSERT INTO card_set_white_card VALUES (100453, 21984);
INSERT INTO card_set_white_card VALUES (100453, 21985);
INSERT INTO card_set_white_card VALUES (100453, 21986);
INSERT INTO card_set_white_card VALUES (100453, 21987);
INSERT INTO card_set_white_card VALUES (100453, 21988);
INSERT INTO card_set_white_card VALUES (100453, 21989);
INSERT INTO card_set_white_card VALUES (100453, 21990);
INSERT INTO card_set_white_card VALUES (100453, 21991);
INSERT INTO card_set_white_card VALUES (100453, 21992);
INSERT INTO card_set_white_card VALUES (100453, 21993);
INSERT INTO card_set_white_card VALUES (100453, 21994);
INSERT INTO card_set_white_card VALUES (100453, 21995);
INSERT INTO card_set_white_card VALUES (100453, 21996);
INSERT INTO card_set_white_card VALUES (100453, 21997);
INSERT INTO card_set_white_card VALUES (100453, 21998);
INSERT INTO card_set_white_card VALUES (100453, 21999);
INSERT INTO card_set_white_card VALUES (100453, 21971);
INSERT INTO card_set_white_card VALUES (100453, 21970);
INSERT INTO card_set_white_card VALUES (100453, 21969);
INSERT INTO card_set_white_card VALUES (100453, 21968);
INSERT INTO card_set_white_card VALUES (100453, 21975);
INSERT INTO card_set_white_card VALUES (100453, 21974);
INSERT INTO card_set_white_card VALUES (100453, 21973);
INSERT INTO card_set_white_card VALUES (100453, 21972);
INSERT INTO card_set_white_card VALUES (100453, 21979);
INSERT INTO card_set_white_card VALUES (100453, 21978);
INSERT INTO card_set_white_card VALUES (100453, 21977);
INSERT INTO card_set_white_card VALUES (100453, 21976);
INSERT INTO card_set_white_card VALUES (100453, 21983);
INSERT INTO card_set_white_card VALUES (100453, 21982);
INSERT INTO card_set_white_card VALUES (100453, 21981);
INSERT INTO card_set_white_card VALUES (100453, 21980);
INSERT INTO card_set_white_card VALUES (100453, 21954);
INSERT INTO card_set_white_card VALUES (100453, 21955);
INSERT INTO card_set_white_card VALUES (100453, 21952);
INSERT INTO card_set_white_card VALUES (100453, 21953);
INSERT INTO card_set_white_card VALUES (100453, 21958);
INSERT INTO card_set_white_card VALUES (100453, 21959);
INSERT INTO card_set_white_card VALUES (100453, 21956);
INSERT INTO card_set_white_card VALUES (100453, 21957);
INSERT INTO card_set_white_card VALUES (100453, 59);
INSERT INTO card_set_white_card VALUES (100453, 21962);
INSERT INTO card_set_white_card VALUES (100453, 21963);
INSERT INTO card_set_white_card VALUES (100453, 21960);
INSERT INTO card_set_white_card VALUES (100453, 21961);
INSERT INTO card_set_white_card VALUES (100453, 21966);
INSERT INTO card_set_white_card VALUES (100453, 21967);
INSERT INTO card_set_white_card VALUES (100453, 21964);
INSERT INTO card_set_white_card VALUES (100453, 21965);
INSERT INTO card_set_white_card VALUES (100453, 21941);
INSERT INTO card_set_white_card VALUES (100453, 21940);
INSERT INTO card_set_white_card VALUES (100453, 21943);
INSERT INTO card_set_white_card VALUES (100453, 21942);
INSERT INTO card_set_white_card VALUES (100453, 21937);
INSERT INTO card_set_white_card VALUES (100453, 21936);
INSERT INTO card_set_white_card VALUES (100453, 21939);
INSERT INTO card_set_white_card VALUES (100453, 21938);
INSERT INTO card_set_white_card VALUES (100453, 21949);
INSERT INTO card_set_white_card VALUES (100453, 21948);
INSERT INTO card_set_white_card VALUES (100453, 21951);
INSERT INTO card_set_white_card VALUES (100453, 21950);
INSERT INTO card_set_white_card VALUES (100453, 21945);
INSERT INTO card_set_white_card VALUES (100453, 21944);
INSERT INTO card_set_white_card VALUES (100453, 21947);
INSERT INTO card_set_white_card VALUES (100453, 21946);
INSERT INTO card_set_white_card VALUES (100453, 21924);
INSERT INTO card_set_white_card VALUES (100453, 21925);
INSERT INTO card_set_white_card VALUES (100453, 21926);
INSERT INTO card_set_white_card VALUES (100453, 21927);
INSERT INTO card_set_white_card VALUES (100453, 21920);
INSERT INTO card_set_white_card VALUES (100453, 21921);
INSERT INTO card_set_white_card VALUES (100453, 21922);
INSERT INTO card_set_white_card VALUES (100453, 21923);
INSERT INTO card_set_white_card VALUES (100453, 21932);
INSERT INTO card_set_white_card VALUES (100453, 21933);
INSERT INTO card_set_white_card VALUES (100453, 21934);
INSERT INTO card_set_white_card VALUES (100453, 21935);
INSERT INTO card_set_white_card VALUES (100453, 21928);
INSERT INTO card_set_white_card VALUES (100453, 21929);
INSERT INTO card_set_white_card VALUES (100453, 21930);
INSERT INTO card_set_white_card VALUES (100453, 21931);
INSERT INTO card_set_white_card VALUES (100453, 21911);
INSERT INTO card_set_white_card VALUES (100453, 21910);
INSERT INTO card_set_white_card VALUES (100453, 21909);
INSERT INTO card_set_white_card VALUES (100453, 21908);
INSERT INTO card_set_white_card VALUES (100453, 21907);
INSERT INTO card_set_white_card VALUES (100453, 21906);
INSERT INTO card_set_white_card VALUES (100453, 21905);
INSERT INTO card_set_white_card VALUES (100453, 21904);
INSERT INTO card_set_white_card VALUES (100453, 21919);
INSERT INTO card_set_white_card VALUES (100453, 21918);
INSERT INTO card_set_white_card VALUES (100453, 21917);
INSERT INTO card_set_white_card VALUES (100453, 21916);
INSERT INTO card_set_white_card VALUES (100453, 21915);
INSERT INTO card_set_white_card VALUES (100453, 21914);
INSERT INTO card_set_white_card VALUES (100453, 21913);
INSERT INTO card_set_white_card VALUES (100453, 21912);
INSERT INTO card_set_white_card VALUES (100453, 105);
INSERT INTO card_set_white_card VALUES (100453, 21894);
INSERT INTO card_set_white_card VALUES (100453, 21895);
INSERT INTO card_set_white_card VALUES (100453, 21892);
INSERT INTO card_set_white_card VALUES (100453, 21893);
INSERT INTO card_set_white_card VALUES (100453, 21890);
INSERT INTO card_set_white_card VALUES (100453, 21891);
INSERT INTO card_set_white_card VALUES (100453, 21888);
INSERT INTO card_set_white_card VALUES (100453, 21889);
INSERT INTO card_set_white_card VALUES (100453, 21902);
INSERT INTO card_set_white_card VALUES (100453, 21903);
INSERT INTO card_set_white_card VALUES (100453, 21900);
INSERT INTO card_set_white_card VALUES (100453, 21901);
INSERT INTO card_set_white_card VALUES (100453, 21898);
INSERT INTO card_set_white_card VALUES (100453, 21899);
INSERT INTO card_set_white_card VALUES (100453, 21896);
INSERT INTO card_set_white_card VALUES (100453, 21897);
INSERT INTO card_set_white_card VALUES (100453, 21880);
INSERT INTO card_set_white_card VALUES (100453, 21881);
INSERT INTO card_set_white_card VALUES (100453, 21882);
INSERT INTO card_set_white_card VALUES (100453, 21883);
INSERT INTO card_set_white_card VALUES (100453, 21884);
INSERT INTO card_set_white_card VALUES (100453, 21885);
INSERT INTO card_set_white_card VALUES (100453, 21886);
INSERT INTO card_set_white_card VALUES (100453, 21887);
INSERT INTO card_set_white_card VALUES (100453, 21872);
INSERT INTO card_set_white_card VALUES (100453, 21873);
INSERT INTO card_set_white_card VALUES (100453, 21874);
INSERT INTO card_set_white_card VALUES (100453, 21875);
INSERT INTO card_set_white_card VALUES (100453, 21876);
INSERT INTO card_set_white_card VALUES (100453, 21877);
INSERT INTO card_set_white_card VALUES (100453, 21878);
INSERT INTO card_set_white_card VALUES (100453, 21879);
INSERT INTO card_set_white_card VALUES (100453, 152);
INSERT INTO card_set_white_card VALUES (100453, 21865);
INSERT INTO card_set_white_card VALUES (100453, 21864);
INSERT INTO card_set_white_card VALUES (100453, 21867);
INSERT INTO card_set_white_card VALUES (100453, 21866);
INSERT INTO card_set_white_card VALUES (100453, 155);
INSERT INTO card_set_white_card VALUES (100453, 21869);
INSERT INTO card_set_white_card VALUES (100453, 21868);
INSERT INTO card_set_white_card VALUES (100453, 157);
INSERT INTO card_set_white_card VALUES (100453, 21871);
INSERT INTO card_set_white_card VALUES (100453, 21870);
INSERT INTO card_set_white_card VALUES (100453, 21857);
INSERT INTO card_set_white_card VALUES (100453, 21856);
INSERT INTO card_set_white_card VALUES (100453, 21859);
INSERT INTO card_set_white_card VALUES (100453, 21858);
INSERT INTO card_set_white_card VALUES (100453, 21861);
INSERT INTO card_set_white_card VALUES (100453, 21860);
INSERT INTO card_set_white_card VALUES (100453, 21863);
INSERT INTO card_set_white_card VALUES (100453, 21862);
INSERT INTO card_set_white_card VALUES (100453, 21850);
INSERT INTO card_set_white_card VALUES (100453, 21851);
INSERT INTO card_set_white_card VALUES (100453, 21848);
INSERT INTO card_set_white_card VALUES (100453, 21849);
INSERT INTO card_set_white_card VALUES (100453, 21854);
INSERT INTO card_set_white_card VALUES (100453, 21855);
INSERT INTO card_set_white_card VALUES (100453, 21852);
INSERT INTO card_set_white_card VALUES (100453, 21853);
INSERT INTO card_set_white_card VALUES (100453, 21842);
INSERT INTO card_set_white_card VALUES (100453, 21843);
INSERT INTO card_set_white_card VALUES (100453, 21840);
INSERT INTO card_set_white_card VALUES (100453, 21841);
INSERT INTO card_set_white_card VALUES (100453, 21846);
INSERT INTO card_set_white_card VALUES (100453, 21847);
INSERT INTO card_set_white_card VALUES (100453, 21844);
INSERT INTO card_set_white_card VALUES (100453, 21845);
INSERT INTO card_set_white_card VALUES (100453, 21835);
INSERT INTO card_set_white_card VALUES (100453, 21834);
INSERT INTO card_set_white_card VALUES (100453, 21833);
INSERT INTO card_set_white_card VALUES (100453, 21832);
INSERT INTO card_set_white_card VALUES (100453, 21839);
INSERT INTO card_set_white_card VALUES (100453, 21838);
INSERT INTO card_set_white_card VALUES (100453, 21837);
INSERT INTO card_set_white_card VALUES (100453, 21836);
INSERT INTO card_set_white_card VALUES (100453, 21827);
INSERT INTO card_set_white_card VALUES (100453, 21826);
INSERT INTO card_set_white_card VALUES (100453, 21825);
INSERT INTO card_set_white_card VALUES (100453, 21824);
INSERT INTO card_set_white_card VALUES (100453, 21831);
INSERT INTO card_set_white_card VALUES (100453, 21830);
INSERT INTO card_set_white_card VALUES (100453, 21829);
INSERT INTO card_set_white_card VALUES (100453, 21828);
INSERT INTO card_set_white_card VALUES (100453, 21820);
INSERT INTO card_set_white_card VALUES (100453, 21821);
INSERT INTO card_set_white_card VALUES (100453, 21822);
INSERT INTO card_set_white_card VALUES (100453, 21823);
INSERT INTO card_set_white_card VALUES (100453, 21816);
INSERT INTO card_set_white_card VALUES (100453, 21817);
INSERT INTO card_set_white_card VALUES (100453, 21818);
INSERT INTO card_set_white_card VALUES (100453, 21819);
INSERT INTO card_set_white_card VALUES (100453, 21812);
INSERT INTO card_set_white_card VALUES (100453, 21813);
INSERT INTO card_set_white_card VALUES (100453, 21814);
INSERT INTO card_set_white_card VALUES (100453, 21815);
INSERT INTO card_set_white_card VALUES (100453, 21808);
INSERT INTO card_set_white_card VALUES (100453, 21809);
INSERT INTO card_set_white_card VALUES (100453, 21810);
INSERT INTO card_set_white_card VALUES (100453, 21811);
INSERT INTO card_set_white_card VALUES (100453, 21805);
INSERT INTO card_set_white_card VALUES (100453, 21804);
INSERT INTO card_set_white_card VALUES (100453, 21807);
INSERT INTO card_set_white_card VALUES (100453, 21806);
INSERT INTO card_set_white_card VALUES (100453, 21801);
INSERT INTO card_set_white_card VALUES (100453, 21800);
INSERT INTO card_set_white_card VALUES (100453, 21803);
INSERT INTO card_set_white_card VALUES (100453, 21802);
INSERT INTO card_set_white_card VALUES (100453, 21797);
INSERT INTO card_set_white_card VALUES (100453, 21796);
INSERT INTO card_set_white_card VALUES (100453, 21799);
INSERT INTO card_set_white_card VALUES (100453, 21798);
INSERT INTO card_set_white_card VALUES (100453, 21793);
INSERT INTO card_set_white_card VALUES (100453, 21792);
INSERT INTO card_set_white_card VALUES (100453, 21795);
INSERT INTO card_set_white_card VALUES (100453, 21794);
INSERT INTO card_set_white_card VALUES (100453, 21790);
INSERT INTO card_set_white_card VALUES (100453, 21791);
INSERT INTO card_set_white_card VALUES (100453, 21788);
INSERT INTO card_set_white_card VALUES (100453, 21789);
INSERT INTO card_set_white_card VALUES (100453, 21786);
INSERT INTO card_set_white_card VALUES (100453, 21787);
INSERT INTO card_set_white_card VALUES (100453, 21784);
INSERT INTO card_set_white_card VALUES (100453, 232);
INSERT INTO card_set_white_card VALUES (100453, 21785);
INSERT INTO card_set_white_card VALUES (100453, 21782);
INSERT INTO card_set_white_card VALUES (100453, 21783);
INSERT INTO card_set_white_card VALUES (100453, 21780);
INSERT INTO card_set_white_card VALUES (100453, 21781);
INSERT INTO card_set_white_card VALUES (100453, 336);
INSERT INTO card_set_white_card VALUES (100453, 321);
INSERT INTO card_set_white_card VALUES (100453, 359);
INSERT INTO card_set_white_card VALUES (100453, 462);
INSERT INTO card_set_white_card VALUES (100453, 493);
INSERT INTO card_set_white_card VALUES (100453, 22144);
INSERT INTO card_set_white_card VALUES (100453, 22145);
INSERT INTO card_set_white_card VALUES (100453, 22146);
INSERT INTO card_set_white_card VALUES (100453, 22147);
INSERT INTO card_set_white_card VALUES (100453, 22148);
INSERT INTO card_set_white_card VALUES (100453, 22149);
INSERT INTO card_set_white_card VALUES (100453, 22150);
INSERT INTO card_set_white_card VALUES (100453, 22151);
INSERT INTO card_set_white_card VALUES (100453, 22152);
INSERT INTO card_set_white_card VALUES (100453, 22153);
INSERT INTO card_set_white_card VALUES (100453, 22154);
INSERT INTO card_set_white_card VALUES (100453, 22155);
INSERT INTO card_set_white_card VALUES (100453, 22156);
INSERT INTO card_set_white_card VALUES (100453, 22157);
INSERT INTO card_set_white_card VALUES (100453, 22158);
INSERT INTO card_set_white_card VALUES (100453, 22159);
INSERT INTO card_set_white_card VALUES (100453, 22161);
INSERT INTO card_set_white_card VALUES (100453, 22160);
INSERT INTO card_set_white_card VALUES (100453, 22163);
INSERT INTO card_set_white_card VALUES (100453, 22162);
INSERT INTO card_set_white_card VALUES (100453, 22093);
INSERT INTO card_set_white_card VALUES (100453, 22092);
INSERT INTO card_set_white_card VALUES (100453, 22095);
INSERT INTO card_set_white_card VALUES (100453, 22094);
INSERT INTO card_set_white_card VALUES (100453, 22089);
INSERT INTO card_set_white_card VALUES (100453, 22088);
INSERT INTO card_set_white_card VALUES (100453, 22091);
INSERT INTO card_set_white_card VALUES (100453, 22090);
INSERT INTO card_set_white_card VALUES (100453, 22085);
INSERT INTO card_set_white_card VALUES (100453, 22084);
INSERT INTO card_set_white_card VALUES (100453, 22087);
INSERT INTO card_set_white_card VALUES (100453, 22086);
INSERT INTO card_set_white_card VALUES (100453, 22081);
INSERT INTO card_set_white_card VALUES (100453, 22080);
INSERT INTO card_set_white_card VALUES (100453, 22083);
INSERT INTO card_set_white_card VALUES (100453, 22082);
INSERT INTO card_set_white_card VALUES (100453, 22108);
INSERT INTO card_set_white_card VALUES (100453, 22109);
INSERT INTO card_set_white_card VALUES (100453, 22110);
INSERT INTO card_set_white_card VALUES (100453, 22111);
INSERT INTO card_set_white_card VALUES (100453, 22104);
INSERT INTO card_set_white_card VALUES (100453, 22105);
INSERT INTO card_set_white_card VALUES (100453, 22106);
INSERT INTO card_set_white_card VALUES (100453, 22107);
INSERT INTO card_set_white_card VALUES (100453, 22100);
INSERT INTO card_set_white_card VALUES (100453, 22101);
INSERT INTO card_set_white_card VALUES (100453, 22102);
INSERT INTO card_set_white_card VALUES (100453, 22103);
INSERT INTO card_set_white_card VALUES (100453, 22096);
INSERT INTO card_set_white_card VALUES (100453, 22097);
INSERT INTO card_set_white_card VALUES (100453, 22098);
INSERT INTO card_set_white_card VALUES (100453, 22099);
INSERT INTO card_set_white_card VALUES (100453, 22127);
INSERT INTO card_set_white_card VALUES (100453, 22126);
INSERT INTO card_set_white_card VALUES (100453, 22125);
INSERT INTO card_set_white_card VALUES (100453, 22124);
INSERT INTO card_set_white_card VALUES (100453, 22123);
INSERT INTO card_set_white_card VALUES (100453, 22122);
INSERT INTO card_set_white_card VALUES (100453, 22121);
INSERT INTO card_set_white_card VALUES (100453, 22120);
INSERT INTO card_set_white_card VALUES (100453, 22119);
INSERT INTO card_set_white_card VALUES (100453, 22118);
INSERT INTO card_set_white_card VALUES (100453, 22117);
INSERT INTO card_set_white_card VALUES (100453, 22116);
INSERT INTO card_set_white_card VALUES (100453, 22115);
INSERT INTO card_set_white_card VALUES (100453, 22114);
INSERT INTO card_set_white_card VALUES (100453, 22113);
INSERT INTO card_set_white_card VALUES (100453, 22112);
INSERT INTO card_set_white_card VALUES (100453, 22142);
INSERT INTO card_set_white_card VALUES (100453, 22143);
INSERT INTO card_set_white_card VALUES (100453, 22140);
INSERT INTO card_set_white_card VALUES (100453, 22141);
INSERT INTO card_set_white_card VALUES (100453, 22138);
INSERT INTO card_set_white_card VALUES (100453, 22139);
INSERT INTO card_set_white_card VALUES (100453, 22136);
INSERT INTO card_set_white_card VALUES (100453, 22137);
INSERT INTO card_set_white_card VALUES (100453, 22134);
INSERT INTO card_set_white_card VALUES (100453, 22135);
INSERT INTO card_set_white_card VALUES (100453, 22132);
INSERT INTO card_set_white_card VALUES (100453, 22133);
INSERT INTO card_set_white_card VALUES (100453, 22130);
INSERT INTO card_set_white_card VALUES (100453, 22131);
INSERT INTO card_set_white_card VALUES (100453, 22128);
INSERT INTO card_set_white_card VALUES (100453, 22129);
INSERT INTO card_set_white_card VALUES (100453, 22025);
INSERT INTO card_set_white_card VALUES (100453, 22024);
INSERT INTO card_set_white_card VALUES (100453, 22027);
INSERT INTO card_set_white_card VALUES (100453, 22026);
INSERT INTO card_set_white_card VALUES (100453, 22029);
INSERT INTO card_set_white_card VALUES (100453, 22028);
INSERT INTO card_set_white_card VALUES (100453, 22031);
INSERT INTO card_set_white_card VALUES (100453, 22030);
INSERT INTO card_set_white_card VALUES (100453, 22017);
INSERT INTO card_set_white_card VALUES (100453, 22016);
INSERT INTO card_set_white_card VALUES (100453, 22019);
INSERT INTO card_set_white_card VALUES (100453, 22018);
INSERT INTO card_set_white_card VALUES (100453, 22021);
INSERT INTO card_set_white_card VALUES (100453, 22020);
INSERT INTO card_set_white_card VALUES (100453, 22023);
INSERT INTO card_set_white_card VALUES (100453, 22022);
INSERT INTO card_set_white_card VALUES (100453, 22040);
INSERT INTO card_set_white_card VALUES (100453, 22041);
INSERT INTO card_set_white_card VALUES (100453, 22042);
INSERT INTO card_set_white_card VALUES (100453, 22043);
INSERT INTO card_set_white_card VALUES (100453, 22044);
INSERT INTO card_set_white_card VALUES (100453, 22045);
INSERT INTO card_set_white_card VALUES (100453, 22046);
INSERT INTO card_set_white_card VALUES (100453, 22047);
INSERT INTO card_set_white_card VALUES (100453, 22032);
INSERT INTO card_set_white_card VALUES (100453, 22033);
INSERT INTO card_set_white_card VALUES (100453, 22034);
INSERT INTO card_set_white_card VALUES (100453, 22035);
INSERT INTO card_set_white_card VALUES (100453, 22036);
INSERT INTO card_set_white_card VALUES (100453, 22037);
INSERT INTO card_set_white_card VALUES (100453, 22038);
INSERT INTO card_set_white_card VALUES (100453, 22039);
INSERT INTO card_set_white_card VALUES (100453, 22059);
INSERT INTO card_set_white_card VALUES (100453, 22058);
INSERT INTO card_set_white_card VALUES (100453, 22057);
INSERT INTO card_set_white_card VALUES (100453, 22056);
INSERT INTO card_set_white_card VALUES (100453, 22063);
INSERT INTO card_set_white_card VALUES (100453, 22062);
INSERT INTO card_set_white_card VALUES (100453, 22061);
INSERT INTO card_set_white_card VALUES (100453, 22060);
INSERT INTO card_set_white_card VALUES (100453, 22051);
INSERT INTO card_set_white_card VALUES (100453, 22050);
INSERT INTO card_set_white_card VALUES (100453, 22049);
INSERT INTO card_set_white_card VALUES (100453, 22048);
INSERT INTO card_set_white_card VALUES (100453, 22055);
INSERT INTO card_set_white_card VALUES (100453, 22054);
INSERT INTO card_set_white_card VALUES (100453, 22053);
INSERT INTO card_set_white_card VALUES (100453, 22052);
INSERT INTO card_set_white_card VALUES (100453, 22074);
INSERT INTO card_set_white_card VALUES (100453, 22075);
INSERT INTO card_set_white_card VALUES (100453, 22072);
INSERT INTO card_set_white_card VALUES (100453, 22073);
INSERT INTO card_set_white_card VALUES (100453, 22078);
INSERT INTO card_set_white_card VALUES (100453, 22079);
INSERT INTO card_set_white_card VALUES (100453, 22076);
INSERT INTO card_set_white_card VALUES (100453, 22077);
INSERT INTO card_set_white_card VALUES (100453, 22066);
INSERT INTO card_set_white_card VALUES (100453, 22067);
INSERT INTO card_set_white_card VALUES (100453, 22064);
INSERT INTO card_set_white_card VALUES (100453, 22065);
INSERT INTO card_set_white_card VALUES (100453, 22070);
INSERT INTO card_set_white_card VALUES (100453, 22071);
INSERT INTO card_set_white_card VALUES (100453, 22068);
INSERT INTO card_set_white_card VALUES (100453, 22069);
INSERT INTO card_set_white_card VALUES (100017, 100454);
INSERT INTO card_set_white_card VALUES (100422, 100457);
INSERT INTO card_set_white_card VALUES (100422, 100456);
INSERT INTO card_set_white_card VALUES (100422, 100455);
INSERT INTO card_set_white_card VALUES (100257, 100057);
INSERT INTO card_set_white_card VALUES (100485, 100463);
INSERT INTO card_set_white_card VALUES (100485, 100462);
INSERT INTO card_set_white_card VALUES (100485, 100461);
INSERT INTO card_set_white_card VALUES (100485, 100460);
INSERT INTO card_set_white_card VALUES (100485, 100474);
INSERT INTO card_set_white_card VALUES (100485, 100475);
INSERT INTO card_set_white_card VALUES (100485, 100472);
INSERT INTO card_set_white_card VALUES (100485, 100473);
INSERT INTO card_set_white_card VALUES (100485, 100470);
INSERT INTO card_set_white_card VALUES (100485, 100471);
INSERT INTO card_set_white_card VALUES (100485, 100468);
INSERT INTO card_set_white_card VALUES (100485, 100469);
INSERT INTO card_set_white_card VALUES (100485, 100466);
INSERT INTO card_set_white_card VALUES (100485, 100467);
INSERT INTO card_set_white_card VALUES (100485, 100464);
INSERT INTO card_set_white_card VALUES (100485, 100465);


--
-- TOC entry 1947 (class 0 OID 0)
-- Dependencies: 166
-- Name: hibernate_sequence; Type: SEQUENCE SET; Schema: public; Owner: cah
--

SELECT pg_catalog.setval('hibernate_sequence', 100485, true);


--
-- TOC entry 1934 (class 0 OID 16493)
-- Dependencies: 167
-- Data for Name: white_cards; Type: TABLE DATA; Schema: public; Owner: cah
--

INSERT INTO white_cards VALUES (282, 'Michelle Obama''s arms.', NULL);
INSERT INTO white_cards VALUES (124, 'White people.', NULL);
INSERT INTO white_cards VALUES (393, 'An erection that lasts longer than four hours.', NULL);
INSERT INTO white_cards VALUES (141, 'Panda sex.', NULL);
INSERT INTO white_cards VALUES (121, 'Stifling a giggle at the mention of Hutus and Tutsis.', NULL);
INSERT INTO white_cards VALUES (269, 'A middle-aged man on roller skates.', NULL);
INSERT INTO white_cards VALUES (1, 'Coat hanger abortions.', NULL);
INSERT INTO white_cards VALUES (138, 'Scrubbing under the folds.', NULL);
INSERT INTO white_cards VALUES (275, 'Wearing underwear inside-out to avoid doing laundry.', NULL);
INSERT INTO white_cards VALUES (3662, 'Canadian Kindness.', 'RS');
INSERT INTO white_cards VALUES (1146, 'end First Expansion', NULL);
INSERT INTO white_cards VALUES (3663, 'The world''s tallest midget.', 'RS');
INSERT INTO white_cards VALUES (462, 'MechaHitler.', '1.2');
INSERT INTO white_cards VALUES (463, 'Getting naked and watching Nickelodeon.', '1.2');
INSERT INTO white_cards VALUES (464, 'Charisma.', '1.2');
INSERT INTO white_cards VALUES (465, 'Morgan Freeman''s voice.', '1.2');
INSERT INTO white_cards VALUES (466, 'Breaking out into song and dance.', '1.2');
INSERT INTO white_cards VALUES (467, 'Soup that is too hot.', '1.2');
INSERT INTO white_cards VALUES (468, 'Chutzpah.', '1.2');
INSERT INTO white_cards VALUES (469, 'Unfathomable stupidity.', '1.2');
INSERT INTO white_cards VALUES (470, 'Horrifying laser hair removal accidents.', '1.2');
INSERT INTO white_cards VALUES (471, 'Boogers.', '1.2');
INSERT INTO white_cards VALUES (3664, 'The shitty remains of Taco Bell&reg;.', 'RS');
INSERT INTO white_cards VALUES (473, 'Expecting a burp and vomiting on the floor.', '1.2');
INSERT INTO white_cards VALUES (474, 'A defective condom.', '1.2');
INSERT INTO white_cards VALUES (475, 'Teenage pregnancy.', '1.2');
INSERT INTO white_cards VALUES (476, 'Hot cheese.', '1.2');
INSERT INTO white_cards VALUES (477, 'A mopey zoo lion.', '1.2');
INSERT INTO white_cards VALUES (478, 'Shapeshifters.', '1.2');
INSERT INTO white_cards VALUES (479, 'The Care Bear Stare.', '1.2');
INSERT INTO white_cards VALUES (480, 'Erectile dysfunction.', '1.2');
INSERT INTO white_cards VALUES (481, 'The chronic.', '1.2');
INSERT INTO white_cards VALUES (483, '"Tweeting."', '1.2');
INSERT INTO white_cards VALUES (484, 'Firing a rifle into the air while balls deep in a squealing hog.', '1.2');
INSERT INTO white_cards VALUES (485, 'Nicolas Cage.', '1.2');
INSERT INTO white_cards VALUES (3665, 'Master Chief.', 'RS');
INSERT INTO white_cards VALUES (1110, 'Leveling up.', 'X1');
INSERT INTO white_cards VALUES (1111, 'Literally eating shit.', 'X1');
INSERT INTO white_cards VALUES (1112, 'Making the penises kiss.', 'X1');
INSERT INTO white_cards VALUES (1113, 'Media coverage.', 'X1');
INSERT INTO white_cards VALUES (3666, 'Four Loko.', 'RS');
INSERT INTO white_cards VALUES (1115, 'Moral ambiguity.', 'X1');
INSERT INTO white_cards VALUES (1116, 'My machete.', 'X1');
INSERT INTO white_cards VALUES (1117, 'One thousand Slim Jims.', 'X1');
INSERT INTO white_cards VALUES (1118, 'Ominous background music.', 'X1');
INSERT INTO white_cards VALUES (1119, 'Overpowering your father.', 'X1');
INSERT INTO white_cards VALUES (1120, 'Pistol-whipping a hostage.', 'X1');
INSERT INTO white_cards VALUES (1121, 'Quiche.', 'X1');
INSERT INTO white_cards VALUES (1122, 'Quivering jowls.', 'X1');
INSERT INTO white_cards VALUES (1123, 'Revenge fucking.', 'X1');
INSERT INTO white_cards VALUES (1124, 'Ripping into a man''s chest and pulling out his still-beating heart.', 'X1');
INSERT INTO white_cards VALUES (1125, 'Ryan Gosling riding in on a white horse.', 'X1');
INSERT INTO white_cards VALUES (1126, 'Santa Claus.', 'X1');
INSERT INTO white_cards VALUES (1127, 'Scrotum tickling.', 'X1');
INSERT INTO white_cards VALUES (1128, 'Sexual humiliation.', 'X1');
INSERT INTO white_cards VALUES (1129, 'Sexy Siamese twins.', 'X1');
INSERT INTO white_cards VALUES (1130, 'Slow motion.', 'X1');
INSERT INTO white_cards VALUES (1131, 'Space muffins.', 'X1');
INSERT INTO white_cards VALUES (1132, 'Statistically validated stereotypes.', 'X1');
INSERT INTO white_cards VALUES (1133, 'Sudden Poop Explosion Disease.', 'X1');
INSERT INTO white_cards VALUES (1134, 'The boners of the elderly.', 'X1');
INSERT INTO white_cards VALUES (1135, 'The economy.', 'X1');
INSERT INTO white_cards VALUES (225, 'Dropping a chandelier on your enemies and riding the rope up.', NULL);
INSERT INTO white_cards VALUES (297, 'Public ridicule.', NULL);
INSERT INTO white_cards VALUES (265, 'A snapping turtle biting the tip of your penis.', NULL);
INSERT INTO white_cards VALUES (218, 'Vehicular manslaughter.', NULL);
INSERT INTO white_cards VALUES (3667, 'Xyzzy playing around with gender roles.', 'RS');
INSERT INTO white_cards VALUES (160, 'The token minority.', NULL);
INSERT INTO white_cards VALUES (3668, 'Walt Disney''s frozen head.', 'RS');
INSERT INTO white_cards VALUES (3669, 'Sponge baths.', 'RS');
INSERT INTO white_cards VALUES (488, 'A gentle caress of the inner thigh.', '1.2');
INSERT INTO white_cards VALUES (489, 'Poor life choices.', '1.2');
INSERT INTO white_cards VALUES (490, 'Embryonic stem cells.', '1.2');
INSERT INTO white_cards VALUES (491, 'Customer service representatives.', '1.2');
INSERT INTO white_cards VALUES (492, 'The Little Engine That Could.', '1.2');
INSERT INTO white_cards VALUES (493, 'Lady Gaga.', '1.2');
INSERT INTO white_cards VALUES (494, 'A death ray.', '1.2');
INSERT INTO white_cards VALUES (495, 'Vigilante justice.', '1.2');
INSERT INTO white_cards VALUES (496, 'Exactly what you''d expect.', '1.2');
INSERT INTO white_cards VALUES (497, 'Natural male enhancement.', '1.2');
INSERT INTO white_cards VALUES (498, 'Passive-aggressive Post-it notes.', '1.2');
INSERT INTO white_cards VALUES (499, 'Inappropriate yodeling.', '1.2');
INSERT INTO white_cards VALUES (500, 'A homoerotic volleyball montage.', '1.2');
INSERT INTO white_cards VALUES (501, 'Actually taking candy from a baby.', '1.2');
INSERT INTO white_cards VALUES (502, 'Jibber-jabber.', '1.2');
INSERT INTO white_cards VALUES (503, 'Crystal meth.', '1.2');
INSERT INTO white_cards VALUES (504, 'My inner demons.', '1.2');
INSERT INTO white_cards VALUES (505, 'Pac-Man uncontrollably guzzling cum.', '1.2');
INSERT INTO white_cards VALUES (506, 'My vagina.', '1.2');
INSERT INTO white_cards VALUES (3670, 'Sonic brutally murdering Mario.', 'RS');
INSERT INTO white_cards VALUES (508, 'The true meaning of Christmas.', '1.2');
INSERT INTO white_cards VALUES (3671, 'Mario brutally murdering Sonic.', 'RS');
INSERT INTO white_cards VALUES (1137, 'The Gulags.', 'X1');
INSERT INTO white_cards VALUES (1138, 'The harsh light of day.', 'X1');
INSERT INTO white_cards VALUES (1139, 'The hiccups.', 'X1');
INSERT INTO white_cards VALUES (1140, 'The shambling corpse of Larry King.', 'X1');
INSERT INTO white_cards VALUES (1141, 'The four arms of Vishnu.', 'X1');
INSERT INTO white_cards VALUES (1142, 'Being a busy adult with many important things to do.', 'X1');
INSERT INTO white_cards VALUES (1143, 'Tripping balls.', 'X1');
INSERT INTO white_cards VALUES (1144, 'Words, words, words.', 'X1');
INSERT INTO white_cards VALUES (1145, 'Zeus''s sexual appetites.', 'X1');
INSERT INTO white_cards VALUES (1066, 'A big black dick.', 'X1');
INSERT INTO white_cards VALUES (1067, 'A beached whale.', 'X1');
INSERT INTO white_cards VALUES (1068, 'A bloody pacifier.', 'X1');
INSERT INTO white_cards VALUES (1069, 'A crappy little hand.', 'X1');
INSERT INTO white_cards VALUES (1070, 'A low standard of living.', 'X1');
INSERT INTO white_cards VALUES (1071, 'A nuanced critique.', 'X1');
INSERT INTO white_cards VALUES (1072, 'Panty raids.', 'X1');
INSERT INTO white_cards VALUES (1073, 'A passionate Latino lover.', 'X1');
INSERT INTO white_cards VALUES (1074, 'A rival dojo.', 'X1');
INSERT INTO white_cards VALUES (1075, 'A web of lies.', 'X1');
INSERT INTO white_cards VALUES (1076, 'A woman scorned.', 'X1');
INSERT INTO white_cards VALUES (1078, 'Apologizing.', 'X1');
INSERT INTO white_cards VALUES (1079, 'Appreciative snapping.', 'X1');
INSERT INTO white_cards VALUES (1080, 'Neil Patrick Harris.', 'X1');
INSERT INTO white_cards VALUES (1081, 'Beating your wives.', 'X1');
INSERT INTO white_cards VALUES (1082, 'Being a dinosaur.', 'X1');
INSERT INTO white_cards VALUES (1083, 'Shaft.', 'X1');
INSERT INTO white_cards VALUES (1217, 'A soulful rendition of "Ol'' Man River."', 'X2');
INSERT INTO white_cards VALUES (1218, 'Intimacy problems.', 'X2');
INSERT INTO white_cards VALUES (1219, 'A sweaty, panting leather daddy.', 'X2');
INSERT INTO white_cards VALUES (1220, 'Spring break!', 'X2');
INSERT INTO white_cards VALUES (1221, 'Being awesome at sex.', 'X2');
INSERT INTO white_cards VALUES (1222, 'Dining with cardboard cutouts of the cast of "Friends."', 'X2');
INSERT INTO white_cards VALUES (461, 'Flying sex snakes.', '1.2');
INSERT INTO white_cards VALUES (1077, 'Clams.', 'X1');
INSERT INTO white_cards VALUES (1223, 'Another shot of morphine.', 'X2');
INSERT INTO white_cards VALUES (1226, 'Bullshit.', 'X2');
INSERT INTO white_cards VALUES (1227, 'The Google.', 'X2');
INSERT INTO white_cards VALUES (3672, 'Getting high on bath salts.', 'RS');
INSERT INTO white_cards VALUES (1229, 'The new Radiohead album.', 'X2');
INSERT INTO white_cards VALUES (1230, 'An army of skeletons.', 'X2');
INSERT INTO white_cards VALUES (1231, 'A man in yoga pants with a ponytail and feather earrings.', 'X2');
INSERT INTO white_cards VALUES (1232, 'Mild autism.', 'X2');
INSERT INTO white_cards VALUES (1233, 'Nunchuck moves.', 'X2');
INSERT INTO white_cards VALUES (1234, 'Whipping a disobedient slave.', 'X2');
INSERT INTO white_cards VALUES (1235, 'An ether-soaked rag.', 'X2');
INSERT INTO white_cards VALUES (1236, 'A sweet spaceship.', 'X2');
INSERT INTO white_cards VALUES (1237, 'A 55-gallon drum of lube.', 'X2');
INSERT INTO white_cards VALUES (1238, 'Special musical guest, Cher.', 'X2');
INSERT INTO white_cards VALUES (1239, 'The human body.', 'X2');
INSERT INTO white_cards VALUES (1240, 'Boris the Soviet Love Hammer.', 'X2');
INSERT INTO white_cards VALUES (1241, 'The grey nutrient broth that sustains Mitt Romney.', 'X2');
INSERT INTO white_cards VALUES (1242, 'Tiny nipples.', 'X2');
INSERT INTO white_cards VALUES (1243, 'Power.', 'X2');
INSERT INTO white_cards VALUES (1244, 'Oncoming traffic.', 'X2');
INSERT INTO white_cards VALUES (1245, 'A dollop of sour cream.', 'X2');
INSERT INTO white_cards VALUES (1246, 'A slightly shittier parallel universe.', 'X2');
INSERT INTO white_cards VALUES (1247, 'My first kill.', 'X2');
INSERT INTO white_cards VALUES (1248, 'Graphic violence, adult language, and some sexual content.', 'X2');
INSERT INTO white_cards VALUES (1249, 'Fetal alcohol syndrome.', 'X2');
INSERT INTO white_cards VALUES (1250, 'The day the birds attacked.', 'X2');
INSERT INTO white_cards VALUES (1251, 'One Ring to rule them all.', 'X2');
INSERT INTO white_cards VALUES (1252, 'Grandpa''s ashes.', 'X2');
INSERT INTO white_cards VALUES (1253, 'Basic human decency.', 'X2');
INSERT INTO white_cards VALUES (1254, 'A Burmese tiger pit.', 'X2');
INSERT INTO white_cards VALUES (1255, 'Death by Steven Seagal.', 'X2');
INSERT INTO white_cards VALUES (1002, 'testtest', NULL);
INSERT INTO white_cards VALUES (1031, 'End Canadian White Cards', NULL);
INSERT INTO white_cards VALUES (1010, 'Mr. Dressup.', 'CAN');
INSERT INTO white_cards VALUES (1011, 'Being Canadian.', 'CAN');
INSERT INTO white_cards VALUES (1012, 'The Famous Five.', 'CAN');
INSERT INTO white_cards VALUES (1013, 'Stephen Harper.', 'CAN');
INSERT INTO white_cards VALUES (1014, 'The Royal Canadian Mounted Police.', 'CAN');
INSERT INTO white_cards VALUES (1015, 'An icy handjob from an Edmonton hooker.', 'CAN');
INSERT INTO white_cards VALUES (1016, 'Poutine.', 'CAN');
INSERT INTO white_cards VALUES (1017, 'Newfies.', 'CAN');
INSERT INTO white_cards VALUES (1018, 'The Official Languages Act. La Loi sur les langues officielles.', 'CAN');
INSERT INTO white_cards VALUES (1019, 'Terry Fox''s prosthetic leg.', 'CAN');
INSERT INTO white_cards VALUES (1020, 'The FLQ.', 'CAN');
INSERT INTO white_cards VALUES (1021, 'Canada: America''s Hat.', 'CAN');
INSERT INTO white_cards VALUES (1022, 'Don Cherry''s wardrobe.', 'CAN');
INSERT INTO white_cards VALUES (1023, 'Burning down the White House.', 'CAN');
INSERT INTO white_cards VALUES (1024, 'Heritage minutes.', 'CAN');
INSERT INTO white_cards VALUES (1025, 'Homo milk.', 'CAN');
INSERT INTO white_cards VALUES (1026, 'Naked News.', 'CAN');
INSERT INTO white_cards VALUES (1027, 'Syrupy sex with a maple tree.', 'CAN');
INSERT INTO white_cards VALUES (1028, 'Snotsicles.', 'CAN');
INSERT INTO white_cards VALUES (1029, 'Schmirler the Curler.', 'CAN');
INSERT INTO white_cards VALUES (1030, 'A Molson muscle.', 'CAN');
INSERT INTO white_cards VALUES (1181, 'A bigger, blacker dick.', 'X2');
INSERT INTO white_cards VALUES (3673, 'Snorting Pixie Stix.', 'RS');
INSERT INTO white_cards VALUES (1183, 'A sad fat dragon with no friends.', 'X2');
INSERT INTO white_cards VALUES (1184, 'Catastrophic urethral trauma.', 'X2');
INSERT INTO white_cards VALUES (1185, 'Hillary Clinton''s death stare.', 'X2');
INSERT INTO white_cards VALUES (1186, 'Existing.', 'X2');
INSERT INTO white_cards VALUES (3674, 'Poorly written Star Wars&reg; fan fiction.', 'RS');
INSERT INTO white_cards VALUES (1188, 'Mooing.', 'X2');
INSERT INTO white_cards VALUES (1189, 'Swiftly achieving orgasm.', 'X2');
INSERT INTO white_cards VALUES (1190, 'Daddy''s belt.', 'X2');
INSERT INTO white_cards VALUES (1191, 'Double penetration.', 'X2');
INSERT INTO white_cards VALUES (1192, 'Weapons-grade plutonium.', 'X2');
INSERT INTO white_cards VALUES (1193, 'Some really fucked-up shit.', 'X2');
INSERT INTO white_cards VALUES (1194, 'Subduing a grizzly bear and making her your wife.', 'X2');
INSERT INTO white_cards VALUES (1195, 'Rising from the grave.', 'X2');
INSERT INTO white_cards VALUES (1196, 'The mixing of the races.', 'X2');
INSERT INTO white_cards VALUES (1197, 'Taking a man''s eyes and balls out and putting his eyes where his balls go and then his balls in the eye holes.', 'X2');
INSERT INTO white_cards VALUES (1198, 'Scrotal frostbite.', 'X2');
INSERT INTO white_cards VALUES (1199, 'All of this blood.', 'X2');
INSERT INTO white_cards VALUES (1200, 'Loki, the trickster god.', 'X2');
INSERT INTO white_cards VALUES (1201, 'Whining like a little bitch.', 'X2');
INSERT INTO white_cards VALUES (1202, 'Pumping out a baby every nine months.', 'X2');
INSERT INTO white_cards VALUES (1203, 'Tongue.', 'X2');
INSERT INTO white_cards VALUES (1204, 'Finding Waldo.', 'X2');
INSERT INTO white_cards VALUES (1205, 'Upgrading homeless people to mobile hotspots.', 'X2');
INSERT INTO white_cards VALUES (1206, 'Wearing an octopus for a hat.', 'X2');
INSERT INTO white_cards VALUES (1207, 'An unhinged ferris wheel rolling toward the sea.', 'X2');
INSERT INTO white_cards VALUES (1208, 'Living in a trashcan.', 'X2');
INSERT INTO white_cards VALUES (1209, 'The corporations.', 'X2');
INSERT INTO white_cards VALUES (1210, 'A magic hippie love cloud.', 'X2');
INSERT INTO white_cards VALUES (1211, 'Fuck Mountain.', 'X2');
INSERT INTO white_cards VALUES (1212, 'Survivor''s guilt.', 'X2');
INSERT INTO white_cards VALUES (1213, 'Me.', 'X2');
INSERT INTO white_cards VALUES (1214, 'Getting hilariously gang-banged by the Blue Man Group.', 'X2');
INSERT INTO white_cards VALUES (1215, 'Jeff Goldblum.', 'X2');
INSERT INTO white_cards VALUES (1216, 'Making a friend.', 'X2');
INSERT INTO white_cards VALUES (44, 'German dungeon porn.', NULL);
INSERT INTO white_cards VALUES (40, 'Praying the gay away.', NULL);
INSERT INTO white_cards VALUES (63, 'Dying.', NULL);
INSERT INTO white_cards VALUES (41, 'Same-sex ice dancing.', NULL);
INSERT INTO white_cards VALUES (70, 'Dying of dysentery.', NULL);
INSERT INTO white_cards VALUES (19, 'Roofies.', NULL);
INSERT INTO white_cards VALUES (22, 'The Big Bang.', NULL);
INSERT INTO white_cards VALUES (23, 'Amputees.', NULL);
INSERT INTO white_cards VALUES (74, 'Men.', NULL);
INSERT INTO white_cards VALUES (18, 'Concealing a boner.', NULL);
INSERT INTO white_cards VALUES (87, 'Agriculture.', NULL);
INSERT INTO white_cards VALUES (51, 'Making a pouty face.', NULL);
INSERT INTO white_cards VALUES (98, 'YOU MUST CONSTRUCT ADDITIONAL PYLONS.', NULL);
INSERT INTO white_cards VALUES (60, 'Hormone injections.', NULL);
INSERT INTO white_cards VALUES (55, 'Tom Cruise.', NULL);
INSERT INTO white_cards VALUES (56, 'Object permanence.', NULL);
INSERT INTO white_cards VALUES (92, 'Consultants.', NULL);
INSERT INTO white_cards VALUES (26, 'Being marginalized.', NULL);
INSERT INTO white_cards VALUES (54, 'The profoundly handicapped.', NULL);
INSERT INTO white_cards VALUES (96, 'Party poopers.', NULL);
INSERT INTO white_cards VALUES (48, 'Nickelback.', NULL);
INSERT INTO white_cards VALUES (7, 'Doing the right thing.', NULL);
INSERT INTO white_cards VALUES (65, 'The invisible hand.', NULL);
INSERT INTO white_cards VALUES (49, 'Heteronormativity.', NULL);
INSERT INTO white_cards VALUES (29, 'Cuddling.', NULL);
INSERT INTO white_cards VALUES (84, 'Raptor attacks.', NULL);
INSERT INTO white_cards VALUES (38, 'Fear itself.', NULL);
INSERT INTO white_cards VALUES (91, 'Sniffing glue.', NULL);
INSERT INTO white_cards VALUES (58, 'An icepick lobotomy.', NULL);
INSERT INTO white_cards VALUES (109, 'Being rich.', NULL);
INSERT INTO white_cards VALUES (79, 'The clitoris.', NULL);
INSERT INTO white_cards VALUES (71, 'Sexy pillow fights.', NULL);
INSERT INTO white_cards VALUES (105, 'Michael Jackson.', NULL);
INSERT INTO white_cards VALUES (101, 'Sexting.', NULL);
INSERT INTO white_cards VALUES (33, 'Horse meat.', NULL);
INSERT INTO white_cards VALUES (8, 'Hunting accidents.', NULL);
INSERT INTO white_cards VALUES (9, 'A cartoon camel enjoying the smooth, refreshing taste of a cigarette.', NULL);
INSERT INTO white_cards VALUES (15, 'Abstinence.', NULL);
INSERT INTO white_cards VALUES (17, 'Mountain Dew Code Red.', NULL);
INSERT INTO white_cards VALUES (21, 'Tweeting.', NULL);
INSERT INTO white_cards VALUES (43, 'Making sex at her.', NULL);
INSERT INTO white_cards VALUES (64, 'Stunt doubles.', NULL);
INSERT INTO white_cards VALUES (69, 'Flavored condoms.', NULL);
INSERT INTO white_cards VALUES (100, 'Heath Ledger.', NULL);
INSERT INTO white_cards VALUES (110, 'Muzzy.', NULL);
INSERT INTO white_cards VALUES (97, 'Sunshine and rainbows.', NULL);
INSERT INTO white_cards VALUES (68, 'Flash flooding.', NULL);
INSERT INTO white_cards VALUES (57, 'Goblins.', NULL);
INSERT INTO white_cards VALUES (13, 'Spectacular abs.', NULL);
INSERT INTO white_cards VALUES (72, 'The Three-Fifths compromise.', NULL);
INSERT INTO white_cards VALUES (4, 'Vigorous jazz hands.', NULL);
INSERT INTO white_cards VALUES (106, 'Skeletor.', NULL);
INSERT INTO white_cards VALUES (80, 'Vikings.', NULL);
INSERT INTO white_cards VALUES (34, 'Genital piercings.', NULL);
INSERT INTO white_cards VALUES (3675, 'The final circle of Hell.', 'RS');
INSERT INTO white_cards VALUES (67, 'A really cool hat.', NULL);
INSERT INTO white_cards VALUES (102, 'An Oedipus complex.', NULL);
INSERT INTO white_cards VALUES (82, 'The Underground Railroad.', NULL);
INSERT INTO white_cards VALUES (77, 'Heartwarming orphans.', NULL);
INSERT INTO white_cards VALUES (47, 'Cheating in the Special Olympics.', NULL);
INSERT INTO white_cards VALUES (108, 'Sharing needles.', NULL);
INSERT INTO white_cards VALUES (46, 'Ethnic cleansing.', NULL);
INSERT INTO white_cards VALUES (103, 'Eating all of the cookies before the AIDS bake-sale.', NULL);
INSERT INTO white_cards VALUES (93, 'My humps.', NULL);
INSERT INTO white_cards VALUES (10, 'The violation of our most basic human rights.', NULL);
INSERT INTO white_cards VALUES (35, 'Fingering.', NULL);
INSERT INTO white_cards VALUES (53, 'The placenta.', NULL);
INSERT INTO white_cards VALUES (5, 'Flightless birds.', NULL);
INSERT INTO white_cards VALUES (37, 'Stranger danger.', NULL);
INSERT INTO white_cards VALUES (107, 'Chivalry.', NULL);
INSERT INTO white_cards VALUES (76, 'Sean Penn.', NULL);
INSERT INTO white_cards VALUES (73, 'A sad handjob.', NULL);
INSERT INTO white_cards VALUES (66, 'Jew-fros.', NULL);
INSERT INTO white_cards VALUES (12, 'Self-loathing.', NULL);
INSERT INTO white_cards VALUES (61, 'A falcon with a cap on its head.', NULL);
INSERT INTO white_cards VALUES (75, 'Historically black colleges.', NULL);
INSERT INTO white_cards VALUES (30, 'Aaron Burr.', NULL);
INSERT INTO white_cards VALUES (25, 'Former President George W. Bush.', NULL);
INSERT INTO white_cards VALUES (94, 'Geese.', NULL);
INSERT INTO white_cards VALUES (99, 'Mutually-assured destruction.', NULL);
INSERT INTO white_cards VALUES (88, 'Bling.', NULL);
INSERT INTO white_cards VALUES (27, 'Smegma.', NULL);
INSERT INTO white_cards VALUES (90, 'The South.', NULL);
INSERT INTO white_cards VALUES (83, 'Pretending to care.', NULL);
INSERT INTO white_cards VALUES (59, 'Arnold Schwarzenegger.', NULL);
INSERT INTO white_cards VALUES (20, 'Glenn Beck convulsively vomiting as a brood of crab spiders hatches in his brain and erupts from his tear ducts.', NULL);
INSERT INTO white_cards VALUES (104, 'A sausage festival.', NULL);
INSERT INTO white_cards VALUES (62, 'Foreskin.', NULL);
INSERT INTO white_cards VALUES (95, 'Being a dick to children.', NULL);
INSERT INTO white_cards VALUES (52, 'Chainsaws for hands.', NULL);
INSERT INTO white_cards VALUES (86, 'A Gypsy curse.', NULL);
INSERT INTO white_cards VALUES (31, 'The Pope.', NULL);
INSERT INTO white_cards VALUES (16, 'A balanced breakfast.', NULL);
INSERT INTO white_cards VALUES (36, 'Elderly Japanese men.', NULL);
INSERT INTO white_cards VALUES (6, 'Pictures of boobs.', NULL);
INSERT INTO white_cards VALUES (39, 'Science.', NULL);
INSERT INTO white_cards VALUES (32, 'A bleached asshole.', NULL);
INSERT INTO white_cards VALUES (3, 'Autocannibalism.', NULL);
INSERT INTO white_cards VALUES (50, 'William Shatner.', NULL);
INSERT INTO white_cards VALUES (85, 'A micropenis.', NULL);
INSERT INTO white_cards VALUES (78, 'Waterboarding.', NULL);
INSERT INTO white_cards VALUES (45, 'Bingeing and purging.', NULL);
INSERT INTO white_cards VALUES (89, 'A clandestine butt scratch.', NULL);
INSERT INTO white_cards VALUES (2, 'Man meat.', NULL);
INSERT INTO white_cards VALUES (28, 'Laying an egg.', NULL);
INSERT INTO white_cards VALUES (14, 'An honest cop with nothing left to lose.', NULL);
INSERT INTO white_cards VALUES (42, 'The terrorists.', NULL);
INSERT INTO white_cards VALUES (81, 'Friends who eat all the snacks.', NULL);
INSERT INTO white_cards VALUES (1043, 'end misprint bonus card', NULL);
INSERT INTO white_cards VALUES (1034, 'A bitch slap.', 'B');
INSERT INTO white_cards VALUES (1035, 'One trillion dollars.', 'B');
INSERT INTO white_cards VALUES (1036, 'Chunks of dead prostitute.', 'B');
INSERT INTO white_cards VALUES (1037, 'The entire Mormon Tabernacle Choir.', 'B');
INSERT INTO white_cards VALUES (1038, 'The female orgasm.', 'B');
INSERT INTO white_cards VALUES (1039, 'Extremely tight pants.', 'B');
INSERT INTO white_cards VALUES (1040, 'Stormtroopers.', 'B');
INSERT INTO white_cards VALUES (1041, 'The Boy Scouts of America.', 'B');
INSERT INTO white_cards VALUES (1042, 'Throwing a virgin into a volcano.', 'B');
INSERT INTO white_cards VALUES (120, 'Cookie Monster devouring the Eucharist wafers.', NULL);
INSERT INTO white_cards VALUES (123, 'Letting yourself go.', NULL);
INSERT INTO white_cards VALUES (3676, 'The Bible.', 'RS');
INSERT INTO white_cards VALUES (131, 'A LAN party.', NULL);
INSERT INTO white_cards VALUES (133, 'A grande sugar-free iced soy caramel macchiato.', NULL);
INSERT INTO white_cards VALUES (143, 'Will Smith.', NULL);
INSERT INTO white_cards VALUES (156, 'Marky Mark and the Funky Bunch.', NULL);
INSERT INTO white_cards VALUES (158, 'Dave Matthews Band.', NULL);
INSERT INTO white_cards VALUES (164, 'Substitute teachers.', NULL);
INSERT INTO white_cards VALUES (177, 'Garth Brooks.', NULL);
INSERT INTO white_cards VALUES (188, 'Keeping Christ in Christmas.', NULL);
INSERT INTO white_cards VALUES (190, 'That one gay Teletubby.', NULL);
INSERT INTO white_cards VALUES (216, 'Passive-agression.', NULL);
INSERT INTO white_cards VALUES (3677, 'Borat''s one piece.', 'RS');
INSERT INTO white_cards VALUES (248, 'The People''s Elbow.', NULL);
INSERT INTO white_cards VALUES (230, 'Guys who don''t call.', NULL);
INSERT INTO white_cards VALUES (152, 'AIDS.', NULL);
INSERT INTO white_cards VALUES (187, 'The Rapture.', NULL);
INSERT INTO white_cards VALUES (244, 'Eugenics.', NULL);
INSERT INTO white_cards VALUES (181, 'Taking off your shirt.', NULL);
INSERT INTO white_cards VALUES (139, 'A drive-by shooting.', NULL);
INSERT INTO white_cards VALUES (217, 'Ronald Reagan.', NULL);
INSERT INTO white_cards VALUES (195, 'Jewish fraternities.', NULL);
INSERT INTO white_cards VALUES (198, 'All-you-can-eat shrimp for $4.99.', NULL);
INSERT INTO white_cards VALUES (233, 'Scalping.', NULL);
INSERT INTO white_cards VALUES (196, 'Edible underpants.', NULL);
INSERT INTO white_cards VALUES (154, 'Figgy pudding.', NULL);
INSERT INTO white_cards VALUES (240, 'Intelligent design.', NULL);
INSERT INTO white_cards VALUES (207, 'Nocturnal emissions.', NULL);
INSERT INTO white_cards VALUES (119, 'Uppercuts.', NULL);
INSERT INTO white_cards VALUES (180, 'The American Dream.', NULL);
INSERT INTO white_cards VALUES (226, 'Testicular torsion.', NULL);
INSERT INTO white_cards VALUES (201, 'The folly of man.', NULL);
INSERT INTO white_cards VALUES (153, 'The KKK.', NULL);
INSERT INTO white_cards VALUES (241, 'The taint; the grundle; the fleshy fun-bridge.', NULL);
INSERT INTO white_cards VALUES (237, 'Saxophone solos.', NULL);
INSERT INTO white_cards VALUES (200, 'That thing that electrocutes your abs.', NULL);
INSERT INTO white_cards VALUES (176, 'Oversized lollipops.', NULL);
INSERT INTO white_cards VALUES (161, 'Friends with benefits.', NULL);
INSERT INTO white_cards VALUES (137, 'Teaching a robot to love.', NULL);
INSERT INTO white_cards VALUES (205, 'Me time.', NULL);
INSERT INTO white_cards VALUES (250, 'The heart of a child.', NULL);
INSERT INTO white_cards VALUES (252, 'Smallpox blankets.', NULL);
INSERT INTO white_cards VALUES (127, 'Yeast.', NULL);
INSERT INTO white_cards VALUES (214, 'Full frontal nudity.', NULL);
INSERT INTO white_cards VALUES (175, 'Authentic Mexican cuisine.', NULL);
INSERT INTO white_cards VALUES (253, 'Licking things to claim them as your own.', NULL);
INSERT INTO white_cards VALUES (174, 'Genghis Khan.', NULL);
INSERT INTO white_cards VALUES (209, 'The hardworking Mexican.', NULL);
INSERT INTO white_cards VALUES (189, 'RoboCop.', NULL);
INSERT INTO white_cards VALUES (112, 'Spontaneous human combustion.', NULL);
INSERT INTO white_cards VALUES (128, 'Natural selection.', NULL);
INSERT INTO white_cards VALUES (245, 'A good sniff.', NULL);
INSERT INTO white_cards VALUES (212, 'Nipple blades.', NULL);
INSERT INTO white_cards VALUES (126, 'Leaving an awkward voicemail.', NULL);
INSERT INTO white_cards VALUES (213, 'Assless chaps.', NULL);
INSERT INTO white_cards VALUES (191, 'Sweet, sweet vengeance.', NULL);
INSERT INTO white_cards VALUES (243, 'Keg stands.', NULL);
INSERT INTO white_cards VALUES (232, 'Darth Vader.', NULL);
INSERT INTO white_cards VALUES (114, 'Necrophilia.', NULL);
INSERT INTO white_cards VALUES (144, 'Toni Morrison''s vagina.', NULL);
INSERT INTO white_cards VALUES (159, 'Preteens.', NULL);
INSERT INTO white_cards VALUES (185, 'A cooler full of organs.', NULL);
INSERT INTO white_cards VALUES (178, 'Keanu Reeves.', NULL);
INSERT INTO white_cards VALUES (166, 'A thermonuclear detonation.', NULL);
INSERT INTO white_cards VALUES (186, 'A moment of silence.', NULL);
INSERT INTO white_cards VALUES (142, 'Catapults.', NULL);
INSERT INTO white_cards VALUES (118, 'Emotions.', NULL);
INSERT INTO white_cards VALUES (151, 'Balls.', NULL);
INSERT INTO white_cards VALUES (234, 'Homeless people.', NULL);
INSERT INTO white_cards VALUES (173, 'Old-people smell.', NULL);
INSERT INTO white_cards VALUES (117, 'Farting and walking away.', NULL);
INSERT INTO white_cards VALUES (206, 'The inevitable heat death of the universe.', NULL);
INSERT INTO white_cards VALUES (24, 'The Rev. Dr. Martin Luther King, Jr.', NULL);
INSERT INTO white_cards VALUES (136, 'Sperm whales.', NULL);
INSERT INTO white_cards VALUES (204, 'A murder most foul.', NULL);
INSERT INTO white_cards VALUES (208, 'Daddy issues.', NULL);
INSERT INTO white_cards VALUES (199, 'Britney Spears at 55.', NULL);
INSERT INTO white_cards VALUES (210, 'Natalie Portman.', NULL);
INSERT INTO white_cards VALUES (223, 'The Holy Bible.', NULL);
INSERT INTO white_cards VALUES (3678, 'LOOK AT THIS PHOTOGRAPH!', 'RS');
INSERT INTO white_cards VALUES (220, 'Pulling out.', NULL);
INSERT INTO white_cards VALUES (163, 'Pixelated bukkake.', NULL);
INSERT INTO white_cards VALUES (168, 'Waiting ''til marriage.', NULL);
INSERT INTO white_cards VALUES (235, 'The World of Warcraft.', NULL);
INSERT INTO white_cards VALUES (116, 'Global warming.', NULL);
INSERT INTO white_cards VALUES (224, 'World peace.', NULL);
INSERT INTO white_cards VALUES (170, 'A can of whoop-ass.', NULL);
INSERT INTO white_cards VALUES (148, 'A zesty breakfast burrito.', NULL);
INSERT INTO white_cards VALUES (221, 'Picking up girls at the abortion clinic.', NULL);
INSERT INTO white_cards VALUES (146, 'Land mines.', NULL);
INSERT INTO white_cards VALUES (113, 'College.', NULL);
INSERT INTO white_cards VALUES (228, 'A time travel paradox.', NULL);
INSERT INTO white_cards VALUES (155, 'Seppuku.', NULL);
INSERT INTO white_cards VALUES (211, 'Waking up half-naked in a Denny''s parking lot.', NULL);
INSERT INTO white_cards VALUES (149, 'Christopher Walken.', NULL);
INSERT INTO white_cards VALUES (236, 'Gloryholes.', NULL);
INSERT INTO white_cards VALUES (169, 'A tiny horse.', NULL);
INSERT INTO white_cards VALUES (184, 'Child abuse.', NULL);
INSERT INTO white_cards VALUES (219, 'Menstruation.', NULL);
INSERT INTO white_cards VALUES (135, 'A sassy black woman.', NULL);
INSERT INTO white_cards VALUES (162, 'Re-gifting.', NULL);
INSERT INTO white_cards VALUES (122, 'Penis envy.', NULL);
INSERT INTO white_cards VALUES (179, 'Drinking alone.', NULL);
INSERT INTO white_cards VALUES (215, 'Hulk Hogan.', NULL);
INSERT INTO white_cards VALUES (3679, 'A 1971 Ford Pinto.', 'RS');
INSERT INTO white_cards VALUES (140, 'Whipping it out.', NULL);
INSERT INTO white_cards VALUES (171, 'Dental dams.', NULL);
INSERT INTO white_cards VALUES (157, 'Gandhi.', NULL);
INSERT INTO white_cards VALUES (239, 'God.', NULL);
INSERT INTO white_cards VALUES (150, 'Friction.', NULL);
INSERT INTO white_cards VALUES (147, 'A sea of troubles.', NULL);
INSERT INTO white_cards VALUES (197, 'Poor people.', NULL);
INSERT INTO white_cards VALUES (183, 'Flesh-eating bacteria.', NULL);
INSERT INTO white_cards VALUES (125, 'Dick Cheney.', NULL);
INSERT INTO white_cards VALUES (246, 'Lockjaw.', NULL);
INSERT INTO white_cards VALUES (165, 'Take-backsies.', NULL);
INSERT INTO white_cards VALUES (132, 'Opposable thumbs.', NULL);
INSERT INTO white_cards VALUES (222, 'The homosexual agenda.', NULL);
INSERT INTO white_cards VALUES (202, 'Fiery poops.', NULL);
INSERT INTO white_cards VALUES (203, 'Cards Against Humanity.', NULL);
INSERT INTO white_cards VALUES (3680, 'Shitting on the White House lawn.', 'RS');
INSERT INTO white_cards VALUES (238, 'Sean Connery.', NULL);
INSERT INTO white_cards VALUES (227, 'The milk man.', NULL);
INSERT INTO white_cards VALUES (115, 'The Chinese gymnastics team.', NULL);
INSERT INTO white_cards VALUES (231, 'Eating the last known bison.', NULL);
INSERT INTO white_cards VALUES (134, 'Soiling oneself.', NULL);
INSERT INTO white_cards VALUES (182, 'Giving 110%.', NULL);
INSERT INTO white_cards VALUES (242, 'Friendly fire.', NULL);
INSERT INTO white_cards VALUES (111, 'Count Chocula.', NULL);
INSERT INTO white_cards VALUES (172, 'Feeding Rosie O''Donnell.', NULL);
INSERT INTO white_cards VALUES (251, 'Seduction.', NULL);
INSERT INTO white_cards VALUES (194, 'Being a motherfucking sorcerer.', NULL);
INSERT INTO white_cards VALUES (264, 'Eastern European Turbo-Folk music.', NULL);
INSERT INTO white_cards VALUES (273, 'Douchebags on their iPhones.', NULL);
INSERT INTO white_cards VALUES (281, 'The deformed.', NULL);
INSERT INTO white_cards VALUES (285, 'Donald Trump.', NULL);
INSERT INTO white_cards VALUES (288, 'This answer is postmodern.', NULL);
INSERT INTO white_cards VALUES (301, 'African children.', NULL);
INSERT INTO white_cards VALUES (307, 'Have some more kugel.', NULL);
INSERT INTO white_cards VALUES (310, 'Crippling debt.', NULL);
INSERT INTO white_cards VALUES (313, 'Shorties and blunts.', NULL);
INSERT INTO white_cards VALUES (328, '(I am doing Kegels right now.)', NULL);
INSERT INTO white_cards VALUES (331, 'Bestiality.', NULL);
INSERT INTO white_cards VALUES (333, 'Drum circles.', NULL);
INSERT INTO white_cards VALUES (338, 'Inappropriate yelling.', NULL);
INSERT INTO white_cards VALUES (341, 'The Thong Song.', NULL);
INSERT INTO white_cards VALUES (342, 'A vajazzled vagina.', NULL);
INSERT INTO white_cards VALUES (3681, 'Mountain Dew&reg; Baja Blast.', 'RS');
INSERT INTO white_cards VALUES (3682, 'Nessie.', 'RS');
INSERT INTO white_cards VALUES (363, 'Tiger Woods.', NULL);
INSERT INTO white_cards VALUES (371, 'PCP.', NULL);
INSERT INTO white_cards VALUES (383, 'Mr. Snuffleupagus.', NULL);
INSERT INTO white_cards VALUES (394, 'A disappointing birthday party.', NULL);
INSERT INTO white_cards VALUES (319, 'Puppies!', NULL);
INSERT INTO white_cards VALUES (308, 'A windmill full of corpses.', NULL);
INSERT INTO white_cards VALUES (340, 'Being on fire.', NULL);
INSERT INTO white_cards VALUES (372, 'A lifetime of sadness.', NULL);
INSERT INTO white_cards VALUES (258, 'Pterodactyl eggs.', NULL);
INSERT INTO white_cards VALUES (289, 'Crumpets with the Queen.', NULL);
INSERT INTO white_cards VALUES (344, 'Exchanging pleasantries.', NULL);
INSERT INTO white_cards VALUES (276, 'Republicans.', NULL);
INSERT INTO white_cards VALUES (321, 'Kim Jong-il.', NULL);
INSERT INTO white_cards VALUES (366, 'Glenn Beck being harried by a swarm of buzzards.', NULL);
INSERT INTO white_cards VALUES (254, 'A salty surprise.', NULL);
INSERT INTO white_cards VALUES (330, 'The Jews.', NULL);
INSERT INTO white_cards VALUES (324, 'Incest.', NULL);
INSERT INTO white_cards VALUES (3683, 'Princess Peach''s Cake.', 'RS');
INSERT INTO white_cards VALUES (391, 'Nazis.', NULL);
INSERT INTO white_cards VALUES (292, 'Repression.', NULL);
INSERT INTO white_cards VALUES (287, 'Attitude.', NULL);
INSERT INTO white_cards VALUES (361, 'Passable transvestites.', NULL);
INSERT INTO white_cards VALUES (395, 'Puberty.', NULL);
INSERT INTO white_cards VALUES (374, 'Swooping.', NULL);
INSERT INTO white_cards VALUES (4221, 'Rob Liefeld.', 'TGWTG');
INSERT INTO white_cards VALUES (379, 'A look-see.', NULL);
INSERT INTO white_cards VALUES (348, 'Lactation.', NULL);
INSERT INTO white_cards VALUES (266, 'Pabst Blue Ribbon.', NULL);
INSERT INTO white_cards VALUES (357, 'The gays.', NULL);
INSERT INTO white_cards VALUES (278, 'A foul mouth.', NULL);
INSERT INTO white_cards VALUES (377, 'A hot mess.', NULL);
INSERT INTO white_cards VALUES (268, 'My collection of high-tech sex toys.', NULL);
INSERT INTO white_cards VALUES (318, 'Bees?', NULL);
INSERT INTO white_cards VALUES (388, 'Getting drunk on mouthwash.', NULL);
INSERT INTO white_cards VALUES (277, 'The glass ceiling.', NULL);
INSERT INTO white_cards VALUES (286, 'Sarah Palin.', NULL);
INSERT INTO white_cards VALUES (291, 'Team-building exercises.', NULL);
INSERT INTO white_cards VALUES (290, 'Frolicking.', NULL);
INSERT INTO white_cards VALUES (380, 'Not giving a shit about the Third World.', NULL);
INSERT INTO white_cards VALUES (345, 'My relationship status.', NULL);
INSERT INTO white_cards VALUES (384, 'Barack Obama.', NULL);
INSERT INTO white_cards VALUES (302, 'Mouth herpes.', NULL);
INSERT INTO white_cards VALUES (386, 'Wiping her butt.', NULL);
INSERT INTO white_cards VALUES (263, 'Pedophiles.', NULL);
INSERT INTO white_cards VALUES (373, 'Doin'' it in the butt.', NULL);
INSERT INTO white_cards VALUES (347, 'Being fabulous.', NULL);
INSERT INTO white_cards VALUES (389, 'An M. Night Shyamalan plot twist.', NULL);
INSERT INTO white_cards VALUES (294, 'A bag of magic beans.', NULL);
INSERT INTO white_cards VALUES (296, 'Dead parents.', NULL);
INSERT INTO white_cards VALUES (257, 'My sex life.', NULL);
INSERT INTO white_cards VALUES (343, 'Riding off into the sunset.', NULL);
INSERT INTO white_cards VALUES (364, 'Dick fingers.', NULL);
INSERT INTO white_cards VALUES (362, 'The Virginia Tech Massacre.', NULL);
INSERT INTO white_cards VALUES (387, 'Queefing.', NULL);
INSERT INTO white_cards VALUES (339, 'Tangled Slinkys.', NULL);
INSERT INTO white_cards VALUES (337, 'Civilian casualties.', NULL);
INSERT INTO white_cards VALUES (316, 'Leprosy.', NULL);
INSERT INTO white_cards VALUES (325, 'Grave robbing.', NULL);
INSERT INTO white_cards VALUES (376, 'Tentacle porn.', NULL);
INSERT INTO white_cards VALUES (304, 'Bill Nye the Science Guy.', NULL);
INSERT INTO white_cards VALUES (370, 'New Age music.', NULL);
INSERT INTO white_cards VALUES (261, '72 virgins.', NULL);
INSERT INTO white_cards VALUES (322, 'Hope.', NULL);
INSERT INTO white_cards VALUES (314, 'Passing a kidney stone.', NULL);
INSERT INTO white_cards VALUES (299, 'A mime having a stroke.', NULL);
INSERT INTO white_cards VALUES (368, 'Classist undertones.', NULL);
INSERT INTO white_cards VALUES (298, 'A mating display.', NULL);
INSERT INTO white_cards VALUES (382, 'The Kool-Aid Man.', NULL);
INSERT INTO white_cards VALUES (349, 'Not reciprocating oral sex.', NULL);
INSERT INTO white_cards VALUES (352, 'Date rape.', NULL);
INSERT INTO white_cards VALUES (306, 'Italians.', NULL);
INSERT INTO white_cards VALUES (256, 'My soul.', NULL);
INSERT INTO white_cards VALUES (3684, 'Two midgets stacked up pretending to be one person.', 'RS');
INSERT INTO white_cards VALUES (312, 'A stray pube.', NULL);
INSERT INTO white_cards VALUES (279, 'Jerking off into a pool of children''s tears.', NULL);
INSERT INTO white_cards VALUES (280, 'Getting really high.', NULL);
INSERT INTO white_cards VALUES (378, 'Too much hair gel.', NULL);
INSERT INTO white_cards VALUES (303, 'Overcompensation.', NULL);
INSERT INTO white_cards VALUES (272, 'Free samples.', NULL);
INSERT INTO white_cards VALUES (346, 'Shaquille O''Neal''s acting career.', NULL);
INSERT INTO white_cards VALUES (271, 'Half-assed foreplay.', NULL);
INSERT INTO white_cards VALUES (283, 'Explosions.', NULL);
INSERT INTO white_cards VALUES (392, 'White privilege.', NULL);
INSERT INTO white_cards VALUES (293, 'Road head.', NULL);
INSERT INTO white_cards VALUES (255, 'Poorly-timed Holocaust jokes.', NULL);
INSERT INTO white_cards VALUES (323, '8 oz. of sweet Mexican black-tar heroin.', NULL);
INSERT INTO white_cards VALUES (355, 'Judge Judy.', NULL);
INSERT INTO white_cards VALUES (259, 'Altar boys.', NULL);
INSERT INTO white_cards VALUES (358, 'Scientology.', NULL);
INSERT INTO white_cards VALUES (329, 'Justin Bieber.', NULL);
INSERT INTO white_cards VALUES (327, 'Alcoholism.', NULL);
INSERT INTO white_cards VALUES (351, 'My genitals.', NULL);
INSERT INTO white_cards VALUES (332, 'Winking at old people.', NULL);
INSERT INTO white_cards VALUES (385, 'Golden showers.', NULL);
INSERT INTO white_cards VALUES (365, 'Racism.', NULL);
INSERT INTO white_cards VALUES (336, 'Auschwitz.', NULL);
INSERT INTO white_cards VALUES (262, 'Raping and pillaging.', NULL);
INSERT INTO white_cards VALUES (334, 'Kids with ass cancer.', NULL);
INSERT INTO white_cards VALUES (274, 'Hurricane Katrina.', NULL);
INSERT INTO white_cards VALUES (356, 'Lumberjack fantasies.', NULL);
INSERT INTO white_cards VALUES (381, 'American Gladiators.', NULL);
INSERT INTO white_cards VALUES (295, 'An asymmetric boob job.', NULL);
INSERT INTO white_cards VALUES (326, 'Asians who aren''t good at math.', NULL);
INSERT INTO white_cards VALUES (335, 'Loose lips.', NULL);
INSERT INTO white_cards VALUES (270, 'The Blood of Christ.', NULL);
INSERT INTO white_cards VALUES (317, 'A brain tumor.', NULL);
INSERT INTO white_cards VALUES (315, 'Prancing.', NULL);
INSERT INTO white_cards VALUES (375, 'The Hamburglar.', NULL);
INSERT INTO white_cards VALUES (360, 'Police brutality.', NULL);
INSERT INTO white_cards VALUES (260, 'Forgetting the Alamo.', NULL);
INSERT INTO white_cards VALUES (369, 'Booby-trapping the house to foil burglars.', NULL);
INSERT INTO white_cards VALUES (359, 'Estrogen.', NULL);
INSERT INTO white_cards VALUES (390, 'A robust mongoloid.', NULL);
INSERT INTO white_cards VALUES (309, 'Her Royal Highness, Queen Elizabeth II.', NULL);
INSERT INTO white_cards VALUES (193, 'Pooping back and forth. Forever.', NULL);
INSERT INTO white_cards VALUES (320, 'Cockfights.', NULL);
INSERT INTO white_cards VALUES (305, 'Bitches.', NULL);
INSERT INTO white_cards VALUES (300, 'Stephen Hawking talking dirty.', NULL);
INSERT INTO white_cards VALUES (403, 'Those times when you get sand in your vagina.', NULL);
INSERT INTO white_cards VALUES (424, 'Faith healing.', NULL);
INSERT INTO white_cards VALUES (428, 'Impotence.', NULL);
INSERT INTO white_cards VALUES (454, 'Bananas in Pajamas.', NULL);
INSERT INTO white_cards VALUES (399, 'Getting so angry that you pop a boner.', NULL);
INSERT INTO white_cards VALUES (414, 'Tasteful sideboob.', NULL);
INSERT INTO white_cards VALUES (396, 'Two midgets shitting into a bucket.', NULL);
INSERT INTO white_cards VALUES (406, 'Racially-biased SAT questions.', NULL);
INSERT INTO white_cards VALUES (449, 'Glenn Beck catching his scrotum on a curtain hook.', NULL);
INSERT INTO white_cards VALUES (398, 'The forbidden fruit.', NULL);
INSERT INTO white_cards VALUES (459, 'Anal beads.', NULL);
INSERT INTO white_cards VALUES (367, 'Surprise sex!', NULL);
INSERT INTO white_cards VALUES (426, 'Dead babies.', NULL);
INSERT INTO white_cards VALUES (129, 'Masturbation.', NULL);
INSERT INTO white_cards VALUES (452, 'The Hustle.', NULL);
INSERT INTO white_cards VALUES (3685, 'Apples to Apples&reg;.', 'RS');
INSERT INTO white_cards VALUES (409, 'Obesity.', NULL);
INSERT INTO white_cards VALUES (429, 'Child beauty pageants.', NULL);
INSERT INTO white_cards VALUES (422, 'Goats eating coins.', NULL);
INSERT INTO white_cards VALUES (457, 'Kamikaze pilots.', NULL);
INSERT INTO white_cards VALUES (443, 'Powerful thighs.', NULL);
INSERT INTO white_cards VALUES (450, 'A big hoopla about nothing.', NULL);
INSERT INTO white_cards VALUES (433, 'Women''s suffrage.', NULL);
INSERT INTO white_cards VALUES (442, 'John Wilkes Booth.', NULL);
INSERT INTO white_cards VALUES (425, 'Parting the Red Sea.', NULL);
INSERT INTO white_cards VALUES (435, 'Harry Potter erotica.', NULL);
INSERT INTO white_cards VALUES (416, 'Grandma.', NULL);
INSERT INTO white_cards VALUES (407, 'Porn stars.', NULL);
INSERT INTO white_cards VALUES (423, 'A monkey smoking a cigar.', NULL);
INSERT INTO white_cards VALUES (439, 'Mathletes.', NULL);
INSERT INTO white_cards VALUES (437, 'Lance Armstrong''s missing testicle.', NULL);
INSERT INTO white_cards VALUES (434, 'Children on leashes.', NULL);
INSERT INTO white_cards VALUES (445, 'Multiple stab wounds.', NULL);
INSERT INTO white_cards VALUES (411, 'Oompa-Loompas.', NULL);
INSERT INTO white_cards VALUES (451, 'Peeing a little bit.', NULL);
INSERT INTO white_cards VALUES (421, 'The miracle of childbirth.', NULL);
INSERT INTO white_cards VALUES (448, 'Another goddamn vampire movie.', NULL);
INSERT INTO white_cards VALUES (3686, 'The tears of a college student.', 'RS');
INSERT INTO white_cards VALUES (455, 'Active listening.', NULL);
INSERT INTO white_cards VALUES (402, 'A gassy antelope.', NULL);
INSERT INTO white_cards VALUES (412, 'BATMAN!!!', NULL);
INSERT INTO white_cards VALUES (413, 'Black people.', NULL);
INSERT INTO white_cards VALUES (447, 'Serfdom.', NULL);
INSERT INTO white_cards VALUES (418, 'The Trail of Tears.', NULL);
INSERT INTO white_cards VALUES (453, 'Ghosts.', NULL);
INSERT INTO white_cards VALUES (436, 'The Dance of the Sugar Plum Fairy.', NULL);
INSERT INTO white_cards VALUES (420, 'Finger painting.', NULL);
INSERT INTO white_cards VALUES (249, 'Robert Downey, Jr.', NULL);
INSERT INTO white_cards VALUES (405, 'Muhammed (Praise Be Unto Him).', NULL);
INSERT INTO white_cards VALUES (419, 'Famine.', NULL);
INSERT INTO white_cards VALUES (431, 'AXE Body Spray.', NULL);
INSERT INTO white_cards VALUES (458, 'The Force.', NULL);
INSERT INTO white_cards VALUES (446, 'Cybernetic enhancements.', NULL);
INSERT INTO white_cards VALUES (444, 'Mr. Clean, right behind you.', NULL);
INSERT INTO white_cards VALUES (401, 'Third base.', NULL);
INSERT INTO white_cards VALUES (438, 'Dwarf tossing.', NULL);
INSERT INTO white_cards VALUES (408, 'A fetus.', NULL);
INSERT INTO white_cards VALUES (441, 'Women in yogurt commercials.', NULL);
INSERT INTO white_cards VALUES (417, 'Copping a feel.', NULL);
INSERT INTO white_cards VALUES (400, 'Sexual tension.', NULL);
INSERT INTO white_cards VALUES (456, 'Dry heaving.', NULL);
INSERT INTO white_cards VALUES (430, 'Centaurs.', NULL);
INSERT INTO white_cards VALUES (397, 'Wifely duties.', NULL);
INSERT INTO white_cards VALUES (415, 'Hot people.', NULL);
INSERT INTO white_cards VALUES (432, 'Kanye West.', NULL);
INSERT INTO white_cards VALUES (427, 'The Amish.', NULL);
INSERT INTO white_cards VALUES (410, 'When you fart and a little bit comes out.', NULL);
INSERT INTO white_cards VALUES (1084, 'Bosnian chicken farmers.', 'X1');
INSERT INTO white_cards VALUES (1085, 'Nubile slave boys.', 'X1');
INSERT INTO white_cards VALUES (1086, 'Carnies.', 'X1');
INSERT INTO white_cards VALUES (1087, 'Coughing into a vagina.', 'X1');
INSERT INTO white_cards VALUES (1088, 'Suicidal thoughts.', 'X1');
INSERT INTO white_cards VALUES (1089, 'Dancing with a broom.', 'X1');
INSERT INTO white_cards VALUES (1090, 'Deflowering the princess.', 'X1');
INSERT INTO white_cards VALUES (1091, 'Dorito breath.', 'X1');
INSERT INTO white_cards VALUES (1092, 'Eating an albino.', 'X1');
INSERT INTO white_cards VALUES (1093, 'Enormous Scandinavian women.', 'X1');
INSERT INTO white_cards VALUES (1094, 'Fabricating statistics.', 'X1');
INSERT INTO white_cards VALUES (1095, 'Finding a skeleton.', 'X1');
INSERT INTO white_cards VALUES (1096, 'Gandalf.', 'X1');
INSERT INTO white_cards VALUES (1097, 'Genetically engineered super-soldiers.', 'X1');
INSERT INTO white_cards VALUES (1098, 'George Clooney''s musk.', 'X1');
INSERT INTO white_cards VALUES (1099, 'Getting abducted by Peter Pan.', 'X1');
INSERT INTO white_cards VALUES (1100, 'Getting in her pants, politely.', 'X1');
INSERT INTO white_cards VALUES (1101, 'Gladiatorial combat.', 'X1');
INSERT INTO white_cards VALUES (1102, 'Good grammar.', 'X1');
INSERT INTO white_cards VALUES (1103, 'Hipsters.', 'X1');
INSERT INTO white_cards VALUES (1104, 'Historical revisionism.', 'X1');
INSERT INTO white_cards VALUES (1105, 'Insatiable bloodlust.', 'X1');
INSERT INTO white_cards VALUES (1106, 'Jafar.', 'X1');
INSERT INTO white_cards VALUES (1107, 'Jean-Claude Van Damme.', 'X1');
INSERT INTO white_cards VALUES (1108, 'Just the tip.', 'X1');
INSERT INTO white_cards VALUES (1109, 'Mad hacky-sack skills.', 'X1');
INSERT INTO white_cards VALUES (1224, 'Beefin'' over turf.', 'X2');
INSERT INTO white_cards VALUES (1225, 'A squadron of moles wearing aviator goggles.', 'X2');
INSERT INTO white_cards VALUES (1464, 'Santa''s heavy sack.', '❄');
INSERT INTO white_cards VALUES (1465, 'Clearing a bloody path through Walmart with a scimitar.', '❄');
INSERT INTO white_cards VALUES (1466, 'Another shitty year.', '❄');
INSERT INTO white_cards VALUES (1467, 'Whatever Kwanzaa is supposed to be about.', '❄');
INSERT INTO white_cards VALUES (1468, 'A Christmas stocking full of coleslaw.', '❄');
INSERT INTO white_cards VALUES (1469, 'Elf cum.', '❄');
INSERT INTO white_cards VALUES (1470, 'The tiny, calloused hands of the Chinese children that made this card.', '❄');
INSERT INTO white_cards VALUES (1471, 'Taking down Santa with a surface-to-air missle.', '❄');
INSERT INTO white_cards VALUES (1473, 'Socks. ', '❄');
INSERT INTO white_cards VALUES (1474, 'Pretending to be happy.', '❄');
INSERT INTO white_cards VALUES (1475, 'Krampus, the Austrian Christmas monster.', '❄');
INSERT INTO white_cards VALUES (1476, 'The Star Wars Holiday Special.', '❄');
INSERT INTO white_cards VALUES (11, 'Viagra&reg;.', NULL);
INSERT INTO white_cards VALUES (1478, 'Mall Santa.', '❄');
INSERT INTO white_cards VALUES (1479, 'Several intertwining love stories featuring Hugh Grant.', '❄');
INSERT INTO white_cards VALUES (1481, 'Gift-wrapping a live hamster.', '❄');
INSERT INTO white_cards VALUES (1482, 'Space Jam on VHS.', '❄');
INSERT INTO white_cards VALUES (1483, 'Immaculate conception.', '❄');
INSERT INTO white_cards VALUES (1484, 'Fucking up "Silent Night" in front of 300 parents.', '❄');
INSERT INTO white_cards VALUES (1485, 'A visually arresting turtleneck.', '❄');
INSERT INTO white_cards VALUES (1486, 'A toxic family environment.', '❄');
INSERT INTO white_cards VALUES (1487, 'Eating an entire snowman.', '❄');
INSERT INTO white_cards VALUES (3687, 'Mr. Hankey the Christmas Poo.', 'RS');
INSERT INTO white_cards VALUES (509, 'Show me your tits!', 'VS');
INSERT INTO white_cards VALUES (510, 'Thanking your sex slaves.', 'VS');
INSERT INTO white_cards VALUES (511, 'Dickcheese.', 'VS');
INSERT INTO white_cards VALUES (512, 'Googly eyes on a cock.', 'VS');
INSERT INTO white_cards VALUES (513, 'Typing with your genitals.', 'VS');
INSERT INTO white_cards VALUES (514, 'Pirate hookers.', 'VS');
INSERT INTO white_cards VALUES (515, 'Poopcake.', 'VS');
INSERT INTO white_cards VALUES (516, 'Mandatory Sex Party.', 'VS');
INSERT INTO white_cards VALUES (517, 'A WHOLE GALLON.', 'VS');
INSERT INTO white_cards VALUES (518, 'Games you can play with bricks.', 'VS');
INSERT INTO white_cards VALUES (519, 'Lewhora.', 'VS');
INSERT INTO white_cards VALUES (520, 'Fancy tampons.', 'VS');
INSERT INTO white_cards VALUES (521, 'Very Serious Island.', 'VS');
INSERT INTO white_cards VALUES (522, 'COLLIN.', 'VS');
INSERT INTO white_cards VALUES (523, 'Ferngully.', 'VS');
INSERT INTO white_cards VALUES (524, 'Velociraptor.', 'VS');
INSERT INTO white_cards VALUES (525, 'Thundercunting.', 'VS');
INSERT INTO white_cards VALUES (526, 'Werewolf.', 'VS');
INSERT INTO white_cards VALUES (527, 'Cultist.', 'VS');
INSERT INTO white_cards VALUES (528, 'Vejazzled vagina.', 'VS');
INSERT INTO white_cards VALUES (529, 'HODOR.', 'VS');
INSERT INTO white_cards VALUES (530, 'Simple dog.', 'VS');
INSERT INTO white_cards VALUES (531, 'Butt oranges.', 'VS');
INSERT INTO white_cards VALUES (532, 'Sweater kittens.', 'VS');
INSERT INTO white_cards VALUES (533, 'Baby batter.', 'VS');
INSERT INTO white_cards VALUES (534, 'Meat curtains.', 'VS');
INSERT INTO white_cards VALUES (535, 'Strawberry Shortcake sexing up a Carebear and giving birth to NyanCat.', 'VS');
INSERT INTO white_cards VALUES (536, 'Blowjob Jesus.', 'VS');
INSERT INTO white_cards VALUES (537, 'GOATS.', 'VS');
INSERT INTO white_cards VALUES (538, 'Welcome Taco.', 'VS');
INSERT INTO white_cards VALUES (539, 'Boobs.', 'VS');
INSERT INTO white_cards VALUES (540, 'Moobs.', 'VS');
INSERT INTO white_cards VALUES (541, 'Tinychat.', 'VS');
INSERT INTO white_cards VALUES (542, 'Centaur Therapist Jesus.', 'VS');
INSERT INTO white_cards VALUES (543, 'LOUD NOISES.', 'VS');
INSERT INTO white_cards VALUES (544, 'THE GODDAMN BATMAN.', 'VS');
INSERT INTO white_cards VALUES (545, 'Swinging an axe in the air while cornholing a bear.', 'VS');
INSERT INTO white_cards VALUES (546, 'WIIINES.', 'VS');
INSERT INTO white_cards VALUES (547, 'A Wende head tilt.', 'VS');
INSERT INTO white_cards VALUES (548, 'Chris Gaines.', 'VS');
INSERT INTO white_cards VALUES (549, 'Fuck you, I''m a bear.', 'VS');
INSERT INTO white_cards VALUES (550, 'Doctor Who.', 'VS');
INSERT INTO white_cards VALUES (551, 'EXTERMINATE.', 'VS');
INSERT INTO white_cards VALUES (552, 'Landshark.', 'VS');
INSERT INTO white_cards VALUES (553, 'Bearshark.', 'VS');
INSERT INTO white_cards VALUES (554, 'SCIENCE!!1!', 'VS');
INSERT INTO white_cards VALUES (555, 'The Great Dildo, Thor.', 'VS');
INSERT INTO white_cards VALUES (556, 'Just the tip!', 'VS');
INSERT INTO white_cards VALUES (557, 'Daddy foam.', 'VS');
INSERT INTO white_cards VALUES (558, 'PooooooP!', 'VS');
INSERT INTO white_cards VALUES (10001, 'Dragon dildos.', 'Furry');
INSERT INTO white_cards VALUES (560, 'Buttpirate Pokemon.', 'VS');
INSERT INTO white_cards VALUES (561, 'A really good booby weight.', 'VS');
INSERT INTO white_cards VALUES (562, 'Tubemonster.', 'VS');
INSERT INTO white_cards VALUES (563, 'Bevis.', 'VS');
INSERT INTO white_cards VALUES (564, 'Trouser snakes.', 'VS');
INSERT INTO white_cards VALUES (565, 'A WHOLE GALLON OF BOOBS.', 'VS');
INSERT INTO white_cards VALUES (566, 'Barfstab.', 'VS');
INSERT INTO white_cards VALUES (567, 'LYNCH LUPUS.', 'VS');
INSERT INTO white_cards VALUES (568, 'Drinking on live TV.', 'VS');
INSERT INTO white_cards VALUES (569, 'Shooting heroin into my eyeballs.', 'VS');
INSERT INTO white_cards VALUES (570, 'Skittering ovaries.', 'VS');
INSERT INTO white_cards VALUES (571, 'Ricardo.', 'VS');
INSERT INTO white_cards VALUES (572, 'The Power of Greyskull.', 'VS');
INSERT INTO white_cards VALUES (573, 'The revolution.', 'VS');
INSERT INTO white_cards VALUES (574, 'The establishment.', 'VS');
INSERT INTO white_cards VALUES (575, 'Queer Lesbian Jesus.', 'VS');
INSERT INTO white_cards VALUES (576, 'Hello Kitty.', 'VS');
INSERT INTO white_cards VALUES (577, 'Readying my torch for burnination.', 'VS');
INSERT INTO white_cards VALUES (578, 'Tots.', 'VS');
INSERT INTO white_cards VALUES (579, 'Getting drunk before noon.', 'VS');
INSERT INTO white_cards VALUES (580, 'In a sneaky hate spiral.', 'VS');
INSERT INTO white_cards VALUES (581, 'Clown strippers.', 'VS');
INSERT INTO white_cards VALUES (582, 'KERMIT FLAIL.', 'VS');
INSERT INTO white_cards VALUES (583, 'Certified Breast Maintenance Engineer.', 'VS');
INSERT INTO white_cards VALUES (584, 'A test tube baby.', 'VS');
INSERT INTO white_cards VALUES (585, 'Dancing naked.', 'VS');
INSERT INTO white_cards VALUES (586, 'Moist and Juicy.', 'VS');
INSERT INTO white_cards VALUES (587, 'Orgy.', 'VS');
INSERT INTO white_cards VALUES (588, 'Premature ejaculation.', 'VS');
INSERT INTO white_cards VALUES (589, 'Bounty, the Quicker Picker Upper.', 'VS');
INSERT INTO white_cards VALUES (590, 'Lotion.', 'VS');
INSERT INTO white_cards VALUES (591, 'Rapey dolphin.', 'VS');
INSERT INTO white_cards VALUES (592, 'Werepoo.', 'VS');
INSERT INTO white_cards VALUES (593, 'Handbra.', 'VS');
INSERT INTO white_cards VALUES (594, 'A moose giving birth in Maggly''s yard.', 'VS');
INSERT INTO white_cards VALUES (595, 'More bandaids.', 'VS');
INSERT INTO white_cards VALUES (596, 'Fuckweasel.', 'VS');
INSERT INTO white_cards VALUES (597, 'Curious hands.', 'VS');
INSERT INTO white_cards VALUES (598, 'Spagbag.', 'VS');
INSERT INTO white_cards VALUES (599, 'Tears of manly pain.', 'VS');
INSERT INTO white_cards VALUES (130, 'Twinkies&reg;.', NULL);
INSERT INTO white_cards VALUES (600, 'Cthulu.', 'VS');
INSERT INTO white_cards VALUES (601, 'Surprise penis.', 'VS');
INSERT INTO white_cards VALUES (602, 'SEX.', 'VS');
INSERT INTO white_cards VALUES (603, 'Mr. Tinycheeks.', 'VS');
INSERT INTO white_cards VALUES (604, 'A spoon that is too big.', 'VS');
INSERT INTO white_cards VALUES (605, 'Bleeding Anuses.', 'VS');
INSERT INTO white_cards VALUES (606, 'Not being pregnant.', 'VS');
INSERT INTO white_cards VALUES (607, 'An Olive Ewe.', 'VS');
INSERT INTO white_cards VALUES (608, 'Hookers and blow.', 'VS');
INSERT INTO white_cards VALUES (609, 'Dropbears.', 'VS');
INSERT INTO white_cards VALUES (610, 'Standing next to short people to use them as armrests.', 'VS');
INSERT INTO white_cards VALUES (611, 'Making a random guess in Werewolf that gets you killed later.', 'VS');
INSERT INTO white_cards VALUES (612, 'INTERNET FOREVER!', 'VS');
INSERT INTO white_cards VALUES (613, 'The jitters you get before a meetup.', 'VS');
INSERT INTO white_cards VALUES (614, 'Shenaniganty.', 'VS');
INSERT INTO white_cards VALUES (615, 'I AM HOW BABIES ARE MADE.', 'VS');
INSERT INTO white_cards VALUES (616, 'Noble whore.', 'VS');
INSERT INTO white_cards VALUES (617, 'Kangaroo stripper.', 'VS');
INSERT INTO white_cards VALUES (618, 'Droopums.', 'VS');
INSERT INTO white_cards VALUES (619, 'Nonni''s mantis.', 'VS');
INSERT INTO white_cards VALUES (620, 'Ginger baby.', 'VS');
INSERT INTO white_cards VALUES (621, 'Drunk foruming.', 'VS');
INSERT INTO white_cards VALUES (1477, 'My hot cousin.', '❄');
INSERT INTO white_cards VALUES (100008, 'The sound a single ThunderStix&reg; makes.', 'SG');
INSERT INTO white_cards VALUES (100009, 'The Chilled Knife.', 'SG');
INSERT INTO white_cards VALUES (145, 'Five-Dollar Footlongs&trade;.', NULL);
INSERT INTO white_cards VALUES (100011, 'Dr. Phil.', 'SG');
INSERT INTO white_cards VALUES (100012, 'Paul and Storm.', 'SG');
INSERT INTO white_cards VALUES (100013, 'Jonathan Coulton.', 'SG');
INSERT INTO white_cards VALUES (100014, 'MC Frontalot.', 'SG');
INSERT INTO white_cards VALUES (100015, 'Pretending you''re Xyzzy.', 'SG');
INSERT INTO white_cards VALUES (100018, 'Cleveland (it''s not Detroit!).', 'SG');
INSERT INTO white_cards VALUES (100019, 'An immediately regrettable $9 hot dog from the Boston Convention Center.', 'PAX A');
INSERT INTO white_cards VALUES (100020, 'Running out of stamina.', 'PAX A');
INSERT INTO white_cards VALUES (100021, 'Casting Magic Missile at a bully.', 'PAX A');
INSERT INTO white_cards VALUES (100022, 'Getting bitch slapped by Dhalsim.', 'PAX A');
INSERT INTO white_cards VALUES (100023, 'Firefly: Season 2.', 'PAX A');
INSERT INTO white_cards VALUES (100024, 'Rotating shapes in mid-air so that they fit into other shapes when they fall.', 'PAX A');
INSERT INTO white_cards VALUES (100025, 'Jiggle physics.', 'PAX A');
INSERT INTO white_cards VALUES (100026, 'Paying the iron price.', 'PAX A');
INSERT INTO white_cards VALUES (100029, 'Loading from a previous save.', 'PAX B');
INSERT INTO white_cards VALUES (100030, 'Sharpening a foam broadsword on a foam whetstone.', 'PAX B');
INSERT INTO white_cards VALUES (100031, 'The rocket launcher.', 'PAX B');
INSERT INTO white_cards VALUES (100032, 'The depression that ensues after catching ''em all.', 'PAX B');
INSERT INTO white_cards VALUES (100033, 'Violating the First Law of Robotics.', 'PAX B');
INSERT INTO white_cards VALUES (100034, 'Getting inside the Horadric Cube with a hot babe and pressing the transmute button.', 'PAX B');
INSERT INTO white_cards VALUES (100035, 'Punching a tree to gather wood.', 'PAX B');
INSERT INTO white_cards VALUES (100036, 'Spending the year''s insulin budget on Warhammer 40k figurines.', 'PAX B');
INSERT INTO white_cards VALUES (100039, 'Achieving 500 actions per minute.', 'PAX C');
INSERT INTO white_cards VALUES (100040, 'Forgetting to eat, and consequently dying.', 'PAX C');
INSERT INTO white_cards VALUES (100041, 'Wil Wheaton crashing an actual spaceship.', 'PAX C');
INSERT INTO white_cards VALUES (100042, 'The Klobb.', 'PAX C');
INSERT INTO white_cards VALUES (100043, 'Charging up all the way.', 'PAX C');
INSERT INTO white_cards VALUES (100044, 'Vespene gas.', 'PAX C');
INSERT INTO white_cards VALUES (100045, 'Judging elves by the color of their skin and not by the content of their character.', 'PAX C');
INSERT INTO white_cards VALUES (100046, 'Smashing all the pottery in a Pottery Barn in search of rupees.', 'PAX C');
INSERT INTO white_cards VALUES (100052, 'The best card in my hand.', 'SG');
INSERT INTO white_cards VALUES (100053, 'The primal, ball-slapping sex your parents are having right now.', 'X3');
INSERT INTO white_cards VALUES (100055, 'A cat video so cute that your eyes roll back and your spine slides out of your anus.', 'X3');
INSERT INTO white_cards VALUES (100056, 'Cock.', 'X3');
INSERT INTO white_cards VALUES (100057, 'The biggest, blackest dick.', 'SG');
INSERT INTO white_cards VALUES (100060, 'A cop who is also a dog.', 'X3');
INSERT INTO white_cards VALUES (100061, 'Dying alone and in pain.', 'X3');
INSERT INTO white_cards VALUES (100062, 'Gay aliens.', 'X3');
INSERT INTO white_cards VALUES (100063, 'The way white people is.', 'X3');
INSERT INTO white_cards VALUES (100064, 'Reverse cowgirl.', 'X3');
INSERT INTO white_cards VALUES (100067, 'The Quesadilla Explosion Salad&trade; from Chili''s&reg;.', 'X3');
INSERT INTO white_cards VALUES (100068, 'Actually getting shot, for real.', 'X3');
INSERT INTO white_cards VALUES (100069, 'Not having sex.', 'X3');
INSERT INTO white_cards VALUES (100071, 'Vietnam flashbacks.', 'X3');
INSERT INTO white_cards VALUES (100072, 'Running naked through a mall, pissing and shitting everywhere.', 'X3');
INSERT INTO white_cards VALUES (100073, 'Nothing.', 'X3');
INSERT INTO white_cards VALUES (100075, 'Warm, velvety muppet sex.', 'X3');
INSERT INTO white_cards VALUES (100076, 'Self-flagellation.', 'X3');
INSERT INTO white_cards VALUES (100077, 'The systematic destruction of an entire people and their way of life.', 'X3');
INSERT INTO white_cards VALUES (100079, 'Samuel L. Jackson.', 'X3');
INSERT INTO white_cards VALUES (100080, 'A boo-boo.', 'X3');
INSERT INTO white_cards VALUES (100081, 'Going around punching people.', 'X3');
INSERT INTO white_cards VALUES (100082, 'The entire Internet.', 'X3');
INSERT INTO white_cards VALUES (100083, 'Some kind of bird-man.', 'X3');
INSERT INTO white_cards VALUES (100084, 'Chugging a lava lamp.', 'X3');
INSERT INTO white_cards VALUES (100086, 'Having sex on top of a pizza.', 'X3');
INSERT INTO white_cards VALUES (100087, 'Indescribable loneliness.', 'X3');
INSERT INTO white_cards VALUES (100088, 'An ass disaster.', 'X3');
INSERT INTO white_cards VALUES (100090, 'Shutting the fuck up.', 'X3');
INSERT INTO white_cards VALUES (100091, 'All my friends dying.', 'X3');
INSERT INTO white_cards VALUES (100099, 'Putting an entire peanut butter and jelly sandwich into the VCR.', 'X3');
INSERT INTO white_cards VALUES (100101, 'Spending lots of money.', 'X3');
INSERT INTO white_cards VALUES (100102, 'Some douche with an acoustic guitar.', 'X3');
INSERT INTO white_cards VALUES (100107, 'Flying robots that kill people.', 'X3');
INSERT INTO white_cards VALUES (100109, 'A greased-up Matthew McConaughey.', 'X3');
INSERT INTO white_cards VALUES (100111, 'An unstoppable wave of fire ants.', 'X3');
INSERT INTO white_cards VALUES (100112, 'Not contributing to society in any meaningful way.', 'X3');
INSERT INTO white_cards VALUES (100114, 'An all-midget production of Shakespeare''s <i>Richard III</i>.', 'X3');
INSERT INTO white_cards VALUES (100115, 'Screaming like a maniac.', 'X3');
INSERT INTO white_cards VALUES (100116, 'The moist, demanding chasm of his mouth.', 'X3');
INSERT INTO white_cards VALUES (100117, 'Filling every orifice with butterscotch pudding.', 'X3');
INSERT INTO white_cards VALUES (100118, 'Unlimited soup, salad, and breadsticks.', 'X3');
INSERT INTO white_cards VALUES (100119, 'Crying into the pages of Sylvia Plath.', 'X3');
INSERT INTO white_cards VALUES (10002, 'Adam Wan.', 'Furry');
INSERT INTO white_cards VALUES (100121, 'A PowerPoint presentation.', 'X3');
INSERT INTO white_cards VALUES (100122, 'A surprising amount of hair.', 'X3');
INSERT INTO white_cards VALUES (100123, 'Eating Tom Selleck''s mustache to gain his powers.', 'X3');
INSERT INTO white_cards VALUES (100124, 'Roland the Farter, flatulist to the king.', 'X3');
INSERT INTO white_cards VALUES (100125, 'That ass.', 'X3');
INSERT INTO white_cards VALUES (100126, 'A pile of squirming bodies.', 'X3');
INSERT INTO white_cards VALUES (100127, 'Buying the right pants to be cool.', 'X3');
INSERT INTO white_cards VALUES (100128, 'Blood farts.', 'X3');
INSERT INTO white_cards VALUES (100129, 'Three months in the hole.', 'X3');
INSERT INTO white_cards VALUES (100130, 'A botched circumcision.', 'X3');
INSERT INTO white_cards VALUES (100131, 'The Land of Chocolate.', 'X3');
INSERT INTO white_cards VALUES (100132, 'Slapping a racist old lady.', 'X3');
INSERT INTO white_cards VALUES (100133, 'A lamprey swimming up the toilet and latching onto your taint.', 'X3');
INSERT INTO white_cards VALUES (100134, 'Jumping out at people.', 'X3');
INSERT INTO white_cards VALUES (100135, 'A black male in his early 20s, last seen wearing a hoodie.', 'X3');
INSERT INTO white_cards VALUES (100136, 'Mufasa''s death scene.', 'X3');
INSERT INTO white_cards VALUES (100137, 'Bill Clinton, naked on a bearskin rug with a saxophone.', 'X3');
INSERT INTO white_cards VALUES (100138, 'Demonic possession.', 'X3');
INSERT INTO white_cards VALUES (100139, 'The Harlem Globetrotters.', 'X3');
INSERT INTO white_cards VALUES (100140, 'Vomiting mid-blowjob.', 'X3');
INSERT INTO white_cards VALUES (100141, 'My manservant, Claude.', 'X3');
INSERT INTO white_cards VALUES (100142, 'Having shotguns for legs.', 'X3');
INSERT INTO white_cards VALUES (100143, 'Letting everyone down.', 'X3');
INSERT INTO white_cards VALUES (100144, 'A spontaneous conga line.', 'X3');
INSERT INTO white_cards VALUES (100145, 'A vagina that leads to another dimension.', 'X3');
INSERT INTO white_cards VALUES (100146, 'Disco fever.', 'X3');
INSERT INTO white_cards VALUES (100147, 'Getting your dick stuck in a Chinese finger trap with another dick.', 'X3');
INSERT INTO white_cards VALUES (100148, 'Fisting.', 'X3');
INSERT INTO white_cards VALUES (100149, 'The thin veneer of situational causality that underlies porn.', 'X3');
INSERT INTO white_cards VALUES (100150, 'Girls that always be textin''.', 'X3');
INSERT INTO white_cards VALUES (100151, 'Blowing some dudes in an alley.', 'X3');
INSERT INTO white_cards VALUES (3688, 'The Columbine Shooting.', 'RS');
INSERT INTO white_cards VALUES (100153, 'Sneezing, farting, and coming at the same time.', 'X3');
INSERT INTO white_cards VALUES (167, 'The Tempur-Pedic&reg; Swedish Sleep System&trade;.', NULL);
INSERT INTO white_cards VALUES (192, 'Fancy Feast&reg;.', NULL);
INSERT INTO white_cards VALUES (229, 'Hot Pockets&reg;.', NULL);
INSERT INTO white_cards VALUES (247, 'A neglected Tamagotchi&trade;.', NULL);
INSERT INTO white_cards VALUES (267, 'Domino''s&trade; Oreo&trade; Dessert Pizza.', NULL);
INSERT INTO white_cards VALUES (284, 'The &Uuml;bermensch.', NULL);
INSERT INTO white_cards VALUES (311, 'Adderall&trade;.', NULL);
INSERT INTO white_cards VALUES (350, 'Sobbing into a Hungry-Man&reg; Frozen Dinner.', NULL);
INSERT INTO white_cards VALUES (353, 'Ring Pops&trade;.', NULL);
INSERT INTO white_cards VALUES (354, 'GoGurt&reg;.', NULL);
INSERT INTO white_cards VALUES (404, 'A Super Soaker&trade; full of cat pee.', NULL);
INSERT INTO white_cards VALUES (440, 'Lunchables&trade;.', NULL);
INSERT INTO white_cards VALUES (460, 'The Make-A-Wish&reg; Foundation.', NULL);
INSERT INTO white_cards VALUES (472, 'A Bop It&trade;.', '1.2');
INSERT INTO white_cards VALUES (482, 'Home video of Oprah sobbing into a Lean Cuisine&reg;.', '1.2');
INSERT INTO white_cards VALUES (486, 'Euphoria&trade; by Calvin Klein.', '1.2');
INSERT INTO white_cards VALUES (487, 'Switching to Geico&reg;.', '1.2');
INSERT INTO white_cards VALUES (507, 'The Donald Trump Seal of Approval&trade;.', '1.2');
INSERT INTO white_cards VALUES (1114, 'Medieval Times&reg; Dinner &amp; Tournament.', 'X1');
INSERT INTO white_cards VALUES (1136, 'The Fanta&reg; girls.', 'X1');
INSERT INTO white_cards VALUES (1182, 'The mere concept of Applebee''s&reg;.', 'X2');
INSERT INTO white_cards VALUES (1187, 'A pi&ntilde;ata full of scorpions.', 'X2');
INSERT INTO white_cards VALUES (1228, 'Pretty Pretty Princess Dress-Up Board Game&reg;.', 'X2');
INSERT INTO white_cards VALUES (1480, 'A Hungry-Man&trade; Frozen Christmas Dinner for One.', '❄');
INSERT INTO white_cards VALUES (3689, 'Shag carpeting.', 'RS');
INSERT INTO white_cards VALUES (100156, 'Suddenly realizing you''re retarded.', 'SG');
INSERT INTO white_cards VALUES (3001, 'Steven Docking.', 'NL');
INSERT INTO white_cards VALUES (3002, '/r/Letsplay.', 'NL');
INSERT INTO white_cards VALUES (3003, '/r/sloths.', 'NL');
INSERT INTO white_cards VALUES (3004, '#Krazymike.', 'NL');
INSERT INTO white_cards VALUES (3005, 'A Bane impression.', 'NL');
INSERT INTO white_cards VALUES (3006, 'A big wet pink laser sword.', 'NL');
INSERT INTO white_cards VALUES (3007, 'A brief moment of aptitude.', 'NL');
INSERT INTO white_cards VALUES (3008, 'A bunch of jabronies.', 'NL');
INSERT INTO white_cards VALUES (3009, 'A butt egg.', 'NL');
INSERT INTO white_cards VALUES (15368, 'Rock-hard, glistening abs.', 'ANX1');
INSERT INTO white_cards VALUES (3011, 'A delicious baby.', 'NL');
INSERT INTO white_cards VALUES (3012, 'A docking sleeve.', 'NL');
INSERT INTO white_cards VALUES (3013, 'A little bit of added defense.', 'NL');
INSERT INTO white_cards VALUES (3014, 'A street cleaning simulator.', 'NL');
INSERT INTO white_cards VALUES (3015, 'An old man carrying a box of glass down stairs.', 'NL');
INSERT INTO white_cards VALUES (3016, 'Anything from http://www.thenorthernlionstory.com/.', 'NL');
INSERT INTO white_cards VALUES (3017, 'Beating it on camera.', 'NL');
INSERT INTO white_cards VALUES (3018, 'Being terrible at games.', 'NL');
INSERT INTO white_cards VALUES (3019, 'Bejeweed.', 'NL');
INSERT INTO white_cards VALUES (3020, 'Big Hat Logan.', 'NL');
INSERT INTO white_cards VALUES (3021, 'Blondes, brunettes, and redheads.', 'NL');
INSERT INTO white_cards VALUES (3022, 'Blue Baby.', 'NL');
INSERT INTO white_cards VALUES (3023, 'BOOYAH!', 'NL');
INSERT INTO white_cards VALUES (3024, 'Bow to your sensei!', 'NL');
INSERT INTO white_cards VALUES (3025, 'Brimstone.', 'NL');
INSERT INTO white_cards VALUES (3026, 'Butt meat.', 'NL');
INSERT INTO white_cards VALUES (3027, 'Checking the wiki.', 'NL');
INSERT INTO white_cards VALUES (3028, 'Cheeseysaurus Rex.', 'NL');
INSERT INTO white_cards VALUES (3029, 'Classic Northernlion.', 'NL');
INSERT INTO white_cards VALUES (3030, 'Coming on Milhouse.', 'NL');
INSERT INTO white_cards VALUES (3031, 'Corner fucking.', 'NL');
INSERT INTO white_cards VALUES (3032, 'Crazy Mike.', 'NL');
INSERT INTO white_cards VALUES (3033, 'Cross-dimensional fucking.', 'NL');
INSERT INTO white_cards VALUES (3034, 'Dark holes.', 'NL');
INSERT INTO white_cards VALUES (3035, 'Detroit Dock City.', 'NL');
INSERT INTO white_cards VALUES (3036, 'Docking.', 'NL');
INSERT INTO white_cards VALUES (3037, 'DockLeeSmile.', 'NL');
INSERT INTO white_cards VALUES (3038, 'Dung pies.', 'NL');
INSERT INTO white_cards VALUES (3039, 'Dying in a hang gliding accident. ', 'NL');
INSERT INTO white_cards VALUES (3040, 'Excuse me?', 'NL');
INSERT INTO white_cards VALUES (3041, 'Eyeless ooze guys.', 'NL');
INSERT INTO white_cards VALUES (3042, 'Falling down the stairs with a bag full of glass.', 'NL');
INSERT INTO white_cards VALUES (3043, 'Fat Robert Downey Jr.', 'NL');
INSERT INTO white_cards VALUES (3044, 'Feline eugenics.', 'NL');
INSERT INTO white_cards VALUES (3045, 'Fuck tables.', 'NL');
INSERT INTO white_cards VALUES (3046, 'Fucking during a Diphtheria epidemic.', 'NL');
INSERT INTO white_cards VALUES (3047, 'Garglebutts.', 'NL');
INSERT INTO white_cards VALUES (3048, 'Getting corner fucked.', 'NL');
INSERT INTO white_cards VALUES (3049, 'Getting wood.', 'NL');
INSERT INTO white_cards VALUES (3050, 'Greed.', 'NL');
INSERT INTO white_cards VALUES (3051, 'Harry Potter and the Chamber of a Salty Surprise.', 'NL');
INSERT INTO white_cards VALUES (3052, 'Hookers, blow, and JSmithOTI.', 'NL');
INSERT INTO white_cards VALUES (3053, 'Infomercials.', 'NL');
INSERT INTO white_cards VALUES (3054, 'John Madden.', 'NL');
INSERT INTO white_cards VALUES (3055, 'JSmithOTI.', 'NL');
INSERT INTO white_cards VALUES (3056, 'Kate''s Mario Party skills.', 'NL');
INSERT INTO white_cards VALUES (3057, 'Krazy Mike doing a backflip, throwing a talking nut, and chanting "Hello!"', 'NL');
INSERT INTO white_cards VALUES (3058, 'Krazy Mike.', 'NL');
INSERT INTO white_cards VALUES (3060, 'Like you, but not rogue-like you.', 'NL');
INSERT INTO white_cards VALUES (3061, 'Losing to Monstro after 300 hours of experience.', 'NL');
INSERT INTO white_cards VALUES (3062, 'The backroom casting couch.', 'NL');
INSERT INTO white_cards VALUES (3063, 'The fuck zone.', 'NL');
INSERT INTO white_cards VALUES (3064, 'Losing to Quelaag 12 times in 72 minutes.', 'NL');
INSERT INTO white_cards VALUES (3065, 'Maple syrup.', 'NL');
INSERT INTO white_cards VALUES (3066, 'Michael Caine''s spider collection.', 'NL');
INSERT INTO white_cards VALUES (3067, 'Michaelalfox.', 'NL');
INSERT INTO white_cards VALUES (3068, 'Michaelalfox''s love of cheese.', 'NL');
INSERT INTO white_cards VALUES (3069, 'Michaelalfox''s muscles.', 'NL');
INSERT INTO white_cards VALUES (3070, 'A mile-long penis.', 'NL');
INSERT INTO white_cards VALUES (3071, 'Milking the poop for red hearts.', 'NL');
INSERT INTO white_cards VALUES (3072, 'Mom''s knife.', 'NL');
INSERT INTO white_cards VALUES (3073, 'Mom''s pad.', 'NL');
INSERT INTO white_cards VALUES (3074, 'Monty.', 'NL');
INSERT INTO white_cards VALUES (3075, 'A motherfucker.', 'NL');
INSERT INTO white_cards VALUES (3076, 'Motherfucking.', 'NL');
INSERT INTO white_cards VALUES (3077, 'Nipple hair.', 'NL');
INSERT INTO white_cards VALUES (3078, 'Northernlion.', 'NL');
INSERT INTO white_cards VALUES (100152, 'Drinking ten 5-hour ENERGYs&reg; to get fifty continuous hours of energy.', 'X3');
INSERT INTO white_cards VALUES (3079, 'Northernlion''s cancelled Assassin''s Creed II let''s play.', 'NL');
INSERT INTO white_cards VALUES (3080, 'Northernlion''s coffee maker.', 'NL');
INSERT INTO white_cards VALUES (3081, 'Northernlion''s hair.', 'NL');
INSERT INTO white_cards VALUES (3082, 'Northernlion''s pooping album.', 'NL');
INSERT INTO white_cards VALUES (3083, 'Not Satan, I promise.', 'NL');
INSERT INTO white_cards VALUES (3084, 'Novelty Twitter accounts.', 'NL');
INSERT INTO white_cards VALUES (3085, 'Olmec.', 'NL');
INSERT INTO white_cards VALUES (3086, 'Permanent Polaroid invincibility.', 'NL');
INSERT INTO white_cards VALUES (3087, 'Poison Mushroom.', 'NL');
INSERT INTO white_cards VALUES (3088, 'Poutine-induced diabetes.', 'NL');
INSERT INTO white_cards VALUES (3089, 'Pretending youtube let''s playing is a real job.', 'NL');
INSERT INTO white_cards VALUES (3090, 'Projectile annoyance.', 'NL');
INSERT INTO white_cards VALUES (3091, 'Putting your balls in her butt.', 'NL');
INSERT INTO white_cards VALUES (3092, 'Puzzle platformers with rogue-like elements.', 'NL');
INSERT INTO white_cards VALUES (3093, 'Quelaag''s Furysword.', 'NL');
INSERT INTO white_cards VALUES (3094, 'Reddit.', 'NL');
INSERT INTO white_cards VALUES (3095, 'Residue.', 'NL');
INSERT INTO white_cards VALUES (3096, 'RockLeeSmile.', 'NL');
INSERT INTO white_cards VALUES (3097, 'Rogue-like likes.', 'NL');
INSERT INTO white_cards VALUES (3098, 'Roll Fizzlebeef.', 'NL');
INSERT INTO white_cards VALUES (3099, 'Ronald McDonald.', 'NL');
INSERT INTO white_cards VALUES (3100, 'Sex.', 'NL');
INSERT INTO white_cards VALUES (3101, 'Shit happens.', 'NL');
INSERT INTO white_cards VALUES (3102, 'Shooting the poop.', 'NL');
INSERT INTO white_cards VALUES (3103, 'Solaire of Astora.', 'NL');
INSERT INTO white_cards VALUES (3104, 'South Korea.', 'NL');
INSERT INTO white_cards VALUES (3105, 'Stream lag.', 'NL');
INSERT INTO white_cards VALUES (3106, 'Stupid damage.', 'NL');
INSERT INTO white_cards VALUES (3107, 'A tactical backflip.', 'NL');
INSERT INTO white_cards VALUES (3108, 'The Northernlion Story.', 'NL');
INSERT INTO white_cards VALUES (3109, 'Whispering sweet nothings into your rear.', 'NL');
INSERT INTO white_cards VALUES (3110, 'The notorious Grey''s Anatomy let''s play.', 'NL');
INSERT INTO white_cards VALUES (3111, 'The Binding of Isaac wiki.', 'NL');
INSERT INTO white_cards VALUES (3112, 'Thornforg.', 'NL');
INSERT INTO white_cards VALUES (3113, 'When you fuck a dog in the ass and it shits all over your dick.', 'NL');
INSERT INTO white_cards VALUES (3114, 'The USS Buttfucker.', 'NL');
INSERT INTO white_cards VALUES (3115, 'Vaginal silk worms.', 'NL');
INSERT INTO white_cards VALUES (3116, 'The Anor Londo Archers.', 'NL');
INSERT INTO white_cards VALUES (3117, 'YouTube.', 'NL');
INSERT INTO white_cards VALUES (3118, 'The saga of Krazy Mike.', 'NL');
INSERT INTO white_cards VALUES (3119, 'A urination break.', 'NL');
INSERT INTO white_cards VALUES (3120, 'The World Docking Champion.', 'NL');
INSERT INTO white_cards VALUES (3121, 'Type-C Tetris music.', 'NL');
INSERT INTO white_cards VALUES (3122, 'The Thug of Porn.', 'NL');
INSERT INTO white_cards VALUES (3123, 'That damned HDPVR.', 'NL');
INSERT INTO white_cards VALUES (3124, 'The NLSS: drawing unwanted attention from the actual docking community.', 'NL');
INSERT INTO white_cards VALUES (3125, 'Patrick Dempsey thrusting violently into my midsection.', 'NL');
INSERT INTO white_cards VALUES (3126, 'Well, what is it?', 'NL');
INSERT INTO white_cards VALUES (3127, 'The Four Horsemen of The Apocolypse.', 'NL');
INSERT INTO white_cards VALUES (3128, 'Talking nuts.', 'NL');
INSERT INTO white_cards VALUES (3129, 'The Ozymandias head.', 'NL');
INSERT INTO white_cards VALUES (3130, 'A total scumbag.', 'NL');
INSERT INTO white_cards VALUES (3131, 'Striking fear into the hearts of your enemies.', 'NL');
INSERT INTO white_cards VALUES (100158, 'Using the tears of an abused toddler to conquer my foes.', 'NL');
INSERT INTO white_cards VALUES (3690, 'The Eiffel Tower.', 'RS');
INSERT INTO white_cards VALUES (3691, 'Chicken and Waffles.', 'RS');
INSERT INTO white_cards VALUES (3692, 'The Oculus Rift.', 'RS');
INSERT INTO white_cards VALUES (3693, 'Banana Hammocks.', 'RS');
INSERT INTO white_cards VALUES (3694, 'Dirty hippies.', 'RS');
INSERT INTO white_cards VALUES (3695, 'Hey Arnold!', 'RS');
INSERT INTO white_cards VALUES (3696, 'Air Bud.', 'RS');
INSERT INTO white_cards VALUES (3697, 'Yankee Stadium.', 'RS');
INSERT INTO white_cards VALUES (3698, 'Hump Day.', 'RS');
INSERT INTO white_cards VALUES (3699, 'Sheepskin Condoms.', 'RS');
INSERT INTO white_cards VALUES (3700, 'Cranky Kong.', 'RS');
INSERT INTO white_cards VALUES (3701, 'The DK Rap.', 'RS');
INSERT INTO white_cards VALUES (3702, 'Donkey Shows.', 'RS');
INSERT INTO white_cards VALUES (3703, 'Hordes of zombies.', 'RS');
INSERT INTO white_cards VALUES (3704, 'Monkeys throwing shit.', 'RS');
INSERT INTO white_cards VALUES (3705, 'Rainbows and magic.', 'RS');
INSERT INTO white_cards VALUES (3706, 'Tits.', 'RS');
INSERT INTO white_cards VALUES (3707, 'The brown note.', 'RS');
INSERT INTO white_cards VALUES (3708, 'Hentai.', 'RS');
INSERT INTO white_cards VALUES (3709, 'Indiana Jones.', 'RS');
INSERT INTO white_cards VALUES (3710, 'ALL the things!', 'RS');
INSERT INTO white_cards VALUES (3711, 'Hitler''s mustache.', 'RS');
INSERT INTO white_cards VALUES (3712, 'Gerudo Valley.', 'RS');
INSERT INTO white_cards VALUES (3713, 'Song of Storms.', 'RS');
INSERT INTO white_cards VALUES (3714, 'Bill Gates pissing on Steve Jobs''s grave.', 'RS');
INSERT INTO white_cards VALUES (3715, 'A giant purple dildo sword.', 'RS');
INSERT INTO white_cards VALUES (3716, 'Hipsters on their iPhones at Starbucks.', 'RS');
INSERT INTO white_cards VALUES (3717, 'Catdog.', 'RS');
INSERT INTO white_cards VALUES (3718, 'A boat load of cocaine.', 'RS');
INSERT INTO white_cards VALUES (3719, 'Smooth jazz.', 'RS');
INSERT INTO white_cards VALUES (3720, 'Lemon grenades.', 'RS');
INSERT INTO white_cards VALUES (3721, 'Blue Waffles.', 'RS');
INSERT INTO white_cards VALUES (3722, '360 no scopes.', 'RS');
INSERT INTO white_cards VALUES (3723, 'Soviet Russia.', 'RS');
INSERT INTO white_cards VALUES (3724, 'The Mushroom Kingdom.', 'RS');
INSERT INTO white_cards VALUES (3725, 'Outsourcing jobs to India.', 'RS');
INSERT INTO white_cards VALUES (3726, 'Hooters.', 'RS');
INSERT INTO white_cards VALUES (3727, 'The Hokey Pokey.', 'RS');
INSERT INTO white_cards VALUES (3728, 'Kaizo Mario.', 'RS');
INSERT INTO white_cards VALUES (3729, 'FrankerZ.', 'RS');
INSERT INTO white_cards VALUES (3730, 'Spontaneous Combustion.', 'RS');
INSERT INTO white_cards VALUES (3731, 'Kappa.', 'RS');
INSERT INTO white_cards VALUES (3732, 'Insane Clown Posse.', 'RS');
INSERT INTO white_cards VALUES (3733, 'Nu Metal.', 'RS');
INSERT INTO white_cards VALUES (3734, 'The Wiggles.', 'RS');
INSERT INTO white_cards VALUES (3735, 'Blue''s Clues.', 'RS');
INSERT INTO white_cards VALUES (3736, 'Using hot sauce as lube.', 'RS');
INSERT INTO white_cards VALUES (3737, 'Mating season.', 'RS');
INSERT INTO white_cards VALUES (3738, 'The Ouya.', 'RS');
INSERT INTO white_cards VALUES (3739, 'Jew-Fros.', 'RS');
INSERT INTO white_cards VALUES (3740, 'Fruit Fuckers.', 'RS');
INSERT INTO white_cards VALUES (3741, 'Blowing your hand off with a firework.', 'RS');
INSERT INTO white_cards VALUES (3742, 'Beer Pong.', 'RS');
INSERT INTO white_cards VALUES (3743, 'Duke Nukem Forever.', 'RS');
INSERT INTO white_cards VALUES (3744, 'Rule 34.', 'RS');
INSERT INTO white_cards VALUES (3745, 'Made-for-TV movies.', 'RS');
INSERT INTO white_cards VALUES (3746, 'Spanish soap operas.', 'RS');
INSERT INTO white_cards VALUES (3747, 'Teh Urn.', 'RS');
INSERT INTO white_cards VALUES (3748, 'Viking Metal.', 'RS');
INSERT INTO white_cards VALUES (3749, 'Tickle Me Elmo.', 'RS');
INSERT INTO white_cards VALUES (3750, 'Barney''s rape dungeon.', 'RS');
INSERT INTO white_cards VALUES (3751, 'Nurse Joy.', 'RS');
INSERT INTO white_cards VALUES (3752, 'Canadian tuxedo.', 'RS');
INSERT INTO white_cards VALUES (3753, 'Hungry Hungry Hippos.', 'RS');
INSERT INTO white_cards VALUES (3754, 'The smallest, whitest dick.', 'RS');
INSERT INTO white_cards VALUES (3755, 'Abusive fathers.', 'RS');
INSERT INTO white_cards VALUES (3756, 'Rich, chocolatey Ovaltine&reg;.', 'RS');
INSERT INTO white_cards VALUES (3757, 'Ringworm.', 'RS');
INSERT INTO white_cards VALUES (3758, 'The hero of time.', 'RS');
INSERT INTO white_cards VALUES (3759, 'Terabytes of horse porn.', 'RS');
INSERT INTO white_cards VALUES (3760, 'Blowing the President.', 'RS');
INSERT INTO white_cards VALUES (3761, 'Skullcrusher Mountain.', 'RS');
INSERT INTO white_cards VALUES (3762, 'Mr. Fancy Pants.', 'RS');
INSERT INTO white_cards VALUES (3763, 'TotalBiscuit''s top hat.', 'RS');
INSERT INTO white_cards VALUES (3764, 'Demi Moore''s bush.', 'RS');
INSERT INTO white_cards VALUES (3765, 'Eating 120 White Castle burgers&reg;.', 'RS');
INSERT INTO white_cards VALUES (3766, 'A walrus with a beret.', 'RS');
INSERT INTO white_cards VALUES (3767, 'Speedrunning life.', 'RS');
INSERT INTO white_cards VALUES (3769, 'The truffle shuffle.', 'RS');
INSERT INTO white_cards VALUES (3770, 'An 8-ball.', 'RS');
INSERT INTO white_cards VALUES (3771, 'Quiznos&reg;.', 'RS');
INSERT INTO white_cards VALUES (3772, 'Bong hits for Jesus.', 'RS');
INSERT INTO white_cards VALUES (3773, 'Penn and Teller.', 'RS');
INSERT INTO white_cards VALUES (3774, 'Indentured servants.', 'RS');
INSERT INTO white_cards VALUES (3775, 'Sex in your mouth.', 'RS');
INSERT INTO white_cards VALUES (3776, 'Hoola hoops.', 'RS');
INSERT INTO white_cards VALUES (4109, 'Literally drinking bottled fangirl tears.', 'TGWTG');
INSERT INTO white_cards VALUES (4110, 'LordKaT''s used nipple tassles.', 'TGWTG');
INSERT INTO white_cards VALUES (4111, 'Luke''s curly hair.', 'TGWTG');
INSERT INTO white_cards VALUES (4112, 'Lupa''s brand of hair dye.', 'TGWTG');
INSERT INTO white_cards VALUES (4113, 'Ma-Ti being castrated and having his balls shipped to Oancitizen in the mail by Diamanda Hagan.', 'TGWTG');
INSERT INTO white_cards VALUES (4114, 'Magical fairy sex.', 'TGWTG');
INSERT INTO white_cards VALUES (4115, 'Making angry love to a DVD copy of "Neverending Story III".', 'TGWTG');
INSERT INTO white_cards VALUES (4116, 'Mako.', 'TGWTG');
INSERT INTO white_cards VALUES (4117, 'Malachite''s Hand.', 'TGWTG');
INSERT INTO white_cards VALUES (4118, 'Maven''s secret sparkling vampire dildo.', 'TGWTG');
INSERT INTO white_cards VALUES (4119, 'Melvin, brother of the Joker.', 'TGWTG');
INSERT INTO white_cards VALUES (4120, 'My mom.', 'TGWTG');
INSERT INTO white_cards VALUES (4121, 'My penis catching fire.', 'TGWTG');
INSERT INTO white_cards VALUES (4122, 'Naked crazy.', 'TGWTG');
INSERT INTO white_cards VALUES (4123, 'Nash breaking his ass.', 'TGWTG');
INSERT INTO white_cards VALUES (4124, 'Nash dressed in drag.', 'TGWTG');
INSERT INTO white_cards VALUES (4125, 'Nash in a gimp suit.', 'TGWTG');
INSERT INTO white_cards VALUES (4126, 'Nash popping a blood vessel over Florida.', 'TGWTG');
INSERT INTO white_cards VALUES (4127, 'Nash.', 'TGWTG');
INSERT INTO white_cards VALUES (4128, 'Nash''s long, long hair.', 'TGWTG');
INSERT INTO white_cards VALUES (4129, 'Newborn porn.', 'TGWTG');
INSERT INTO white_cards VALUES (4130, 'Nun fuckery.', 'TGWTG');
INSERT INTO white_cards VALUES (4131, 'Oancitizen.', 'TGWTG');
INSERT INTO white_cards VALUES (4132, 'Over-intrusive fanboys.', 'TGWTG');
INSERT INTO white_cards VALUES (4133, 'Having sex at a screening of Mr. Popper''s Penguins.', 'TGWTG');
INSERT INTO white_cards VALUES (4134, 'Phelous making love to his Turtles collection.', 'TGWTG');
INSERT INTO white_cards VALUES (4135, 'Poop, as a plan.', 'TGWTG');
INSERT INTO white_cards VALUES (4136, 'Punching your foe in the stomach and screaming "I AM A MAN!"', 'TGWTG');
INSERT INTO white_cards VALUES (4137, 'PushingUpRoses'' bird tattoos.', 'TGWTG');
INSERT INTO white_cards VALUES (4138, 'Putting sexy pantyhose on your dog.', 'TGWTG');
INSERT INTO white_cards VALUES (4139, 'Radio Dead Air.', 'TGWTG');
INSERT INTO white_cards VALUES (10003, 'Non-consensual sex with Zaush.', 'Furry');
INSERT INTO white_cards VALUES (4141, 'Reading fan fiction on a live stream.', 'TGWTG');
INSERT INTO white_cards VALUES (4142, 'Reading the comments.', 'TGWTG');
INSERT INTO white_cards VALUES (4143, 'Requesting John Cage''s "4''33" on Radio Dead Air.', 'TGWTG');
INSERT INTO white_cards VALUES (4144, 'Reviewer dibs.', 'TGWTG');
INSERT INTO white_cards VALUES (4145, 'Robotic sex slaves that are made to feel sadness.', 'TGWTG');
INSERT INTO white_cards VALUES (4146, 'Rule 34 of Linkara and a lamp.', 'TGWTG');
INSERT INTO white_cards VALUES (4147, 'Sad Panda.', 'TGWTG');
INSERT INTO white_cards VALUES (4148, 'Santa Christ.', 'TGWTG');
INSERT INTO white_cards VALUES (4149, 'Santa Christ''s raging boner.', 'TGWTG');
INSERT INTO white_cards VALUES (10004, 'My tailhole.', 'Furry');
INSERT INTO white_cards VALUES (4151, 'Sharkleberry Finn-flavored Kool-Aid.', 'TGWTG');
INSERT INTO white_cards VALUES (4152, 'Shooting colored corn syrup up your nose.', 'TGWTG');
INSERT INTO white_cards VALUES (4153, 'Slightly creepy comments about Tara''s hair.', 'TGWTG');
INSERT INTO white_cards VALUES (4154, 'Smoking kittens.', 'TGWTG');
INSERT INTO white_cards VALUES (4155, 'Snowdicking.', 'TGWTG');
INSERT INTO white_cards VALUES (4156, 'Snowflame, feeling no pain.', 'TGWTG');
INSERT INTO white_cards VALUES (4157, 'Sodomizing a loved one with a baseball bat.', 'TGWTG');
INSERT INTO white_cards VALUES (4158, 'Space Guy.', 'TGWTG');
INSERT INTO white_cards VALUES (4159, 'Spoony''s fans.', 'TGWTG');
INSERT INTO white_cards VALUES (4160, 'Spoony''s sexy goth pixie girlfriend.', 'TGWTG');
INSERT INTO white_cards VALUES (4161, 'Stick figure porn.', 'TGWTG');
INSERT INTO white_cards VALUES (4162, 'Stickboy.', 'TGWTG');
INSERT INTO white_cards VALUES (4163, 'Storing your dead friend''s ashes into a Quaker Oats can.', 'TGWTG');
INSERT INTO white_cards VALUES (4164, 'Suggestively eating a banana at the sight of David Bowie.', 'TGWTG');
INSERT INTO white_cards VALUES (4165, 'SYMBOLISM!', 'TGWTG');
INSERT INTO white_cards VALUES (4166, 'Taking someone by the shoulders, throwing them on the bed and riding them like a stallion.', 'TGWTG');
INSERT INTO white_cards VALUES (4167, 'That Aussie Guy.', 'TGWTG');
INSERT INTO white_cards VALUES (4168, 'That goddamned Colossus roar.', 'TGWTG');
INSERT INTO white_cards VALUES (4169, 'That one guy with snails.', 'TGWTG');
INSERT INTO white_cards VALUES (4170, 'The Angry Video Game Nerd.', 'TGWTG');
INSERT INTO white_cards VALUES (4171, 'The Blockbuster Buster.', 'TGWTG');
INSERT INTO white_cards VALUES (4172, 'The Cinema Snob Movie DVD.', 'TGWTG');
INSERT INTO white_cards VALUES (4173, 'THE COCK.', 'TGWTG');
INSERT INTO white_cards VALUES (4174, 'The Continuity Alarm.', 'TGWTG');
INSERT INTO white_cards VALUES (4175, 'The elephant in the room.', 'TGWTG');
INSERT INTO white_cards VALUES (4176, 'The Film Renegado.', 'TGWTG');
INSERT INTO white_cards VALUES (4177, 'The five months when the Nostalgia Critic was dead.', 'TGWTG');
INSERT INTO white_cards VALUES (4178, 'The LAAAAAAAAAAAAAAAAAAAAAW!', 'TGWTG');
INSERT INTO white_cards VALUES (4179, 'The Makeover Fairy.', 'TGWTG');
INSERT INTO white_cards VALUES (4180, 'The Nostalgia Critic.', 'TGWTG');
INSERT INTO white_cards VALUES (4181, 'The pig fucking movie.', 'TGWTG');
INSERT INTO white_cards VALUES (4182, 'The plot hole.', 'TGWTG');
INSERT INTO white_cards VALUES (4183, 'The Power Glove.', 'TGWTG');
INSERT INTO white_cards VALUES (4184, 'The RDA drinking game.', 'TGWTG');
INSERT INTO white_cards VALUES (4185, 'The RDA IRC channel.', 'TGWTG');
INSERT INTO white_cards VALUES (4186, 'The Spocker.', 'TGWTG');
INSERT INTO white_cards VALUES (4187, 'The TGWTG site redesign.', 'TGWTG');
INSERT INTO white_cards VALUES (4188, 'The Wunder Boner.', 'TGWTG');
INSERT INTO white_cards VALUES (4189, 'This fecal matter you call "Fluttershy".', 'TGWTG');
INSERT INTO white_cards VALUES (4190, 'Throwing a Baby Tumbles Surprise down a staircase.', 'TGWTG');
INSERT INTO white_cards VALUES (4191, 'Time travel.', 'TGWTG');
INSERT INTO white_cards VALUES (4192, 'Timing.', 'TGWTG');
INSERT INTO white_cards VALUES (4193, 'Todd''s unmasked visage.', 'TGWTG');
INSERT INTO white_cards VALUES (4194, 'Using Crystal Pepsi as a substitute for lube.', 'TGWTG');
INSERT INTO white_cards VALUES (4195, 'Using your underwear to shoplift raw meat from your local Wal-Mart.', 'TGWTG');
INSERT INTO white_cards VALUES (4196, 'Vigorously shagging your sister while holding a mug of warm tea.', 'TGWTG');
INSERT INTO white_cards VALUES (4197, 'Welshy.', 'TGWTG');
INSERT INTO white_cards VALUES (4199, 'Whatever the hell Barfiesta was supposed to be.', 'TGWTG');
INSERT INTO white_cards VALUES (4200, 'Yet another Thunderdome reference.', 'TGWTG');
INSERT INTO white_cards VALUES (4201, 'Your mom.', 'TGWTG');
INSERT INTO white_cards VALUES (4202, 'Zodan The Unbouncable.', 'TGWTG');
INSERT INTO white_cards VALUES (4203, '90''s Kid''s comic collection.', 'TGWTG');
INSERT INTO white_cards VALUES (4204, 'A Linkara cameo.', 'TGWTG');
INSERT INTO white_cards VALUES (4205, 'A plushie cybermat.', 'TGWTG');
INSERT INTO white_cards VALUES (4206, 'ALL THE COCAINE!!!', 'TGWTG');
INSERT INTO white_cards VALUES (4207, 'Bees!', 'TGWTG');
INSERT INTO white_cards VALUES (4208, 'Being fed up with reviewing lamps, what obscure topic did Linkara review next?', 'TGWTG');
INSERT INTO white_cards VALUES (4209, 'Harvey Finevoice''s fine voice.', 'TGWTG');
INSERT INTO white_cards VALUES (4210, 'Killing clowns.', 'TGWTG');
INSERT INTO white_cards VALUES (4211, 'Linkara crying in his Gatorade made of cybermat tears.', 'TGWTG');
INSERT INTO white_cards VALUES (4212, 'Linkara stalking Gail Simone on Twitter.', 'TGWTG');
INSERT INTO white_cards VALUES (4213, 'Linkara''s cybermat invasion force.', 'TGWTG');
INSERT INTO white_cards VALUES (4214, 'Linkara''s fangirl support group.', 'TGWTG');
INSERT INTO white_cards VALUES (4215, 'Linkara''s magic gun.', 'TGWTG');
INSERT INTO white_cards VALUES (4216, 'Linkara''s masculine arms.', 'TGWTG');
INSERT INTO white_cards VALUES (4217, 'MAGfest.', 'TGWTG');
INSERT INTO white_cards VALUES (4218, 'Marzkara fanfiction.', 'TGWTG');
INSERT INTO white_cards VALUES (4219, 'Mechakara''s phallic drill.', 'TGWTG');
INSERT INTO white_cards VALUES (4220, 'Reviews of $20 lamps.', 'TGWTG');
INSERT INTO white_cards VALUES (4198, 'What did the commenters bitch about next to Doug?', 'TGWTG');
INSERT INTO white_cards VALUES (15369, 'A diet consisting almost entirely of potatoes.', 'ANX1');
INSERT INTO white_cards VALUES (3994, 'A baseball to the nuts.', 'TGWTG');
INSERT INTO white_cards VALUES (3995, 'A bat credit card.', 'TGWTG');
INSERT INTO white_cards VALUES (3996, 'A Big Lipped Alligator Moment.', 'TGWTG');
INSERT INTO white_cards VALUES (3997, 'A big long pink ding dong penis.', 'TGWTG');
INSERT INTO white_cards VALUES (3998, 'A bird fucking a horse.', 'TGWTG');
INSERT INTO white_cards VALUES (3999, 'A Blip check.', 'TGWTG');
INSERT INTO white_cards VALUES (4000, 'A bootleg ninja turtle action figure possessed by Satan.', 'TGWTG');
INSERT INTO white_cards VALUES (4001, 'A car landing on a roof.', 'TGWTG');
INSERT INTO white_cards VALUES (4002, 'A case of disappearing bears.', 'TGWTG');
INSERT INTO white_cards VALUES (4003, 'A Chia-Child.', 'TGWTG');
INSERT INTO white_cards VALUES (4004, 'A congregation of bums.', 'TGWTG');
INSERT INTO white_cards VALUES (4005, 'A Crystal Pepsi&reg;-flavored enema.', 'TGWTG');
INSERT INTO white_cards VALUES (10005, 'Adoptables with visible genitalia.', 'Furry');
INSERT INTO white_cards VALUES (10006, 'An embarrassingly long F-List profile.', 'Furry');
INSERT INTO white_cards VALUES (4008, 'A drugged Oancitizen in a schoolgirl outfit.', 'TGWTG');
INSERT INTO white_cards VALUES (4009, 'A greased-up meth guy.', 'TGWTG');
INSERT INTO white_cards VALUES (10007, 'Catching STDs at conventions.', 'Furry');
INSERT INTO white_cards VALUES (4011, 'A killer rabbit.', 'TGWTG');
INSERT INTO white_cards VALUES (4012, 'A mexican car wash.', 'TGWTG');
INSERT INTO white_cards VALUES (4013, 'A misguided Tumblr activism campaign.', 'TGWTG');
INSERT INTO white_cards VALUES (4014, 'A mobile meth lab in your pants.', 'TGWTG');
INSERT INTO white_cards VALUES (10008, 'Fursuit adventures.', 'Furry');
INSERT INTO white_cards VALUES (4016, 'A novelty slot machine.', 'TGWTG');
INSERT INTO white_cards VALUES (4017, 'A Pan-Galactic Gargle Blaster.', 'TGWTG');
INSERT INTO white_cards VALUES (4018, 'A poorly-written ugly mess.', 'TGWTG');
INSERT INTO white_cards VALUES (4019, 'A really pimped out DeLorean.', 'TGWTG');
INSERT INTO white_cards VALUES (4020, 'A talking snail in a suit.', 'TGWTG');
INSERT INTO white_cards VALUES (4021, 'A tiny white dick.', 'TGWTG');
INSERT INTO white_cards VALUES (4022, 'A titanic, undead, six-headed space dragon spewing bubbles.', 'TGWTG');
INSERT INTO white_cards VALUES (4023, 'A zombie fisherman.', 'TGWTG');
INSERT INTO white_cards VALUES (4024, 'Accidentally punching your cohost in the face.', 'TGWTG');
INSERT INTO white_cards VALUES (4025, 'ALL OF THE DICKS.', 'TGWTG');
INSERT INTO white_cards VALUES (4026, 'Almost dying at Sesame Street.', 'TGWTG');
INSERT INTO white_cards VALUES (4027, 'An art film Kyle''s reviewed.', 'TGWTG');
INSERT INTO white_cards VALUES (4028, 'An autoclitorodectomy.', 'TGWTG');
INSERT INTO white_cards VALUES (10009, 'A semen-stained fursuit.', 'Furry');
INSERT INTO white_cards VALUES (4030, 'An obscure reference only two people will get.', 'TGWTG');
INSERT INTO white_cards VALUES (4031, 'Anal tearing.', 'TGWTG');
INSERT INTO white_cards VALUES (4032, 'Andrew Dickman.', 'TGWTG');
INSERT INTO white_cards VALUES (4033, 'Angrily playing piano.', 'TGWTG');
INSERT INTO white_cards VALUES (4034, 'Ash.', 'TGWTG');
INSERT INTO white_cards VALUES (4035, 'Ash and Checkers.', 'TGWTG');
INSERT INTO white_cards VALUES (4036, 'Ask That Guy raped by Ma-Ti live.', 'TGWTG');
INSERT INTO white_cards VALUES (4037, 'ASS ASS ASS ASS ASS ASS ASS ASS.', 'TGWTG');
INSERT INTO white_cards VALUES (4038, 'Ass demons.', 'TGWTG');
INSERT INTO white_cards VALUES (4039, 'Awkward pity sex with a sparkly teenage Cthulu.', 'TGWTG');
INSERT INTO white_cards VALUES (10010, 'Fake furry girls.', 'Furry');
INSERT INTO white_cards VALUES (4041, 'Because no one wants to see your dick.', 'TGWTG');
INSERT INTO white_cards VALUES (4042, 'Because the Kool-Aid Man is red.', 'TGWTG');
INSERT INTO white_cards VALUES (4043, 'Because there''s nothing sexy at the Wal-Mart.', 'TGWTG');
INSERT INTO white_cards VALUES (4044, 'Bees. My God.', 'TGWTG');
INSERT INTO white_cards VALUES (4045, 'Being frozen today.', 'TGWTG');
INSERT INTO white_cards VALUES (4046, 'Beppo the Invisible Monkey.', 'TGWTG');
INSERT INTO white_cards VALUES (4047, 'BETRAYAL!', 'TGWTG');
INSERT INTO white_cards VALUES (4048, 'Big Jim Slade.', 'TGWTG');
INSERT INTO white_cards VALUES (4049, 'Blockbuster Buster busting a nut.', 'TGWTG');
INSERT INTO white_cards VALUES (4050, 'Breaking someone''s spine by fucking.', 'TGWTG');
INSERT INTO white_cards VALUES (4051, 'Carl Copenhagen.', 'TGWTG');
INSERT INTO white_cards VALUES (4052, 'Casper.', 'TGWTG');
INSERT INTO white_cards VALUES (4053, 'Chuck Norris.', 'TGWTG');
INSERT INTO white_cards VALUES (4054, 'Confusing The Last Angry Geek and Linkara.', 'TGWTG');
INSERT INTO white_cards VALUES (4055, 'CR''s collection of My Little Pony pins.', 'TGWTG');
INSERT INTO white_cards VALUES (4056, 'Creepy fans at cons buying expensive stuff for MarzGurl.', 'TGWTG');
INSERT INTO white_cards VALUES (4057, 'Creepy guys in the RDA chat hitting on Tara.', 'TGWTG');
INSERT INTO white_cards VALUES (4058, 'Nash''s creepy face.', 'TGWTG');
INSERT INTO white_cards VALUES (4059, 'Crying your eyes out at a bunch of online reviewers.', 'TGWTG');
INSERT INTO white_cards VALUES (4060, 'Crystal Pepsi&reg;.', 'TGWTG');
INSERT INTO white_cards VALUES (4061, 'Dark Nella.', 'TGWTG');
INSERT INTO white_cards VALUES (4062, 'David Bowie''s package.', 'TGWTG');
INSERT INTO white_cards VALUES (10011, 'That one straight guy at the party.', 'Furry');
INSERT INTO white_cards VALUES (4064, 'Diamanda Hagan''s sexbot.', 'TGWTG');
INSERT INTO white_cards VALUES (4065, 'Diamanda''s copy of Cockhammer.', 'TGWTG');
INSERT INTO white_cards VALUES (4066, 'Disney''s Anne Frank.', 'TGWTG');
INSERT INTO white_cards VALUES (4067, 'Dogs wearing pantyhose.', 'TGWTG');
INSERT INTO white_cards VALUES (4068, 'Dolphin rape.', 'TGWTG');
INSERT INTO white_cards VALUES (4069, 'A douchequake.', 'TGWTG');
INSERT INTO white_cards VALUES (4070, 'Dr. Insano.', 'TGWTG');
INSERT INTO white_cards VALUES (4071, 'Dr. Wiki.', 'TGWTG');
INSERT INTO white_cards VALUES (4072, 'Explosively masturbating with Malachite''s Hand.', 'TGWTG');
INSERT INTO white_cards VALUES (4073, 'Ferdinand Von Turrell.', 'TGWTG');
INSERT INTO white_cards VALUES (4074, 'Film Brain''s lovely accent.', 'TGWTG');
INSERT INTO white_cards VALUES (4075, 'Finding out that "it''s not Pop Tarts!"', 'TGWTG');
INSERT INTO white_cards VALUES (4076, 'Firing a blue shell at the opposing house ship.', 'TGWTG');
INSERT INTO white_cards VALUES (4077, 'Florida.', 'TGWTG');
INSERT INTO white_cards VALUES (4078, 'Florida Man.', 'TGWTG');
INSERT INTO white_cards VALUES (4079, 'Flying sex snakes in monocles and bow ties.', 'TGWTG');
INSERT INTO white_cards VALUES (4080, 'Fort Super-Awesome.', 'TGWTG');
INSERT INTO white_cards VALUES (4081, 'FOUR HOURS?!', 'TGWTG');
INSERT INTO white_cards VALUES (10012, 'An apartment full of internet-obsessed losers.', 'Furry');
INSERT INTO white_cards VALUES (4083, 'Fuck yeah, SPARKLE SPARKLE SPARKLE!', 'TGWTG');
INSERT INTO white_cards VALUES (4084, 'Fuck you, I do what I want.', 'TGWTG');
INSERT INTO white_cards VALUES (4085, 'FUCK YOU, I''M SPIDERMAN!', 'TGWTG');
INSERT INTO white_cards VALUES (4086, 'Fucking bubbles.', 'TGWTG');
INSERT INTO white_cards VALUES (4087, 'Getting buggered by a giant hamster.', 'TGWTG');
INSERT INTO white_cards VALUES (4088, 'Getting mauled by a mountain lion AND a grizzly bear at the same time.', 'TGWTG');
INSERT INTO white_cards VALUES (4089, 'Glenn Beck being torn apart by zombies.', 'TGWTG');
INSERT INTO white_cards VALUES (4090, 'Going full retard.', 'TGWTG');
INSERT INTO white_cards VALUES (4091, 'Going through the effort to build a wall in your back yard just to bash your head into it over and over again.', 'TGWTG');
INSERT INTO white_cards VALUES (4092, 'Gooby.', 'TGWTG');
INSERT INTO white_cards VALUES (4093, 'Hagan''s dictator tendencies.', 'TGWTG');
INSERT INTO white_cards VALUES (4094, 'Hagan''s make up artist.', 'TGWTG');
INSERT INTO white_cards VALUES (4095, 'Hagan''s masturbating minion.', 'TGWTG');
INSERT INTO white_cards VALUES (4096, 'Ham?', 'TGWTG');
INSERT INTO white_cards VALUES (4097, 'Hippo Queen Tara.', 'TGWTG');
INSERT INTO white_cards VALUES (4098, 'Hitler without the mustache.', 'TGWTG');
INSERT INTO white_cards VALUES (15370, 'Mamoru Oshii''s dog love.', 'ANX1');
INSERT INTO white_cards VALUES (4100, 'Humping a can of trash.', 'TGWTG');
INSERT INTO white_cards VALUES (4101, 'I AM A MAN!', 'TGWTG');
INSERT INTO white_cards VALUES (4102, 'Invading a micronation in Nevada and making it your own.', 'TGWTG');
INSERT INTO white_cards VALUES (4103, 'JewWario''s solar penis.', 'TGWTG');
INSERT INTO white_cards VALUES (4104, 'Kickassia.', 'TGWTG');
INSERT INTO white_cards VALUES (4105, 'Kitler.', 'TGWTG');
INSERT INTO white_cards VALUES (4106, 'Kyle humping a trashcan.', 'TGWTG');
INSERT INTO white_cards VALUES (4107, 'Linkara''s ''special'' comic books.', 'TGWTG');
INSERT INTO white_cards VALUES (4108, 'Linkara''s hat.', 'TGWTG');
INSERT INTO white_cards VALUES (4222, 'Superboy Prime.', 'TGWTG');
INSERT INTO white_cards VALUES (4223, 'The Entity.', 'TGWTG');
INSERT INTO white_cards VALUES (4224, 'The legendary MAGFest orgy.', 'TGWTG');
INSERT INTO white_cards VALUES (4225, 'The most important job, reviewing a crappy comic book.', 'TGWTG');
INSERT INTO white_cards VALUES (4226, 'The next History of Power Rangers.', 'TGWTG');
INSERT INTO white_cards VALUES (4227, 'Youngblood''s disease.', 'TGWTG');
INSERT INTO white_cards VALUES (4228, 'Twin clones of Hitler.', 'TGWTG');
INSERT INTO white_cards VALUES (559, 'Thundercunt.', 'VS');
INSERT INTO white_cards VALUES (4006, 'A disembodied orgasm hippo.', 'TGWTG');
INSERT INTO white_cards VALUES (4007, 'A doppelganger in black leather with a sword.', 'TGWTG');
INSERT INTO white_cards VALUES (4010, 'A guest appearance by Giovanni Jones, the talking lobster.', 'TGWTG');
INSERT INTO white_cards VALUES (4015, 'A naked rampage.', 'TGWTG');
INSERT INTO white_cards VALUES (4029, 'An awkward slash fic between The Nostalgia Critic and The Angry Video Game Nerd.', 'TGWTG');
INSERT INTO white_cards VALUES (4040, 'Bath salts.', 'TGWTG');
INSERT INTO white_cards VALUES (4063, 'Diamanda Hagan.', 'TGWTG');
INSERT INTO white_cards VALUES (4082, 'Frying the Coke.', 'TGWTG');
INSERT INTO white_cards VALUES (4140, 'Rapidly pounding themselves in the face with a hammer.', 'TGWTG');
INSERT INTO white_cards VALUES (100120, 'Velcro&trade;.', 'X3');
INSERT INTO white_cards VALUES (4150, 'Sci-Fi Guy''s ponytail.', 'TGWTG');
INSERT INTO white_cards VALUES (4229, 'A beef swarm.', 'NL');
INSERT INTO white_cards VALUES (3010, 'A butt pooping upwards an egg.', 'NL');
INSERT INTO white_cards VALUES (100162, 'The League of Legends.', 'SG');
INSERT INTO white_cards VALUES (100164, 'Advice from a wise, old black man.', '1.3');
INSERT INTO white_cards VALUES (100165, 'The Devil himself.', '1.3');
INSERT INTO white_cards VALUES (100166, 'The art of seduction.', '1.3');
INSERT INTO white_cards VALUES (100167, 'Funky fresh rhymes.', '1.3');
INSERT INTO white_cards VALUES (100168, 'The light of a billion suns.', '1.3');
INSERT INTO white_cards VALUES (10013, 'A tub of Vaseline.', 'Furry');
INSERT INTO white_cards VALUES (100170, 'Destroying the evidence.', '1.3');
INSERT INTO white_cards VALUES (10014, 'Sex with strangers.', 'Furry');
INSERT INTO white_cards VALUES (100172, 'Silence.', '1.3');
INSERT INTO white_cards VALUES (100173, 'Growing a pair.', '1.3');
INSERT INTO white_cards VALUES (100174, 'Synergistic management solutions.', '1.3');
INSERT INTO white_cards VALUES (100175, 'Wet dreams.', '1.3');
INSERT INTO white_cards VALUES (100176, 'A live studio audience.', '1.3');
INSERT INTO white_cards VALUES (100177, 'The Great Depression.', '1.3');
INSERT INTO white_cards VALUES (100178, 'An M16 assault rifle.', '1.3');
INSERT INTO white_cards VALUES (100179, 'Poopy diapers.', '1.3');
INSERT INTO white_cards VALUES (100180, 'Tickling Sean Hannity, even after he tells you to stop.', '1.3');
INSERT INTO white_cards VALUES (100181, 'Stalin.', '1.3');
INSERT INTO white_cards VALUES (100182, 'A spastic nerd.', '1.3');
INSERT INTO white_cards VALUES (100183, 'Rush Limbaugh''s soft, shitty body.', '1.3');
INSERT INTO white_cards VALUES (100184, 'Capturing Newt Gingrich and forcing him to dance in a monkey suit.', '1.3');
INSERT INTO white_cards VALUES (100185, 'Battlefield amputations.', '1.3');
INSERT INTO white_cards VALUES (100186, 'Brown people.', '1.3');
INSERT INTO white_cards VALUES (100187, 'Rehab.', '1.3');
INSERT INTO white_cards VALUES (100188, 'An ugly face.', '1.3');
INSERT INTO white_cards VALUES (100189, 'Menstrual rage.', '1.3');
INSERT INTO white_cards VALUES (100190, 'An uppercut.', '1.3');
INSERT INTO white_cards VALUES (100191, 'Shiny objects.', '1.3');
INSERT INTO white_cards VALUES (100192, '50,000 volts straight to the nipples.', '1.3');
INSERT INTO white_cards VALUES (100193, 'A bucket of fish heads.', '1.3');
INSERT INTO white_cards VALUES (100194, 'Hospice care.', '1.3');
INSERT INTO white_cards VALUES (100195, 'Being fat and stupid.', '1.3');
INSERT INTO white_cards VALUES (100196, 'Getting married, having a few kids, buying some stuff, retiring to Florida, and dying.', '1.3');
INSERT INTO white_cards VALUES (100197, 'A pyramid of severed heads.', '1.3');
INSERT INTO white_cards VALUES (100198, 'Crucifixion.', '1.3');
INSERT INTO white_cards VALUES (100199, 'A subscription to Men''s Fitness.', '1.3');
INSERT INTO white_cards VALUES (100200, 'Some god-damn peace and quiet.', '1.3');
INSERT INTO white_cards VALUES (100201, 'A micropig wearing a tiny raincoat and booties.', '1.3');
INSERT INTO white_cards VALUES (100202, 'Used panties.', '1.3');
INSERT INTO white_cards VALUES (100204, 'The penny whistle solo from "My Heart Will Go On."', '1.3');
INSERT INTO white_cards VALUES (100205, 'A tribe of warrior women.', '1.3');
INSERT INTO white_cards VALUES (100212, 'An oversized lollipop.', '1.3');
INSERT INTO white_cards VALUES (100213, 'Helplessly giggling at the mention of Hutus and Tutsis.', '1.3');
INSERT INTO white_cards VALUES (100214, 'Not wearing pants.', '1.3');
INSERT INTO white_cards VALUES (100215, 'Consensual sex.', '1.3');
INSERT INTO white_cards VALUES (100216, 'Her Majesty, Queen Elizabeth II.', '1.3');
INSERT INTO white_cards VALUES (4230, 'Angry Joe.', 'TGWTG');
INSERT INTO white_cards VALUES (4231, 'Marzgurl.', 'TGWTG');
INSERT INTO white_cards VALUES (4232, 'Chester A. Bum.', 'TGWTG');
INSERT INTO white_cards VALUES (4233, 'Ask That Guy With The Glasses.', 'TGWTG');
INSERT INTO white_cards VALUES (4234, 'Dominic the Bartender.', 'TGWTG');
INSERT INTO white_cards VALUES (4235, 'Obscurus Lupa.', 'TGWTG');
INSERT INTO white_cards VALUES (4236, 'ChaosD1.', 'TGWTG');
INSERT INTO white_cards VALUES (4237, 'Skitch.', 'TGWTG');
INSERT INTO white_cards VALUES (4238, 'Y Ruler Of Time.', 'TGWTG');
INSERT INTO white_cards VALUES (4239, 'Linkara.', 'TGWTG');
INSERT INTO white_cards VALUES (4240, 'Mechakara.', 'TGWTG');
INSERT INTO white_cards VALUES (4241, 'Lord Vyce.', 'TGWTG');
INSERT INTO white_cards VALUES (4242, '90''s Kid.', 'TGWTG');
INSERT INTO white_cards VALUES (4243, 'Corporate Commander.', 'TGWTG');
INSERT INTO white_cards VALUES (4244, 'JewWario.', 'TGWTG');
INSERT INTO white_cards VALUES (4245, 'A demonic Teddy Ruxpin doll.', 'TGWTG');
INSERT INTO white_cards VALUES (4246, 'Luke.', 'TGWTG');
INSERT INTO white_cards VALUES (4247, 'Luke''s inners.', 'TGWTG');
INSERT INTO white_cards VALUES (4248, 'PhelousD1.', 'TGWTG');
INSERT INTO white_cards VALUES (4249, 'Phelous.', 'TGWTG');
INSERT INTO white_cards VALUES (4250, 'Filmbrain.', 'TGWTG');
INSERT INTO white_cards VALUES (4251, 'Iron Liz.', 'TGWTG');
INSERT INTO white_cards VALUES (4252, 'Malachite.', 'TGWTG');
INSERT INTO white_cards VALUES (4253, 'Zodd.', 'TGWTG');
INSERT INTO white_cards VALUES (4254, 'The Executor.', 'TGWTG');
INSERT INTO white_cards VALUES (4255, 'PhilBuni.', 'TGWTG');
INSERT INTO white_cards VALUES (4256, 'Ven Gethenian.', 'TGWTG');
INSERT INTO white_cards VALUES (4257, 'That Sci-Fi Guy.', 'TGWTG');
INSERT INTO white_cards VALUES (4258, 'Black Lantern Spoony.', 'TGWTG');
INSERT INTO white_cards VALUES (4259, 'The Trousers Cosmic.', 'TGWTG');
INSERT INTO white_cards VALUES (4260, 'Nash''s folksy, velvety voice.', 'TGWTG');
INSERT INTO white_cards VALUES (4261, 'Australia, Florida of the Pacific.', 'TGWTG');
INSERT INTO white_cards VALUES (4262, 'Angrily eating lettuce.', 'TGWTG');
INSERT INTO white_cards VALUES (4263, 'Mary Sewage.', 'TGWTG');
INSERT INTO white_cards VALUES (4264, 'A legion of mechawolves.', 'TGWTG');
INSERT INTO white_cards VALUES (4265, 'Linkara''s futon.', 'TGWTG');
INSERT INTO white_cards VALUES (4266, 'The Gooby Curse.', 'TGWTG');
INSERT INTO white_cards VALUES (4267, 'ANCIENT EGYPT!', 'TGWTG');
INSERT INTO white_cards VALUES (4268, 'An obligatory cameo.', 'TGWTG');
INSERT INTO white_cards VALUES (4269, 'Dodger of Zion.', 'TGWTG');
INSERT INTO white_cards VALUES (4270, 'An elevator party.', 'TGWTG');
INSERT INTO white_cards VALUES (4271, 'Pants that need to be darkened.', 'TGWTG');
INSERT INTO white_cards VALUES (4272, 'Only being on the site because of the influence of famous acquaintences.', 'TGWTG');
INSERT INTO white_cards VALUES (4273, 'Enoby Dark''ness Dementia Raven TARA Way.', 'TGWTG');
INSERT INTO white_cards VALUES (4274, 'JSmith''s salty nuts.', 'NL');
INSERT INTO white_cards VALUES (4275, '#ShotsFired.', 'NL');
INSERT INTO white_cards VALUES (4276, 'Banana bread.', 'NL');
INSERT INTO white_cards VALUES (4277, 'Butterjail.', 'NL');
INSERT INTO white_cards VALUES (10015, 'People who cosplay at furry conventions.', 'Furry');
INSERT INTO white_cards VALUES (10016, 'Fursuiters at anime conventions.', 'Furry');
INSERT INTO white_cards VALUES (10017, 'Embarrassing craigslist ads.', 'Furry');
INSERT INTO white_cards VALUES (10018, 'Pounced.org.', 'Furry');
INSERT INTO white_cards VALUES (10019, 'A large, flared Chance.', 'Furry');
INSERT INTO white_cards VALUES (10020, 'Stretching your anus in preparation for horse cock.', 'Furry');
INSERT INTO white_cards VALUES (10021, 'A hermaphrodite foxtaur.', 'Furry');
INSERT INTO white_cards VALUES (10022, 'Babyfurs.', 'Furry');
INSERT INTO white_cards VALUES (10023, 'Uncomfortably attractive animals.', 'Furry');
INSERT INTO white_cards VALUES (10024, 'Confusing feelings about cartoon characters.', 'Furry');
INSERT INTO white_cards VALUES (10025, 'PetSmart.', 'Furry');
INSERT INTO white_cards VALUES (10026, 'Krystal, the fox.', 'Furry');
INSERT INTO white_cards VALUES (10027, 'StarFox.', 'Furry');
INSERT INTO white_cards VALUES (10028, 'Sonic the Hedgehog.', 'Furry');
INSERT INTO white_cards VALUES (10029, 'Bowser''s sweaty balls.', 'Furry');
INSERT INTO white_cards VALUES (10030, 'A furpile.', 'Furry');
INSERT INTO white_cards VALUES (10031, 'The stench of half a dozen unwashed bronies.', 'Furry');
INSERT INTO white_cards VALUES (10032, 'Intimacy with the family dog.', 'Furry');
INSERT INTO white_cards VALUES (10033, 'Horses.', 'Furry');
INSERT INTO white_cards VALUES (10034, 'Fursecution.', 'Furry');
INSERT INTO white_cards VALUES (10035, 'Chakats.', 'Furry');
INSERT INTO white_cards VALUES (10036, 'DeviantArt.', 'Furry');
INSERT INTO white_cards VALUES (10037, 'Otherkin.', 'Furry');
INSERT INTO white_cards VALUES (10038, 'Heated debates about human genitalia versus animal genitalia.', 'Furry');
INSERT INTO white_cards VALUES (10039, 'Taking the knot.', 'Furry');
INSERT INTO white_cards VALUES (10040, 'Really, really liking Disney''s Robin Hood.', 'Furry');
INSERT INTO white_cards VALUES (10041, 'Applying your obscure, unrealistic fetishes to 90''s cartoon characters.', 'Furry');
INSERT INTO white_cards VALUES (10042, 'The texture and color of raw meat.', 'Furry');
INSERT INTO white_cards VALUES (10043, 'An oversized clitoris that acts as a functional penis.', 'Furry');
INSERT INTO white_cards VALUES (10044, 'A hermaphrodite snow leopard.', 'Furry');
INSERT INTO white_cards VALUES (10045, 'Drawing furry porn.', 'Furry');
INSERT INTO white_cards VALUES (10046, 'Lovingly rendered dragon anus.', 'Furry');
INSERT INTO white_cards VALUES (10047, 'Cloaca.', 'Furry');
INSERT INTO white_cards VALUES (10048, 'Animal genitalia.', 'Furry');
INSERT INTO white_cards VALUES (10049, 'Motherfucking wolves.', 'Furry');
INSERT INTO white_cards VALUES (10050, 'Christian furries.', 'Furry');
INSERT INTO white_cards VALUES (10051, 'Barbed penises.', 'Furry');
INSERT INTO white_cards VALUES (10052, 'Two knots.', 'Furry');
INSERT INTO white_cards VALUES (10053, 'A really attractive wolf.', 'Furry');
INSERT INTO white_cards VALUES (10054, 'A slutty gay fox.', 'Furry');
INSERT INTO white_cards VALUES (10055, 'A surprisingly attractive anteater.', 'Furry');
INSERT INTO white_cards VALUES (10056, 'FUCK YOU, I''M A DRAGON.', 'Furry');
INSERT INTO white_cards VALUES (10057, 'Tumbles, the Stair Dragon.', 'Furry');
INSERT INTO white_cards VALUES (10058, 'Furry Weekend Atlanta.', 'Furry');
INSERT INTO white_cards VALUES (10059, 'Further Confusion.', 'Furry');
INSERT INTO white_cards VALUES (10060, 'AnthroCon.', 'Furry');
INSERT INTO white_cards VALUES (10061, 'Literally a bucket of semen.', 'Furry');
INSERT INTO white_cards VALUES (10062, 'Sexual interest in pretty much anything with a hole.', 'Furry');
INSERT INTO white_cards VALUES (10063, 'Attraction to pretty much anything with a penis.', 'Furry');
INSERT INTO white_cards VALUES (10064, 'Transformation porn.', 'Furry');
INSERT INTO white_cards VALUES (10065, 'Anatomically incorrect genitalia.', 'Furry');
INSERT INTO white_cards VALUES (10066, 'When you catch yourself glancing at the crotches of animated characters.', 'Furry');
INSERT INTO white_cards VALUES (10067, 'Belly rubs leading to awkward boners.', 'Furry');
INSERT INTO white_cards VALUES (10068, 'Scritches.', 'Furry');
INSERT INTO white_cards VALUES (10069, 'Lifting your tail.', 'Furry');
INSERT INTO white_cards VALUES (10070, 'Experimenting with fisting.', 'Furry');
INSERT INTO white_cards VALUES (10071, 'Bad decisions.', 'Furry');
INSERT INTO white_cards VALUES (10072, 'A little bitch.', 'Furry');
INSERT INTO white_cards VALUES (10073, 'A lime Citra.', 'Furry');
INSERT INTO white_cards VALUES (10074, 'Sergals.', 'Furry');
INSERT INTO white_cards VALUES (10075, 'An autistic knife fight.', 'Furry');
INSERT INTO white_cards VALUES (10076, 'The noises red pandas make during sex.', 'Furry');
INSERT INTO white_cards VALUES (10077, 'About 16 ounces of horse semen.', 'Furry');
INSERT INTO white_cards VALUES (10078, 'Dog cum.', 'Furry');
INSERT INTO white_cards VALUES (10079, 'Oral knotting.', 'Furry');
INSERT INTO white_cards VALUES (10080, 'Leaving your orifices bloody and sore.', 'Furry');
INSERT INTO white_cards VALUES (10081, 'Rubbing peanut butter on your genitals.', 'Furry');
INSERT INTO white_cards VALUES (10082, 'Bad Dragon&trade; cumlube.', 'Furry');
INSERT INTO white_cards VALUES (10083, 'Piss.', 'Furry');
INSERT INTO white_cards VALUES (10084, 'Smells.', 'Furry');
INSERT INTO white_cards VALUES (10085, 'When "blowing ten bucks" makes you think of a long night with a bunch of deer.', 'Furry');
INSERT INTO white_cards VALUES (10086, 'Forgetting which set of fursuit paws you use for handjobs.', 'Furry');
INSERT INTO white_cards VALUES (10087, 'A strategically placed hole.', 'Furry');
INSERT INTO white_cards VALUES (10088, 'Shitting on my face.', 'Furry');
INSERT INTO white_cards VALUES (10089, 'Barking at strangers.', 'Furry');
INSERT INTO white_cards VALUES (10090, 'Sitting on your face.', 'Furry');
INSERT INTO white_cards VALUES (10091, 'Spending more money on commissions than food in a given week.', 'Furry');
INSERT INTO white_cards VALUES (10092, 'A dick so big you have to give it a hugjob.', 'Furry');
INSERT INTO white_cards VALUES (10093, 'The fine line between feral and outright bestiality.', 'Furry');
INSERT INTO white_cards VALUES (10094, 'Anal training.', 'Furry');
INSERT INTO white_cards VALUES (10095, 'Discovering monster porn.', 'Furry');
INSERT INTO white_cards VALUES (10096, 'Realizing that rimming is pretty cool.', 'Furry');
INSERT INTO white_cards VALUES (10097, 'Endearing social ineptitude.', 'Furry');
INSERT INTO white_cards VALUES (10098, 'All this lube.', 'Furry');
INSERT INTO white_cards VALUES (10099, 'That thing that gives your dick a knot IRL.', 'Furry');
INSERT INTO white_cards VALUES (10100, 'Gay.', 'Furry');
INSERT INTO white_cards VALUES (10101, 'Really, truly heterosexual.', 'Furry');
INSERT INTO white_cards VALUES (10102, 'Drenching your fursuit in Febreeze.', 'Furry');
INSERT INTO white_cards VALUES (10103, 'That time you let your dog go a little further than just sniffing your crotch.', 'Furry');
INSERT INTO white_cards VALUES (10104, 'Poodles with afros.', 'Furry');
INSERT INTO white_cards VALUES (10105, 'Offensively stereotyped African animals.', 'Furry');
INSERT INTO white_cards VALUES (10106, 'A sassy lioness.', 'Furry');
INSERT INTO white_cards VALUES (10107, 'Surprise hermaphrodites.', 'Furry');
INSERT INTO white_cards VALUES (10152, 'Taking special interest in nature documentaries.', 'Furry');
INSERT INTO white_cards VALUES (10153, 'Becoming a veterinarian for all the wrong reasons.', 'Furry');
INSERT INTO white_cards VALUES (10154, 'The premise of every furry comic ever.', 'Furry');
INSERT INTO white_cards VALUES (10155, 'Anal sex you didn''t know you wanted.', 'Furry');
INSERT INTO white_cards VALUES (10156, 'The incredibly satisfying sound it makes when you pull it out.', 'Furry');
INSERT INTO white_cards VALUES (10157, 'Bear tits.', 'Furry');
INSERT INTO white_cards VALUES (10158, 'Big cute paws.', 'Furry');
INSERT INTO white_cards VALUES (10159, 'Paws.', 'Furry');
INSERT INTO white_cards VALUES (10160, 'Furry porn, shamelessly taped to the walls.', 'Furry');
INSERT INTO white_cards VALUES (10161, 'Grabby-paws.', 'Furry');
INSERT INTO white_cards VALUES (10162, 'Masturbating, with claws.', 'Furry');
INSERT INTO white_cards VALUES (10163, 'Pawing-off.', 'Furry');
INSERT INTO white_cards VALUES (10164, 'Tail-sex.', 'Furry');
INSERT INTO white_cards VALUES (10165, 'Mary, the anthro mare.', 'Furry');
INSERT INTO white_cards VALUES (10166, 'Natascha, the anthro husky.', 'Furry');
INSERT INTO white_cards VALUES (10167, 'Nipple buffet.', 'Furry');
INSERT INTO white_cards VALUES (10168, 'Crotch-tits.', 'Furry');
INSERT INTO white_cards VALUES (10169, 'The tailstar tango.', 'Furry');
INSERT INTO white_cards VALUES (10170, 'Furries in heat.', 'Furry');
INSERT INTO white_cards VALUES (10171, 'Fantasizing about sex with just about every monster you encounter in your video game.', 'Furry');
INSERT INTO white_cards VALUES (10172, 'Impure thoughts about Kobolds.', 'Furry');
INSERT INTO white_cards VALUES (10173, 'Erotic roleplay.', 'Furry');
INSERT INTO white_cards VALUES (10174, 'Monsters with bedroom eyes.', 'Furry');
INSERT INTO white_cards VALUES (10175, 'Accurate avian anatomy.', 'Furry');
INSERT INTO white_cards VALUES (10176, 'Getting fur stuck in your teeth.', 'Furry');
INSERT INTO white_cards VALUES (10177, 'Getting feathers stuck in your teeth.', 'Furry');
INSERT INTO white_cards VALUES (10178, 'Ignoring a person''s faults because their character is hot.', 'Furry');
INSERT INTO white_cards VALUES (4099, 'A legion of spiders.', 'TGWTG');
INSERT INTO white_cards VALUES (3993, 'A secret goat porn stash.', 'TGWTG');
INSERT INTO white_cards VALUES (15371, 'An 8 million yen debt to a club of rich pretty boys.', 'ANX1');
INSERT INTO white_cards VALUES (15372, 'Hideaki Anno''s poor, tortured therapist.', 'ANX1');
INSERT INTO white_cards VALUES (4360, 'Golby.', 'GFC');
INSERT INTO white_cards VALUES (15373, 'Fucking postcards as a cheap-ass pack-in gift.', 'ANX1');
INSERT INTO white_cards VALUES (15374, 'Wild Tiger''s Hundred Power.', 'ANX1');
INSERT INTO white_cards VALUES (15375, 'Totoro.', 'ANX1');
INSERT INTO white_cards VALUES (15376, 'Traps.', 'ANX1');
INSERT INTO white_cards VALUES (15377, 'Korean Jesus.', 'ANX1');
INSERT INTO white_cards VALUES (15378, 'Astro Boy.', 'ANX1');
INSERT INTO white_cards VALUES (15379, 'Jacking off into a bottle of formaldehyde and calling it our firstborn.', 'ANX1');
INSERT INTO white_cards VALUES (15380, 'Valvrape the Dominator.', 'ANX1');
INSERT INTO white_cards VALUES (15381, 'Piles of dead children.', 'ANX1');
INSERT INTO white_cards VALUES (15382, 'An unending, unquenchable thirst for orange Fanta.', 'ANX1');
INSERT INTO white_cards VALUES (15383, 'Breaking the fourth wall to kill the mangaka.', 'ANX1');
INSERT INTO white_cards VALUES (15384, 'Hentai voice acting.', 'ANX1');
INSERT INTO white_cards VALUES (15385, 'A vampire ninja.', 'ANX1');
INSERT INTO white_cards VALUES (15386, 'A potato committing seppuku.', 'ANX1');
INSERT INTO white_cards VALUES (15387, 'A giant robot German suplex.', 'ANX1');
INSERT INTO white_cards VALUES (4358, 'Benchpressing.', 'GFC');
INSERT INTO white_cards VALUES (4359, 'Mother''s debit card.', 'GFC');
INSERT INTO white_cards VALUES (4361, 'Kevin Golby.', 'GFC');
INSERT INTO white_cards VALUES (4362, 'That Kevin Golby.', 'GFC');
INSERT INTO white_cards VALUES (4363, 'The Golbies: like the jitters but with a concern towards stabbings.', 'GFC');
INSERT INTO white_cards VALUES (4364, 'STEAL ALL THE FARM.', 'GFC');
INSERT INTO white_cards VALUES (4365, 'Norwegian Oil.', 'GFC');
INSERT INTO white_cards VALUES (4366, 'Grandiosa.', 'GFC');
INSERT INTO white_cards VALUES (4367, 'Drilling.', 'GFC');
INSERT INTO white_cards VALUES (4368, 'Barta''s glorious hair.', 'GFC');
INSERT INTO white_cards VALUES (4369, 'BENCH ALL THE MOTHERS.', 'GFC');
INSERT INTO white_cards VALUES (4370, 'Taking the second and third blue buff.', 'GFC');
INSERT INTO white_cards VALUES (4371, 'Invisible stabwounds.', 'GFC');
INSERT INTO white_cards VALUES (4372, 'Lulu''s double E.', 'GFC');
INSERT INTO white_cards VALUES (4373, 'A blurry picture.', 'GFC');
INSERT INTO white_cards VALUES (4374, 'The Merchant Navy.', 'GFC');
INSERT INTO white_cards VALUES (4375, 'Extensive research by Trygve.', 'GFC');
INSERT INTO white_cards VALUES (4376, 'The Trygvipedia.', 'GFC');
INSERT INTO white_cards VALUES (4377, 'Chak looking like Ross Kemp on a good day.', 'GFC');
INSERT INTO white_cards VALUES (4378, 'Manny''s epic laugh.', 'GFC');
INSERT INTO white_cards VALUES (4379, 'Clearly jealous.', 'GFC');
INSERT INTO white_cards VALUES (4380, 'A very tight vest from Primark.', 'GFC');
INSERT INTO white_cards VALUES (4381, 'Fisting a nun.', 'GFC');
INSERT INTO white_cards VALUES (4382, 'Teabagging a siamese midget while benchpressing a cybernetically enhanced bear.', 'GFC');
INSERT INTO white_cards VALUES (4383, 'From Primark.', 'GFC');
INSERT INTO white_cards VALUES (4384, 'smoochy moochy.', 'GFC');
INSERT INTO white_cards VALUES (4385, 'A Superman tattoo.', 'GFC');
INSERT INTO white_cards VALUES (4386, 'Gary Glitter.', 'GFC');
INSERT INTO white_cards VALUES (4387, 'Blanda Upp!.', 'GFC');
INSERT INTO white_cards VALUES (4388, 'Hestkuk.', 'GFC');
INSERT INTO white_cards VALUES (4389, 'A nice guy.', 'GFC');
INSERT INTO white_cards VALUES (4390, 'My 6.3 KDA ratio.', 'GFC');
INSERT INTO white_cards VALUES (4391, 'bronze scrub.', 'GFC');
INSERT INTO white_cards VALUES (4392, 'Get on my level.', 'GFC');
INSERT INTO white_cards VALUES (4393, 'Fucking tryhard.', 'GFC');
INSERT INTO white_cards VALUES (4394, 'Those moments when you''re bored and pucker your anus to a good beat.', 'GFC');
INSERT INTO white_cards VALUES (4395, 'An undetermined but significant quantity of penis.', 'GFC');
INSERT INTO white_cards VALUES (4396, 'PEEEEEEEEEEEEEEEENIIIISSSSSSSS.', 'GFC');
INSERT INTO white_cards VALUES (4397, 'The Shawk.', 'GFC');
INSERT INTO white_cards VALUES (4398, 'They''re taking the hobbits to Isengard!', 'GFC');
INSERT INTO white_cards VALUES (4399, 'Confounding jerry at every turn.', 'GFC');
INSERT INTO white_cards VALUES (4400, 'Jumanji.', 'GFC');
INSERT INTO white_cards VALUES (4401, 'Wards.', 'GFC');
INSERT INTO white_cards VALUES (4402, 'Build an Aegis!', 'GFC');
INSERT INTO white_cards VALUES (4403, 'Wildturtle''s vast range of emotions.', 'GFC');
INSERT INTO white_cards VALUES (4404, 'K-Pop.', 'GFC');
INSERT INTO white_cards VALUES (4405, 'Doing Gangnam Style at a funeral.', 'GFC');
INSERT INTO white_cards VALUES (4406, 'joseph gordon-Levitt wearing nothing but a kitten.', 'GFC');
INSERT INTO white_cards VALUES (4407, '125% Reccomended Daily Allowance of cock.', 'GFC');
INSERT INTO white_cards VALUES (4408, 'Barta not being sarcastic.', 'GFC');
INSERT INTO white_cards VALUES (4409, 'Golby''s itchy testicles.', 'GFC');
INSERT INTO white_cards VALUES (4410, 'Surgery to move the male g-spot to the naval.', 'GFC');
INSERT INTO white_cards VALUES (4411, 'The Kirk vs Spock fight scene music.', 'GFC');
INSERT INTO white_cards VALUES (4412, 'Golby not jungling.', 'GFC');
INSERT INTO white_cards VALUES (4413, 'Feeling a fart pushing against your prostate.', 'GFC');
INSERT INTO white_cards VALUES (4414, 'I''m Batman. WHERE ARE THEY?!?', 'GFC');
INSERT INTO white_cards VALUES (4415, 'Band Camp.', 'GFC');
INSERT INTO white_cards VALUES (4416, 'A corgi wearing a hat.', 'GFC');
INSERT INTO white_cards VALUES (4417, 'A corgi wearing a sailor moon outfit.', 'GFC');
INSERT INTO white_cards VALUES (4418, 'a corgi dressed as a viking.', 'GFC');
INSERT INTO white_cards VALUES (4419, 'A corgi.', 'GFC');
INSERT INTO white_cards VALUES (4420, 'Chak''s bald spot.', 'GFC');
INSERT INTO white_cards VALUES (4421, 'THE HAWK!', 'GFC');
INSERT INTO white_cards VALUES (4422, 'When Aunt Erma visits.', 'GFC');
INSERT INTO white_cards VALUES (4423, 'Jamiroquai.', 'GFC');
INSERT INTO white_cards VALUES (4424, 'BAWNJOURNO.', 'GFC');
INSERT INTO white_cards VALUES (4425, 'Black people''s nostrils.', 'GFC');
INSERT INTO white_cards VALUES (4426, 'LOOK AT MY HORSE.', 'GFC');
INSERT INTO white_cards VALUES (4427, 'MY HORSE IS AMAZING.', 'GFC');
INSERT INTO white_cards VALUES (4428, 'XPEKE!', 'GFC');
INSERT INTO white_cards VALUES (4429, 'Because Froggen did it.', 'GFC');
INSERT INTO white_cards VALUES (4430, 'Meowing Ride of the Valkyries during intercourse.', 'GFC');
INSERT INTO white_cards VALUES (4431, 'CACAW!', 'GFC');
INSERT INTO white_cards VALUES (4432, 'Dryhumping.', 'GFC');
INSERT INTO white_cards VALUES (4433, 'Gilbert Gotfried.', 'GFC');
INSERT INTO white_cards VALUES (4434, '50 Shades of Gay.', 'GFC');
INSERT INTO white_cards VALUES (4435, 'Maple Bourbon Bacon Jam.', 'GFC');
INSERT INTO white_cards VALUES (4436, 'Chak making a sandwich.', 'GFC');
INSERT INTO white_cards VALUES (4437, 'Jealous.', 'GFC');
INSERT INTO white_cards VALUES (4438, 'Frozen Heart Ashe.', 'GFC');
INSERT INTO white_cards VALUES (4439, 'Yorick Ult on Anivia Egg.', 'GFC');
INSERT INTO white_cards VALUES (4440, 'David.', 'GFC');
INSERT INTO white_cards VALUES (4441, 'A healthy dose of Vitamin Cock and Vitamin Dick.', 'GFC');
INSERT INTO white_cards VALUES (4442, 'Questioning my sexuality.', 'GFC');
INSERT INTO white_cards VALUES (4445, 'Tons of Damage.', 'GFC');
INSERT INTO white_cards VALUES (15388, 'A Godzilla attack.', 'ANX1');
INSERT INTO white_cards VALUES (15389, 'Eating KFC on Christmas day.', 'ANX1');
INSERT INTO white_cards VALUES (15390, 'Hello Kitty! pregnancy doujins.', 'ANX1');
INSERT INTO white_cards VALUES (15391, 'Waving it around all willy-nilly.', 'ANX1');
INSERT INTO white_cards VALUES (15392, 'Hot anime moms.', 'ANX1');
INSERT INTO white_cards VALUES (15393, 'Pissing yourself.', 'ANX1');
INSERT INTO white_cards VALUES (15394, 'GAO! GAI! GAR!!!', 'ANX1');
INSERT INTO white_cards VALUES (15395, 'Vocaloid death metal.', 'ANX1');
INSERT INTO white_cards VALUES (15396, 'The Dark Lord Shawne Kleckner.', 'ANX1');
INSERT INTO white_cards VALUES (15397, 'Yaoi paddles.', 'ANX1');
INSERT INTO white_cards VALUES (15398, 'Bad Steven Foster dubs.', 'ANX1');
INSERT INTO white_cards VALUES (15399, 'Mr. Satan.', 'ANX1');
INSERT INTO white_cards VALUES (15400, 'An actual, honest-to-God black guy.', 'ANX1');
INSERT INTO white_cards VALUES (15401, '4,000 tacos, and one Diet Coke.', 'ANX1');
INSERT INTO white_cards VALUES (15402, 'Sick with the cancer.', 'ANX1');
INSERT INTO white_cards VALUES (15403, 'Black and white samurai movies.', 'ANX1');
INSERT INTO white_cards VALUES (15404, 'A promotional crossover with Pizza Hut.', 'ANX1');
INSERT INTO white_cards VALUES (15405, 'Transvestite police officers.', 'ANX1');
INSERT INTO white_cards VALUES (15406, 'Con funk.', 'ANX1');
INSERT INTO white_cards VALUES (15407, 'Star-shaped nipples.', 'ANX1');
INSERT INTO white_cards VALUES (15408, 'A laser horse.', 'ANX1');
INSERT INTO white_cards VALUES (15409, 'Girls with guns AND glasses.', 'ANX1');
INSERT INTO white_cards VALUES (15410, 'Teenaged miniskirt-wearing space pirates.', 'ANX1');
INSERT INTO white_cards VALUES (15411, 'Gas station sushi.', 'ANX1');
INSERT INTO white_cards VALUES (4443, 'Deman making a racist pun.', 'GFC');
INSERT INTO white_cards VALUES (4444, 'Phreak staring at you and never blinking.', 'GFC');
INSERT INTO white_cards VALUES (4446, 'PENTAFAIL!', 'GFC');
INSERT INTO white_cards VALUES (4447, 'I Can''t Believe It''s Not Butter.', 'GFC');
INSERT INTO white_cards VALUES (4448, 'A Wanksock.', 'GFC');
INSERT INTO white_cards VALUES (4449, 'An arsehole like a wellington top.', 'GFC');
INSERT INTO white_cards VALUES (4450, 'Emma Watson dressed as a crab dancing to K-Pop.', 'GFC');
INSERT INTO white_cards VALUES (4451, 'BORK.', 'GFC');
INSERT INTO white_cards VALUES (4452, 'Handicapped people on Takeshi''s Castle.', 'GFC');
INSERT INTO white_cards VALUES (4453, 'The Chuckle Brothers at their mother''s funeral.', 'GFC');
INSERT INTO white_cards VALUES (4454, 'A 3am phone call.', 'GFC');
INSERT INTO white_cards VALUES (4455, 'A cardboard cutout of Jennifer Lawrence.', 'GFC');
INSERT INTO white_cards VALUES (4456, 'Robert Pattinson with Freddy Mercury''s moustache and Gilbert.', 'GFC');
INSERT INTO white_cards VALUES (4457, 'Gotfried''s voice.', 'GFC');
INSERT INTO white_cards VALUES (4458, 'Ezreal''s hot sugary ass.', 'GFC');
INSERT INTO white_cards VALUES (100220, 'A Canadian penny.', 'SG');
INSERT INTO white_cards VALUES (100221, 'dho''s penis.', 'SG');
INSERT INTO white_cards VALUES (100222, 'Griffy''s tits.', 'SG');
INSERT INTO white_cards VALUES (4459, 'Kyubey.', 'AN');
INSERT INTO white_cards VALUES (4460, 'Weeaboos.', 'AN');
INSERT INTO white_cards VALUES (4461, 'Narutards.', 'AN');
INSERT INTO white_cards VALUES (4462, 'Dead catgirls.', 'AN');
INSERT INTO white_cards VALUES (4463, 'Aniplex of America.', 'AN');
INSERT INTO white_cards VALUES (4464, 'Steve Motherfuckin'' Blum.', 'AN');
INSERT INTO white_cards VALUES (4465, 'Norio Wakamoto.', 'AN');
INSERT INTO white_cards VALUES (4466, 'Tentacle rape.', 'AN');
INSERT INTO white_cards VALUES (4467, 'Eating an entire box of Pocky in a single bite.', 'AN');
INSERT INTO white_cards VALUES (4468, 'Lolis.', 'AN');
INSERT INTO white_cards VALUES (4469, 'Hot-blooded shonen protagonists.', 'AN');
INSERT INTO white_cards VALUES (4470, 'Crispin Freeman.', 'AN');
INSERT INTO white_cards VALUES (4471, 'A fuck-mothering vampire.', 'AN');
INSERT INTO white_cards VALUES (4472, 'A big-breasted 14-year-old wearing a bikini and sucking on a popsicle.', 'AN');
INSERT INTO white_cards VALUES (4473, 'Henry Goto being savagely raped by a bear.', 'AN');
INSERT INTO white_cards VALUES (4474, 'Yet another goddamn Goku vs. Superman argument.', 'AN');
INSERT INTO white_cards VALUES (4475, 'FANSERVICE!!!', 'AN');
INSERT INTO white_cards VALUES (4476, 'Gen Fukunaga counting his money.', 'AN');
INSERT INTO white_cards VALUES (4477, 'FUNimation.', 'AN');
INSERT INTO white_cards VALUES (4478, 'Hatsune Miku.', 'AN');
INSERT INTO white_cards VALUES (4479, 'Strangling hardcore otaku nerds with razor wire.', 'AN');
INSERT INTO white_cards VALUES (4480, 'Aya Hirano being gang-banged by her entire band.', 'AN');
INSERT INTO white_cards VALUES (4481, 'Bukkake.', 'AN');
INSERT INTO white_cards VALUES (4482, 'OVER 9000!!', 'AN');
INSERT INTO white_cards VALUES (4483, 'Little Kuriboh.', 'AN');
INSERT INTO white_cards VALUES (4484, 'Bulma''s panties.', 'AN');
INSERT INTO white_cards VALUES (4485, 'Mami getting her head bitten off.', 'AN');
INSERT INTO white_cards VALUES (4486, 'A Captain Harlock body pillow.', 'AN');
INSERT INTO white_cards VALUES (4487, 'Onii-chan.', 'AN');
INSERT INTO white_cards VALUES (4488, 'MAWNING LESCUE!!!', 'AN');
INSERT INTO white_cards VALUES (4489, 'Idiots who don''t seem to realize that Avatar: The Last Airbender isn''t really an anime.', 'AN');
INSERT INTO white_cards VALUES (4490, 'Christopher R. Sabat.', 'AN');
INSERT INTO white_cards VALUES (4491, 'PASTAAAAA!!!!', 'AN');
INSERT INTO white_cards VALUES (4492, 'Johnny Yong Bosch.', 'AN');
INSERT INTO white_cards VALUES (4493, 'Yu-Gi-Oh! The Abridged Series.', 'AN');
INSERT INTO white_cards VALUES (4494, 'A fat middle-aged man in a Sailor Moon costume.', 'AN');
INSERT INTO white_cards VALUES (4495, '$300 anime bluray boxsets.', 'AN');
INSERT INTO white_cards VALUES (4496, 'Man-Faye.', 'AN');
INSERT INTO white_cards VALUES (4497, 'DAN GREEN.', 'AN');
INSERT INTO white_cards VALUES (4498, '"WE UNDERSTAND ANIME FAN WANTS!!"', 'AN');
INSERT INTO white_cards VALUES (4499, 'Dio Brando.', 'AN');
INSERT INTO white_cards VALUES (4500, 'Hokuto! Hyakurestu-ken!', 'AN');
INSERT INTO white_cards VALUES (4501, 'Vic Micderpaderp.', 'AN');
INSERT INTO white_cards VALUES (4502, 'Goku.', 'AN');
INSERT INTO white_cards VALUES (4503, 'Soldier A.', 'AN');
INSERT INTO white_cards VALUES (4504, 'Red-headed tsunderes.', 'AN');
INSERT INTO white_cards VALUES (4505, 'That sound effect in every hentai when the guy ejaculates.', 'AN');
INSERT INTO white_cards VALUES (4506, 'Sarah Fuckin'' Palin.', 'AN');
INSERT INTO white_cards VALUES (4507, 'Edward Wong Hau Pepelu Tivruski IV.', 'AN');
INSERT INTO white_cards VALUES (4508, '"Bang."', 'AN');
INSERT INTO white_cards VALUES (4509, 'Prof''s legs.', 'AN');
INSERT INTO white_cards VALUES (4510, 'Naruto.', 'AN');
INSERT INTO white_cards VALUES (4511, 'Wendee Lee.', 'AN');
INSERT INTO white_cards VALUES (4512, 'Rice balls.', 'AN');
INSERT INTO white_cards VALUES (4513, 'Monkey D. Luffy.', 'AN');
INSERT INTO white_cards VALUES (4514, 'JesuOtaku''s ginormous lips.', 'AN');
INSERT INTO white_cards VALUES (4515, 'Princess Tutu.', 'AN');
INSERT INTO white_cards VALUES (4516, 'Fujiko''s boobs.', 'AN');
INSERT INTO white_cards VALUES (4517, 'Vash the Stampede.', 'AN');
INSERT INTO white_cards VALUES (4518, 'Shinji being a whiny little bitch.', 'AN');
INSERT INTO white_cards VALUES (4519, 'Third Impact.', 'AN');
INSERT INTO white_cards VALUES (4520, 'Kenshiro.', 'AN');
INSERT INTO white_cards VALUES (4521, 'Puella Magi Madoka Magica.', 'AN');
INSERT INTO white_cards VALUES (4522, 'Cowboy Bebop.', 'AN');
INSERT INTO white_cards VALUES (4523, 'Fullmetal Alchemist.', 'AN');
INSERT INTO white_cards VALUES (4524, 'Futanari.', 'AN');
INSERT INTO white_cards VALUES (4525, 'Taking a potato chip... and EATING IT.', 'AN');
INSERT INTO white_cards VALUES (4526, 'Unreasonably long transformation sequences.', 'AN');
INSERT INTO white_cards VALUES (4527, 'Ass dance!! Ass dance!!', 'AN');
INSERT INTO white_cards VALUES (4528, 'Stupid fucking Kululu.', 'AN');
INSERT INTO white_cards VALUES (4529, 'CENTURY SOOOOUUUP!!!!!', 'AN');
INSERT INTO white_cards VALUES (4530, 'The Gripper.', 'AN');
INSERT INTO white_cards VALUES (4531, 'Thinking Misty from Pok&eacute;mon is... kinda sexy.', 'AN');
INSERT INTO white_cards VALUES (4532, 'Garzey''s Wing.', 'AN');
INSERT INTO white_cards VALUES (4533, 'Reverse harems.', 'AN');
INSERT INTO white_cards VALUES (4534, 'Mewtwo.', 'AN');
INSERT INTO white_cards VALUES (4535, 'Tengen Toppa Gurren Lagann.', 'AN');
INSERT INTO white_cards VALUES (4536, 'Sir Integra Fairbrook Wingates Hellsing.', 'AN');
INSERT INTO white_cards VALUES (4537, 'Wearing panties on the head.', 'AN');
INSERT INTO white_cards VALUES (4538, 'Brina Palencia as an angsty teenage boy, Monica Rial as his bratty little sister, and Shelley Calene-Black as their hot mom.', 'AN');
INSERT INTO white_cards VALUES (4539, 'CARD GAMES ON MOTORCYCLES.', 'AN');
INSERT INTO white_cards VALUES (4540, 'Nice boat.', 'AN');
INSERT INTO white_cards VALUES (4541, 'Boku no Pico.', 'AN');
INSERT INTO white_cards VALUES (4542, 'The One Piece rap.', 'AN');
INSERT INTO white_cards VALUES (4543, 'A Bleach hentai doujin where Rukia rapes Ichigo.', 'AN');
INSERT INTO white_cards VALUES (4544, 'Walpurgisnacht.', 'AN');
INSERT INTO white_cards VALUES (4545, 'Bludgeoning Haruhi Suzumiya to death with a tire iron.', 'AN');
INSERT INTO white_cards VALUES (4546, 'Girls with glasses.', 'AN');
INSERT INTO white_cards VALUES (4547, 'Eating the wrong end of a chocolate cornet.', 'AN');
INSERT INTO white_cards VALUES (4548, 'Being eaten by a titan.', 'AN');
INSERT INTO white_cards VALUES (4549, 'Casca''s hairy unshaven vag.', 'AN');
INSERT INTO white_cards VALUES (4550, 'Tits on your hand.', 'AN');
INSERT INTO white_cards VALUES (4551, 'That little fat kid from Accel World.', 'AN');
INSERT INTO white_cards VALUES (4552, 'The Death Note.', 'AN');
INSERT INTO white_cards VALUES (4553, 'A "read the manga" style ending.', 'AN');
INSERT INTO white_cards VALUES (4554, 'Giant robots.', 'AN');
INSERT INTO white_cards VALUES (4555, 'Osamu Tezuka.', 'AN');
INSERT INTO white_cards VALUES (4556, 'Studio Ghibli.', 'AN');
INSERT INTO white_cards VALUES (4557, 'Masa! <3', 'AN');
INSERT INTO white_cards VALUES (4558, 'THE MAN-POLE OF <i>DOOOOOOOOOM!!!</i>', 'AN');
INSERT INTO white_cards VALUES (4559, 'Ladd Russo.', 'AN');
INSERT INTO white_cards VALUES (4560, 'Home For Infinite Losers (HFIL).', 'AN');
INSERT INTO white_cards VALUES (4561, 'Moe Moe Kyun!', 'AN');
INSERT INTO white_cards VALUES (4562, 'El Psy Congroo.', 'AN');
INSERT INTO white_cards VALUES (4563, 'Sailor Moon and the 7 Ballz.', 'AN');
INSERT INTO white_cards VALUES (4564, 'Gratuitous panty shots.', 'AN');
INSERT INTO white_cards VALUES (4565, 'Sucking Kyle Hebert''s dick for hamburgers.', 'AN');
INSERT INTO white_cards VALUES (4566, 'Cartoon buttholes.', 'AN');
INSERT INTO white_cards VALUES (4567, 'Muscle-bound shirtless MEN.', 'AN');
INSERT INTO white_cards VALUES (4568, 'Recap episodes.', 'AN');
INSERT INTO white_cards VALUES (4569, 'An overly defensive fanbase.', 'AN');
INSERT INTO white_cards VALUES (4570, 'Fuckin'' Bronies.', 'AN');
INSERT INTO white_cards VALUES (4571, 'Groping strangers on a train.', 'AN');
INSERT INTO white_cards VALUES (4572, 'My Cresta.', 'AN');
INSERT INTO white_cards VALUES (4573, 'Nerdy kids in Speedos.', 'AN');
INSERT INTO white_cards VALUES (4574, 'Bad K-on! fanart.', 'AN');
INSERT INTO white_cards VALUES (4575, 'That stupid opening song from Steel Angel Kurumi getting stuck in your head.', 'AN');
INSERT INTO white_cards VALUES (4576, 'Mamoru Miyano.', 'AN');
INSERT INTO white_cards VALUES (4577, 'A Hello Kitty! vibrator.', 'AN');
INSERT INTO white_cards VALUES (4578, 'TETSUOOOOOO!!!', 'AN');
INSERT INTO white_cards VALUES (4579, 'Wibble.', 'AN');
INSERT INTO white_cards VALUES (4580, 'Black cosplayers.', 'AN');
INSERT INTO white_cards VALUES (4581, 'Fake Nendoroids.', 'AN');
INSERT INTO white_cards VALUES (4582, 'Eating ramen noodles for a month because you HAD to have that out of print Macross boxset.', 'AN');
INSERT INTO white_cards VALUES (4583, 'Showing Serial Experiments Lain to toddlers.', 'AN');
INSERT INTO white_cards VALUES (4584, 'A mindfuck.', 'AN');
INSERT INTO white_cards VALUES (4585, 'A puppy being beaten to death with a flower pot.', 'AN');
INSERT INTO white_cards VALUES (4586, 'Gantz. Just.... Gantz.', 'AN');
INSERT INTO white_cards VALUES (4587, 'Snapping the nipple off of a prostitute''s breast and eating it.', 'AN');
INSERT INTO white_cards VALUES (4588, 'Panty &amp; Stocking with Garterbelt.', 'AN');
INSERT INTO white_cards VALUES (4589, 'Punching a man so hard his clothes fly off.', 'AN');
INSERT INTO white_cards VALUES (4590, 'Banana sushi.', 'AN');
INSERT INTO white_cards VALUES (4591, 'Oro?', 'AN');
INSERT INTO white_cards VALUES (4592, 'Creamy Mami.', 'AN');
INSERT INTO white_cards VALUES (4593, 'Whatever the hell the Utena movie was about.', 'AN');
INSERT INTO white_cards VALUES (4594, 'Carl Macek.', 'AN');
INSERT INTO white_cards VALUES (4595, 'The ungodly abomination that is Robotech.', 'AN');
INSERT INTO white_cards VALUES (4596, 'Kira worshippers.', 'AN');
INSERT INTO white_cards VALUES (4597, 'The thousands upon thousands of women that Golgo 13 has slept with.', 'AN');
INSERT INTO white_cards VALUES (4598, 'Uguu...', 'AN');
INSERT INTO white_cards VALUES (4599, 'Old man dragon dick.', 'AN');
INSERT INTO white_cards VALUES (4600, 'Apocalypse Zero.', 'AN');
INSERT INTO white_cards VALUES (4601, 'Ikki Tousen.', 'AN');
INSERT INTO white_cards VALUES (4602, '". . . ."', 'AN');
INSERT INTO white_cards VALUES (4603, 'The inevitable beach episode.', 'AN');
INSERT INTO white_cards VALUES (4604, 'A Japanese schoolgirl covered head-to-toe in semen.', 'AN');
INSERT INTO white_cards VALUES (4605, 'Satoshi Kon.', 'AN');
INSERT INTO white_cards VALUES (4606, 'Kigurumi.', 'AN');
INSERT INTO white_cards VALUES (4607, 'Good ol'' fashioned Japanese sexism.', 'AN');
INSERT INTO white_cards VALUES (4608, 'Guro.', 'AN');
INSERT INTO white_cards VALUES (4609, 'Dr. Who fans showing up at anime cons despite not being invited.', 'AN');
INSERT INTO white_cards VALUES (4610, 'Plot armor.', 'AN');
INSERT INTO white_cards VALUES (4611, 'Nekomimi.', 'AN');
INSERT INTO white_cards VALUES (4612, 'Pure grade-A opium.', 'AN');
INSERT INTO white_cards VALUES (4613, 'Banging 1,000 dudes.', 'AN');
INSERT INTO white_cards VALUES (4614, 'A drunken Japanese businessman.', 'AN');
INSERT INTO white_cards VALUES (4615, 'Maid cafes.', 'AN');
INSERT INTO white_cards VALUES (4616, 'Host clubs.', 'AN');
INSERT INTO white_cards VALUES (4617, 'Shooting out nearly an entire liter of cum.', 'AN');
INSERT INTO white_cards VALUES (4618, 'The Hare Hare Yukai dance.', 'AN');
INSERT INTO white_cards VALUES (4619, 'Shining Finger!', 'AN');
INSERT INTO white_cards VALUES (4620, 'The inkvasion.', 'AN');
INSERT INTO white_cards VALUES (4621, 'School swimsuits.', 'AN');
INSERT INTO white_cards VALUES (4622, 'Underpants. Underpants. Underpants. Underpants. Under-', 'AN');
INSERT INTO white_cards VALUES (4623, 'Acidic breast milk.', 'AN');
INSERT INTO white_cards VALUES (4624, 'Kamen Rider.', 'AN');
INSERT INTO white_cards VALUES (4625, 'The Major''s hips and bust.', 'AN');
INSERT INTO white_cards VALUES (4626, 'Captain Bravo.', 'AN');
INSERT INTO white_cards VALUES (4627, 'Kirino''s ass.', 'AN');
INSERT INTO white_cards VALUES (4628, 'Crystal Boy''s creepy smile.', 'AN');
INSERT INTO white_cards VALUES (4629, 'Gackt.', 'AN');
INSERT INTO white_cards VALUES (4630, 'Used panty vending machines.', 'AN');
INSERT INTO white_cards VALUES (4631, 'Butt sniffing.', 'AN');
INSERT INTO white_cards VALUES (4632, 'Vegeta''s sweet goatee.', 'AN');
INSERT INTO white_cards VALUES (4633, 'Sub-only releases.', 'AN');
INSERT INTO white_cards VALUES (4634, 'Getting drunk on sake.', 'AN');
INSERT INTO white_cards VALUES (4635, 'Flying Vortex of Fear.', 'AN');
INSERT INTO white_cards VALUES (4636, 'Fishcake.', 'AN');
INSERT INTO white_cards VALUES (4637, 'Go Nagai sideburns.', 'AN');
INSERT INTO white_cards VALUES (4638, '<i>CHIIIIIIIIN.</i>', 'AN');
INSERT INTO white_cards VALUES (4639, 'Getting the bad ending of a visual novel.', 'AN');
INSERT INTO white_cards VALUES (4640, 'The Tsukihime anime.', 'AN');
INSERT INTO white_cards VALUES (4641, 'Jacuzzi Splot.', 'AN');
INSERT INTO white_cards VALUES (4642, 'Juvijuvibro.', 'AN');
INSERT INTO white_cards VALUES (4643, 'Bear punching, tiger chopping, shark suplexing, &amp; helicopter bodyslamming.', 'AN');
INSERT INTO white_cards VALUES (4644, 'Getting your penis cut in half.', 'AN');
INSERT INTO white_cards VALUES (4645, 'Stupid sexy Johan.', 'AN');
INSERT INTO white_cards VALUES (4646, 'Naoki Urasawa.', 'AN');
INSERT INTO white_cards VALUES (4647, 'Tachikoma-kun.', 'AN');
INSERT INTO white_cards VALUES (4648, 'Dancin'' on the Planet Dance.', 'AN');
INSERT INTO white_cards VALUES (4649, 'Super Milk-chan.', 'AN');
INSERT INTO white_cards VALUES (4650, 'You dumbass!', 'AN');
INSERT INTO white_cards VALUES (4651, 'Being the uke.', 'AN');
INSERT INTO white_cards VALUES (4652, 'The power of friendship.', 'AN');
INSERT INTO white_cards VALUES (4653, 'An arm and a leg.', 'AN');
INSERT INTO white_cards VALUES (4654, 'The entire cast of School Days.', 'AN');
INSERT INTO white_cards VALUES (4655, 'Giant naked Rei.', 'AN');
INSERT INTO white_cards VALUES (4656, 'Masturbating over Asuka''s comatose body.', 'AN');
INSERT INTO white_cards VALUES (4657, 'Let''s Fighting Love!', 'AN');
INSERT INTO white_cards VALUES (4658, 'Cousin marriage.', 'AN');
INSERT INTO white_cards VALUES (4659, '4Kids.', 'AN');
INSERT INTO white_cards VALUES (4660, 'Making someone''s head explode.', 'AN');
INSERT INTO white_cards VALUES (4661, 'Michelle Ru-<br>er, I mean... "Sophie Roberts."', 'AN');
INSERT INTO white_cards VALUES (4662, 'Calling out the name of your attack.', 'AN');
INSERT INTO white_cards VALUES (4663, 'Multi-episode fights.', 'AN');
INSERT INTO white_cards VALUES (4664, 'M.D. Geist.', 'AN');
INSERT INTO white_cards VALUES (4665, 'Blue Water Studios.', 'AN');
INSERT INTO white_cards VALUES (4666, 'Darrel Guilbeau trying to act.', 'AN');
INSERT INTO white_cards VALUES (4667, 'Highschool of the Dead.', 'AN');
INSERT INTO white_cards VALUES (4668, 'Girls with guns.', 'AN');
INSERT INTO white_cards VALUES (4669, 'The goddamn Maho.', 'AN');
INSERT INTO white_cards VALUES (4670, 'Fat, sweaty otaku.', 'AN');
INSERT INTO white_cards VALUES (4671, 'Ganguro girls.', 'AN');
INSERT INTO white_cards VALUES (4672, 'Magical girls.', 'AN');
INSERT INTO white_cards VALUES (4673, 'Hot female bass players.', 'AN');
INSERT INTO white_cards VALUES (4674, 'Goku, Luffy, Toriko, and Lina Inverse in an eating contest.', 'AN');
INSERT INTO white_cards VALUES (4675, 'BlackStar', 'AN');
INSERT INTO white_cards VALUES (4676, 'KING!!! KING!!! KING GAINER!!!<br><i>*does the Monkey*</i>', 'AN');
INSERT INTO white_cards VALUES (4677, 'You cactus bastard!', 'AN');
INSERT INTO white_cards VALUES (4678, 'Underwater Ray Romano.', 'AN');
INSERT INTO white_cards VALUES (4679, 'Sexy schoolteacher types.', 'AN');
INSERT INTO white_cards VALUES (4680, 'Tig ol'' bitties.', 'AN');
INSERT INTO white_cards VALUES (4681, 'Lesbian subtext.', 'AN');
INSERT INTO white_cards VALUES (4682, 'Watching FLCL while tripping on acid.', 'AN');
INSERT INTO white_cards VALUES (4683, 'Inspector Zenigata.', 'AN');
INSERT INTO white_cards VALUES (4684, 'Pure fighting spirit.', 'AN');
INSERT INTO white_cards VALUES (4685, 'The GARtender.', 'AN');
INSERT INTO white_cards VALUES (4686, 'Mad Bull 34.', 'AN');
INSERT INTO white_cards VALUES (4687, 'Sticking your finger up her ass.', 'AN');
INSERT INTO white_cards VALUES (4688, 'Freddie riding to school on a wild black stallion.', 'AN');
INSERT INTO white_cards VALUES (4689, 'Whatever turns you on, big guy.', 'AN');
INSERT INTO white_cards VALUES (4690, 'Standing outside the gates of the White House completely naked with a revolver in your hand.', 'AN');
INSERT INTO white_cards VALUES (4691, 'I''LL ANSWER THE PHONE FROM NOW ON, LILY!!', 'AN');
INSERT INTO white_cards VALUES (4692, 'KITTEH. :3', 'AN');
INSERT INTO white_cards VALUES (4693, 'Manly tears of manliness.', 'AN');
INSERT INTO white_cards VALUES (4694, 'Zetman.', 'AN');
INSERT INTO white_cards VALUES (4695, 'Giant mutant cockroaches.', 'AN');
INSERT INTO white_cards VALUES (4696, 'Bible Black.', 'AN');
INSERT INTO white_cards VALUES (4697, 'Rape fantasies.', 'AN');
INSERT INTO white_cards VALUES (4698, 'Keith David''s voice.', 'AN');
INSERT INTO white_cards VALUES (4699, 'Scott McNeil.', 'AN');
INSERT INTO white_cards VALUES (4700, 'The eternal pervert, Eric Vale.', 'AN');
INSERT INTO white_cards VALUES (4701, 'The Irresponsible Captain Tylor.', 'AN');
INSERT INTO white_cards VALUES (4702, 'Birdy the Mighty.', 'AN');
INSERT INTO white_cards VALUES (4703, 'Prying SpacemanHardy''s Master Keaton boxset from his cold, dead hands.', 'AN');
INSERT INTO white_cards VALUES (4704, 'Satan worshipping Christians.', 'AN');
INSERT INTO white_cards VALUES (4705, 'Hunting down every single copy of Ninja Resurrection and setting them on fire.', 'AN');
INSERT INTO white_cards VALUES (4706, 'R-R-R-R-R-REDLINE!!!', 'AN');
INSERT INTO white_cards VALUES (4707, 'Catholic priests who drink, smoke, and carry guns.', 'AN');
INSERT INTO white_cards VALUES (4708, 'Badass 15-year-olds.', 'AN');
INSERT INTO white_cards VALUES (4709, 'Losing 20 gallons of blood... and surviving.', 'AN');
INSERT INTO white_cards VALUES (4710, 'One HELL of a butler.', 'AN');
INSERT INTO white_cards VALUES (4711, 'Being beaten to a bloody pulp by a middle school student.', 'AN');
INSERT INTO white_cards VALUES (4712, 'Anime News Network.', 'AN');
INSERT INTO white_cards VALUES (4713, 'Having blackmail sex with your teacher.', 'AN');
INSERT INTO white_cards VALUES (4714, 'A large paper fan.', 'AN');
INSERT INTO white_cards VALUES (4715, 'The Shikon Jewel.', 'AN');
INSERT INTO white_cards VALUES (4716, '"INUYASHA!!"<br>"KAGOME!!"', 'AN');
INSERT INTO white_cards VALUES (4717, 'Sneaking a peek at the girls'' open bath.', 'AN');
INSERT INTO white_cards VALUES (4718, 'Revy Two-Hands.', 'AN');
INSERT INTO white_cards VALUES (4719, 'A Claymore swimsuit issue.', 'AN');
INSERT INTO white_cards VALUES (4720, 'A samurai terminator.', 'AN');
INSERT INTO white_cards VALUES (4721, 'Physics.', 'AN');
INSERT INTO white_cards VALUES (4722, 'Gangnam Style.', 'AN');
INSERT INTO white_cards VALUES (4723, 'MUNGLE!!<br><i>*shakes fist*</i>', 'AN');
INSERT INTO white_cards VALUES (4724, 'A talking motorcycle.', 'AN');
INSERT INTO white_cards VALUES (4725, 'Rie Kugimiya.', 'AN');
INSERT INTO white_cards VALUES (4726, 'The Animatrix.', 'AN');
INSERT INTO white_cards VALUES (4727, 'Your virgin soul.', 'AN');
INSERT INTO white_cards VALUES (4728, 'Franky''s awesome Speedo dance.', 'AN');
INSERT INTO white_cards VALUES (4729, 'Soul traveling.', 'AN');
INSERT INTO white_cards VALUES (4730, 'Production I.G.', 'AN');
INSERT INTO white_cards VALUES (4731, 'GONZO.', 'AN');
INSERT INTO white_cards VALUES (4732, 'Really shitty CGI effects.', 'AN');
INSERT INTO white_cards VALUES (4733, 'The hot buttered sex voice of Patrick Seitz.', 'AN');
INSERT INTO white_cards VALUES (4734, 'Sticking a chopstick in your pee-hole.', 'AN');
INSERT INTO white_cards VALUES (4735, 'A copy of Trigun signed by Micah Solusod.', 'AN');
INSERT INTO white_cards VALUES (4736, 'Gilgamesh.', 'AN');
INSERT INTO white_cards VALUES (4737, 'That one guy who always dresses up as the Red Ranger.', 'AN');
INSERT INTO white_cards VALUES (4738, 'Engrish.', 'AN');
INSERT INTO white_cards VALUES (4739, 'A dead meme.', 'AN');
INSERT INTO white_cards VALUES (4740, 'Madhouse.', 'AN');
INSERT INTO white_cards VALUES (4741, 'ARMS.', 'AN');
INSERT INTO white_cards VALUES (4742, 'Mr. Tadakichi.', 'AN');
INSERT INTO white_cards VALUES (4743, 'Showing episodes of Toriko to starving children.', 'AN');
INSERT INTO white_cards VALUES (4744, 'Governor Ishihara.', 'AN');
INSERT INTO white_cards VALUES (4745, 'Shrine maidens.', 'AN');
INSERT INTO white_cards VALUES (4746, 'Taking a shit in the shrine''s donation box.', 'AN');
INSERT INTO white_cards VALUES (4747, 'Farting... tadpoles?', 'AN');
INSERT INTO white_cards VALUES (4748, 'Heavily-tattooed yakuza henchmen.', 'AN');
INSERT INTO white_cards VALUES (4749, 'The life-sized Gundam statue.', 'AN');
INSERT INTO white_cards VALUES (4750, 'Forcing someone to watch every episode of Dragon Ball GT.', 'AN');
INSERT INTO white_cards VALUES (4751, 'ZA WARUDO.', 'AN');
INSERT INTO white_cards VALUES (4752, 'Eating a banana all sexy-like.', 'AN');
INSERT INTO white_cards VALUES (4753, 'Awesome Prussia.', 'AN');
INSERT INTO white_cards VALUES (4754, 'Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora! Ora!', 'AN');
INSERT INTO white_cards VALUES (4755, 'A shitload of yen.', 'AN');
INSERT INTO white_cards VALUES (4756, 'Johannes Krauser II.', 'AN');
INSERT INTO white_cards VALUES (4757, 'Raccoon testicles.', 'AN');
INSERT INTO white_cards VALUES (4758, 'Beautiful bishonen boys.', 'AN');
INSERT INTO white_cards VALUES (4759, 'Rule 63''d Death the Kid.', 'AN');
INSERT INTO white_cards VALUES (4760, 'Hetalia porn.', 'AN');
INSERT INTO white_cards VALUES (4761, '1,000 years of pain.', 'AN');
INSERT INTO white_cards VALUES (4762, 'Rally Vincent firing a gun in her underwear.', 'AN');
INSERT INTO white_cards VALUES (4763, 'A Maka Chop.', 'AN');
INSERT INTO white_cards VALUES (4764, 'Twincest.', 'AN');
INSERT INTO white_cards VALUES (4765, 'Broken-ass Aizen.', 'AN');
INSERT INTO white_cards VALUES (4766, 'The Garden of Sinners.', 'AN');
INSERT INTO white_cards VALUES (4767, 'Romi Paku.', 'AN');
INSERT INTO white_cards VALUES (4768, 'My Johnny!', 'AN');
INSERT INTO white_cards VALUES (4769, 'Petite Princess Yucie.', 'AN');
INSERT INTO white_cards VALUES (4770, 'Ice cold water<br>(and it''s only a dollar).', 'AN');
INSERT INTO white_cards VALUES (4771, 'Me wearing a penguin suit.', 'AN');
INSERT INTO white_cards VALUES (4772, 'Farting on your cat.', 'AN');
INSERT INTO white_cards VALUES (4773, 'Combat afros.', 'AN');
INSERT INTO white_cards VALUES (4774, 'A brand new, mint condition copy of JoJo''s Bizarre Adventure vol. 4, still in shrinkwrap.', 'AN');
INSERT INTO white_cards VALUES (4775, 'Grave of the Fireflies.', 'AN');
INSERT INTO white_cards VALUES (4776, 'Strapping hand grenades to your pubes.', 'AN');
INSERT INTO white_cards VALUES (4777, 'Toilet worship.', 'AN');
INSERT INTO white_cards VALUES (4778, 'My badass numchucks.', 'AN');
INSERT INTO white_cards VALUES (4779, 'Trying to get your die-cast Gundam model through airport security.', 'AN');
INSERT INTO white_cards VALUES (4780, 'Black&#x2605;Star', 'AN');
INSERT INTO white_cards VALUES (4781, 'Octopus balls.', 'AN');
INSERT INTO white_cards VALUES (4782, 'Getting in a fistfight with an earthquake.', 'AN');
INSERT INTO white_cards VALUES (4783, 'WcDonald''s.', 'AN');
INSERT INTO white_cards VALUES (4784, 'Undead body-swapping space vampire teens.', 'AN');
INSERT INTO white_cards VALUES (4785, 'The alpha bitch.', 'AN');
INSERT INTO white_cards VALUES (4786, 'Eating someone else''s drool.', 'AN');
INSERT INTO white_cards VALUES (4787, 'My hot zombie girlfriend..', 'AN');
INSERT INTO white_cards VALUES (4788, 'Puppets made from the skin of children.', 'AN');
INSERT INTO white_cards VALUES (4789, 'Swallowing an entire carton of cigarettes before barfing them back up.', 'AN');
INSERT INTO white_cards VALUES (4790, 'Giving a girl an orgasm using only your shoulderpads.', 'AN');
INSERT INTO white_cards VALUES (4791, 'Being accidentally turned into a girl by aliens.', 'AN');
INSERT INTO white_cards VALUES (4792, 'Ghosts that come out of your asscrack.', 'AN');
INSERT INTO white_cards VALUES (4793, '#DesuDes4Life.', 'AN');
INSERT INTO white_cards VALUES (4794, 'Fucking a nun.', 'AN');
INSERT INTO white_cards VALUES (4795, 'Raping Tokyo Tower.', 'AN');
INSERT INTO white_cards VALUES (4796, 'A succubus living inside your testes.', 'AN');
INSERT INTO white_cards VALUES (4797, 'Saber Starblast.', 'AN');
INSERT INTO white_cards VALUES (4798, 'An argument lasting over an hour about what mo&eacute; really is.', 'AN');
INSERT INTO white_cards VALUES (4799, 'Kotetsu T. Kaburagi, aka. "The D.I.L.F."', 'AN');
INSERT INTO white_cards VALUES (4800, 'Japanese Spider-Man.', 'AN');
INSERT INTO white_cards VALUES (4801, 'A bass guitar straight to the face.', 'AN');
INSERT INTO white_cards VALUES (4802, 'Sonny Strait''s manly parts.', 'AN');
INSERT INTO white_cards VALUES (4803, 'Asian cock.', 'AN');
INSERT INTO white_cards VALUES (4804, 'Guts.', 'AN');
INSERT INTO white_cards VALUES (4805, 'Holy dildos.', 'AN');
INSERT INTO white_cards VALUES (4806, 'Finger nigiri.', 'AN');
INSERT INTO white_cards VALUES (4807, 'Dragon Balls.', 'AN');
INSERT INTO white_cards VALUES (4808, 'Drills for hands.', 'AN');
INSERT INTO white_cards VALUES (4809, 'Suplexing your teacher.', 'AN');
INSERT INTO white_cards VALUES (4810, 'A leopard print fundoshi.', 'AN');
INSERT INTO white_cards VALUES (4811, 'Breast envy.', 'AN');
INSERT INTO white_cards VALUES (4812, 'The entire last episode of Blood-C.', 'AN');
INSERT INTO white_cards VALUES (4813, 'Origami sex toys.', 'AN');
INSERT INTO white_cards VALUES (4814, 'ALL OF THE HOMO!', 'AN');
INSERT INTO white_cards VALUES (4815, 'Japanese rope bondage.', 'AN');
INSERT INTO white_cards VALUES (4816, 'Griffith''s mysterious disappearing penis.', 'AN');
INSERT INTO white_cards VALUES (4817, 'Naughty geishas.', 'AN');
INSERT INTO white_cards VALUES (4818, 'Ninjas!', 'AN');
INSERT INTO white_cards VALUES (4819, 'Pubic hair needle attack.', 'AN');
INSERT INTO white_cards VALUES (4820, 'Sexy jutsu.', 'AN');
INSERT INTO white_cards VALUES (4821, 'Getting your fingernails ripped out.', 'AN');
INSERT INTO white_cards VALUES (4822, 'Shinichiro Watanabe single-handedly curing cancer, ending world hunger, and bringing peace to the Middle East.', 'AN');
INSERT INTO white_cards VALUES (4823, 'Love Machine.', 'AN');
INSERT INTO white_cards VALUES (4824, 'Rapping samurai.', 'AN');
INSERT INTO white_cards VALUES (4825, 'Putting all the condiments on your steak. ALL OF THEM.', 'AN');
INSERT INTO white_cards VALUES (4826, 'Naga''s extremely annoying laugh.', 'AN');
INSERT INTO white_cards VALUES (4827, 'A dolphin in a mech suit.', 'AN');
INSERT INTO white_cards VALUES (4828, 'Flying Nimbus.', 'AN');
INSERT INTO white_cards VALUES (4829, 'Strikeman and his "Balls of Justice".', 'AN');
INSERT INTO white_cards VALUES (4830, 'A busty, blonde, blue-eyed, dumb-as-rocks American.', 'AN');
INSERT INTO white_cards VALUES (4831, 'Running during the credits.', 'AN');
INSERT INTO white_cards VALUES (4832, 'Red bean paste.', 'AN');
INSERT INTO white_cards VALUES (4833, 'Gender-swapped Oda Nobunaga.', 'AN');
INSERT INTO white_cards VALUES (4834, 'Cutting off a finger to restore your honor.', 'AN');
INSERT INTO white_cards VALUES (4835, 'Robots with tits.', 'AN');
INSERT INTO white_cards VALUES (4836, 'Henry Goto.', 'AN:HG');
INSERT INTO white_cards VALUES (4837, 'Henry Goto having an accident in his pants during the live Aniplex of America panel.', 'AN:HG');
INSERT INTO white_cards VALUES (4838, 'Henry Goto''s massive peyote &amp; wine cooler addiction.', 'AN:HG');
INSERT INTO white_cards VALUES (4839, 'Henry Goto, John Sirabella, and Stu Levy in a three man fight to the death.', 'AN:HG');
INSERT INTO white_cards VALUES (4840, 'Henry Goto fapping to a photograph of himself.', 'AN:HG');
INSERT INTO white_cards VALUES (4841, 'Henry Goto being eaten by a group of backwoods hillbilly cannibals.', 'AN:HG');
INSERT INTO white_cards VALUES (4842, 'Henry Goto ending up homeless on the streets and sucking dick for coke.', 'AN:HG');
INSERT INTO white_cards VALUES (4843, 'Two gallons of elephant shit being dropped on Henry Goto''s desk.', 'AN:HG');
INSERT INTO white_cards VALUES (4844, 'Henry Goto falling down the stairs, receiving a massive head injury, and believing he''s really Sailor Moon.', 'AN:HG');
INSERT INTO white_cards VALUES (4845, 'A Henry Goto joke that no one will laugh at other than SpacemanHardy.', 'AN:HG');
INSERT INTO white_cards VALUES (4846, 'Henry Goto bleeding profusely from his groin after having his penis bitten off by a 15-year-old Vietnamese prostitute.', 'AN:HG');
INSERT INTO white_cards VALUES (4847, 'A 30-year-old man who''s obsessed with K-on!', 'AN');
INSERT INTO white_cards VALUES (4848, 'LAZAR!', 'AN');
INSERT INTO white_cards VALUES (4849, 'I AM AWESOME!!', 'AN');
INSERT INTO white_cards VALUES (4850, 'Getting kicked in the nuts by a mermaid.', 'AN');
INSERT INTO white_cards VALUES (4851, 'Taking a seat with Chris Hansen.', 'MrMan');
INSERT INTO white_cards VALUES (4852, 'The Village People.', 'MrMan');
INSERT INTO white_cards VALUES (4853, 'A Cleveland steamer.', 'MrMan');
INSERT INTO white_cards VALUES (4854, 'A big floppy donkey dick.', 'MrMan');
INSERT INTO white_cards VALUES (4855, 'Pooping in the bathtub.', 'MrMan');
INSERT INTO white_cards VALUES (4856, 'Bathing the homeless.', 'MrMan');
INSERT INTO white_cards VALUES (4857, 'An awkward sponge bath.', 'MrMan');
INSERT INTO white_cards VALUES (4858, 'Toilet paper.', 'MrMan');
INSERT INTO white_cards VALUES (4859, 'Getting off on anime porn.', 'MrMan');
INSERT INTO white_cards VALUES (4860, 'Enemas.', 'MrMan');
INSERT INTO white_cards VALUES (4861, 'The Teenage Mutant Ninja Turtles.', 'MrMan');
INSERT INTO white_cards VALUES (4862, 'Mining for nose gold.', 'MrMan');
INSERT INTO white_cards VALUES (4863, 'Laxatives.', 'MrMan');
INSERT INTO white_cards VALUES (4864, 'Putting the fucking lotion in the basket.', 'MrMan');
INSERT INTO white_cards VALUES (4865, 'The tears of a clown.', 'MrMan');
INSERT INTO white_cards VALUES (4866, 'Gangrene.', 'MrMan');
INSERT INTO white_cards VALUES (4867, 'Gingivitis.', 'MrMan');
INSERT INTO white_cards VALUES (4868, 'Two dogs humping.', 'MrMan');
INSERT INTO white_cards VALUES (4869, 'Genital warts.', 'MrMan');
INSERT INTO white_cards VALUES (4870, 'Suppositories.', 'MrMan');
INSERT INTO white_cards VALUES (4871, 'Face painting.', 'MrMan');
INSERT INTO white_cards VALUES (4872, 'A prolapse.', 'MrMan');
INSERT INTO white_cards VALUES (4873, 'Digital piracy.', 'MrMan');
INSERT INTO white_cards VALUES (4874, 'A poop sandwich.', 'MrMan');
INSERT INTO white_cards VALUES (4875, 'Executive parking.', 'MrMan');
INSERT INTO white_cards VALUES (4876, 'A dead hooker.', 'MrMan');
INSERT INTO white_cards VALUES (4877, 'A skeptical sheriff.', 'MrMan');
INSERT INTO white_cards VALUES (4878, 'A chatroom predator.', 'MrMan');
INSERT INTO white_cards VALUES (4879, 'A loud mouth-breather.', 'MrMan');
INSERT INTO white_cards VALUES (4880, 'The crushed dreams of a stripper.', 'MrMan');
INSERT INTO white_cards VALUES (4881, 'Anorexia.', 'MrMan');
INSERT INTO white_cards VALUES (4882, 'Gobots.', 'MrMan');
INSERT INTO white_cards VALUES (4883, 'A Motown group.', 'MrMan');
INSERT INTO white_cards VALUES (4884, 'a classy smoking jacket.', 'MrMan');
INSERT INTO white_cards VALUES (4885, 'Giant areolas.', 'MrMan');
INSERT INTO white_cards VALUES (4886, 'Peanutbutter jelly time.', 'MrMan');
INSERT INTO white_cards VALUES (4887, 'A sexy senior citizen.', 'MrMan');
INSERT INTO white_cards VALUES (4888, 'Granny panties.', 'MrMan');
INSERT INTO white_cards VALUES (4889, 'A stuttering auctioneer.', 'MrMan');
INSERT INTO white_cards VALUES (4890, 'Farting into a fancy handkerchief.', 'MrMan');
INSERT INTO white_cards VALUES (4891, 'Lot lizards.', 'MrMan');
INSERT INTO white_cards VALUES (4892, 'A LARPing sleeper cell.', 'MrMan');
INSERT INTO white_cards VALUES (4893, 'A Fleshlite&trade;.', 'MrMan');
INSERT INTO white_cards VALUES (4894, 'A molotov cocktail.', 'MrMan');
INSERT INTO white_cards VALUES (4895, 'A cockblocker.', 'MrMan');
INSERT INTO white_cards VALUES (4896, 'Public schooling.', 'MrMan');
INSERT INTO white_cards VALUES (4897, 'The end of the world.', 'MrMan');
INSERT INTO white_cards VALUES (4898, 'Dickjitsu.', 'MrMan');
INSERT INTO white_cards VALUES (4899, 'A mushy tushy.', 'MrMan');
INSERT INTO white_cards VALUES (4900, 'Don Knotts.', 'MrMan');
INSERT INTO white_cards VALUES (4901, 'Morbid obesity.', 'MrMan');
INSERT INTO white_cards VALUES (4902, 'Geriatric diaper rash.', 'MrMan');
INSERT INTO white_cards VALUES (4903, 'A MILF.', 'MrMan');
INSERT INTO white_cards VALUES (4904, 'Bigfoot.', 'MrMan');
INSERT INTO white_cards VALUES (4905, 'Yellow snow.', 'MrMan');
INSERT INTO white_cards VALUES (4906, 'A limp wrist.', 'MrMan');
INSERT INTO white_cards VALUES (4907, 'An angry leprechaun.', 'MrMan');
INSERT INTO white_cards VALUES (4908, 'The Tin Man.', 'MrMan');
INSERT INTO white_cards VALUES (4909, 'Giving yourself a stranger.', 'MrMan');
INSERT INTO white_cards VALUES (4910, 'Shitting into someone''s hat for revenge.', 'MrMan');
INSERT INTO white_cards VALUES (4911, 'Learning hypnosis to get laid.', 'MrMan');
INSERT INTO white_cards VALUES (4912, 'The War of Northern Aggression.', 'MrMan');
INSERT INTO white_cards VALUES (4913, 'A snot rocket.', 'MrMan');
INSERT INTO white_cards VALUES (4914, 'Miss. Piggy.', 'MrMan');
INSERT INTO white_cards VALUES (4915, 'Sailor Moon.', 'MrMan');
INSERT INTO white_cards VALUES (4916, 'Mass graves.', 'MrMan');
INSERT INTO white_cards VALUES (4917, 'A victim.', 'MrMan');
INSERT INTO white_cards VALUES (4918, 'Soiling ones self.', 'MrMan');
INSERT INTO white_cards VALUES (4919, 'A clone army.', 'MrMan');
INSERT INTO white_cards VALUES (4920, 'Raw sewage.', 'MrMan');
INSERT INTO white_cards VALUES (4921, 'War crimes.', 'MrMan');
INSERT INTO white_cards VALUES (4922, 'A collapsed lung.', 'MrMan');
INSERT INTO white_cards VALUES (4923, 'The town drunk.', 'MrMan');
INSERT INTO white_cards VALUES (4924, 'The face of pure evil.', 'MrMan');
INSERT INTO white_cards VALUES (4925, 'Spontaneous pie fights.', 'MrMan');
INSERT INTO white_cards VALUES (4926, 'The Fresh Prince of Bel-Air.', 'MrMan');
INSERT INTO white_cards VALUES (4927, 'Being screamed at in German.', 'MrMan');
INSERT INTO white_cards VALUES (4928, 'A lesson in pain.', 'MrMan');
INSERT INTO white_cards VALUES (4929, 'Talking like a pirate.', 'MrMan');
INSERT INTO white_cards VALUES (4930, 'A Facebook stalker.', 'MrMan');
INSERT INTO white_cards VALUES (4931, 'Sausage.', 'MrMan');
INSERT INTO white_cards VALUES (4932, 'A compound fracture.', 'MrMan');
INSERT INTO white_cards VALUES (4933, 'The magical land of Oz.', 'MrMan');
INSERT INTO white_cards VALUES (4934, 'Pow-Pow-PowerWheeels&reg;!', 'MrMan');
INSERT INTO white_cards VALUES (4935, 'Cheating death.', 'MrMan');
INSERT INTO white_cards VALUES (4936, 'Clown Shoes.', 'MrMan');
INSERT INTO white_cards VALUES (4937, 'Clown college.', 'MrMan');
INSERT INTO white_cards VALUES (4938, 'A lousy comb-over.', 'MrMan');
INSERT INTO white_cards VALUES (4939, 'Chaz Bono.', 'MrMan');
INSERT INTO white_cards VALUES (4940, 'Hoarders.', 'MrMan');
INSERT INTO white_cards VALUES (4941, 'Bed wetting.', 'MrMan');
INSERT INTO white_cards VALUES (4942, 'Nuns.', 'MrMan');
INSERT INTO white_cards VALUES (4943, 'A closed casket funeral.', 'MrMan');
INSERT INTO white_cards VALUES (4944, 'Scotch.', 'MrMan');
INSERT INTO white_cards VALUES (4945, 'A really ugly baby.', 'MrMan');
INSERT INTO white_cards VALUES (4947, 'Realizing, too late, that there is no toilet paper left.', 'MrMan');
INSERT INTO white_cards VALUES (4948, 'Illegal immigrants.', 'MrMan');
INSERT INTO white_cards VALUES (4949, 'Elder abuse.', 'MrMan');
INSERT INTO white_cards VALUES (15412, 'Jerry Jewell''s serial killer face.', 'ANX1');
INSERT INTO white_cards VALUES (15413, 'A FUCKING DRAGONITE, MOTHERFUCKER!!', 'ANX1');
INSERT INTO white_cards VALUES (15414, 'A school bus orgy.', 'ANX1');
INSERT INTO white_cards VALUES (15415, 'Super Aryan Hitler.', 'ANX1');
INSERT INTO white_cards VALUES (15416, 'Having sex with a dragon.', 'ANX1');
INSERT INTO white_cards VALUES (15417, 'Manga Jesus.', 'ANX1');
INSERT INTO white_cards VALUES (15418, 'Manly pink sparkles.', 'ANX1');
INSERT INTO white_cards VALUES (15419, '7 ft. tall red-headed Alexander the Great.', 'ANX1');
INSERT INTO white_cards VALUES (15420, 'Training a dinosaur to ride a ball.', 'ANX1');
INSERT INTO white_cards VALUES (15421, 'Samba-dancing dinosaurs.', 'ANX1');
INSERT INTO white_cards VALUES (15422, 'An armored truck full of shit.', 'ANX1');
INSERT INTO white_cards VALUES (15423, 'A Togepi omelet.', 'ANX1');
INSERT INTO white_cards VALUES (15424, 'The Puchuu.', 'ANX1');
INSERT INTO white_cards VALUES (15425, 'Dying over and over again.', 'ANX1');
INSERT INTO white_cards VALUES (15426, 'Fuckingham Palace.', 'ANX1');
INSERT INTO white_cards VALUES (15427, 'Epic old bald dudes.', 'ANX1');
INSERT INTO white_cards VALUES (15428, 'A smashed-in face.', 'ANX1');
INSERT INTO white_cards VALUES (15429, 'A Dragon Slave.', 'ANX1');
INSERT INTO white_cards VALUES (15430, 'Zelgadis'' flame-proof bikini briefs.', 'ANX1');
INSERT INTO white_cards VALUES (15431, 'Morphin''.', 'ANX1');
INSERT INTO white_cards VALUES (15432, 'A naughty nurse outfit.', 'ANX1');
INSERT INTO white_cards VALUES (15433, 'A sweaty shirtless man holding a large, writhing fish against his chest.', 'ANX1');
INSERT INTO white_cards VALUES (15434, 'Millionaire Beaver.', 'ANX1');
INSERT INTO white_cards VALUES (15435, 'Dick Saucer.', 'ANX1');
INSERT INTO white_cards VALUES (15436, 'A couple that spends over 30 manga volumes trying to get to first base.', 'ANX1');
INSERT INTO white_cards VALUES (15437, 'Alice in Sexland.', 'ANX1');
INSERT INTO white_cards VALUES (15438, 'Succubus-on-futanari action.', 'ANX1');
INSERT INTO white_cards VALUES (15439, 'High-stakes mahjong.', 'ANX1');
INSERT INTO white_cards VALUES (15440, 'Garbage collectors... IN SPACE!!', 'ANX1');
INSERT INTO white_cards VALUES (15441, 'Magical friendship lasers.', 'ANX1');
INSERT INTO white_cards VALUES (15442, 'The War on Pants.', 'ANX1');
INSERT INTO white_cards VALUES (15443, 'An ending where everyone dies.', 'ANX1');
INSERT INTO white_cards VALUES (15444, 'A cyborg assassin dressed as a magical girl fighting a talking lion and a floating psychic electric jellyfish.', 'ANX1');
INSERT INTO white_cards VALUES (15445, 'J-pop idols.', 'ANX1');
INSERT INTO white_cards VALUES (15446, 'Chest-hair afros.', 'ANX1');
INSERT INTO white_cards VALUES (15447, 'Cowboy Andy.', 'ANX1');
INSERT INTO white_cards VALUES (15448, 'A chainsaw-wielding male magical girl zombie.', 'ANX1');
INSERT INTO white_cards VALUES (15449, 'Inoue Kikoku, 17-years old.', 'ANX1');
INSERT INTO white_cards VALUES (15450, 'Fujoshi.', 'ANX1');
INSERT INTO white_cards VALUES (15451, 'Matrix boobs.', 'ANX1');
INSERT INTO white_cards VALUES (15452, 'Completely losing your shit over Endless Eight.', 'ANX1');
INSERT INTO white_cards VALUES (15453, 'Violently beating your friends to death with a baseball bat.', 'ANX1');
INSERT INTO white_cards VALUES (15454, 'Clothing-dissolving slime.', 'ANX1');
INSERT INTO white_cards VALUES (15455, 'Involuntary crossdressing.', 'ANX1');
INSERT INTO white_cards VALUES (15456, 'Getting sucked into a fantasy world.', 'ANX1');
INSERT INTO white_cards VALUES (15457, 'Hentai artists who don''t change their pen name when they go legit.', 'ANX1');
INSERT INTO white_cards VALUES (15458, 'A Masamune Shirou artbook.', 'ANX1');
INSERT INTO white_cards VALUES (15459, 'Loli in a box.', 'ANX1');
INSERT INTO white_cards VALUES (15460, 'Romance of the Three Kingdoms, but everyone is gender-swapped.', 'ANX1');
INSERT INTO white_cards VALUES (15461, 'Mo&eacute; schoolgirl Hitler.', 'ANX1');
INSERT INTO white_cards VALUES (15462, 'Franken Fran.', 'ANX1');
INSERT INTO white_cards VALUES (15463, 'A washpan falling onto someone''s head from out of nowhere.', 'ANX1');
INSERT INTO white_cards VALUES (15464, 'SHAFT being SHAFT.', 'ANX1');
INSERT INTO white_cards VALUES (15465, 'A third-grader seducing her 23-year-old teacher.', 'ANX1');
INSERT INTO white_cards VALUES (15466, 'Shotas.', 'ANX1');
INSERT INTO white_cards VALUES (15467, 'One a them bamboo things that goes "doonk".', 'ANX1');
INSERT INTO white_cards VALUES (15468, 'Banging your adopted daughter.', 'ANX1');
INSERT INTO white_cards VALUES (15469, 'Tripping, falling, and landing with your face in a girl''s breasts.', 'ANX1');
INSERT INTO white_cards VALUES (15470, 'A bunny girl having a lightsaber duel with Darth Vader.', 'ANX1');
INSERT INTO white_cards VALUES (15471, 'A 10-year old with boobs twice the size of her head.', 'ANX1');
INSERT INTO white_cards VALUES (15472, 'An ancient vampire who looks like she''s 10.', 'ANX1');
INSERT INTO white_cards VALUES (15473, 'Literally ripping your own heart out.', 'ANX1');
INSERT INTO white_cards VALUES (15474, 'Japanese-style elf ears.', 'ANX1');
INSERT INTO white_cards VALUES (15475, 'Flamboyantly gay William Shakespeare.', 'ANX1');
INSERT INTO white_cards VALUES (15476, 'Gen "The Uro-Butcher".', 'ANX1');
INSERT INTO white_cards VALUES (15477, 'Mikuru Beam!', 'ANX1');
INSERT INTO white_cards VALUES (15478, 'Tons and tons of close-up underaged schoolgirl ass-shots.', 'ANX1');
INSERT INTO white_cards VALUES (15479, 'Starfish Hitler.', 'ANX1');
INSERT INTO white_cards VALUES (15480, 'Pok&eacute;mon tears.', 'ANX1');
INSERT INTO white_cards VALUES (15481, 'Pok&eacute;sexuality.', 'ANX1');
INSERT INTO white_cards VALUES (15482, 'Chopstick-based martial arts.', 'ANX1');
INSERT INTO white_cards VALUES (15483, 'All the gayness in GetBackers.', 'ANX1');
INSERT INTO white_cards VALUES (15484, 'Naming yourself after the method of your suicide.', 'ANX1');
INSERT INTO white_cards VALUES (15485, 'The Chupacabra.', 'ANX1');
INSERT INTO white_cards VALUES (15486, 'Blowing a child''s head off with a rocket launcher.', 'ANX1');
INSERT INTO white_cards VALUES (15487, 'Erotic incestuous toothbrushing.', 'ANX1');
INSERT INTO white_cards VALUES (15488, 'An artbox that feels like human skin.', 'ANX1');
INSERT INTO white_cards VALUES (15489, 'Polygamy jokes in a kid''s show.', 'ANX1');
INSERT INTO white_cards VALUES (15490, 'Urd, Kana, and Misato in a drinking contest.', 'ANX1');
INSERT INTO white_cards VALUES (15491, 'Cute stuff.', 'ANX1');
INSERT INTO white_cards VALUES (15492, 'A robot having an orgasm.', 'ANX1');
INSERT INTO white_cards VALUES (15493, 'Villagulio.', 'ANX1');
INSERT INTO white_cards VALUES (15494, 'Dangling Pok&eacute;balls.', 'ANX1');
INSERT INTO white_cards VALUES (15495, 'Having a giant drill for a dick.', 'ANX1');
INSERT INTO white_cards VALUES (15522, 'An ingrown toenail on the tip of a penis.', 'AI');
INSERT INTO white_cards VALUES (15523, 'Feline Leukemia.', 'AI');
INSERT INTO white_cards VALUES (15524, 'Marky Mark''s foam rubber penis from Boogie Nights.', 'AI');
INSERT INTO white_cards VALUES (15525, 'My Spankerchief.', 'AI');
INSERT INTO white_cards VALUES (15526, 'Pumping a chemical toilet.', 'AI');
INSERT INTO white_cards VALUES (15527, 'The fine line between kinky and perverted.', 'AI');
INSERT INTO white_cards VALUES (15528, 'A Rotisserie Chicken.', 'AI');
INSERT INTO white_cards VALUES (15529, 'Vultures circling a birthday party.', 'AI');
INSERT INTO white_cards VALUES (15530, 'An All White Jury.', 'AI');
INSERT INTO white_cards VALUES (15531, 'Frottage.', 'AI');
INSERT INTO white_cards VALUES (15532, 'Michael J. Fox trying to use a rotary phone.', 'AI');
INSERT INTO white_cards VALUES (15533, 'The Five Knuckle Truffle Punch.', 'AI');
INSERT INTO white_cards VALUES (15534, 'Flipper Babies.', 'AI');
INSERT INTO white_cards VALUES (15535, 'Ejaculating into an insulin pump.', 'AI');
INSERT INTO white_cards VALUES (15536, 'Rocky Dennis and John Merrick''s lovechild.', 'AI');
INSERT INTO white_cards VALUES (15537, 'The syrupy goop inside a Stretch Armstrong doll.', 'AI');
INSERT INTO white_cards VALUES (15538, 'Finding an adhesive bandage at the bottom of your ice cream.', 'AI');
INSERT INTO white_cards VALUES (15539, 'Life after Parole.', 'AI');
INSERT INTO white_cards VALUES (15540, 'A cat''s sand papery tongue bath.', 'AI');
INSERT INTO white_cards VALUES (15541, 'A Pit Bull named Genghis.', 'AI');
INSERT INTO white_cards VALUES (10108, 'Discovering that it''s never just a big vagina.', 'Furry');
INSERT INTO white_cards VALUES (10109, 'Dragoneer.', 'Furry');
INSERT INTO white_cards VALUES (10110, 'A horny dragon.', 'Furry');
INSERT INTO white_cards VALUES (10111, 'A sexually frustrated griffon.', 'Furry');
INSERT INTO white_cards VALUES (10112, 'Species stereotypes.', 'Furry');
INSERT INTO white_cards VALUES (10113, 'HELLO FURRIEND, HOWL ARE YOU DOING.', 'Furry');
INSERT INTO white_cards VALUES (10114, 'Convention sluts.', 'Furry');
INSERT INTO white_cards VALUES (10115, 'Horns and hooves.', 'Furry');
INSERT INTO white_cards VALUES (10116, 'Being "prison gay."', 'Furry');
INSERT INTO white_cards VALUES (10117, 'Microwaving diapers.', 'Furry');
INSERT INTO white_cards VALUES (10118, 'Adorable dog people.', 'Furry');
INSERT INTO white_cards VALUES (10119, 'Sexy the Cat.', 'Furry');
INSERT INTO white_cards VALUES (10120, 'That one episode of CSI.', 'Furry');
INSERT INTO white_cards VALUES (10121, 'SecondLife.', 'Furry');
INSERT INTO white_cards VALUES (10122, 'The Gay Yiffy Club.', 'Furry');
INSERT INTO white_cards VALUES (10123, 'Hyper-endowed squirrels.', 'Furry');
INSERT INTO white_cards VALUES (10124, 'A spider furry who isn''t even into bondage.', 'Furry');
INSERT INTO white_cards VALUES (10125, 'Being really, really into monsters.', 'Furry');
INSERT INTO white_cards VALUES (10126, 'Sexual arousal from children''s cartoons.', 'Furry');
INSERT INTO white_cards VALUES (10127, 'No males, no herms, no cuntboys, no shemales, no trannys, no furries, no aliens, no vampires, and no werewolves. ONLY STRAIGHT OR BI HUMAN FEMALES.', 'Furry');
INSERT INTO white_cards VALUES (10128, 'Overcompensating with a huge horse penis.', 'Furry');
INSERT INTO white_cards VALUES (10129, 'A fedora enthusiast.', 'Furry');
INSERT INTO white_cards VALUES (10130, 'A tongue-beast.', 'Furry');
INSERT INTO white_cards VALUES (10131, 'Frisky tentacles.', 'Furry');
INSERT INTO white_cards VALUES (10132, 'A very steampunk rat.', 'Furry');
INSERT INTO white_cards VALUES (10133, 'Canine superiority.', 'Furry');
INSERT INTO white_cards VALUES (10134, 'Oviposition.', 'Furry');
INSERT INTO white_cards VALUES (10135, 'Flares.', 'Furry');
INSERT INTO white_cards VALUES (10136, 'Dogs wearing panties.', 'Furry');
INSERT INTO white_cards VALUES (10137, 'Monster boys in lingerie.', 'Furry');
INSERT INTO white_cards VALUES (10138, 'Power bottoms.', 'Furry');
INSERT INTO white_cards VALUES (10139, 'Sheath licking.', 'Furry');
INSERT INTO white_cards VALUES (10140, 'Sex with Pok&eacute;mon.', 'Furry');
INSERT INTO white_cards VALUES (10141, 'Making out with dogs.', 'Furry');
INSERT INTO white_cards VALUES (10142, 'YouTube videos of horse breeding.', 'Furry');
INSERT INTO white_cards VALUES (10143, 'Pissing on your significant other to show ownership.', 'Furry');
INSERT INTO white_cards VALUES (1331, 'Da Magicks.', 'CAE');
INSERT INTO white_cards VALUES (10144, 'Being able to recognize your friends by the scent of their asses.', 'Furry');
INSERT INTO white_cards VALUES (10145, 'A notebook full of embarrassing niche porn sketches.', 'Furry');
INSERT INTO white_cards VALUES (10146, 'Cockvore.', 'Furry');
INSERT INTO white_cards VALUES (10147, 'A prehensile penis.', 'Furry');
INSERT INTO white_cards VALUES (10148, 'Puns involving the word "knot."', 'Furry');
INSERT INTO white_cards VALUES (10149, 'Jerking off on an unconscious friend''s feet.', 'Furry');
INSERT INTO white_cards VALUES (10150, 'CrusaderCat.', 'Furry');
INSERT INTO white_cards VALUES (10151, 'Your Character Here.', 'Furry');
INSERT INTO white_cards VALUES (15542, 'Sphincter Bleaching.', 'AI');
INSERT INTO white_cards VALUES (15543, 'Bringing the Hamburglar to Justice.', 'AI');
INSERT INTO white_cards VALUES (15544, 'Toilet Wine.', 'AI');
INSERT INTO white_cards VALUES (15545, 'An Amputee''s chapped limb nub.', 'AI');
INSERT INTO white_cards VALUES (15546, 'Febreezing your Taint.', 'AI');
INSERT INTO white_cards VALUES (15547, 'Leftist Propaganda.', 'AI');
INSERT INTO white_cards VALUES (15548, 'Cookie Monster''s substance abuse issues.', 'AI');
INSERT INTO white_cards VALUES (100241, 'An outbreak of smallbox.', 'BOX');
INSERT INTO white_cards VALUES (100242, 'The Boxcar Children.', 'BOX');
INSERT INTO white_cards VALUES (100243, 'A world without boxes.', 'BOX');
INSERT INTO white_cards VALUES (100244, 'Boxing up my feelings.', 'BOX');
INSERT INTO white_cards VALUES (100247, 'Something that looks like a box but turns out to be a crate.', 'BOX');
INSERT INTO white_cards VALUES (100250, 'The J15 Patriot Assault Box.', 'BOX');
INSERT INTO white_cards VALUES (100251, 'A box without hinges, key, or lid, yet golden treasure inside is hid.', 'BOX');
INSERT INTO white_cards VALUES (100255, 'Former President George W. Box.', 'BOX');
INSERT INTO white_cards VALUES (100256, 'Pandora''s vagina.', 'BOX');
INSERT INTO white_cards VALUES (100263, 'Offering sexual favors for an ore and a sheep. (19/44)', 'PAX');
INSERT INTO white_cards VALUES (100265, 'Winning the approval of Cooking Mama that you never got from actual mama. (32/44)', 'PAX');
INSERT INTO white_cards VALUES (100270, 'Reading the comments.<span class="cardnum">3 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100275, 'The collective wail of every Magic player suddenly realizing that they''ve spent hundreds of dollars on pieces of cardboard.<span class="cardnum">8 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100276, 'Being an attractive elf trapped in an unattractive human''s body.<span class="cardnum">9 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100277, 'Temporary invincibility.<span class="cardnum">10 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100281, 'Mario Kart rage.<span class="cardnum">14 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100287, 'A homemade, cum-stained Star Trek uniform.<span class="cardnum">20 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100290, 'Never watching, discussing, or thinking about My Little Pony.<span class="cardnum">23 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100291, 'Turn-of-the-century sky racists.<span class="cardnum">24 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100293, 'A fully-dressed female videogame character.<span class="cardnum">26 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100294, 'Buying virtual clothes for a Sim family instead of real clothes for a real family.<span class="cardnum">27 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100295, 'Google Glass + e-cigarette: Ultimate Combo!<span class="cardnum">28 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (1259, 'A daisy sandwich.', 'CAE');
INSERT INTO white_cards VALUES (100237, 'A box.', 'BOX');
INSERT INTO white_cards VALUES (100238, 'A box within a box.', 'BOX');
INSERT INTO white_cards VALUES (100239, 'A boxing match with a giant box.', 'BOX');
INSERT INTO white_cards VALUES (100248, 'A box that is conscious and wishes it weren''t a box.', 'BOX');
INSERT INTO white_cards VALUES (100258, 'Reading the comments. (3/44)', 'PAX');
INSERT INTO white_cards VALUES (100268, 'Full HD.<span class="cardnum">1 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100272, 'Allowing nacho cheese to curdle in your beard while you creep in League of Legends.<span class="cardnum">5 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100278, 'The Sarlacc.<span class="cardnum">11 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100282, 'Nude-modding Super Mario World.<span class="cardnum">15 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100283, 'An angry stone head that stomps on the floor every three seconds.<span class="cardnum">16 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100284, 'Yoshi''s huge egg-laying cloaca.<span class="cardnum">17 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100285, 'The Cock Ring of Alacrity.<span class="cardnum">18 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100286, 'Offering sexual favors for an ore and a sheep.<span class="cardnum">19 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100288, 'Unlocking a new sex position.<span class="cardnum">21 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100289, 'The boner hatch in the Iron Man suit.<span class="cardnum">22 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100292, 'The decade of legal inquests following a single hour of Grand Theft Auto.<span class="cardnum">25 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100296, 'Legendary Creature &ndash; Robert Khoo.<span class="cardnum">31 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100297, 'Winning the approval of Cooking Mama that you never got from actual mama.<span class="cardnum">32 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100305, 'Tapping Sara Angel.<span class="cardnum">29 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100306, 'Charles Barkley Shut Up and Jam!<span class="cardnum">30 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100307, 'Getting into a situation with an owlbear.<span class="cardnum">34 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100308, 'Grand Theft Auto: Fort Lauderdale.<span class="cardnum">35 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100309, 'A madman who lives in a policebox and kidnaps women.<span class="cardnum">36 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100310, 'SNES cartridge cleaning fluid.<span class="cardnum">37 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100311, 'Eating a pizza that''s lying on the street to gain health.<span class="cardnum">33 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (1261, 'A decorative toaster cozy.', 'CAE');
INSERT INTO white_cards VALUES (1263, 'A giant horse cock.', 'CAE');
INSERT INTO white_cards VALUES (1266, 'A hoof in the ass.', 'CAE');
INSERT INTO white_cards VALUES (1269, 'A horny stallion.', 'CAE');
INSERT INTO white_cards VALUES (1271, 'A human fetish.', 'CAE');
INSERT INTO white_cards VALUES (1272, 'A juice box fetish.', 'CAE');
INSERT INTO white_cards VALUES (1274, 'A juice box.', 'CAE');
INSERT INTO white_cards VALUES (1276, 'A mare in heat.', 'CAE');
INSERT INTO white_cards VALUES (1278, 'A racially pure Cloudsdale.', 'CAE');
INSERT INTO white_cards VALUES (1280, 'A sexy saddle.', 'CAE');
INSERT INTO white_cards VALUES (1282, 'A sock fetish.', 'CAE');
INSERT INTO white_cards VALUES (1284, 'A Sonic Raingasm.', 'CAE');
INSERT INTO white_cards VALUES (1286, 'A tactical sonic rainnuke.', 'CAE');
INSERT INTO white_cards VALUES (1288, 'A tree.', 'CAE');
INSERT INTO white_cards VALUES (1290, 'Actually cumming inside Rainbow Dash.', 'CAE');
INSERT INTO white_cards VALUES (1293, 'An epic pony war in the distant future.', 'CAE');
INSERT INTO white_cards VALUES (1294, 'An extremely horny Granny Smith.', 'CAE');
INSERT INTO white_cards VALUES (1296, 'Another doughnut! With extra sprinkles!', 'CAE');
INSERT INTO white_cards VALUES (1298, 'Applebucking.', 'CAE');
INSERT INTO white_cards VALUES (1299, 'Applejack.', 'CAE');
INSERT INTO white_cards VALUES (1300, 'Avasting Fluttershy''s Ass.', 'CAE');
INSERT INTO white_cards VALUES (1302, 'Baked Bads.', 'CAE');
INSERT INTO white_cards VALUES (1304, 'Banned From Equestria (Daily).', 'CAE');
INSERT INTO white_cards VALUES (1307, 'Being trapped on the Moon for 1000 years.', 'CAE');
INSERT INTO white_cards VALUES (1308, 'Best Pony.', 'CAE');
INSERT INTO white_cards VALUES (1310, 'Big Macintosh.', 'CAE');
INSERT INTO white_cards VALUES (1312, 'BonBon.', 'CAE');
INSERT INTO white_cards VALUES (1314, 'Books.', 'CAE');
INSERT INTO white_cards VALUES (1316, 'Celestia''s Hoof.', 'CAE');
INSERT INTO white_cards VALUES (1318, 'Celestia''s massive harem of foals.', 'CAE');
INSERT INTO white_cards VALUES (1320, 'Cider.', 'CAE');
INSERT INTO white_cards VALUES (1322, 'Clopfics.', 'CAE');
INSERT INTO white_cards VALUES (1324, 'Clopping.', 'CAE');
INSERT INTO white_cards VALUES (1326, 'Crippled foals.', 'CAE');
INSERT INTO white_cards VALUES (1328, 'Cupcakes.', 'CAE');
INSERT INTO white_cards VALUES (1332, 'Daring Do fanfiction.', 'CAE');
INSERT INTO white_cards VALUES (1333, 'Dark Magicks.', 'CAE');
INSERT INTO white_cards VALUES (1334, 'Derpy Hooves.', 'CAE');
INSERT INTO white_cards VALUES (1335, 'Diamond Dog roleplay.', 'CAE');
INSERT INTO white_cards VALUES (1336, 'Discord.', 'CAE');
INSERT INTO white_cards VALUES (1337, 'Equestria.', 'CAE');
INSERT INTO white_cards VALUES (1338, 'Facehoofing.', 'CAE');
INSERT INTO white_cards VALUES (1339, 'Fillidelphia.', 'CAE');
INSERT INTO white_cards VALUES (1340, 'Filly fiddling.', 'CAE');
INSERT INTO white_cards VALUES (1341, 'Fluffy Pony.', 'CAE');
INSERT INTO white_cards VALUES (1342, 'Fluttershy.', 'CAE');
INSERT INTO white_cards VALUES (1343, 'Fluttershy''s secret stash.', 'CAE');
INSERT INTO white_cards VALUES (1344, 'Fluttershy''s Shed.', 'CAE');
INSERT INTO white_cards VALUES (1346, 'Fluttertree.', 'CAE');
INSERT INTO white_cards VALUES (1348, 'Foal abuse.', 'CAE');
INSERT INTO white_cards VALUES (1349, 'Foodmanes.', 'CAE');
INSERT INTO white_cards VALUES (1351, 'Friendship.', 'CAE');
INSERT INTO white_cards VALUES (1357, 'Futaloo.', 'CAE');
INSERT INTO white_cards VALUES (1358, 'Gabby Gums.', 'CAE');
INSERT INTO white_cards VALUES (1360, 'Gently stroking the horn.', 'CAE');
INSERT INTO white_cards VALUES (1362, 'Getting 20% cooler!', 'CAE');
INSERT INTO white_cards VALUES (1364, 'Gypsies.', 'CAE');
INSERT INTO white_cards VALUES (1367, 'Having hot pony sex with Bloomberg.', 'CAE');
INSERT INTO white_cards VALUES (1368, 'Horn Necrosis.', 'CAE');
INSERT INTO white_cards VALUES (1379, 'Hugging a pony non-sexually.', 'CAE');
INSERT INTO white_cards VALUES (1380, 'Jappleack.', 'CAE');
INSERT INTO white_cards VALUES (1381, 'Joe''s Donut Hole.', 'CAE');
INSERT INTO white_cards VALUES (1382, 'John Joseco.', 'CAE');
INSERT INTO white_cards VALUES (1383, 'Lesbians.', 'CAE');
INSERT INTO white_cards VALUES (1384, 'Zecora''s meth lab.', 'CAE');
INSERT INTO white_cards VALUES (1385, 'Lyra Heartstrings.', 'CAE');
INSERT INTO white_cards VALUES (1386, 'Worst pony.', 'CAE');
INSERT INTO white_cards VALUES (1387, 'Magic.', 'CAE');
INSERT INTO white_cards VALUES (1388, 'Wolfieshy.', 'CAE');
INSERT INTO white_cards VALUES (1389, 'Winter Wrap Up.', 'CAE');
INSERT INTO white_cards VALUES (1390, 'Making Magic.', 'CAE');
INSERT INTO white_cards VALUES (1391, 'Wincest.', 'CAE');
INSERT INTO white_cards VALUES (1392, 'Whipping the Earth Pony slaves.', 'CAE');
INSERT INTO white_cards VALUES (1393, 'Vinyl Scratch / DJ Pon-3.', 'CAE');
INSERT INTO white_cards VALUES (1394, 'Unicorn Privilege.', 'CAE');
INSERT INTO white_cards VALUES (1395, 'Man Spike.', 'CAE');
INSERT INTO white_cards VALUES (1396, 'Two fillies shitting into a bucket.', 'CAE');
INSERT INTO white_cards VALUES (1397, 'Manehatten.', 'CAE');
INSERT INTO white_cards VALUES (1398, 'Twist.', 'CAE');
INSERT INTO white_cards VALUES (1399, 'Mare Supremacy.', 'CAE');
INSERT INTO white_cards VALUES (1400, 'Twilight''s secret clop stash.', 'CAE');
INSERT INTO white_cards VALUES (1401, 'Molestia''s sex dungeon.', 'CAE');
INSERT INTO white_cards VALUES (1402, 'Twilight Sparkle.', 'CAE');
INSERT INTO white_cards VALUES (1403, 'THE ROYAL CANTERLOT VOICE.', 'CAE');
INSERT INTO white_cards VALUES (1404, 'My OC.', 'CAE');
INSERT INTO white_cards VALUES (1405, 'The Rainbow Factory.', 'CAE');
INSERT INTO white_cards VALUES (1406, 'Nightmare Moon.', 'CAE');
INSERT INTO white_cards VALUES (1407, 'The Pegasus Master Race.', 'CAE');
INSERT INTO white_cards VALUES (14817, '____.', 'TGWTG');
INSERT INTO white_cards VALUES (14818, '*liveshot*.', 'TGWTG');
INSERT INTO white_cards VALUES (14819, '8-Bit Mickey on an unstoppable merry-go-round.', 'TGWTG');
INSERT INTO white_cards VALUES (14820, '80''s Dan.', 'TGWTG');
INSERT INTO white_cards VALUES (14821, 'A Blip ad for the most embarrassing reality show ever.', 'TGWTG');
INSERT INTO white_cards VALUES (14822, 'A Brad Jones impersonation.', 'TGWTG');
INSERT INTO white_cards VALUES (14823, 'A crossover.', 'TGWTG');
INSERT INTO white_cards VALUES (14824, 'A Cybermat in a bow tie.', 'TGWTG');
INSERT INTO white_cards VALUES (14825, 'A delicious fried chicken holocaust.', 'TGWTG');
INSERT INTO white_cards VALUES (14826, 'A DMCA takedown notice.', 'TGWTG');
INSERT INTO white_cards VALUES (14827, 'A fan artist.', 'TGWTG');
INSERT INTO white_cards VALUES (14828, 'A FUCKING PONCHO!', 'TGWTG');
INSERT INTO white_cards VALUES (14829, 'A giant go-fuck-yourself spider.', 'TGWTG');
INSERT INTO white_cards VALUES (14830, 'A half naked, fencing JewWario.', 'TGWTG');
INSERT INTO white_cards VALUES (14831, 'A hand-basket of lobsters.', 'TGWTG');
INSERT INTO white_cards VALUES (14832, 'A Mr. T Trading Card.', 'TGWTG');
INSERT INTO white_cards VALUES (14833, 'A pile of skulls.', 'TGWTG');
INSERT INTO white_cards VALUES (14834, 'A pink tutu.', 'TGWTG');
INSERT INTO white_cards VALUES (14835, 'A plushie TARDIS.', 'TGWTG');
INSERT INTO white_cards VALUES (14836, 'A poorly made knockoff action figure.', 'TGWTG');
INSERT INTO white_cards VALUES (14837, 'A REALLY big hoopla about nothing.', 'TGWTG');
INSERT INTO white_cards VALUES (14838, 'A Serbian Film.', 'TGWTG');
INSERT INTO white_cards VALUES (14839, 'A smoking, muscled ice cream cone shooting guns and eye lasers.', 'TGWTG');
INSERT INTO white_cards VALUES (14840, 'A speeding NERF dart to the junk.', 'TGWTG');
INSERT INTO white_cards VALUES (14841, 'A squadron of attack Corgis.', 'TGWTG');
INSERT INTO white_cards VALUES (14842, 'A squadron of line-dancing hippos.', 'TGWTG');
INSERT INTO white_cards VALUES (14843, 'A strip-tease from the Nostalgia Critic.', 'TGWTG');
INSERT INTO white_cards VALUES (14844, 'A tauntaun puppy.', 'TGWTG');
INSERT INTO white_cards VALUES (14845, 'A very serious hat.', 'TGWTG');
INSERT INTO white_cards VALUES (14846, 'Ambiguously nude Linkara.', 'TGWTG');
INSERT INTO white_cards VALUES (14847, 'An electronic cigarette that resembles a Sonic Screwdriver.', 'TGWTG');
INSERT INTO white_cards VALUES (14848, 'An evangelizing minion.', 'TGWTG');
INSERT INTO white_cards VALUES (14849, 'An existential crisis over internet reviews.', 'TGWTG');
INSERT INTO white_cards VALUES (14850, 'An impassioned plea for understanding.', 'TGWTG');
INSERT INTO white_cards VALUES (14851, 'An unhinged Oancitizen rolling towards the sea.', 'TGWTG');
INSERT INTO white_cards VALUES (14852, 'Angry Joe dancing in a squid suit.', 'TGWTG');
INSERT INTO white_cards VALUES (14853, 'Angry Joe''s raging boner.', 'TGWTG');
INSERT INTO white_cards VALUES (14854, 'Another fucking Iron Liz pun.', 'TGWTG');
INSERT INTO white_cards VALUES (14855, 'Another goddamn PhilBuni Vine.', 'TGWTG');
INSERT INTO white_cards VALUES (14856, 'Aplos, or Steve, the Wizard.', 'TGWTG');
INSERT INTO white_cards VALUES (14857, 'Arlo P. Arlo.', 'TGWTG');
INSERT INTO white_cards VALUES (14858, 'Arlo the Orc.', 'TGWTG');
INSERT INTO white_cards VALUES (14859, 'Ashens taking a blowtorch to a crappy toy.', 'TGWTG');
INSERT INTO white_cards VALUES (14860, 'Ashens.', 'TGWTG');
INSERT INTO white_cards VALUES (14861, 'Because...hippos.', 'TGWTG');
INSERT INTO white_cards VALUES (14862, 'Becoming possessed and insulting your colleague.', 'TGWTG');
INSERT INTO white_cards VALUES (14863, 'Being awkward around your favorite reviewer.', 'TGWTG');
INSERT INTO white_cards VALUES (14864, 'Bennett the Sage.', 'TGWTG');
INSERT INTO white_cards VALUES (14865, 'Big Butter Jesus.', 'TGWTG');
INSERT INTO white_cards VALUES (14866, 'Blip.', 'TGWTG');
INSERT INTO white_cards VALUES (14867, 'Brad, drinking a Turkey-flavored Jones Soda.', 'TGWTG');
INSERT INTO white_cards VALUES (14868, 'Bruno Matei.', 'TGWTG');
INSERT INTO white_cards VALUES (14869, 'Butchered Dutch.', 'TGWTG');
INSERT INTO white_cards VALUES (14870, 'Comicron One.', 'TGWTG');
INSERT INTO white_cards VALUES (14871, 'CR.', 'TGWTG');
INSERT INTO white_cards VALUES (14872, 'Cynthia Rothrock', 'TGWTG');
INSERT INTO white_cards VALUES (14873, 'DEATH FROM ABOOOOOVE!!!', 'TGWTG');
INSERT INTO white_cards VALUES (14874, 'Derek the Bard.', 'TGWTG');
INSERT INTO white_cards VALUES (14875, 'Derek the Bard''s hat.', 'TGWTG');
INSERT INTO white_cards VALUES (14876, 'Disturbing comments in the RDA chat.', 'TGWTG');
INSERT INTO white_cards VALUES (14877, 'Dodger''s ban chain.', 'TGWTG');
INSERT INTO white_cards VALUES (14878, 'Dodging blowjobs.', 'TGWTG');
INSERT INTO white_cards VALUES (14879, 'Dr. Tease & Dr. Block.', 'TGWTG');
INSERT INTO white_cards VALUES (14880, 'Dragging Oancitizen back home from a wild night of partying.', 'TGWTG');
INSERT INTO white_cards VALUES (14881, 'Dump cards.', 'TGWTG');
INSERT INTO white_cards VALUES (14882, 'E Rod''s smooth, smooth dance skills.', 'TGWTG');
INSERT INTO white_cards VALUES (14883, 'Eating the flesh of your foes while howling at the moon.', 'TGWTG');
INSERT INTO white_cards VALUES (14884, 'Evilina.', 'TGWTG');
INSERT INTO white_cards VALUES (14885, 'Evilina''s monstrous visage.', 'TGWTG');
INSERT INTO white_cards VALUES (14886, 'Film Brain, dressed tastefully in fashionable clothing.', 'TGWTG');
INSERT INTO white_cards VALUES (14887, 'Film Brain''s hair.', 'TGWTG');
INSERT INTO white_cards VALUES (14888, 'Film Renegado creaming himself over Pacific Rim.', 'TGWTG');
INSERT INTO white_cards VALUES (14889, 'Forcing an NPC to haul your crap.', 'TGWTG');
INSERT INTO white_cards VALUES (14890, 'Fuckstick the Magic Dragon.', 'TGWTG');
INSERT INTO white_cards VALUES (14891, 'Gargoyle Cat.', 'TGWTG');
INSERT INTO white_cards VALUES (14892, 'Haganistan.', 'TGWTG');
INSERT INTO white_cards VALUES (14893, 'Harmony Korine.', 'TGWTG');
INSERT INTO white_cards VALUES (14894, 'HIPPOS!', 'TGWTG');
INSERT INTO white_cards VALUES (14895, 'Holly.', 'TGWTG');
INSERT INTO white_cards VALUES (14896, 'Il Neige in a freakishly accurate Film Brain costume.', 'TGWTG');
INSERT INTO white_cards VALUES (14897, 'Jaeris, the Gunslinger.', 'TGWTG');
INSERT INTO white_cards VALUES (14898, 'Joe Quesada.', 'TGWTG');
INSERT INTO white_cards VALUES (14899, 'Kali.', 'TGWTG');
INSERT INTO white_cards VALUES (14900, 'Kung Tai Ted.', 'TGWTG');
INSERT INTO white_cards VALUES (14901, 'Kyle playing GTA while drunk.', 'TGWTG');
INSERT INTO white_cards VALUES (14902, 'Kyle''s "unicorns."', 'TGWTG');
INSERT INTO white_cards VALUES (14903, 'Laura, the Fender Stratocaster Goddess.', 'TGWTG');
INSERT INTO white_cards VALUES (14904, 'Linkara lying naked on his futon, playing with a Cybermat.', 'TGWTG');
INSERT INTO white_cards VALUES (14905, 'Linkara, dressed as the Green Ranger.', 'TGWTG');
INSERT INTO white_cards VALUES (14906, 'Linkara, dropping an F-Bomb.', 'TGWTG');
INSERT INTO white_cards VALUES (14907, 'Linkara, sexily eating a salad.', 'TGWTG');
INSERT INTO white_cards VALUES (14908, 'Linkara''s massive ego.', 'TGWTG');
INSERT INTO white_cards VALUES (14909, 'Little Pluckies Ninja Protects.', 'TGWTG');
INSERT INTO white_cards VALUES (14910, 'Luke Mochrie''s trust fund.', 'TGWTG');
INSERT INTO white_cards VALUES (14911, 'Maven of ze Eventide.', 'TGWTG');
INSERT INTO white_cards VALUES (14912, 'Mexican Spider-Man.', 'TGWTG');
INSERT INTO white_cards VALUES (14913, 'MikeJ.', 'TGWTG');
INSERT INTO white_cards VALUES (14914, 'Moarte.', 'TGWTG');
INSERT INTO white_cards VALUES (14915, 'Nash, dressed as The Undertaker.', 'TGWTG');
INSERT INTO white_cards VALUES (14916, 'Nash, making "vroom vroom" noises.', 'TGWTG');
INSERT INTO white_cards VALUES (14917, 'Nash, making train sounds in a bathtub.', 'TGWTG');
INSERT INTO white_cards VALUES (14918, 'Nella.', 'TGWTG');
INSERT INTO white_cards VALUES (14919, 'Nella''s cleavage Altoids.', 'TGWTG');
INSERT INTO white_cards VALUES (14920, 'Not reading the FAQ.', 'TGWTG');
INSERT INTO white_cards VALUES (14921, 'Obelisk Blue Linkara.', 'TGWTG');
INSERT INTO white_cards VALUES (14922, 'Paw.', 'TGWTG');
INSERT INTO white_cards VALUES (14923, 'Paw''s soul patch.', 'TGWTG');
INSERT INTO white_cards VALUES (14924, 'Penis whiskers.', 'TGWTG');
INSERT INTO white_cards VALUES (10509, 'the 8 million jews.', 'Vidya');
INSERT INTO white_cards VALUES (10510, 'George Costanza', 'Viyda');
INSERT INTO white_cards VALUES (10511, 'Honk! Honk!', 'Vidya');
INSERT INTO white_cards VALUES (10512, 'Hideo Kojima', 'Vidya');
INSERT INTO white_cards VALUES (10513, 'Alright', 'Vidya');
INSERT INTO white_cards VALUES (10514, 'LIQUID!', 'Vidya');
INSERT INTO white_cards VALUES (10515, 'BROTHER!', 'Vidya');
INSERT INTO white_cards VALUES (10516, 'Gaben', 'Vidya');
INSERT INTO white_cards VALUES (10517, 'Kirby''s Air Ride', 'Vidya');
INSERT INTO white_cards VALUES (10518, 'Yume Nikki', 'Vidya');
INSERT INTO white_cards VALUES (10519, 'HL3 confirmed!', 'Vidya');
INSERT INTO white_cards VALUES (10520, 'That feel', 'Vidya');
INSERT INTO white_cards VALUES (10521, 'Tim Buckley', 'Vidya');
INSERT INTO white_cards VALUES (10522, 'Bum Tickley', 'Vidya');
INSERT INTO white_cards VALUES (10523, 'Star Wars: Battlefront', 'Vidya');
INSERT INTO white_cards VALUES (10524, 'The Wii U', 'Vidya');
INSERT INTO white_cards VALUES (10525, 'the PS4', 'Vidya');
INSERT INTO white_cards VALUES (10526, 'the NES', 'Vidya');
INSERT INTO white_cards VALUES (10527, 'the SNES', 'Vidya');
INSERT INTO white_cards VALUES (10528, 'the SEGA Genesis', 'Vidya');
INSERT INTO white_cards VALUES (10529, 'the PSX', 'Vidya');
INSERT INTO white_cards VALUES (10530, 'Silent Hill', 'Vidya');
INSERT INTO white_cards VALUES (10531, 'Harry Mason', 'Vidya');
INSERT INTO white_cards VALUES (10532, 'James Sunderland', 'Vidya');
INSERT INTO white_cards VALUES (10533, 'the plot of MGS4', 'Vidya');
INSERT INTO white_cards VALUES (10534, 'Kramer', 'Vidya');
INSERT INTO white_cards VALUES (10535, 'no games', 'Vidya');
INSERT INTO white_cards VALUES (10536, 'Words, Words, Words', 'Vidya');
INSERT INTO white_cards VALUES (10537, 'Le /v/ culture', 'Vidya');
INSERT INTO white_cards VALUES (10538, 'Mods', 'Vidya');
INSERT INTO white_cards VALUES (10539, 'Furfags', 'Vidya');
INSERT INTO white_cards VALUES (10540, 'HERESY!', 'Vidya');
INSERT INTO white_cards VALUES (10541, 'My waifu', 'Vidya');
INSERT INTO white_cards VALUES (10542, 'Jews', 'Vidya');
INSERT INTO white_cards VALUES (10543, 'the duck hunt dog', 'Vidya');
INSERT INTO white_cards VALUES (10544, 'Max Payne', 'Vidya');
INSERT INTO white_cards VALUES (10545, 'L.A. Noire', 'Vidya');
INSERT INTO white_cards VALUES (10546, 'Call of Duty 4', 'Vidya');
INSERT INTO white_cards VALUES (10547, 'Cowadooty Franchise', 'Vidya');
INSERT INTO white_cards VALUES (10548, 'Master Chef', 'Vidya');
INSERT INTO white_cards VALUES (10549, 'Samus Aran', 'Vidya');
INSERT INTO white_cards VALUES (10550, 'Kamiya', 'Vidya');
INSERT INTO white_cards VALUES (10551, 'The red ring of death', 'Vidya');
INSERT INTO white_cards VALUES (10552, 'Toady', 'Vidya');
INSERT INTO white_cards VALUES (10553, 'the mustard race', 'Vidya');
INSERT INTO white_cards VALUES (10554, 'Klonies', 'Vidya');
INSERT INTO white_cards VALUES (10555, 'Valve', 'Vidya');
INSERT INTO white_cards VALUES (10556, 'source engine', 'Vidya');
INSERT INTO white_cards VALUES (10557, 'Wii-tier graphics', 'Vidya');
INSERT INTO white_cards VALUES (10558, 'brown and bloom', 'Vidya');
INSERT INTO white_cards VALUES (10559, 'FUCKING GAMESTOP', 'Vidya');
INSERT INTO white_cards VALUES (10560, 'Mountain Dew', 'Vidya');
INSERT INTO white_cards VALUES (10561, 'Doritoes', 'Vidya');
INSERT INTO white_cards VALUES (10562, 'Dante, but you an call him Dante the demon killer', 'Vidya');
INSERT INTO white_cards VALUES (10563, 'FUCK YOU', 'Vidya');
INSERT INTO white_cards VALUES (10564, 'Princess Peach', 'Vidya');
INSERT INTO white_cards VALUES (10565, 'Ronnie', 'Vidya');
INSERT INTO white_cards VALUES (10566, 'Wreck-It Ralph', 'Vidya');
INSERT INTO white_cards VALUES (10567, 'Destroy-It Dan', 'Vidya');
INSERT INTO white_cards VALUES (10568, 'Rape-It Randy', 'Vidya');
INSERT INTO white_cards VALUES (10569, 'Bayonetta', 'Vidya');
INSERT INTO white_cards VALUES (10570, 'Fifa 2014', 'Vidya');
INSERT INTO white_cards VALUES (10571, 'Superman 64', 'Vidya');
INSERT INTO white_cards VALUES (10572, 'E.T. for Atari', 'Vidya');
INSERT INTO white_cards VALUES (10573, 'Dark Souls', 'Vidya');
INSERT INTO white_cards VALUES (10574, 'Devil May Cry', 'Vidya');
INSERT INTO white_cards VALUES (10575, 'Wubs', 'Vidya');
INSERT INTO white_cards VALUES (10576, 'a custom built PC', 'Vidya');
INSERT INTO white_cards VALUES (10577, 'making an email to gabe newell one post at a time', 'Vidya');
INSERT INTO white_cards VALUES (10578, 'Warioware', 'Vidya');
INSERT INTO white_cards VALUES (10579, 'Earthbound', 'Vidya');
INSERT INTO white_cards VALUES (10580, 'Pikmen', 'Vidya');
INSERT INTO white_cards VALUES (10581, 'Duck Hunt', 'Vidya');
INSERT INTO white_cards VALUES (10582, 'Egoraptor', 'Vidya');
INSERT INTO white_cards VALUES (10583, 'Cory in the House', 'Vidya');
INSERT INTO white_cards VALUES (10584, 'Katawa Shoujio', 'Vidya');
INSERT INTO white_cards VALUES (10585, 'Donte', 'Vidya');
INSERT INTO white_cards VALUES (10586, '/sp/', 'Vidya');
INSERT INTO white_cards VALUES (10587, '/pol/', 'Vidya');
INSERT INTO white_cards VALUES (10588, '/a/', 'Vidya');
INSERT INTO white_cards VALUES (10589, 'Traps', 'Vidya');
INSERT INTO white_cards VALUES (10590, 'Capitan Falcon', 'Vidya');
INSERT INTO white_cards VALUES (10591, 'knowing that feel', 'Vidya');
INSERT INTO white_cards VALUES (10592, 'my sides', 'Vidya');
INSERT INTO white_cards VALUES (10593, 'wagglan', 'Vidya');
INSERT INTO white_cards VALUES (10594, 'playing vidya', 'Vidya');
INSERT INTO white_cards VALUES (10595, 'being a casual fuck', 'Vidya');
INSERT INTO white_cards VALUES (10596, 'JonTron', 'Vidya');
INSERT INTO white_cards VALUES (10597, 'Two Best Friends', 'Vidya');
INSERT INTO white_cards VALUES (10598, 'Tropes vs Women in Video Games', 'Vidya');
INSERT INTO white_cards VALUES (10599, 'Anita', 'Vidya');
INSERT INTO white_cards VALUES (10600, 'Wiimote', 'Vidya');
INSERT INTO white_cards VALUES (10601, 'Xbox Hueg', 'Vidya');
INSERT INTO white_cards VALUES (10602, 'Japan Time', 'Vidya');
INSERT INTO white_cards VALUES (10603, 'the orignal Xbox controller', 'Vidya');
INSERT INTO white_cards VALUES (10604, 'Solid Snake''s Ass', 'Vidya');
INSERT INTO white_cards VALUES (10605, 'Big Boss', 'Vidya');
INSERT INTO white_cards VALUES (10606, 'Kirby', 'Vidya');
INSERT INTO white_cards VALUES (10607, 'Waluigi', 'Vidya');
INSERT INTO white_cards VALUES (10608, 'Geno', 'Vidya');
INSERT INTO white_cards VALUES (10609, 'Ridley', 'Vidya');
INSERT INTO white_cards VALUES (10610, 'GLaDOS', 'Vidya');
INSERT INTO white_cards VALUES (10611, 'Shigeru Miyamoto', 'Vidya');
INSERT INTO white_cards VALUES (10612, 'Mother 3', 'Vidya');
INSERT INTO white_cards VALUES (10613, 'Shigesato Itoi', 'Vidya');
INSERT INTO white_cards VALUES (10614, 'Alexey Pajinov', 'Vidya');
INSERT INTO white_cards VALUES (10615, 'Sam & Max', 'Vidya');
INSERT INTO white_cards VALUES (10616, 'Banjo-Kazooie', 'Vidya');
INSERT INTO white_cards VALUES (10617, 'Hank Hill', 'Vidya');
INSERT INTO white_cards VALUES (10618, 'Pheonix Wright', 'Vidya');
INSERT INTO white_cards VALUES (10619, 'the orange gem from Bejeweled&trade;', 'Vidya');
INSERT INTO white_cards VALUES (10620, 'thowing bottles of holy water in the original Castlevania', 'Vidya');
INSERT INTO white_cards VALUES (10621, 'using your PC as a heater in the winter', 'Vidya');
INSERT INTO white_cards VALUES (10622, 'Wii Fit Trainer', 'Vidya');
INSERT INTO white_cards VALUES (10623, 'Nanomachines, son', 'Vidya');
INSERT INTO white_cards VALUES (10624, 'Creating a LttP vs Majora''s Mask', 'Vidya');
INSERT INTO white_cards VALUES (10625, 'Following the damn train', 'Vidya');
INSERT INTO white_cards VALUES (10626, 'Kotaku', 'Vidya');
INSERT INTO white_cards VALUES (10627, 'checking your privledge', 'Vidya');
INSERT INTO white_cards VALUES (10628, 'having fun', 'Vidya');
INSERT INTO white_cards VALUES (10629, 'Call of Cthulhu', 'Vidya');
INSERT INTO white_cards VALUES (10630, 'Corruption of Champions', 'Vidya');
INSERT INTO white_cards VALUES (10631, 'Sanic', 'Vidya');
INSERT INTO white_cards VALUES (10632, 'Sanic Adventure 2', 'Vidya');
INSERT INTO white_cards VALUES (10633, 'Civillization IV', 'Vidya');
INSERT INTO white_cards VALUES (10634, 'League of Legends', 'Vidya');
INSERT INTO white_cards VALUES (10635, 'DoTA 2', 'Vidya');
INSERT INTO white_cards VALUES (10636, 'HoN', 'Vidya');
INSERT INTO white_cards VALUES (10637, 'asking br? when joining a server', 'Vidya');
INSERT INTO white_cards VALUES (10638, 'Geralt', 'Vidya');
INSERT INTO white_cards VALUES (10639, 'Halo', 'Vidya');
INSERT INTO white_cards VALUES (10640, 'Doomguy', 'Vidya');
INSERT INTO white_cards VALUES (10641, 'Regginator', 'Vidya');
INSERT INTO white_cards VALUES (10642, 'tfw no qt gf', 'Vidya');
INSERT INTO white_cards VALUES (10643, 'Atelier', 'Vidya');
INSERT INTO white_cards VALUES (10644, 'Asura', 'Vidya');
INSERT INTO white_cards VALUES (10645, 'Obsidrones', 'Vidya');
INSERT INTO white_cards VALUES (10646, 'Nintenyearolds', 'Vidya');
INSERT INTO white_cards VALUES (10647, 'Xbots', 'Vidya');
INSERT INTO white_cards VALUES (10648, 'Sonyggers', 'Vidya');
INSERT INTO white_cards VALUES (10649, 'Hitscan', 'Vidya');
INSERT INTO white_cards VALUES (10650, 'xX420blazeitXx', 'Vidya');
INSERT INTO white_cards VALUES (10651, 'Sakurai', 'Vidya');
INSERT INTO white_cards VALUES (10652, 'blowing into a catridge', 'Vidya');
INSERT INTO white_cards VALUES (10653, 'Dragon Dildos', 'Vidya');
INSERT INTO white_cards VALUES (10654, 'Nintendo', 'Vidya');
INSERT INTO white_cards VALUES (10655, 'Sony', 'Vidya');
INSERT INTO white_cards VALUES (10656, 'Microsoft', 'Vidya');
INSERT INTO white_cards VALUES (10657, 'Sega', 'Vidya');
INSERT INTO white_cards VALUES (10658, 'Konami', 'Vidya');
INSERT INTO white_cards VALUES (10659, 'Game Freak', 'Vidya');
INSERT INTO white_cards VALUES (10660, 'Fez', 'Vidya');
INSERT INTO white_cards VALUES (10661, 'Cave Story', 'Vidya');
INSERT INTO white_cards VALUES (10662, 'Wololololololololo', 'Vidya');
INSERT INTO white_cards VALUES (10663, 'pirating games because you hate the government', 'Vidya');
INSERT INTO white_cards VALUES (10664, 'New Super Luigi Bros', 'Vidya');
INSERT INTO white_cards VALUES (10665, 'the Demoman (who takes skill)', 'Vidya');
INSERT INTO white_cards VALUES (10666, 'the Pyro (who takes skill)', 'Vidya');
INSERT INTO white_cards VALUES (10667, 'on disk DLC', 'Vidya');
INSERT INTO white_cards VALUES (10668, 'sports games the come out year after year', 'Vidya');
INSERT INTO white_cards VALUES (10669, 'Ass Creed', 'Vidya');
INSERT INTO white_cards VALUES (10670, 'playing counterstrike too seriously', 'Vidya');
INSERT INTO white_cards VALUES (10671, 'Minecraft', 'Vidya');
INSERT INTO white_cards VALUES (10672, 'Notch', 'Vidya');
INSERT INTO white_cards VALUES (10673, 'Buzzwords', 'Vidya');
INSERT INTO white_cards VALUES (10674, 'OFF by Mortis Ghost', 'Vidya');
INSERT INTO white_cards VALUES (10675, 'an indie dev that no one knows about', 'Vidya');
INSERT INTO white_cards VALUES (10676, 'the Secret of Monkey Island', 'Vidya');
INSERT INTO white_cards VALUES (10677, 'watching let''s plays on youtube', 'Vidya');
INSERT INTO white_cards VALUES (10678, 'grumpy dumpies', 'Vidya');
INSERT INTO white_cards VALUES (10679, 'Spaghetti', 'Vidya');
INSERT INTO white_cards VALUES (10680, 'the best Final Fantasy game', 'Vidya');
INSERT INTO white_cards VALUES (10681, 'Grayson Hunt', 'Vidya');
INSERT INTO white_cards VALUES (10682, 'not completing all the side quests', 'Vidya');
INSERT INTO white_cards VALUES (10683, 'artificial difficulty', 'Vidya');
INSERT INTO white_cards VALUES (10684, 'padding', 'Vidya');
INSERT INTO white_cards VALUES (10685, 'artificial fun', 'Vidya');
INSERT INTO white_cards VALUES (10686, 'Matt and Pat', 'Vidya');
INSERT INTO white_cards VALUES (10687, 'Hamberger Helper', 'Vidya');
INSERT INTO white_cards VALUES (10688, 'Yahtzee', 'Vidya');
INSERT INTO white_cards VALUES (10689, 'iJustine', 'Vidya');
INSERT INTO white_cards VALUES (10690, 'Jack Thompson', 'Vidya');
INSERT INTO white_cards VALUES (10691, 'rebbit', 'Vidya');
INSERT INTO white_cards VALUES (10692, 'The /v/idya gaem awards', 'Vidya');
INSERT INTO white_cards VALUES (10693, 'Emi (from Katawa Shoujo)', 'Vidya');
INSERT INTO white_cards VALUES (10694, 'Rin (from Katawa Shuojo)', 'Vidya');
INSERT INTO white_cards VALUES (10695, 'Lilly (from Katawa Shuojo)', 'Vidya');
INSERT INTO white_cards VALUES (10696, 'Hanako (from Katawa Shuojo)', 'Vidya');
INSERT INTO white_cards VALUES (10697, 'Shizune (from Katawa Shuojo)', 'Vidya');
INSERT INTO white_cards VALUES (10698, 'Misha (from Katawa Shuojo)', 'Vidya');
INSERT INTO white_cards VALUES (10699, 'Kenji (from Katawa Shuojo)', 'Vidya');
INSERT INTO white_cards VALUES (10700, 'The Last of Us', 'Vidya');
INSERT INTO white_cards VALUES (10701, '/v/', 'Vidya');
INSERT INTO white_cards VALUES (10702, 'Video Games', 'Vidya');
INSERT INTO white_cards VALUES (10703, 'NSA', 'Vidya');
INSERT INTO white_cards VALUES (10704, 'Christopher Robin', 'Vidya');
INSERT INTO white_cards VALUES (10705, 'The Master Race', 'Vidya');
INSERT INTO white_cards VALUES (10706, '/mlp/', 'Vidya');
INSERT INTO white_cards VALUES (10707, 'Bronies', 'Vidya');
INSERT INTO white_cards VALUES (10708, '/vg/', 'Vidya');
INSERT INTO white_cards VALUES (10709, '/vr/', 'Vidya');
INSERT INTO white_cards VALUES (10710, '/vp/', 'Vidya');
INSERT INTO white_cards VALUES (10711, 'p2w', 'Vidya');
INSERT INTO white_cards VALUES (10712, 'the delay time of Duke Nukem Forever', 'Vidya');
INSERT INTO white_cards VALUES (10713, 'Duke Nukem', 'Vidya');
INSERT INTO white_cards VALUES (10714, 'WoW', 'Vidya');
INSERT INTO white_cards VALUES (10715, 'Worth the Weight', 'Vidya');
INSERT INTO white_cards VALUES (10716, 'anything but video games', 'Vidya');
INSERT INTO white_cards VALUES (10717, 'Tom Preston', 'Vidya');
INSERT INTO white_cards VALUES (10718, 'Andrew Dobson', 'Vidya');
INSERT INTO white_cards VALUES (10719, 'nogames', 'Vidya');
INSERT INTO white_cards VALUES (10720, '2spooky', 'Vidya');
INSERT INTO white_cards VALUES (10721, '599 US Dollars ', 'Vidya');
INSERT INTO white_cards VALUES (10722, 'Eight Point Eight', 'Vidya');
INSERT INTO white_cards VALUES (10723, 'RAGE', 'Vidya');
INSERT INTO white_cards VALUES (14925, 'Playing TGWTG Cards Against Humanity at stupid o''clock.', 'TGWTG');
INSERT INTO white_cards VALUES (14926, 'Pol Pot pies.', 'TGWTG');
INSERT INTO white_cards VALUES (14927, 'Rachel Tietz, trying to Kill the Nostalgia Critic.', 'TGWTG');
INSERT INTO white_cards VALUES (14928, 'Ripping off part of your penis.', 'TGWTG');
INSERT INTO white_cards VALUES (14929, 'ROCKET BOOTS!', 'TGWTG');
INSERT INTO white_cards VALUES (14930, 'ROCKET PUNCH!', 'TGWTG');
INSERT INTO white_cards VALUES (14931, 'Sad Panda''s lanky, manly chest.', 'TGWTG');
INSERT INTO white_cards VALUES (14932, 'Sage''s "RAPE!" face.', 'TGWTG');
INSERT INTO white_cards VALUES (14933, 'Sean.', 'TGWTG');
INSERT INTO white_cards VALUES (14934, 'Sex, violence, and Daffy Duck screaming.', 'TGWTG');
INSERT INTO white_cards VALUES (14935, 'Shouting "FUS-RO-DAH!" at a puppy.', 'TGWTG');
INSERT INTO white_cards VALUES (14936, 'Smarty.', 'TGWTG');
INSERT INTO white_cards VALUES (14937, 'Smarty''s special bag of AIDS.', 'TGWTG');
INSERT INTO white_cards VALUES (14938, 'Snowflame''s cocaine flavored popsicles.', 'TGWTG');
INSERT INTO white_cards VALUES (14939, 'Snowflame''s fuzzy slippers.', 'TGWTG');
INSERT INTO white_cards VALUES (14940, 'Space Core.', 'TGWTG');
INSERT INTO white_cards VALUES (14941, 'Stealing money off dead wolves.', 'TGWTG');
INSERT INTO white_cards VALUES (14942, 'Surprise blowjobs.', 'TGWTG');
INSERT INTO white_cards VALUES (14943, 'Tara''s tramautic childhood stories.', 'TGWTG');
INSERT INTO white_cards VALUES (14944, 'That Dude In The Suede.', 'TGWTG');
INSERT INTO white_cards VALUES (14945, 'The Adventures of Horsemeat and the Placenta #1.', 'TGWTG');
INSERT INTO white_cards VALUES (14946, 'The Amazing Bulk.', 'TGWTG');
INSERT INTO white_cards VALUES (14947, 'The Channel Awesome satellite.', 'TGWTG');
INSERT INTO white_cards VALUES (14948, 'The Hippo Lantern Corps.', 'TGWTG');
INSERT INTO white_cards VALUES (14949, 'The Last Angry Geek.', 'TGWTG');
INSERT INTO white_cards VALUES (14950, 'The Longbox of the Damned.', 'TGWTG');
INSERT INTO white_cards VALUES (14951, 'The Nostalgia Ranger.', 'TGWTG');
INSERT INTO white_cards VALUES (14952, 'The Rap Critic.', 'TGWTG');
INSERT INTO white_cards VALUES (14953, 'The thick, muscular arms of ChaosD1.', 'TGWTG');
INSERT INTO white_cards VALUES (14954, 'The Uncanny Valley.', 'TGWTG');
INSERT INTO white_cards VALUES (14955, 'The Wal-Mart.', 'TGWTG');
INSERT INTO white_cards VALUES (14956, 'Todd in the Shadows.', 'TGWTG');
INSERT INTO white_cards VALUES (14957, 'Todd trolling Chris Brown on Twitter.', 'TGWTG');
INSERT INTO white_cards VALUES (14958, 'Tommy Wiseau.', 'TGWTG');
INSERT INTO white_cards VALUES (14959, 'Turtle.', 'TGWTG');
INSERT INTO white_cards VALUES (14960, 'Using a frontloader to steal deodorant.', 'TGWTG');
INSERT INTO white_cards VALUES (14961, 'Using donation money for weed.', 'TGWTG');
INSERT INTO white_cards VALUES (14962, 'Vangelus', 'TGWTG');
INSERT INTO white_cards VALUES (14963, 'Ven''s voice, a gift from the fairies.', 'TGWTG');
INSERT INTO white_cards VALUES (14964, 'Zeo Linkara.', 'TGWTG');
INSERT INTO white_cards VALUES (14965, 'A DraculaFetus animation.', 'NL');
INSERT INTO white_cards VALUES (14966, 'A profile pic that looks like a dick and balls.', 'NL');
INSERT INTO white_cards VALUES (14967, 'Spy Party racism.', 'NL');
INSERT INTO white_cards VALUES (14968, 'The ghost of Ohmwrecker.', 'NL');
INSERT INTO white_cards VALUES (14969, 'Shooting the black guy.', 'NL');
INSERT INTO white_cards VALUES (14970, 'Ohm''s mindgames.', 'NL');
INSERT INTO white_cards VALUES (14971, 'DOTA 2.', 'NL');
INSERT INTO white_cards VALUES (14972, 'Magic: The Gathering.', 'NL');
INSERT INTO white_cards VALUES (14973, 'A failed challenge run.', 'NL');
INSERT INTO white_cards VALUES (14974, 'Setting the world on fire.', 'NL');
INSERT INTO white_cards VALUES (14975, 'Pot magic.', 'NL');
INSERT INTO white_cards VALUES (14976, 'Josh''s washing machine.', 'NL');
INSERT INTO white_cards VALUES (14977, 'Dang it, Bobby!', 'NL');
INSERT INTO white_cards VALUES (14978, 'Up in the air like a George Clooney movie.', 'NL');
INSERT INTO white_cards VALUES (14979, 'A lemon mishap.', 'NL');
INSERT INTO white_cards VALUES (14980, 'This cat, I swear to god.', 'NL');
INSERT INTO white_cards VALUES (14981, 'Ohmwrecker.', 'NL');
INSERT INTO white_cards VALUES (14982, 'youtube.com/Ohmwrecker.', 'NL');
INSERT INTO white_cards VALUES (14983, 'Drinkable fire.', 'NL');
INSERT INTO white_cards VALUES (14984, 'Ohmsdrawings.tumblr.com.', 'NL');
INSERT INTO white_cards VALUES (14985, 'Soul level 1 invasions.', 'NL');
INSERT INTO white_cards VALUES (14986, 'Ryuka.', 'NL');
INSERT INTO white_cards VALUES (14987, 'The blue candle.', 'NL');
INSERT INTO white_cards VALUES (14988, 'JSmith''s laundry.', 'NL');
INSERT INTO white_cards VALUES (14989, 'Mount Your Friends: Docking Edition.', 'NL');
INSERT INTO white_cards VALUES (14990, 'Childlike bukakke.', 'NL');
INSERT INTO white_cards VALUES (14991, 'A water supply full of leeches.', 'NL');
INSERT INTO white_cards VALUES (14992, 'Travelling by bones.', 'NL');
INSERT INTO white_cards VALUES (14993, 'AlpacaPatrol.', 'NL');
INSERT INTO white_cards VALUES (14994, 'Zen.', 'NL');
INSERT INTO white_cards VALUES (14995, 'Green9090.', 'NL');
INSERT INTO white_cards VALUES (14996, '#MikeBithell.', 'NL');
INSERT INTO white_cards VALUES (14997, 'RedPandaGamer.', 'NL');
INSERT INTO white_cards VALUES (14998, 'Ohm, our god.', 'NL');
INSERT INTO white_cards VALUES (14999, '...Metal Gear?!', 'GG');
INSERT INTO white_cards VALUES (15000, 'A beautiful little moment.', 'GG');
INSERT INTO white_cards VALUES (15001, 'A couch stinking of naked people.', 'GG');
INSERT INTO white_cards VALUES (15002, 'A humanlike bat with tits.', 'GG');
INSERT INTO white_cards VALUES (15003, 'A little dingle-dang.', 'GG');
INSERT INTO white_cards VALUES (15004, 'A pretty epic poo.', 'GG');
INSERT INTO white_cards VALUES (15005, 'A replay from Barry.', 'GG');
INSERT INTO white_cards VALUES (15006, 'A Scottish bloke that talks too fast.', 'GG');
INSERT INTO white_cards VALUES (15007, 'A smaller, whiter dick.', 'GG');
INSERT INTO white_cards VALUES (15008, 'A Sonic.', 'GG');
INSERT INTO white_cards VALUES (15009, 'A testicle examination.', 'GG');
INSERT INTO white_cards VALUES (15010, 'A whale making a seal noise.', 'GG');
INSERT INTO white_cards VALUES (15011, 'Accidentally resetting a video game.', 'GG');
INSERT INTO white_cards VALUES (15012, 'An expensive rental costume.', 'GG');
INSERT INTO white_cards VALUES (15013, 'Anne Frank doing a striptease.', 'GG');
INSERT INTO white_cards VALUES (15014, 'Arin actually winning a Game Grumps VS.', 'GG');
INSERT INTO white_cards VALUES (15015, 'Arin Hanson / Egoraptor.', 'GG');
INSERT INTO white_cards VALUES (15016, 'Arin''s big floppy penis.', 'GG');
INSERT INTO white_cards VALUES (15017, 'Arin''s dicksaber.', 'GG');
INSERT INTO white_cards VALUES (15018, 'Arin''s voice acting.', 'GG');
INSERT INTO white_cards VALUES (15019, 'Barry Kramer.', 'GG');
INSERT INTO white_cards VALUES (15020, 'Barry''s censorship noises.', 'GG');
INSERT INTO white_cards VALUES (15021, 'Becoming a vegetarian, then becoming clinically depressed.', 'GG');
INSERT INTO white_cards VALUES (15022, 'Being forced to replay the same section of the game over and over.', 'GG');
INSERT INTO white_cards VALUES (15023, 'Birdemic.', 'GG');
INSERT INTO white_cards VALUES (15024, 'Borderline narcissism.', 'GG');
INSERT INTO white_cards VALUES (15025, 'Breaking a basketball net''s back board.', 'GG');
INSERT INTO white_cards VALUES (15026, 'Breaking into song.', 'GG');
INSERT INTO white_cards VALUES (15027, 'Brian / Frank / Steve / Willard / Jonathan / Michael IV / Michael III / Michael Jordan / Scott.', 'GG');
INSERT INTO white_cards VALUES (15028, 'Bumping butts.', 'GG');
INSERT INTO white_cards VALUES (15029, 'Buying chicken fingers for homeless people.', 'GG');
INSERT INTO white_cards VALUES (15030, 'Carefully escorting Anna.', 'GG');
INSERT INTO white_cards VALUES (15031, 'Catharsis.', 'GG');
INSERT INTO white_cards VALUES (15032, 'Cheese pizza.', 'GG');
INSERT INTO white_cards VALUES (15033, 'Chu Chu Rocket.', 'GG');
INSERT INTO white_cards VALUES (15034, 'Chulip.', 'GG');
INSERT INTO white_cards VALUES (15035, 'Comparing someone to a trainwreck.', 'GG');
INSERT INTO white_cards VALUES (15036, 'Completely missing the tutorials and instructions.', 'GG');
INSERT INTO white_cards VALUES (15037, 'Cumfaggots.', 'GG');
INSERT INTO white_cards VALUES (15038, 'Dan getting some action with one of Egoraptor''s action figures.', 'GG');
INSERT INTO white_cards VALUES (15039, 'Danny Sexbang.', 'GG');
INSERT INTO white_cards VALUES (15040, 'Danny''s crippling Skittles addiction.', 'GG');
INSERT INTO white_cards VALUES (15041, 'Dipping your balls in the sand.', 'GG');
INSERT INTO white_cards VALUES (15042, 'Dixon.', 'GG');
INSERT INTO white_cards VALUES (15043, 'Donkey-ass Kong.', 'GG');
INSERT INTO white_cards VALUES (15044, 'Drakkhen''s realistic fight sequences.', 'GG');
INSERT INTO white_cards VALUES (15045, 'Drawing the line in the fucking sand.', 'GG');
INSERT INTO white_cards VALUES (15046, 'Eating the Holocaust.', 'GG');
INSERT INTO white_cards VALUES (15047, 'Eating your peas.', 'GG');
INSERT INTO white_cards VALUES (15048, 'Egofaptor.', 'GG');
INSERT INTO white_cards VALUES (15049, 'Ending an episode on "Heil Hitler!"', 'GG');
INSERT INTO white_cards VALUES (15050, 'The eyeless girl demographic.', 'GG');
INSERT INTO white_cards VALUES (15051, 'Fart science.', 'GG');
INSERT INTO white_cards VALUES (15052, 'Fast-forwarding.', 'GG');
INSERT INTO white_cards VALUES (15053, 'Fighting Iblis for the hundredth time.', 'GG');
INSERT INTO white_cards VALUES (15054, 'Fooling me three times.', 'GG');
INSERT INTO white_cards VALUES (15055, 'Fuckin'' Larry.', 'GG');
INSERT INTO white_cards VALUES (15056, 'FUCKING LEGO CARS!!?!', 'GG');
INSERT INTO white_cards VALUES (15057, 'Game feel.', 'GG');
INSERT INTO white_cards VALUES (15058, 'Game Grumps remixes.', 'GG');
INSERT INTO white_cards VALUES (15059, 'Game Grumps VS.', 'GG');
INSERT INTO white_cards VALUES (15060, 'Game Grumps.', 'GG');
INSERT INTO white_cards VALUES (15061, 'Garshstostoles.', 'GG');
INSERT INTO white_cards VALUES (15062, 'GeorgLopez.', 'GG');
INSERT INTO white_cards VALUES (15063, 'Getting censored by a stampede of elephants.', 'GG');
INSERT INTO white_cards VALUES (15064, 'Getting diddled again.', 'GG');
INSERT INTO white_cards VALUES (15065, 'Getting fucking ganked.', 'GG');
INSERT INTO white_cards VALUES (15066, 'Getting horribly diarrhea''d on by an owl.', 'GG');
INSERT INTO white_cards VALUES (15067, 'Getting killed by a motherfucking paralyzed Taillow.', 'GG');
INSERT INTO white_cards VALUES (15068, 'Getting stuck on the ceiling for no explicable reason.', 'GG');
INSERT INTO white_cards VALUES (15069, 'Getting violently sick at MAGfest.', 'GG');
INSERT INTO white_cards VALUES (15070, 'Goof Troop.', 'GG');
INSERT INTO white_cards VALUES (15071, 'Goofy masturbating in the fields.', 'GG');
INSERT INTO white_cards VALUES (15072, 'Grade A meat.', 'GG');
INSERT INTO white_cards VALUES (15073, 'Grant Kirkhope.', 'GG');
INSERT INTO white_cards VALUES (15074, 'Grant Kirkhope’s knackers.', 'GG');
INSERT INTO white_cards VALUES (15075, 'GREAT! GREAT! GREAT!', 'GG');
INSERT INTO white_cards VALUES (15076, 'Grep.', 'GG');
INSERT INTO white_cards VALUES (15077, 'Grumping it.', 'GG');
INSERT INTO white_cards VALUES (15078, 'Güf Troop.', 'GG');
INSERT INTO white_cards VALUES (15079, 'Half the deal for twice the price!', 'GG');
INSERT INTO white_cards VALUES (15080, 'Having a cough that lasts forever.', 'GG');
INSERT INTO white_cards VALUES (15081, 'Helicopter tits.', 'GG');
INSERT INTO white_cards VALUES (15082, 'Hepatitis Sea.', 'GG');
INSERT INTO white_cards VALUES (15213, 'Slo Mo Guys.', 'RT');
INSERT INTO white_cards VALUES (15083, 'Hitting a Nightshade cartridge with Thor’s Hammer only to break the hammer.', 'GG');
INSERT INTO white_cards VALUES (15084, 'Homoerotic subtext between two grown men playing video games.', 'GG');
INSERT INTO white_cards VALUES (15085, 'Ice hair.', 'GG');
INSERT INTO white_cards VALUES (15086, 'Incriminating footage of Jon.', 'GG');
INSERT INTO white_cards VALUES (15087, 'Insta-killing your partner with the Select button.', 'GG');
INSERT INTO white_cards VALUES (15088, 'It being no use.', 'GG');
INSERT INTO white_cards VALUES (15089, 'Jacques.', 'GG');
INSERT INTO white_cards VALUES (15090, 'JonTron.', 'GG');
INSERT INTO white_cards VALUES (15091, 'Jon winning. AS USUAL.', 'GG');
INSERT INTO white_cards VALUES (15092, 'Jon''s soulful singing.', 'GG');
INSERT INTO white_cards VALUES (15093, 'Jon/Arin slash fiction.', 'GG');
INSERT INTO white_cards VALUES (15094, 'JonTron’s musical theater voice.', 'GG');
INSERT INTO white_cards VALUES (15095, 'Js''keep goin''.', 'GG');
INSERT INTO white_cards VALUES (15096, 'Killing zombies by typing on a keyboard-gun.', 'GG');
INSERT INTO white_cards VALUES (15097, 'Kirby.', 'GG');
INSERT INTO white_cards VALUES (15098, 'Kitty Cat Dance Party.', 'GG');
INSERT INTO white_cards VALUES (15099, 'Learning that your son is dead, but not caring because you didn''t want him anyway.', 'GG');
INSERT INTO white_cards VALUES (15100, 'Lemon and Bill.', 'GG');
INSERT INTO white_cards VALUES (15101, 'Lightsaber Fightsaber.', 'GG');
INSERT INTO white_cards VALUES (15102, 'Literally going to Hell.', 'GG');
INSERT INTO white_cards VALUES (15103, 'Mediocrity, as a power.', 'GG');
INSERT INTO white_cards VALUES (15104, 'Mega Man.', 'GG');
INSERT INTO white_cards VALUES (15105, 'Mike Tyson.', 'GG');
INSERT INTO white_cards VALUES (15106, 'Mispronouncing Duran Duran.', 'GG');
INSERT INTO white_cards VALUES (15107, 'Mister Mosquito.', 'GG');
INSERT INTO white_cards VALUES (15108, 'MomTron.', 'GG');
INSERT INTO white_cards VALUES (15109, 'Moundo.', 'GG');
INSERT INTO white_cards VALUES (15110, 'Naughty Bear.', 'GG');
INSERT INTO white_cards VALUES (15111, 'Nazi von Killyou.', 'GG');
INSERT INTO white_cards VALUES (15112, 'Ninja Sex Party.', 'GG');
INSERT INTO white_cards VALUES (15113, 'Nixon.', 'GG');
INSERT INTO white_cards VALUES (15114, 'NO JON NO.', 'GG');
INSERT INTO white_cards VALUES (15115, 'NOT FUCKING THIS!', 'GG');
INSERT INTO white_cards VALUES (15116, 'Not knowing the controls to Nickelodeon GUTS.', 'GG');
INSERT INTO white_cards VALUES (15117, 'Not reading the game''s instructions.', 'GG');
INSERT INTO white_cards VALUES (15118, 'Obeying Protoman and burning down a forest.', 'GG');
INSERT INTO white_cards VALUES (15119, 'Pacific Rim.', 'GG');
INSERT INTO white_cards VALUES (15120, 'Pause balls.', 'GG');
INSERT INTO white_cards VALUES (15121, 'Pelistorm.', 'GG');
INSERT INTO white_cards VALUES (15122, 'Playing a terrible game for more than a hundred episodes.', 'GG');
INSERT INTO white_cards VALUES (15123, 'Playing slaps to break a tie.', 'GG');
INSERT INTO white_cards VALUES (15124, 'PONY.MOV.', 'GG');
INSERT INTO white_cards VALUES (15125, 'Poopy butt.', 'GG');
INSERT INTO white_cards VALUES (15126, 'Poppy Bros.', 'GG');
INSERT INTO white_cards VALUES (15127, 'Princess Elise''s octopus face.', 'GG');
INSERT INTO white_cards VALUES (15128, 'Punching a hole in a gingerbread house.', 'GG');
INSERT INTO white_cards VALUES (15129, 'Queefing bombs out of your vagina.', 'GG');
INSERT INTO white_cards VALUES (15130, 'Racial slurs.', 'GG');
INSERT INTO white_cards VALUES (15131, 'Reading the manual.', 'GG');
INSERT INTO white_cards VALUES (15132, 'RIDIN’ ON CARS!!!', 'GG');
INSERT INTO white_cards VALUES (15133, 'Robots ordering cheese pizza.', 'GG');
INSERT INTO white_cards VALUES (15134, 'Rocket. To the moon.', 'GG');
INSERT INTO white_cards VALUES (15135, 'Rolling around at the speed of sound.', 'GG');
INSERT INTO white_cards VALUES (15136, 'RubberRoss.', 'GG');
INSERT INTO white_cards VALUES (15137, 'Rouge''s gross bat face.', 'GG');
INSERT INTO white_cards VALUES (15138, 'Screaming out Whitney Houston’s “I Will Always Love You” in primal agony.', 'GG');
INSERT INTO white_cards VALUES (15139, 'Sequelitis.', 'GG');
INSERT INTO white_cards VALUES (15140, 'Seven asses.', 'GG');
INSERT INTO white_cards VALUES (15141, 'Signing and destroying a copy of Sonic ''06.', 'GG');
INSERT INTO white_cards VALUES (15142, 'Silver the Hedgehog.', 'GG');
INSERT INTO white_cards VALUES (15143, 'Sneaking dirty British humour into an unassuming video game about a bear and a bird.', 'GG');
INSERT INTO white_cards VALUES (15144, 'Snow white shit.', 'GG');
INSERT INTO white_cards VALUES (15145, 'Snowboarding uphill', 'GG');
INSERT INTO white_cards VALUES (15146, 'Solid Snake.', 'GG');
INSERT INTO white_cards VALUES (15147, 'Sonic ''06.', 'GG');
INSERT INTO white_cards VALUES (15148, 'Spice World.', 'GG');
INSERT INTO white_cards VALUES (15149, 'Spraying compressed air with a bittering agent in your face, and subsequently vomiting.', 'GG');
INSERT INTO white_cards VALUES (15150, 'Stairfax Temperatures.', 'GG');
INSERT INTO white_cards VALUES (15151, 'Staring at a menu while Ross stuffs his disgusting face with candy.', 'GG');
INSERT INTO white_cards VALUES (15152, 'Stasis-ing the drill.', 'GG');
INSERT INTO white_cards VALUES (15153, 'Steam Train.', 'GG');
INSERT INTO white_cards VALUES (15154, 'Sticky sap.', 'GG');
INSERT INTO white_cards VALUES (15155, 'Stretch Panic.', 'GG');
INSERT INTO white_cards VALUES (15156, 'STRGG.', 'GG');
INSERT INTO white_cards VALUES (15157, 'Struggling to fight Silver the Hedgehog.', 'GG');
INSERT INTO white_cards VALUES (15158, 'Sucking blood from a Japanese girl''s tits.', 'GG');
INSERT INTO white_cards VALUES (15159, 'Suzy the Goose.', 'GG');
INSERT INTO white_cards VALUES (15160, 'TENOUTTATEN.', 'GG');
INSERT INTO white_cards VALUES (15161, 'That guy.', 'GG');
INSERT INTO white_cards VALUES (15162, 'The Awesome Series.', 'GG');
INSERT INTO white_cards VALUES (15163, 'The band Egoraptor.', 'GG');
INSERT INTO white_cards VALUES (15164, 'The Chinless Wonder.', 'GG');
INSERT INTO white_cards VALUES (15165, 'The Goshdangodon.', 'GG');
INSERT INTO white_cards VALUES (15166, 'The Higgs Boson.', 'GG');
INSERT INTO white_cards VALUES (15167, 'The Knuckles wall glitch.', 'GG');
INSERT INTO white_cards VALUES (15168, 'The rarest form of Arin having fun.', 'GG');
INSERT INTO white_cards VALUES (15169, 'The realization that friendship is more important.', 'GG');
INSERT INTO white_cards VALUES (15170, 'Three big feet of pleasure.', 'GG');
INSERT INTO white_cards VALUES (15171, 'Tonguing up.', 'GG');
INSERT INTO white_cards VALUES (15172, 'Typing "C D PLAYER" and getting "MODEL CAR."', 'GG');
INSERT INTO white_cards VALUES (15173, 'WAAAAAAAVE LAAAAZEEEEEEER.', 'GG');
INSERT INTO white_cards VALUES (15174, 'Walking around in my banana shoes.', 'GG');
INSERT INTO white_cards VALUES (15175, 'World Dick Barf Syndrome.', 'GG');
INSERT INTO white_cards VALUES (15176, 'Man-Gobbler, the turkey bestiality movie.', 'RT');
INSERT INTO white_cards VALUES (15177, 'RoosterTeeth.', 'RT');
INSERT INTO white_cards VALUES (15178, 'Michael Jones.', 'RT');
INSERT INTO white_cards VALUES (15179, 'Gavin Free.', 'RT');
INSERT INTO white_cards VALUES (15180, 'Surgeon Simulator 2013.', 'RT');
INSERT INTO white_cards VALUES (15181, 'Ray Narvaez, Jr.', 'RT');
INSERT INTO white_cards VALUES (15182, 'Burnie Burns.', 'RT');
INSERT INTO white_cards VALUES (15183, 'Geoff Lazer Ramsey.', 'RT');
INSERT INTO white_cards VALUES (15184, 'Jack Pattillo.', 'RT');
INSERT INTO white_cards VALUES (15185, 'Ryan Haywood.', 'RT');
INSERT INTO white_cards VALUES (15186, 'Gus Sorola.', 'RT');
INSERT INTO white_cards VALUES (15187, 'The cardboard cutout of Gus.', 'RT');
INSERT INTO white_cards VALUES (15188, 'Joel Heyman.', 'RT');
INSERT INTO white_cards VALUES (15189, 'Going cakeless.', 'RT');
INSERT INTO white_cards VALUES (15190, 'Headlight fluid.', 'RT');
INSERT INTO white_cards VALUES (15191, 'Playing Hitler twice.', 'RT');
INSERT INTO white_cards VALUES (15192, 'Sarge.', 'RT');
INSERT INTO white_cards VALUES (15193, 'Lopez la Pesado.', 'RT');
INSERT INTO white_cards VALUES (15194, 'Franklin Delano Donut.', 'RT');
INSERT INTO white_cards VALUES (15195, 'Dexter Grif.', 'RT');
INSERT INTO white_cards VALUES (15196, 'Dick Simmons.', 'RT');
INSERT INTO white_cards VALUES (15197, 'Agent Washington.', 'RT');
INSERT INTO white_cards VALUES (15198, 'Andy the bomb.', 'RT');
INSERT INTO white_cards VALUES (15199, 'Picking up chicks in a tank.', 'RT');
INSERT INTO white_cards VALUES (15200, 'Michael J. Caboose.', 'RT');
INSERT INTO white_cards VALUES (15201, 'Sheila the tank.', 'RT');
INSERT INTO white_cards VALUES (15202, 'Leonard Church.', 'RT');
INSERT INTO white_cards VALUES (15203, 'Lavernius Tucker.', 'RT');
INSERT INTO white_cards VALUES (15204, 'Agent Texas / Allison.', 'RT');
INSERT INTO white_cards VALUES (15205, 'Omega / O''Malley.', 'RT');
INSERT INTO white_cards VALUES (15206, 'Agent Maine / the Meta.', 'RT');
INSERT INTO white_cards VALUES (15207, 'Frank "Doc" DuFresne.', 'RT');
INSERT INTO white_cards VALUES (15208, 'Screen looking.', 'RT');
INSERT INTO white_cards VALUES (15209, 'A wet paper towel.', 'RT');
INSERT INTO white_cards VALUES (15210, 'Minecraft.', 'RT');
INSERT INTO white_cards VALUES (15211, 'MOGAR!', 'RT');
INSERT INTO white_cards VALUES (15212, 'X-Ray and Vav.', 'RT');
INSERT INTO white_cards VALUES (15214, '#DantheMan.', 'RT');
INSERT INTO white_cards VALUES (15215, 'Joe the cat.', 'RT');
INSERT INTO white_cards VALUES (15216, 'Pongo.', 'RT');
INSERT INTO white_cards VALUES (15217, 'Soggy bread.', 'RT');
INSERT INTO white_cards VALUES (15218, 'Rage Quit.', 'RT');
INSERT INTO white_cards VALUES (15219, 'Achievement Hunter.', 'RT');
INSERT INTO white_cards VALUES (15220, 'Team-killing fucktards.', 'RT');
INSERT INTO white_cards VALUES (15221, 'Calling dibs on a spaceship.', 'RT');
INSERT INTO white_cards VALUES (15222, 'Sarge''s funeral.', 'RT');
INSERT INTO white_cards VALUES (15223, 'Camping, as a legitimate strategy.', 'RT');
INSERT INTO white_cards VALUES (15224, 'Epsilon''s laser face.', 'RT');
INSERT INTO white_cards VALUES (15225, 'MOTHERFUCKING TRIPLE SPIKES!', 'RT');
INSERT INTO white_cards VALUES (15226, 'Because people like grapes.', 'RT');
INSERT INTO white_cards VALUES (15227, 'Upside-down Kerry.', 'RT');
INSERT INTO white_cards VALUES (15228, 'Ray''s sombrero.', 'RT');
INSERT INTO white_cards VALUES (15229, 'Doing a dig-down.', 'RT');
INSERT INTO white_cards VALUES (15230, 'Mark Nutt.', 'RT');
INSERT INTO white_cards VALUES (15231, 'AHWU.', 'RT');
INSERT INTO white_cards VALUES (15232, 'Throwing shit at the AHWU announcer.', 'RT');
INSERT INTO white_cards VALUES (15233, 'Red vs. Blue.', 'RT');
INSERT INTO white_cards VALUES (15234, 'Geoff''s cancer-curing laugh.', 'RT');
INSERT INTO white_cards VALUES (15235, 'The Tower of Pimps.', 'RT');
INSERT INTO white_cards VALUES (15236, 'The Frienderman.', 'RT');
INSERT INTO white_cards VALUES (15237, 'Beating a man to death with his own skull.', 'RT');
INSERT INTO white_cards VALUES (15238, 'Fighting to the death on pigback.', 'RT');
INSERT INTO white_cards VALUES (15239, 'RWBY.', 'RT');
INSERT INTO white_cards VALUES (15240, 'RT Shorts.', 'RT');
INSERT INTO white_cards VALUES (15241, 'RT Animated Adventures.', 'RT');
INSERT INTO white_cards VALUES (15242, 'Mega64.', 'RT');
INSERT INTO white_cards VALUES (15243, 'Immersion.', 'RT');
INSERT INTO white_cards VALUES (15244, 'Reaching a billion total views on YouTube.', 'RT');
INSERT INTO white_cards VALUES (15245, 'Doing a double barrel roll and immediately running someone over.', 'RT');
INSERT INTO white_cards VALUES (15246, 'A Ray-Cam masturbation moment.', 'RT');
INSERT INTO white_cards VALUES (15247, 'Tackling Gavin to stop him from winning.', 'RT');
INSERT INTO white_cards VALUES (15248, 'Losing an hour''s worth of footage to a brief blackout.', 'RT');
INSERT INTO white_cards VALUES (15249, 'Fails of the Weak.', 'RT');
INSERT INTO white_cards VALUES (15250, 'Achievement HORSE.', 'RT');
INSERT INTO white_cards VALUES (15251, 'Trials PIG.', 'RT');
INSERT INTO white_cards VALUES (15252, 'Slapping the controller out of a competitor''s hands.', 'RT');
INSERT INTO white_cards VALUES (15253, 'Cockbites.', 'RT');
INSERT INTO white_cards VALUES (15254, 'Achievement City.', 'RT');
INSERT INTO white_cards VALUES (15255, 'Two bases in the middle of a box canyon. Whoop-dee-fuckin''-doo.', 'RT');
INSERT INTO white_cards VALUES (15256, 'Blood Gulch.', 'RT');
INSERT INTO white_cards VALUES (15257, 'Parkour.', 'RT');
INSERT INTO white_cards VALUES (15258, 'Faffy Waffle.', 'RT');
INSERT INTO white_cards VALUES (15259, 'Something that is top.', 'RT');
INSERT INTO white_cards VALUES (15260, 'A plan that involves Grif dying.', 'RT');
INSERT INTO white_cards VALUES (4946, 'Drunkenly texting an ex.', 'MrMan');
INSERT INTO white_cards VALUES (15261, 'Using CPR to treat a bullet wound to the head.', 'RT');
INSERT INTO white_cards VALUES (15262, 'Front flip for style!', 'RT');
INSERT INTO white_cards VALUES (15263, 'Trying to eat a five-pound gummy bear in one sitting.', 'RT');
INSERT INTO white_cards VALUES (15264, 'RTX.', 'RT');
INSERT INTO white_cards VALUES (15265, 'Randy Newman.', 'RT');
INSERT INTO white_cards VALUES (15266, 'Slenderman.', 'RT');
INSERT INTO white_cards VALUES (15267, 'The R&R Connection.', 'RT');
INSERT INTO white_cards VALUES (15268, 'The Internet Box.', 'RT');
INSERT INTO white_cards VALUES (15269, 'Performing surgery in space.', 'RT');
INSERT INTO white_cards VALUES (15270, 'Jack''s dick.', 'RT');
INSERT INTO white_cards VALUES (15271, 'The Crev.', 'RT');
INSERT INTO white_cards VALUES (15272, 'Team Nice Dynamite.', 'RT');
INSERT INTO white_cards VALUES (15273, 'Team Lads.', 'RT');
INSERT INTO white_cards VALUES (15274, 'Team Gents.', 'RT');
INSERT INTO white_cards VALUES (15275, 'Plan G.', 'RT');
INSERT INTO white_cards VALUES (15276, 'Team Neighborhood Watch.', 'RT');
INSERT INTO white_cards VALUES (15277, 'Ray winning.', 'RT');
INSERT INTO white_cards VALUES (15278, 'Edgar the cow.', 'RT');
INSERT INTO white_cards VALUES (15279, 'Gavin''s Trophy Room of Victory.', 'RT');
INSERT INTO white_cards VALUES (15280, 'Jack''s beard.', 'RT');
INSERT INTO white_cards VALUES (15281, 'Being trapped in a dog cage.', 'RT');
INSERT INTO white_cards VALUES (15282, 'Geoff''s hobo beard.', 'RT');
INSERT INTO white_cards VALUES (15283, 'Killing Gavin.', 'RT');
INSERT INTO white_cards VALUES (15284, 'Discovering your long-lost Creeper parents.', 'RT');
INSERT INTO white_cards VALUES (15285, 'A megalomaniac with a beard.', 'RT');
INSERT INTO white_cards VALUES (15286, 'Ray''s douche-cut.', 'RT');
INSERT INTO white_cards VALUES (15287, 'The adventures of Batman and Randy Newman.', 'RT');
INSERT INTO white_cards VALUES (15288, 'Because they''d like it.', 'RT');
INSERT INTO white_cards VALUES (15289, 'Knobs.', 'RT');
INSERT INTO white_cards VALUES (15290, 'Gubbins.', 'RT');
INSERT INTO white_cards VALUES (15291, 'Meatspin.', 'RT');
INSERT INTO white_cards VALUES (15292, 'Flynt Coal.', 'RT');
INSERT INTO white_cards VALUES (15293, 'Tupperware.', 'RT');
INSERT INTO white_cards VALUES (15294, 'A miniature Tower of Pimps.', 'RT');
INSERT INTO white_cards VALUES (15295, 'Giving up and building a house.', 'RT');
INSERT INTO white_cards VALUES (15296, 'Gavin''s dick.', 'RT');
INSERT INTO white_cards VALUES (15297, 'Wearing your headphones backwards during a podcast week after week.', 'RT');
INSERT INTO white_cards VALUES (15298, 'Flicking the bean.', 'RT');
INSERT INTO white_cards VALUES (15299, 'Getting minged up your quelch.', 'RT');
INSERT INTO white_cards VALUES (15300, 'Grand Theft Auto IV.', 'RT');
INSERT INTO white_cards VALUES (15301, 'Ray''s wet sponge.', 'RT');
INSERT INTO white_cards VALUES (15302, 'Bankrupting your company over a crane game.', 'RT');
INSERT INTO white_cards VALUES (15303, 'A bag of dicks.', 'RT');
INSERT INTO white_cards VALUES (15304, 'ENDERMAN!!!', 'RT');
INSERT INTO white_cards VALUES (15305, 'Lightish red.', 'RT');
INSERT INTO white_cards VALUES (15306, 'In denial.', 'RT');
INSERT INTO white_cards VALUES (15307, 'Enwrong.', 'RT');
INSERT INTO white_cards VALUES (15308, 'Papa BrownMan.', 'RT');
INSERT INTO white_cards VALUES (15309, 'Caleb''s house.', 'RT');
INSERT INTO white_cards VALUES (15310, 'Evil Ryan.', 'RT');
INSERT INTO white_cards VALUES (15311, 'Randy Savage.', 'RT');
INSERT INTO white_cards VALUES (15312, 'RT Confessions.', 'RT');
INSERT INTO white_cards VALUES (15313, 'Two dumb cunts.', 'RT');
INSERT INTO white_cards VALUES (15314, 'Smegpot.', 'RT');
INSERT INTO white_cards VALUES (15315, 'Guffpap.', 'RT');
INSERT INTO white_cards VALUES (15316, 'Launching dump trucks off an unfinished bridge.', 'RT');
INSERT INTO white_cards VALUES (15317, 'Because bitches ain''t shit.', 'RT');
INSERT INTO white_cards VALUES (15318, 'Gavino.', 'RT');
INSERT INTO white_cards VALUES (15319, 'Monoray.', 'RT');
INSERT INTO white_cards VALUES (15320, 'Montages no one will watch.', 'RT');
INSERT INTO white_cards VALUES (15321, 'A gay cave. A gayve.', 'RT');
INSERT INTO white_cards VALUES (15322, 'A squid orgy.', 'RT');
INSERT INTO white_cards VALUES (15323, 'Getting boned.', 'RT');
INSERT INTO white_cards VALUES (15324, '300,000 Gamerscore.', 'RT');
INSERT INTO white_cards VALUES (15325, 'Team Magnum Dong.', 'RT');
INSERT INTO white_cards VALUES (15326, 'Lindsay Tuggey.', 'RT');
INSERT INTO white_cards VALUES (15327, 'Barbara Dunkelman.', 'RT');
INSERT INTO white_cards VALUES (15328, 'Mavin slash fiction.', 'RT');
INSERT INTO white_cards VALUES (15329, 'Caleb Denecour.', 'RT');
INSERT INTO white_cards VALUES (15330, 'Monty Oum.', 'RT');
INSERT INTO white_cards VALUES (15331, 'The league of being a big faggot.', 'DAH');
INSERT INTO white_cards VALUES (15332, 'GaLm''s sunglasses.', 'DAH');
INSERT INTO white_cards VALUES (15333, 'The Card Czar.', 'DAH');
INSERT INTO white_cards VALUES (15334, 'Inside Shrek''s asshole.', 'DAH');
INSERT INTO white_cards VALUES (15335, 'Solving a rubiks cube with your bare nipples.', 'DAH');
INSERT INTO white_cards VALUES (15336, 'A canoe with enough room for Phil.', 'DAH');
INSERT INTO white_cards VALUES (15337, 'The Black Seed.', 'DAH');
INSERT INTO white_cards VALUES (15338, 'That video of EatMyDiction1 twerking.', 'DAH');
INSERT INTO white_cards VALUES (15339, 'The Sips Co. Dirt Factory.', 'DAH');
INSERT INTO white_cards VALUES (15340, 'DarkSydePhil playing Dark Souls.', 'DAH');
INSERT INTO white_cards VALUES (15341, 'Hitler''s Train!', 'DAH');
INSERT INTO white_cards VALUES (15342, 'That time when Machinima played actual machinima videos.', 'DAH');
INSERT INTO white_cards VALUES (15343, 'Bajan Canadian''s fridge.', 'DAH');
INSERT INTO white_cards VALUES (15344, 'Seananners'' dolphin laugh.', 'DAH');
INSERT INTO white_cards VALUES (15345, 'Chilledchaos'' homosexual tendencies.', 'DAH');
INSERT INTO white_cards VALUES (15346, 'Bolshevik the wolf.', 'DAH');
INSERT INTO white_cards VALUES (15347, 'Diction watching a burly outdoorsman skin a bear while eating honey and crying.', 'DAH');
INSERT INTO white_cards VALUES (15348, 'The Tom Shark.', 'DAH');
INSERT INTO white_cards VALUES (15349, '#TysLeftFoot', 'DAH');
INSERT INTO white_cards VALUES (15350, 'Seananners joyously dropping "presents" on the African minority in GTA.', 'DAH');
INSERT INTO white_cards VALUES (15351, 'Jah be dwarfin'' it up!', 'DAH');
INSERT INTO white_cards VALUES (15352, 'Tom drunk off his ass.', 'DAH');
INSERT INTO white_cards VALUES (15353, 'Getting anally violated by a silverback gorilla.', 'DAH');
INSERT INTO white_cards VALUES (15354, 'A Big ''Ol Bowl of Fruit!', 'DAH');
INSERT INTO white_cards VALUES (15355, 'An LP Smarty finished.', 'DAH');
INSERT INTO white_cards VALUES (15356, 'BEARS!', 'DAH');
INSERT INTO white_cards VALUES (15357, 'The Blue Yeti microphone.', 'DAH');
INSERT INTO white_cards VALUES (15358, 'A Machinima contract.', 'DAH');
INSERT INTO white_cards VALUES (15359, 'Criken''s Fun House.', 'DAH');
INSERT INTO white_cards VALUES (15360, 'A smart joke.', 'DAH');
INSERT INTO white_cards VALUES (15361, 'One of Chuggaconroy''s awful puns.', 'DAH');
INSERT INTO white_cards VALUES (15362, 'The Great Youtube Unsubbing of 2012.', 'DAH');
INSERT INTO white_cards VALUES (15363, 'A robot bird.', 'DAH');
INSERT INTO white_cards VALUES (15364, 'Time to cancel Smash Fighter.', 'DAH');
INSERT INTO white_cards VALUES (15365, 'Smash Fighter.', 'DAH');
INSERT INTO white_cards VALUES (15366, 'Totalbiscuit and Angry Joe frolicking in a meadow.', 'DAH');
INSERT INTO white_cards VALUES (15367, 'Chilled and Smarty''s wedding.', 'DAH');
INSERT INTO white_cards VALUES (100240, 'A box of biscuits, a box of mixed biscuits, and a biscuit mixer.', 'BOX');
INSERT INTO white_cards VALUES (100245, 'A box-shaped man.', 'BOX');
INSERT INTO white_cards VALUES (100246, 'A man-shaped box.', 'BOX');
INSERT INTO white_cards VALUES (100249, 'An alternate universe in which boxes store things inside of people.', 'BOX');
INSERT INTO white_cards VALUES (100252, 'Two midgets shitting into a box.', 'BOX');
INSERT INTO white_cards VALUES (100253, 'A falcon with a box on its head.', 'BOX');
INSERT INTO white_cards VALUES (100254, 'Being a motherfucking box.', 'BOX');
INSERT INTO white_cards VALUES (100259, 'Achieving the manual dexterity and tactical brilliance of a 12-year-old Korean boy. (6/44)', 'PAX');
INSERT INTO white_cards VALUES (100260, 'Being an attractive elf trapped in an unattractive human''s body. (9/44)', 'PAX');
INSERT INTO white_cards VALUES (100261, 'Filling every pouch of a UtiliKilt&trade; with pizza. (12/44)', 'PAX');
INSERT INTO white_cards VALUES (100262, 'Bowser''s aching heart. (13/44)', 'PAX');
INSERT INTO white_cards VALUES (100264, 'Turn-of-the-century sky racists. (24/44)', 'PAX');
INSERT INTO white_cards VALUES (100269, 'The gravity gun.<span class="cardnum">2 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100273, 'Achieving the manual dexterity and tactical brilliance of a 12-year-old Korean boy.<span class="cardnum">6 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100274, 'Rolling a D20 to save a failing marriage.<span class="cardnum">7 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (1258, 'A cutie mark.', 'CAE');
INSERT INTO white_cards VALUES (1408, 'Octavia.', 'CAE');
INSERT INTO white_cards VALUES (1409, 'The Moon.', 'CAE');
INSERT INTO white_cards VALUES (1410, 'Orphaned foals.', 'CAE');
INSERT INTO white_cards VALUES (1411, 'Pants.', 'CAE');
INSERT INTO white_cards VALUES (1412, 'The Great and Powerful Trixie Lulamoon.', 'CAE');
INSERT INTO white_cards VALUES (1413, 'The Grand Galloping Gala.', 'CAE');
INSERT INTO white_cards VALUES (1414, 'Pegasus wing deformities.', 'CAE');
INSERT INTO white_cards VALUES (1415, 'The Friendship Express.', 'CAE');
INSERT INTO white_cards VALUES (1416, 'Pinkamena Diane Pie.', 'CAE');
INSERT INTO white_cards VALUES (1417, 'The Chocolate Mousse Moose.', 'CAE');
INSERT INTO white_cards VALUES (1418, 'The Cakes.', 'CAE');
INSERT INTO white_cards VALUES (1419, 'Pinkamena''s hacksaw.', 'CAE');
INSERT INTO white_cards VALUES (1420, 'That squee noise.', 'CAE');
INSERT INTO white_cards VALUES (1421, 'That Lyra plushie.', 'CAE');
INSERT INTO white_cards VALUES (1422, 'Sweetie Bot.', 'CAE');
INSERT INTO white_cards VALUES (1423, 'Sweetie Belle''s virgin marshmallow pussy.', 'CAE');
INSERT INTO white_cards VALUES (1424, 'Sweetie Belle.', 'CAE');
INSERT INTO white_cards VALUES (1425, 'Pinkie Pie in full latex.', 'CAE');
INSERT INTO white_cards VALUES (1426, 'Surprise.', 'CAE');
INSERT INTO white_cards VALUES (1427, 'Stretching those glutes.', 'CAE');
INSERT INTO white_cards VALUES (1428, 'Pinkie Pie.', 'CAE');
INSERT INTO white_cards VALUES (1429, 'Steven Magnets.', 'CAE');
INSERT INTO white_cards VALUES (1430, 'Plot.', 'CAE');
INSERT INTO white_cards VALUES (1431, 'Spike''s understanding of biology.', 'CAE');
INSERT INTO white_cards VALUES (1432, 'Speaking Fancy.', 'CAE');
INSERT INTO white_cards VALUES (1433, 'Poison Joke.', 'CAE');
INSERT INTO white_cards VALUES (1434, 'Socks.', 'CAE');
INSERT INTO white_cards VALUES (1435, 'Ponies wearing clothes.', 'CAE');
INSERT INTO white_cards VALUES (1436, 'Sloppy clop.', 'CAE');
INSERT INTO white_cards VALUES (1437, 'Shipping.', 'CAE');
INSERT INTO white_cards VALUES (1439, 'Shaking Dat Plot.', 'CAE');
INSERT INTO white_cards VALUES (1440, 'Secretly being a changeling all along.', 'CAE');
INSERT INTO white_cards VALUES (1441, 'Ponies.', 'CAE');
INSERT INTO white_cards VALUES (1442, 'Scootabuse.', 'CAE');
INSERT INTO white_cards VALUES (1443, 'Pony racism.', 'CAE');
INSERT INTO white_cards VALUES (1444, 'Scoot, Scoot-A-Loo.', 'CAE');
INSERT INTO white_cards VALUES (1445, 'Pony-Griffon marriage.', 'CAE');
INSERT INTO white_cards VALUES (1446, 'Rarity.', 'CAE');
INSERT INTO white_cards VALUES (1447, 'Rainbow Dash.', 'CAE');
INSERT INTO white_cards VALUES (1448, 'Rainbow Crash.', 'CAE');
INSERT INTO white_cards VALUES (1449, 'Ponychan.', 'CAE');
INSERT INTO white_cards VALUES (1450, 'Raging wingboners.', 'CAE');
INSERT INTO white_cards VALUES (1451, 'Queen Chrysalis.', 'CAE');
INSERT INTO white_cards VALUES (1452, 'Princess Molestia.', 'CAE');
INSERT INTO white_cards VALUES (1453, 'Princess Celestia.', 'CAE');
INSERT INTO white_cards VALUES (1454, 'Princess Mi Amore Cadenza.', 'CAE');
INSERT INTO white_cards VALUES (1455, 'Princess Luna.', 'CAE');
INSERT INTO white_cards VALUES (1438, 'Ponies with fricken'' laser beams attached to their heads!', 'CAE');
INSERT INTO white_cards VALUES (3059, 'Lara Croft.', 'NL');
INSERT INTO white_cards VALUES (100280, 'Bowser''s aching heart.<span class="cardnum">13 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (3768, 'Scotsmen marrying their sheep.', 'RS');
INSERT INTO white_cards VALUES (100279, 'Filling every pouch of a UtiliKilt&trade; with pizza.<span class="cardnum">12 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100313, 'Quiznos.', 'SG');
INSERT INTO white_cards VALUES (100271, '70,000 gamers sweating and farting inside an airtight steel dome.<span class="cardnum">4 / 44</span>', '13PAX');
INSERT INTO white_cards VALUES (100314, 'A bunch of idiots playing a card game instead of interacting like normal humans.', 'X4');
INSERT INTO white_cards VALUES (100315, 'A sex goblin with a carnival penis.', 'X4');
INSERT INTO white_cards VALUES (100316, 'Lots and lots of abortions.', 'X4');
INSERT INTO white_cards VALUES (100317, 'Injecting speed into one arm and horse tranquilizer into the other.', 'X4');
INSERT INTO white_cards VALUES (100318, 'Sharks with legs.', 'X4');
INSERT INTO white_cards VALUES (100319, 'A sex comet from Neptune that plunges the Earth into eternal sexiness.', 'X4');
INSERT INTO white_cards VALUES (100320, 'How awesome I am.', 'X4');
INSERT INTO white_cards VALUES (100321, 'Smoking crack, for instance.', 'X4');
INSERT INTO white_cards VALUES (100322, 'A dance move that''s just sex.', 'X4');
INSERT INTO white_cards VALUES (100323, 'A hopeless amount of spiders.', 'X4');
INSERT INTO white_cards VALUES (100324, 'Drinking responsibly.', 'X4');
INSERT INTO white_cards VALUES (100325, 'Angelheaded hipsters burning for the ancient heavenly connection to the starry dynamo in the machinery of night.', 'X4');
INSERT INTO white_cards VALUES (100326, 'Bouncing up and down.', 'X4');
INSERT INTO white_cards VALUES (100327, 'A shiny rock that proves I love you.', 'X4');
INSERT INTO white_cards VALUES (100328, 'Crazy opium eyes.', 'X4');
INSERT INTO white_cards VALUES (100329, 'Moderate-to-severe joint pain.', 'X4');
INSERT INTO white_cards VALUES (100330, 'Finally finishing off the Indians.', 'X4');
INSERT INTO white_cards VALUES (100331, 'Actual mutants with medical conditions and no superpowers.', 'X4');
INSERT INTO white_cards VALUES (100332, 'The complex geopolitical quagmire that is the Middle East.', 'X4');
INSERT INTO white_cards VALUES (100333, 'Neil Diamond''s Greatest Hits.', 'X4');
INSERT INTO white_cards VALUES (100334, 'No clothes on, penis in vagina.', 'X4');
INSERT INTO white_cards VALUES (100335, 'Whispering all sexy.', 'X4');
INSERT INTO white_cards VALUES (100336, 'A horse with no legs.', 'X4');
INSERT INTO white_cards VALUES (100337, 'Depression.', 'X4');
INSERT INTO white_cards VALUES (100338, 'Almost giving money to a homeless person.', 'X4');
INSERT INTO white_cards VALUES (100339, 'Interspecies marriage.', 'X4');
INSERT INTO white_cards VALUES (100340, 'Blackula.', 'X4');
INSERT INTO white_cards VALUES (100341, 'What Jesus would do.', 'X4');
INSERT INTO white_cards VALUES (100342, 'A manhole.', 'X4');
INSERT INTO white_cards VALUES (100343, 'My dad''s dumb fucking face.', 'X4');
INSERT INTO white_cards VALUES (100344, 'A Ugandan warlord.', 'X4');
INSERT INTO white_cards VALUES (100345, 'My worthless son.', 'X4');
INSERT INTO white_cards VALUES (100346, 'A Native American who solves crimes by going into the spirit world.', 'X4');
INSERT INTO white_cards VALUES (100347, 'A kiss on the lips.', 'X4');
INSERT INTO white_cards VALUES (100348, 'A fart.', 'X4');
INSERT INTO white_cards VALUES (100349, 'The peaceful and nonthreatening rise of China.', 'X4');
INSERT INTO white_cards VALUES (100355, 'The size of my penis.', 'X4');
INSERT INTO white_cards VALUES (100359, 'Jizz.', 'X4');
INSERT INTO white_cards VALUES (100361, '10 Incredible Facts About the Anus.', 'X4');
INSERT INTO white_cards VALUES (100362, 'The secret formula for ultimate female satisfaction.', 'X4');
INSERT INTO white_cards VALUES (100363, 'Sugar madness.', 'X4');
INSERT INTO white_cards VALUES (100364, 'Calculating every mannerism so as not to suggest homosexuality.', 'X4');
INSERT INTO white_cards VALUES (100365, 'Fucking a corpse back to life.', 'X4');
INSERT INTO white_cards VALUES (100369, 'The euphoric rush of strangling a drifter.', 'X4');
INSERT INTO white_cards VALUES (100350, 'Snorting coke off a clown''s boner.', 'X4');
INSERT INTO white_cards VALUES (100351, 'Three consecutive seconds of happiness.', 'X4');
INSERT INTO white_cards VALUES (100352, 'Falling into the toilet.', 'X4');
INSERT INTO white_cards VALUES (100353, 'Ass to mouth.', 'X4');
INSERT INTO white_cards VALUES (100354, 'Some sort of Asian.', 'X4');
INSERT INTO white_cards VALUES (100356, 'The safe word.', 'X4');
INSERT INTO white_cards VALUES (100357, 'Party Mexicans.', 'X4');
INSERT INTO white_cards VALUES (100358, 'Ambiguous sarcasm.', 'X4');
INSERT INTO white_cards VALUES (100375, 'Prince Ali,<br/>fabulous he,<br/>Ali Ababwa.', 'X4');
INSERT INTO white_cards VALUES (100378, 'My sex dungeon.', 'X4');
INSERT INTO white_cards VALUES (100379, 'Child Protective Services.', 'X4');
INSERT INTO white_cards VALUES (100360, 'An interracial handshake.', 'X4');
INSERT INTO white_cards VALUES (100366, 'All the single ladies.', 'X4');
INSERT INTO white_cards VALUES (100367, 'Whatever a McRib&reg; is made of.', 'X4');
INSERT INTO white_cards VALUES (100368, 'Africa.', 'X4');
INSERT INTO white_cards VALUES (100370, 'Khakis.', 'X4');
INSERT INTO white_cards VALUES (100371, 'A gender identity that can only be conveyed through slam poetry.', 'X4');
INSERT INTO white_cards VALUES (100372, 'Stuff a child''s face with Fun Dip&reg; until he starts having fun.', 'X4');
INSERT INTO white_cards VALUES (100373, 'A for-real lizard that spits blood from its eyes.', 'X4');
INSERT INTO white_cards VALUES (100374, 'The tiniest shred of evidence that God is real.', 'X4');
INSERT INTO white_cards VALUES (100376, 'Dem titties.', 'X4');
INSERT INTO white_cards VALUES (100377, 'Exploding pigeons.', 'X4');
INSERT INTO white_cards VALUES (100380, 'Doo-doo.', 'X4');
INSERT INTO white_cards VALUES (100381, 'Sports.', 'X4');
INSERT INTO white_cards VALUES (100382, 'Unquestioning obedience.', 'X4');
INSERT INTO white_cards VALUES (100383, 'Grammar nazis who are also regular Nazis.', 'X4');
INSERT INTO white_cards VALUES (100414, 'Being banned from /r/pyongyang.', 'SG');
INSERT INTO white_cards VALUES (100416, 'The lost city of Atlantis.', 'SG');
INSERT INTO white_cards VALUES (100417, 'Giving money and personal information to strangers on the Internet.', 'HBS');
INSERT INTO white_cards VALUES (100418, 'A magical tablet containing a world of unlimited pornography.', 'HBS');
INSERT INTO white_cards VALUES (100419, 'These low, low prices!', 'HBS');
INSERT INTO white_cards VALUES (100420, 'Piece of shit Christmas cards with no money in them.', 'HBS');
INSERT INTO white_cards VALUES (100423, 'Moses gargling Jesus''s balls while Shiva and the Buddha penetrate his divine hand holes.', 'HBS');
INSERT INTO white_cards VALUES (100424, 'The Hawaiian goddess Kapo and her flying detachable vagina.', 'HBS');
INSERT INTO white_cards VALUES (100425, 'The shittier, Jewish version of Christmas.', 'HBS');
INSERT INTO white_cards VALUES (100428, 'Making up for 10 years of shitty parenting with a PlayStation.', 'HBS');
INSERT INTO white_cards VALUES (100429, 'Swapping bodies with mom for a day.', 'HBS');
INSERT INTO white_cards VALUES (100430, 'Slicing a ham in icy silence.', 'HBS');
INSERT INTO white_cards VALUES (100431, 'Finding out that Santa isn''t real.', 'HBS');
INSERT INTO white_cards VALUES (100433, 'Rudolph''s bright red balls.', 'HBS');
INSERT INTO white_cards VALUES (100434, 'The Grinch''s musty, cum-stained pelt.', 'HBS');
INSERT INTO white_cards VALUES (100435, 'Breeding elves for their priceless semen.', 'HBS');
INSERT INTO white_cards VALUES (100436, 'Jizzing into Santa''s beard.', 'HBS');
INSERT INTO white_cards VALUES (100438, 'A simultaneous nightmare and wet dream starring Sigourney Weaver.', 'HBS');
INSERT INTO white_cards VALUES (100439, 'Being blind and deaf and having no limbs.', 'HBS');
INSERT INTO white_cards VALUES (100440, 'People with cake in their mouths talking about how good cake is.', 'HBS');
INSERT INTO white_cards VALUES (15549, 'Ewoks.', 'Imgur');
INSERT INTO white_cards VALUES (15550, 'OP Delivers.', 'Imgur');
INSERT INTO white_cards VALUES (15551, '#SOCKS.', 'Imgur');
INSERT INTO white_cards VALUES (15552, 'Oh look! A cat!', 'Imgur');
INSERT INTO white_cards VALUES (15553, 'I am not a clever man.', 'Imgur');
INSERT INTO white_cards VALUES (15554, 'Banana.', 'Imgur');
INSERT INTO white_cards VALUES (15555, 'Read me 10 for all coffee.', 'Imgur');
INSERT INTO white_cards VALUES (15556, 'Juan.', 'Imgur');
INSERT INTO white_cards VALUES (15557, 'Sir Patrick Stewart.', 'Imgur');
INSERT INTO white_cards VALUES (15558, 'Troy and Abed.', 'Imgur');
INSERT INTO white_cards VALUES (15559, 'MOON MOON.', 'Imgur');
INSERT INTO white_cards VALUES (15560, 'Nathan Fillion.', 'Imgur');
INSERT INTO white_cards VALUES (15561, 'Felica Day.', 'Imgur');
INSERT INTO white_cards VALUES (15562, '9.', 'Imgur');
INSERT INTO white_cards VALUES (15563, '10.', 'Imgur');
INSERT INTO white_cards VALUES (15564, '11.', 'Imgur');
INSERT INTO white_cards VALUES (15565, 'BOOM! Pregnant.', 'Imgur');
INSERT INTO white_cards VALUES (15566, 'Tesla.', 'Imgur');
INSERT INTO white_cards VALUES (15567, 'Jon Snow.', 'Imgur');
INSERT INTO white_cards VALUES (15568, 'Ass.', 'Imgur');
INSERT INTO white_cards VALUES (15569, 'Theon Greyjoy’s dismembered member.', 'Imgur');
INSERT INTO white_cards VALUES (15570, 'Not since the accident.', 'Imgur');
INSERT INTO white_cards VALUES (15571, 'Lechuga.', 'Imgur');
INSERT INTO white_cards VALUES (15572, 'Edward Macaroni Fork.', 'Imgur');
INSERT INTO white_cards VALUES (15573, 'Imgurgiraffe.', 'Imgur');
INSERT INTO white_cards VALUES (15574, 'ANUSTART.', 'Imgur');
INSERT INTO white_cards VALUES (15575, 'This was a grave mistake.', 'Imgur');
INSERT INTO white_cards VALUES (15576, 'BAZINGA!', 'Imgur');
INSERT INTO white_cards VALUES (15577, 'Cousin Maeby.', 'Imgur');
INSERT INTO white_cards VALUES (15578, 'STEVE HOLT.', 'Imgur');
INSERT INTO white_cards VALUES (15579, 'Nevernudes.', 'Imgur');
INSERT INTO white_cards VALUES (15580, 'Tard.', 'Imgur');
INSERT INTO white_cards VALUES (15581, 'Potato. ', 'Imgur');
INSERT INTO white_cards VALUES (15582, 'Bacon.', 'Imgur');
INSERT INTO white_cards VALUES (15583, 'Erotic fiction featuring Snape and Hermione.', 'Imgur');
INSERT INTO white_cards VALUES (15584, 'Sonic Screwdriver. ', 'Imgur');
INSERT INTO white_cards VALUES (15585, 'Chak´s homemade maple bacon jam.', 'Imgur');
INSERT INTO white_cards VALUES (15586, 'Moisturize me.', 'Imgur');
INSERT INTO white_cards VALUES (15587, 'Mummy.', 'Imgur');
INSERT INTO white_cards VALUES (15588, 'Expelliarmus!', 'Imgur');
INSERT INTO white_cards VALUES (15589, 'Hagrid.', 'Imgur');
INSERT INTO white_cards VALUES (15590, 'Buckbeak.', 'Imgur');
INSERT INTO white_cards VALUES (15591, 'Luke Skywalker making out with his sister, Leia.', 'Imgur');
INSERT INTO white_cards VALUES (15592, 'NobodySaysThis.', 'Imgur');
INSERT INTO white_cards VALUES (15593, 'Nargles.', 'Imgur');
INSERT INTO white_cards VALUES (15594, 'Annie´s boobs.', 'Imgur');
INSERT INTO white_cards VALUES (15595, 'An overpriced cup of coffee.', 'Imgur');
INSERT INTO white_cards VALUES (15596, 'Demonstrating how to properly put on a condom using a cucumber as substitute for a penis.', 'Imgur');
INSERT INTO white_cards VALUES (15597, 'Katie the Cock Cozy.', 'Imgur');
INSERT INTO white_cards VALUES (15598, 'Going Super Saiyan.', 'ANX1');
INSERT INTO white_cards VALUES (15599, 'Going Super Saiyan during orgasm.', 'ANX1');
INSERT INTO white_cards VALUES (15600, 'Going Super Saiyan while taking a massive dump.', 'ANX1');
INSERT INTO white_cards VALUES (15601, 'Angry naked people.', 'ANX1');
INSERT INTO white_cards VALUES (15602, 'Literally spanking a monkey.', 'ANX1');
INSERT INTO white_cards VALUES (15603, 'My daikon.', 'ANX1');
INSERT INTO white_cards VALUES (15604, 'Alicorn OCs.', 'FiM1');
INSERT INTO white_cards VALUES (15605, 'An End of Ponies update.', 'FiM1');
INSERT INTO white_cards VALUES (15606, 'Another ball-greasing 502 error, for fuck''s sake! Goddamnit!', 'FiM1');
INSERT INTO white_cards VALUES (15607, 'Assholes who hate foalcon.', 'FiM1');
INSERT INTO white_cards VALUES (15608, 'Big Macintosh''s gaping, sloppy-wet boycunt.', 'FiM1');
INSERT INTO white_cards VALUES (15609, 'Blackjack.', 'FiM1');
INSERT INTO white_cards VALUES (15610, 'Bronies.', 'FiM1');
INSERT INTO white_cards VALUES (15611, 'Chuckward, before he was banned.', 'FiM1');
INSERT INTO white_cards VALUES (15612, 'Cola''s ass.', 'FiM1');
INSERT INTO white_cards VALUES (15613, 'Columbine. Dear fucking Celestia, Columbine.', 'FiM1');
INSERT INTO white_cards VALUES (15614, 'Crotchtits.', 'FiM1');
INSERT INTO white_cards VALUES (15615, 'darf.', 'FiM1');
INSERT INTO white_cards VALUES (15616, 'darf''s corpse, Faust rest his soul.', 'FiM1');
INSERT INTO white_cards VALUES (15617, 'Dollhouse.', 'FiM1');
INSERT INTO white_cards VALUES (15618, 'Eakin.', 'FiM1');
INSERT INTO white_cards VALUES (15619, 'Equestria Daily.', 'FiM1');
INSERT INTO white_cards VALUES (15620, 'Fallout: Equestria: Project Horizons.', 'FiM1');
INSERT INTO white_cards VALUES (15621, 'Fallout: Equestria.', 'FiM1');
INSERT INTO white_cards VALUES (15622, 'FelixDawn.', 'FiM1');
INSERT INTO white_cards VALUES (15623, 'Fillyfooler.', 'FiM1');
INSERT INTO white_cards VALUES (15624, 'Foalcon.', 'FiM1');
INSERT INTO white_cards VALUES (15625, 'Fucking 502 errors.', 'FiM1');
INSERT INTO white_cards VALUES (15626, 'Fucking Anthro.', 'FiM1');
INSERT INTO white_cards VALUES (15627, 'Goddamned crossover fics.', 'FiM1');
INSERT INTO white_cards VALUES (15628, 'Goddamned unnecessary futa.', 'FiM1');
INSERT INTO white_cards VALUES (15629, 'Horsedick.', 'FiM1');
INSERT INTO white_cards VALUES (15630, 'Humancunt.', 'FiM1');
INSERT INTO white_cards VALUES (15631, 'Humanized.', 'FiM1');
INSERT INTO white_cards VALUES (15632, 'IJAB.', 'FiM1');
INSERT INTO white_cards VALUES (15633, 'Kaidan.', 'FiM1');
INSERT INTO white_cards VALUES (15634, 'knighty.', 'FiM1');
INSERT INTO white_cards VALUES (15635, 'knighty''s dribbling dick.', 'FiM1');
INSERT INTO white_cards VALUES (15636, 'Lacinias.', 'FiM1');
INSERT INTO white_cards VALUES (15637, 'Littlepip.', 'FiM1');
INSERT INTO white_cards VALUES (15638, 'Mares with dicks.', 'FiM1');
INSERT INTO white_cards VALUES (15639, 'Meeester', 'FiM1');
INSERT INTO white_cards VALUES (15640, 'Mods.', 'FiM1');
INSERT INTO white_cards VALUES (15641, 'More 502 errors, christ.', 'FiM1');
INSERT INTO white_cards VALUES (15642, 'My Little Dashie, even though it''s a piece of shit.', 'FiM1');
INSERT INTO white_cards VALUES (15643, 'NSFW blogposts filled with guro and incest.', 'FiM1');
INSERT INTO white_cards VALUES (15644, 'Nyx, the ultimate Mary Sue.', 'FiM1');
INSERT INTO white_cards VALUES (15645, 'Obselescence.', 'FiM1');
INSERT INTO white_cards VALUES (15646, 'On A Cross And An Arrow.', 'FiM1');
INSERT INTO white_cards VALUES (15647, 'para''s sweaty nutsack.', 'FiM1');
INSERT INTO white_cards VALUES (15648, 'parasprite.', 'FiM1');
INSERT INTO white_cards VALUES (15649, 'Ponycunt.', 'FiM1');
INSERT INTO white_cards VALUES (15650, 'RainbowBob.', 'FiM1');
INSERT INTO white_cards VALUES (15651, 'RBDash47''s latest blog post.', 'FiM1');
INSERT INTO white_cards VALUES (15652, 'Regidar, again, the little shit.', 'FiM1');
INSERT INTO white_cards VALUES (15653, 'Regidar.', 'FiM1');
INSERT INTO white_cards VALUES (15654, 'Riffing.', 'FiM1');
INSERT INTO white_cards VALUES (15655, 'Rule 63.', 'FiM1');
INSERT INTO white_cards VALUES (15656, 'Sethisto.', 'FiM1');
INSERT INTO white_cards VALUES (15657, 'Short Skirts and Explosions.', 'FiM1');
INSERT INTO white_cards VALUES (15658, 'Sick freaks who love foalcon.', 'FiM1');
INSERT INTO white_cards VALUES (15659, 'Skeeter The Lurker.', 'FiM1');
INSERT INTO white_cards VALUES (15660, 'Stallions with cunts.', 'FiM1');
INSERT INTO white_cards VALUES (15661, 'That jackass Aegis Shield.', 'FiM1');
INSERT INTO white_cards VALUES (15662, 'That jackass Silent Bob.', 'FiM1');
INSERT INTO white_cards VALUES (15663, 'The Conversion Bureau.', 'FiM1');
INSERT INTO white_cards VALUES (15664, 'The Featured Box.', 'FiM1');
INSERT INTO white_cards VALUES (15665, 'The Great NSFW Purge Of 2013.', 'FiM1');
INSERT INTO white_cards VALUES (15666, 'The Mature Featured Box.', 'FiM1');
INSERT INTO white_cards VALUES (15667, 'The Noble Jury.', 'FiM1');
INSERT INTO white_cards VALUES (15668, 'The Pony Fiction Vault, before it fucked off into the sunset.', 'FiM1');
INSERT INTO white_cards VALUES (15669, 'The Train Wreck Explorers.', 'FiM1');
INSERT INTO white_cards VALUES (15670, 'The Writer''s Group.', 'FiM1');
INSERT INTO white_cards VALUES (15671, 'Those doucheslurping Adsense assholes.', 'FiM1');
INSERT INTO white_cards VALUES (15672, 'Twilacorn Autism.', 'FiM1');
INSERT INTO white_cards VALUES (15673, 'Twilacorn.', 'FiM1');
INSERT INTO white_cards VALUES (15674, 'Twilight Sparkle, the ultimate Mary Sue.', 'FiM1');
INSERT INTO white_cards VALUES (15675, 'Twilight Sparkle''s massive, throbbing princesshood.', 'FiM1');
INSERT INTO white_cards VALUES (15676, 'Twilight''s Library', 'FiM1');
INSERT INTO white_cards VALUES (15677, 'Wanderer D.', 'FiM1');
INSERT INTO white_cards VALUES (15678, 'Xenophilia.', 'FiM1');
INSERT INTO white_cards VALUES (15679, 'Your bullshit OTP.', 'FiM1');
INSERT INTO white_cards VALUES (15680, 'Your shitty OC.', 'FiM1');
INSERT INTO white_cards VALUES (16718, 'Spess mehrines', '/tg/');
INSERT INTO white_cards VALUES (16719, 'Paladin', '/tg/');
INSERT INTO white_cards VALUES (16720, 'Rogue', '/tg/');
INSERT INTO white_cards VALUES (16721, 'Blackguard', '/tg/');
INSERT INTO white_cards VALUES (16722, '¡MAGOOOOOOOOOOOS DEL TIEMPOOOOOOOOOOOOOO!', '/tg/');
INSERT INTO white_cards VALUES (16723, 'Lich', '/tg/');
INSERT INTO white_cards VALUES (16724, 'A Mastercraft Greatsword', '/tg/');
INSERT INTO white_cards VALUES (16725, 'A Bag of Holding full of Portable Holes', '/tg/');
INSERT INTO white_cards VALUES (16726, 'Explosive Runes', '/tg/');
INSERT INTO white_cards VALUES (16727, 'Wizard', '/tg/');
INSERT INTO white_cards VALUES (16728, 'Pelor', '/tg/');
INSERT INTO white_cards VALUES (16729, 'Lady of Pain', '/tg/');
INSERT INTO white_cards VALUES (16730, 'Spelljammer', '/tg/');
INSERT INTO white_cards VALUES (16731, 'Druidic Mysteries', '/tg/');
INSERT INTO white_cards VALUES (16732, 'The MacGuffin', '/tg/');
INSERT INTO white_cards VALUES (16733, 'My Magical Realm', '/tg/');
INSERT INTO white_cards VALUES (16734, 'A Literal White Knight', '/tg/');
INSERT INTO white_cards VALUES (16735, 'A Literal Black Knight', '/tg/');
INSERT INTO white_cards VALUES (16736, 'A Big, Black Knight', '/tg/');
INSERT INTO white_cards VALUES (16737, 'A Bigger, Blacker Knight', '/tg/');
INSERT INTO white_cards VALUES (16738, 'The Biggest, Blackest Knight', '/tg/');
INSERT INTO white_cards VALUES (16739, 'Brogan', '/tg/');
INSERT INTO white_cards VALUES (16740, 'stat me', '/tg/');
INSERT INTO white_cards VALUES (16741, '/co/', '/tg/');
INSERT INTO white_cards VALUES (16742, '/d/', '/tg/');
INSERT INTO white_cards VALUES (16743, '/x/', '/tg/');
INSERT INTO white_cards VALUES (16744, 'The whizzard', '/tg/');
INSERT INTO white_cards VALUES (16745, 'Mary Sue', '/tg/');
INSERT INTO white_cards VALUES (16746, 'Crazy Hassan', '/tg/');
INSERT INTO white_cards VALUES (16747, '&gt;BLAM', '/tg/');
INSERT INTO white_cards VALUES (16748, 'Gork and Mork', '/tg/');
INSERT INTO white_cards VALUES (16749, 'Hour long quest adventures over Omegle', '/tg/');
INSERT INTO white_cards VALUES (16750, 'Skip the bullshit and go straight to banging', '/tg/');
INSERT INTO white_cards VALUES (16751, 'Anthropomorphism in 40K', '/tg/');
INSERT INTO white_cards VALUES (16752, 'Surf ninjas', '/tg/');
INSERT INTO white_cards VALUES (16753, 'Being a motherfucking sorcerer', '/tg/');
INSERT INTO white_cards VALUES (16754, 'Fa/tg/uy', '/tg/');
INSERT INTO white_cards VALUES (16755, 'A diaper of holding flamethrower', '/tg/');
INSERT INTO white_cards VALUES (16756, 'Peasant railguns', '/tg/');
INSERT INTO white_cards VALUES (16757, 'Sexbots', '/tg/');
INSERT INTO white_cards VALUES (16758, 'Chaotic randumb', '/tg/');
INSERT INTO white_cards VALUES (16759, 'That guy', '/tg/');
INSERT INTO white_cards VALUES (16760, 'Laughing Eldar', '/tg/');
INSERT INTO white_cards VALUES (16761, 'Your FLGS', '/tg/');
INSERT INTO white_cards VALUES (16762, 'Roll-play', '/tg/');
INSERT INTO white_cards VALUES (16763, 'Goddamn magpies', '/tg/');
INSERT INTO white_cards VALUES (16764, 'Diplomacy', '/tg/');
INSERT INTO white_cards VALUES (16765, 'Metal Boxes', '/tg/');
INSERT INTO white_cards VALUES (16766, 'That DM', '/tg/');
INSERT INTO white_cards VALUES (16767, 'LIIVI', '/tg/');
INSERT INTO white_cards VALUES (16768, 'Lofn', '/tg/');
INSERT INTO white_cards VALUES (16769, 'NONE PURER!!!', '/tg/');
INSERT INTO white_cards VALUES (16770, 'Haters gonna hate', '/tg/');
INSERT INTO white_cards VALUES (16771, 'THIN YOUR PAINTS', '/tg/');
INSERT INTO white_cards VALUES (16772, 'An Imperial titan', '/tg/');
INSERT INTO white_cards VALUES (16773, 'GMPC', '/tg/');
INSERT INTO white_cards VALUES (16774, 'Elf vaginas', '/tg/');
INSERT INTO white_cards VALUES (16775, 'Subtle pigmen', '/tg/');
INSERT INTO white_cards VALUES (16776, 'Falling Rocks', '/tg/');
INSERT INTO white_cards VALUES (16777, 'Attacking the darkness', '/tg/');
INSERT INTO white_cards VALUES (16778, 'The emprah', '/tg/');
INSERT INTO white_cards VALUES (16779, 'Blood for the blood god', '/tg/');
INSERT INTO white_cards VALUES (16780, 'Thick and luxurious neckbeards', '/tg/');
INSERT INTO white_cards VALUES (16781, 'KUUUUUUUBOOOOOOOOO!', '/tg/');
INSERT INTO white_cards VALUES (16782, 'AC Guy''s luck', '/tg/');
INSERT INTO white_cards VALUES (16783, 'Canon fanfiction', '/tg/');
INSERT INTO white_cards VALUES (16784, 'Rolling straight 1s', '/tg/');
INSERT INTO white_cards VALUES (16785, 'Sexy, barely-legal Thri-kreen', '/tg/');
INSERT INTO white_cards VALUES (16786, 'Overpowered katanas', '/tg/');
INSERT INTO white_cards VALUES (16787, 'Getting ''Squatted''', '/tg/');
INSERT INTO white_cards VALUES (16788, 'Fucking kender', '/tg/');
INSERT INTO white_cards VALUES (16789, 'TIIIIIMMMME WIIIIZZZZAAAAARRRDDDDs!', '/tg/');
INSERT INTO white_cards VALUES (16790, '-4 str', '/tg/');
INSERT INTO white_cards VALUES (16791, 'Lenore', '/tg/');
INSERT INTO white_cards VALUES (16792, 'Dorfs', '/tg/');
INSERT INTO white_cards VALUES (16793, 'THAC0', '/tg/');
INSERT INTO white_cards VALUES (16794, 'Your Spiritual Liege, Matt Ward', '/tg/');
INSERT INTO white_cards VALUES (16795, 'Skub', '/tg/');
INSERT INTO white_cards VALUES (16796, 'Vectron, his name be praised.', '/tg/');
INSERT INTO white_cards VALUES (16797, 'Vectron''s kindly claw.', '/tg/');
INSERT INTO white_cards VALUES (16798, 'Doomrider and his cocaine', '/tg/');
INSERT INTO white_cards VALUES (16799, 'The GM''s girlfriend', '/tg/');
INSERT INTO white_cards VALUES (16800, 'A first edition copy of FATAL', '/tg/');
INSERT INTO white_cards VALUES (16801, 'A vagina full of spiders', '/tg/');
INSERT INTO white_cards VALUES (16802, 'A bear in a disguise', '/tg/');
INSERT INTO white_cards VALUES (16803, 'DC 80 Escape Artist check', '/tg/');
INSERT INTO white_cards VALUES (16804, 'DRAGON DILDOS', '/tg/');
INSERT INTO white_cards VALUES (16805, 'Decanter of endless water rocket', '/tg/');
INSERT INTO white_cards VALUES (16806, 'Necronomicon', '/tg/');
INSERT INTO white_cards VALUES (16807, 'Joshua-the embodiment of male self loathing', '/tg/');
INSERT INTO white_cards VALUES (16808, 'd4 caltrops', '/tg/');
INSERT INTO white_cards VALUES (16809, 'An army made of sprues', '/tg/');
INSERT INTO white_cards VALUES (16810, 'Meatbread', '/tg/');
INSERT INTO white_cards VALUES (16811, 'Xeno scum', '/tg/');
INSERT INTO white_cards VALUES (16812, 'Muckin'' about', '/tg/');
INSERT INTO white_cards VALUES (16813, 'Enuff Dakka', '/tg/');
INSERT INTO white_cards VALUES (16814, 'Deep Rot', '/tg/');
INSERT INTO white_cards VALUES (16815, 'Caster Edition Fanboys.', '/tg/');
INSERT INTO white_cards VALUES (16816, 'Monte Cooke''s rancid fursuit.', '/tg/');
INSERT INTO white_cards VALUES (16817, 'Kickstarting a /tg/ homebrew only to have it turn out to be shit.', '/tg/');
INSERT INTO white_cards VALUES (16818, 'Waiting for Time Wizards!', '/tg/');
INSERT INTO white_cards VALUES (16819, 'Covering yourself in mountain dew and rolling around the FLGS bathroom.', '/tg/');
INSERT INTO white_cards VALUES (16820, 'A magical piss forest.', '/tg/');
INSERT INTO white_cards VALUES (16821, 'Asking to play a pony in a Game of Thrones rpg.', '/tg/');
INSERT INTO white_cards VALUES (16822, 'Half-fae catboys.', '/tg/');
INSERT INTO white_cards VALUES (16823, 'SAN loss.', '/tg/');
INSERT INTO white_cards VALUES (16824, 'Dakkon Motherfucking Blackblade', '/tg/');
INSERT INTO white_cards VALUES (16825, 'Mark Rosewater', '/tg/');
INSERT INTO white_cards VALUES (16826, 'Chimney Imp', '/tg/');
INSERT INTO white_cards VALUES (16827, 'Storm Crow', '/tg/');
INSERT INTO white_cards VALUES (16828, 'Big Blue Boy', '/tg/');
INSERT INTO white_cards VALUES (16829, 'Fisk Malks', '/tg/');
INSERT INTO white_cards VALUES (16830, 'Madolche?', '/tg/');
INSERT INTO white_cards VALUES (16831, 'Filthy Casual', '/tg/');
INSERT INTO white_cards VALUES (16832, 'If only Tom Bombadil gave a fuck.', '/tg/');
INSERT INTO white_cards VALUES (16833, 'Gratuitous Babe Art', '/tg/');
INSERT INTO white_cards VALUES (16834, 'Failing your Privilege Check and taking full damage from the Tumblrdragon''s breath weapon', '/tg/');
INSERT INTO white_cards VALUES (16835, 'People who don''t understand THAC0.', '/tg/');
INSERT INTO white_cards VALUES (16836, 'People who use THAC0.', '/tg/');
INSERT INTO white_cards VALUES (16837, 'Declaring a TIME MOMENT when the TM is about to say something important.', '/tg/');
INSERT INTO white_cards VALUES (16838, 'Coasters', '/tg/');
INSERT INTO white_cards VALUES (16839, 'Moot', '/tg/');
INSERT INTO white_cards VALUES (16840, 'Saying goodbye to Exodia.', '/tg/');
INSERT INTO white_cards VALUES (16841, 'A railroad with no end.', '/tg/');
INSERT INTO white_cards VALUES (16842, 'Edition wars.', '/tg/');
INSERT INTO white_cards VALUES (16843, 'Riding the Jund train at full throttle.', '/tg/');
INSERT INTO white_cards VALUES (16844, 'Metagaming.', '/tg/');
INSERT INTO white_cards VALUES (16845, 'Playing for the story.', '/tg/');
INSERT INTO white_cards VALUES (16846, 'Glorified games of pretend.', '/tg/');
INSERT INTO white_cards VALUES (16847, 'Frost Giants', '/tg/');
INSERT INTO white_cards VALUES (16848, 'A robotic ninja catgirl maid', '/tg/');
INSERT INTO white_cards VALUES (16849, 'Please do not take the items.', '/tg/');
INSERT INTO white_cards VALUES (16850, 'Kord', '/tg/');
INSERT INTO white_cards VALUES (16851, 'Queen of Blades', '/tg/');
INSERT INTO white_cards VALUES (16852, 'Boxcars', '/tg/');
INSERT INTO white_cards VALUES (16853, 'A Natural 20', '/tg/');
INSERT INTO white_cards VALUES (16854, 'Hypercube', '/tg/');
INSERT INTO white_cards VALUES (16855, 'A falling Paladin', '/tg/');
INSERT INTO white_cards VALUES (16856, 'Children''s Card Games', '/tg/');
INSERT INTO white_cards VALUES (16857, 'Cardgames on motorcycles.', '/tg/');
INSERT INTO white_cards VALUES (16858, 'Mise.', '/tg/');
INSERT INTO white_cards VALUES (16859, 'Crawdaddy.', '/tg/');
INSERT INTO white_cards VALUES (16860, 'Jace:the Wallet Sculptor.', '/tg/');
INSERT INTO white_cards VALUES (16861, 'Grim dark darkness that''s grim.', '/tg/');
INSERT INTO white_cards VALUES (16862, 'Virgin Spike.', '/tg/');
INSERT INTO white_cards VALUES (16863, 'Choo choo, motherfucker.', '/tg/');
INSERT INTO white_cards VALUES (16864, 'Squats.', '/tg/');
INSERT INTO white_cards VALUES (16865, 'Sabbat Warhero', '/tg/');
INSERT INTO white_cards VALUES (16866, 'Shitting all over the DM''s plans.', '/tg/');
INSERT INTO white_cards VALUES (16867, 'Chaos Spawn.', '/tg/');
INSERT INTO white_cards VALUES (16868, 'Satanic rituals and human sacrifice.', '/tg/');
INSERT INTO white_cards VALUES (16869, 'Suggesting GURPS. No matter what.', '/tg/');
INSERT INTO white_cards VALUES (16870, 'Old Man Henderson.', '/tg/');
INSERT INTO white_cards VALUES (16871, 'Monstergirls.', '/tg/');
INSERT INTO white_cards VALUES (16872, 'Grognard', '/tg/');
INSERT INTO white_cards VALUES (16873, 'Scary Spooky Skeletons', '/tg/');
INSERT INTO white_cards VALUES (16874, 'No sense of right and wrong', '/tg/');
INSERT INTO white_cards VALUES (16875, 'Goblins', '/tg/');
INSERT INTO white_cards VALUES (16876, 'Kharne', '/tg/');
INSERT INTO white_cards VALUES (16877, 'Eldrad', '/tg/');
INSERT INTO white_cards VALUES (16878, 'Sister of Battle lesbian hebephilia', '/tg/');
INSERT INTO white_cards VALUES (16879, 'FATE', '/tg/');
INSERT INTO white_cards VALUES (16880, 'Bad at Magic', '/tg/');
INSERT INTO white_cards VALUES (16881, 'Time Cube chess', '/tg/');
INSERT INTO white_cards VALUES (16882, 'Noh', '/tg/');
INSERT INTO white_cards VALUES (16883, 'Tankred Endures', '/tg/');
INSERT INTO white_cards VALUES (16884, 'FOR THE EMPRAH', '/tg/');
INSERT INTO white_cards VALUES (16885, 'CREEEEEEEEEEED!', '/tg/');
INSERT INTO white_cards VALUES (16886, 'Shitposting', '/tg/');
INSERT INTO white_cards VALUES (16887, 'A Kobold princess', '/tg/');
INSERT INTO white_cards VALUES (16888, 'Kebab', '/tg/');
INSERT INTO white_cards VALUES (16889, 'Los Tiburon', '/tg/');
INSERT INTO white_cards VALUES (16890, 'CLANG!', '/tg/');
INSERT INTO white_cards VALUES (16891, 'Commissar Fuklaw', '/tg/');
INSERT INTO white_cards VALUES (16892, 'F.A.T.A.L.', '/tg/');
INSERT INTO white_cards VALUES (16893, 'Female Space Marines', '/tg/');
INSERT INTO white_cards VALUES (16894, 'An orc guarding a chest in a 10x10 room', '/tg/');
INSERT INTO white_cards VALUES (16895, 'Captcha', '/tg/');
INSERT INTO white_cards VALUES (16896, 'Ruby and Tom', '/tg/');
INSERT INTO white_cards VALUES (16897, 'Pun-Pun', '/tg/');
INSERT INTO white_cards VALUES (16898, 'I CAST FIST!', '/tg/');
INSERT INTO white_cards VALUES (16899, 'Cultist-Chan', '/tg/');
INSERT INTO white_cards VALUES (16900, '100-ton Atlas-class Mech', '/tg/');
INSERT INTO white_cards VALUES (16901, 'Ciaphas Cain', '/tg/');
INSERT INTO white_cards VALUES (16902, 'Oinkbane The Wereboar Assassin', '/tg/');
INSERT INTO white_cards VALUES (16903, 'orkupy waaaghstreet', '/tg/');
INSERT INTO white_cards VALUES (16904, 'Bard dad', '/tg/');
INSERT INTO white_cards VALUES (16905, 'Warhammer 40k', '/tg/');
INSERT INTO white_cards VALUES (16906, 'Warhammer Fantasy', '/tg/');
INSERT INTO white_cards VALUES (16907, 'Bloodbowl', '/tg/');
INSERT INTO white_cards VALUES (16908, 'Games Workshop', '/tg/');
INSERT INTO white_cards VALUES (16909, 'Dungeons and Dragons', '/tg/');
INSERT INTO white_cards VALUES (16910, 'Pathfinder', '/tg/');
INSERT INTO white_cards VALUES (16911, 'Magic: the Gathering', '/tg/');
INSERT INTO white_cards VALUES (16912, 'Engine Heart', '/tg/');
INSERT INTO white_cards VALUES (16913, 'Yu-Gi-Oh', '/tg/');
INSERT INTO white_cards VALUES (16914, 'Pokémon TCG', '/tg/');
INSERT INTO white_cards VALUES (16915, 'Pokemon: Tabletop Adventures', '/tg/');
INSERT INTO white_cards VALUES (16916, 'Vampire: The Masquerade', '/tg/');
INSERT INTO white_cards VALUES (16917, 'Vampire LARP', '/tg/');
INSERT INTO white_cards VALUES (16918, 'Hungarian Larper', '/tg/');
INSERT INTO white_cards VALUES (16919, 'Esh-Esh', '/tg/');
INSERT INTO white_cards VALUES (16920, 'Dice Bags', '/tg/');
INSERT INTO white_cards VALUES (16921, 'Bitches for Thulsa Doom', '/tg/');
INSERT INTO white_cards VALUES (16922, 'Conan the Librarian', '/tg/');
INSERT INTO white_cards VALUES (16923, 'Conan the Libertarian', '/tg/');
INSERT INTO white_cards VALUES (16924, 'Show me Your Honor', '/tg/');
INSERT INTO white_cards VALUES (16925, 'Blood and Thunder!', '/tg/');
INSERT INTO white_cards VALUES (16926, 'Actually having an intelligent discussion about religion.', '/tg/');
INSERT INTO white_cards VALUES (16927, 'Blood for the Blood God!', '/tg/');
INSERT INTO white_cards VALUES (16928, 'WAAAAAAAAAAGH!', '/tg/');
INSERT INTO white_cards VALUES (16929, 'Female DM', '/tg/');
INSERT INTO white_cards VALUES (16930, 'Buying GW paints and primer', '/tg/');
INSERT INTO white_cards VALUES (16931, 'Your Other Honor!', '/tg/');
INSERT INTO white_cards VALUES (16932, 'Kromgol', '/tg/');
INSERT INTO white_cards VALUES (16933, 'Tyrone the Monk', '/tg/');
INSERT INTO white_cards VALUES (16934, 'Mr. Fred Rogers, blessed be his name.', '/tg/');
INSERT INTO white_cards VALUES (16935, 'The ship is all. The ship moves', '/tg/');
INSERT INTO white_cards VALUES (16936, 'Haggard', '/tg/');
INSERT INTO white_cards VALUES (16937, 'Living Saint Inquisitor Grendel', '/tg/');
INSERT INTO white_cards VALUES (16938, 'METAL BOXES', '/tg/');
INSERT INTO white_cards VALUES (16939, '100 Baneblades', '/tg/');
INSERT INTO white_cards VALUES (16940, 'Gav &amp; Bob', '/tg/');
INSERT INTO white_cards VALUES (16941, 'MR RAGE', '/tg/');
INSERT INTO white_cards VALUES (16942, 'Abaddon the Armless', '/tg/');
INSERT INTO white_cards VALUES (16943, 'Sigmar', '/tg/');
INSERT INTO white_cards VALUES (16944, 'Cthulhu himself', '/tg/');
INSERT INTO white_cards VALUES (16945, 'Nyarlathotep', '/tg/');
INSERT INTO white_cards VALUES (16946, 'The Great Race of Yith', '/tg/');
INSERT INTO white_cards VALUES (16947, 'Shub-Niggurath', '/tg/');
INSERT INTO white_cards VALUES (16948, 'Deep Ones', '/tg/');
INSERT INTO white_cards VALUES (16949, 'Yog-Sothoth', '/tg/');
INSERT INTO white_cards VALUES (16950, 'Azathoth', '/tg/');
INSERT INTO white_cards VALUES (16951, 'The King in Yellow', '/tg/');
INSERT INTO white_cards VALUES (16952, 'The Queen in Yellow', '/tg/');
INSERT INTO white_cards VALUES (16953, 'Saya no Uta', '/tg/');
INSERT INTO white_cards VALUES (16954, 'Haiyore Nyaruko-San', '/tg/');
INSERT INTO white_cards VALUES (16955, 'A boat', '/tg/');
INSERT INTO white_cards VALUES (16956, 'Faptau', '/tg/');
INSERT INTO white_cards VALUES (16957, 'Shlicktau', '/tg/');
INSERT INTO white_cards VALUES (16958, 'A shoggoth', '/tg/');
INSERT INTO white_cards VALUES (16959, 'Transformation Fetishists', '/tg/');
INSERT INTO white_cards VALUES (16960, 'Scat Fetish', '/tg/');
INSERT INTO white_cards VALUES (16961, 'Watersports Fetish', '/tg/');
INSERT INTO white_cards VALUES (16962, 'Blood Ravens', '/tg/');
INSERT INTO white_cards VALUES (16963, 'Ultramarines', '/tg/');
INSERT INTO white_cards VALUES (16964, 'DJ Phylactery', '/tg/');
INSERT INTO white_cards VALUES (16965, 'Muscle Wizard', '/tg/');
INSERT INTO white_cards VALUES (16966, 'Sir Bearington', '/tg/');
INSERT INTO white_cards VALUES (16967, '2 cat', '/tg/');
INSERT INTO white_cards VALUES (16968, 'Dr. Assmarbles', '/tg/');
INSERT INTO white_cards VALUES (16969, '/d/M', '/tg/');
INSERT INTO white_cards VALUES (16970, 'Macha''s stash of mon-keigh lewds.', '/tg/');
INSERT INTO white_cards VALUES (16971, 'A Tactical Genius.', '/tg/');
INSERT INTO white_cards VALUES (16972, 'Blast Templates.', '/tg/');
INSERT INTO white_cards VALUES (16973, 'Decking from a room in a love hotel.', '/tg/');
INSERT INTO white_cards VALUES (16974, 'Teacup Ride.', '/tg/');
INSERT INTO white_cards VALUES (16975, 'WHERE IS FELIX RAMIREZ?', '/tg/');
INSERT INTO white_cards VALUES (16976, 'Teaching the newbie about THE SYSTEM.', '/tg/');
INSERT INTO white_cards VALUES (16977, 'Dealing Meat Damage.', '/tg/');
INSERT INTO white_cards VALUES (16978, 'America-san.', '/tg/');
INSERT INTO white_cards VALUES (16979, 'Having a Spy Moment.', '/tg/');
INSERT INTO white_cards VALUES (16980, 'Burning Fate Points to survive.', '/tg/');
INSERT INTO white_cards VALUES (18508, 'Tom Baker, in nothing but a scarf', 'DW');
INSERT INTO white_cards VALUES (18509, 'Walking in on Jack Harkness doing your mom. And your dad.', 'DW');
INSERT INTO white_cards VALUES (18510, 'The buzzing noise the Sonic Screwdriver makes', 'DW');
INSERT INTO white_cards VALUES (18511, 'Sharing a public restroom with a Weeping Angel', 'DW');
INSERT INTO white_cards VALUES (18512, 'Just now realizing Torchwood is an anagram of Doctor Who', 'DW');
INSERT INTO white_cards VALUES (18513, 'Fifty years of fanfic.', 'DW');
INSERT INTO white_cards VALUES (18514, 'Wanting to punch that teeny-bopper Whovian that''s butthurt the new Doctor isn''t in his twenties.', 'DW');
INSERT INTO white_cards VALUES (18515, 'The Doctor going back in time to solve a REAL problem: Twilight.', 'DW');
INSERT INTO white_cards VALUES (18516, 'A Doctor Who body pillow.', 'DW');
INSERT INTO white_cards VALUES (18517, 'The Silence', 'DW');
INSERT INTO white_cards VALUES (18518, 'Drunkenly drawing tally marks on your face.', 'DW');
INSERT INTO white_cards VALUES (18519, 'A Rusty Cyberman', 'DW');
INSERT INTO white_cards VALUES (18520, 'A shitty Doctor Who knock-knock joke.', 'DW');
INSERT INTO white_cards VALUES (18521, 'The Doctor having a chance encounter with a couple of 80s metalheads.', 'DW');
INSERT INTO white_cards VALUES (18522, 'Davros getting up on the wrong side of the bed.', 'DW');
INSERT INTO white_cards VALUES (18523, 'The Master, baiting the Doctor into a trap', 'DW');
INSERT INTO white_cards VALUES (18524, 'A Vashta Nerada that just wants a hug.', 'DW');
INSERT INTO white_cards VALUES (18525, 'Wishing you could regenerate.', 'DW');
INSERT INTO white_cards VALUES (18526, 'Kidnapping a barely-legal woman to time travel with.', 'DW');
INSERT INTO white_cards VALUES (18527, 'The poor costume decisions that were the 1970s.', 'DW');
INSERT INTO white_cards VALUES (18528, 'Sixteen feet of scarf bondage.', 'DW');
INSERT INTO white_cards VALUES (18529, 'Getting so much plastic surgery you have to be framed and moisturized.', 'DW');
INSERT INTO white_cards VALUES (18530, 'Quitting this panel after one round because you are afraid of getting typecast.', 'DW');
INSERT INTO white_cards VALUES (18531, 'The Mary Jane Adventures.', 'DW');
INSERT INTO white_cards VALUES (18532, 'Fondling a Dalek''s slippery bits.', 'DW');
INSERT INTO white_cards VALUES (18533, 'Air from my lungs.', 'DW');
INSERT INTO white_cards VALUES (18534, 'Smoking 1,000 cigarettes, just so you can sound like a Dalek when you talk.', 'DW');
INSERT INTO white_cards VALUES (18535, 'Slipping her the ol'' plastic Mickey.', 'DW');
INSERT INTO white_cards VALUES (18536, 'Companion Porn.', 'DW');
INSERT INTO white_cards VALUES (18537, 'An acid rain shower on Skaro.', 'DW');
INSERT INTO white_cards VALUES (18538, 'A Sonic Screwdriver stuck on the vibrate setting.', 'DW');
INSERT INTO white_cards VALUES (18539, 'Pouting in a rain storm and having to take a wicked piss.', 'DW');
INSERT INTO white_cards VALUES (18540, 'The poor decision that is having a staring contest with a weeping angel.', 'DW');
INSERT INTO white_cards VALUES (18541, 'Sorry, this answer is only available in the fanfic version of Cards against Con.', 'DW');
INSERT INTO white_cards VALUES (18542, 'Plot holes so wide you could drive a truck through them.', 'DW');
INSERT INTO white_cards VALUES (18543, 'A blinged out TARDIS blasting dubstep when it is traveling.', 'DW');
INSERT INTO white_cards VALUES (18544, 'Rose Tyler''s teeth.', 'DW');
INSERT INTO white_cards VALUES (18545, 'The Master singing Bad Case of Loving You.', 'DW');
INSERT INTO white_cards VALUES (18546, 'K-9 humping your leg.', 'DW');
INSERT INTO white_cards VALUES (18547, 'A bigger, bluer TARDIS.', 'DW');
INSERT INTO white_cards VALUES (18548, 'Steven Moffatt taking a big old dump in your Cheerios.', 'DW');
INSERT INTO white_cards VALUES (18549, 'Robot Anne Robinson.', 'DW');
INSERT INTO white_cards VALUES (18550, 'A fez caked with semen.', 'DW');
INSERT INTO white_cards VALUES (18551, 'A GUITARDIS', 'DW');
INSERT INTO white_cards VALUES (18552, 'The Celestial Toymaker''s plaything.', 'DW');
INSERT INTO white_cards VALUES (18553, 'Captain Jack Harkness.', 'DW');
INSERT INTO white_cards VALUES (18554, 'Your dyslexic friend that wants you to come watch a marathon of Doctor How.', 'DW');
INSERT INTO white_cards VALUES (18555, 'Fapping to Billie Piper portraying a callgirl.', 'DW');
INSERT INTO white_cards VALUES (18556, 'A furry writing BAD WOLF everywhere.', 'DW');
INSERT INTO white_cards VALUES (18557, 'Being used as a plot device by Steven Moffat.', 'DW');
INSERT INTO white_cards VALUES (18558, 'A Costco-sized bag of Jelly Babies.', 'DW');
INSERT INTO white_cards VALUES (18559, 'A global simulcast that forces Whovians to see the sunlight for the first time in ages.', 'DW');
INSERT INTO white_cards VALUES (18560, 'THE END OF TIME ITSELF!', 'DW');
INSERT INTO white_cards VALUES (18561, 'Finding Autons oddly attractive.', 'DW');
INSERT INTO white_cards VALUES (18562, 'The fuck machine dungeon of the Cybermen.', 'DW');
INSERT INTO white_cards VALUES (18563, 'Glenn Beck convulsively puking as a brood of Daleks swarm in on him.', 'DW');
INSERT INTO white_cards VALUES (18564, 'River Song.', 'DW');
INSERT INTO white_cards VALUES (18565, 'Low-budget special effects.', 'DW');
INSERT INTO white_cards VALUES (18566, 'Eggs.', 'DW');
INSERT INTO white_cards VALUES (18567, 'Dalek porn.', 'DW');
INSERT INTO white_cards VALUES (18568, 'Taking a Doctor Poo.', 'DW');
INSERT INTO white_cards VALUES (18569, 'The big banana in your pocket.', 'DW');
INSERT INTO white_cards VALUES (18570, 'Opening the door of the TARDIS and leaving a deuce in the time-space continuum.', 'DW');
INSERT INTO white_cards VALUES (18571, 'David Tennant.', 'DW');
INSERT INTO white_cards VALUES (18572, 'Matt Smith.', 'DW');
INSERT INTO white_cards VALUES (18573, 'Christopher Eccleston.', 'DW');
INSERT INTO white_cards VALUES (18574, 'Siltheen farts.', 'DW');
INSERT INTO white_cards VALUES (18575, 'A kid in a gas mask asking if you are his mummy.', 'DW');
INSERT INTO white_cards VALUES (17075, 'Anthrocon.', 'RPF');
INSERT INTO white_cards VALUES (17076, 'Uncle Kage.', 'RPF');
INSERT INTO white_cards VALUES (17077, 'The furries.', 'RPF');
INSERT INTO white_cards VALUES (17078, 'Furries on the Tyra Banks show.', 'RPF');
INSERT INTO white_cards VALUES (17079, 'Midna and Wolf Link.', 'RPF');
INSERT INTO white_cards VALUES (17080, 'Paying $3,500 for an oversized novelty fursuiter badge.', 'RPF');
INSERT INTO white_cards VALUES (17081, '2, the Ranting Gryphon.', 'RPF');
INSERT INTO white_cards VALUES (17082, 'Going on a diet for the sole reason of being able to fit in a fursuit.', 'RPF');
INSERT INTO white_cards VALUES (17083, 'Waiting over a year for someone to finish your art commission.', 'RPF');
INSERT INTO white_cards VALUES (17084, 'A used sock collection.', 'RPF');
INSERT INTO white_cards VALUES (17085, 'A small creature being stuffed in a smelly boot.', 'RPF');
INSERT INTO white_cards VALUES (17086, 'Being facesat by someone who is holding in a fart.', 'RPF');
INSERT INTO white_cards VALUES (17087, 'Licking Cinnabon icing off of your partner''s dick.', 'RPF');
INSERT INTO white_cards VALUES (17088, 'Being tied up and having a musky foot stuffed in your mouth.', 'RPF');
INSERT INTO white_cards VALUES (17089, 'A Bad Dragon dildo.', 'RPF');
INSERT INTO white_cards VALUES (17090, 'Being pinned to the wall and fucked in a shower.', 'RPF');
INSERT INTO white_cards VALUES (17091, 'Trees made out of living tentacles.', 'RPF');
INSERT INTO white_cards VALUES (17092, 'Tickling someone until they almost piss themself.', 'RPF');
INSERT INTO white_cards VALUES (17093, 'Using a save state in a video game so you can fap to it later.', 'RPF');
INSERT INTO white_cards VALUES (17094, 'Having every embarrassing kink of yours indulged at one time for a "shamegasm."', 'RPF');
INSERT INTO white_cards VALUES (17095, 'Getting fucked by the Red Robin.', 'RPF');
INSERT INTO white_cards VALUES (17096, 'Horny, stupid livestock.', 'RPF');
INSERT INTO white_cards VALUES (17097, 'A fat Russian Blue that pees on the carpet.', 'RPF');
INSERT INTO white_cards VALUES (17098, 'Poking cats.', 'RPF');
INSERT INTO white_cards VALUES (17099, 'Bending a Lucario over and using its dreadlocks as fuckhandles.', 'RPF');
INSERT INTO white_cards VALUES (17100, 'Role reversal.', 'RPF');
INSERT INTO white_cards VALUES (17101, 'Ray Sipe singing about how /v/ doesn''t like video games.', 'RPF');
INSERT INTO white_cards VALUES (17102, 'A stripper so ugly people throw nickels at her.', 'RPF');
INSERT INTO white_cards VALUES (17103, 'Lesbrarians.', 'RPF');
INSERT INTO white_cards VALUES (17104, 'Umbreon.', 'RPF');
INSERT INTO white_cards VALUES (17105, 'Masturbating at work.', 'RPF');
INSERT INTO white_cards VALUES (17106, 'Rick Astley.', 'RPF');
INSERT INTO white_cards VALUES (17107, 'Poor quality ParkerSteel.', 'RPF');
INSERT INTO white_cards VALUES (17108, 'Vodka spiked with GHB.', 'RPF');
INSERT INTO white_cards VALUES (17109, 'Chopping up someone''s parents and putting them into chili.', 'RPF');
INSERT INTO white_cards VALUES (17110, 'Getting banned from Dave & Buster''s.', 'RPF');
INSERT INTO white_cards VALUES (17111, 'Finding out your internet stalker''s doing 10-30 in federal prison.', 'RPF');
INSERT INTO white_cards VALUES (17112, 'Gambling on a fart and losing.', 'RPF');
INSERT INTO white_cards VALUES (17113, 'A woman with a double-wide stroller about to mow you down.', 'RPF');
INSERT INTO white_cards VALUES (17114, 'A cat trying to stick its nose up your asshole.', 'RPF');
INSERT INTO white_cards VALUES (17115, 'A Fleshlight full of thumb tacks.', 'RPF');
INSERT INTO white_cards VALUES (17116, 'Stayin'' Alive.', 'RPF');
INSERT INTO white_cards VALUES (17117, 'The Sexflesh Venereal Vinnie Suction Cup Diseased Dildo.', 'RPF');
INSERT INTO white_cards VALUES (17118, 'That barrel in Carnival Night Zone at the supposed "dead end".', 'RPF');
INSERT INTO white_cards VALUES (17119, 'Whitney''s Miltank.', 'RPF');
INSERT INTO white_cards VALUES (17120, 'Tourneyfags who turn off all items when playing Super Smash Bros.', 'RPF');
INSERT INTO white_cards VALUES (17121, 'Being stalked by a paranoid schizophrenic on Reddit.', 'RPF');
INSERT INTO white_cards VALUES (17122, 'Looking up where someone lives because they posted something you didn''t like on the internet.', 'RPF');
INSERT INTO white_cards VALUES (17123, 'Chance Time.', 'RPF');
INSERT INTO white_cards VALUES (17124, 'CryptoLocker.', 'RPF');
INSERT INTO white_cards VALUES (17125, 'Colby 2012.', 'RPF');
INSERT INTO white_cards VALUES (17126, 'Petty people.', 'RPF');
INSERT INTO white_cards VALUES (17127, 'Paying $1,475 for a bath sponge.', 'RPF');
INSERT INTO white_cards VALUES (17128, 'Giovanni''s head being suplexed through a floor.', 'RPF');
INSERT INTO white_cards VALUES (17129, 'Plush animals that come to life long enough to drink all your rum.', 'RPF');
INSERT INTO white_cards VALUES (17130, 'BLORF.', 'RPF');
INSERT INTO white_cards VALUES (17131, 'Mewtwo''s reveal as a playable character in the next Super Smash Bros. title.', 'RPF');
INSERT INTO white_cards VALUES (17132, 'The Baconator.', 'RPF');
INSERT INTO white_cards VALUES (17133, 'A chinese buffet where everything is wrapped in bacon.', 'RPF');
INSERT INTO white_cards VALUES (17134, 'A lifetime supply of Olive Garden breadsticks.', 'RPF');
INSERT INTO white_cards VALUES (17135, 'The 52 oz. "Fizzinator" from Sheetz.', 'RPF');
INSERT INTO white_cards VALUES (18576, 'Fish fingering your custard.', 'DW');
INSERT INTO white_cards VALUES (18577, 'The hideousness that is Raxacoricofallapatorious.', 'DW');
INSERT INTO white_cards VALUES (18578, 'An Ood getting a starring role in a hentai.', 'DW');
INSERT INTO white_cards VALUES (18579, 'The voice of one of the Cybermen has malfunctioned. Instead of saying DELETE!', 'DW');
INSERT INTO white_cards VALUES (18580, 'Godwin''s law.', 'KHAOS');
INSERT INTO white_cards VALUES (18581, 'Nope! Chuck Testa.', 'KHAOS');
INSERT INTO white_cards VALUES (18582, 'Pedo-bear.', 'KHAOS');
INSERT INTO white_cards VALUES (18583, 'Honey badger.', 'KHAOS');
INSERT INTO white_cards VALUES (18584, 'Linux.', 'KHAOS');
INSERT INTO white_cards VALUES (18585, 'Unix.', 'KHAOS');
INSERT INTO white_cards VALUES (18586, 'My ANUS is bleeding!', 'KHAOS');
INSERT INTO white_cards VALUES (18587, 'My spoon is too big.', 'KHAOS');
INSERT INTO white_cards VALUES (18588, 'Badger badger badger badger badger...', 'KHAOS');
INSERT INTO white_cards VALUES (18589, 'Candy Mountain.', 'KHAOS');
INSERT INTO white_cards VALUES (18590, 'Pewdiepie.', 'KHAOS');
INSERT INTO white_cards VALUES (18591, 'Black Mesa.', 'KHAOS');
INSERT INTO white_cards VALUES (18592, 'The Umbrella Corporation.', 'KHAOS');
INSERT INTO white_cards VALUES (18593, 'Gordon Freeman.', 'KHAOS');
INSERT INTO white_cards VALUES (18594, 'Head Crabs.', 'KHAOS');
INSERT INTO white_cards VALUES (18595, 'GLaDOS''s cake recipe.', 'KHAOS');
INSERT INTO white_cards VALUES (18596, 'An arrow to the knee.', 'KHAOS');
INSERT INTO white_cards VALUES (18597, 'All your base.', 'KHAOS');
INSERT INTO white_cards VALUES (18598, 'Wood for sheep.', 'KHAOS');
INSERT INTO white_cards VALUES (18599, 'Wonder Woman''s invisible chopper', 'KHAOS');
INSERT INTO white_cards VALUES (18600, 'The Tick.', 'KHAOS');
INSERT INTO white_cards VALUES (18601, 'SHAZAM!', 'KHAOS');
INSERT INTO white_cards VALUES (18602, 'Being tied up with Wonder Woman''s Magic Lasso.', 'KHAOS');
INSERT INTO white_cards VALUES (18603, 'The Batmobile!', 'KHAOS');
INSERT INTO white_cards VALUES (18604, 'Outrunning The Flash!', 'KHAOS');
INSERT INTO white_cards VALUES (18605, 'Getting caught in Spiderman''s sticky, sticky... web.', 'KHAOS');
INSERT INTO white_cards VALUES (18606, 'Getting caught between Green Lantern creating an anvil and Sinestro creating a hammer.', 'KHAOS');
INSERT INTO white_cards VALUES (18607, 'Pissing in the suit', 'KHAOS');
INSERT INTO white_cards VALUES (18608, 'A REALLY cool cape and tights', 'KHAOS');
INSERT INTO white_cards VALUES (18609, 'Content.', 'KHAOS');
INSERT INTO white_cards VALUES (100454, 'The Hollaad Tonnel.', 'SG');
INSERT INTO white_cards VALUES (100460, '25 shitty jokes about House of Cards.', 'HOCAH');
INSERT INTO white_cards VALUES (18610, 'Good Ash', 'KHAOS');
INSERT INTO white_cards VALUES (18611, 'Evil Ash', 'KHAOS');
INSERT INTO white_cards VALUES (18612, 'My boomstick', 'KHAOS');
INSERT INTO white_cards VALUES (18613, 'S-Mart', 'KHAOS');
INSERT INTO white_cards VALUES (18614, 'The Necronomiconexmortis', 'KHAOS');
INSERT INTO white_cards VALUES (18615, 'We''re coming to get you, Barbara!', 'KHAOS');
INSERT INTO white_cards VALUES (18616, 'Groovy', 'KHAOS');
INSERT INTO white_cards VALUES (18617, 'A shrubbery!', 'KHAOS');
INSERT INTO white_cards VALUES (18618, 'The machine that goes "Ping!"', 'KHAOS');
INSERT INTO white_cards VALUES (18619, 'A herring!', 'KHAOS');
INSERT INTO white_cards VALUES (18620, 'The Holy Grail', 'KHAOS');
INSERT INTO white_cards VALUES (18621, 'Camelot', 'KHAOS');
INSERT INTO white_cards VALUES (18622, 'Morgan Freeman', 'KHAOS');
INSERT INTO white_cards VALUES (18623, 'Inconceivable!!', 'KHAOS');
INSERT INTO white_cards VALUES (18624, 'To the pain', 'KHAOS');
INSERT INTO white_cards VALUES (18625, 'Iocane powder', 'KHAOS');
INSERT INTO white_cards VALUES (18626, 'The Orgazmorator', 'KHAOS');
INSERT INTO white_cards VALUES (18627, 'Damn dirty ape', 'KHAOS');
INSERT INTO white_cards VALUES (18628, 'Cowboys from Hell', 'KHAOS');
INSERT INTO white_cards VALUES (18629, 'Festively plump', 'KHAOS');
INSERT INTO white_cards VALUES (18630, 'Ants in the Pants', 'KHAOS');
INSERT INTO white_cards VALUES (18631, 'Mecha-Streisand', 'KHAOS');
INSERT INTO white_cards VALUES (18632, 'Snookie', 'KHAOS');
INSERT INTO white_cards VALUES (18633, 'Honey Boo Boo', 'KHAOS');
INSERT INTO white_cards VALUES (18634, 'Like a boss!', 'KHAOS');
INSERT INTO white_cards VALUES (18635, 'Mutton Vindaloo Beast', 'KHAOS');
INSERT INTO white_cards VALUES (18636, 'Queeg 500', 'KHAOS');
INSERT INTO white_cards VALUES (18637, 'Talkie Toaster', 'KHAOS');
INSERT INTO white_cards VALUES (18638, 'Droid Rot', 'KHAOS');
INSERT INTO white_cards VALUES (18639, 'Athlete''s Hand', 'KHAOS');
INSERT INTO white_cards VALUES (18640, 'Anti-Matter Chopsticks', 'KHAOS');
INSERT INTO white_cards VALUES (18641, 'Groinal Exploder', 'KHAOS');
INSERT INTO white_cards VALUES (18642, 'Shiny!', 'KHAOS');
INSERT INTO white_cards VALUES (18643, 'River Tam', 'KHAOS');
INSERT INTO white_cards VALUES (18644, 'Browncoats', 'KHAOS');
INSERT INTO white_cards VALUES (18645, 'Getting raped to death by reavers', 'KHAOS');
INSERT INTO white_cards VALUES (18646, 'I''ll be in my bunk!', 'KHAOS');
INSERT INTO white_cards VALUES (18647, 'The Alliance', 'KHAOS');
INSERT INTO white_cards VALUES (18648, 'A bigger, blacker deck', 'KHAOS');
INSERT INTO white_cards VALUES (18649, 'The Necronomicon', 'KHAOS');
INSERT INTO white_cards VALUES (18650, 'Fruit flies', 'KHAOS');
INSERT INTO white_cards VALUES (18651, 'Fruit bat', 'KHAOS');
INSERT INTO white_cards VALUES (18652, 'Traumatic insemination', 'KHAOS');
INSERT INTO white_cards VALUES (18653, 'Bagpipes', 'KHAOS');
INSERT INTO white_cards VALUES (18654, 'The Metal!', 'KHAOS');
INSERT INTO white_cards VALUES (18655, 'All the ass in the world!', 'KHAOS');
INSERT INTO white_cards VALUES (18656, 'Prehensile nipples', 'KHAOS');
INSERT INTO white_cards VALUES (18657, 'No pants', 'KHAOS');
INSERT INTO white_cards VALUES (18658, 'Locusts', 'KHAOS');
INSERT INTO white_cards VALUES (18659, 'A tantrum', 'KHAOS');
INSERT INTO white_cards VALUES (18660, 'Fifi the dancing poodle', 'KHAOS');
INSERT INTO white_cards VALUES (18661, 'Wal-Mart', 'KHAOS');
INSERT INTO white_cards VALUES (18662, 'Rape culture', 'KHAOS');
INSERT INTO white_cards VALUES (18663, 'Cultural misappropriation', 'KHAOS');
INSERT INTO white_cards VALUES (18664, 'Soggy biscuit', 'KHAOS');
INSERT INTO white_cards VALUES (18665, 'A gang of bikers', 'KHAOS');
INSERT INTO white_cards VALUES (18666, 'Cake', 'KHAOS');
INSERT INTO white_cards VALUES (18667, 'Lice', 'KHAOS');
INSERT INTO white_cards VALUES (18668, 'The walk of shame', 'KHAOS');
INSERT INTO white_cards VALUES (18669, 'Rough trade', 'KHAOS');
INSERT INTO white_cards VALUES (16981, 'A poisson distribution', 'xkcd');
INSERT INTO white_cards VALUES (16982, 'An apple infused with tin', 'xkcd');
INSERT INTO white_cards VALUES (16983, 'A ferret with wings strapped on', 'xkcd');
INSERT INTO white_cards VALUES (16984, 'Taking a fourier transform of your cat', 'xkcd');
INSERT INTO white_cards VALUES (16985, 'The red spiders', 'xkcd');
INSERT INTO white_cards VALUES (16986, 'A malaria party', 'xkcd');
INSERT INTO white_cards VALUES (16987, 'The square root of lov', 'xkcd');
INSERT INTO white_cards VALUES (16988, 'Orion''s penis', 'xkcd');
INSERT INTO white_cards VALUES (16989, 'The Bellman-Ford algorithm', 'xkcd');
INSERT INTO white_cards VALUES (16990, 'Only knowing music from Guitar Hero', 'xkcd');
INSERT INTO white_cards VALUES (16991, 'Feeding rocks to children', 'xkcd');
INSERT INTO white_cards VALUES (16992, 'Poking small holes in noodle cups', 'xkcd');
INSERT INTO white_cards VALUES (16993, 'Zeppelins', 'xkcd');
INSERT INTO white_cards VALUES (16994, 'Mixing curse levels', 'xkcd');
INSERT INTO white_cards VALUES (16995, 'Going out in a blaze of Dadaist glory', 'xkcd');
INSERT INTO white_cards VALUES (16996, 'Answering casual questions in Iambic Pentameter', 'xkcd');
INSERT INTO white_cards VALUES (16997, 'An inexorably advancing wall of ice', 'xkcd');
INSERT INTO white_cards VALUES (16998, 'Raptor attacks', 'xkcd');
INSERT INTO white_cards VALUES (16999, 'Getting Jeremy Irons to do your dialogue', 'xkcd');
INSERT INTO white_cards VALUES (17000, 'Sending strange things through the mail', 'xkcd');
INSERT INTO white_cards VALUES (17001, 'The RJX-21 Laser Scope', 'xkcd');
INSERT INTO white_cards VALUES (17002, 'Moral Relativity', 'xkcd');
INSERT INTO white_cards VALUES (17003, 'Snakes on Every Plane!', 'xkcd');
INSERT INTO white_cards VALUES (17004, 'A girl whose only mode of transportation is the M.C. Hammer slide', 'xkcd');
INSERT INTO white_cards VALUES (17005, 'Clark Gable''s Tourette''s', 'xkcd');
INSERT INTO white_cards VALUES (17006, 'Vanilla Ice', 'xkcd');
INSERT INTO white_cards VALUES (17007, 'Computational Linguists', 'xkcd');
INSERT INTO white_cards VALUES (17008, 'Cunnilingus', 'xkcd');
INSERT INTO white_cards VALUES (17009, 'A Pong machine that''s self-aware', 'xkcd');
INSERT INTO white_cards VALUES (17010, 'Centrifugal force', 'xkcd');
INSERT INTO white_cards VALUES (17011, 'The elimination of all culture you don''t control', 'xkcd');
INSERT INTO white_cards VALUES (17012, 'Embedded music on MySpace', 'xkcd');
INSERT INTO white_cards VALUES (17013, 'The math of Velociraptors', 'xkcd');
INSERT INTO white_cards VALUES (17014, 'The mathematics of cunnilungus', 'xkcd');
INSERT INTO white_cards VALUES (17015, 'Electric Skateboards', 'xkcd');
INSERT INTO white_cards VALUES (17016, 'Using ''They'' as a third-person singular gender-free pronoun', 'xkcd');
INSERT INTO white_cards VALUES (17017, 'Pronouncing ''Blog'' as ''Blag''', 'xkcd');
INSERT INTO white_cards VALUES (17018, 'Casual use of ''sudo''', 'xkcd');
INSERT INTO white_cards VALUES (17019, 'A human-sized hamster ball', 'xkcd');
INSERT INTO white_cards VALUES (17020, 'An embarrassing search history', 'xkcd');
INSERT INTO white_cards VALUES (17021, 'Commenting out what other people say', 'xkcd');
INSERT INTO white_cards VALUES (100461, 'An origami swan thatâs some kind of symbol?', 'HOCAH');
INSERT INTO white_cards VALUES (100465, 'The sensitive European photographer whoâs fucking my wife.', 'HOCAH');
INSERT INTO white_cards VALUES (100470, 'A much younger woman.', 'HOCAH');
INSERT INTO white_cards VALUES (100455, 'Congress''s flaccid penises withering away beneath their suit pants.', 'HBS');
INSERT INTO white_cards VALUES (100462, 'A homoerotic subplot.', 'HOCAH');
INSERT INTO white_cards VALUES (18777, '"The" Hateboner.', 'RP');
INSERT INTO white_cards VALUES (18778, '(I glances.)', 'RP');
INSERT INTO white_cards VALUES (18779, '(unsure).', 'RP');
INSERT INTO white_cards VALUES (18780, 'Too rad to be cis.', 'RP');
INSERT INTO white_cards VALUES (18781, 'A ''shopped vendetta.', 'RP');
INSERT INTO white_cards VALUES (18782, 'A 5-page-long kink list.', 'RP');
INSERT INTO white_cards VALUES (18783, 'A bouquet of dicks.', 'RP');
INSERT INTO white_cards VALUES (18784, 'A creepy Corruption of Champions OC.', 'RP');
INSERT INTO white_cards VALUES (18785, 'A funny name for Benedict Cumberbatch.', 'RP');
INSERT INTO white_cards VALUES (18786, 'A genderswapped vampire AU Cloud Strife.', 'RP');
INSERT INTO white_cards VALUES (18787, 'A glopping noise.', 'RP');
INSERT INTO white_cards VALUES (18788, 'A misfire.', 'RP');
INSERT INTO white_cards VALUES (18789, 'A paid account full of nothing but terrible fanart icons.', 'RP');
INSERT INTO white_cards VALUES (18790, 'A penis approximately the size and shape of a Guinness can.', 'RP');
INSERT INTO white_cards VALUES (18791, 'A shitty urban fantasy OC.', 'RP');
INSERT INTO white_cards VALUES (18792, 'A spooky jamjar.', 'RP');
INSERT INTO white_cards VALUES (18793, 'A tag so boring it makes you want to delete all of your journals.', 'RP');
INSERT INTO white_cards VALUES (18794, 'A tragic Christmas hang-gliding accident.', 'RP');
INSERT INTO white_cards VALUES (18795, 'Accidental video posts.', 'RP');
INSERT INTO white_cards VALUES (18796, 'Alpha/Beta/Omega.', 'RP');
INSERT INTO white_cards VALUES (18797, 'Amatomnes.', 'RP');
INSERT INTO white_cards VALUES (18798, 'An awful fandom OC who''s married to the main character.', 'RP');
INSERT INTO white_cards VALUES (18799, 'Anonfailing.', 'RP');
INSERT INTO white_cards VALUES (18800, 'Another boring wank about f/f.', 'RP');
INSERT INTO white_cards VALUES (18801, 'Another fucking TFLN meme.', 'RP');
INSERT INTO white_cards VALUES (18802, 'App revisions.', 'RP');
INSERT INTO white_cards VALUES (18803, 'Ataraxion.', 'RP');
INSERT INTO white_cards VALUES (18804, 'Autistic gypsies.', 'RP');
INSERT INTO white_cards VALUES (18805, 'Baby penis.', 'RP');
INSERT INTO white_cards VALUES (18806, 'Bakerstreet.', 'RP');
INSERT INTO white_cards VALUES (18807, 'Begging for asspats.', 'RP');
INSERT INTO white_cards VALUES (18808, 'Being really passive-aggressive because you "don''t wanna hurt anyone''s feelings".', 'RP');
INSERT INTO white_cards VALUES (18809, 'Being soulbonded to a Homestuck character.', 'RP');
INSERT INTO white_cards VALUES (18810, 'Broccoli trees.', 'RP');
INSERT INTO white_cards VALUES (18811, 'Butthurt.', 'RP');
INSERT INTO white_cards VALUES (18812, 'Calling long-distance to demand tags from your RP partner.', 'RP');
INSERT INTO white_cards VALUES (18813, 'Cape and Cowl.', 'RP');
INSERT INTO white_cards VALUES (18814, 'Changed.', 'RP');
INSERT INTO white_cards VALUES (18815, 'Chronic Lyme disease.', 'RP');
INSERT INTO white_cards VALUES (18816, 'Circlejerking.', 'RP');
INSERT INTO white_cards VALUES (18817, 'City of Ariel.', 'RP');
INSERT INTO white_cards VALUES (18818, 'Cloud being eaten by a chocobo.', 'RP');
INSERT INTO white_cards VALUES (18819, 'Cockhopping.', 'RP');
INSERT INTO white_cards VALUES (18820, 'Constructive criticism.', 'RP');
INSERT INTO white_cards VALUES (18821, 'Dangan Ronpa''s crazy fandom.', 'RP');
INSERT INTO white_cards VALUES (18822, 'Dean/Goku.', 'RP');
INSERT INTO white_cards VALUES (18823, 'Dear Mun.', 'RP');
INSERT INTO white_cards VALUES (18824, 'Discedo.', 'RP');
INSERT INTO white_cards VALUES (18825, 'Drama Drama Duck.', 'RP');
INSERT INTO white_cards VALUES (18826, 'Dropping the thread after two tags because it sucks.', 'RP');
INSERT INTO white_cards VALUES (18827, 'ECATS? CAT DESK? WE SCAT?', 'RP');
INSERT INTO white_cards VALUES (18828, 'An incest ship.', 'RP');
INSERT INTO white_cards VALUES (18829, 'Entranceway.', 'RP');
INSERT INTO white_cards VALUES (18830, 'Everyone turning into ponies.', 'RP');
INSERT INTO white_cards VALUES (18831, 'Exit Void.', 'RP');
INSERT INTO white_cards VALUES (18832, 'Exsilium.', 'RP');
INSERT INTO white_cards VALUES (18833, 'FACT IT!', 'RP');
INSERT INTO white_cards VALUES (18834, 'Fad fandoms.', 'RP');
INSERT INTO white_cards VALUES (18835, 'Falling in love with your RP partner.', 'RP');
INSERT INTO white_cards VALUES (18836, 'Feeling like the only one.', 'RP');
INSERT INTO white_cards VALUES (18837, 'Flouncing. The more dramatic, the better.', 'RP');
INSERT INTO white_cards VALUES (18838, 'Fucking that chicken.', 'RP');
INSERT INTO white_cards VALUES (18839, 'Generic white male actor PBs.', 'RP');
INSERT INTO white_cards VALUES (18840, 'Haven.', 'RP');
INSERT INTO white_cards VALUES (18841, 'Hellion.', 'RP');
INSERT INTO white_cards VALUES (18842, 'Hetalia''s annoying fandom.', 'RP');
INSERT INTO white_cards VALUES (18843, 'High Seas.', 'RP');
INSERT INTO white_cards VALUES (18844, 'Highlandering.', 'RP');
INSERT INTO white_cards VALUES (18845, 'Hitting the cervix with your dick.', 'RP');
INSERT INTO white_cards VALUES (18846, 'Holly Heights.', 'RP');
INSERT INTO white_cards VALUES (18847, 'Homestuck''s insane fandom.', 'RP');
INSERT INTO white_cards VALUES (18848, 'Icon elitism.', 'RP');
INSERT INTO white_cards VALUES (18849, 'Icons that aren''t 100x100.', 'RP');
INSERT INTO white_cards VALUES (18850, 'Kink shaming.', 'RP');
INSERT INTO white_cards VALUES (18851, 'Legbeards.', 'RP');
INSERT INTO white_cards VALUES (18852, 'Literally shaking and crying.', 'RP');
INSERT INTO white_cards VALUES (18853, 'lol so randumb!!!!111 XD', 'RP');
INSERT INTO white_cards VALUES (18854, 'Lovingly describing your character''s throbbing cock.', 'RP');
INSERT INTO white_cards VALUES (18855, 'Luceti.', 'RP');
INSERT INTO white_cards VALUES (18856, 'Mpreg.', 'RP');
INSERT INTO white_cards VALUES (18857, 'Musedumping.', 'RP');
INSERT INTO white_cards VALUES (18858, 'Neckbeards.', 'RP');
INSERT INTO white_cards VALUES (18859, 'Needing to lei down.', 'RP');
INSERT INTO white_cards VALUES (18860, 'Not posting deets.', 'RP');
INSERT INTO white_cards VALUES (18861, 'Nymphomanic werewolf Rei Ayanami. On rollerskates.', 'RP');
INSERT INTO white_cards VALUES (18862, 'One-pixel borders.', 'RP');
INSERT INTO white_cards VALUES (18863, 'One-word replies.', 'RP');
INSERT INTO white_cards VALUES (18864, 'Paradisa.', 'RP');
INSERT INTO white_cards VALUES (18865, 'Passive-aggressive editing.', 'RP');
INSERT INTO white_cards VALUES (18866, 'Pigeon superpowers.', 'RP');
INSERT INTO white_cards VALUES (18867, 'Pillow queens.', 'RP');
INSERT INTO white_cards VALUES (18868, 'Only playing for ships.', 'RP');
INSERT INTO white_cards VALUES (18869, 'Polychromatic.', 'RP');
INSERT INTO white_cards VALUES (18870, 'Posting to Wankgate logged in.', 'RP');
INSERT INTO white_cards VALUES (18871, 'Pregnancy plots.', 'RP');
INSERT INTO white_cards VALUES (18872, 'Pretentious, illegible formatting.', 'RP');
INSERT INTO white_cards VALUES (18873, 'Queefing on someone''s dick.', 'RP');
INSERT INTO white_cards VALUES (18874, 'Rebutle.', 'RP');
INSERT INTO white_cards VALUES (18875, 'Renne.', 'RP');
INSERT INTO white_cards VALUES (18876, 'Replying to everyone on ATP because you''re just that desperate.', 'RP');
INSERT INTO white_cards VALUES (18877, 'Reserving a popular character and never apping.', 'RP');
INSERT INTO white_cards VALUES (18878, 'Roleplaying One Direction slash.', 'RP');
INSERT INTO white_cards VALUES (18879, 'Route 29.', 'RP');
INSERT INTO white_cards VALUES (18880, 'Roxanne Ritchie''s vagina.', 'RP');
INSERT INTO white_cards VALUES (18881, 'RPAnons.', 'RP');
INSERT INTO white_cards VALUES (18882, 'Ruby City.', 'RP');
INSERT INTO white_cards VALUES (18883, 'Rushing to dear_mun to post about the latest global tragedy in-character.', 'RP');
INSERT INTO white_cards VALUES (18884, 'St-stuttered t-typing.', 'RP');
INSERT INTO white_cards VALUES (18885, 'Obviously sameanoning.', 'RP');
INSERT INTO white_cards VALUES (18886, 'Sample prompts.', 'RP');
INSERT INTO white_cards VALUES (18887, 'Save The Earth.', 'RP');
INSERT INTO white_cards VALUES (18888, 'Scathing anonymous criticism.', 'RP');
INSERT INTO white_cards VALUES (18889, 'Scrambling to pass AC at the last minute.', 'RP');
INSERT INTO white_cards VALUES (18890, 'Shounen retards.', 'RP');
INSERT INTO white_cards VALUES (18891, 'Signal boosting an obvious hoax.', 'RP');
INSERT INTO white_cards VALUES (18892, 'Slacktivism.', 'RP');
INSERT INTO white_cards VALUES (18893, 'Social justice warriors.', 'RP');
INSERT INTO white_cards VALUES (18894, 'Sora and Emperor Palpatine in an awkward, skeezy relationship.', 'RP');
INSERT INTO white_cards VALUES (18895, 'Springing rape scenarios on people without asking.', 'RP');
INSERT INTO white_cards VALUES (18896, 'Stormy''s latest alias.', 'RP');
INSERT INTO white_cards VALUES (18897, 'Superwholockvengers.', 'RP');
INSERT INTO white_cards VALUES (18898, 'Surprise futa.', 'RP');
INSERT INTO white_cards VALUES (18899, 'Tag nirvana.', 'RP');
INSERT INTO white_cards VALUES (18900, 'Tentabulge headcanons.', 'RP');
INSERT INTO white_cards VALUES (18901, 'Terminal Tokyo.', 'RP');
INSERT INTO white_cards VALUES (18902, 'That Kronk.', 'RP');
INSERT INTO white_cards VALUES (18903, 'That Patchouli.', 'RP');
INSERT INTO white_cards VALUES (18904, 'The Box.', 'RP');
INSERT INTO white_cards VALUES (18905, 'The dominate one.', 'RP');
INSERT INTO white_cards VALUES (18906, 'The Love Hotel.', 'RP');
INSERT INTO white_cards VALUES (18907, 'The medium divide.', 'RP');
INSERT INTO white_cards VALUES (18908, 'The myriad of songs you associate with your OTP.', 'RP');
INSERT INTO white_cards VALUES (18909, 'The paid account fairy.', 'RP');
INSERT INTO white_cards VALUES (18910, 'The Royal Baby.', 'RP');
INSERT INTO white_cards VALUES (18911, 'The Salkia Island award.', 'RP');
INSERT INTO white_cards VALUES (18912, 'The whole game jumping on the villain before they have a chance to be villainous.', 'RP');
INSERT INTO white_cards VALUES (18913, 'TL;DR.', 'RP');
INSERT INTO white_cards VALUES (18914, 'TMI public plurks.', 'RP');
INSERT INTO white_cards VALUES (18915, 'Touhou lesbians nobody wants to play with.', 'RP');
INSERT INTO white_cards VALUES (18916, 'Tower of Animus.', 'RP');
INSERT INTO white_cards VALUES (18917, 'Tryhards.', 'RP');
INSERT INTO white_cards VALUES (18918, 'Tittybabies.', 'RP');
INSERT INTO white_cards VALUES (18919, 'Tumblrinas.', 'RP');
INSERT INTO white_cards VALUES (18920, 'Two lonely neckbeards playing out futa together because nobody else will.', 'RP');
INSERT INTO white_cards VALUES (18921, 'Two years'' worth of semen.', 'RP');
INSERT INTO white_cards VALUES (18922, 'tYPING LIKE THIS???????? oH MY GKFOODODD??????', 'RP');
INSERT INTO white_cards VALUES (18923, 'Unironically using the word "kawaii".', 'RP');
INSERT INTO white_cards VALUES (18924, 'Username elitism.', 'RP');
INSERT INTO white_cards VALUES (18925, 'Username squatting.', 'RP');
INSERT INTO white_cards VALUES (18926, 'Vatheon.', 'RP');
INSERT INTO white_cards VALUES (18927, 'Viewing anoncomms in flat-view like a heathen.', 'RP');
INSERT INTO white_cards VALUES (18928, 'Visualosities.', 'RP');
INSERT INTO white_cards VALUES (18929, 'Wank terriers.', 'RP');
INSERT INTO white_cards VALUES (18930, 'Wankgate.', 'RP');
INSERT INTO white_cards VALUES (18931, 'Wanking about games you aren''t in.', 'RP');
INSERT INTO white_cards VALUES (18932, 'Wanking about a private musebox.', 'RP');
INSERT INTO white_cards VALUES (18933, 'wgar.', 'RP');
INSERT INTO white_cards VALUES (18934, 'Whiteknighting.', 'RP');
INSERT INTO white_cards VALUES (18935, 'Whoremongers.', 'RP');
INSERT INTO white_cards VALUES (18936, 'Wrapping your hands around a penis and twisting in opposite directions.', 'RP');
INSERT INTO white_cards VALUES (18937, 'Yaoi.', 'RP');
INSERT INTO white_cards VALUES (18938, 'Zodion.', 'RP');
INSERT INTO white_cards VALUES (18939, 'Verka Serduchka.', 'ESC');
INSERT INTO white_cards VALUES (18940, 'Cezar Ouatu, his opera falsetto voice, his lifting dress and his naked dancers.', 'ESC');
INSERT INTO white_cards VALUES (18941, 'EUUUUUUPHOOOORIAAAA.', 'ESC');
INSERT INTO white_cards VALUES (18942, 'Loreen''s hammertime dance.', 'ESC');
INSERT INTO white_cards VALUES (18943, 'Ruslana''s vast array of animals she may or may not have slain with her bare hands.', 'ESC');
INSERT INTO white_cards VALUES (18944, 'Alexander Rybak.', 'ESC');
INSERT INTO white_cards VALUES (18945, 'Eldar Gasimov''s stone cold,, dead eyes.', 'ESC');
INSERT INTO white_cards VALUES (18946, 'The Eurovision Song Contest.', 'ESC');
INSERT INTO white_cards VALUES (18947, 'Loreen Talhaoui.', 'ESC');
INSERT INTO white_cards VALUES (18948, 'Epic Sax Guy.', 'ESC');
INSERT INTO white_cards VALUES (18949, 'Not being Jedward.', 'ESC');
INSERT INTO white_cards VALUES (18950, 'Lena Meyer-Landrut.', 'ESC');
INSERT INTO white_cards VALUES (18951, 'Helena Paparizou breathing a sigh of relief that she didn''t win during the economic crisis.', 'ESC');
INSERT INTO white_cards VALUES (18952, 'Emmelie de Forest''s big doe-eyed look.', 'ESC');
INSERT INTO white_cards VALUES (18953, 'ZELJKO YOU CHEAAAAAT.', 'ESC');
INSERT INTO white_cards VALUES (18954, 'Lordi''s entire army of makeup artists.', 'ESC');
INSERT INTO white_cards VALUES (18955, 'Malena Ernman''s massive arms.', 'ESC');
INSERT INTO white_cards VALUES (18956, 'The shock and anger you feel when your neighbour doesn''t give you 12 points.', 'ESC');
INSERT INTO white_cards VALUES (18957, 'Showing you the Maiden Tower 15 times.', 'ESC');
INSERT INTO white_cards VALUES (18958, 'The ABBApocalypse.', 'ESC');
INSERT INTO white_cards VALUES (100456, 'The royal afterbirth.', 'HBS');
INSERT INTO white_cards VALUES (100457, 'Having a strong opinion about Obamacare.', 'HBS');
INSERT INTO white_cards VALUES (100463, 'Forcing a handjob on a dying man. ', 'HOCAH');
INSERT INTO white_cards VALUES (100464, 'Ribs so good they transcend race and class.', 'HOCAH');
INSERT INTO white_cards VALUES (100466, 'Carbon monoxide poisoning. ', 'HOCAH');
INSERT INTO white_cards VALUES (100475, 'Punching a congressman in the face.', 'HOCAH');
INSERT INTO white_cards VALUES (100467, 'Discharging a firearm in a residential area.', 'HOCAH');
INSERT INTO white_cards VALUES (100472, 'Strangling a dog to make a point to the audience.', 'HOCAH');
INSERT INTO white_cards VALUES (100473, 'A childless marriage.', 'HOCAH');
INSERT INTO white_cards VALUES (100468, 'Getting eaten out while on the phone with Dad.', 'HOCAH');
INSERT INTO white_cards VALUES (100469, 'Making it look like a suicide.', 'HOCAH');
INSERT INTO white_cards VALUES (100471, 'An older man.', 'HOCAH');
INSERT INTO white_cards VALUES (100474, 'My constituents.', 'HOCAH');
INSERT INTO white_cards VALUES (18168, '... . .-. . -. .. - -.—  (Serenity)', 'MSPA');
INSERT INTO white_cards VALUES (18169, 'Rails with pails.', 'MSPA');
INSERT INTO white_cards VALUES (18170, '"Apple Juice."', 'MSPA');
INSERT INTO white_cards VALUES (18171, 'The 7th Gate.', 'MSPA');
INSERT INTO white_cards VALUES (18172, 'Accidentally touching Gamze''s enormous codpiece.', 'MSPA');
INSERT INTO white_cards VALUES (18173, 'An acrobatic fucking pirouette.', 'MSPA');
INSERT INTO white_cards VALUES (18174, 'Alternian fine art.', 'MSPA');
INSERT INTO white_cards VALUES (18175, 'Alternian rainbow-drinker romance novels.', 'MSPA');
INSERT INTO white_cards VALUES (18176, 'Andrew Hussie.', 'MSPA');
INSERT INTO white_cards VALUES (18177, 'Andrew Hussie''s lips.', 'MSPA');
INSERT INTO white_cards VALUES (18178, 'The animes.', 'MSPA');
INSERT INTO white_cards VALUES (18179, 'Anonymous Soporifics Support.', 'MSPA');
INSERT INTO white_cards VALUES (18180, 'Apple Juice.', 'MSPA');
INSERT INTO white_cards VALUES (18181, 'Aradia Bot.', 'MSPA');
INSERT INTO white_cards VALUES (18182, 'Aradia Megido.', 'MSPA');
INSERT INTO white_cards VALUES (18183, 'Aradia''s charred, rotting corpse.', 'MSPA');
INSERT INTO white_cards VALUES (18184, 'Aranea Serket.', 'MSPA');
INSERT INTO white_cards VALUES (18185, 'Aranea''s exposition stand.', 'MSPA');
INSERT INTO white_cards VALUES (18186, 'Arguing over troll sexuality.', 'MSPA');
INSERT INTO white_cards VALUES (18187, 'ARquiusprite''s muscles.', 'MSPA');
INSERT INTO white_cards VALUES (18188, 'Arthour the lusus.', 'MSPA');
INSERT INTO white_cards VALUES (18189, 'AVATAR.', 'MSPA');
INSERT INTO white_cards VALUES (18190, 'Baby Dave.', 'MSPA');
INSERT INTO white_cards VALUES (18191, 'Bard Quest.', 'MSPA');
INSERT INTO white_cards VALUES (18192, 'Bec Noir.', 'MSPA');
INSERT INTO white_cards VALUES (18193, 'Becoming Tumblr famous.', 'MSPA');
INSERT INTO white_cards VALUES (18194, 'Being fuck deep in meowcats.', 'MSPA');
INSERT INTO white_cards VALUES (18195, 'Being in a relationship with a non-Homestuck.', 'MSPA');
INSERT INTO white_cards VALUES (18196, 'Being locked in a Prospitian prison.', 'MSPA');
INSERT INTO white_cards VALUES (18197, 'Being the other guy.', 'MSPA');
INSERT INTO white_cards VALUES (18198, 'BETTY FUCKING CROCKER.', 'MSPA');
INSERT INTO white_cards VALUES (18199, 'Binge reading every fanfiction for a pairing and then hating yourself a little bit.', 'MSPA');
INSERT INTO white_cards VALUES (18200, 'BL1ND JUST1C3.', 'MSPA');
INSERT INTO white_cards VALUES (18201, 'Blackrom orgies.', 'MSPA');
INSERT INTO white_cards VALUES (18202, 'Bro and Dave banging while Rose watches.', 'MSPA');
INSERT INTO white_cards VALUES (18203, 'Bro.', 'MSPA');
INSERT INTO white_cards VALUES (18204, 'Bro''s rapping ventriloquism act.', 'MSPA');
INSERT INTO white_cards VALUES (18205, 'Bro''s death.', 'MSPA');
INSERT INTO white_cards VALUES (18206, 'BUCKETS.', 'MSPA');
INSERT INTO white_cards VALUES (18207, 'A bull penis cane.', 'MSPA');
INSERT INTO white_cards VALUES (18208, 'Butler Island.', 'MSPA');
INSERT INTO white_cards VALUES (18209, 'C4NDY R3D BLOOD &gt;:]', 'MSPA');
INSERT INTO white_cards VALUES (18210, 'Caledscratch.', 'MSPA');
INSERT INTO white_cards VALUES (18211, 'Caliborn.', 'MSPA');
INSERT INTO white_cards VALUES (18212, 'Caliginous speed dating.', 'MSPA');
INSERT INTO white_cards VALUES (18213, 'Calliope.', 'MSPA');
INSERT INTO white_cards VALUES (18214, 'Can Town.', 'MSPA');
INSERT INTO white_cards VALUES (18215, 'Cards Against Alternia.', 'MSPA');
INSERT INTO white_cards VALUES (18216, 'Carlos Maraka.', 'MSPA');
INSERT INTO white_cards VALUES (18217, 'Casey.', 'MSPA');
INSERT INTO white_cards VALUES (18218, 'Centaur milk.', 'MSPA');
INSERT INTO white_cards VALUES (18219, 'Charging down halls, shouting profanities and being silly.', 'MSPA');
INSERT INTO white_cards VALUES (18220, 'Cherub m-preg.', 'MSPA');
INSERT INTO white_cards VALUES (18221, 'Cherub mating rituals.', 'MSPA');
INSERT INTO white_cards VALUES (18222, 'Chest of WHIMSY.', 'MSPA');
INSERT INTO white_cards VALUES (18223, 'A chip in your heart that forces you to love.', 'MSPA');
INSERT INTO white_cards VALUES (18224, 'Cliched JohnKat fanfiction.', 'MSPA');
INSERT INTO white_cards VALUES (18225, 'Cod Palace.', 'MSPA');
INSERT INTO white_cards VALUES (18226, 'Cod Tier Gamzee.', 'MSPA');
INSERT INTO white_cards VALUES (18227, 'Communism!', 'MSPA');
INSERT INTO white_cards VALUES (18228, 'The Condesce''s crotch.', 'MSPA');
INSERT INTO white_cards VALUES (18229, 'The Condesce''s selfies.', 'MSPA');
INSERT INTO white_cards VALUES (18230, 'Constantly breaking Hussie''s copyright.', 'MSPA');
INSERT INTO white_cards VALUES (18231, 'Cosplay sex.', 'MSPA');
INSERT INTO white_cards VALUES (18232, 'Cosplayers who do photo shoots in bondage (God bless them).', 'MSPA');
INSERT INTO white_cards VALUES (18233, 'Cosplayers who don''t seal their paint.', 'MSPA');
INSERT INTO white_cards VALUES (18234, 'Crabdad.', 'MSPA');
INSERT INTO white_cards VALUES (18235, 'Creative uses for Aradia''s whip.', 'MSPA');
INSERT INTO white_cards VALUES (18236, 'Cronus Ampora.', 'MSPA');
INSERT INTO white_cards VALUES (18237, 'Dad Egbert/Dad Crocker.', 'MSPA');
INSERT INTO white_cards VALUES (18238, 'Dad''s pipe.', 'MSPA');
INSERT INTO white_cards VALUES (18239, 'Dad''s fedora.', 'MSPA');
INSERT INTO white_cards VALUES (18240, 'Damara Megido wearing white at her wedding.', 'MSPA');
INSERT INTO white_cards VALUES (18241, 'Damara Megido.', 'MSPA');
INSERT INTO white_cards VALUES (18242, 'Damara Megido''s existence.', 'MSPA');
INSERT INTO white_cards VALUES (18243, 'Dante Basco.', 'MSPA');
INSERT INTO white_cards VALUES (18244, 'Dating exclusively within the fandom.', 'MSPA');
INSERT INTO white_cards VALUES (18245, 'Dave Strider.', 'MSPA');
INSERT INTO white_cards VALUES (18246, 'Dave''s throbbing beef truncheon.', 'MSPA');
INSERT INTO white_cards VALUES (18247, 'A dead Ms. Paint.', 'MSPA');
INSERT INTO white_cards VALUES (18248, 'Destroying clocks.', 'MSPA');
INSERT INTO white_cards VALUES (18249, 'Developing a deep fear of the sound of clown horns after becoming a Homestuck.', 'MSPA');
INSERT INTO white_cards VALUES (18250, 'The Dildo of Oglogoth.', 'MSPA');
INSERT INTO white_cards VALUES (18251, 'Dirk Strider.', 'MSPA');
INSERT INTO white_cards VALUES (18252, 'Dirk''s self-insert MLP fan character.', 'MSPA');
INSERT INTO white_cards VALUES (18253, 'The Disciple.', 'MSPA');
INSERT INTO white_cards VALUES (18254, 'Discovering Sollux is red-blue colorblind.', 'MSPA');
INSERT INTO white_cards VALUES (18255, 'Doc Scratch.', 'MSPA');
INSERT INTO white_cards VALUES (18256, 'The Dolorosa.', 'MSPA');
INSERT INTO white_cards VALUES (18257, 'A dominant Kankri.', 'MSPA');
INSERT INTO white_cards VALUES (18258, 'Drawing pornography for Caliborn.', 'MSPA');
INSERT INTO white_cards VALUES (18259, 'The E%ecutor/Expatri8 Darkleer.', 'MSPA');
INSERT INTO white_cards VALUES (18260, 'Elf tears.', 'MSPA');
INSERT INTO white_cards VALUES (18261, 'Equius Zahhak.', 'MSPA');
INSERT INTO white_cards VALUES (18262, 'Equius''s choice ass.', 'MSPA');
INSERT INTO white_cards VALUES (18263, 'Equius''s copy of "Fifty Shades of Neigh."', 'MSPA');
INSERT INTO white_cards VALUES (18264, 'Equius''s towel.', 'MSPA');
INSERT INTO white_cards VALUES (18265, 'Equius''s used towel pile.', 'MSPA');
INSERT INTO white_cards VALUES (18266, 'Eridan Ampora.', 'MSPA');
INSERT INTO white_cards VALUES (18267, 'Eridan crying after pailing Vriska for the first time.', 'MSPA');
INSERT INTO white_cards VALUES (18268, 'Eridan stripping to make rent.', 'MSPA');
INSERT INTO white_cards VALUES (18269, 'Eridan''s cape.', 'MSPA');
INSERT INTO white_cards VALUES (18270, 'Eridan''s empty quadrants.', 'MSPA');
INSERT INTO white_cards VALUES (18271, 'Eridan''s lowwer half.', 'MSPA');
INSERT INTO white_cards VALUES (18272, 'Eridan''s upper half.', 'MSPA');
INSERT INTO white_cards VALUES (18273, 'The Exiles.', 'MSPA');
INSERT INTO white_cards VALUES (18274, 'Fat Vriska.', 'MSPA');
INSERT INTO white_cards VALUES (18275, 'Faygo.', 'MSPA');
INSERT INTO white_cards VALUES (18276, 'Feferi Peixes.', 'MSPA');
INSERT INTO white_cards VALUES (18277, 'The Felt.', 'MSPA');
INSERT INTO white_cards VALUES (18278, 'Fiduspawn.', 'MSPA');
INSERT INTO white_cards VALUES (18279, 'Fifty fucking Nepetas.', 'MSPA');
INSERT INTO white_cards VALUES (18280, 'Filling all of your quadrants.', 'MSPA');
INSERT INTO white_cards VALUES (18281, 'Finding grey paint on your bathroom door three weeks after the last meetup.', 'MSPA');
INSERT INTO white_cards VALUES (18282, 'A five minute video of Cronus giving Kankri a blowjob.', 'MSPA');
INSERT INTO white_cards VALUES (18283, 'Flighty broads.', 'MSPA');
INSERT INTO white_cards VALUES (18284, 'Flipping the fuck out.', 'MSPA');
INSERT INTO white_cards VALUES (18285, 'Game Bro Magazine.', 'MSPA');
INSERT INTO white_cards VALUES (18286, 'Gamzee Makara.', 'MSPA');
INSERT INTO white_cards VALUES (18287, 'Gamzee''s clown horns.', 'MSPA');
INSERT INTO white_cards VALUES (18288, 'gAmZeE''S pOtIoNs: 420 bOoNbUcKs.', 'MSPA');
INSERT INTO white_cards VALUES (18289, 'Geromy.', 'MSPA');
INSERT INTO white_cards VALUES (18290, 'Gl''bgolyb. AKA Feferi''s fucking lusus.', 'MSPA');
INSERT INTO white_cards VALUES (18291, 'The glory that is BroJohn.', 'MSPA');
INSERT INTO white_cards VALUES (18292, 'Going to the bark side.', 'MSPA');
INSERT INTO white_cards VALUES (18293, 'The Grand Highblood.', 'MSPA');
INSERT INTO white_cards VALUES (18294, 'Grandpa Harley/Grandma English.', 'MSPA');
INSERT INTO white_cards VALUES (18295, 'The Great Hiatus of 2013.', 'MSPA');
INSERT INTO white_cards VALUES (18296, 'The green sun.', 'MSPA');
INSERT INTO white_cards VALUES (18297, 'Grimbark Jade.', 'MSPA');
INSERT INTO white_cards VALUES (18298, 'Groincobblers.', 'MSPA');
INSERT INTO white_cards VALUES (18299, 'Gross misinterpretations of your favorite character.', 'MSPA');
INSERT INTO white_cards VALUES (18300, 'The guy who fingered an Ampora.', 'MSPA');
INSERT INTO white_cards VALUES (18301, 'The Handmaid.', 'MSPA');
INSERT INTO white_cards VALUES (18302, 'Hateclown on the side.', 'MSPA');
INSERT INTO white_cards VALUES (18303, 'Having STRONG surprise buttsex.', 'MSPA');
INSERT INTO white_cards VALUES (18304, 'Hellmurder Island.', 'MSPA');
INSERT INTO white_cards VALUES (18305, 'The hemospectrum.', 'MSPA');
INSERT INTO white_cards VALUES (18306, 'Hemostuck.', 'MSPA');
INSERT INTO white_cards VALUES (18307, 'Her Imperious Condescenscion.', 'MSPA');
INSERT INTO white_cards VALUES (18308, 'Her Imperious Condescension''s royal butt-plug collection.', 'MSPA');
INSERT INTO white_cards VALUES (18309, 'The Hilarocaust.', 'MSPA');
INSERT INTO white_cards VALUES (18310, 'Homesmut Voices.', 'MSPA');
INSERT INTO white_cards VALUES (18311, 'The Homestuck drinking game (do a shot every time someone dies!)', 'MSPA');
INSERT INTO white_cards VALUES (18312, 'Homestuck stealing all the fans from Hetalia and then subsequently watching all its fans leave for OFF and Danganronpa.', 'MSPA');
INSERT INTO white_cards VALUES (18313, 'Homestuck.', 'MSPA');
INSERT INTO white_cards VALUES (18314, 'Homosuck.', 'MSPA');
INSERT INTO white_cards VALUES (18315, 'HONK HONK, MOTHER FUCKER.', 'MSPA');
INSERT INTO white_cards VALUES (18316, 'Horsearoni.', 'MSPA');
INSERT INTO white_cards VALUES (18317, 'Horuss Zahhak.', 'MSPA');
INSERT INTO white_cards VALUES (18318, 'Hunk Rump Magazine.', 'MSPA');
INSERT INTO white_cards VALUES (18319, 'Hussie constantly breaking copyright and then telling his fans to not break his copyright.', 'MSPA');
INSERT INTO white_cards VALUES (18320, 'Hussie constantly breaking copyright.', 'MSPA');
INSERT INTO white_cards VALUES (18321, 'Hussie jacking it to our tears of anguish.', 'MSPA');
INSERT INTO white_cards VALUES (18322, 'The Insane Clown Posse.', 'MSPA');
INSERT INTO white_cards VALUES (18323, 'Jade Harley.', 'MSPA');
INSERT INTO white_cards VALUES (18324, 'Jade''s dog penis and knot.', 'MSPA');
INSERT INTO white_cards VALUES (18325, 'Jailbreak.', 'MSPA');
INSERT INTO white_cards VALUES (18326, 'Jake English.', 'MSPA');
INSERT INTO white_cards VALUES (18327, 'Jake English''s assless chaps.', 'MSPA');
INSERT INTO white_cards VALUES (18328, 'Jake English''s choice ass.', 'MSPA');
INSERT INTO white_cards VALUES (18329, 'Jake English''s manhood.', 'MSPA');
INSERT INTO white_cards VALUES (18330, 'Jane Crocker.', 'MSPA');
INSERT INTO white_cards VALUES (18331, 'John Egbert.', 'MSPA');
INSERT INTO white_cards VALUES (18332, 'John''s Prankster''s Gambit.', 'MSPA');
INSERT INTO white_cards VALUES (18333, 'Just KNOWING that Slick is going to stab Ms. Paint.', 'MSPA');
INSERT INTO white_cards VALUES (18334, 'Kanaya destroying Cantown.', 'MSPA');
INSERT INTO white_cards VALUES (18335, 'Kanaya Maryam.', 'MSPA');
INSERT INTO white_cards VALUES (18336, 'Kanaya''s ashen promiscuity.', 'MSPA');
INSERT INTO white_cards VALUES (18337, 'Kanaya''s chainsaw.', 'MSPA');
INSERT INTO white_cards VALUES (18338, 'Kankri Vantas.', 'MSPA');
INSERT INTO white_cards VALUES (18339, 'Karkat actually topping, for once.', 'MSPA');
INSERT INTO white_cards VALUES (18340, 'Karkat and Jade''s adorable little of mpreg puppies.', 'MSPA');
INSERT INTO white_cards VALUES (18341, 'Karkat dying of a burst blood vessel mid-rant.', 'MSPA');
INSERT INTO white_cards VALUES (18342, 'Karkat going through puberty before every other troll and being, like, nine feet tall.', 'MSPA');
INSERT INTO white_cards VALUES (18343, 'Karkat Tantrum Bingo.', 'MSPA');
INSERT INTO white_cards VALUES (18344, 'Karkat Vantas.', 'MSPA');
INSERT INTO white_cards VALUES (18345, 'Karkat''s ragegasm.', 'MSPA');
INSERT INTO white_cards VALUES (18346, 'Kawaii Yaoi.', 'MSPA');
INSERT INTO white_cards VALUES (18347, 'Kurloz Makara.', 'MSPA');
INSERT INTO white_cards VALUES (18348, 'Lame bucket jokes.', 'MSPA');
INSERT INTO white_cards VALUES (18349, 'Latula Pyrope.', 'MSPA');
INSERT INTO white_cards VALUES (18350, 'Laying back and thinking of Alternia.', 'MSPA');
INSERT INTO white_cards VALUES (18351, 'Leprechaun m-preg.', 'MSPA');
INSERT INTO white_cards VALUES (18352, 'Liberty. Reason. Justice. Civility. Edification. Perfection. MAIL.', 'MSPA');
INSERT INTO white_cards VALUES (18353, 'Lil'' Cal''s dead eyes.', 'MSPA');
INSERT INTO white_cards VALUES (18354, 'Lil'' Cal.', 'MSPA');
INSERT INTO white_cards VALUES (18355, 'Lil'' Cal''s raging boner.', 'MSPA');
INSERT INTO white_cards VALUES (18356, 'Lil'' Hal.', 'MSPA');
INSERT INTO white_cards VALUES (18357, 'Lil'' Seb.', 'MSPA');
INSERT INTO white_cards VALUES (18358, 'Little children who poop hard in their baby ass diapers.', 'MSPA');
INSERT INTO white_cards VALUES (18359, 'The little red arm-swingy-dealy thing or whatever it is called.', 'MSPA');
INSERT INTO white_cards VALUES (18360, 'Lord English.', 'MSPA');
INSERT INTO white_cards VALUES (18361, 'Lord English''s peg leg.', 'MSPA');
INSERT INTO white_cards VALUES (18362, 'Lucky Charms.', 'MSPA');
INSERT INTO white_cards VALUES (18363, 'Maid Equius.', 'MSPA');
INSERT INTO white_cards VALUES (18364, 'Maple Hoof.', 'MSPA');
INSERT INTO white_cards VALUES (18365, 'March Eridan.', 'MSPA');
INSERT INTO white_cards VALUES (18366, 'The Marquise Spinneret Mindfang.', 'MSPA');
INSERT INTO white_cards VALUES (18367, 'Masturbating while thinking of your OTP.', 'MSPA');
INSERT INTO white_cards VALUES (18368, 'Maxing out your credit cards to buy Homestuck merchandise.', 'MSPA');
INSERT INTO white_cards VALUES (18369, 'The Mayor.', 'MSPA');
INSERT INTO white_cards VALUES (18370, 'Meenah Piexes.', 'MSPA');
INSERT INTO white_cards VALUES (18371, 'The mere concept of the Olive Garden.', 'MSPA');
INSERT INTO white_cards VALUES (18372, 'Meulin Leijon.', 'MSPA');
INSERT INTO white_cards VALUES (18373, 'The Midnight Crew.', 'MSPA');
INSERT INTO white_cards VALUES (18374, 'Mierfa Durgas.', 'MSPA');
INSERT INTO white_cards VALUES (18375, 'Mierfa Durgas'' troll-horn nunchakus.', 'MSPA');
INSERT INTO white_cards VALUES (18376, 'A mighty wwizard of wwhite science.', 'MSPA');
INSERT INTO white_cards VALUES (18377, 'Mind honey.', 'MSPA');
INSERT INTO white_cards VALUES (18378, 'Mister Dude, Sir Brah, Dood Dude, Vitamin D, Dude Esquire.', 'MSPA');
INSERT INTO white_cards VALUES (18379, 'Mituna Captor.', 'MSPA');
INSERT INTO white_cards VALUES (18380, 'Mom.', 'MSPA');
INSERT INTO white_cards VALUES (18381, 'MS Paint Adventures.', 'MSPA');
INSERT INTO white_cards VALUES (18382, 'Murdering angels.', 'MSPA');
INSERT INTO white_cards VALUES (18383, 'Muscle beasts.', 'MSPA');
INSERT INTO white_cards VALUES (18384, 'My Little Hoofbeast: Moirailigence Is Magic.', 'MSPA');
INSERT INTO white_cards VALUES (18385, 'Nektan Whelan.', 'MSPA');
INSERT INTO white_cards VALUES (18386, 'Neophyte Redglare.', 'MSPA');
INSERT INTO white_cards VALUES (18387, 'Nepeta Leijon.', 'MSPA');
INSERT INTO white_cards VALUES (18388, 'Nepeta''s heat cycle.', 'MSPA');
INSERT INTO white_cards VALUES (18389, 'Nepeta''s shipping chart.', 'MSPA');
INSERT INTO white_cards VALUES (18390, 'Never being able to look at apple juice, milk, buckets, or knitting needles without feeling a little bit uncormfortable.', 'MSPA');
INSERT INTO white_cards VALUES (18391, 'Never dating a Serket.', 'MSPA');
INSERT INTO white_cards VALUES (18392, 'Nic Cage saying "boner."', 'MSPA');
INSERT INTO white_cards VALUES (18393, 'A Nicolas Cage body pillow.', 'MSPA');
INSERT INTO white_cards VALUES (18394, 'Noping the fuck out of there.', 'MSPA');
INSERT INTO white_cards VALUES (18395, 'Not shipping it.', 'MSPA');
INSERT INTO white_cards VALUES (18396, 'Only cosplaying male characters when you get pregnant.', 'MSPA');
INSERT INTO white_cards VALUES (18397, 'The Orphaner Dualscar.', 'MSPA');
INSERT INTO white_cards VALUES (18398, 'Overtaking entire conventions.', 'MSPA');
INSERT INTO white_cards VALUES (18399, 'A painting of a horse attacking a football player.', 'MSPA');
INSERT INTO white_cards VALUES (18400, 'PantsKat.', 'MSPA');
INSERT INTO white_cards VALUES (18401, 'Paradox slime.', 'MSPA');
INSERT INTO white_cards VALUES (18402, 'Petstuck.', 'MSPA');
INSERT INTO white_cards VALUES (18403, 'PipeFan413.', 'MSPA');
INSERT INTO white_cards VALUES (18404, 'Plush Rump Magazine.', 'MSPA');
INSERT INTO white_cards VALUES (18405, 'Plush rump.', 'MSPA');
INSERT INTO white_cards VALUES (18406, 'Porrim Maryam.', 'MSPA');
INSERT INTO white_cards VALUES (18407, 'Porrim''s condom stash.', 'MSPA');
INSERT INTO white_cards VALUES (18408, 'Porrim''s motherly affections.', 'MSPA');
INSERT INTO white_cards VALUES (18409, 'Post-apocalyptic shroudwear.', 'MSPA');
INSERT INTO white_cards VALUES (18410, 'Problem Sleuth.', 'MSPA');
INSERT INTO white_cards VALUES (18411, 'The Psiionic.', 'MSPA');
INSERT INTO white_cards VALUES (18412, 'A rapist cuttlefish.', 'MSPA');
INSERT INTO white_cards VALUES (18413, 'Recuperacoon.', 'MSPA');
INSERT INTO white_cards VALUES (18414, 'The ridiculous fact that some people communicate without luminous rear ends.', 'MSPA');
INSERT INTO white_cards VALUES (18415, 'Rose and Kanaya snuggling.', 'MSPA');
INSERT INTO white_cards VALUES (18416, 'Rose Lalonde.', 'MSPA');
INSERT INTO white_cards VALUES (18417, 'Rose telling John she''s a lesbian and they will never be together.', 'MSPA');
INSERT INTO white_cards VALUES (18418, 'Rose''s review of "My Immortal."', 'MSPA');
INSERT INTO white_cards VALUES (18419, 'Roxy Lalonde.', 'MSPA');
INSERT INTO white_cards VALUES (18420, 'Rufio.', 'MSPA');
INSERT INTO white_cards VALUES (18421, 'Rufioh Nitram.', 'MSPA');
INSERT INTO white_cards VALUES (18422, 'Sacred leggings.', 'MSPA');
INSERT INTO white_cards VALUES (18423, 'SBAHJ hentai doujinshi.', 'MSPA');
INSERT INTO white_cards VALUES (18424, 'Schrödinger''s Nepeta.', 'MSPA');
INSERT INTO white_cards VALUES (18425, 'SCIENCE WAND!', 'MSPA');
INSERT INTO white_cards VALUES (18426, 'Seadweller dick fins.', 'MSPA');
INSERT INTO white_cards VALUES (18427, 'Shippers.', 'MSPA');
INSERT INTO white_cards VALUES (18428, 'Shipping it.', 'MSPA');
INSERT INTO white_cards VALUES (18429, 'The Shipping Olympics.', 'MSPA');
INSERT INTO white_cards VALUES (18430, 'Shipping the fuck out of something.', 'MSPA');
INSERT INTO white_cards VALUES (18431, 'Ships ending in -cest.', 'MSPA');
INSERT INTO white_cards VALUES (18432, 'Shitty swords.', 'MSPA');
INSERT INTO white_cards VALUES (18433, 'Shopping with Terezi.', 'MSPA');
INSERT INTO white_cards VALUES (18434, 'Sick fires.', 'MSPA');
INSERT INTO white_cards VALUES (18435, 'The significant purposes, biologically speaking, of troll nipples.', 'MSPA');
INSERT INTO white_cards VALUES (18436, 'Skipping to Act 5.', 'MSPA');
INSERT INTO white_cards VALUES (18437, 'The slammer.', 'MSPA');
INSERT INTO white_cards VALUES (18438, 'A slaughtered sperm whale.', 'MSPA');
INSERT INTO white_cards VALUES (18439, 'Sleeping ten people to a room at conventions.', 'MSPA');
INSERT INTO white_cards VALUES (18440, 'Sloppy inter-species makeouts.', 'MSPA');
INSERT INTO white_cards VALUES (18441, 'A smuppet in Dirk''s pants.', 'MSPA');
INSERT INTO white_cards VALUES (18442, 'Smuppets.', 'MSPA');
INSERT INTO white_cards VALUES (18443, 'Sobbing uncontrollably while reading fanfiction.', 'MSPA');
INSERT INTO white_cards VALUES (18444, 'Sollux Captor.', 'MSPA');
INSERT INTO white_cards VALUES (18445, 'Sollux''s bifurcated bone bulge.', 'MSPA');
INSERT INTO white_cards VALUES (18446, 'Sopor pies.', 'MSPA');
INSERT INTO white_cards VALUES (18447, 'SORD.', 'MSPA');
INSERT INTO white_cards VALUES (18448, 'Soul portraits.', 'MSPA');
INSERT INTO white_cards VALUES (18449, 'Species-swap fanfics.', 'MSPA');
INSERT INTO white_cards VALUES (18450, 'Spidermom.', 'MSPA');
INSERT INTO white_cards VALUES (18451, 'Staying up to three AM, cleaning the grey off every surface of your hotel room in a desperate bid to not get fined.', 'MSPA');
INSERT INTO white_cards VALUES (18452, 'Stealing Tavros''s wheelchair.', 'MSPA');
INSERT INTO white_cards VALUES (18453, 'A Strider sandwich.', 'MSPA');
INSERT INTO white_cards VALUES (18454, 'Stridercest.', 'MSPA');
INSERT INTO white_cards VALUES (18455, 'The Sufferer/The Signless.', 'MSPA');
INSERT INTO white_cards VALUES (18456, 'Sugoi Yuri.', 'MSPA');
INSERT INTO white_cards VALUES (18457, 'The Summoner.', 'MSPA');
INSERT INTO white_cards VALUES (18458, 'The sweat-drenched, rippling muscles of several truly majestically endowed hoofbeasts.', 'MSPA');
INSERT INTO white_cards VALUES (18459, 'sweet bro and hell jeff.', 'MSPA');
INSERT INTO white_cards VALUES (18460, 'TAB.', 'MSPA');
INSERT INTO white_cards VALUES (18461, 'Tavros Nitram.', 'MSPA');
INSERT INTO white_cards VALUES (18462, 'Tavros''s wheelchair.', 'MSPA');
INSERT INTO white_cards VALUES (18463, 'Telling Sollux what happens to male bees after sex.', 'MSPA');
INSERT INTO white_cards VALUES (18464, 'Tentabulges.', 'MSPA');
INSERT INTO white_cards VALUES (18465, 'Tentative thank-you stabs.', 'MSPA');
INSERT INTO white_cards VALUES (18466, 'Terezi Pyrope.', 'MSPA');
INSERT INTO white_cards VALUES (18467, 'That dead crow with the sword through it.', 'MSPA');
INSERT INTO white_cards VALUES (18468, 'That human vacation with the giant red chimney-ass-hole.', 'MSPA');
INSERT INTO white_cards VALUES (18469, 'That shitty apple.', 'MSPA');
INSERT INTO white_cards VALUES (18470, 'That wonderful feeling when you take off your binder.', 'MSPA');
INSERT INTO white_cards VALUES (18471, 'The "special attachments" we ALL know that Equius gave to AradiaBot.', 'MSPA');
INSERT INTO white_cards VALUES (18472, 'Toilet displacement.', 'MSPA');
INSERT INTO white_cards VALUES (18473, 'Topping from the bottom.', 'MSPA');
INSERT INTO white_cards VALUES (18474, 'Triggers.', 'MSPA');
INSERT INTO white_cards VALUES (18475, 'Troll blood.', 'MSPA');
INSERT INTO white_cards VALUES (18476, 'Troll horns.', 'MSPA');
INSERT INTO white_cards VALUES (18477, 'Troll Will Smith.', 'MSPA');
INSERT INTO white_cards VALUES (18478, 'Trolls misunderstanding what "Bucket List" means.', 'MSPA');
INSERT INTO white_cards VALUES (18479, 'Tumblr spoilers.', 'MSPA');
INSERT INTO white_cards VALUES (18480, 'Tumblr user Egberts.', 'MSPA');
INSERT INTO white_cards VALUES (18481, 'Tumblr user Pizza.', 'MSPA');
INSERT INTO white_cards VALUES (18482, 'Tumblr.', 'MSPA');
INSERT INTO white_cards VALUES (18483, 'Unreal air.', 'MSPA');
INSERT INTO white_cards VALUES (18484, 'UPD8!!!!!!!!', 'MSPA');
INSERT INTO white_cards VALUES (18485, 'UPS delivery woman Nepeta.', 'MSPA');
INSERT INTO white_cards VALUES (18486, 'Viceroy Bubbles von Salamancer.', 'MSPA');
INSERT INTO white_cards VALUES (18487, 'Vodka Mutini.', 'MSPA');
INSERT INTO white_cards VALUES (18488, 'Vodka.', 'MSPA');
INSERT INTO white_cards VALUES (18489, 'Vriska dying after being stabbed by Terezi.', 'MSPA');
INSERT INTO white_cards VALUES (18490, 'Vriska Serket.', 'MSPA');
INSERT INTO white_cards VALUES (18491, 'Vriska''s SEXY sex tips for having SEXY SEX!', 'MSPA');
INSERT INTO white_cards VALUES (18492, 'A VrisKan waffle.', 'MSPA');
INSERT INTO white_cards VALUES (18493, 'Warhammer of Zillyhoo.', 'MSPA');
INSERT INTO white_cards VALUES (18494, 'What pumpkin?', 'MSPA');
INSERT INTO white_cards VALUES (18495, 'When your favorite character dies.', 'MSPA');
INSERT INTO white_cards VALUES (18496, 'where MAKING THIS HAPEN', 'MSPA');
INSERT INTO white_cards VALUES (18497, 'Willingly filling buckets with Eridan.', 'MSPA');
INSERT INTO white_cards VALUES (18498, 'World building!', 'MSPA');
INSERT INTO white_cards VALUES (18499, 'The Wrinklefucker.', 'MSPA');
INSERT INTO white_cards VALUES (18500, 'Your 300 pound matronly freight-train.', 'MSPA');
INSERT INTO white_cards VALUES (18501, 'Your lusus giving you "The Talk."', 'MSPA');
INSERT INTO white_cards VALUES (18502, 'Your Mary Sue fantroll.', 'MSPA');
INSERT INTO white_cards VALUES (18503, 'Your privilege.', 'MSPA');
INSERT INTO white_cards VALUES (18504, 'Your significant other coming home and finding you in full grey cosplay.', 'MSPA');
INSERT INTO white_cards VALUES (18505, 'Beating the shit out of Terezi.', 'MSPA');
INSERT INTO white_cards VALUES (18506, 'Jake English standing there like a fucking idiot.', 'MSPA');
INSERT INTO white_cards VALUES (18507, 'Falling into a pool of lava.', 'MSPA');
INSERT INTO white_cards VALUES (21780, 'Cygańska klštwa.', 'Pol');
INSERT INTO white_cards VALUES (21781, 'Minuta ciszy.', 'Pol');
INSERT INTO white_cards VALUES (21782, 'Gej party.', 'Pol');
INSERT INTO white_cards VALUES (21783, 'Uczciwy gliniarz z niczym do stracenia.', 'Pol');
INSERT INTO white_cards VALUES (21784, 'Głód.', 'Pol');
INSERT INTO white_cards VALUES (21785, 'Bakteria żywišca się mięsem.', 'Pol');
INSERT INTO white_cards VALUES (21786, 'Olewanie problemów trzeciego wiata.', 'Pol');
INSERT INTO white_cards VALUES (21787, 'Sprone SMSy.', 'Pol');
INSERT INTO white_cards VALUES (21788, 'Gwiazda porno.', 'Pol');
INSERT INTO white_cards VALUES (21789, 'Mordowanie, palenie, gwałcenie.', 'Pol');
INSERT INTO white_cards VALUES (21790, '72 dziewice.', 'Pol');
INSERT INTO white_cards VALUES (21791, 'Napad w bramie.', 'Pol');
INSERT INTO white_cards VALUES (21792, 'Paradoks podróży w czasie.', 'Pol');
INSERT INTO white_cards VALUES (21793, 'Złoty łańcuch.', 'Pol');
INSERT INTO white_cards VALUES (21794, 'Konsultanci.', 'Pol');
INSERT INTO white_cards VALUES (21795, 'Dług publiczny.', 'Pol');
INSERT INTO white_cards VALUES (21796, 'Zrzucanie żyrandolu na przeciwniku i wjeżdzanie do góry po linie.', 'Pol');
INSERT INTO white_cards VALUES (21797, 'Jarosław kaczyński.', 'Pol');
INSERT INTO white_cards VALUES (21798, 'Nagoć.', 'Pol');
INSERT INTO white_cards VALUES (21799, 'Terapia hormonalna.', 'Pol');
INSERT INTO white_cards VALUES (21800, 'Rozbierania się do naga i oglšdanie cartoon network.', 'Pol');
INSERT INTO white_cards VALUES (21801, 'udawane współczucie.', 'Pol');
INSERT INTO white_cards VALUES (21802, 'Publiczne omieszanie.', 'Pol');
INSERT INTO white_cards VALUES (21803, 'Używanie wspólnej strzykawki.', 'Pol');
INSERT INTO white_cards VALUES (21804, 'Baby z nosa.', 'Pol');
INSERT INTO white_cards VALUES (21805, 'Cud porodu.', 'Pol');
INSERT INTO white_cards VALUES (21806, 'Obowišzki małżeńskie.', 'Pol');
INSERT INTO white_cards VALUES (21807, 'Dezodorant AXE.', 'Pol');
INSERT INTO white_cards VALUES (21808, 'Krew chrystusa.', 'Pol');
INSERT INTO white_cards VALUES (21809, 'Przerażajšce wypadki podczas laserowego usuwania włosów.', 'Pol');
INSERT INTO white_cards VALUES (21810, 'BATMAN!!!.', 'Pol');
INSERT INTO white_cards VALUES (21811, 'Rolnictwo.', 'Pol');
INSERT INTO white_cards VALUES (21812, 'Naturalna selekcja.', 'Pol');
INSERT INTO white_cards VALUES (21813, 'Amatorskie aborcje.', 'Pol');
INSERT INTO white_cards VALUES (21814, 'World of warcraft.', 'Pol');
INSERT INTO white_cards VALUES (21815, 'Otyłoć.', 'Pol');
INSERT INTO white_cards VALUES (21816, 'Homoerotyczna scena gry w siadkówkę .', 'Pol');
INSERT INTO white_cards VALUES (21817, 'Szczękocisk.', 'Pol');
INSERT INTO white_cards VALUES (21818, 'Taniec godowy.', 'Pol');
INSERT INTO white_cards VALUES (21819, 'Skręt jšdra.', 'Pol');
INSERT INTO white_cards VALUES (21820, 'Hot-dogi za 1zł.', 'Pol');
INSERT INTO white_cards VALUES (21821, 'Tede.', 'Pol');
INSERT INTO white_cards VALUES (21822, 'Ser topiony.', 'Pol');
INSERT INTO white_cards VALUES (21823, 'Ataki dinozaurów.', 'Pol');
INSERT INTO white_cards VALUES (21824, 'cišganie koszulki.', 'Pol');
INSERT INTO white_cards VALUES (21825, '"serek" z pod napletka.', 'Pol');
INSERT INTO white_cards VALUES (21826, 'Alkocholizm.', 'Pol');
INSERT INTO white_cards VALUES (21827, '40-latek na rolkach.', 'Pol');
INSERT INTO white_cards VALUES (21828, 'Obżeranie się i wymiotowanie.', 'Pol');
INSERT INTO white_cards VALUES (21829, 'Olbrzymie lizaki.', 'Pol');
INSERT INTO white_cards VALUES (21830, 'Wstręt do samego siebie.', 'Pol');
INSERT INTO white_cards VALUES (21831, 'Dzieci na smyczy.', 'Pol');
INSERT INTO white_cards VALUES (21832, 'Żałosna gra wstępna.', 'Pol');
INSERT INTO white_cards VALUES (21833, 'Biblia.', 'Pol');
INSERT INTO white_cards VALUES (21834, 'Niemieckie porno w lochach.', 'Pol');
INSERT INTO white_cards VALUES (21835, 'Palenie się.', 'Pol');
INSERT INTO white_cards VALUES (21836, 'Nastoletne cišże.', 'Pol');
INSERT INTO white_cards VALUES (21837, 'Zostawianie kłopotliwych wiadomoci na poczcie głosowej.', 'Pol');
INSERT INTO white_cards VALUES (21838, 'Cios podbrudkowy.', 'Pol');
INSERT INTO white_cards VALUES (21839, 'Pracownicy działu obsługi klijenta.', 'Pol');
INSERT INTO white_cards VALUES (21840, 'Wzwód trwajšcy ponad 4 godziny.', 'Pol');
INSERT INTO white_cards VALUES (21841, 'Moje genitalia.', 'Pol');
INSERT INTO white_cards VALUES (21842, 'Podrywanie dziewczyny w klinice aborcyjnej.', 'Pol');
INSERT INTO white_cards VALUES (21843, 'Nauka.', 'Pol');
INSERT INTO white_cards VALUES (21844, 'Nieodwzajemniony sex oralny.', 'Pol');
INSERT INTO white_cards VALUES (21845, 'Ptaki nieloty.', 'Pol');
INSERT INTO white_cards VALUES (21846, 'Mocne sztachnięcie.', 'Pol');
INSERT INTO white_cards VALUES (21847, 'Tortury.', 'Pol');
INSERT INTO white_cards VALUES (21848, 'Zbilansowane niadanie.', 'Pol');
INSERT INTO white_cards VALUES (21849, 'Faktyczne zabranie dziecku cukierka.', 'Pol');
INSERT INTO white_cards VALUES (21850, 'Fundacja Polsat dzieciš.', 'Pol');
INSERT INTO white_cards VALUES (21851, 'Potajemne drapanie się po tyłku.', 'Pol');
INSERT INTO white_cards VALUES (21852, 'Pasywno-agresywne ogłoszenia.', 'Pol');
INSERT INTO white_cards VALUES (21853, 'Chińska drużyna gimnastyczna.', 'Pol');
INSERT INTO white_cards VALUES (21854, 'Popuszczenie w majtki.', 'Pol');
INSERT INTO white_cards VALUES (21855, 'Zmazy nocne.', 'Pol');
INSERT INTO white_cards VALUES (21856, 'Żydzi.', 'Pol');
INSERT INTO white_cards VALUES (21857, 'Potężne uda.', 'Pol');
INSERT INTO white_cards VALUES (21858, 'Puszczanie oczek do starszych ludzi.', 'Pol');
INSERT INTO white_cards VALUES (21859, 'Delikatne pieszczoty wewnętrznej częci uda.', 'Pol');
INSERT INTO white_cards VALUES (21860, 'Napięcie seksualne.', 'Pol');
INSERT INTO white_cards VALUES (21861, 'Zakazany owoc.', 'Pol');
INSERT INTO white_cards VALUES (21862, 'Szkieletor.', 'Pol');
INSERT INTO white_cards VALUES (21863, 'Whiskas@.', 'Pol');
INSERT INTO white_cards VALUES (21864, 'Bogactwo.', 'Pol');
INSERT INTO white_cards VALUES (21865, 'Słodka zemsta.', 'Pol');
INSERT INTO white_cards VALUES (21866, 'PiS.', 'Pol');
INSERT INTO white_cards VALUES (21867, 'Anna mucha.', 'Pol');
INSERT INTO white_cards VALUES (21868, 'Macanie.', 'Pol');
INSERT INTO white_cards VALUES (21869, 'Piloci kamikaze.', 'Pol');
INSERT INTO white_cards VALUES (21870, 'Andzej grabowski.', 'Pol');
INSERT INTO white_cards VALUES (21871, 'Propaganda homoseksualna.', 'Pol');
INSERT INTO white_cards VALUES (21872, 'Ciężko pracujšcy cygan.', 'Pol');
INSERT INTO white_cards VALUES (21873, 'Sokół z czapkš na głowie.', 'Pol');
INSERT INTO white_cards VALUES (21874, 'Ministranci.', 'Pol');
INSERT INTO white_cards VALUES (21875, 'Bycie tak złym że aż Ci staje.', 'Pol');
INSERT INTO white_cards VALUES (21876, 'Darmowe próbki.', 'Pol');
INSERT INTO white_cards VALUES (21877, 'Wielkie halo o nic.', 'Pol');
INSERT INTO white_cards VALUES (21878, 'Właciwe postępowanie.', 'Pol');
INSERT INTO white_cards VALUES (21879, 'Laktacja.', 'Pol');
INSERT INTO white_cards VALUES (21880, 'Pokój na wiecie.', 'Pol');
INSERT INTO white_cards VALUES (21881, 'Robocop.', 'Pol');
INSERT INTO white_cards VALUES (21882, 'Bezczelnoć.', 'Pol');
INSERT INTO white_cards VALUES (21883, 'Justin bieber.', 'Pol');
INSERT INTO white_cards VALUES (21884, 'Krasnoludki.', 'Pol');
INSERT INTO white_cards VALUES (21885, 'Niestosowne jodłowanie.', 'Pol');
INSERT INTO white_cards VALUES (21886, 'Dojrzewanie płuciowe.', 'Pol');
INSERT INTO white_cards VALUES (21887, 'Duchy.', 'Pol');
INSERT INTO white_cards VALUES (21888, 'Niesymetryczne sztuczne piersi.', 'Pol');
INSERT INTO white_cards VALUES (21889, 'Palcówka.', 'Pol');
INSERT INTO white_cards VALUES (21890, 'Kuba wojewudzki zaczepiony mosznš o haczyk od zasłony.', 'Pol');
INSERT INTO white_cards VALUES (21891, 'Mleko w tubce.', 'Pol');
INSERT INTO white_cards VALUES (21892, 'Policyjna przemoc.', 'Pol');
INSERT INTO white_cards VALUES (21893, 'Generał Wojciech Jaruzelski.', 'Pol');
INSERT INTO white_cards VALUES (21894, 'Dzieci.', 'Pol');
INSERT INTO white_cards VALUES (21895, 'Skalpowanie.', 'Pol');
INSERT INTO white_cards VALUES (21896, 'Smsowanie.', 'Pol');
INSERT INTO white_cards VALUES (21897, 'Dokładnie to czego się spodziewasz.', 'Pol');
INSERT INTO white_cards VALUES (21898, 'To uczucie gdy wydaję Ci się, że to tylko beknięcie, a okazuje się że to rzyg.', 'Pol');
INSERT INTO white_cards VALUES (21899, 'Leki na ADHD.', 'Pol');
INSERT INTO white_cards VALUES (21900, 'Komurki macierzyste.', 'Pol');
INSERT INTO white_cards VALUES (21901, 'Lobotomia szpikulcem do lodu.', 'Pol');
INSERT INTO white_cards VALUES (21902, 'Borys Szyc.', 'Pol');
INSERT INTO white_cards VALUES (21903, 'Opryszczka.', 'Pol');
INSERT INTO white_cards VALUES (21904, 'Kaszaloty.', 'Pol');
INSERT INTO white_cards VALUES (21905, 'Bezdomni.', 'Pol');
INSERT INTO white_cards VALUES (21906, 'Petting.', 'Pol');
INSERT INTO white_cards VALUES (21907, 'Kazirodztwo.', 'Pol');
INSERT INTO white_cards VALUES (21908, 'Pac-man tryskajšcy spermš w amoku.', 'Pol');
INSERT INTO white_cards VALUES (21909, 'Mim w trakcie zawału.', 'Pol');
INSERT INTO white_cards VALUES (21910, 'Robert Burneika.', 'Pol');
INSERT INTO white_cards VALUES (21911, 'Bóg.', 'Pol');
INSERT INTO white_cards VALUES (21912, 'Złoty deszcz.', 'Pol');
INSERT INTO white_cards VALUES (21913, 'Emocje.', 'Pol');
INSERT INTO white_cards VALUES (21914, 'Oblizywanie rzeczy, oznaczyć je jako swoje .', 'Pol');
INSERT INTO white_cards VALUES (21915, 'Tyskie.', 'Pol');
INSERT INTO white_cards VALUES (21916, 'Łożysko.', 'Pol');
INSERT INTO white_cards VALUES (21917, 'Spontaniczne samospalanie.', 'Pol');
INSERT INTO white_cards VALUES (21918, 'Przyjaciele z bonusem.', 'Pol');
INSERT INTO white_cards VALUES (21919, 'Malowanie palcami.', 'Pol');
INSERT INTO white_cards VALUES (21920, 'Zapach starych ludzi.', 'Pol');
INSERT INTO white_cards VALUES (21921, 'Moje wewnętrzne demony.', 'Pol');
INSERT INTO white_cards VALUES (21922, 'Gšbka pełna kocich sików.', 'Pol');
INSERT INTO white_cards VALUES (21923, 'Juzef Piłsudski.', 'Pol');
INSERT INTO white_cards VALUES (21924, 'Przytulanie.', 'Pol');
INSERT INTO white_cards VALUES (21925, 'Zielsko/jaranie/palenie/trawa/ganja.', 'Pol');
INSERT INTO white_cards VALUES (21926, 'Walki kogutów.', 'Pol');
INSERT INTO white_cards VALUES (21927, 'Strzelanie do swoich.', 'Pol');
INSERT INTO white_cards VALUES (21928, 'Lech wałęsa.', 'Pol');
INSERT INTO white_cards VALUES (21929, 'Rozczarowujšce przyjęcie urodzinowe.', 'Pol');
INSERT INTO white_cards VALUES (21930, 'Finalista kangura.', 'Pol');
INSERT INTO white_cards VALUES (21931, 'Kucyk.', 'Pol');
INSERT INTO white_cards VALUES (21932, 'Olaf Lubaszenko.', 'Pol');
INSERT INTO white_cards VALUES (21933, 'Wyrusznie w stronę zachodu słońca.', 'Pol');
INSERT INTO white_cards VALUES (21934, 'Nagły zwrot akcji.', 'Pol');
INSERT INTO white_cards VALUES (21935, 'Pedofile.', 'Pol');
INSERT INTO white_cards VALUES (21936, 'Drożdże.', 'Pol');
INSERT INTO white_cards VALUES (21937, 'Okradanie grobów.', 'Pol');
INSERT INTO white_cards VALUES (21938, 'Katapulty.', 'Pol');
INSERT INTO white_cards VALUES (21939, 'Biedni ludzie.', 'Pol');
INSERT INTO white_cards VALUES (21940, 'Moc Jedi.', 'Pol');
INSERT INTO white_cards VALUES (21941, 'Paplanie.', 'Pol');
INSERT INTO white_cards VALUES (21942, 'Zdięcia piersi.', 'Pol');
INSERT INTO white_cards VALUES (21943, 'Nelli Rokita.', 'Pol');
INSERT INTO white_cards VALUES (21944, 'Amerykańscy gradiatorzy.', 'Pol');
INSERT INTO white_cards VALUES (21945, 'Bycie naprawdę mocno spalonym.', 'Pol');
INSERT INTO white_cards VALUES (21946, 'Scjentologia.', 'Pol');
INSERT INTO white_cards VALUES (21947, 'Leczenie homoseksualizmu.', 'Pol');
INSERT INTO white_cards VALUES (21948, 'Igraszki.', 'Pol');
INSERT INTO white_cards VALUES (21949, 'Dwóch karłów srajšcych do wiadra.', 'Pol');
INSERT INTO white_cards VALUES (21950, 'Ku Klux klan.', 'Pol');
INSERT INTO white_cards VALUES (21951, 'Czyngis-chan.', 'Pol');
INSERT INTO white_cards VALUES (21952, 'Metamfetamina.', 'Pol');
INSERT INTO white_cards VALUES (21953, 'Poddaństwo.', 'Pol');
INSERT INTO white_cards VALUES (21954, 'Nie rozmawianie z obcymi.', 'Pol');
INSERT INTO white_cards VALUES (21955, 'Kariera aktorska Przemysława Salety.', 'Pol');
INSERT INTO white_cards VALUES (21956, 'Hasanie.', 'Pol');
INSERT INTO white_cards VALUES (21957, 'Samosšd.', 'Pol');
INSERT INTO white_cards VALUES (21958, 'Ocenzurowanie bukkake.', 'Pol');
INSERT INTO white_cards VALUES (21959, 'Wieczny smutek.', 'Pol');
INSERT INTO white_cards VALUES (21960, 'Rasizm.', 'Pol');
INSERT INTO white_cards VALUES (21961, 'Rzut karłem.', 'Pol');
INSERT INTO white_cards VALUES (21962, 'Bezchmurne niebo i wiecšce słońce.', 'Pol');
INSERT INTO white_cards VALUES (21963, 'Małpa palšca cygara.', 'Pol');
INSERT INTO white_cards VALUES (21964, 'Gwałtowna powód.', 'Pol');
INSERT INTO white_cards VALUES (21965, 'Suche wymioty.', 'Pol');
INSERT INTO white_cards VALUES (21966, 'Terorryci.', 'Pol');
INSERT INTO white_cards VALUES (21967, 'Britney Spears w wieku 55 lat.', 'Pol');
INSERT INTO white_cards VALUES (21968, 'Niastawienie.', 'Pol');
INSERT INTO white_cards VALUES (21969, 'Spontaniczne wyrwanie się do tańca i piewu.', 'Pol');
INSERT INTO white_cards VALUES (21970, 'Tršd.', 'Pol');
INSERT INTO white_cards VALUES (21971, 'Kolczyki do sutków.', 'Pol');
INSERT INTO white_cards VALUES (21972, 'Serce dziecka.', 'Pol');
INSERT INTO white_cards VALUES (21973, 'Szczeniaczki.', 'Pol');
INSERT INTO white_cards VALUES (21974, 'Pobudka na parkingu będšc na wpół nagim.', 'Pol');
INSERT INTO white_cards VALUES (21975, 'Pochwała Marii Czubaszek.', 'Pol');
INSERT INTO white_cards VALUES (21976, 'To miejsce u mężczyzny mędzy jšdrami a odbytem.', 'Pol');
INSERT INTO white_cards VALUES (21977, 'Aktywne słuchanie.', 'Pol');
INSERT INTO white_cards VALUES (21978, 'Czystki etmiczne.', 'Pol');
INSERT INTO white_cards VALUES (21979, 'Parowóz tomek.', 'Pol');
INSERT INTO white_cards VALUES (21980, 'Czekanie do lubu.', 'Pol');
INSERT INTO white_cards VALUES (21981, 'Niewyobrazalna głupota.', 'Pol');
INSERT INTO white_cards VALUES (21982, 'Euphoria Calvina Kleina.', 'Pol');
INSERT INTO white_cards VALUES (21983, 'Przekazywanie dalej niechcianych prezentów.', 'Pol');
INSERT INTO white_cards VALUES (21984, 'Autokalibalizm.', 'Pol');
INSERT INTO white_cards VALUES (21985, 'Problemy z erekcjš.', 'Pol');
INSERT INTO white_cards VALUES (21986, 'Moja kolekcja nowoczesnych gadżetów erotycznych.', 'Pol');
INSERT INTO white_cards VALUES (21987, 'Papież.', 'Pol');
INSERT INTO white_cards VALUES (21988, 'Biali ludzie.', 'Pol');
INSERT INTO white_cards VALUES (21989, 'Porno z mackami.', 'Pol');
INSERT INTO white_cards VALUES (21990, 'Konwulsynje wymiotujšcy Kuba Wojewódzki podczas gdy chmara pajšków wylęga się w jego mózgu i eksploduje z kanalików łzowych.', 'Pol');
INSERT INTO white_cards VALUES (21991, 'Za dużo żelu we włosach.', 'Pol');
INSERT INTO white_cards VALUES (21992, 'Oszukiwanie na olimpiadzie specialnej.', 'Pol');
INSERT INTO white_cards VALUES (21993, 'Charyzma.', 'Pol');
INSERT INTO white_cards VALUES (21994, 'Tomasz Karolak.', 'Pol');
INSERT INTO white_cards VALUES (21995, 'Tomasz Kot.', 'Pol');
INSERT INTO white_cards VALUES (21996, 'Zespół Feel.', 'Pol');
INSERT INTO white_cards VALUES (21997, 'Zerknięcie.', 'Pol');
INSERT INTO white_cards VALUES (21998, 'Sranie w tš i spowrotem w nieskończonoć.', 'Pol');
INSERT INTO white_cards VALUES (21999, 'Menstruacja.', 'Pol');
INSERT INTO white_cards VALUES (22000, 'Dzieci z rakiem odbytu.', 'Pol');
INSERT INTO white_cards VALUES (22001, 'lšsk.', 'Pol');
INSERT INTO white_cards VALUES (22002, 'Naruszanie podctawowych praw człowieka.', 'Pol');
INSERT INTO white_cards VALUES (22003, 'Gwałt na randce.', 'Pol');
INSERT INTO white_cards VALUES (22004, 'Bycie bajecznie pięknym.', 'Pol');
INSERT INTO white_cards VALUES (22005, 'Nekrofilia.', 'Pol');
INSERT INTO white_cards VALUES (22006, 'Centaury.', 'Pol');
INSERT INTO white_cards VALUES (22007, 'Adam Słodowy.', 'Pol');
INSERT INTO white_cards VALUES (22008, 'Murzyni.', 'Pol');
INSERT INTO white_cards VALUES (22009, 'Rycerskoć.', 'Pol');
INSERT INTO white_cards VALUES (22010, 'Suki.', 'Pol');
INSERT INTO white_cards VALUES (22011, 'Głęboko upoledzeni.', 'Pol');
INSERT INTO white_cards VALUES (22012, 'Chwytajšce za serce sierotki.', 'Pol');
INSERT INTO white_cards VALUES (22013, 'Peczenie odbytu.', 'Pol');
INSERT INTO white_cards VALUES (22014, 'Kolejny, cholerny film z wampirami.', 'Pol');
INSERT INTO white_cards VALUES (22015, 'Prawdzine znaczenie wišt.', 'Pol');
INSERT INTO white_cards VALUES (22016, 'Ten pas na brzuch z tv mango.', 'Pol');
INSERT INTO white_cards VALUES (22017, 'Rodzenie kamienia nerkowego.', 'Pol');
INSERT INTO white_cards VALUES (22018, 'Wybielony odbyt.', 'Pol');
INSERT INTO white_cards VALUES (22019, 'Cybernetyczne ulepszenia.', 'Pol');
INSERT INTO white_cards VALUES (22020, 'Chłopacy którzy nie dzwoniš póniej do dziewczyn poznanych na imprezie.', 'Pol');
INSERT INTO white_cards VALUES (22021, 'Masturbacja.', 'Pol');
INSERT INTO white_cards VALUES (22022, 'Pierdzenie pochwš.', 'Pol');
INSERT INTO white_cards VALUES (22023, 'Ukrywanie wzwodu.', 'Pol');
INSERT INTO white_cards VALUES (22024, 'Jadalna bielizna.', 'Pol');
INSERT INTO white_cards VALUES (22025, 'Viagra@.', 'Pol');
INSERT INTO white_cards VALUES (22026, 'Za goršca zupa.', 'Pol');
INSERT INTO white_cards VALUES (22027, 'Machomet(chwała mu po wieczne czasy).', 'Pol');
INSERT INTO white_cards VALUES (22028, 'Seks niespodzianka!.', 'Pol');
INSERT INTO white_cards VALUES (22029, 'Picie w samotnoci.', 'Pol');
INSERT INTO white_cards VALUES (22030, 'Dziurawe ręce.', 'Pol');
INSERT INTO white_cards VALUES (22031, 'Liczne rany kłute.', 'Pol');
INSERT INTO white_cards VALUES (22032, 'Ubrudzenie się.', 'Pol');
INSERT INTO white_cards VALUES (22033, 'Wykorzystanie dzieci.', 'Pol');
INSERT INTO white_cards VALUES (22034, 'Koraliki analne.', 'Pol');
INSERT INTO white_cards VALUES (22035, 'Ofiary wród cywili.', 'Pol');
INSERT INTO white_cards VALUES (22036, 'Piotr Adamczyk.', 'Pol');
INSERT INTO white_cards VALUES (22037, 'Konina.', 'Pol');
INSERT INTO white_cards VALUES (22038, 'Naprawde fajny kapelusz.', 'Pol');
INSERT INTO white_cards VALUES (22039, 'Zabłškany włos łonowy.', 'Pol');
INSERT INTO white_cards VALUES (22040, 'Kochanie się w tyłek.', 'Pol');
INSERT INTO white_cards VALUES (22041, 'Dokarmianie Magdy Gessler.', 'Pol');
INSERT INTO white_cards VALUES (22042, 'Uczenie robota miłoci.', 'Pol');
INSERT INTO white_cards VALUES (22043, 'Wpierdol.', 'Pol');
INSERT INTO white_cards VALUES (22044, 'Młyn pełen trupów.', 'Pol');
INSERT INTO white_cards VALUES (22045, 'Chocapic.', 'Pol');
INSERT INTO white_cards VALUES (22046, 'Noszenie bielizny na lewš stronę by uniknšć prania.', 'Pol');
INSERT INTO white_cards VALUES (22047, 'miercionony laser.', 'Pol');
INSERT INTO white_cards VALUES (22048, 'Zamrażarka pełna organów.', 'Pol');
INSERT INTO white_cards VALUES (22049, 'Amerykański sen.', 'Pol');
INSERT INTO white_cards VALUES (22050, 'Mokry bšk.', 'Pol');
INSERT INTO white_cards VALUES (22051, 'Martwe niemowlęta.', 'Pol');
INSERT INTO white_cards VALUES (22052, 'Napletek.', 'Pol');
INSERT INTO white_cards VALUES (22053, 'Solówka na saksofonie.', 'Pol');
INSERT INTO white_cards VALUES (22054, 'Niemcy.', 'Pol');
INSERT INTO white_cards VALUES (22055, 'Płód.', 'Pol');
INSERT INTO white_cards VALUES (22056, 'Janusz Korwin-Mikke.', 'Pol');
INSERT INTO white_cards VALUES (22057, 'Amputacja.', 'Pol');
INSERT INTO white_cards VALUES (22058, 'Status mojego zwišzku.', 'Pol');
INSERT INTO white_cards VALUES (22059, 'Pszczoły?.', 'Pol');
INSERT INTO white_cards VALUES (22060, 'Erotyczna wersja Harrego Pottera.', 'Pol');
INSERT INTO white_cards VALUES (22061, 'Studia.', 'Pol');
INSERT INTO white_cards VALUES (22062, 'Upijanie się płynem do spryskiwaczy.', 'Pol');
INSERT INTO white_cards VALUES (22063, 'Nazici.', 'Pol');
INSERT INTO white_cards VALUES (22064, 'Zazywanie krokodyla.', 'Pol');
INSERT INTO white_cards VALUES (22065, 'Steven Hawking mówišcy wiństwa.', 'Pol');
INSERT INTO white_cards VALUES (22066, 'Martwi rodzice.', 'Pol');
INSERT INTO white_cards VALUES (22067, 'Przeciwstawne kciuki.', 'Pol');
INSERT INTO white_cards VALUES (22068, 'Gadanie głupot.', 'Pol');
INSERT INTO white_cards VALUES (22069, 'Piły łšńcuchowe zamiast ršk.', 'Pol');
INSERT INTO white_cards VALUES (22070, 'Cezary Pazura.', 'Pol');
INSERT INTO white_cards VALUES (22071, 'Dziecięce konkursy pięknoci.', 'Pol');
INSERT INTO white_cards VALUES (22072, 'Wybuchy.', 'Pol');
INSERT INTO white_cards VALUES (22073, 'Wšchanie kleju.', 'Pol');
INSERT INTO white_cards VALUES (22074, 'Kuba Wojewódzki nękany przez rój myszołowów.', 'Pol');
INSERT INTO white_cards VALUES (22075, 'Tabletki gwałtu.', 'Pol');
INSERT INTO white_cards VALUES (22076, 'Moja pochwa.', 'Pol');
INSERT INTO white_cards VALUES (22077, 'Spodnie bez tyłka.', 'Pol');
INSERT INTO white_cards VALUES (22078, 'Dawanie z siebie 100%.', 'Pol');
INSERT INTO white_cards VALUES (22079, 'Jej wysokoć królowa Elżbieta II.', 'Pol');
INSERT INTO white_cards VALUES (22080, 'Bycie zmarginazowanym.', 'Pol');
INSERT INTO white_cards VALUES (22081, 'Gobliny.', 'Pol');
INSERT INTO white_cards VALUES (22082, 'Nadzieja.', 'Pol');
INSERT INTO white_cards VALUES (22083, 'Mikro penis.', 'Pol');
INSERT INTO white_cards VALUES (22084, 'Moja dusza.', 'Pol');
INSERT INTO white_cards VALUES (22085, 'Wikingowie.', 'Pol');
INSERT INTO white_cards VALUES (22086, 'Piękni ludzie.', 'Pol');
INSERT INTO white_cards VALUES (22087, 'Uwodzenie.', 'Pol');
INSERT INTO white_cards VALUES (22088, 'Kompleks Edypa.', 'Pol');
INSERT INTO white_cards VALUES (22089, 'Gęsi.', 'Pol');
INSERT INTO white_cards VALUES (22090, 'Globalne ocieplenie.', 'Pol');
INSERT INTO white_cards VALUES (22091, 'Robienie smutnej minki.', 'Pol');
INSERT INTO white_cards VALUES (22092, 'Kobiece prawa wyborcze.', 'Pol');
INSERT INTO white_cards VALUES (22093, 'Dziurawa prezerwatywa.', 'Pol');
INSERT INTO white_cards VALUES (22094, 'Sędzia Anna Maria Wesołowska.', 'Pol');
INSERT INTO white_cards VALUES (22095, 'Afrykańskie dzieci.', 'Pol');
INSERT INTO white_cards VALUES (22096, 'Obcišganie w czasie jazdy autem.', 'Pol');
INSERT INTO white_cards VALUES (22097, 'Spektaktualne mięnie brzucha.', 'Pol');
INSERT INTO white_cards VALUES (22098, 'Mazurek.', 'Pol');
INSERT INTO white_cards VALUES (22099, 'Zaspany lew w zoo.', 'Pol');
INSERT INTO white_cards VALUES (22100, 'Paczka magicznych fasolek.', 'Pol');
INSERT INTO white_cards VALUES (22101, 'Złe decyzje życiowe.', 'Pol');
INSERT INTO white_cards VALUES (22102, 'Moje życie seksualne.', 'Pol');
INSERT INTO white_cards VALUES (22103, 'Żółw jaszczurowaty gryzšcy cie w końcówkę penisa.', 'Pol');
INSERT INTO white_cards VALUES (22104, 'Wybuch termo jšdrowy.', 'Pol');
INSERT INTO white_cards VALUES (22105, 'łechtaczka.', 'Pol');
INSERT INTO white_cards VALUES (22106, 'Donald Tusk.', 'Pol');
INSERT INTO white_cards VALUES (22107, 'Wymiana uprzejnoci.', 'Pol');
INSERT INTO white_cards VALUES (22108, 'Zabawa w wampira podczas miesišczki.', 'Pol');
INSERT INTO white_cards VALUES (22109, 'Wielki wybuch.', 'Pol');
INSERT INTO white_cards VALUES (22110, 'Miny lšdowe.', 'Pol');
INSERT INTO white_cards VALUES (22111, 'Znajomi wyjadajšcy całš zagrychę.', 'Pol');
INSERT INTO white_cards VALUES (22112, 'Kozy pożerajšce dzieci.', 'Pol');
INSERT INTO white_cards VALUES (22113, 'Jezioro łabędzie.', 'Pol');
INSERT INTO white_cards VALUES (22114, 'Spuszcznie się do basenu dziecięcych łez.', 'Pol');
INSERT INTO white_cards VALUES (22115, 'Męska pała.', 'Pol');
INSERT INTO white_cards VALUES (22116, 'Czas dla siebie.', 'Pol');
INSERT INTO white_cards VALUES (22117, 'Opowiadanie kawałów o żydach w nieodpowiednim momecie.', 'Pol');
INSERT INTO white_cards VALUES (22118, 'Morze problemów.', 'Pol');
INSERT INTO white_cards VALUES (22119, 'Fantazje o drwalach.', 'Pol');
INSERT INTO white_cards VALUES (22120, 'Głos Krystyny Czubówny.', 'Pol');
INSERT INTO white_cards VALUES (22121, 'Kobiety w reklamach jogurtów.', 'Pol');
INSERT INTO white_cards VALUES (22122, 'Ziołowe tabletki na problemy z potenciš.', 'Pol');
INSERT INTO white_cards VALUES (22123, 'Bycie pierdolonym czarodziejem.', 'Pol');
INSERT INTO white_cards VALUES (22124, 'Piercing genitaliów.', 'Pol');
INSERT INTO white_cards VALUES (22125, 'Znoni transwestyci.', 'Pol');
INSERT INTO white_cards VALUES (22126, 'Seksowne walki na poduszki.', 'Pol');
INSERT INTO white_cards VALUES (22127, 'Jšdra.', 'Pol');
INSERT INTO white_cards VALUES (22128, 'Babcia.', 'Pol');
INSERT INTO white_cards VALUES (22129, 'Tarcie.', 'Pol');
INSERT INTO white_cards VALUES (22130, 'Ludzie zawszę psujš dobrš zabawę.', 'Pol');
INSERT INTO white_cards VALUES (22131, 'Pierdzenie o odchodzenie.', 'Pol');
INSERT INTO white_cards VALUES (22132, 'Bycie chujem w stosunku do dzieci.', 'Pol');
INSERT INTO white_cards VALUES (22133, 'Zastawianie pułapek na złodziei.', 'Pol');
INSERT INTO white_cards VALUES (22134, 'Materac z TV mango.', 'Pol');
INSERT INTO white_cards VALUES (22135, 'Umieranie.', 'Pol');
INSERT INTO white_cards VALUES (22136, 'Huragan Katrina.', 'Pol');
INSERT INTO white_cards VALUES (22137, 'Geje.', 'Pol');
INSERT INTO white_cards VALUES (22138, 'Ludzka Głupota.', 'Pol');
INSERT INTO white_cards VALUES (22139, 'Mężczyżni.', 'Pol');
INSERT INTO white_cards VALUES (22140, 'Amisze.', 'Pol');
INSERT INTO white_cards VALUES (22141, 'Pterodaktyre jaja.', 'Pol');
INSERT INTO white_cards VALUES (22142, 'Zdjęcia integracyjne.', 'Pol');
INSERT INTO white_cards VALUES (22143, 'Guz mózgu.', 'Pol');
INSERT INTO white_cards VALUES (22144, 'Karty przeciwko ludzkoci.', 'Pol');
INSERT INTO white_cards VALUES (22145, 'Strach w czystej postaci.', 'Pol');
INSERT INTO white_cards VALUES (22146, 'Mleczarz.', 'Pol');
INSERT INTO white_cards VALUES (22147, 'Niewyparzona buzia.', 'Pol');
INSERT INTO white_cards VALUES (22148, 'Lubię cycki.', 'Pol');
INSERT INTO white_cards VALUES (22149, 'Kalesony.', 'Pol');
INSERT INTO white_cards VALUES (22150, 'Nie mam teamu.', 'Pol');
INSERT INTO white_cards VALUES (22151, 'Że ja?!?!?!?.', 'Pol');
INSERT INTO white_cards VALUES (22152, 'Za kalimdor.', 'Pol');
INSERT INTO white_cards VALUES (22153, 'Za horde!..', 'Pol');
INSERT INTO white_cards VALUES (22154, 'Rabarbar.', 'Pol');
INSERT INTO white_cards VALUES (22155, 'Kotlecik.', 'Pol');
INSERT INTO white_cards VALUES (22156, 'Tybetańscy mnisi.', 'Pol');
INSERT INTO white_cards VALUES (22157, 'Tampon.', 'Pol');
INSERT INTO white_cards VALUES (22158, 'Sałatka.', 'Pol');
INSERT INTO white_cards VALUES (22159, 'Władca niebiańskich penisów.', 'Pol');
INSERT INTO white_cards VALUES (22160, 'Syrenka ladacznica.', 'Pol');
INSERT INTO white_cards VALUES (22161, 'Zużyte majtki.', 'Pol');
INSERT INTO white_cards VALUES (22162, 'Bijcie masterczułki.', 'Pol');
INSERT INTO white_cards VALUES (22163, 'Krucjata lezbijek.', 'Pol');


--
-- TOC entry 1948 (class 0 OID 0)
-- Dependencies: 168
-- Name: white_cards_id_seq; Type: SEQUENCE SET; Schema: public; Owner: cah
--

SELECT pg_catalog.setval('white_cards_id_seq', 22163, true);


--
-- TOC entry 1911 (class 2606 OID 16501)
-- Name: black_cards_pkey; Type: CONSTRAINT; Schema: public; Owner: cah; Tablespace: 
--

ALTER TABLE ONLY black_cards
    ADD CONSTRAINT black_cards_pkey PRIMARY KEY (id);


--
-- TOC entry 1913 (class 2606 OID 16503)
-- Name: black_cards_text_key; Type: CONSTRAINT; Schema: public; Owner: cah; Tablespace: 
--

ALTER TABLE ONLY black_cards
    ADD CONSTRAINT black_cards_text_key UNIQUE (text);


--
-- TOC entry 1917 (class 2606 OID 16505)
-- Name: card_set_black_card_pkey; Type: CONSTRAINT; Schema: public; Owner: cah; Tablespace: 
--

ALTER TABLE ONLY card_set_black_card
    ADD CONSTRAINT card_set_black_card_pkey PRIMARY KEY (card_set_id, black_card_id);


--
-- TOC entry 1915 (class 2606 OID 16507)
-- Name: card_set_pkey; Type: CONSTRAINT; Schema: public; Owner: cah; Tablespace: 
--

ALTER TABLE ONLY card_set
    ADD CONSTRAINT card_set_pkey PRIMARY KEY (id);


--
-- TOC entry 1919 (class 2606 OID 16509)
-- Name: card_set_white_card_pkey; Type: CONSTRAINT; Schema: public; Owner: cah; Tablespace: 
--

ALTER TABLE ONLY card_set_white_card
    ADD CONSTRAINT card_set_white_card_pkey PRIMARY KEY (card_set_id, white_card_id);


--
-- TOC entry 1921 (class 2606 OID 16511)
-- Name: white_cards_pkey; Type: CONSTRAINT; Schema: public; Owner: cah; Tablespace: 
--

ALTER TABLE ONLY white_cards
    ADD CONSTRAINT white_cards_pkey PRIMARY KEY (id);


--
-- TOC entry 1923 (class 2606 OID 16513)
-- Name: white_cards_text_key; Type: CONSTRAINT; Schema: public; Owner: cah; Tablespace: 
--

ALTER TABLE ONLY white_cards
    ADD CONSTRAINT white_cards_text_key UNIQUE (text);


--
-- TOC entry 1924 (class 2606 OID 16514)
-- Name: fk513da45c997611f9; Type: FK CONSTRAINT; Schema: public; Owner: cah
--

ALTER TABLE ONLY card_set_black_card
    ADD CONSTRAINT fk513da45c997611f9 FOREIGN KEY (black_card_id) REFERENCES black_cards(id);


--
-- TOC entry 1925 (class 2606 OID 16519)
-- Name: fk513da45cb2505f39; Type: FK CONSTRAINT; Schema: public; Owner: cah
--

ALTER TABLE ONLY card_set_black_card
    ADD CONSTRAINT fk513da45cb2505f39 FOREIGN KEY (card_set_id) REFERENCES card_set(id);


--
-- TOC entry 1926 (class 2606 OID 16524)
-- Name: fkc2487272b2505f39; Type: FK CONSTRAINT; Schema: public; Owner: cah
--

ALTER TABLE ONLY card_set_white_card
    ADD CONSTRAINT fkc2487272b2505f39 FOREIGN KEY (card_set_id) REFERENCES card_set(id);


--
-- TOC entry 1927 (class 2606 OID 16529)
-- Name: fkc2487272bfd29b4d; Type: FK CONSTRAINT; Schema: public; Owner: cah
--

ALTER TABLE ONLY card_set_white_card
    ADD CONSTRAINT fkc2487272bfd29b4d FOREIGN KEY (white_card_id) REFERENCES white_cards(id);


--
-- TOC entry 1942 (class 0 OID 0)
-- Dependencies: 6
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


-- Completed on 2014-02-16 23:02:31

--
-- PostgreSQL database dump complete
--

